#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 11
#define STATE_COUNT 1423
#define LARGE_STATE_COUNT 325
#define SYMBOL_COUNT 301
#define ALIAS_COUNT 1
#define TOKEN_COUNT 154
#define EXTERNAL_TOKEN_COUNT 3
#define FIELD_COUNT 16
#define MAX_ALIAS_SEQUENCE_LENGTH 12

enum {
  sym_name = 1,
  sym_php_tag = 2,
  anon_sym_QMARK_GT = 3,
  aux_sym_text_token1 = 4,
  aux_sym_text_token2 = 5,
  anon_sym_SEMI = 6,
  anon_sym_static = 7,
  anon_sym_COMMA = 8,
  anon_sym_EQ = 9,
  anon_sym_global = 10,
  anon_sym_namespace = 11,
  anon_sym_use = 12,
  anon_sym_BSLASH = 13,
  anon_sym_function = 14,
  anon_sym_const = 15,
  anon_sym_as = 16,
  anon_sym_LBRACE = 17,
  anon_sym_RBRACE = 18,
  anon_sym_trait = 19,
  anon_sym_interface = 20,
  anon_sym_extends = 21,
  anon_sym_class = 22,
  anon_sym_abstract = 23,
  anon_sym_final = 24,
  anon_sym_implements = 25,
  sym_var_modifier = 26,
  anon_sym_insteadof = 27,
  anon_sym_public = 28,
  anon_sym_protected = 29,
  anon_sym_private = 30,
  anon_sym_AMP = 31,
  anon_sym_LPAREN = 32,
  anon_sym_RPAREN = 33,
  anon_sym_DOT_DOT_DOT = 34,
  anon_sym_QMARK = 35,
  anon_sym_array = 36,
  anon_sym_callable = 37,
  anon_sym_iterable = 38,
  anon_sym_bool = 39,
  anon_sym_float = 40,
  anon_sym_int = 41,
  anon_sym_string = 42,
  anon_sym_void = 43,
  anon_sym_binary = 44,
  anon_sym_boolean = 45,
  anon_sym_double = 46,
  anon_sym_integer = 47,
  anon_sym_object = 48,
  anon_sym_real = 49,
  anon_sym_unset = 50,
  anon_sym_COLON = 51,
  anon_sym_echo = 52,
  anon_sym_declare = 53,
  anon_sym_enddeclare = 54,
  anon_sym_ticks = 55,
  anon_sym_encoding = 56,
  anon_sym_strict_types = 57,
  sym_float = 58,
  anon_sym_try = 59,
  anon_sym_catch = 60,
  anon_sym_finally = 61,
  anon_sym_goto = 62,
  anon_sym_continue = 63,
  anon_sym_break = 64,
  sym_integer = 65,
  anon_sym_return = 66,
  anon_sym_throw = 67,
  anon_sym_while = 68,
  anon_sym_endwhile = 69,
  anon_sym_do = 70,
  anon_sym_for = 71,
  anon_sym_endfor = 72,
  anon_sym_foreach = 73,
  anon_sym_endforeach = 74,
  anon_sym_EQ_GT = 75,
  anon_sym_if = 76,
  anon_sym_endif = 77,
  anon_sym_elseif = 78,
  anon_sym_else = 79,
  anon_sym_switch = 80,
  anon_sym_endswitch = 81,
  anon_sym_case = 82,
  anon_sym_default = 83,
  anon_sym_AT = 84,
  anon_sym_PLUS = 85,
  anon_sym_DASH = 86,
  anon_sym_TILDE = 87,
  anon_sym_BANG = 88,
  anon_sym_STAR_STAR = 89,
  anon_sym_clone = 90,
  anon_sym_COLON_COLON = 91,
  anon_sym_print = 92,
  anon_sym_new = 93,
  anon_sym_PLUS_PLUS = 94,
  anon_sym_DASH_DASH = 95,
  sym_shell_command_expression = 96,
  anon_sym_STAR_STAR_EQ = 97,
  anon_sym_STAR_EQ = 98,
  anon_sym_SLASH_EQ = 99,
  anon_sym_PERCENT_EQ = 100,
  anon_sym_PLUS_EQ = 101,
  anon_sym_DASH_EQ = 102,
  anon_sym_DOT_EQ = 103,
  anon_sym_LT_LT_EQ = 104,
  anon_sym_GT_GT_EQ = 105,
  anon_sym_AMP_EQ = 106,
  anon_sym_CARET_EQ = 107,
  anon_sym_PIPE_EQ = 108,
  anon_sym_DASH_GT = 109,
  anon_sym_list = 110,
  anon_sym_self = 111,
  anon_sym_parent = 112,
  anon_sym_LBRACK = 113,
  anon_sym_RBRACK = 114,
  sym_string = 115,
  sym_boolean = 116,
  sym_null = 117,
  anon_sym_DOLLAR = 118,
  anon_sym_yield = 119,
  anon_sym_from = 120,
  anon_sym_instanceof = 121,
  anon_sym_QMARK_QMARK = 122,
  aux_sym_binary_expression_token1 = 123,
  aux_sym_binary_expression_token2 = 124,
  aux_sym_binary_expression_token3 = 125,
  anon_sym_PIPE_PIPE = 126,
  anon_sym_AMP_AMP = 127,
  anon_sym_PIPE = 128,
  anon_sym_CARET = 129,
  anon_sym_EQ_EQ = 130,
  anon_sym_BANG_EQ = 131,
  anon_sym_LT_GT = 132,
  anon_sym_EQ_EQ_EQ = 133,
  anon_sym_BANG_EQ_EQ = 134,
  anon_sym_LT = 135,
  anon_sym_GT = 136,
  anon_sym_LT_EQ = 137,
  anon_sym_GT_EQ = 138,
  anon_sym_LT_EQ_GT = 139,
  anon_sym_LT_LT = 140,
  anon_sym_GT_GT = 141,
  anon_sym_DOT = 142,
  anon_sym_STAR = 143,
  anon_sym_SLASH = 144,
  anon_sym_PERCENT = 145,
  anon_sym_include = 146,
  anon_sym_include_once = 147,
  anon_sym_require = 148,
  anon_sym_require_once = 149,
  sym_comment = 150,
  sym__automatic_semicolon = 151,
  sym_heredoc = 152,
  sym__eof = 153,
  sym_program = 154,
  sym_text_interpolation = 155,
  sym_text = 156,
  sym_empty_statement = 157,
  sym_function_static_declaration = 158,
  sym_static_variable_declaration = 159,
  sym_global_declaration = 160,
  sym_namespace_definition = 161,
  sym_namespace_use_declaration = 162,
  sym_namespace_function_or_const = 163,
  sym_namespace_use_clause = 164,
  sym_qualified_name = 165,
  sym_namespace_name_as_prefix = 166,
  sym_namespace_name = 167,
  sym_namespace_aliasing_clause = 168,
  sym_namespace_use_group = 169,
  sym_namespace_use_group_clause = 170,
  sym_trait_declaration = 171,
  sym_interface_declaration = 172,
  sym_interface_base_clause = 173,
  sym_class_declaration = 174,
  sym_declaration_list = 175,
  sym_class_modifier = 176,
  sym_class_base_clause = 177,
  sym_class_interface_clause = 178,
  sym__member_declaration = 179,
  sym_const_declaration = 180,
  sym_property_declaration = 181,
  sym__modifier = 182,
  sym_property_element = 183,
  sym_property_initializer = 184,
  sym_method_declaration = 185,
  sym_static_modifier = 186,
  sym_use_declaration = 187,
  sym_use_list = 188,
  sym_use_instead_of_clause = 189,
  sym_use_as_clause = 190,
  sym_visibility_modifier = 191,
  sym_function_definition = 192,
  sym__function_definition_header = 193,
  sym_formal_parameters = 194,
  sym_simple_parameter = 195,
  sym_variadic_parameter = 196,
  sym__type = 197,
  sym_optional_type = 198,
  sym_primitive_type = 199,
  sym_cast_type = 200,
  sym__return_type = 201,
  sym_const_element = 202,
  sym_echo_statement = 203,
  sym_unset_statement = 204,
  sym_declare_statement = 205,
  sym_declare_directive = 206,
  sym_try_statement = 207,
  sym_catch_clause = 208,
  sym_finally_clause = 209,
  sym__jump_statement = 210,
  sym_goto_statement = 211,
  sym_continue_statement = 212,
  sym_break_statement = 213,
  sym_return_statement = 214,
  sym_throw_statement = 215,
  sym_while_statement = 216,
  sym_do_statement = 217,
  sym_for_statement = 218,
  sym__expressions = 219,
  sym_sequence_expression = 220,
  sym_foreach_statement = 221,
  sym_foreach_pair = 222,
  sym_if_statement = 223,
  sym_colon_block = 224,
  sym_else_if_clause = 225,
  sym_else_clause = 226,
  sym_else_if_clause_2 = 227,
  sym_else_clause_2 = 228,
  sym_switch_statement = 229,
  sym_switch_block = 230,
  sym_case_statement = 231,
  sym_default_statement = 232,
  sym_compound_statement = 233,
  sym_named_label_statement = 234,
  sym_expression_statement = 235,
  sym__expression = 236,
  sym__unary_expression = 237,
  sym_unary_op_expression = 238,
  sym_exponentiation_expression = 239,
  sym_clone_expression = 240,
  sym__primary_expression = 241,
  sym_parenthesized_expression = 242,
  sym_class_constant_access_expression = 243,
  sym_print_intrinsic = 244,
  sym_anonymous_function_creation_expression = 245,
  sym_anonymous_function_use_clause = 246,
  sym_object_creation_expression = 247,
  sym_update_expression = 248,
  sym_cast_expression = 249,
  sym_cast_variable = 250,
  sym_assignment_expression = 251,
  sym_conditional_expression = 252,
  sym_augmented_assignment_expression = 253,
  sym_member_access_expression = 254,
  sym_scoped_property_access_expression = 255,
  sym_list_literal = 256,
  sym_function_call_expression = 257,
  sym_scoped_call_expression = 258,
  sym__scope_resolution_qualifier = 259,
  sym_relative_scope = 260,
  sym_arguments = 261,
  sym_member_call_expression = 262,
  sym_variadic_unpacking = 263,
  sym_subscript_expression = 264,
  sym__dereferencable_expression = 265,
  sym_array_creation_expression = 266,
  sym__string = 267,
  sym_dynamic_variable_name = 268,
  sym_variable_name = 269,
  sym_yield_expression = 270,
  sym_array_element_initializer = 271,
  sym_binary_expression = 272,
  sym_include_expression = 273,
  sym_include_once_expression = 274,
  sym_require_expression = 275,
  sym_require_once_expression = 276,
  sym__reserved_identifier = 277,
  aux_sym_program_repeat1 = 278,
  aux_sym_text_repeat1 = 279,
  aux_sym_function_static_declaration_repeat1 = 280,
  aux_sym_global_declaration_repeat1 = 281,
  aux_sym_namespace_use_declaration_repeat1 = 282,
  aux_sym_namespace_name_repeat1 = 283,
  aux_sym_namespace_use_group_repeat1 = 284,
  aux_sym_interface_base_clause_repeat1 = 285,
  aux_sym_declaration_list_repeat1 = 286,
  aux_sym_const_declaration_repeat1 = 287,
  aux_sym_property_declaration_repeat1 = 288,
  aux_sym_property_declaration_repeat2 = 289,
  aux_sym_use_list_repeat1 = 290,
  aux_sym_formal_parameters_repeat1 = 291,
  aux_sym_unset_statement_repeat1 = 292,
  aux_sym_try_statement_repeat1 = 293,
  aux_sym_if_statement_repeat1 = 294,
  aux_sym_if_statement_repeat2 = 295,
  aux_sym_switch_block_repeat1 = 296,
  aux_sym_anonymous_function_use_clause_repeat1 = 297,
  aux_sym_list_literal_repeat1 = 298,
  aux_sym_arguments_repeat1 = 299,
  aux_sym_array_creation_expression_repeat1 = 300,
  alias_sym_type_name = 301,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_name] = "name",
  [sym_php_tag] = "php_tag",
  [anon_sym_QMARK_GT] = "?>",
  [aux_sym_text_token1] = "text_token1",
  [aux_sym_text_token2] = "text_token2",
  [anon_sym_SEMI] = ";",
  [anon_sym_static] = "static",
  [anon_sym_COMMA] = ",",
  [anon_sym_EQ] = "=",
  [anon_sym_global] = "global",
  [anon_sym_namespace] = "namespace",
  [anon_sym_use] = "use",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_function] = "function",
  [anon_sym_const] = "const",
  [anon_sym_as] = "as",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_trait] = "trait",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_class] = "class",
  [anon_sym_abstract] = "abstract",
  [anon_sym_final] = "final",
  [anon_sym_implements] = "implements",
  [sym_var_modifier] = "var_modifier",
  [anon_sym_insteadof] = "insteadof",
  [anon_sym_public] = "public",
  [anon_sym_protected] = "protected",
  [anon_sym_private] = "private",
  [anon_sym_AMP] = "&",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_array] = "array",
  [anon_sym_callable] = "callable",
  [anon_sym_iterable] = "iterable",
  [anon_sym_bool] = "bool",
  [anon_sym_float] = "float",
  [anon_sym_int] = "int",
  [anon_sym_string] = "string",
  [anon_sym_void] = "void",
  [anon_sym_binary] = "binary",
  [anon_sym_boolean] = "boolean",
  [anon_sym_double] = "double",
  [anon_sym_integer] = "integer",
  [anon_sym_object] = "object",
  [anon_sym_real] = "real",
  [anon_sym_unset] = "unset",
  [anon_sym_COLON] = ":",
  [anon_sym_echo] = "echo",
  [anon_sym_declare] = "declare",
  [anon_sym_enddeclare] = "enddeclare",
  [anon_sym_ticks] = "ticks",
  [anon_sym_encoding] = "encoding",
  [anon_sym_strict_types] = "strict_types",
  [sym_float] = "float",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_goto] = "goto",
  [anon_sym_continue] = "continue",
  [anon_sym_break] = "break",
  [sym_integer] = "integer",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_while] = "while",
  [anon_sym_endwhile] = "endwhile",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_endfor] = "endfor",
  [anon_sym_foreach] = "foreach",
  [anon_sym_endforeach] = "endforeach",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_if] = "if",
  [anon_sym_endif] = "endif",
  [anon_sym_elseif] = "elseif",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_endswitch] = "endswitch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_AT] = "@",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_TILDE] = "~",
  [anon_sym_BANG] = "!",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_clone] = "clone",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_print] = "print",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [sym_shell_command_expression] = "shell_command_expression",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_DOT_EQ] = ".=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_list] = "list",
  [anon_sym_self] = "self",
  [anon_sym_parent] = "parent",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym_string] = "string",
  [sym_boolean] = "boolean",
  [sym_null] = "null",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_yield] = "yield",
  [anon_sym_from] = "from",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_QMARK_QMARK] = "??",
  [aux_sym_binary_expression_token1] = "and",
  [aux_sym_binary_expression_token2] = "or",
  [aux_sym_binary_expression_token3] = "xor",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_DOT] = ".",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_include] = "include",
  [anon_sym_include_once] = "include_once",
  [anon_sym_require] = "require",
  [anon_sym_require_once] = "require_once",
  [sym_comment] = "comment",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym_heredoc] = "heredoc",
  [sym__eof] = "_eof",
  [sym_program] = "program",
  [sym_text_interpolation] = "text_interpolation",
  [sym_text] = "text",
  [sym_empty_statement] = "empty_statement",
  [sym_function_static_declaration] = "function_static_declaration",
  [sym_static_variable_declaration] = "static_variable_declaration",
  [sym_global_declaration] = "global_declaration",
  [sym_namespace_definition] = "namespace_definition",
  [sym_namespace_use_declaration] = "namespace_use_declaration",
  [sym_namespace_function_or_const] = "namespace_function_or_const",
  [sym_namespace_use_clause] = "namespace_use_clause",
  [sym_qualified_name] = "qualified_name",
  [sym_namespace_name_as_prefix] = "namespace_name_as_prefix",
  [sym_namespace_name] = "namespace_name",
  [sym_namespace_aliasing_clause] = "namespace_aliasing_clause",
  [sym_namespace_use_group] = "namespace_use_group",
  [sym_namespace_use_group_clause] = "namespace_use_group_clause",
  [sym_trait_declaration] = "trait_declaration",
  [sym_interface_declaration] = "interface_declaration",
  [sym_interface_base_clause] = "interface_base_clause",
  [sym_class_declaration] = "class_declaration",
  [sym_declaration_list] = "declaration_list",
  [sym_class_modifier] = "class_modifier",
  [sym_class_base_clause] = "class_base_clause",
  [sym_class_interface_clause] = "class_interface_clause",
  [sym__member_declaration] = "_member_declaration",
  [sym_const_declaration] = "const_declaration",
  [sym_property_declaration] = "property_declaration",
  [sym__modifier] = "_modifier",
  [sym_property_element] = "property_element",
  [sym_property_initializer] = "property_initializer",
  [sym_method_declaration] = "method_declaration",
  [sym_static_modifier] = "static_modifier",
  [sym_use_declaration] = "use_declaration",
  [sym_use_list] = "use_list",
  [sym_use_instead_of_clause] = "use_instead_of_clause",
  [sym_use_as_clause] = "use_as_clause",
  [sym_visibility_modifier] = "visibility_modifier",
  [sym_function_definition] = "function_definition",
  [sym__function_definition_header] = "_function_definition_header",
  [sym_formal_parameters] = "formal_parameters",
  [sym_simple_parameter] = "simple_parameter",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym__type] = "_type",
  [sym_optional_type] = "optional_type",
  [sym_primitive_type] = "primitive_type",
  [sym_cast_type] = "cast_type",
  [sym__return_type] = "_return_type",
  [sym_const_element] = "const_element",
  [sym_echo_statement] = "echo_statement",
  [sym_unset_statement] = "unset_statement",
  [sym_declare_statement] = "declare_statement",
  [sym_declare_directive] = "declare_directive",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym__jump_statement] = "_jump_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_break_statement] = "break_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__expressions] = "_expressions",
  [sym_sequence_expression] = "sequence_expression",
  [sym_foreach_statement] = "foreach_statement",
  [sym_foreach_pair] = "pair",
  [sym_if_statement] = "if_statement",
  [sym_colon_block] = "colon_block",
  [sym_else_if_clause] = "else_if_clause",
  [sym_else_clause] = "else_clause",
  [sym_else_if_clause_2] = "else_if_clause",
  [sym_else_clause_2] = "else_clause",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_block] = "switch_block",
  [sym_case_statement] = "case_statement",
  [sym_default_statement] = "default_statement",
  [sym_compound_statement] = "compound_statement",
  [sym_named_label_statement] = "named_label_statement",
  [sym_expression_statement] = "expression_statement",
  [sym__expression] = "_expression",
  [sym__unary_expression] = "_unary_expression",
  [sym_unary_op_expression] = "unary_op_expression",
  [sym_exponentiation_expression] = "exponentiation_expression",
  [sym_clone_expression] = "clone_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_class_constant_access_expression] = "class_constant_access_expression",
  [sym_print_intrinsic] = "print_intrinsic",
  [sym_anonymous_function_creation_expression] = "anonymous_function_creation_expression",
  [sym_anonymous_function_use_clause] = "anonymous_function_use_clause",
  [sym_object_creation_expression] = "object_creation_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_cast_variable] = "cast_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym_member_access_expression] = "member_access_expression",
  [sym_scoped_property_access_expression] = "scoped_property_access_expression",
  [sym_list_literal] = "list_literal",
  [sym_function_call_expression] = "function_call_expression",
  [sym_scoped_call_expression] = "scoped_call_expression",
  [sym__scope_resolution_qualifier] = "_scope_resolution_qualifier",
  [sym_relative_scope] = "relative_scope",
  [sym_arguments] = "arguments",
  [sym_member_call_expression] = "member_call_expression",
  [sym_variadic_unpacking] = "variadic_unpacking",
  [sym_subscript_expression] = "subscript_expression",
  [sym__dereferencable_expression] = "_dereferencable_expression",
  [sym_array_creation_expression] = "array_creation_expression",
  [sym__string] = "_string",
  [sym_dynamic_variable_name] = "dynamic_variable_name",
  [sym_variable_name] = "variable_name",
  [sym_yield_expression] = "yield_expression",
  [sym_array_element_initializer] = "array_element_initializer",
  [sym_binary_expression] = "binary_expression",
  [sym_include_expression] = "include_expression",
  [sym_include_once_expression] = "include_once_expression",
  [sym_require_expression] = "require_expression",
  [sym_require_once_expression] = "require_once_expression",
  [sym__reserved_identifier] = "name",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_text_repeat1] = "text_repeat1",
  [aux_sym_function_static_declaration_repeat1] = "function_static_declaration_repeat1",
  [aux_sym_global_declaration_repeat1] = "global_declaration_repeat1",
  [aux_sym_namespace_use_declaration_repeat1] = "namespace_use_declaration_repeat1",
  [aux_sym_namespace_name_repeat1] = "namespace_name_repeat1",
  [aux_sym_namespace_use_group_repeat1] = "namespace_use_group_repeat1",
  [aux_sym_interface_base_clause_repeat1] = "interface_base_clause_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym_const_declaration_repeat1] = "const_declaration_repeat1",
  [aux_sym_property_declaration_repeat1] = "property_declaration_repeat1",
  [aux_sym_property_declaration_repeat2] = "property_declaration_repeat2",
  [aux_sym_use_list_repeat1] = "use_list_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_unset_statement_repeat1] = "unset_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_if_statement_repeat2] = "if_statement_repeat2",
  [aux_sym_switch_block_repeat1] = "switch_block_repeat1",
  [aux_sym_anonymous_function_use_clause_repeat1] = "anonymous_function_use_clause_repeat1",
  [aux_sym_list_literal_repeat1] = "list_literal_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym_array_creation_expression_repeat1] = "array_creation_expression_repeat1",
  [alias_sym_type_name] = "type_name",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_name] = sym_name,
  [sym_php_tag] = sym_php_tag,
  [anon_sym_QMARK_GT] = anon_sym_QMARK_GT,
  [aux_sym_text_token1] = aux_sym_text_token1,
  [aux_sym_text_token2] = aux_sym_text_token2,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_trait] = anon_sym_trait,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_implements] = anon_sym_implements,
  [sym_var_modifier] = sym_var_modifier,
  [anon_sym_insteadof] = anon_sym_insteadof,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_array] = anon_sym_array,
  [anon_sym_callable] = anon_sym_callable,
  [anon_sym_iterable] = anon_sym_iterable,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_binary] = anon_sym_binary,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_double] = anon_sym_double,
  [anon_sym_integer] = anon_sym_integer,
  [anon_sym_object] = anon_sym_object,
  [anon_sym_real] = anon_sym_real,
  [anon_sym_unset] = anon_sym_unset,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_echo] = anon_sym_echo,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_enddeclare] = anon_sym_enddeclare,
  [anon_sym_ticks] = anon_sym_ticks,
  [anon_sym_encoding] = anon_sym_encoding,
  [anon_sym_strict_types] = anon_sym_strict_types,
  [sym_float] = sym_float,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_break] = anon_sym_break,
  [sym_integer] = sym_integer,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_endwhile] = anon_sym_endwhile,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_endfor] = anon_sym_endfor,
  [anon_sym_foreach] = anon_sym_foreach,
  [anon_sym_endforeach] = anon_sym_endforeach,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_endif] = anon_sym_endif,
  [anon_sym_elseif] = anon_sym_elseif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_endswitch] = anon_sym_endswitch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_clone] = anon_sym_clone,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_print] = anon_sym_print,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [sym_shell_command_expression] = sym_shell_command_expression,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_DOT_EQ] = anon_sym_DOT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_list] = anon_sym_list,
  [anon_sym_self] = anon_sym_self,
  [anon_sym_parent] = anon_sym_parent,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [sym_string] = sym_string,
  [sym_boolean] = sym_boolean,
  [sym_null] = sym_null,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [aux_sym_binary_expression_token1] = aux_sym_binary_expression_token1,
  [aux_sym_binary_expression_token2] = aux_sym_binary_expression_token2,
  [aux_sym_binary_expression_token3] = aux_sym_binary_expression_token3,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_include] = anon_sym_include,
  [anon_sym_include_once] = anon_sym_include_once,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_require_once] = anon_sym_require_once,
  [sym_comment] = sym_comment,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym_heredoc] = sym_heredoc,
  [sym__eof] = sym__eof,
  [sym_program] = sym_program,
  [sym_text_interpolation] = sym_text_interpolation,
  [sym_text] = sym_text,
  [sym_empty_statement] = sym_empty_statement,
  [sym_function_static_declaration] = sym_function_static_declaration,
  [sym_static_variable_declaration] = sym_static_variable_declaration,
  [sym_global_declaration] = sym_global_declaration,
  [sym_namespace_definition] = sym_namespace_definition,
  [sym_namespace_use_declaration] = sym_namespace_use_declaration,
  [sym_namespace_function_or_const] = sym_namespace_function_or_const,
  [sym_namespace_use_clause] = sym_namespace_use_clause,
  [sym_qualified_name] = sym_qualified_name,
  [sym_namespace_name_as_prefix] = sym_namespace_name_as_prefix,
  [sym_namespace_name] = sym_namespace_name,
  [sym_namespace_aliasing_clause] = sym_namespace_aliasing_clause,
  [sym_namespace_use_group] = sym_namespace_use_group,
  [sym_namespace_use_group_clause] = sym_namespace_use_group_clause,
  [sym_trait_declaration] = sym_trait_declaration,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_interface_base_clause] = sym_interface_base_clause,
  [sym_class_declaration] = sym_class_declaration,
  [sym_declaration_list] = sym_declaration_list,
  [sym_class_modifier] = sym_class_modifier,
  [sym_class_base_clause] = sym_class_base_clause,
  [sym_class_interface_clause] = sym_class_interface_clause,
  [sym__member_declaration] = sym__member_declaration,
  [sym_const_declaration] = sym_const_declaration,
  [sym_property_declaration] = sym_property_declaration,
  [sym__modifier] = sym__modifier,
  [sym_property_element] = sym_property_element,
  [sym_property_initializer] = sym_property_initializer,
  [sym_method_declaration] = sym_method_declaration,
  [sym_static_modifier] = sym_static_modifier,
  [sym_use_declaration] = sym_use_declaration,
  [sym_use_list] = sym_use_list,
  [sym_use_instead_of_clause] = sym_use_instead_of_clause,
  [sym_use_as_clause] = sym_use_as_clause,
  [sym_visibility_modifier] = sym_visibility_modifier,
  [sym_function_definition] = sym_function_definition,
  [sym__function_definition_header] = sym__function_definition_header,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_simple_parameter] = sym_simple_parameter,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym__type] = sym__type,
  [sym_optional_type] = sym_optional_type,
  [sym_primitive_type] = sym_primitive_type,
  [sym_cast_type] = sym_cast_type,
  [sym__return_type] = sym__return_type,
  [sym_const_element] = sym_const_element,
  [sym_echo_statement] = sym_echo_statement,
  [sym_unset_statement] = sym_unset_statement,
  [sym_declare_statement] = sym_declare_statement,
  [sym_declare_directive] = sym_declare_directive,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym__jump_statement] = sym__jump_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__expressions] = sym__expressions,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_foreach_statement] = sym_foreach_statement,
  [sym_foreach_pair] = sym_foreach_pair,
  [sym_if_statement] = sym_if_statement,
  [sym_colon_block] = sym_colon_block,
  [sym_else_if_clause] = sym_else_if_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_else_if_clause_2] = sym_else_if_clause,
  [sym_else_clause_2] = sym_else_clause,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_block] = sym_switch_block,
  [sym_case_statement] = sym_case_statement,
  [sym_default_statement] = sym_default_statement,
  [sym_compound_statement] = sym_compound_statement,
  [sym_named_label_statement] = sym_named_label_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym__expression] = sym__expression,
  [sym__unary_expression] = sym__unary_expression,
  [sym_unary_op_expression] = sym_unary_op_expression,
  [sym_exponentiation_expression] = sym_exponentiation_expression,
  [sym_clone_expression] = sym_clone_expression,
  [sym__primary_expression] = sym__primary_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_class_constant_access_expression] = sym_class_constant_access_expression,
  [sym_print_intrinsic] = sym_print_intrinsic,
  [sym_anonymous_function_creation_expression] = sym_anonymous_function_creation_expression,
  [sym_anonymous_function_use_clause] = sym_anonymous_function_use_clause,
  [sym_object_creation_expression] = sym_object_creation_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_cast_variable] = sym_cast_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym_member_access_expression] = sym_member_access_expression,
  [sym_scoped_property_access_expression] = sym_scoped_property_access_expression,
  [sym_list_literal] = sym_list_literal,
  [sym_function_call_expression] = sym_function_call_expression,
  [sym_scoped_call_expression] = sym_scoped_call_expression,
  [sym__scope_resolution_qualifier] = sym__scope_resolution_qualifier,
  [sym_relative_scope] = sym_relative_scope,
  [sym_arguments] = sym_arguments,
  [sym_member_call_expression] = sym_member_call_expression,
  [sym_variadic_unpacking] = sym_variadic_unpacking,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym__dereferencable_expression] = sym__dereferencable_expression,
  [sym_array_creation_expression] = sym_array_creation_expression,
  [sym__string] = sym__string,
  [sym_dynamic_variable_name] = sym_dynamic_variable_name,
  [sym_variable_name] = sym_variable_name,
  [sym_yield_expression] = sym_yield_expression,
  [sym_array_element_initializer] = sym_array_element_initializer,
  [sym_binary_expression] = sym_binary_expression,
  [sym_include_expression] = sym_include_expression,
  [sym_include_once_expression] = sym_include_once_expression,
  [sym_require_expression] = sym_require_expression,
  [sym_require_once_expression] = sym_require_once_expression,
  [sym__reserved_identifier] = sym_name,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_text_repeat1] = aux_sym_text_repeat1,
  [aux_sym_function_static_declaration_repeat1] = aux_sym_function_static_declaration_repeat1,
  [aux_sym_global_declaration_repeat1] = aux_sym_global_declaration_repeat1,
  [aux_sym_namespace_use_declaration_repeat1] = aux_sym_namespace_use_declaration_repeat1,
  [aux_sym_namespace_name_repeat1] = aux_sym_namespace_name_repeat1,
  [aux_sym_namespace_use_group_repeat1] = aux_sym_namespace_use_group_repeat1,
  [aux_sym_interface_base_clause_repeat1] = aux_sym_interface_base_clause_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym_const_declaration_repeat1] = aux_sym_const_declaration_repeat1,
  [aux_sym_property_declaration_repeat1] = aux_sym_property_declaration_repeat1,
  [aux_sym_property_declaration_repeat2] = aux_sym_property_declaration_repeat2,
  [aux_sym_use_list_repeat1] = aux_sym_use_list_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_unset_statement_repeat1] = aux_sym_unset_statement_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_if_statement_repeat2] = aux_sym_if_statement_repeat2,
  [aux_sym_switch_block_repeat1] = aux_sym_switch_block_repeat1,
  [aux_sym_anonymous_function_use_clause_repeat1] = aux_sym_anonymous_function_use_clause_repeat1,
  [aux_sym_list_literal_repeat1] = aux_sym_list_literal_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym_array_creation_expression_repeat1] = aux_sym_array_creation_expression_repeat1,
  [alias_sym_type_name] = alias_sym_type_name,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_name] = {
    .visible = true,
    .named = true,
  },
  [sym_php_tag] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_text_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_text_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_trait] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [sym_var_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_insteadof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_array] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iterable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_binary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_double] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_integer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_real] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_echo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enddeclare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ticks] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_encoding] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_strict_types] = {
    .visible = true,
    .named = false,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_endwhile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_endfor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_endforeach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_endif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elseif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_endswitch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_clone] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_shell_command_expression] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_list] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_self] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_parent] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_binary_expression_token3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_include] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_include_once] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require_once] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym__eof] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_text_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_text] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_function_static_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_global_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_function_or_const] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_name_as_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_aliasing_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_group] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_use_group_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_base_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_class_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class_base_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_class_interface_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__member_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_const_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__modifier] = {
    .visible = false,
    .named = true,
  },
  [sym_property_element] = {
    .visible = true,
    .named = true,
  },
  [sym_property_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_instead_of_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_use_as_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__function_definition_header] = {
    .visible = false,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_type] = {
    .visible = true,
    .named = true,
  },
  [sym__return_type] = {
    .visible = false,
    .named = true,
  },
  [sym_const_element] = {
    .visible = true,
    .named = true,
  },
  [sym_echo_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_declare_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_declare_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__jump_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expressions] = {
    .visible = false,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_colon_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_clause_2] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause_2] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_block] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_default_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_named_label_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_unary_op_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_exponentiation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_clone_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_constant_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_print_intrinsic] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_function_use_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_property_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_list_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__scope_resolution_qualifier] = {
    .visible = false,
    .named = true,
  },
  [sym_relative_scope] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_member_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_unpacking] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__dereferencable_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_dynamic_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_element_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_include_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_include_once_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_require_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_require_once_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__reserved_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_text_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_static_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_use_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_namespace_use_group_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_base_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_const_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_property_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_property_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_anonymous_function_use_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_creation_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_type_name] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alternative = 1,
  field_arguments = 2,
  field_body = 3,
  field_condition = 4,
  field_default_value = 5,
  field_function = 6,
  field_left = 7,
  field_name = 8,
  field_object = 9,
  field_operator = 10,
  field_parameters = 11,
  field_return_type = 12,
  field_right = 13,
  field_scope = 14,
  field_type = 15,
  field_value = 16,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_default_value] = "default_value",
  [field_function] = "function",
  [field_left] = "left",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_type] = "type",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[64] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 2},
  [4] = {.index = 4, .length = 4},
  [5] = {.index = 8, .length = 1},
  [6] = {.index = 9, .length = 2},
  [8] = {.index = 11, .length = 2},
  [9] = {.index = 13, .length = 2},
  [10] = {.index = 15, .length = 2},
  [11] = {.index = 17, .length = 3},
  [12] = {.index = 20, .length = 2},
  [13] = {.index = 22, .length = 2},
  [14] = {.index = 24, .length = 2},
  [15] = {.index = 26, .length = 2},
  [16] = {.index = 28, .length = 2},
  [17] = {.index = 30, .length = 2},
  [19] = {.index = 32, .length = 2},
  [20] = {.index = 34, .length = 3},
  [21] = {.index = 37, .length = 1},
  [22] = {.index = 38, .length = 3},
  [23] = {.index = 41, .length = 2},
  [24] = {.index = 43, .length = 2},
  [25] = {.index = 45, .length = 1},
  [26] = {.index = 46, .length = 3},
  [27] = {.index = 49, .length = 3},
  [28] = {.index = 52, .length = 2},
  [29] = {.index = 54, .length = 2},
  [30] = {.index = 56, .length = 2},
  [31] = {.index = 58, .length = 3},
  [32] = {.index = 61, .length = 3},
  [33] = {.index = 64, .length = 2},
  [34] = {.index = 66, .length = 3},
  [35] = {.index = 69, .length = 3},
  [36] = {.index = 72, .length = 1},
  [37] = {.index = 73, .length = 2},
  [38] = {.index = 75, .length = 2},
  [39] = {.index = 77, .length = 3},
  [40] = {.index = 80, .length = 3},
  [41] = {.index = 83, .length = 2},
  [42] = {.index = 85, .length = 2},
  [43] = {.index = 87, .length = 4},
  [44] = {.index = 91, .length = 2},
  [45] = {.index = 93, .length = 2},
  [46] = {.index = 95, .length = 3},
  [47] = {.index = 98, .length = 2},
  [48] = {.index = 100, .length = 3},
  [49] = {.index = 103, .length = 3},
  [50] = {.index = 106, .length = 2},
  [51] = {.index = 108, .length = 2},
  [52] = {.index = 110, .length = 3},
  [53] = {.index = 113, .length = 3},
  [54] = {.index = 116, .length = 4},
  [55] = {.index = 120, .length = 1},
  [56] = {.index = 121, .length = 2},
  [57] = {.index = 123, .length = 3},
  [58] = {.index = 126, .length = 3},
  [59] = {.index = 129, .length = 3},
  [60] = {.index = 132, .length = 3},
  [61] = {.index = 135, .length = 1},
  [62] = {.index = 136, .length = 3},
  [63] = {.index = 139, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_body, 1},
  [2] =
    {field_arguments, 1},
    {field_function, 0},
  [4] =
    {field_body, 1},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
  [8] =
    {field_name, 1},
  [9] =
    {field_body, 2},
    {field_name, 1},
  [11] =
    {field_name, 1},
    {field_parameters, 2},
  [13] =
    {field_body, 2},
    {field_parameters, 1},
  [15] =
    {field_body, 2},
    {field_condition, 1},
  [17] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [20] =
    {field_left, 0},
    {field_right, 2},
  [22] =
    {field_name, 2},
    {field_scope, 0},
  [24] =
    {field_name, 2},
    {field_object, 0},
  [26] =
    {field_body, 3},
    {field_parameters, 2},
  [28] =
    {field_name, 0},
    {field_value, 2},
  [30] =
    {field_name, 2},
    {field_parameters, 3},
  [32] =
    {field_name, 1},
    {field_type, 0},
  [34] =
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [37] =
    {field_return_type, 1},
  [38] =
    {field_body, 3},
    {field_parameters, 1},
    {field_return_type, 2, .inherited = true},
  [41] =
    {field_body, 3},
    {field_name, 1},
  [43] =
    {field_type, 1},
    {field_value, 3},
  [45] =
    {field_alternative, 0},
  [46] =
    {field_alternative, 3},
    {field_body, 2},
    {field_condition, 1},
  [49] =
    {field_alternative, 3, .inherited = true},
    {field_body, 2},
    {field_condition, 1},
  [52] =
    {field_body, 3},
    {field_name, 2},
  [54] =
    {field_alternative, 3},
    {field_condition, 0},
  [56] =
    {field_left, 0},
    {field_right, 3},
  [58] =
    {field_arguments, 3},
    {field_name, 2},
    {field_scope, 0},
  [61] =
    {field_arguments, 3},
    {field_name, 2},
    {field_object, 0},
  [64] =
    {field_body, 4},
    {field_parameters, 3},
  [66] =
    {field_body, 4},
    {field_parameters, 2},
    {field_return_type, 3, .inherited = true},
  [69] =
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 4, .inherited = true},
  [72] =
    {field_name, 2},
  [73] =
    {field_name, 2},
    {field_type, 0},
  [75] =
    {field_default_value, 2},
    {field_name, 0},
  [77] =
    {field_body, 4},
    {field_parameters, 1},
    {field_return_type, 3, .inherited = true},
  [80] =
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
  [83] =
    {field_body, 4},
    {field_name, 1},
  [85] =
    {field_body, 1},
    {field_condition, 3},
  [87] =
    {field_alternative, 3, .inherited = true},
    {field_alternative, 4},
    {field_body, 2},
    {field_condition, 1},
  [91] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [93] =
    {field_body, 4},
    {field_name, 2},
  [95] =
    {field_alternative, 4},
    {field_body, 2},
    {field_condition, 0},
  [98] =
    {field_name, 3},
    {field_object, 0},
  [100] =
    {field_body, 5},
    {field_parameters, 3},
    {field_return_type, 4, .inherited = true},
  [103] =
    {field_body, 5},
    {field_parameters, 2},
    {field_return_type, 4, .inherited = true},
  [106] =
    {field_default_value, 3},
    {field_name, 1},
  [108] =
    {field_name, 3},
    {field_type, 0},
  [110] =
    {field_default_value, 3},
    {field_name, 1},
    {field_type, 0},
  [113] =
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [116] =
    {field_body, 2},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
  [120] =
    {field_value, 1},
  [121] =
    {field_body, 5},
    {field_name, 2},
  [123] =
    {field_arguments, 5},
    {field_name, 3},
    {field_scope, 0},
  [126] =
    {field_arguments, 5},
    {field_name, 3},
    {field_object, 0},
  [129] =
    {field_body, 6},
    {field_parameters, 3},
    {field_return_type, 5, .inherited = true},
  [132] =
    {field_default_value, 4},
    {field_name, 2},
    {field_type, 0},
  [135] =
    {field_body, 6},
  [136] =
    {field_body, 5},
    {field_name, 3},
    {field_type, 2},
  [139] =
    {field_body, 7},
};

static TSSymbol ts_alias_sequences[64][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [7] = {
    [0] = alias_sym_type_name,
  },
  [18] = {
    [1] = alias_sym_type_name,
  },
  [62] = {
    [2] = alias_sym_type_name,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(80);
      if (lookahead == '!') ADVANCE(132);
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(105);
      if (lookahead == '\'') ADVANCE(29);
      if (lookahead == '(') ADVANCE(106);
      if (lookahead == ')') ADVANCE(107);
      if (lookahead == '*') ADVANCE(187);
      if (lookahead == '+') ADVANCE(126);
      if (lookahead == ',') ADVANCE(97);
      if (lookahead == '-') ADVANCE(128);
      if (lookahead == '.') ADVANCE(186);
      if (lookahead == '/') ADVANCE(190);
      if (lookahead == '0') ADVANCE(117);
      if (lookahead == ':') ADVANCE(112);
      if (lookahead == ';') ADVANCE(96);
      if (lookahead == '<') ADVANCE(174);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '>') ADVANCE(175);
      if (lookahead == '?') ADVANCE(110);
      if (lookahead == '@') ADVANCE(123);
      if (lookahead == '[') ADVANCE(152);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == ']') ADVANCE(153);
      if (lookahead == '^') ADVANCE(166);
      if (lookahead == '`') ADVANCE(58);
      if (lookahead == '{') ADVANCE(101);
      if (lookahead == '|') ADVANCE(163);
      if (lookahead == '}') ADVANCE(102);
      if (lookahead == '~') ADVANCE(130);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(193);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(194);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(195);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(203);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(200);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      if (('A' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(205);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(205);
      if (lookahead == '\r') ADVANCE(1);
      if (lookahead != 0 &&
          lookahead != '>') ADVANCE(206);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(132);
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(104);
      if (lookahead == '\'') ADVANCE(29);
      if (lookahead == '(') ADVANCE(106);
      if (lookahead == ')') ADVANCE(107);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(97);
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(186);
      if (lookahead == '/') ADVANCE(189);
      if (lookahead == '0') ADVANCE(117);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(96);
      if (lookahead == '<') ADVANCE(172);
      if (lookahead == '=') ADVANCE(44);
      if (lookahead == '>') ADVANCE(176);
      if (lookahead == '?') ADVANCE(110);
      if (lookahead == '@') ADVANCE(123);
      if (lookahead == '[') ADVANCE(152);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == ']') ADVANCE(153);
      if (lookahead == '^') ADVANCE(165);
      if (lookahead == '`') ADVANCE(58);
      if (lookahead == '|') ADVANCE(164);
      if (lookahead == '}') ADVANCE(102);
      if (lookahead == '~') ADVANCE(130);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(193);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(194);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(195);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(203);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(200);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      if (('A' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(131);
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '&') ADVANCE(103);
      if (lookahead == '\'') ADVANCE(29);
      if (lookahead == '(') ADVANCE(106);
      if (lookahead == ')') ADVANCE(107);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(30);
      if (lookahead == '0') ADVANCE(117);
      if (lookahead == '?') ADVANCE(46);
      if (lookahead == '@') ADVANCE(123);
      if (lookahead == '[') ADVANCE(152);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == '`') ADVANCE(58);
      if (lookahead == '{') ADVANCE(101);
      if (lookahead == '~') ADVANCE(130);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(193);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(194);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(195);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(203);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(200);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(4)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(43);
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '%') ADVANCE(192);
      if (lookahead == '&') ADVANCE(105);
      if (lookahead == '\'') ADVANCE(29);
      if (lookahead == '(') ADVANCE(106);
      if (lookahead == ')') ADVANCE(107);
      if (lookahead == '*') ADVANCE(187);
      if (lookahead == '+') ADVANCE(126);
      if (lookahead == ',') ADVANCE(97);
      if (lookahead == '-') ADVANCE(128);
      if (lookahead == '.') ADVANCE(185);
      if (lookahead == '/') ADVANCE(190);
      if (lookahead == ':') ADVANCE(112);
      if (lookahead == ';') ADVANCE(96);
      if (lookahead == '<') ADVANCE(173);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '>') ADVANCE(175);
      if (lookahead == '?') ADVANCE(110);
      if (lookahead == '[') ADVANCE(152);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == ']') ADVANCE(153);
      if (lookahead == '^') ADVANCE(166);
      if (lookahead == '{') ADVANCE(101);
      if (lookahead == '|') ADVANCE(163);
      if (lookahead == '}') ADVANCE(102);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(193);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(5)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(43);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '%') ADVANCE(191);
      if (lookahead == '&') ADVANCE(104);
      if (lookahead == '(') ADVANCE(106);
      if (lookahead == ')') ADVANCE(107);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(97);
      if (lookahead == '-') ADVANCE(129);
      if (lookahead == '.') ADVANCE(184);
      if (lookahead == '/') ADVANCE(189);
      if (lookahead == ':') ADVANCE(112);
      if (lookahead == ';') ADVANCE(96);
      if (lookahead == '<') ADVANCE(172);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '>') ADVANCE(176);
      if (lookahead == '?') ADVANCE(110);
      if (lookahead == '[') ADVANCE(152);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == ']') ADVANCE(153);
      if (lookahead == '^') ADVANCE(165);
      if (lookahead == '{') ADVANCE(101);
      if (lookahead == '|') ADVANCE(164);
      if (lookahead == '}') ADVANCE(102);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '\'') ADVANCE(29);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(30);
      if (lookahead == '0') ADVANCE(117);
      if (lookahead == '?') ADVANCE(46);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(8);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(61);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(71);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(7)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '\'') ADVANCE(29);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '-') ADVANCE(25);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '-') ADVANCE(19);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '-') ADVANCE(21);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '-') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '-') ADVANCE(20);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '-') ADVANCE(22);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == 'A') ADVANCE(10);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead == 'a') ADVANCE(11);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(16);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == 'A') ADVANCE(12);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead == 'a') ADVANCE(9);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == 'A') ADVANCE(13);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead == 'a') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(18);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == 'A') ADVANCE(13);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead == 'a') ADVANCE(14);
      if (lookahead != 0 &&
          (lookahead < '0' || '9' < lookahead)) ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(18);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == 'F') ADVANCE(16);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == 'F') ADVANCE(18);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 21:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead == 'f') ADVANCE(16);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 22:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead == 'f') ADVANCE(18);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 23:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead == '{') ADVANCE(17);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 24:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(25);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 25:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(76);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 26:
      if (lookahead == '"') ADVANCE(154);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(25);
      if (lookahead == '\\') ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '&') ADVANCE(103);
      if (lookahead == '(') ADVANCE(106);
      if (lookahead == ')') ADVANCE(107);
      if (lookahead == ',') ADVANCE(97);
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == '.') ADVANCE(40);
      if (lookahead == '/') ADVANCE(30);
      if (lookahead == ':') ADVANCE(42);
      if (lookahead == '=') ADVANCE(98);
      if (lookahead == '?') ADVANCE(109);
      if (lookahead == '[') ADVANCE(152);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == '{') ADVANCE(101);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(27)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 28:
      if (lookahead == '#') ADVANCE(93);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(28)
      if (lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(89);
      if (lookahead != 0) ADVANCE(95);
      END_STATE();
    case 29:
      if (lookahead == '\'') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(74);
      if (lookahead != 0) ADVANCE(29);
      END_STATE();
    case 30:
      if (lookahead == '*') ADVANCE(32);
      if (lookahead == '/') ADVANCE(206);
      END_STATE();
    case 31:
      if (lookahead == '*') ADVANCE(31);
      if (lookahead == '/') ADVANCE(205);
      if (lookahead != 0) ADVANCE(32);
      END_STATE();
    case 32:
      if (lookahead == '*') ADVANCE(31);
      if (lookahead != 0) ADVANCE(32);
      END_STATE();
    case 33:
      if (lookahead == '-') ADVANCE(58);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 34:
      if (lookahead == '-') ADVANCE(52);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 35:
      if (lookahead == '-') ADVANCE(54);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 36:
      if (lookahead == '-') ADVANCE(75);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 37:
      if (lookahead == '-') ADVANCE(53);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 38:
      if (lookahead == '-') ADVANCE(55);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 39:
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '.') ADVANCE(41);
      END_STATE();
    case 41:
      if (lookahead == '.') ADVANCE(108);
      END_STATE();
    case 42:
      if (lookahead == ':') ADVANCE(135);
      END_STATE();
    case 43:
      if (lookahead == '=') ADVANCE(168);
      END_STATE();
    case 44:
      if (lookahead == '=') ADVANCE(167);
      if (lookahead == '>') ADVANCE(122);
      END_STATE();
    case 45:
      if (lookahead == '>') ADVANCE(151);
      END_STATE();
    case 46:
      if (lookahead == '>') ADVANCE(83);
      END_STATE();
    case 47:
      if (lookahead == '?') ADVANCE(82);
      END_STATE();
    case 48:
      if (lookahead == 'A') ADVANCE(34);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead == 'a') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(49);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 49:
      if (lookahead == 'A') ADVANCE(36);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead == 'a') ADVANCE(33);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 50:
      if (lookahead == 'A') ADVANCE(37);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead == 'a') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(51);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 51:
      if (lookahead == 'A') ADVANCE(37);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead == 'a') ADVANCE(38);
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < '0' || '9' < lookahead)) ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(51);
      END_STATE();
    case 52:
      if (lookahead == 'F') ADVANCE(49);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 53:
      if (lookahead == 'F') ADVANCE(51);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 54:
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead == 'f') ADVANCE(49);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 55:
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead == 'f') ADVANCE(51);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 56:
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead == '{') ADVANCE(50);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 57:
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(58);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 58:
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 59:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(116);
      END_STATE();
    case 60:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(120);
      END_STATE();
    case 61:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 62:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(155);
      END_STATE();
    case 63:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(67);
      END_STATE();
    case 64:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(69);
      END_STATE();
    case 65:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(157);
      END_STATE();
    case 66:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(65);
      END_STATE();
    case 67:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(81);
      END_STATE();
    case 68:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(70);
      END_STATE();
    case 69:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(62);
      END_STATE();
    case 70:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(62);
      END_STATE();
    case 71:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(66);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(116);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(121);
      END_STATE();
    case 74:
      if (lookahead != 0) ADVANCE(29);
      END_STATE();
    case 75:
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(58);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      END_STATE();
    case 76:
      if (lookahead != 0 &&
          (lookahead < '0' || '7' < lookahead) &&
          lookahead != 'X' &&
          lookahead != 'u' &&
          lookahead != 'x') ADVANCE(25);
      if (lookahead == 'u') ADVANCE(23);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(24);
      END_STATE();
    case 77:
      if (lookahead != 0 &&
          (lookahead < '0' || '7' < lookahead) &&
          lookahead != 'X' &&
          lookahead != 'u' &&
          lookahead != 'x') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(56);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(57);
      END_STATE();
    case 78:
      if (eof) ADVANCE(80);
      if (lookahead == '!') ADVANCE(131);
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '#') ADVANCE(206);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '&') ADVANCE(103);
      if (lookahead == '\'') ADVANCE(29);
      if (lookahead == '(') ADVANCE(106);
      if (lookahead == ')') ADVANCE(107);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(97);
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(30);
      if (lookahead == '0') ADVANCE(117);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(96);
      if (lookahead == '<') ADVANCE(47);
      if (lookahead == '?') ADVANCE(46);
      if (lookahead == '@') ADVANCE(123);
      if (lookahead == '[') ADVANCE(152);
      if (lookahead == '\\') ADVANCE(100);
      if (lookahead == ']') ADVANCE(153);
      if (lookahead == '`') ADVANCE(58);
      if (lookahead == '{') ADVANCE(101);
      if (lookahead == '}') ADVANCE(102);
      if (lookahead == '~') ADVANCE(130);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(193);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(194);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(195);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(203);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(200);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(78)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(119);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 79:
      if (eof) ADVANCE(80);
      if (lookahead == '#') ADVANCE(93);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '<') ADVANCE(85);
      if (lookahead == '?') ADVANCE(94);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(79)
      if (lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(88);
      if (lookahead != 0) ADVANCE(95);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_php_tag);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_php_tag);
      if (lookahead == '=') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(63);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_QMARK_GT);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_QMARK_GT);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(95);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym_text_token1);
      if (lookahead == '?') ADVANCE(82);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '\n') ADVANCE(95);
      if (lookahead == '\r') ADVANCE(87);
      if (lookahead == '<') ADVANCE(206);
      if (lookahead == '>') ADVANCE(95);
      if (lookahead != 0) ADVANCE(93);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '\n') ADVANCE(95);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(95);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '#') ADVANCE(93);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '?') ADVANCE(94);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(88);
      if (lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(88);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(95);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '#') ADVANCE(93);
      if (lookahead == '/') ADVANCE(90);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(89);
      if (lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(95);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '*') ADVANCE(92);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(95);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '*') ADVANCE(91);
      if (lookahead == '/') ADVANCE(95);
      if (lookahead == '<') ADVANCE(32);
      if (lookahead != 0) ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '*') ADVANCE(91);
      if (lookahead == '<') ADVANCE(32);
      if (lookahead != 0) ADVANCE(92);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '<') ADVANCE(206);
      if (lookahead == '?') ADVANCE(86);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(95);
      if (lookahead != 0) ADVANCE(93);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(95);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym_text_token2);
      if (lookahead != 0 &&
          lookahead != '<') ADVANCE(95);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(167);
      if (lookahead == '>') ADVANCE(122);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(162);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(162);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '>') ADVANCE(83);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '>') ADVANCE(83);
      if (lookahead == '?') ADVANCE(160);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(135);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(114);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(114);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(115);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(116);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(39);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(60);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(118);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(39);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(118);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(119);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(120);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_integer);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(121);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(136);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == '=') ADVANCE(143);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(137);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(137);
      if (lookahead == '=') ADVANCE(144);
      if (lookahead == '>') ADVANCE(151);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(151);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(168);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(139);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_shell_command_expression);
      if (lookahead == '\\') ADVANCE(77);
      if (lookahead == '`') ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(58);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_DOT_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_boolean);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_boolean);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_null);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(150);
      if (lookahead == '|') ADVANCE(161);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(161);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(170);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(171);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(180);
      if (lookahead == '=') ADVANCE(177);
      if (lookahead == '>') ADVANCE(169);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(181);
      if (lookahead == '=') ADVANCE(177);
      if (lookahead == '>') ADVANCE(169);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '?') ADVANCE(82);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(178);
      if (lookahead == '>') ADVANCE(183);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(178);
      if (lookahead == '>') ADVANCE(182);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(179);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(114);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(134);
      if (lookahead == '=') ADVANCE(140);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(133);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(32);
      if (lookahead == '/') ADVANCE(206);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(32);
      if (lookahead == '/') ADVANCE(206);
      if (lookahead == '=') ADVANCE(141);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(142);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '"') ADVANCE(25);
      if (lookahead == '\'') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(115);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(197);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('B' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(158);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(198);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(202);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(196);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(196);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_name);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(199);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (161 <= lookahead && lookahead <= 255)) ADVANCE(204);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '?') ADVANCE(2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(206);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'A') ADVANCE(1);
      if (lookahead == 'O') ADVANCE(2);
      if (lookahead == 'X') ADVANCE(3);
      if (lookahead == 'a') ADVANCE(4);
      if (lookahead == 'b') ADVANCE(5);
      if (lookahead == 'c') ADVANCE(6);
      if (lookahead == 'd') ADVANCE(7);
      if (lookahead == 'e') ADVANCE(8);
      if (lookahead == 'f') ADVANCE(9);
      if (lookahead == 'g') ADVANCE(10);
      if (lookahead == 'i') ADVANCE(11);
      if (lookahead == 'l') ADVANCE(12);
      if (lookahead == 'n') ADVANCE(13);
      if (lookahead == 'o') ADVANCE(14);
      if (lookahead == 'p') ADVANCE(15);
      if (lookahead == 'r') ADVANCE(16);
      if (lookahead == 's') ADVANCE(17);
      if (lookahead == 't') ADVANCE(18);
      if (lookahead == 'u') ADVANCE(19);
      if (lookahead == 'v') ADVANCE(20);
      if (lookahead == 'w') ADVANCE(21);
      if (lookahead == 'x') ADVANCE(22);
      if (lookahead == 'y') ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'N') ADVANCE(24);
      END_STATE();
    case 2:
      if (lookahead == 'R') ADVANCE(25);
      END_STATE();
    case 3:
      if (lookahead == 'O') ADVANCE(26);
      END_STATE();
    case 4:
      if (lookahead == 'b') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(28);
      if (lookahead == 'r') ADVANCE(29);
      if (lookahead == 's') ADVANCE(30);
      END_STATE();
    case 5:
      if (lookahead == 'i') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      if (lookahead == 'r') ADVANCE(33);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'l') ADVANCE(35);
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      END_STATE();
    case 8:
      if (lookahead == 'c') ADVANCE(39);
      if (lookahead == 'l') ADVANCE(40);
      if (lookahead == 'n') ADVANCE(41);
      if (lookahead == 'x') ADVANCE(42);
      END_STATE();
    case 9:
      if (lookahead == 'i') ADVANCE(43);
      if (lookahead == 'l') ADVANCE(44);
      if (lookahead == 'o') ADVANCE(45);
      if (lookahead == 'r') ADVANCE(46);
      if (lookahead == 'u') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'l') ADVANCE(48);
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 11:
      if (lookahead == 'f') ADVANCE(50);
      if (lookahead == 'm') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(52);
      if (lookahead == 't') ADVANCE(53);
      END_STATE();
    case 12:
      if (lookahead == 'i') ADVANCE(54);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(55);
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 14:
      if (lookahead == 'b') ADVANCE(57);
      if (lookahead == 'r') ADVANCE(25);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(58);
      if (lookahead == 'r') ADVANCE(59);
      if (lookahead == 'u') ADVANCE(60);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(62);
      if (lookahead == 't') ADVANCE(63);
      if (lookahead == 'w') ADVANCE(64);
      END_STATE();
    case 18:
      if (lookahead == 'h') ADVANCE(65);
      if (lookahead == 'i') ADVANCE(66);
      if (lookahead == 'r') ADVANCE(67);
      END_STATE();
    case 19:
      if (lookahead == 'n') ADVANCE(68);
      if (lookahead == 's') ADVANCE(69);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(70);
      if (lookahead == 'o') ADVANCE(71);
      END_STATE();
    case 21:
      if (lookahead == 'h') ADVANCE(72);
      END_STATE();
    case 22:
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 23:
      if (lookahead == 'i') ADVANCE(74);
      END_STATE();
    case 24:
      if (lookahead == 'D') ADVANCE(75);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(aux_sym_binary_expression_token2);
      END_STATE();
    case 26:
      if (lookahead == 'R') ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 's') ADVANCE(77);
      END_STATE();
    case 28:
      if (lookahead == 'd') ADVANCE(75);
      END_STATE();
    case 29:
      if (lookahead == 'r') ADVANCE(78);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 31:
      if (lookahead == 'n') ADVANCE(79);
      END_STATE();
    case 32:
      if (lookahead == 'o') ADVANCE(80);
      END_STATE();
    case 33:
      if (lookahead == 'e') ADVANCE(81);
      END_STATE();
    case 34:
      if (lookahead == 'l') ADVANCE(82);
      if (lookahead == 's') ADVANCE(83);
      if (lookahead == 't') ADVANCE(84);
      END_STATE();
    case 35:
      if (lookahead == 'a') ADVANCE(85);
      if (lookahead == 'o') ADVANCE(86);
      END_STATE();
    case 36:
      if (lookahead == 'n') ADVANCE(87);
      END_STATE();
    case 37:
      if (lookahead == 'c') ADVANCE(88);
      if (lookahead == 'f') ADVANCE(89);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(90);
      END_STATE();
    case 39:
      if (lookahead == 'h') ADVANCE(91);
      END_STATE();
    case 40:
      if (lookahead == 's') ADVANCE(92);
      END_STATE();
    case 41:
      if (lookahead == 'c') ADVANCE(93);
      if (lookahead == 'd') ADVANCE(94);
      END_STATE();
    case 42:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 43:
      if (lookahead == 'n') ADVANCE(96);
      END_STATE();
    case 44:
      if (lookahead == 'o') ADVANCE(97);
      END_STATE();
    case 45:
      if (lookahead == 'r') ADVANCE(98);
      END_STATE();
    case 46:
      if (lookahead == 'o') ADVANCE(99);
      END_STATE();
    case 47:
      if (lookahead == 'n') ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 'o') ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 51:
      if (lookahead == 'p') ADVANCE(103);
      END_STATE();
    case 52:
      if (lookahead == 'c') ADVANCE(104);
      if (lookahead == 's') ADVANCE(105);
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 54:
      if (lookahead == 's') ADVANCE(108);
      END_STATE();
    case 55:
      if (lookahead == 'm') ADVANCE(109);
      END_STATE();
    case 56:
      if (lookahead == 'w') ADVANCE(110);
      END_STATE();
    case 57:
      if (lookahead == 'j') ADVANCE(111);
      END_STATE();
    case 58:
      if (lookahead == 'r') ADVANCE(112);
      END_STATE();
    case 59:
      if (lookahead == 'i') ADVANCE(113);
      if (lookahead == 'o') ADVANCE(114);
      END_STATE();
    case 60:
      if (lookahead == 'b') ADVANCE(115);
      END_STATE();
    case 61:
      if (lookahead == 'a') ADVANCE(116);
      if (lookahead == 'q') ADVANCE(117);
      if (lookahead == 't') ADVANCE(118);
      END_STATE();
    case 62:
      if (lookahead == 'l') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'a') ADVANCE(120);
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == 'i') ADVANCE(122);
      END_STATE();
    case 65:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 66:
      if (lookahead == 'c') ADVANCE(124);
      END_STATE();
    case 67:
      if (lookahead == 'a') ADVANCE(125);
      if (lookahead == 'y') ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 's') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 'r') ADVANCE(129);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(131);
      END_STATE();
    case 73:
      if (lookahead == 'r') ADVANCE(76);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym_binary_expression_token1);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym_binary_expression_token3);
      END_STATE();
    case 77:
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 78:
      if (lookahead == 'a') ADVANCE(134);
      END_STATE();
    case 79:
      if (lookahead == 'a') ADVANCE(135);
      END_STATE();
    case 80:
      if (lookahead == 'l') ADVANCE(136);
      END_STATE();
    case 81:
      if (lookahead == 'a') ADVANCE(137);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(138);
      END_STATE();
    case 83:
      if (lookahead == 'e') ADVANCE(139);
      END_STATE();
    case 84:
      if (lookahead == 'c') ADVANCE(140);
      END_STATE();
    case 85:
      if (lookahead == 's') ADVANCE(141);
      END_STATE();
    case 86:
      if (lookahead == 'n') ADVANCE(142);
      END_STATE();
    case 87:
      if (lookahead == 's') ADVANCE(143);
      if (lookahead == 't') ADVANCE(144);
      END_STATE();
    case 88:
      if (lookahead == 'l') ADVANCE(145);
      END_STATE();
    case 89:
      if (lookahead == 'a') ADVANCE(146);
      END_STATE();
    case 90:
      if (lookahead == 'b') ADVANCE(147);
      END_STATE();
    case 91:
      if (lookahead == 'o') ADVANCE(148);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 93:
      if (lookahead == 'o') ADVANCE(150);
      END_STATE();
    case 94:
      if (lookahead == 'd') ADVANCE(151);
      if (lookahead == 'f') ADVANCE(152);
      if (lookahead == 'i') ADVANCE(153);
      if (lookahead == 's') ADVANCE(154);
      if (lookahead == 'w') ADVANCE(155);
      END_STATE();
    case 95:
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 96:
      if (lookahead == 'a') ADVANCE(157);
      END_STATE();
    case 97:
      if (lookahead == 'a') ADVANCE(158);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == 'e') ADVANCE(159);
      END_STATE();
    case 99:
      if (lookahead == 'm') ADVANCE(160);
      END_STATE();
    case 100:
      if (lookahead == 'c') ADVANCE(161);
      END_STATE();
    case 101:
      if (lookahead == 'b') ADVANCE(162);
      END_STATE();
    case 102:
      if (lookahead == 'o') ADVANCE(163);
      END_STATE();
    case 103:
      if (lookahead == 'l') ADVANCE(164);
      END_STATE();
    case 104:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 105:
      if (lookahead == 't') ADVANCE(166);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == 'e') ADVANCE(167);
      END_STATE();
    case 107:
      if (lookahead == 'r') ADVANCE(168);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 111:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 113:
      if (lookahead == 'n') ADVANCE(173);
      if (lookahead == 'v') ADVANCE(174);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(175);
      END_STATE();
    case 115:
      if (lookahead == 'l') ADVANCE(176);
      END_STATE();
    case 116:
      if (lookahead == 'l') ADVANCE(177);
      END_STATE();
    case 117:
      if (lookahead == 'u') ADVANCE(178);
      END_STATE();
    case 118:
      if (lookahead == 'u') ADVANCE(179);
      END_STATE();
    case 119:
      if (lookahead == 'f') ADVANCE(180);
      END_STATE();
    case 120:
      if (lookahead == 't') ADVANCE(181);
      END_STATE();
    case 121:
      if (lookahead == 'i') ADVANCE(182);
      END_STATE();
    case 122:
      if (lookahead == 't') ADVANCE(183);
      END_STATE();
    case 123:
      if (lookahead == 'o') ADVANCE(184);
      END_STATE();
    case 124:
      if (lookahead == 'k') ADVANCE(185);
      END_STATE();
    case 125:
      if (lookahead == 'i') ADVANCE(186);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 127:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_var_modifier);
      END_STATE();
    case 130:
      if (lookahead == 'd') ADVANCE(188);
      END_STATE();
    case 131:
      if (lookahead == 'l') ADVANCE(189);
      END_STATE();
    case 132:
      if (lookahead == 'l') ADVANCE(190);
      END_STATE();
    case 133:
      if (lookahead == 'r') ADVANCE(191);
      END_STATE();
    case 134:
      if (lookahead == 'y') ADVANCE(192);
      END_STATE();
    case 135:
      if (lookahead == 'r') ADVANCE(193);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_bool);
      if (lookahead == 'e') ADVANCE(194);
      END_STATE();
    case 137:
      if (lookahead == 'k') ADVANCE(195);
      END_STATE();
    case 138:
      if (lookahead == 'a') ADVANCE(196);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 140:
      if (lookahead == 'h') ADVANCE(197);
      END_STATE();
    case 141:
      if (lookahead == 's') ADVANCE(198);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 143:
      if (lookahead == 't') ADVANCE(200);
      END_STATE();
    case 144:
      if (lookahead == 'i') ADVANCE(201);
      END_STATE();
    case 145:
      if (lookahead == 'a') ADVANCE(202);
      END_STATE();
    case 146:
      if (lookahead == 'u') ADVANCE(203);
      END_STATE();
    case 147:
      if (lookahead == 'l') ADVANCE(204);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_echo);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(205);
      END_STATE();
    case 150:
      if (lookahead == 'd') ADVANCE(206);
      END_STATE();
    case 151:
      if (lookahead == 'e') ADVANCE(207);
      END_STATE();
    case 152:
      if (lookahead == 'o') ADVANCE(208);
      END_STATE();
    case 153:
      if (lookahead == 'f') ADVANCE(209);
      END_STATE();
    case 154:
      if (lookahead == 'w') ADVANCE(210);
      END_STATE();
    case 155:
      if (lookahead == 'h') ADVANCE(211);
      END_STATE();
    case 156:
      if (lookahead == 'n') ADVANCE(212);
      END_STATE();
    case 157:
      if (lookahead == 'l') ADVANCE(213);
      END_STATE();
    case 158:
      if (lookahead == 't') ADVANCE(214);
      END_STATE();
    case 159:
      if (lookahead == 'a') ADVANCE(215);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 161:
      if (lookahead == 't') ADVANCE(216);
      END_STATE();
    case 162:
      if (lookahead == 'a') ADVANCE(217);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(218);
      END_STATE();
    case 165:
      if (lookahead == 'u') ADVANCE(219);
      END_STATE();
    case 166:
      if (lookahead == 'a') ADVANCE(220);
      if (lookahead == 'e') ADVANCE(221);
      END_STATE();
    case 167:
      if (lookahead == 'g') ADVANCE(222);
      if (lookahead == 'r') ADVANCE(223);
      END_STATE();
    case 168:
      if (lookahead == 'a') ADVANCE(224);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_list);
      END_STATE();
    case 170:
      if (lookahead == 's') ADVANCE(225);
      END_STATE();
    case 171:
      if (lookahead == 'c') ADVANCE(226);
      END_STATE();
    case 172:
      if (lookahead == 'n') ADVANCE(227);
      END_STATE();
    case 173:
      if (lookahead == 't') ADVANCE(228);
      END_STATE();
    case 174:
      if (lookahead == 'a') ADVANCE(229);
      END_STATE();
    case 175:
      if (lookahead == 'e') ADVANCE(230);
      END_STATE();
    case 176:
      if (lookahead == 'i') ADVANCE(231);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_real);
      END_STATE();
    case 178:
      if (lookahead == 'i') ADVANCE(232);
      END_STATE();
    case 179:
      if (lookahead == 'r') ADVANCE(233);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_self);
      END_STATE();
    case 181:
      if (lookahead == 'i') ADVANCE(234);
      END_STATE();
    case 182:
      if (lookahead == 'c') ADVANCE(235);
      if (lookahead == 'n') ADVANCE(236);
      END_STATE();
    case 183:
      if (lookahead == 'c') ADVANCE(237);
      END_STATE();
    case 184:
      if (lookahead == 'w') ADVANCE(238);
      END_STATE();
    case 185:
      if (lookahead == 's') ADVANCE(239);
      END_STATE();
    case 186:
      if (lookahead == 't') ADVANCE(240);
      END_STATE();
    case 187:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 189:
      if (lookahead == 'e') ADVANCE(242);
      END_STATE();
    case 190:
      if (lookahead == 'd') ADVANCE(243);
      END_STATE();
    case 191:
      if (lookahead == 'a') ADVANCE(244);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_array);
      END_STATE();
    case 193:
      if (lookahead == 'y') ADVANCE(245);
      END_STATE();
    case 194:
      if (lookahead == 'a') ADVANCE(246);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 196:
      if (lookahead == 'b') ADVANCE(247);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_clone);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 201:
      if (lookahead == 'n') ADVANCE(248);
      END_STATE();
    case 202:
      if (lookahead == 'r') ADVANCE(249);
      END_STATE();
    case 203:
      if (lookahead == 'l') ADVANCE(250);
      END_STATE();
    case 204:
      if (lookahead == 'e') ADVANCE(251);
      END_STATE();
    case 205:
      if (lookahead == 'f') ADVANCE(252);
      END_STATE();
    case 206:
      if (lookahead == 'i') ADVANCE(253);
      END_STATE();
    case 207:
      if (lookahead == 'c') ADVANCE(254);
      END_STATE();
    case 208:
      if (lookahead == 'r') ADVANCE(255);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_endif);
      END_STATE();
    case 210:
      if (lookahead == 'i') ADVANCE(256);
      END_STATE();
    case 211:
      if (lookahead == 'i') ADVANCE(257);
      END_STATE();
    case 212:
      if (lookahead == 'd') ADVANCE(258);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_final);
      if (lookahead == 'l') ADVANCE(259);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 215:
      if (lookahead == 'c') ADVANCE(260);
      END_STATE();
    case 216:
      if (lookahead == 'i') ADVANCE(261);
      END_STATE();
    case 217:
      if (lookahead == 'l') ADVANCE(262);
      END_STATE();
    case 218:
      if (lookahead == 'm') ADVANCE(263);
      END_STATE();
    case 219:
      if (lookahead == 'd') ADVANCE(264);
      END_STATE();
    case 220:
      if (lookahead == 'n') ADVANCE(265);
      END_STATE();
    case 221:
      if (lookahead == 'a') ADVANCE(266);
      END_STATE();
    case 222:
      if (lookahead == 'e') ADVANCE(267);
      END_STATE();
    case 223:
      if (lookahead == 'f') ADVANCE(268);
      END_STATE();
    case 224:
      if (lookahead == 'b') ADVANCE(269);
      END_STATE();
    case 225:
      if (lookahead == 'p') ADVANCE(270);
      END_STATE();
    case 226:
      if (lookahead == 't') ADVANCE(271);
      END_STATE();
    case 227:
      if (lookahead == 't') ADVANCE(272);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 229:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 230:
      if (lookahead == 'c') ADVANCE(274);
      END_STATE();
    case 231:
      if (lookahead == 'c') ADVANCE(275);
      END_STATE();
    case 232:
      if (lookahead == 'r') ADVANCE(276);
      END_STATE();
    case 233:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 234:
      if (lookahead == 'c') ADVANCE(278);
      END_STATE();
    case 235:
      if (lookahead == 't') ADVANCE(279);
      END_STATE();
    case 236:
      if (lookahead == 'g') ADVANCE(280);
      END_STATE();
    case 237:
      if (lookahead == 'h') ADVANCE(281);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_ticks);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_trait);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_unset);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 244:
      if (lookahead == 'c') ADVANCE(282);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_binary);
      END_STATE();
    case 246:
      if (lookahead == 'n') ADVANCE(283);
      END_STATE();
    case 247:
      if (lookahead == 'l') ADVANCE(284);
      END_STATE();
    case 248:
      if (lookahead == 'u') ADVANCE(285);
      END_STATE();
    case 249:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 250:
      if (lookahead == 't') ADVANCE(287);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_double);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_elseif);
      END_STATE();
    case 253:
      if (lookahead == 'n') ADVANCE(288);
      END_STATE();
    case 254:
      if (lookahead == 'l') ADVANCE(289);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_endfor);
      if (lookahead == 'e') ADVANCE(290);
      END_STATE();
    case 256:
      if (lookahead == 't') ADVANCE(291);
      END_STATE();
    case 257:
      if (lookahead == 'l') ADVANCE(292);
      END_STATE();
    case 258:
      if (lookahead == 's') ADVANCE(293);
      END_STATE();
    case 259:
      if (lookahead == 'y') ADVANCE(294);
      END_STATE();
    case 260:
      if (lookahead == 'h') ADVANCE(295);
      END_STATE();
    case 261:
      if (lookahead == 'o') ADVANCE(296);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 263:
      if (lookahead == 'e') ADVANCE(297);
      END_STATE();
    case 264:
      if (lookahead == 'e') ADVANCE(298);
      END_STATE();
    case 265:
      if (lookahead == 'c') ADVANCE(299);
      END_STATE();
    case 266:
      if (lookahead == 'd') ADVANCE(300);
      END_STATE();
    case 267:
      if (lookahead == 'r') ADVANCE(301);
      END_STATE();
    case 268:
      if (lookahead == 'a') ADVANCE(302);
      END_STATE();
    case 269:
      if (lookahead == 'l') ADVANCE(303);
      END_STATE();
    case 270:
      if (lookahead == 'a') ADVANCE(304);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_parent);
      END_STATE();
    case 273:
      if (lookahead == 'e') ADVANCE(305);
      END_STATE();
    case 274:
      if (lookahead == 't') ADVANCE(306);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 276:
      if (lookahead == 'e') ADVANCE(307);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 279:
      if (lookahead == '_') ADVANCE(308);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(309);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 284:
      if (lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(311);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 288:
      if (lookahead == 'g') ADVANCE(312);
      END_STATE();
    case 289:
      if (lookahead == 'a') ADVANCE(313);
      END_STATE();
    case 290:
      if (lookahead == 'a') ADVANCE(314);
      END_STATE();
    case 291:
      if (lookahead == 'c') ADVANCE(315);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(316);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_foreach);
      END_STATE();
    case 296:
      if (lookahead == 'n') ADVANCE(317);
      END_STATE();
    case 297:
      if (lookahead == 'n') ADVANCE(318);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_include);
      if (lookahead == '_') ADVANCE(319);
      END_STATE();
    case 299:
      if (lookahead == 'e') ADVANCE(320);
      END_STATE();
    case 300:
      if (lookahead == 'o') ADVANCE(321);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_integer);
      END_STATE();
    case 302:
      if (lookahead == 'c') ADVANCE(322);
      END_STATE();
    case 303:
      if (lookahead == 'e') ADVANCE(323);
      END_STATE();
    case 304:
      if (lookahead == 'c') ADVANCE(324);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 306:
      if (lookahead == 'e') ADVANCE(325);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_require);
      if (lookahead == '_') ADVANCE(326);
      END_STATE();
    case 308:
      if (lookahead == 't') ADVANCE(327);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_callable);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_encoding);
      END_STATE();
    case 313:
      if (lookahead == 'r') ADVANCE(328);
      END_STATE();
    case 314:
      if (lookahead == 'c') ADVANCE(329);
      END_STATE();
    case 315:
      if (lookahead == 'h') ADVANCE(330);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_endwhile);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 318:
      if (lookahead == 't') ADVANCE(331);
      END_STATE();
    case 319:
      if (lookahead == 'o') ADVANCE(332);
      END_STATE();
    case 320:
      if (lookahead == 'o') ADVANCE(333);
      END_STATE();
    case 321:
      if (lookahead == 'f') ADVANCE(334);
      END_STATE();
    case 322:
      if (lookahead == 'e') ADVANCE(335);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_iterable);
      END_STATE();
    case 324:
      if (lookahead == 'e') ADVANCE(336);
      END_STATE();
    case 325:
      if (lookahead == 'd') ADVANCE(337);
      END_STATE();
    case 326:
      if (lookahead == 'o') ADVANCE(338);
      END_STATE();
    case 327:
      if (lookahead == 'y') ADVANCE(339);
      END_STATE();
    case 328:
      if (lookahead == 'e') ADVANCE(340);
      END_STATE();
    case 329:
      if (lookahead == 'h') ADVANCE(341);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_endswitch);
      END_STATE();
    case 331:
      if (lookahead == 's') ADVANCE(342);
      END_STATE();
    case 332:
      if (lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 333:
      if (lookahead == 'f') ADVANCE(344);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_insteadof);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 338:
      if (lookahead == 'n') ADVANCE(345);
      END_STATE();
    case 339:
      if (lookahead == 'p') ADVANCE(346);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_enddeclare);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_endforeach);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 343:
      if (lookahead == 'c') ADVANCE(347);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    case 345:
      if (lookahead == 'c') ADVANCE(348);
      END_STATE();
    case 346:
      if (lookahead == 'e') ADVANCE(349);
      END_STATE();
    case 347:
      if (lookahead == 'e') ADVANCE(350);
      END_STATE();
    case 348:
      if (lookahead == 'e') ADVANCE(351);
      END_STATE();
    case 349:
      if (lookahead == 's') ADVANCE(352);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_include_once);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_require_once);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_strict_types);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 79},
  [2] = {.lex_state = 78, .external_lex_state = 2},
  [3] = {.lex_state = 78, .external_lex_state = 2},
  [4] = {.lex_state = 78, .external_lex_state = 2},
  [5] = {.lex_state = 78, .external_lex_state = 2},
  [6] = {.lex_state = 78, .external_lex_state = 2},
  [7] = {.lex_state = 78, .external_lex_state = 2},
  [8] = {.lex_state = 78, .external_lex_state = 2},
  [9] = {.lex_state = 78, .external_lex_state = 3},
  [10] = {.lex_state = 78, .external_lex_state = 3},
  [11] = {.lex_state = 78, .external_lex_state = 3},
  [12] = {.lex_state = 78, .external_lex_state = 3},
  [13] = {.lex_state = 78, .external_lex_state = 2},
  [14] = {.lex_state = 78, .external_lex_state = 2},
  [15] = {.lex_state = 78, .external_lex_state = 2},
  [16] = {.lex_state = 78, .external_lex_state = 2},
  [17] = {.lex_state = 78, .external_lex_state = 3},
  [18] = {.lex_state = 78, .external_lex_state = 3},
  [19] = {.lex_state = 78, .external_lex_state = 3},
  [20] = {.lex_state = 78, .external_lex_state = 3},
  [21] = {.lex_state = 78, .external_lex_state = 2},
  [22] = {.lex_state = 78, .external_lex_state = 2},
  [23] = {.lex_state = 78, .external_lex_state = 2},
  [24] = {.lex_state = 78, .external_lex_state = 2},
  [25] = {.lex_state = 78, .external_lex_state = 3},
  [26] = {.lex_state = 78, .external_lex_state = 2},
  [27] = {.lex_state = 78, .external_lex_state = 3},
  [28] = {.lex_state = 78, .external_lex_state = 2},
  [29] = {.lex_state = 78, .external_lex_state = 3},
  [30] = {.lex_state = 78, .external_lex_state = 2},
  [31] = {.lex_state = 78, .external_lex_state = 2},
  [32] = {.lex_state = 78, .external_lex_state = 2},
  [33] = {.lex_state = 78, .external_lex_state = 2},
  [34] = {.lex_state = 78, .external_lex_state = 3},
  [35] = {.lex_state = 78, .external_lex_state = 2},
  [36] = {.lex_state = 78, .external_lex_state = 2},
  [37] = {.lex_state = 78, .external_lex_state = 2},
  [38] = {.lex_state = 78, .external_lex_state = 2},
  [39] = {.lex_state = 78, .external_lex_state = 3},
  [40] = {.lex_state = 78, .external_lex_state = 2},
  [41] = {.lex_state = 78, .external_lex_state = 2},
  [42] = {.lex_state = 78, .external_lex_state = 2},
  [43] = {.lex_state = 78, .external_lex_state = 2},
  [44] = {.lex_state = 78, .external_lex_state = 2},
  [45] = {.lex_state = 78, .external_lex_state = 2},
  [46] = {.lex_state = 78, .external_lex_state = 2},
  [47] = {.lex_state = 78, .external_lex_state = 2},
  [48] = {.lex_state = 78, .external_lex_state = 2},
  [49] = {.lex_state = 78, .external_lex_state = 2},
  [50] = {.lex_state = 78, .external_lex_state = 2},
  [51] = {.lex_state = 78, .external_lex_state = 2},
  [52] = {.lex_state = 78, .external_lex_state = 2},
  [53] = {.lex_state = 78, .external_lex_state = 3},
  [54] = {.lex_state = 78, .external_lex_state = 2},
  [55] = {.lex_state = 78, .external_lex_state = 2},
  [56] = {.lex_state = 78, .external_lex_state = 2},
  [57] = {.lex_state = 78, .external_lex_state = 2},
  [58] = {.lex_state = 78, .external_lex_state = 2},
  [59] = {.lex_state = 78, .external_lex_state = 2},
  [60] = {.lex_state = 78, .external_lex_state = 2},
  [61] = {.lex_state = 78, .external_lex_state = 2},
  [62] = {.lex_state = 78, .external_lex_state = 2},
  [63] = {.lex_state = 3, .external_lex_state = 2},
  [64] = {.lex_state = 3, .external_lex_state = 3},
  [65] = {.lex_state = 78, .external_lex_state = 2},
  [66] = {.lex_state = 78, .external_lex_state = 2},
  [67] = {.lex_state = 78, .external_lex_state = 2},
  [68] = {.lex_state = 78, .external_lex_state = 2},
  [69] = {.lex_state = 78, .external_lex_state = 2},
  [70] = {.lex_state = 78, .external_lex_state = 2},
  [71] = {.lex_state = 78, .external_lex_state = 2},
  [72] = {.lex_state = 78, .external_lex_state = 2},
  [73] = {.lex_state = 78, .external_lex_state = 2},
  [74] = {.lex_state = 78, .external_lex_state = 2},
  [75] = {.lex_state = 78, .external_lex_state = 2},
  [76] = {.lex_state = 78, .external_lex_state = 2},
  [77] = {.lex_state = 78, .external_lex_state = 2},
  [78] = {.lex_state = 78, .external_lex_state = 2},
  [79] = {.lex_state = 78, .external_lex_state = 2},
  [80] = {.lex_state = 78, .external_lex_state = 2},
  [81] = {.lex_state = 4, .external_lex_state = 2},
  [82] = {.lex_state = 78, .external_lex_state = 2},
  [83] = {.lex_state = 78, .external_lex_state = 2},
  [84] = {.lex_state = 4, .external_lex_state = 2},
  [85] = {.lex_state = 78, .external_lex_state = 2},
  [86] = {.lex_state = 78, .external_lex_state = 2},
  [87] = {.lex_state = 78, .external_lex_state = 2},
  [88] = {.lex_state = 78, .external_lex_state = 2},
  [89] = {.lex_state = 78, .external_lex_state = 2},
  [90] = {.lex_state = 78, .external_lex_state = 2},
  [91] = {.lex_state = 78, .external_lex_state = 2},
  [92] = {.lex_state = 78, .external_lex_state = 2},
  [93] = {.lex_state = 78, .external_lex_state = 2},
  [94] = {.lex_state = 78, .external_lex_state = 2},
  [95] = {.lex_state = 78, .external_lex_state = 2},
  [96] = {.lex_state = 78, .external_lex_state = 2},
  [97] = {.lex_state = 4, .external_lex_state = 2},
  [98] = {.lex_state = 78, .external_lex_state = 2},
  [99] = {.lex_state = 4, .external_lex_state = 2},
  [100] = {.lex_state = 78, .external_lex_state = 2},
  [101] = {.lex_state = 78, .external_lex_state = 2},
  [102] = {.lex_state = 78, .external_lex_state = 2},
  [103] = {.lex_state = 78, .external_lex_state = 2},
  [104] = {.lex_state = 78, .external_lex_state = 2},
  [105] = {.lex_state = 78, .external_lex_state = 3},
  [106] = {.lex_state = 78, .external_lex_state = 2},
  [107] = {.lex_state = 78, .external_lex_state = 2},
  [108] = {.lex_state = 78, .external_lex_state = 2},
  [109] = {.lex_state = 78, .external_lex_state = 2},
  [110] = {.lex_state = 78, .external_lex_state = 3},
  [111] = {.lex_state = 78, .external_lex_state = 3},
  [112] = {.lex_state = 78, .external_lex_state = 2},
  [113] = {.lex_state = 78, .external_lex_state = 2},
  [114] = {.lex_state = 78, .external_lex_state = 2},
  [115] = {.lex_state = 78, .external_lex_state = 2},
  [116] = {.lex_state = 78, .external_lex_state = 3},
  [117] = {.lex_state = 4, .external_lex_state = 2},
  [118] = {.lex_state = 78, .external_lex_state = 3},
  [119] = {.lex_state = 78, .external_lex_state = 3},
  [120] = {.lex_state = 78, .external_lex_state = 2},
  [121] = {.lex_state = 78, .external_lex_state = 2},
  [122] = {.lex_state = 78, .external_lex_state = 2},
  [123] = {.lex_state = 78, .external_lex_state = 2},
  [124] = {.lex_state = 78, .external_lex_state = 2},
  [125] = {.lex_state = 78, .external_lex_state = 2},
  [126] = {.lex_state = 78, .external_lex_state = 2},
  [127] = {.lex_state = 78, .external_lex_state = 2},
  [128] = {.lex_state = 78, .external_lex_state = 2},
  [129] = {.lex_state = 78, .external_lex_state = 2},
  [130] = {.lex_state = 78, .external_lex_state = 2},
  [131] = {.lex_state = 78, .external_lex_state = 2},
  [132] = {.lex_state = 78, .external_lex_state = 2},
  [133] = {.lex_state = 78, .external_lex_state = 2},
  [134] = {.lex_state = 78, .external_lex_state = 2},
  [135] = {.lex_state = 78, .external_lex_state = 2},
  [136] = {.lex_state = 78, .external_lex_state = 2},
  [137] = {.lex_state = 78, .external_lex_state = 2},
  [138] = {.lex_state = 78, .external_lex_state = 2},
  [139] = {.lex_state = 78, .external_lex_state = 2},
  [140] = {.lex_state = 78, .external_lex_state = 2},
  [141] = {.lex_state = 78, .external_lex_state = 2},
  [142] = {.lex_state = 78, .external_lex_state = 3},
  [143] = {.lex_state = 78, .external_lex_state = 2},
  [144] = {.lex_state = 78, .external_lex_state = 2},
  [145] = {.lex_state = 78, .external_lex_state = 2},
  [146] = {.lex_state = 78, .external_lex_state = 2},
  [147] = {.lex_state = 78, .external_lex_state = 2},
  [148] = {.lex_state = 78, .external_lex_state = 2},
  [149] = {.lex_state = 78, .external_lex_state = 2},
  [150] = {.lex_state = 78, .external_lex_state = 2},
  [151] = {.lex_state = 78, .external_lex_state = 2},
  [152] = {.lex_state = 78, .external_lex_state = 2},
  [153] = {.lex_state = 78, .external_lex_state = 2},
  [154] = {.lex_state = 78, .external_lex_state = 2},
  [155] = {.lex_state = 78, .external_lex_state = 3},
  [156] = {.lex_state = 78, .external_lex_state = 2},
  [157] = {.lex_state = 78, .external_lex_state = 2},
  [158] = {.lex_state = 78, .external_lex_state = 2},
  [159] = {.lex_state = 78, .external_lex_state = 2},
  [160] = {.lex_state = 78, .external_lex_state = 3},
  [161] = {.lex_state = 78, .external_lex_state = 2},
  [162] = {.lex_state = 78, .external_lex_state = 2},
  [163] = {.lex_state = 78, .external_lex_state = 2},
  [164] = {.lex_state = 78, .external_lex_state = 2},
  [165] = {.lex_state = 78, .external_lex_state = 2},
  [166] = {.lex_state = 78, .external_lex_state = 2},
  [167] = {.lex_state = 78, .external_lex_state = 2},
  [168] = {.lex_state = 78, .external_lex_state = 2},
  [169] = {.lex_state = 78, .external_lex_state = 2},
  [170] = {.lex_state = 78, .external_lex_state = 2},
  [171] = {.lex_state = 78, .external_lex_state = 2},
  [172] = {.lex_state = 78, .external_lex_state = 2},
  [173] = {.lex_state = 78, .external_lex_state = 3},
  [174] = {.lex_state = 78, .external_lex_state = 2},
  [175] = {.lex_state = 78, .external_lex_state = 2},
  [176] = {.lex_state = 78, .external_lex_state = 2},
  [177] = {.lex_state = 78, .external_lex_state = 2},
  [178] = {.lex_state = 78, .external_lex_state = 3},
  [179] = {.lex_state = 78, .external_lex_state = 2},
  [180] = {.lex_state = 78, .external_lex_state = 2},
  [181] = {.lex_state = 78, .external_lex_state = 2},
  [182] = {.lex_state = 78, .external_lex_state = 2},
  [183] = {.lex_state = 78, .external_lex_state = 2},
  [184] = {.lex_state = 78, .external_lex_state = 2},
  [185] = {.lex_state = 78, .external_lex_state = 2},
  [186] = {.lex_state = 78, .external_lex_state = 2},
  [187] = {.lex_state = 78, .external_lex_state = 2},
  [188] = {.lex_state = 78, .external_lex_state = 2},
  [189] = {.lex_state = 78, .external_lex_state = 2},
  [190] = {.lex_state = 78, .external_lex_state = 2},
  [191] = {.lex_state = 78, .external_lex_state = 2},
  [192] = {.lex_state = 78, .external_lex_state = 2},
  [193] = {.lex_state = 78, .external_lex_state = 2},
  [194] = {.lex_state = 78, .external_lex_state = 2},
  [195] = {.lex_state = 78, .external_lex_state = 2},
  [196] = {.lex_state = 78, .external_lex_state = 2},
  [197] = {.lex_state = 78, .external_lex_state = 2},
  [198] = {.lex_state = 78, .external_lex_state = 2},
  [199] = {.lex_state = 78, .external_lex_state = 2},
  [200] = {.lex_state = 78, .external_lex_state = 2},
  [201] = {.lex_state = 78, .external_lex_state = 2},
  [202] = {.lex_state = 78, .external_lex_state = 2},
  [203] = {.lex_state = 78, .external_lex_state = 2},
  [204] = {.lex_state = 78, .external_lex_state = 2},
  [205] = {.lex_state = 78, .external_lex_state = 2},
  [206] = {.lex_state = 78, .external_lex_state = 2},
  [207] = {.lex_state = 78, .external_lex_state = 2},
  [208] = {.lex_state = 78, .external_lex_state = 3},
  [209] = {.lex_state = 78, .external_lex_state = 2},
  [210] = {.lex_state = 78, .external_lex_state = 2},
  [211] = {.lex_state = 78, .external_lex_state = 2},
  [212] = {.lex_state = 78, .external_lex_state = 3},
  [213] = {.lex_state = 78, .external_lex_state = 2},
  [214] = {.lex_state = 78, .external_lex_state = 2},
  [215] = {.lex_state = 78, .external_lex_state = 2},
  [216] = {.lex_state = 78, .external_lex_state = 2},
  [217] = {.lex_state = 78, .external_lex_state = 2},
  [218] = {.lex_state = 78, .external_lex_state = 2},
  [219] = {.lex_state = 78, .external_lex_state = 2},
  [220] = {.lex_state = 78, .external_lex_state = 2},
  [221] = {.lex_state = 78, .external_lex_state = 2},
  [222] = {.lex_state = 78, .external_lex_state = 3},
  [223] = {.lex_state = 78, .external_lex_state = 2},
  [224] = {.lex_state = 78, .external_lex_state = 2},
  [225] = {.lex_state = 78, .external_lex_state = 2},
  [226] = {.lex_state = 78, .external_lex_state = 2},
  [227] = {.lex_state = 78, .external_lex_state = 2},
  [228] = {.lex_state = 78, .external_lex_state = 2},
  [229] = {.lex_state = 78, .external_lex_state = 2},
  [230] = {.lex_state = 78, .external_lex_state = 2},
  [231] = {.lex_state = 78, .external_lex_state = 2},
  [232] = {.lex_state = 78, .external_lex_state = 2},
  [233] = {.lex_state = 78, .external_lex_state = 2},
  [234] = {.lex_state = 78, .external_lex_state = 2},
  [235] = {.lex_state = 78, .external_lex_state = 2},
  [236] = {.lex_state = 78, .external_lex_state = 2},
  [237] = {.lex_state = 78, .external_lex_state = 2},
  [238] = {.lex_state = 78, .external_lex_state = 2},
  [239] = {.lex_state = 78, .external_lex_state = 2},
  [240] = {.lex_state = 78, .external_lex_state = 2},
  [241] = {.lex_state = 78, .external_lex_state = 2},
  [242] = {.lex_state = 78, .external_lex_state = 2},
  [243] = {.lex_state = 78, .external_lex_state = 2},
  [244] = {.lex_state = 78, .external_lex_state = 2},
  [245] = {.lex_state = 78, .external_lex_state = 2},
  [246] = {.lex_state = 78, .external_lex_state = 2},
  [247] = {.lex_state = 78, .external_lex_state = 2},
  [248] = {.lex_state = 78, .external_lex_state = 2},
  [249] = {.lex_state = 78, .external_lex_state = 2},
  [250] = {.lex_state = 78, .external_lex_state = 2},
  [251] = {.lex_state = 78, .external_lex_state = 2},
  [252] = {.lex_state = 78, .external_lex_state = 2},
  [253] = {.lex_state = 78, .external_lex_state = 2},
  [254] = {.lex_state = 78, .external_lex_state = 2},
  [255] = {.lex_state = 78, .external_lex_state = 2},
  [256] = {.lex_state = 78, .external_lex_state = 2},
  [257] = {.lex_state = 78, .external_lex_state = 2},
  [258] = {.lex_state = 78, .external_lex_state = 2},
  [259] = {.lex_state = 78, .external_lex_state = 2},
  [260] = {.lex_state = 78, .external_lex_state = 2},
  [261] = {.lex_state = 78, .external_lex_state = 2},
  [262] = {.lex_state = 78, .external_lex_state = 2},
  [263] = {.lex_state = 78, .external_lex_state = 2},
  [264] = {.lex_state = 78, .external_lex_state = 2},
  [265] = {.lex_state = 78, .external_lex_state = 2},
  [266] = {.lex_state = 78, .external_lex_state = 2},
  [267] = {.lex_state = 78, .external_lex_state = 2},
  [268] = {.lex_state = 78, .external_lex_state = 2},
  [269] = {.lex_state = 78, .external_lex_state = 2},
  [270] = {.lex_state = 78, .external_lex_state = 2},
  [271] = {.lex_state = 78, .external_lex_state = 2},
  [272] = {.lex_state = 78, .external_lex_state = 2},
  [273] = {.lex_state = 78, .external_lex_state = 2},
  [274] = {.lex_state = 78, .external_lex_state = 2},
  [275] = {.lex_state = 78, .external_lex_state = 2},
  [276] = {.lex_state = 78, .external_lex_state = 2},
  [277] = {.lex_state = 78, .external_lex_state = 2},
  [278] = {.lex_state = 78, .external_lex_state = 2},
  [279] = {.lex_state = 78, .external_lex_state = 2},
  [280] = {.lex_state = 78, .external_lex_state = 2},
  [281] = {.lex_state = 78, .external_lex_state = 2},
  [282] = {.lex_state = 78, .external_lex_state = 2},
  [283] = {.lex_state = 78, .external_lex_state = 2},
  [284] = {.lex_state = 78, .external_lex_state = 2},
  [285] = {.lex_state = 78, .external_lex_state = 2},
  [286] = {.lex_state = 78, .external_lex_state = 2},
  [287] = {.lex_state = 78, .external_lex_state = 2},
  [288] = {.lex_state = 78, .external_lex_state = 2},
  [289] = {.lex_state = 78, .external_lex_state = 2},
  [290] = {.lex_state = 78, .external_lex_state = 2},
  [291] = {.lex_state = 78, .external_lex_state = 2},
  [292] = {.lex_state = 78, .external_lex_state = 2},
  [293] = {.lex_state = 78, .external_lex_state = 2},
  [294] = {.lex_state = 78, .external_lex_state = 2},
  [295] = {.lex_state = 78, .external_lex_state = 2},
  [296] = {.lex_state = 78, .external_lex_state = 2},
  [297] = {.lex_state = 78, .external_lex_state = 2},
  [298] = {.lex_state = 78, .external_lex_state = 2},
  [299] = {.lex_state = 78, .external_lex_state = 2},
  [300] = {.lex_state = 78, .external_lex_state = 2},
  [301] = {.lex_state = 78, .external_lex_state = 2},
  [302] = {.lex_state = 78, .external_lex_state = 2},
  [303] = {.lex_state = 78, .external_lex_state = 2},
  [304] = {.lex_state = 78, .external_lex_state = 2},
  [305] = {.lex_state = 78, .external_lex_state = 2},
  [306] = {.lex_state = 78, .external_lex_state = 2},
  [307] = {.lex_state = 78, .external_lex_state = 2},
  [308] = {.lex_state = 78, .external_lex_state = 2},
  [309] = {.lex_state = 78, .external_lex_state = 2},
  [310] = {.lex_state = 78, .external_lex_state = 2},
  [311] = {.lex_state = 78, .external_lex_state = 2},
  [312] = {.lex_state = 78, .external_lex_state = 2},
  [313] = {.lex_state = 78, .external_lex_state = 2},
  [314] = {.lex_state = 78, .external_lex_state = 2},
  [315] = {.lex_state = 78, .external_lex_state = 2},
  [316] = {.lex_state = 78, .external_lex_state = 2},
  [317] = {.lex_state = 78, .external_lex_state = 2},
  [318] = {.lex_state = 78, .external_lex_state = 2},
  [319] = {.lex_state = 78, .external_lex_state = 2},
  [320] = {.lex_state = 78, .external_lex_state = 2},
  [321] = {.lex_state = 78, .external_lex_state = 2},
  [322] = {.lex_state = 78, .external_lex_state = 2},
  [323] = {.lex_state = 78, .external_lex_state = 2},
  [324] = {.lex_state = 78, .external_lex_state = 2},
  [325] = {.lex_state = 5},
  [326] = {.lex_state = 5},
  [327] = {.lex_state = 5},
  [328] = {.lex_state = 5},
  [329] = {.lex_state = 5},
  [330] = {.lex_state = 5},
  [331] = {.lex_state = 5},
  [332] = {.lex_state = 5},
  [333] = {.lex_state = 78, .external_lex_state = 2},
  [334] = {.lex_state = 78, .external_lex_state = 2},
  [335] = {.lex_state = 5},
  [336] = {.lex_state = 5},
  [337] = {.lex_state = 5},
  [338] = {.lex_state = 5},
  [339] = {.lex_state = 5},
  [340] = {.lex_state = 5},
  [341] = {.lex_state = 78, .external_lex_state = 2},
  [342] = {.lex_state = 5},
  [343] = {.lex_state = 5},
  [344] = {.lex_state = 5},
  [345] = {.lex_state = 5},
  [346] = {.lex_state = 5},
  [347] = {.lex_state = 5},
  [348] = {.lex_state = 5},
  [349] = {.lex_state = 5, .external_lex_state = 4},
  [350] = {.lex_state = 5, .external_lex_state = 4},
  [351] = {.lex_state = 5},
  [352] = {.lex_state = 5, .external_lex_state = 4},
  [353] = {.lex_state = 5, .external_lex_state = 4},
  [354] = {.lex_state = 5, .external_lex_state = 4},
  [355] = {.lex_state = 5, .external_lex_state = 4},
  [356] = {.lex_state = 5, .external_lex_state = 4},
  [357] = {.lex_state = 5, .external_lex_state = 4},
  [358] = {.lex_state = 5},
  [359] = {.lex_state = 5, .external_lex_state = 4},
  [360] = {.lex_state = 5, .external_lex_state = 4},
  [361] = {.lex_state = 5, .external_lex_state = 4},
  [362] = {.lex_state = 5, .external_lex_state = 4},
  [363] = {.lex_state = 5, .external_lex_state = 4},
  [364] = {.lex_state = 5},
  [365] = {.lex_state = 5, .external_lex_state = 4},
  [366] = {.lex_state = 5, .external_lex_state = 4},
  [367] = {.lex_state = 5, .external_lex_state = 4},
  [368] = {.lex_state = 5, .external_lex_state = 4},
  [369] = {.lex_state = 5, .external_lex_state = 4},
  [370] = {.lex_state = 5, .external_lex_state = 4},
  [371] = {.lex_state = 5},
  [372] = {.lex_state = 6},
  [373] = {.lex_state = 6},
  [374] = {.lex_state = 5, .external_lex_state = 4},
  [375] = {.lex_state = 5, .external_lex_state = 4},
  [376] = {.lex_state = 5},
  [377] = {.lex_state = 5},
  [378] = {.lex_state = 78, .external_lex_state = 2},
  [379] = {.lex_state = 78, .external_lex_state = 2},
  [380] = {.lex_state = 78, .external_lex_state = 2},
  [381] = {.lex_state = 78, .external_lex_state = 2},
  [382] = {.lex_state = 5},
  [383] = {.lex_state = 5},
  [384] = {.lex_state = 6},
  [385] = {.lex_state = 6},
  [386] = {.lex_state = 6},
  [387] = {.lex_state = 6},
  [388] = {.lex_state = 6},
  [389] = {.lex_state = 6},
  [390] = {.lex_state = 5},
  [391] = {.lex_state = 5},
  [392] = {.lex_state = 6},
  [393] = {.lex_state = 6},
  [394] = {.lex_state = 6},
  [395] = {.lex_state = 6},
  [396] = {.lex_state = 6},
  [397] = {.lex_state = 6},
  [398] = {.lex_state = 6},
  [399] = {.lex_state = 6},
  [400] = {.lex_state = 6},
  [401] = {.lex_state = 6},
  [402] = {.lex_state = 6},
  [403] = {.lex_state = 6},
  [404] = {.lex_state = 6},
  [405] = {.lex_state = 6},
  [406] = {.lex_state = 6},
  [407] = {.lex_state = 6},
  [408] = {.lex_state = 6},
  [409] = {.lex_state = 6},
  [410] = {.lex_state = 6},
  [411] = {.lex_state = 6},
  [412] = {.lex_state = 6},
  [413] = {.lex_state = 6},
  [414] = {.lex_state = 6},
  [415] = {.lex_state = 6},
  [416] = {.lex_state = 6},
  [417] = {.lex_state = 6},
  [418] = {.lex_state = 6},
  [419] = {.lex_state = 6},
  [420] = {.lex_state = 6},
  [421] = {.lex_state = 6},
  [422] = {.lex_state = 6},
  [423] = {.lex_state = 6},
  [424] = {.lex_state = 6},
  [425] = {.lex_state = 6},
  [426] = {.lex_state = 6},
  [427] = {.lex_state = 6},
  [428] = {.lex_state = 6},
  [429] = {.lex_state = 6},
  [430] = {.lex_state = 5, .external_lex_state = 4},
  [431] = {.lex_state = 6},
  [432] = {.lex_state = 5, .external_lex_state = 4},
  [433] = {.lex_state = 6},
  [434] = {.lex_state = 6},
  [435] = {.lex_state = 6},
  [436] = {.lex_state = 6},
  [437] = {.lex_state = 6, .external_lex_state = 4},
  [438] = {.lex_state = 6},
  [439] = {.lex_state = 6},
  [440] = {.lex_state = 6},
  [441] = {.lex_state = 6, .external_lex_state = 4},
  [442] = {.lex_state = 6, .external_lex_state = 4},
  [443] = {.lex_state = 6, .external_lex_state = 4},
  [444] = {.lex_state = 5, .external_lex_state = 4},
  [445] = {.lex_state = 6, .external_lex_state = 4},
  [446] = {.lex_state = 6, .external_lex_state = 4},
  [447] = {.lex_state = 6, .external_lex_state = 4},
  [448] = {.lex_state = 6},
  [449] = {.lex_state = 6, .external_lex_state = 4},
  [450] = {.lex_state = 6, .external_lex_state = 4},
  [451] = {.lex_state = 6, .external_lex_state = 4},
  [452] = {.lex_state = 6, .external_lex_state = 4},
  [453] = {.lex_state = 6, .external_lex_state = 4},
  [454] = {.lex_state = 6, .external_lex_state = 4},
  [455] = {.lex_state = 6, .external_lex_state = 4},
  [456] = {.lex_state = 6, .external_lex_state = 4},
  [457] = {.lex_state = 6, .external_lex_state = 4},
  [458] = {.lex_state = 6, .external_lex_state = 4},
  [459] = {.lex_state = 6, .external_lex_state = 4},
  [460] = {.lex_state = 6, .external_lex_state = 4},
  [461] = {.lex_state = 6, .external_lex_state = 4},
  [462] = {.lex_state = 6, .external_lex_state = 4},
  [463] = {.lex_state = 6, .external_lex_state = 4},
  [464] = {.lex_state = 5, .external_lex_state = 4},
  [465] = {.lex_state = 6, .external_lex_state = 4},
  [466] = {.lex_state = 6, .external_lex_state = 4},
  [467] = {.lex_state = 6, .external_lex_state = 4},
  [468] = {.lex_state = 6, .external_lex_state = 4},
  [469] = {.lex_state = 6, .external_lex_state = 4},
  [470] = {.lex_state = 6, .external_lex_state = 4},
  [471] = {.lex_state = 6, .external_lex_state = 4},
  [472] = {.lex_state = 6, .external_lex_state = 4},
  [473] = {.lex_state = 6, .external_lex_state = 4},
  [474] = {.lex_state = 6, .external_lex_state = 4},
  [475] = {.lex_state = 6, .external_lex_state = 4},
  [476] = {.lex_state = 6, .external_lex_state = 4},
  [477] = {.lex_state = 6, .external_lex_state = 4},
  [478] = {.lex_state = 6, .external_lex_state = 4},
  [479] = {.lex_state = 6, .external_lex_state = 4},
  [480] = {.lex_state = 6, .external_lex_state = 4},
  [481] = {.lex_state = 6, .external_lex_state = 4},
  [482] = {.lex_state = 6, .external_lex_state = 4},
  [483] = {.lex_state = 6},
  [484] = {.lex_state = 6},
  [485] = {.lex_state = 6},
  [486] = {.lex_state = 6},
  [487] = {.lex_state = 6, .external_lex_state = 4},
  [488] = {.lex_state = 6},
  [489] = {.lex_state = 6},
  [490] = {.lex_state = 6},
  [491] = {.lex_state = 6},
  [492] = {.lex_state = 6},
  [493] = {.lex_state = 6},
  [494] = {.lex_state = 6},
  [495] = {.lex_state = 6},
  [496] = {.lex_state = 6},
  [497] = {.lex_state = 6},
  [498] = {.lex_state = 6, .external_lex_state = 4},
  [499] = {.lex_state = 6},
  [500] = {.lex_state = 6},
  [501] = {.lex_state = 6},
  [502] = {.lex_state = 6},
  [503] = {.lex_state = 6},
  [504] = {.lex_state = 6, .external_lex_state = 4},
  [505] = {.lex_state = 6},
  [506] = {.lex_state = 6},
  [507] = {.lex_state = 6},
  [508] = {.lex_state = 6, .external_lex_state = 4},
  [509] = {.lex_state = 6},
  [510] = {.lex_state = 6},
  [511] = {.lex_state = 6},
  [512] = {.lex_state = 6},
  [513] = {.lex_state = 6},
  [514] = {.lex_state = 6},
  [515] = {.lex_state = 6},
  [516] = {.lex_state = 6, .external_lex_state = 4},
  [517] = {.lex_state = 6},
  [518] = {.lex_state = 6},
  [519] = {.lex_state = 6},
  [520] = {.lex_state = 6},
  [521] = {.lex_state = 6},
  [522] = {.lex_state = 6, .external_lex_state = 4},
  [523] = {.lex_state = 6},
  [524] = {.lex_state = 6},
  [525] = {.lex_state = 6},
  [526] = {.lex_state = 6},
  [527] = {.lex_state = 6},
  [528] = {.lex_state = 6},
  [529] = {.lex_state = 6},
  [530] = {.lex_state = 6, .external_lex_state = 4},
  [531] = {.lex_state = 6},
  [532] = {.lex_state = 6},
  [533] = {.lex_state = 6},
  [534] = {.lex_state = 6},
  [535] = {.lex_state = 6},
  [536] = {.lex_state = 6},
  [537] = {.lex_state = 6},
  [538] = {.lex_state = 6},
  [539] = {.lex_state = 6},
  [540] = {.lex_state = 6},
  [541] = {.lex_state = 6, .external_lex_state = 4},
  [542] = {.lex_state = 6},
  [543] = {.lex_state = 6},
  [544] = {.lex_state = 6},
  [545] = {.lex_state = 6},
  [546] = {.lex_state = 6, .external_lex_state = 4},
  [547] = {.lex_state = 6, .external_lex_state = 4},
  [548] = {.lex_state = 6, .external_lex_state = 4},
  [549] = {.lex_state = 6, .external_lex_state = 4},
  [550] = {.lex_state = 6, .external_lex_state = 4},
  [551] = {.lex_state = 6, .external_lex_state = 4},
  [552] = {.lex_state = 6, .external_lex_state = 4},
  [553] = {.lex_state = 6, .external_lex_state = 4},
  [554] = {.lex_state = 6, .external_lex_state = 4},
  [555] = {.lex_state = 5, .external_lex_state = 2},
  [556] = {.lex_state = 5, .external_lex_state = 2},
  [557] = {.lex_state = 5, .external_lex_state = 2},
  [558] = {.lex_state = 6, .external_lex_state = 4},
  [559] = {.lex_state = 6, .external_lex_state = 4},
  [560] = {.lex_state = 6, .external_lex_state = 4},
  [561] = {.lex_state = 6, .external_lex_state = 4},
  [562] = {.lex_state = 6, .external_lex_state = 4},
  [563] = {.lex_state = 6, .external_lex_state = 4},
  [564] = {.lex_state = 6, .external_lex_state = 4},
  [565] = {.lex_state = 6, .external_lex_state = 4},
  [566] = {.lex_state = 6, .external_lex_state = 4},
  [567] = {.lex_state = 6, .external_lex_state = 4},
  [568] = {.lex_state = 6, .external_lex_state = 4},
  [569] = {.lex_state = 6, .external_lex_state = 4},
  [570] = {.lex_state = 6, .external_lex_state = 4},
  [571] = {.lex_state = 6, .external_lex_state = 4},
  [572] = {.lex_state = 6, .external_lex_state = 4},
  [573] = {.lex_state = 6, .external_lex_state = 4},
  [574] = {.lex_state = 6, .external_lex_state = 4},
  [575] = {.lex_state = 6, .external_lex_state = 4},
  [576] = {.lex_state = 6, .external_lex_state = 4},
  [577] = {.lex_state = 6, .external_lex_state = 4},
  [578] = {.lex_state = 6, .external_lex_state = 4},
  [579] = {.lex_state = 5, .external_lex_state = 2},
  [580] = {.lex_state = 6, .external_lex_state = 4},
  [581] = {.lex_state = 6, .external_lex_state = 4},
  [582] = {.lex_state = 6, .external_lex_state = 4},
  [583] = {.lex_state = 6, .external_lex_state = 4},
  [584] = {.lex_state = 6, .external_lex_state = 4},
  [585] = {.lex_state = 6, .external_lex_state = 4},
  [586] = {.lex_state = 6, .external_lex_state = 4},
  [587] = {.lex_state = 6, .external_lex_state = 4},
  [588] = {.lex_state = 6, .external_lex_state = 4},
  [589] = {.lex_state = 6, .external_lex_state = 4},
  [590] = {.lex_state = 6, .external_lex_state = 4},
  [591] = {.lex_state = 6, .external_lex_state = 4},
  [592] = {.lex_state = 6, .external_lex_state = 4},
  [593] = {.lex_state = 6, .external_lex_state = 4},
  [594] = {.lex_state = 6, .external_lex_state = 4},
  [595] = {.lex_state = 6, .external_lex_state = 4},
  [596] = {.lex_state = 6, .external_lex_state = 4},
  [597] = {.lex_state = 6, .external_lex_state = 4},
  [598] = {.lex_state = 6, .external_lex_state = 4},
  [599] = {.lex_state = 6, .external_lex_state = 4},
  [600] = {.lex_state = 6, .external_lex_state = 4},
  [601] = {.lex_state = 6, .external_lex_state = 4},
  [602] = {.lex_state = 6, .external_lex_state = 4},
  [603] = {.lex_state = 6, .external_lex_state = 4},
  [604] = {.lex_state = 6, .external_lex_state = 4},
  [605] = {.lex_state = 6, .external_lex_state = 4},
  [606] = {.lex_state = 6, .external_lex_state = 4},
  [607] = {.lex_state = 6, .external_lex_state = 4},
  [608] = {.lex_state = 6, .external_lex_state = 4},
  [609] = {.lex_state = 6, .external_lex_state = 4},
  [610] = {.lex_state = 5, .external_lex_state = 2},
  [611] = {.lex_state = 6, .external_lex_state = 4},
  [612] = {.lex_state = 6, .external_lex_state = 4},
  [613] = {.lex_state = 6, .external_lex_state = 4},
  [614] = {.lex_state = 6, .external_lex_state = 4},
  [615] = {.lex_state = 6, .external_lex_state = 4},
  [616] = {.lex_state = 6, .external_lex_state = 4},
  [617] = {.lex_state = 5, .external_lex_state = 2},
  [618] = {.lex_state = 5, .external_lex_state = 2},
  [619] = {.lex_state = 5, .external_lex_state = 2},
  [620] = {.lex_state = 5, .external_lex_state = 2},
  [621] = {.lex_state = 5, .external_lex_state = 2},
  [622] = {.lex_state = 5, .external_lex_state = 2},
  [623] = {.lex_state = 5, .external_lex_state = 2},
  [624] = {.lex_state = 5, .external_lex_state = 2},
  [625] = {.lex_state = 5, .external_lex_state = 2},
  [626] = {.lex_state = 5, .external_lex_state = 2},
  [627] = {.lex_state = 5, .external_lex_state = 2},
  [628] = {.lex_state = 5, .external_lex_state = 2},
  [629] = {.lex_state = 5, .external_lex_state = 2},
  [630] = {.lex_state = 5, .external_lex_state = 2},
  [631] = {.lex_state = 6},
  [632] = {.lex_state = 6},
  [633] = {.lex_state = 6, .external_lex_state = 4},
  [634] = {.lex_state = 6},
  [635] = {.lex_state = 6},
  [636] = {.lex_state = 6, .external_lex_state = 4},
  [637] = {.lex_state = 6, .external_lex_state = 4},
  [638] = {.lex_state = 6},
  [639] = {.lex_state = 6, .external_lex_state = 4},
  [640] = {.lex_state = 6, .external_lex_state = 4},
  [641] = {.lex_state = 6},
  [642] = {.lex_state = 6},
  [643] = {.lex_state = 6},
  [644] = {.lex_state = 6, .external_lex_state = 4},
  [645] = {.lex_state = 6, .external_lex_state = 4},
  [646] = {.lex_state = 6, .external_lex_state = 4},
  [647] = {.lex_state = 6, .external_lex_state = 4},
  [648] = {.lex_state = 6, .external_lex_state = 4},
  [649] = {.lex_state = 6, .external_lex_state = 4},
  [650] = {.lex_state = 6, .external_lex_state = 4},
  [651] = {.lex_state = 6},
  [652] = {.lex_state = 6, .external_lex_state = 4},
  [653] = {.lex_state = 6},
  [654] = {.lex_state = 6, .external_lex_state = 4},
  [655] = {.lex_state = 6},
  [656] = {.lex_state = 6},
  [657] = {.lex_state = 6},
  [658] = {.lex_state = 6},
  [659] = {.lex_state = 6, .external_lex_state = 4},
  [660] = {.lex_state = 6},
  [661] = {.lex_state = 6},
  [662] = {.lex_state = 6},
  [663] = {.lex_state = 6},
  [664] = {.lex_state = 6},
  [665] = {.lex_state = 6},
  [666] = {.lex_state = 27},
  [667] = {.lex_state = 6},
  [668] = {.lex_state = 27},
  [669] = {.lex_state = 6},
  [670] = {.lex_state = 6},
  [671] = {.lex_state = 6},
  [672] = {.lex_state = 6},
  [673] = {.lex_state = 6},
  [674] = {.lex_state = 6},
  [675] = {.lex_state = 6},
  [676] = {.lex_state = 6},
  [677] = {.lex_state = 6},
  [678] = {.lex_state = 6},
  [679] = {.lex_state = 6},
  [680] = {.lex_state = 6},
  [681] = {.lex_state = 6},
  [682] = {.lex_state = 6},
  [683] = {.lex_state = 6},
  [684] = {.lex_state = 6},
  [685] = {.lex_state = 6},
  [686] = {.lex_state = 6},
  [687] = {.lex_state = 6},
  [688] = {.lex_state = 6},
  [689] = {.lex_state = 6},
  [690] = {.lex_state = 6},
  [691] = {.lex_state = 6},
  [692] = {.lex_state = 6},
  [693] = {.lex_state = 6},
  [694] = {.lex_state = 6},
  [695] = {.lex_state = 6},
  [696] = {.lex_state = 6},
  [697] = {.lex_state = 6},
  [698] = {.lex_state = 6},
  [699] = {.lex_state = 6},
  [700] = {.lex_state = 27},
  [701] = {.lex_state = 5},
  [702] = {.lex_state = 5},
  [703] = {.lex_state = 5},
  [704] = {.lex_state = 5},
  [705] = {.lex_state = 5},
  [706] = {.lex_state = 5},
  [707] = {.lex_state = 5},
  [708] = {.lex_state = 5},
  [709] = {.lex_state = 5},
  [710] = {.lex_state = 5},
  [711] = {.lex_state = 5},
  [712] = {.lex_state = 5},
  [713] = {.lex_state = 5},
  [714] = {.lex_state = 5},
  [715] = {.lex_state = 5},
  [716] = {.lex_state = 5},
  [717] = {.lex_state = 5},
  [718] = {.lex_state = 5},
  [719] = {.lex_state = 27},
  [720] = {.lex_state = 5},
  [721] = {.lex_state = 5},
  [722] = {.lex_state = 5},
  [723] = {.lex_state = 5, .external_lex_state = 2},
  [724] = {.lex_state = 5},
  [725] = {.lex_state = 5},
  [726] = {.lex_state = 5},
  [727] = {.lex_state = 5},
  [728] = {.lex_state = 5},
  [729] = {.lex_state = 5},
  [730] = {.lex_state = 5},
  [731] = {.lex_state = 5},
  [732] = {.lex_state = 5},
  [733] = {.lex_state = 5},
  [734] = {.lex_state = 5},
  [735] = {.lex_state = 5},
  [736] = {.lex_state = 5},
  [737] = {.lex_state = 5},
  [738] = {.lex_state = 5},
  [739] = {.lex_state = 5},
  [740] = {.lex_state = 5},
  [741] = {.lex_state = 5},
  [742] = {.lex_state = 5},
  [743] = {.lex_state = 5},
  [744] = {.lex_state = 5},
  [745] = {.lex_state = 5},
  [746] = {.lex_state = 5},
  [747] = {.lex_state = 5},
  [748] = {.lex_state = 5},
  [749] = {.lex_state = 5},
  [750] = {.lex_state = 0},
  [751] = {.lex_state = 5},
  [752] = {.lex_state = 5},
  [753] = {.lex_state = 0},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 5},
  [756] = {.lex_state = 5},
  [757] = {.lex_state = 5},
  [758] = {.lex_state = 5},
  [759] = {.lex_state = 5},
  [760] = {.lex_state = 5},
  [761] = {.lex_state = 5},
  [762] = {.lex_state = 5},
  [763] = {.lex_state = 5},
  [764] = {.lex_state = 5},
  [765] = {.lex_state = 5},
  [766] = {.lex_state = 5},
  [767] = {.lex_state = 5},
  [768] = {.lex_state = 5},
  [769] = {.lex_state = 5},
  [770] = {.lex_state = 5},
  [771] = {.lex_state = 5},
  [772] = {.lex_state = 5},
  [773] = {.lex_state = 5},
  [774] = {.lex_state = 5},
  [775] = {.lex_state = 5},
  [776] = {.lex_state = 5},
  [777] = {.lex_state = 0},
  [778] = {.lex_state = 0},
  [779] = {.lex_state = 5},
  [780] = {.lex_state = 5},
  [781] = {.lex_state = 5},
  [782] = {.lex_state = 5},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 0},
  [785] = {.lex_state = 7, .external_lex_state = 2},
  [786] = {.lex_state = 5},
  [787] = {.lex_state = 0},
  [788] = {.lex_state = 5},
  [789] = {.lex_state = 0},
  [790] = {.lex_state = 0},
  [791] = {.lex_state = 5},
  [792] = {.lex_state = 5},
  [793] = {.lex_state = 5},
  [794] = {.lex_state = 5},
  [795] = {.lex_state = 5},
  [796] = {.lex_state = 5},
  [797] = {.lex_state = 5},
  [798] = {.lex_state = 0},
  [799] = {.lex_state = 5},
  [800] = {.lex_state = 5},
  [801] = {.lex_state = 0, .external_lex_state = 4},
  [802] = {.lex_state = 0},
  [803] = {.lex_state = 5},
  [804] = {.lex_state = 5},
  [805] = {.lex_state = 0},
  [806] = {.lex_state = 0, .external_lex_state = 4},
  [807] = {.lex_state = 5},
  [808] = {.lex_state = 0},
  [809] = {.lex_state = 5},
  [810] = {.lex_state = 5},
  [811] = {.lex_state = 0},
  [812] = {.lex_state = 0},
  [813] = {.lex_state = 5},
  [814] = {.lex_state = 5},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 5},
  [817] = {.lex_state = 5},
  [818] = {.lex_state = 5},
  [819] = {.lex_state = 5},
  [820] = {.lex_state = 5},
  [821] = {.lex_state = 5},
  [822] = {.lex_state = 5},
  [823] = {.lex_state = 5},
  [824] = {.lex_state = 5},
  [825] = {.lex_state = 5},
  [826] = {.lex_state = 5},
  [827] = {.lex_state = 5},
  [828] = {.lex_state = 5},
  [829] = {.lex_state = 5},
  [830] = {.lex_state = 5},
  [831] = {.lex_state = 5},
  [832] = {.lex_state = 5},
  [833] = {.lex_state = 5},
  [834] = {.lex_state = 5},
  [835] = {.lex_state = 5},
  [836] = {.lex_state = 5},
  [837] = {.lex_state = 5},
  [838] = {.lex_state = 5},
  [839] = {.lex_state = 5},
  [840] = {.lex_state = 5},
  [841] = {.lex_state = 5},
  [842] = {.lex_state = 5},
  [843] = {.lex_state = 5},
  [844] = {.lex_state = 5},
  [845] = {.lex_state = 5},
  [846] = {.lex_state = 5},
  [847] = {.lex_state = 5},
  [848] = {.lex_state = 0, .external_lex_state = 4},
  [849] = {.lex_state = 5},
  [850] = {.lex_state = 0, .external_lex_state = 4},
  [851] = {.lex_state = 0, .external_lex_state = 4},
  [852] = {.lex_state = 5, .external_lex_state = 4},
  [853] = {.lex_state = 5, .external_lex_state = 4},
  [854] = {.lex_state = 5},
  [855] = {.lex_state = 5},
  [856] = {.lex_state = 5},
  [857] = {.lex_state = 4},
  [858] = {.lex_state = 5},
  [859] = {.lex_state = 5},
  [860] = {.lex_state = 5},
  [861] = {.lex_state = 5, .external_lex_state = 4},
  [862] = {.lex_state = 0, .external_lex_state = 4},
  [863] = {.lex_state = 5},
  [864] = {.lex_state = 5, .external_lex_state = 4},
  [865] = {.lex_state = 5},
  [866] = {.lex_state = 79},
  [867] = {.lex_state = 5},
  [868] = {.lex_state = 5},
  [869] = {.lex_state = 5},
  [870] = {.lex_state = 5, .external_lex_state = 4},
  [871] = {.lex_state = 5},
  [872] = {.lex_state = 5},
  [873] = {.lex_state = 0, .external_lex_state = 4},
  [874] = {.lex_state = 5},
  [875] = {.lex_state = 5},
  [876] = {.lex_state = 0, .external_lex_state = 4},
  [877] = {.lex_state = 5},
  [878] = {.lex_state = 5, .external_lex_state = 4},
  [879] = {.lex_state = 79},
  [880] = {.lex_state = 5},
  [881] = {.lex_state = 0, .external_lex_state = 4},
  [882] = {.lex_state = 5},
  [883] = {.lex_state = 5},
  [884] = {.lex_state = 0, .external_lex_state = 4},
  [885] = {.lex_state = 5},
  [886] = {.lex_state = 5, .external_lex_state = 4},
  [887] = {.lex_state = 5},
  [888] = {.lex_state = 0, .external_lex_state = 4},
  [889] = {.lex_state = 5},
  [890] = {.lex_state = 5},
  [891] = {.lex_state = 28, .external_lex_state = 5},
  [892] = {.lex_state = 0, .external_lex_state = 4},
  [893] = {.lex_state = 5},
  [894] = {.lex_state = 0, .external_lex_state = 4},
  [895] = {.lex_state = 5},
  [896] = {.lex_state = 0, .external_lex_state = 4},
  [897] = {.lex_state = 0},
  [898] = {.lex_state = 0, .external_lex_state = 4},
  [899] = {.lex_state = 0, .external_lex_state = 4},
  [900] = {.lex_state = 0, .external_lex_state = 4},
  [901] = {.lex_state = 5},
  [902] = {.lex_state = 0},
  [903] = {.lex_state = 0, .external_lex_state = 4},
  [904] = {.lex_state = 5},
  [905] = {.lex_state = 5},
  [906] = {.lex_state = 0},
  [907] = {.lex_state = 0, .external_lex_state = 4},
  [908] = {.lex_state = 0},
  [909] = {.lex_state = 0, .external_lex_state = 4},
  [910] = {.lex_state = 0, .external_lex_state = 4},
  [911] = {.lex_state = 0, .external_lex_state = 4},
  [912] = {.lex_state = 5},
  [913] = {.lex_state = 0, .external_lex_state = 4},
  [914] = {.lex_state = 0, .external_lex_state = 4},
  [915] = {.lex_state = 0, .external_lex_state = 4},
  [916] = {.lex_state = 5},
  [917] = {.lex_state = 0, .external_lex_state = 4},
  [918] = {.lex_state = 5},
  [919] = {.lex_state = 28, .external_lex_state = 5},
  [920] = {.lex_state = 0, .external_lex_state = 4},
  [921] = {.lex_state = 0, .external_lex_state = 4},
  [922] = {.lex_state = 5},
  [923] = {.lex_state = 5},
  [924] = {.lex_state = 0, .external_lex_state = 4},
  [925] = {.lex_state = 0},
  [926] = {.lex_state = 0, .external_lex_state = 4},
  [927] = {.lex_state = 0, .external_lex_state = 4},
  [928] = {.lex_state = 0, .external_lex_state = 4},
  [929] = {.lex_state = 4},
  [930] = {.lex_state = 0, .external_lex_state = 4},
  [931] = {.lex_state = 0},
  [932] = {.lex_state = 0, .external_lex_state = 4},
  [933] = {.lex_state = 0},
  [934] = {.lex_state = 0, .external_lex_state = 4},
  [935] = {.lex_state = 5},
  [936] = {.lex_state = 0, .external_lex_state = 4},
  [937] = {.lex_state = 28, .external_lex_state = 5},
  [938] = {.lex_state = 0},
  [939] = {.lex_state = 0},
  [940] = {.lex_state = 0, .external_lex_state = 4},
  [941] = {.lex_state = 0, .external_lex_state = 4},
  [942] = {.lex_state = 5},
  [943] = {.lex_state = 0, .external_lex_state = 4},
  [944] = {.lex_state = 5},
  [945] = {.lex_state = 5},
  [946] = {.lex_state = 0, .external_lex_state = 4},
  [947] = {.lex_state = 0, .external_lex_state = 4},
  [948] = {.lex_state = 0, .external_lex_state = 4},
  [949] = {.lex_state = 4},
  [950] = {.lex_state = 5},
  [951] = {.lex_state = 0, .external_lex_state = 4},
  [952] = {.lex_state = 0, .external_lex_state = 4},
  [953] = {.lex_state = 0, .external_lex_state = 4},
  [954] = {.lex_state = 5},
  [955] = {.lex_state = 4},
  [956] = {.lex_state = 79},
  [957] = {.lex_state = 5},
  [958] = {.lex_state = 0},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 0, .external_lex_state = 4},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 0, .external_lex_state = 4},
  [963] = {.lex_state = 0},
  [964] = {.lex_state = 5},
  [965] = {.lex_state = 0, .external_lex_state = 4},
  [966] = {.lex_state = 0, .external_lex_state = 4},
  [967] = {.lex_state = 0, .external_lex_state = 4},
  [968] = {.lex_state = 0},
  [969] = {.lex_state = 0},
  [970] = {.lex_state = 4},
  [971] = {.lex_state = 5},
  [972] = {.lex_state = 0},
  [973] = {.lex_state = 4},
  [974] = {.lex_state = 0},
  [975] = {.lex_state = 4},
  [976] = {.lex_state = 0},
  [977] = {.lex_state = 5},
  [978] = {.lex_state = 0},
  [979] = {.lex_state = 5},
  [980] = {.lex_state = 5},
  [981] = {.lex_state = 0},
  [982] = {.lex_state = 5},
  [983] = {.lex_state = 5},
  [984] = {.lex_state = 5},
  [985] = {.lex_state = 5},
  [986] = {.lex_state = 5},
  [987] = {.lex_state = 5},
  [988] = {.lex_state = 5},
  [989] = {.lex_state = 0},
  [990] = {.lex_state = 5},
  [991] = {.lex_state = 5},
  [992] = {.lex_state = 5},
  [993] = {.lex_state = 0, .external_lex_state = 4},
  [994] = {.lex_state = 5},
  [995] = {.lex_state = 5},
  [996] = {.lex_state = 5},
  [997] = {.lex_state = 5},
  [998] = {.lex_state = 5},
  [999] = {.lex_state = 5},
  [1000] = {.lex_state = 5},
  [1001] = {.lex_state = 5},
  [1002] = {.lex_state = 5},
  [1003] = {.lex_state = 5},
  [1004] = {.lex_state = 5},
  [1005] = {.lex_state = 0},
  [1006] = {.lex_state = 5},
  [1007] = {.lex_state = 5},
  [1008] = {.lex_state = 5},
  [1009] = {.lex_state = 5},
  [1010] = {.lex_state = 5},
  [1011] = {.lex_state = 5},
  [1012] = {.lex_state = 5},
  [1013] = {.lex_state = 5},
  [1014] = {.lex_state = 5},
  [1015] = {.lex_state = 5},
  [1016] = {.lex_state = 5},
  [1017] = {.lex_state = 5},
  [1018] = {.lex_state = 4},
  [1019] = {.lex_state = 5},
  [1020] = {.lex_state = 0},
  [1021] = {.lex_state = 5},
  [1022] = {.lex_state = 5},
  [1023] = {.lex_state = 0},
  [1024] = {.lex_state = 0},
  [1025] = {.lex_state = 5},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 4},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 5},
  [1030] = {.lex_state = 5},
  [1031] = {.lex_state = 0},
  [1032] = {.lex_state = 5},
  [1033] = {.lex_state = 5},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 5},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 0, .external_lex_state = 4},
  [1039] = {.lex_state = 5},
  [1040] = {.lex_state = 5},
  [1041] = {.lex_state = 0},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 0, .external_lex_state = 4},
  [1044] = {.lex_state = 4},
  [1045] = {.lex_state = 0},
  [1046] = {.lex_state = 5},
  [1047] = {.lex_state = 0},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 0},
  [1051] = {.lex_state = 0},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 0},
  [1054] = {.lex_state = 0},
  [1055] = {.lex_state = 0},
  [1056] = {.lex_state = 0},
  [1057] = {.lex_state = 0, .external_lex_state = 4},
  [1058] = {.lex_state = 5},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 0},
  [1062] = {.lex_state = 0},
  [1063] = {.lex_state = 0},
  [1064] = {.lex_state = 0},
  [1065] = {.lex_state = 0, .external_lex_state = 4},
  [1066] = {.lex_state = 5},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 5},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 5},
  [1072] = {.lex_state = 5},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 0, .external_lex_state = 4},
  [1075] = {.lex_state = 0},
  [1076] = {.lex_state = 5},
  [1077] = {.lex_state = 5},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 5},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 0},
  [1084] = {.lex_state = 5},
  [1085] = {.lex_state = 5},
  [1086] = {.lex_state = 0, .external_lex_state = 4},
  [1087] = {.lex_state = 0},
  [1088] = {.lex_state = 0, .external_lex_state = 4},
  [1089] = {.lex_state = 0, .external_lex_state = 4},
  [1090] = {.lex_state = 0, .external_lex_state = 4},
  [1091] = {.lex_state = 0, .external_lex_state = 4},
  [1092] = {.lex_state = 0, .external_lex_state = 4},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 5},
  [1095] = {.lex_state = 5},
  [1096] = {.lex_state = 5},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 5},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 0},
  [1103] = {.lex_state = 5},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 5, .external_lex_state = 4},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 0},
  [1109] = {.lex_state = 0},
  [1110] = {.lex_state = 5},
  [1111] = {.lex_state = 4},
  [1112] = {.lex_state = 5},
  [1113] = {.lex_state = 5},
  [1114] = {.lex_state = 5},
  [1115] = {.lex_state = 5},
  [1116] = {.lex_state = 0},
  [1117] = {.lex_state = 0},
  [1118] = {.lex_state = 5},
  [1119] = {.lex_state = 0},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 5},
  [1123] = {.lex_state = 5},
  [1124] = {.lex_state = 5},
  [1125] = {.lex_state = 0},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 0},
  [1128] = {.lex_state = 0, .external_lex_state = 4},
  [1129] = {.lex_state = 5},
  [1130] = {.lex_state = 5},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 5},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 0, .external_lex_state = 4},
  [1136] = {.lex_state = 0, .external_lex_state = 4},
  [1137] = {.lex_state = 0, .external_lex_state = 4},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 5},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 5},
  [1143] = {.lex_state = 5},
  [1144] = {.lex_state = 5},
  [1145] = {.lex_state = 5},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 5},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 5, .external_lex_state = 4},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 5},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 0, .external_lex_state = 4},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 0},
  [1159] = {.lex_state = 0},
  [1160] = {.lex_state = 78},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 0},
  [1163] = {.lex_state = 0},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 0},
  [1169] = {.lex_state = 0},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 0, .external_lex_state = 4},
  [1172] = {.lex_state = 0},
  [1173] = {.lex_state = 0},
  [1174] = {.lex_state = 0},
  [1175] = {.lex_state = 0},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 0, .external_lex_state = 4},
  [1178] = {.lex_state = 0, .external_lex_state = 4},
  [1179] = {.lex_state = 0},
  [1180] = {.lex_state = 0, .external_lex_state = 4},
  [1181] = {.lex_state = 0, .external_lex_state = 4},
  [1182] = {.lex_state = 0},
  [1183] = {.lex_state = 0, .external_lex_state = 4},
  [1184] = {.lex_state = 0, .external_lex_state = 4},
  [1185] = {.lex_state = 0, .external_lex_state = 4},
  [1186] = {.lex_state = 0, .external_lex_state = 4},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 0, .external_lex_state = 4},
  [1189] = {.lex_state = 0},
  [1190] = {.lex_state = 0},
  [1191] = {.lex_state = 0},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 0},
  [1194] = {.lex_state = 0},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 0},
  [1197] = {.lex_state = 0},
  [1198] = {.lex_state = 0, .external_lex_state = 4},
  [1199] = {.lex_state = 0},
  [1200] = {.lex_state = 0, .external_lex_state = 4},
  [1201] = {.lex_state = 0},
  [1202] = {.lex_state = 0, .external_lex_state = 4},
  [1203] = {.lex_state = 0, .external_lex_state = 4},
  [1204] = {.lex_state = 0, .external_lex_state = 4},
  [1205] = {.lex_state = 0},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 0},
  [1208] = {.lex_state = 0},
  [1209] = {.lex_state = 0, .external_lex_state = 4},
  [1210] = {.lex_state = 0, .external_lex_state = 4},
  [1211] = {.lex_state = 5},
  [1212] = {.lex_state = 0, .external_lex_state = 4},
  [1213] = {.lex_state = 0, .external_lex_state = 4},
  [1214] = {.lex_state = 0, .external_lex_state = 4},
  [1215] = {.lex_state = 0},
  [1216] = {.lex_state = 0, .external_lex_state = 4},
  [1217] = {.lex_state = 0},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 0, .external_lex_state = 4},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 0, .external_lex_state = 4},
  [1222] = {.lex_state = 0, .external_lex_state = 4},
  [1223] = {.lex_state = 0, .external_lex_state = 4},
  [1224] = {.lex_state = 0, .external_lex_state = 4},
  [1225] = {.lex_state = 0, .external_lex_state = 4},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 0},
  [1228] = {.lex_state = 0},
  [1229] = {.lex_state = 0, .external_lex_state = 4},
  [1230] = {.lex_state = 0},
  [1231] = {.lex_state = 0},
  [1232] = {.lex_state = 0},
  [1233] = {.lex_state = 0, .external_lex_state = 4},
  [1234] = {.lex_state = 0},
  [1235] = {.lex_state = 0},
  [1236] = {.lex_state = 0},
  [1237] = {.lex_state = 0, .external_lex_state = 4},
  [1238] = {.lex_state = 0, .external_lex_state = 4},
  [1239] = {.lex_state = 0, .external_lex_state = 4},
  [1240] = {.lex_state = 0, .external_lex_state = 4},
  [1241] = {.lex_state = 0, .external_lex_state = 4},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 0, .external_lex_state = 4},
  [1244] = {.lex_state = 0, .external_lex_state = 4},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 0, .external_lex_state = 4},
  [1247] = {.lex_state = 0},
  [1248] = {.lex_state = 0, .external_lex_state = 4},
  [1249] = {.lex_state = 0},
  [1250] = {.lex_state = 0},
  [1251] = {.lex_state = 0},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 0},
  [1254] = {.lex_state = 0},
  [1255] = {.lex_state = 0},
  [1256] = {.lex_state = 0},
  [1257] = {.lex_state = 0},
  [1258] = {.lex_state = 0, .external_lex_state = 4},
  [1259] = {.lex_state = 0},
  [1260] = {.lex_state = 0, .external_lex_state = 4},
  [1261] = {.lex_state = 0, .external_lex_state = 4},
  [1262] = {.lex_state = 0, .external_lex_state = 4},
  [1263] = {.lex_state = 0},
  [1264] = {.lex_state = 0},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 0},
  [1267] = {.lex_state = 0},
  [1268] = {.lex_state = 0, .external_lex_state = 4},
  [1269] = {.lex_state = 5},
  [1270] = {.lex_state = 0, .external_lex_state = 4},
  [1271] = {.lex_state = 0, .external_lex_state = 4},
  [1272] = {.lex_state = 0},
  [1273] = {.lex_state = 0, .external_lex_state = 4},
  [1274] = {.lex_state = 0},
  [1275] = {.lex_state = 0, .external_lex_state = 4},
  [1276] = {.lex_state = 0},
  [1277] = {.lex_state = 0},
  [1278] = {.lex_state = 0},
  [1279] = {.lex_state = 0},
  [1280] = {.lex_state = 0, .external_lex_state = 4},
  [1281] = {.lex_state = 0},
  [1282] = {.lex_state = 0},
  [1283] = {.lex_state = 0, .external_lex_state = 4},
  [1284] = {.lex_state = 0},
  [1285] = {.lex_state = 0, .external_lex_state = 4},
  [1286] = {.lex_state = 0, .external_lex_state = 4},
  [1287] = {.lex_state = 0, .external_lex_state = 4},
  [1288] = {.lex_state = 0},
  [1289] = {.lex_state = 0, .external_lex_state = 4},
  [1290] = {.lex_state = 0},
  [1291] = {.lex_state = 0},
  [1292] = {.lex_state = 0},
  [1293] = {.lex_state = 0},
  [1294] = {.lex_state = 0},
  [1295] = {.lex_state = 0, .external_lex_state = 4},
  [1296] = {.lex_state = 0, .external_lex_state = 4},
  [1297] = {.lex_state = 0},
  [1298] = {.lex_state = 0},
  [1299] = {.lex_state = 0},
  [1300] = {.lex_state = 0},
  [1301] = {.lex_state = 0},
  [1302] = {.lex_state = 0},
  [1303] = {.lex_state = 0},
  [1304] = {.lex_state = 0},
  [1305] = {.lex_state = 0},
  [1306] = {.lex_state = 0},
  [1307] = {.lex_state = 0},
  [1308] = {.lex_state = 0},
  [1309] = {.lex_state = 0},
  [1310] = {.lex_state = 5},
  [1311] = {.lex_state = 0},
  [1312] = {.lex_state = 5},
  [1313] = {.lex_state = 5},
  [1314] = {.lex_state = 5},
  [1315] = {.lex_state = 5},
  [1316] = {.lex_state = 5},
  [1317] = {.lex_state = 5},
  [1318] = {.lex_state = 5},
  [1319] = {.lex_state = 5},
  [1320] = {.lex_state = 5},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 5},
  [1323] = {.lex_state = 0},
  [1324] = {.lex_state = 0},
  [1325] = {.lex_state = 5},
  [1326] = {.lex_state = 0},
  [1327] = {.lex_state = 0},
  [1328] = {.lex_state = 5},
  [1329] = {.lex_state = 5},
  [1330] = {.lex_state = 0},
  [1331] = {.lex_state = 0},
  [1332] = {.lex_state = 0},
  [1333] = {.lex_state = 0},
  [1334] = {.lex_state = 5},
  [1335] = {.lex_state = 0},
  [1336] = {.lex_state = 0},
  [1337] = {.lex_state = 0},
  [1338] = {.lex_state = 5},
  [1339] = {.lex_state = 0},
  [1340] = {.lex_state = 0},
  [1341] = {.lex_state = 0},
  [1342] = {.lex_state = 0},
  [1343] = {.lex_state = 0},
  [1344] = {.lex_state = 0},
  [1345] = {.lex_state = 0},
  [1346] = {.lex_state = 0},
  [1347] = {.lex_state = 0},
  [1348] = {.lex_state = 0},
  [1349] = {.lex_state = 5},
  [1350] = {.lex_state = 0},
  [1351] = {.lex_state = 0},
  [1352] = {.lex_state = 0},
  [1353] = {.lex_state = 0},
  [1354] = {.lex_state = 0},
  [1355] = {.lex_state = 5},
  [1356] = {.lex_state = 0},
  [1357] = {.lex_state = 0},
  [1358] = {.lex_state = 0},
  [1359] = {.lex_state = 5},
  [1360] = {.lex_state = 0},
  [1361] = {.lex_state = 0},
  [1362] = {.lex_state = 5},
  [1363] = {.lex_state = 0},
  [1364] = {.lex_state = 0},
  [1365] = {.lex_state = 0},
  [1366] = {.lex_state = 5},
  [1367] = {.lex_state = 5},
  [1368] = {.lex_state = 0},
  [1369] = {.lex_state = 0},
  [1370] = {.lex_state = 0},
  [1371] = {.lex_state = 0},
  [1372] = {.lex_state = 0},
  [1373] = {.lex_state = 0},
  [1374] = {.lex_state = 5},
  [1375] = {.lex_state = 0},
  [1376] = {.lex_state = 0},
  [1377] = {.lex_state = 5},
  [1378] = {.lex_state = 0},
  [1379] = {.lex_state = 0},
  [1380] = {.lex_state = 5},
  [1381] = {.lex_state = 0},
  [1382] = {.lex_state = 5},
  [1383] = {.lex_state = 5},
  [1384] = {.lex_state = 0},
  [1385] = {.lex_state = 5},
  [1386] = {.lex_state = 5},
  [1387] = {.lex_state = 0},
  [1388] = {.lex_state = 0},
  [1389] = {.lex_state = 5},
  [1390] = {.lex_state = 5},
  [1391] = {.lex_state = 0},
  [1392] = {.lex_state = 0},
  [1393] = {.lex_state = 0},
  [1394] = {.lex_state = 5},
  [1395] = {.lex_state = 0},
  [1396] = {.lex_state = 0},
  [1397] = {.lex_state = 0},
  [1398] = {.lex_state = 0},
  [1399] = {.lex_state = 0},
  [1400] = {.lex_state = 0},
  [1401] = {.lex_state = 0},
  [1402] = {.lex_state = 0},
  [1403] = {.lex_state = 0},
  [1404] = {.lex_state = 0},
  [1405] = {.lex_state = 5},
  [1406] = {.lex_state = 78, .external_lex_state = 5},
  [1407] = {.lex_state = 0},
  [1408] = {.lex_state = 0},
  [1409] = {.lex_state = 5},
  [1410] = {.lex_state = 0},
  [1411] = {.lex_state = 0},
  [1412] = {.lex_state = 0},
  [1413] = {.lex_state = 0},
  [1414] = {.lex_state = 0},
  [1415] = {.lex_state = 0},
  [1416] = {.lex_state = 0},
  [1417] = {.lex_state = 0},
  [1418] = {.lex_state = 0},
  [1419] = {.lex_state = 0},
  [1420] = {.lex_state = 0},
  [1421] = {(TSStateId)(-1)},
  [1422] = {(TSStateId)(-1)},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token_heredoc = 1,
  ts_external_token__eof = 2,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token_heredoc] = sym_heredoc,
  [ts_external_token__eof] = sym__eof,
};

static bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_heredoc] = true,
    [ts_external_token__eof] = true,
  },
  [2] = {
    [ts_external_token_heredoc] = true,
  },
  [3] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token_heredoc] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__eof] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_text_interpolation] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_name] = ACTIONS(1),
    [sym_php_tag] = ACTIONS(1),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [aux_sym_text_token1] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_trait] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [sym_var_modifier] = ACTIONS(1),
    [anon_sym_insteadof] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_array] = ACTIONS(1),
    [anon_sym_callable] = ACTIONS(1),
    [anon_sym_iterable] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_binary] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_double] = ACTIONS(1),
    [anon_sym_integer] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [anon_sym_real] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_echo] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_enddeclare] = ACTIONS(1),
    [anon_sym_ticks] = ACTIONS(1),
    [anon_sym_encoding] = ACTIONS(1),
    [anon_sym_strict_types] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_endwhile] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_endfor] = ACTIONS(1),
    [anon_sym_foreach] = ACTIONS(1),
    [anon_sym_endforeach] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_endif] = ACTIONS(1),
    [anon_sym_elseif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_endswitch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_clone] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_print] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [sym_shell_command_expression] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_list] = ACTIONS(1),
    [anon_sym_self] = ACTIONS(1),
    [anon_sym_parent] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [sym_boolean] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [aux_sym_binary_expression_token1] = ACTIONS(1),
    [aux_sym_binary_expression_token2] = ACTIONS(1),
    [aux_sym_binary_expression_token3] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_include] = ACTIONS(1),
    [anon_sym_include_once] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_require_once] = ACTIONS(1),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym_heredoc] = ACTIONS(1),
    [sym__eof] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(1416),
    [sym_text_interpolation] = STATE(1),
    [sym_text] = STATE(1160),
    [aux_sym_text_repeat1] = STATE(866),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_php_tag] = ACTIONS(9),
    [anon_sym_QMARK_GT] = ACTIONS(11),
    [aux_sym_text_token1] = ACTIONS(13),
    [aux_sym_text_token2] = ACTIONS(13),
    [sym_comment] = ACTIONS(15),
  },
  [2] = {
    [sym_text_interpolation] = STATE(2),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(17),
    [sym_name] = ACTIONS(19),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(22),
    [anon_sym_static] = ACTIONS(25),
    [anon_sym_global] = ACTIONS(28),
    [anon_sym_namespace] = ACTIONS(31),
    [anon_sym_use] = ACTIONS(34),
    [anon_sym_BSLASH] = ACTIONS(37),
    [anon_sym_function] = ACTIONS(40),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(46),
    [anon_sym_RBRACE] = ACTIONS(17),
    [anon_sym_trait] = ACTIONS(49),
    [anon_sym_interface] = ACTIONS(52),
    [anon_sym_class] = ACTIONS(55),
    [anon_sym_abstract] = ACTIONS(58),
    [anon_sym_final] = ACTIONS(58),
    [anon_sym_public] = ACTIONS(61),
    [anon_sym_protected] = ACTIONS(61),
    [anon_sym_private] = ACTIONS(61),
    [anon_sym_LPAREN] = ACTIONS(64),
    [anon_sym_array] = ACTIONS(67),
    [anon_sym_unset] = ACTIONS(70),
    [anon_sym_echo] = ACTIONS(73),
    [anon_sym_declare] = ACTIONS(76),
    [anon_sym_enddeclare] = ACTIONS(79),
    [sym_float] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(84),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_continue] = ACTIONS(90),
    [anon_sym_break] = ACTIONS(93),
    [sym_integer] = ACTIONS(81),
    [anon_sym_return] = ACTIONS(96),
    [anon_sym_throw] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(102),
    [anon_sym_endwhile] = ACTIONS(79),
    [anon_sym_do] = ACTIONS(105),
    [anon_sym_for] = ACTIONS(108),
    [anon_sym_endfor] = ACTIONS(79),
    [anon_sym_foreach] = ACTIONS(111),
    [anon_sym_endforeach] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(114),
    [anon_sym_endif] = ACTIONS(79),
    [anon_sym_elseif] = ACTIONS(79),
    [anon_sym_else] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(117),
    [anon_sym_endswitch] = ACTIONS(79),
    [anon_sym_case] = ACTIONS(79),
    [anon_sym_default] = ACTIONS(79),
    [anon_sym_AT] = ACTIONS(120),
    [anon_sym_PLUS] = ACTIONS(123),
    [anon_sym_DASH] = ACTIONS(123),
    [anon_sym_TILDE] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(126),
    [anon_sym_clone] = ACTIONS(129),
    [anon_sym_print] = ACTIONS(132),
    [anon_sym_new] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(138),
    [anon_sym_DASH_DASH] = ACTIONS(138),
    [sym_shell_command_expression] = ACTIONS(141),
    [anon_sym_list] = ACTIONS(144),
    [anon_sym_self] = ACTIONS(147),
    [anon_sym_parent] = ACTIONS(147),
    [anon_sym_LBRACK] = ACTIONS(150),
    [sym_string] = ACTIONS(153),
    [sym_boolean] = ACTIONS(81),
    [sym_null] = ACTIONS(81),
    [anon_sym_DOLLAR] = ACTIONS(156),
    [anon_sym_yield] = ACTIONS(159),
    [anon_sym_include] = ACTIONS(162),
    [anon_sym_include_once] = ACTIONS(165),
    [anon_sym_require] = ACTIONS(168),
    [anon_sym_require_once] = ACTIONS(171),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(153),
  },
  [3] = {
    [sym_text_interpolation] = STATE(3),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_endwhile] = ACTIONS(230),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_endforeach] = ACTIONS(230),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_endif] = ACTIONS(230),
    [anon_sym_elseif] = ACTIONS(230),
    [anon_sym_else] = ACTIONS(230),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [4] = {
    [sym_text_interpolation] = STATE(4),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(3),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_endwhile] = ACTIONS(278),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_endforeach] = ACTIONS(278),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_endif] = ACTIONS(278),
    [anon_sym_elseif] = ACTIONS(278),
    [anon_sym_else] = ACTIONS(278),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [5] = {
    [sym_text_interpolation] = STATE(5),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(8),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(280),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_endswitch] = ACTIONS(282),
    [anon_sym_case] = ACTIONS(282),
    [anon_sym_default] = ACTIONS(282),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [6] = {
    [sym_text_interpolation] = STATE(6),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(284),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_endswitch] = ACTIONS(286),
    [anon_sym_case] = ACTIONS(286),
    [anon_sym_default] = ACTIONS(286),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [7] = {
    [sym_text_interpolation] = STATE(7),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(6),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(288),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_endswitch] = ACTIONS(290),
    [anon_sym_case] = ACTIONS(290),
    [anon_sym_default] = ACTIONS(290),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [8] = {
    [sym_text_interpolation] = STATE(8),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(292),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_endswitch] = ACTIONS(294),
    [anon_sym_case] = ACTIONS(294),
    [anon_sym_default] = ACTIONS(294),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [9] = {
    [sym_text_interpolation] = STATE(9),
    [sym_empty_statement] = STATE(1010),
    [sym_function_static_declaration] = STATE(1010),
    [sym_global_declaration] = STATE(1010),
    [sym_namespace_definition] = STATE(1010),
    [sym_namespace_use_declaration] = STATE(1010),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(1010),
    [sym_interface_declaration] = STATE(1010),
    [sym_class_declaration] = STATE(1010),
    [sym_class_modifier] = STATE(1385),
    [sym_const_declaration] = STATE(1010),
    [sym_visibility_modifier] = STATE(1386),
    [sym_function_definition] = STATE(1010),
    [sym__function_definition_header] = STATE(1201),
    [sym_echo_statement] = STATE(1010),
    [sym_unset_statement] = STATE(1010),
    [sym_declare_statement] = STATE(1010),
    [sym_try_statement] = STATE(1010),
    [sym__jump_statement] = STATE(1010),
    [sym_goto_statement] = STATE(1124),
    [sym_continue_statement] = STATE(1124),
    [sym_break_statement] = STATE(1124),
    [sym_return_statement] = STATE(1124),
    [sym_throw_statement] = STATE(1124),
    [sym_while_statement] = STATE(1010),
    [sym_do_statement] = STATE(1010),
    [sym_for_statement] = STATE(1010),
    [sym_foreach_statement] = STATE(1010),
    [sym_if_statement] = STATE(1010),
    [sym_colon_block] = STATE(1362),
    [sym_switch_statement] = STATE(1010),
    [sym_compound_statement] = STATE(1010),
    [sym_named_label_statement] = STATE(1010),
    [sym_expression_statement] = STATE(1010),
    [sym__expression] = STATE(654),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(296),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(298),
    [anon_sym_static] = ACTIONS(300),
    [anon_sym_global] = ACTIONS(302),
    [anon_sym_namespace] = ACTIONS(304),
    [anon_sym_use] = ACTIONS(306),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(308),
    [anon_sym_LBRACE] = ACTIONS(310),
    [anon_sym_trait] = ACTIONS(312),
    [anon_sym_interface] = ACTIONS(314),
    [anon_sym_class] = ACTIONS(316),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(318),
    [anon_sym_COLON] = ACTIONS(320),
    [anon_sym_echo] = ACTIONS(322),
    [anon_sym_declare] = ACTIONS(324),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(326),
    [anon_sym_goto] = ACTIONS(328),
    [anon_sym_continue] = ACTIONS(330),
    [anon_sym_break] = ACTIONS(332),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(334),
    [anon_sym_throw] = ACTIONS(336),
    [anon_sym_while] = ACTIONS(338),
    [anon_sym_do] = ACTIONS(340),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_foreach] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(348),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(350),
    [sym_heredoc] = ACTIONS(264),
  },
  [10] = {
    [sym_text_interpolation] = STATE(10),
    [sym_empty_statement] = STATE(318),
    [sym_function_static_declaration] = STATE(318),
    [sym_global_declaration] = STATE(318),
    [sym_namespace_definition] = STATE(318),
    [sym_namespace_use_declaration] = STATE(318),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(318),
    [sym_interface_declaration] = STATE(318),
    [sym_class_declaration] = STATE(318),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(318),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(318),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(318),
    [sym_unset_statement] = STATE(318),
    [sym_declare_statement] = STATE(318),
    [sym_try_statement] = STATE(318),
    [sym__jump_statement] = STATE(318),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(318),
    [sym_do_statement] = STATE(318),
    [sym_for_statement] = STATE(318),
    [sym_foreach_statement] = STATE(318),
    [sym_if_statement] = STATE(318),
    [sym_colon_block] = STATE(1313),
    [sym_switch_statement] = STATE(318),
    [sym_compound_statement] = STATE(318),
    [sym_named_label_statement] = STATE(318),
    [sym_expression_statement] = STATE(318),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(352),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(320),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(354),
    [sym_heredoc] = ACTIONS(264),
  },
  [11] = {
    [sym_text_interpolation] = STATE(11),
    [sym_empty_statement] = STATE(1001),
    [sym_function_static_declaration] = STATE(1001),
    [sym_global_declaration] = STATE(1001),
    [sym_namespace_definition] = STATE(1001),
    [sym_namespace_use_declaration] = STATE(1001),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(1001),
    [sym_interface_declaration] = STATE(1001),
    [sym_class_declaration] = STATE(1001),
    [sym_class_modifier] = STATE(1385),
    [sym_const_declaration] = STATE(1001),
    [sym_visibility_modifier] = STATE(1386),
    [sym_function_definition] = STATE(1001),
    [sym__function_definition_header] = STATE(1201),
    [sym_echo_statement] = STATE(1001),
    [sym_unset_statement] = STATE(1001),
    [sym_declare_statement] = STATE(1001),
    [sym_try_statement] = STATE(1001),
    [sym__jump_statement] = STATE(1001),
    [sym_goto_statement] = STATE(1124),
    [sym_continue_statement] = STATE(1124),
    [sym_break_statement] = STATE(1124),
    [sym_return_statement] = STATE(1124),
    [sym_throw_statement] = STATE(1124),
    [sym_while_statement] = STATE(1001),
    [sym_do_statement] = STATE(1001),
    [sym_for_statement] = STATE(1001),
    [sym_foreach_statement] = STATE(1001),
    [sym_if_statement] = STATE(1001),
    [sym_colon_block] = STATE(1359),
    [sym_switch_statement] = STATE(1001),
    [sym_compound_statement] = STATE(1001),
    [sym_named_label_statement] = STATE(1001),
    [sym_expression_statement] = STATE(1001),
    [sym__expression] = STATE(654),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(296),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(356),
    [anon_sym_static] = ACTIONS(300),
    [anon_sym_global] = ACTIONS(302),
    [anon_sym_namespace] = ACTIONS(304),
    [anon_sym_use] = ACTIONS(306),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(308),
    [anon_sym_LBRACE] = ACTIONS(310),
    [anon_sym_trait] = ACTIONS(312),
    [anon_sym_interface] = ACTIONS(314),
    [anon_sym_class] = ACTIONS(316),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(318),
    [anon_sym_COLON] = ACTIONS(320),
    [anon_sym_echo] = ACTIONS(322),
    [anon_sym_declare] = ACTIONS(324),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(326),
    [anon_sym_goto] = ACTIONS(328),
    [anon_sym_continue] = ACTIONS(330),
    [anon_sym_break] = ACTIONS(332),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(334),
    [anon_sym_throw] = ACTIONS(336),
    [anon_sym_while] = ACTIONS(338),
    [anon_sym_do] = ACTIONS(340),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_foreach] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(348),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(358),
    [sym_heredoc] = ACTIONS(264),
  },
  [12] = {
    [sym_text_interpolation] = STATE(12),
    [sym_empty_statement] = STATE(301),
    [sym_function_static_declaration] = STATE(301),
    [sym_global_declaration] = STATE(301),
    [sym_namespace_definition] = STATE(301),
    [sym_namespace_use_declaration] = STATE(301),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(301),
    [sym_interface_declaration] = STATE(301),
    [sym_class_declaration] = STATE(301),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(301),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(301),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(301),
    [sym_unset_statement] = STATE(301),
    [sym_declare_statement] = STATE(301),
    [sym_try_statement] = STATE(301),
    [sym__jump_statement] = STATE(301),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(301),
    [sym_do_statement] = STATE(301),
    [sym_for_statement] = STATE(301),
    [sym_foreach_statement] = STATE(301),
    [sym_if_statement] = STATE(301),
    [sym_colon_block] = STATE(1334),
    [sym_switch_statement] = STATE(301),
    [sym_compound_statement] = STATE(301),
    [sym_named_label_statement] = STATE(301),
    [sym_expression_statement] = STATE(301),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(360),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(320),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(362),
    [sym_heredoc] = ACTIONS(264),
  },
  [13] = {
    [sym_text_interpolation] = STATE(13),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(364),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [14] = {
    [sym_text_interpolation] = STATE(14),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(366),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [15] = {
    [sym_text_interpolation] = STATE(15),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(16),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(368),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [16] = {
    [sym_text_interpolation] = STATE(16),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(370),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [17] = {
    [sym_text_interpolation] = STATE(17),
    [sym_empty_statement] = STATE(1035),
    [sym_function_static_declaration] = STATE(1035),
    [sym_global_declaration] = STATE(1035),
    [sym_namespace_definition] = STATE(1035),
    [sym_namespace_use_declaration] = STATE(1035),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(1035),
    [sym_interface_declaration] = STATE(1035),
    [sym_class_declaration] = STATE(1035),
    [sym_class_modifier] = STATE(1385),
    [sym_const_declaration] = STATE(1035),
    [sym_visibility_modifier] = STATE(1386),
    [sym_function_definition] = STATE(1035),
    [sym__function_definition_header] = STATE(1201),
    [sym_echo_statement] = STATE(1035),
    [sym_unset_statement] = STATE(1035),
    [sym_declare_statement] = STATE(1035),
    [sym_try_statement] = STATE(1035),
    [sym__jump_statement] = STATE(1035),
    [sym_goto_statement] = STATE(1124),
    [sym_continue_statement] = STATE(1124),
    [sym_break_statement] = STATE(1124),
    [sym_return_statement] = STATE(1124),
    [sym_throw_statement] = STATE(1124),
    [sym_while_statement] = STATE(1035),
    [sym_do_statement] = STATE(1035),
    [sym_for_statement] = STATE(1035),
    [sym_foreach_statement] = STATE(1035),
    [sym_if_statement] = STATE(1035),
    [sym_switch_statement] = STATE(1035),
    [sym_compound_statement] = STATE(1035),
    [sym_named_label_statement] = STATE(1035),
    [sym_expression_statement] = STATE(1035),
    [sym__expression] = STATE(654),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(296),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(372),
    [anon_sym_static] = ACTIONS(300),
    [anon_sym_global] = ACTIONS(302),
    [anon_sym_namespace] = ACTIONS(304),
    [anon_sym_use] = ACTIONS(306),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(308),
    [anon_sym_LBRACE] = ACTIONS(310),
    [anon_sym_trait] = ACTIONS(312),
    [anon_sym_interface] = ACTIONS(314),
    [anon_sym_class] = ACTIONS(316),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(318),
    [anon_sym_COLON] = ACTIONS(374),
    [anon_sym_echo] = ACTIONS(322),
    [anon_sym_declare] = ACTIONS(324),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(326),
    [anon_sym_goto] = ACTIONS(328),
    [anon_sym_continue] = ACTIONS(330),
    [anon_sym_break] = ACTIONS(332),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(334),
    [anon_sym_throw] = ACTIONS(336),
    [anon_sym_while] = ACTIONS(338),
    [anon_sym_do] = ACTIONS(340),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_foreach] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(348),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(376),
    [sym_heredoc] = ACTIONS(264),
  },
  [18] = {
    [sym_text_interpolation] = STATE(18),
    [sym_empty_statement] = STATE(983),
    [sym_function_static_declaration] = STATE(983),
    [sym_global_declaration] = STATE(983),
    [sym_namespace_definition] = STATE(983),
    [sym_namespace_use_declaration] = STATE(983),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(983),
    [sym_interface_declaration] = STATE(983),
    [sym_class_declaration] = STATE(983),
    [sym_class_modifier] = STATE(1385),
    [sym_const_declaration] = STATE(983),
    [sym_visibility_modifier] = STATE(1386),
    [sym_function_definition] = STATE(983),
    [sym__function_definition_header] = STATE(1201),
    [sym_echo_statement] = STATE(983),
    [sym_unset_statement] = STATE(983),
    [sym_declare_statement] = STATE(983),
    [sym_try_statement] = STATE(983),
    [sym__jump_statement] = STATE(983),
    [sym_goto_statement] = STATE(1124),
    [sym_continue_statement] = STATE(1124),
    [sym_break_statement] = STATE(1124),
    [sym_return_statement] = STATE(1124),
    [sym_throw_statement] = STATE(1124),
    [sym_while_statement] = STATE(983),
    [sym_do_statement] = STATE(983),
    [sym_for_statement] = STATE(983),
    [sym_foreach_statement] = STATE(983),
    [sym_if_statement] = STATE(983),
    [sym_switch_statement] = STATE(983),
    [sym_compound_statement] = STATE(983),
    [sym_named_label_statement] = STATE(983),
    [sym_expression_statement] = STATE(983),
    [sym__expression] = STATE(654),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(296),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(378),
    [anon_sym_static] = ACTIONS(300),
    [anon_sym_global] = ACTIONS(302),
    [anon_sym_namespace] = ACTIONS(304),
    [anon_sym_use] = ACTIONS(306),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(308),
    [anon_sym_LBRACE] = ACTIONS(310),
    [anon_sym_trait] = ACTIONS(312),
    [anon_sym_interface] = ACTIONS(314),
    [anon_sym_class] = ACTIONS(316),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(318),
    [anon_sym_COLON] = ACTIONS(380),
    [anon_sym_echo] = ACTIONS(322),
    [anon_sym_declare] = ACTIONS(324),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(326),
    [anon_sym_goto] = ACTIONS(328),
    [anon_sym_continue] = ACTIONS(330),
    [anon_sym_break] = ACTIONS(332),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(334),
    [anon_sym_throw] = ACTIONS(336),
    [anon_sym_while] = ACTIONS(338),
    [anon_sym_do] = ACTIONS(340),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_foreach] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(348),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(382),
    [sym_heredoc] = ACTIONS(264),
  },
  [19] = {
    [sym_text_interpolation] = STATE(19),
    [sym_empty_statement] = STATE(246),
    [sym_function_static_declaration] = STATE(246),
    [sym_global_declaration] = STATE(246),
    [sym_namespace_definition] = STATE(246),
    [sym_namespace_use_declaration] = STATE(246),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(246),
    [sym_interface_declaration] = STATE(246),
    [sym_class_declaration] = STATE(246),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(246),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(246),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(246),
    [sym_unset_statement] = STATE(246),
    [sym_declare_statement] = STATE(246),
    [sym_try_statement] = STATE(246),
    [sym__jump_statement] = STATE(246),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(246),
    [sym_do_statement] = STATE(246),
    [sym_for_statement] = STATE(246),
    [sym_foreach_statement] = STATE(246),
    [sym_if_statement] = STATE(246),
    [sym_switch_statement] = STATE(246),
    [sym_compound_statement] = STATE(246),
    [sym_named_label_statement] = STATE(246),
    [sym_expression_statement] = STATE(246),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(384),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(386),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(388),
    [sym_heredoc] = ACTIONS(264),
  },
  [20] = {
    [sym_text_interpolation] = STATE(20),
    [sym_empty_statement] = STATE(322),
    [sym_function_static_declaration] = STATE(322),
    [sym_global_declaration] = STATE(322),
    [sym_namespace_definition] = STATE(322),
    [sym_namespace_use_declaration] = STATE(322),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(322),
    [sym_interface_declaration] = STATE(322),
    [sym_class_declaration] = STATE(322),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(322),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(322),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(322),
    [sym_unset_statement] = STATE(322),
    [sym_declare_statement] = STATE(322),
    [sym_try_statement] = STATE(322),
    [sym__jump_statement] = STATE(322),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(322),
    [sym_do_statement] = STATE(322),
    [sym_for_statement] = STATE(322),
    [sym_foreach_statement] = STATE(322),
    [sym_if_statement] = STATE(322),
    [sym_switch_statement] = STATE(322),
    [sym_compound_statement] = STATE(322),
    [sym_named_label_statement] = STATE(322),
    [sym_expression_statement] = STATE(322),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(390),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(392),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(394),
    [sym_heredoc] = ACTIONS(264),
  },
  [21] = {
    [sym_text_interpolation] = STATE(21),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(56),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(396),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [22] = {
    [sym_text_interpolation] = STATE(22),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(398),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [23] = {
    [sym_text_interpolation] = STATE(23),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(44),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [anon_sym_enddeclare] = ACTIONS(400),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [24] = {
    [sym_text_interpolation] = STATE(24),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(26),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(398),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [25] = {
    [sym_text_interpolation] = STATE(25),
    [sym_empty_statement] = STATE(300),
    [sym_function_static_declaration] = STATE(300),
    [sym_global_declaration] = STATE(300),
    [sym_namespace_definition] = STATE(300),
    [sym_namespace_use_declaration] = STATE(300),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(300),
    [sym_interface_declaration] = STATE(300),
    [sym_class_declaration] = STATE(300),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(300),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(300),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(300),
    [sym_unset_statement] = STATE(300),
    [sym_declare_statement] = STATE(300),
    [sym_try_statement] = STATE(300),
    [sym__jump_statement] = STATE(300),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(300),
    [sym_do_statement] = STATE(300),
    [sym_for_statement] = STATE(300),
    [sym_foreach_statement] = STATE(300),
    [sym_if_statement] = STATE(300),
    [sym_switch_statement] = STATE(300),
    [sym_compound_statement] = STATE(300),
    [sym_named_label_statement] = STATE(300),
    [sym_expression_statement] = STATE(300),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(402),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(404),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(406),
    [sym_heredoc] = ACTIONS(264),
  },
  [26] = {
    [sym_text_interpolation] = STATE(26),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(408),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [27] = {
    [sym_text_interpolation] = STATE(27),
    [sym_empty_statement] = STATE(997),
    [sym_function_static_declaration] = STATE(997),
    [sym_global_declaration] = STATE(997),
    [sym_namespace_definition] = STATE(997),
    [sym_namespace_use_declaration] = STATE(997),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(997),
    [sym_interface_declaration] = STATE(997),
    [sym_class_declaration] = STATE(997),
    [sym_class_modifier] = STATE(1385),
    [sym_const_declaration] = STATE(997),
    [sym_visibility_modifier] = STATE(1386),
    [sym_function_definition] = STATE(997),
    [sym__function_definition_header] = STATE(1201),
    [sym_echo_statement] = STATE(997),
    [sym_unset_statement] = STATE(997),
    [sym_declare_statement] = STATE(997),
    [sym_try_statement] = STATE(997),
    [sym__jump_statement] = STATE(997),
    [sym_goto_statement] = STATE(1124),
    [sym_continue_statement] = STATE(1124),
    [sym_break_statement] = STATE(1124),
    [sym_return_statement] = STATE(1124),
    [sym_throw_statement] = STATE(1124),
    [sym_while_statement] = STATE(997),
    [sym_do_statement] = STATE(997),
    [sym_for_statement] = STATE(997),
    [sym_foreach_statement] = STATE(997),
    [sym_if_statement] = STATE(997),
    [sym_switch_statement] = STATE(997),
    [sym_compound_statement] = STATE(997),
    [sym_named_label_statement] = STATE(997),
    [sym_expression_statement] = STATE(997),
    [sym__expression] = STATE(654),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(296),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(410),
    [anon_sym_static] = ACTIONS(300),
    [anon_sym_global] = ACTIONS(302),
    [anon_sym_namespace] = ACTIONS(304),
    [anon_sym_use] = ACTIONS(306),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(308),
    [anon_sym_LBRACE] = ACTIONS(310),
    [anon_sym_trait] = ACTIONS(312),
    [anon_sym_interface] = ACTIONS(314),
    [anon_sym_class] = ACTIONS(316),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(318),
    [anon_sym_COLON] = ACTIONS(412),
    [anon_sym_echo] = ACTIONS(322),
    [anon_sym_declare] = ACTIONS(324),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(326),
    [anon_sym_goto] = ACTIONS(328),
    [anon_sym_continue] = ACTIONS(330),
    [anon_sym_break] = ACTIONS(332),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(334),
    [anon_sym_throw] = ACTIONS(336),
    [anon_sym_while] = ACTIONS(338),
    [anon_sym_do] = ACTIONS(340),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_foreach] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(348),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(414),
    [sym_heredoc] = ACTIONS(264),
  },
  [28] = {
    [sym_text_interpolation] = STATE(28),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(36),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(408),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [29] = {
    [sym_text_interpolation] = STATE(29),
    [sym_empty_statement] = STATE(1006),
    [sym_function_static_declaration] = STATE(1006),
    [sym_global_declaration] = STATE(1006),
    [sym_namespace_definition] = STATE(1006),
    [sym_namespace_use_declaration] = STATE(1006),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(1006),
    [sym_interface_declaration] = STATE(1006),
    [sym_class_declaration] = STATE(1006),
    [sym_class_modifier] = STATE(1385),
    [sym_const_declaration] = STATE(1006),
    [sym_visibility_modifier] = STATE(1386),
    [sym_function_definition] = STATE(1006),
    [sym__function_definition_header] = STATE(1201),
    [sym_echo_statement] = STATE(1006),
    [sym_unset_statement] = STATE(1006),
    [sym_declare_statement] = STATE(1006),
    [sym_try_statement] = STATE(1006),
    [sym__jump_statement] = STATE(1006),
    [sym_goto_statement] = STATE(1124),
    [sym_continue_statement] = STATE(1124),
    [sym_break_statement] = STATE(1124),
    [sym_return_statement] = STATE(1124),
    [sym_throw_statement] = STATE(1124),
    [sym_while_statement] = STATE(1006),
    [sym_do_statement] = STATE(1006),
    [sym_for_statement] = STATE(1006),
    [sym_foreach_statement] = STATE(1006),
    [sym_if_statement] = STATE(1006),
    [sym_switch_statement] = STATE(1006),
    [sym_compound_statement] = STATE(1006),
    [sym_named_label_statement] = STATE(1006),
    [sym_expression_statement] = STATE(1006),
    [sym__expression] = STATE(654),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(296),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym_static] = ACTIONS(300),
    [anon_sym_global] = ACTIONS(302),
    [anon_sym_namespace] = ACTIONS(304),
    [anon_sym_use] = ACTIONS(306),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(308),
    [anon_sym_LBRACE] = ACTIONS(310),
    [anon_sym_trait] = ACTIONS(312),
    [anon_sym_interface] = ACTIONS(314),
    [anon_sym_class] = ACTIONS(316),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(318),
    [anon_sym_COLON] = ACTIONS(418),
    [anon_sym_echo] = ACTIONS(322),
    [anon_sym_declare] = ACTIONS(324),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(326),
    [anon_sym_goto] = ACTIONS(328),
    [anon_sym_continue] = ACTIONS(330),
    [anon_sym_break] = ACTIONS(332),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(334),
    [anon_sym_throw] = ACTIONS(336),
    [anon_sym_while] = ACTIONS(338),
    [anon_sym_do] = ACTIONS(340),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_foreach] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(348),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(420),
    [sym_heredoc] = ACTIONS(264),
  },
  [30] = {
    [sym_text_interpolation] = STATE(30),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(35),
    [ts_builtin_sym_end] = ACTIONS(422),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [31] = {
    [sym_text_interpolation] = STATE(31),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(422),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [32] = {
    [sym_text_interpolation] = STATE(32),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(424),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [33] = {
    [sym_text_interpolation] = STATE(33),
    [sym_empty_statement] = STATE(108),
    [sym_function_static_declaration] = STATE(108),
    [sym_global_declaration] = STATE(108),
    [sym_namespace_definition] = STATE(108),
    [sym_namespace_use_declaration] = STATE(108),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(108),
    [sym_interface_declaration] = STATE(108),
    [sym_class_declaration] = STATE(108),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(108),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(108),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(108),
    [sym_unset_statement] = STATE(108),
    [sym_declare_statement] = STATE(108),
    [sym_try_statement] = STATE(108),
    [sym__jump_statement] = STATE(108),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(108),
    [sym_do_statement] = STATE(108),
    [sym_for_statement] = STATE(108),
    [sym_foreach_statement] = STATE(108),
    [sym_if_statement] = STATE(108),
    [sym_colon_block] = STATE(824),
    [sym_switch_statement] = STATE(108),
    [sym_compound_statement] = STATE(108),
    [sym_named_label_statement] = STATE(108),
    [sym_expression_statement] = STATE(108),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(320),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [34] = {
    [sym_text_interpolation] = STATE(34),
    [sym_empty_statement] = STATE(1011),
    [sym_function_static_declaration] = STATE(1011),
    [sym_global_declaration] = STATE(1011),
    [sym_namespace_definition] = STATE(1011),
    [sym_namespace_use_declaration] = STATE(1011),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(1011),
    [sym_interface_declaration] = STATE(1011),
    [sym_class_declaration] = STATE(1011),
    [sym_class_modifier] = STATE(1385),
    [sym_const_declaration] = STATE(1011),
    [sym_visibility_modifier] = STATE(1386),
    [sym_function_definition] = STATE(1011),
    [sym__function_definition_header] = STATE(1201),
    [sym_echo_statement] = STATE(1011),
    [sym_unset_statement] = STATE(1011),
    [sym_declare_statement] = STATE(1011),
    [sym_try_statement] = STATE(1011),
    [sym__jump_statement] = STATE(1011),
    [sym_goto_statement] = STATE(1124),
    [sym_continue_statement] = STATE(1124),
    [sym_break_statement] = STATE(1124),
    [sym_return_statement] = STATE(1124),
    [sym_throw_statement] = STATE(1124),
    [sym_while_statement] = STATE(1011),
    [sym_do_statement] = STATE(1011),
    [sym_for_statement] = STATE(1011),
    [sym_foreach_statement] = STATE(1011),
    [sym_if_statement] = STATE(1011),
    [sym_switch_statement] = STATE(1011),
    [sym_compound_statement] = STATE(1011),
    [sym_named_label_statement] = STATE(1011),
    [sym_expression_statement] = STATE(1011),
    [sym__expression] = STATE(654),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(296),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(426),
    [anon_sym_static] = ACTIONS(300),
    [anon_sym_global] = ACTIONS(302),
    [anon_sym_namespace] = ACTIONS(304),
    [anon_sym_use] = ACTIONS(306),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(308),
    [anon_sym_LBRACE] = ACTIONS(310),
    [anon_sym_trait] = ACTIONS(312),
    [anon_sym_interface] = ACTIONS(314),
    [anon_sym_class] = ACTIONS(316),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(318),
    [anon_sym_COLON] = ACTIONS(428),
    [anon_sym_echo] = ACTIONS(322),
    [anon_sym_declare] = ACTIONS(324),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(326),
    [anon_sym_goto] = ACTIONS(328),
    [anon_sym_continue] = ACTIONS(330),
    [anon_sym_break] = ACTIONS(332),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(334),
    [anon_sym_throw] = ACTIONS(336),
    [anon_sym_while] = ACTIONS(338),
    [anon_sym_do] = ACTIONS(340),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_foreach] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(348),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(430),
    [sym_heredoc] = ACTIONS(264),
  },
  [35] = {
    [sym_text_interpolation] = STATE(35),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(432),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [36] = {
    [sym_text_interpolation] = STATE(36),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(434),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [37] = {
    [sym_text_interpolation] = STATE(37),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(13),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(366),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [38] = {
    [sym_text_interpolation] = STATE(38),
    [sym_empty_statement] = STATE(842),
    [sym_function_static_declaration] = STATE(842),
    [sym_global_declaration] = STATE(842),
    [sym_namespace_definition] = STATE(842),
    [sym_namespace_use_declaration] = STATE(842),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(842),
    [sym_interface_declaration] = STATE(842),
    [sym_class_declaration] = STATE(842),
    [sym_class_modifier] = STATE(1385),
    [sym_const_declaration] = STATE(842),
    [sym_visibility_modifier] = STATE(1386),
    [sym_function_definition] = STATE(842),
    [sym__function_definition_header] = STATE(1201),
    [sym_echo_statement] = STATE(842),
    [sym_unset_statement] = STATE(842),
    [sym_declare_statement] = STATE(842),
    [sym_try_statement] = STATE(842),
    [sym__jump_statement] = STATE(842),
    [sym_goto_statement] = STATE(1124),
    [sym_continue_statement] = STATE(1124),
    [sym_break_statement] = STATE(1124),
    [sym_return_statement] = STATE(1124),
    [sym_throw_statement] = STATE(1124),
    [sym_while_statement] = STATE(842),
    [sym_do_statement] = STATE(842),
    [sym_for_statement] = STATE(842),
    [sym_foreach_statement] = STATE(842),
    [sym_if_statement] = STATE(842),
    [sym_colon_block] = STATE(840),
    [sym_switch_statement] = STATE(842),
    [sym_compound_statement] = STATE(842),
    [sym_named_label_statement] = STATE(842),
    [sym_expression_statement] = STATE(842),
    [sym__expression] = STATE(654),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(296),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(436),
    [anon_sym_static] = ACTIONS(300),
    [anon_sym_global] = ACTIONS(302),
    [anon_sym_namespace] = ACTIONS(304),
    [anon_sym_use] = ACTIONS(306),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(308),
    [anon_sym_LBRACE] = ACTIONS(310),
    [anon_sym_trait] = ACTIONS(312),
    [anon_sym_interface] = ACTIONS(314),
    [anon_sym_class] = ACTIONS(316),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(318),
    [anon_sym_COLON] = ACTIONS(320),
    [anon_sym_echo] = ACTIONS(322),
    [anon_sym_declare] = ACTIONS(324),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(326),
    [anon_sym_goto] = ACTIONS(328),
    [anon_sym_continue] = ACTIONS(330),
    [anon_sym_break] = ACTIONS(332),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(334),
    [anon_sym_throw] = ACTIONS(336),
    [anon_sym_while] = ACTIONS(338),
    [anon_sym_do] = ACTIONS(340),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_foreach] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(348),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [39] = {
    [sym_text_interpolation] = STATE(39),
    [sym_empty_statement] = STATE(309),
    [sym_function_static_declaration] = STATE(309),
    [sym_global_declaration] = STATE(309),
    [sym_namespace_definition] = STATE(309),
    [sym_namespace_use_declaration] = STATE(309),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(309),
    [sym_interface_declaration] = STATE(309),
    [sym_class_declaration] = STATE(309),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(309),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(309),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(309),
    [sym_unset_statement] = STATE(309),
    [sym_declare_statement] = STATE(309),
    [sym_try_statement] = STATE(309),
    [sym__jump_statement] = STATE(309),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(309),
    [sym_do_statement] = STATE(309),
    [sym_for_statement] = STATE(309),
    [sym_foreach_statement] = STATE(309),
    [sym_if_statement] = STATE(309),
    [sym_switch_statement] = STATE(309),
    [sym_compound_statement] = STATE(309),
    [sym_named_label_statement] = STATE(309),
    [sym_expression_statement] = STATE(309),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(440),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(442),
    [sym_heredoc] = ACTIONS(264),
  },
  [40] = {
    [sym_text_interpolation] = STATE(40),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(14),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(444),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [41] = {
    [sym_text_interpolation] = STATE(41),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(444),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [42] = {
    [sym_text_interpolation] = STATE(42),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(41),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(446),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [43] = {
    [sym_text_interpolation] = STATE(43),
    [sym_empty_statement] = STATE(1112),
    [sym_function_static_declaration] = STATE(1112),
    [sym_global_declaration] = STATE(1112),
    [sym_namespace_definition] = STATE(1112),
    [sym_namespace_use_declaration] = STATE(1112),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(1112),
    [sym_interface_declaration] = STATE(1112),
    [sym_class_declaration] = STATE(1112),
    [sym_class_modifier] = STATE(1385),
    [sym_const_declaration] = STATE(1112),
    [sym_visibility_modifier] = STATE(1386),
    [sym_function_definition] = STATE(1112),
    [sym__function_definition_header] = STATE(1201),
    [sym_echo_statement] = STATE(1112),
    [sym_unset_statement] = STATE(1112),
    [sym_declare_statement] = STATE(1112),
    [sym_try_statement] = STATE(1112),
    [sym__jump_statement] = STATE(1112),
    [sym_goto_statement] = STATE(1124),
    [sym_continue_statement] = STATE(1124),
    [sym_break_statement] = STATE(1124),
    [sym_return_statement] = STATE(1124),
    [sym_throw_statement] = STATE(1124),
    [sym_while_statement] = STATE(1112),
    [sym_do_statement] = STATE(1112),
    [sym_for_statement] = STATE(1112),
    [sym_foreach_statement] = STATE(1112),
    [sym_if_statement] = STATE(1112),
    [sym_colon_block] = STATE(1328),
    [sym_switch_statement] = STATE(1112),
    [sym_compound_statement] = STATE(1112),
    [sym_named_label_statement] = STATE(1112),
    [sym_expression_statement] = STATE(1112),
    [sym__expression] = STATE(654),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(296),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(436),
    [anon_sym_static] = ACTIONS(300),
    [anon_sym_global] = ACTIONS(302),
    [anon_sym_namespace] = ACTIONS(304),
    [anon_sym_use] = ACTIONS(306),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(308),
    [anon_sym_LBRACE] = ACTIONS(310),
    [anon_sym_trait] = ACTIONS(312),
    [anon_sym_interface] = ACTIONS(314),
    [anon_sym_class] = ACTIONS(316),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(318),
    [anon_sym_COLON] = ACTIONS(320),
    [anon_sym_echo] = ACTIONS(322),
    [anon_sym_declare] = ACTIONS(324),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(326),
    [anon_sym_goto] = ACTIONS(328),
    [anon_sym_continue] = ACTIONS(330),
    [anon_sym_break] = ACTIONS(332),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(334),
    [anon_sym_throw] = ACTIONS(336),
    [anon_sym_while] = ACTIONS(338),
    [anon_sym_do] = ACTIONS(340),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_foreach] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(348),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [44] = {
    [sym_text_interpolation] = STATE(44),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [anon_sym_enddeclare] = ACTIONS(448),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [45] = {
    [sym_text_interpolation] = STATE(45),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(32),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(450),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [46] = {
    [sym_text_interpolation] = STATE(46),
    [sym_empty_statement] = STATE(289),
    [sym_function_static_declaration] = STATE(289),
    [sym_global_declaration] = STATE(289),
    [sym_namespace_definition] = STATE(289),
    [sym_namespace_use_declaration] = STATE(289),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(289),
    [sym_interface_declaration] = STATE(289),
    [sym_class_declaration] = STATE(289),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(289),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(289),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(289),
    [sym_unset_statement] = STATE(289),
    [sym_declare_statement] = STATE(289),
    [sym_try_statement] = STATE(289),
    [sym__jump_statement] = STATE(289),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(289),
    [sym_do_statement] = STATE(289),
    [sym_for_statement] = STATE(289),
    [sym_foreach_statement] = STATE(289),
    [sym_if_statement] = STATE(289),
    [sym_colon_block] = STATE(1374),
    [sym_switch_statement] = STATE(289),
    [sym_compound_statement] = STATE(289),
    [sym_named_label_statement] = STATE(289),
    [sym_expression_statement] = STATE(289),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(320),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [47] = {
    [sym_text_interpolation] = STATE(47),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(446),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [48] = {
    [sym_text_interpolation] = STATE(48),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(51),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(452),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [49] = {
    [sym_text_interpolation] = STATE(49),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(47),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(454),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [50] = {
    [sym_text_interpolation] = STATE(50),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [anon_sym_enddeclare] = ACTIONS(456),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [51] = {
    [sym_text_interpolation] = STATE(51),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(458),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [52] = {
    [sym_text_interpolation] = STATE(52),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(22),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_endfor] = ACTIONS(424),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [53] = {
    [sym_text_interpolation] = STATE(53),
    [sym_empty_statement] = STATE(291),
    [sym_function_static_declaration] = STATE(291),
    [sym_global_declaration] = STATE(291),
    [sym_namespace_definition] = STATE(291),
    [sym_namespace_use_declaration] = STATE(291),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(291),
    [sym_interface_declaration] = STATE(291),
    [sym_class_declaration] = STATE(291),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(291),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(291),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(291),
    [sym_unset_statement] = STATE(291),
    [sym_declare_statement] = STATE(291),
    [sym_try_statement] = STATE(291),
    [sym__jump_statement] = STATE(291),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(291),
    [sym_do_statement] = STATE(291),
    [sym_for_statement] = STATE(291),
    [sym_foreach_statement] = STATE(291),
    [sym_if_statement] = STATE(291),
    [sym_switch_statement] = STATE(291),
    [sym_compound_statement] = STATE(291),
    [sym_named_label_statement] = STATE(291),
    [sym_expression_statement] = STATE(291),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(460),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_COLON] = ACTIONS(462),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(464),
    [sym_heredoc] = ACTIONS(264),
  },
  [54] = {
    [sym_text_interpolation] = STATE(54),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(31),
    [ts_builtin_sym_end] = ACTIONS(466),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [55] = {
    [sym_text_interpolation] = STATE(55),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(50),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [anon_sym_enddeclare] = ACTIONS(468),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [56] = {
    [sym_text_interpolation] = STATE(56),
    [sym_empty_statement] = STATE(271),
    [sym_function_static_declaration] = STATE(271),
    [sym_global_declaration] = STATE(271),
    [sym_namespace_definition] = STATE(271),
    [sym_namespace_use_declaration] = STATE(271),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(271),
    [sym_interface_declaration] = STATE(271),
    [sym_class_declaration] = STATE(271),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(271),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(271),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(271),
    [sym_unset_statement] = STATE(271),
    [sym_declare_statement] = STATE(271),
    [sym_try_statement] = STATE(271),
    [sym__jump_statement] = STATE(271),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(271),
    [sym_do_statement] = STATE(271),
    [sym_for_statement] = STATE(271),
    [sym_foreach_statement] = STATE(271),
    [sym_if_statement] = STATE(271),
    [sym_switch_statement] = STATE(271),
    [sym_compound_statement] = STATE(271),
    [sym_named_label_statement] = STATE(271),
    [sym_expression_statement] = STATE(271),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [aux_sym_program_repeat1] = STATE(2),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_RBRACE] = ACTIONS(470),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [57] = {
    [sym_text_interpolation] = STATE(57),
    [sym_empty_statement] = STATE(263),
    [sym_function_static_declaration] = STATE(263),
    [sym_global_declaration] = STATE(263),
    [sym_namespace_definition] = STATE(263),
    [sym_namespace_use_declaration] = STATE(263),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(263),
    [sym_interface_declaration] = STATE(263),
    [sym_class_declaration] = STATE(263),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(263),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(263),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(263),
    [sym_unset_statement] = STATE(263),
    [sym_declare_statement] = STATE(263),
    [sym_try_statement] = STATE(263),
    [sym__jump_statement] = STATE(263),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(263),
    [sym_do_statement] = STATE(263),
    [sym_for_statement] = STATE(263),
    [sym_foreach_statement] = STATE(263),
    [sym_if_statement] = STATE(263),
    [sym_switch_statement] = STATE(263),
    [sym_compound_statement] = STATE(263),
    [sym_named_label_statement] = STATE(263),
    [sym_expression_statement] = STATE(263),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [58] = {
    [sym_text_interpolation] = STATE(58),
    [sym_empty_statement] = STATE(1029),
    [sym_function_static_declaration] = STATE(1029),
    [sym_global_declaration] = STATE(1029),
    [sym_namespace_definition] = STATE(1029),
    [sym_namespace_use_declaration] = STATE(1029),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(1029),
    [sym_interface_declaration] = STATE(1029),
    [sym_class_declaration] = STATE(1029),
    [sym_class_modifier] = STATE(1385),
    [sym_const_declaration] = STATE(1029),
    [sym_visibility_modifier] = STATE(1386),
    [sym_function_definition] = STATE(1029),
    [sym__function_definition_header] = STATE(1201),
    [sym_echo_statement] = STATE(1029),
    [sym_unset_statement] = STATE(1029),
    [sym_declare_statement] = STATE(1029),
    [sym_try_statement] = STATE(1029),
    [sym__jump_statement] = STATE(1029),
    [sym_goto_statement] = STATE(1124),
    [sym_continue_statement] = STATE(1124),
    [sym_break_statement] = STATE(1124),
    [sym_return_statement] = STATE(1124),
    [sym_throw_statement] = STATE(1124),
    [sym_while_statement] = STATE(1029),
    [sym_do_statement] = STATE(1029),
    [sym_for_statement] = STATE(1029),
    [sym_foreach_statement] = STATE(1029),
    [sym_if_statement] = STATE(1029),
    [sym_switch_statement] = STATE(1029),
    [sym_compound_statement] = STATE(1029),
    [sym_named_label_statement] = STATE(1029),
    [sym_expression_statement] = STATE(1029),
    [sym__expression] = STATE(654),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(296),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(436),
    [anon_sym_static] = ACTIONS(300),
    [anon_sym_global] = ACTIONS(302),
    [anon_sym_namespace] = ACTIONS(304),
    [anon_sym_use] = ACTIONS(306),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(308),
    [anon_sym_LBRACE] = ACTIONS(310),
    [anon_sym_trait] = ACTIONS(312),
    [anon_sym_interface] = ACTIONS(314),
    [anon_sym_class] = ACTIONS(316),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(318),
    [anon_sym_echo] = ACTIONS(322),
    [anon_sym_declare] = ACTIONS(324),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(326),
    [anon_sym_goto] = ACTIONS(328),
    [anon_sym_continue] = ACTIONS(330),
    [anon_sym_break] = ACTIONS(332),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(334),
    [anon_sym_throw] = ACTIONS(336),
    [anon_sym_while] = ACTIONS(338),
    [anon_sym_do] = ACTIONS(340),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_foreach] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(348),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [59] = {
    [sym_text_interpolation] = STATE(59),
    [sym_empty_statement] = STATE(1390),
    [sym_function_static_declaration] = STATE(1390),
    [sym_global_declaration] = STATE(1390),
    [sym_namespace_definition] = STATE(1390),
    [sym_namespace_use_declaration] = STATE(1390),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(1390),
    [sym_interface_declaration] = STATE(1390),
    [sym_class_declaration] = STATE(1390),
    [sym_class_modifier] = STATE(1385),
    [sym_const_declaration] = STATE(1390),
    [sym_visibility_modifier] = STATE(1386),
    [sym_function_definition] = STATE(1390),
    [sym__function_definition_header] = STATE(1201),
    [sym_echo_statement] = STATE(1390),
    [sym_unset_statement] = STATE(1390),
    [sym_declare_statement] = STATE(1390),
    [sym_try_statement] = STATE(1390),
    [sym__jump_statement] = STATE(1390),
    [sym_goto_statement] = STATE(1124),
    [sym_continue_statement] = STATE(1124),
    [sym_break_statement] = STATE(1124),
    [sym_return_statement] = STATE(1124),
    [sym_throw_statement] = STATE(1124),
    [sym_while_statement] = STATE(1390),
    [sym_do_statement] = STATE(1390),
    [sym_for_statement] = STATE(1390),
    [sym_foreach_statement] = STATE(1390),
    [sym_if_statement] = STATE(1390),
    [sym_switch_statement] = STATE(1390),
    [sym_compound_statement] = STATE(1390),
    [sym_named_label_statement] = STATE(1390),
    [sym_expression_statement] = STATE(1390),
    [sym__expression] = STATE(654),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(296),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(436),
    [anon_sym_static] = ACTIONS(300),
    [anon_sym_global] = ACTIONS(302),
    [anon_sym_namespace] = ACTIONS(304),
    [anon_sym_use] = ACTIONS(306),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(308),
    [anon_sym_LBRACE] = ACTIONS(310),
    [anon_sym_trait] = ACTIONS(312),
    [anon_sym_interface] = ACTIONS(314),
    [anon_sym_class] = ACTIONS(316),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(318),
    [anon_sym_echo] = ACTIONS(322),
    [anon_sym_declare] = ACTIONS(324),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(326),
    [anon_sym_goto] = ACTIONS(328),
    [anon_sym_continue] = ACTIONS(330),
    [anon_sym_break] = ACTIONS(332),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(334),
    [anon_sym_throw] = ACTIONS(336),
    [anon_sym_while] = ACTIONS(338),
    [anon_sym_do] = ACTIONS(340),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_foreach] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(348),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [60] = {
    [sym_text_interpolation] = STATE(60),
    [sym_empty_statement] = STATE(295),
    [sym_function_static_declaration] = STATE(295),
    [sym_global_declaration] = STATE(295),
    [sym_namespace_definition] = STATE(295),
    [sym_namespace_use_declaration] = STATE(295),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(295),
    [sym_interface_declaration] = STATE(295),
    [sym_class_declaration] = STATE(295),
    [sym_class_modifier] = STATE(1322),
    [sym_const_declaration] = STATE(295),
    [sym_visibility_modifier] = STATE(1319),
    [sym_function_definition] = STATE(295),
    [sym__function_definition_header] = STATE(1304),
    [sym_echo_statement] = STATE(295),
    [sym_unset_statement] = STATE(295),
    [sym_declare_statement] = STATE(295),
    [sym_try_statement] = STATE(295),
    [sym__jump_statement] = STATE(295),
    [sym_goto_statement] = STATE(254),
    [sym_continue_statement] = STATE(254),
    [sym_break_statement] = STATE(254),
    [sym_return_statement] = STATE(254),
    [sym_throw_statement] = STATE(254),
    [sym_while_statement] = STATE(295),
    [sym_do_statement] = STATE(295),
    [sym_for_statement] = STATE(295),
    [sym_foreach_statement] = STATE(295),
    [sym_if_statement] = STATE(295),
    [sym_switch_statement] = STATE(295),
    [sym_compound_statement] = STATE(295),
    [sym_named_label_statement] = STATE(295),
    [sym_expression_statement] = STATE(295),
    [sym__expression] = STATE(659),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(174),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(176),
    [anon_sym_static] = ACTIONS(178),
    [anon_sym_global] = ACTIONS(180),
    [anon_sym_namespace] = ACTIONS(182),
    [anon_sym_use] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(190),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_trait] = ACTIONS(194),
    [anon_sym_interface] = ACTIONS(196),
    [anon_sym_class] = ACTIONS(198),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(208),
    [anon_sym_echo] = ACTIONS(210),
    [anon_sym_declare] = ACTIONS(212),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(216),
    [anon_sym_goto] = ACTIONS(218),
    [anon_sym_continue] = ACTIONS(220),
    [anon_sym_break] = ACTIONS(222),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(224),
    [anon_sym_throw] = ACTIONS(226),
    [anon_sym_while] = ACTIONS(228),
    [anon_sym_do] = ACTIONS(232),
    [anon_sym_for] = ACTIONS(234),
    [anon_sym_foreach] = ACTIONS(236),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_switch] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [61] = {
    [sym_text_interpolation] = STATE(61),
    [sym_empty_statement] = STATE(1329),
    [sym_function_static_declaration] = STATE(1329),
    [sym_global_declaration] = STATE(1329),
    [sym_namespace_definition] = STATE(1329),
    [sym_namespace_use_declaration] = STATE(1329),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(1329),
    [sym_interface_declaration] = STATE(1329),
    [sym_class_declaration] = STATE(1329),
    [sym_class_modifier] = STATE(1385),
    [sym_const_declaration] = STATE(1329),
    [sym_visibility_modifier] = STATE(1386),
    [sym_function_definition] = STATE(1329),
    [sym__function_definition_header] = STATE(1201),
    [sym_echo_statement] = STATE(1329),
    [sym_unset_statement] = STATE(1329),
    [sym_declare_statement] = STATE(1329),
    [sym_try_statement] = STATE(1329),
    [sym__jump_statement] = STATE(1329),
    [sym_goto_statement] = STATE(1124),
    [sym_continue_statement] = STATE(1124),
    [sym_break_statement] = STATE(1124),
    [sym_return_statement] = STATE(1124),
    [sym_throw_statement] = STATE(1124),
    [sym_while_statement] = STATE(1329),
    [sym_do_statement] = STATE(1329),
    [sym_for_statement] = STATE(1329),
    [sym_foreach_statement] = STATE(1329),
    [sym_if_statement] = STATE(1329),
    [sym_switch_statement] = STATE(1329),
    [sym_compound_statement] = STATE(1329),
    [sym_named_label_statement] = STATE(1329),
    [sym_expression_statement] = STATE(1329),
    [sym__expression] = STATE(654),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(296),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(436),
    [anon_sym_static] = ACTIONS(300),
    [anon_sym_global] = ACTIONS(302),
    [anon_sym_namespace] = ACTIONS(304),
    [anon_sym_use] = ACTIONS(306),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(308),
    [anon_sym_LBRACE] = ACTIONS(310),
    [anon_sym_trait] = ACTIONS(312),
    [anon_sym_interface] = ACTIONS(314),
    [anon_sym_class] = ACTIONS(316),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(318),
    [anon_sym_echo] = ACTIONS(322),
    [anon_sym_declare] = ACTIONS(324),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(326),
    [anon_sym_goto] = ACTIONS(328),
    [anon_sym_continue] = ACTIONS(330),
    [anon_sym_break] = ACTIONS(332),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(334),
    [anon_sym_throw] = ACTIONS(336),
    [anon_sym_while] = ACTIONS(338),
    [anon_sym_do] = ACTIONS(340),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_foreach] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(348),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [62] = {
    [sym_text_interpolation] = STATE(62),
    [sym_empty_statement] = STATE(985),
    [sym_function_static_declaration] = STATE(985),
    [sym_global_declaration] = STATE(985),
    [sym_namespace_definition] = STATE(985),
    [sym_namespace_use_declaration] = STATE(985),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_trait_declaration] = STATE(985),
    [sym_interface_declaration] = STATE(985),
    [sym_class_declaration] = STATE(985),
    [sym_class_modifier] = STATE(1385),
    [sym_const_declaration] = STATE(985),
    [sym_visibility_modifier] = STATE(1386),
    [sym_function_definition] = STATE(985),
    [sym__function_definition_header] = STATE(1201),
    [sym_echo_statement] = STATE(985),
    [sym_unset_statement] = STATE(985),
    [sym_declare_statement] = STATE(985),
    [sym_try_statement] = STATE(985),
    [sym__jump_statement] = STATE(985),
    [sym_goto_statement] = STATE(1124),
    [sym_continue_statement] = STATE(1124),
    [sym_break_statement] = STATE(1124),
    [sym_return_statement] = STATE(1124),
    [sym_throw_statement] = STATE(1124),
    [sym_while_statement] = STATE(985),
    [sym_do_statement] = STATE(985),
    [sym_for_statement] = STATE(985),
    [sym_foreach_statement] = STATE(985),
    [sym_if_statement] = STATE(985),
    [sym_switch_statement] = STATE(985),
    [sym_compound_statement] = STATE(985),
    [sym_named_label_statement] = STATE(985),
    [sym_expression_statement] = STATE(985),
    [sym__expression] = STATE(654),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(296),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(436),
    [anon_sym_static] = ACTIONS(300),
    [anon_sym_global] = ACTIONS(302),
    [anon_sym_namespace] = ACTIONS(304),
    [anon_sym_use] = ACTIONS(306),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(188),
    [anon_sym_const] = ACTIONS(308),
    [anon_sym_LBRACE] = ACTIONS(310),
    [anon_sym_trait] = ACTIONS(312),
    [anon_sym_interface] = ACTIONS(314),
    [anon_sym_class] = ACTIONS(316),
    [anon_sym_abstract] = ACTIONS(200),
    [anon_sym_final] = ACTIONS(200),
    [anon_sym_public] = ACTIONS(202),
    [anon_sym_protected] = ACTIONS(202),
    [anon_sym_private] = ACTIONS(202),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [anon_sym_unset] = ACTIONS(318),
    [anon_sym_echo] = ACTIONS(322),
    [anon_sym_declare] = ACTIONS(324),
    [sym_float] = ACTIONS(214),
    [anon_sym_try] = ACTIONS(326),
    [anon_sym_goto] = ACTIONS(328),
    [anon_sym_continue] = ACTIONS(330),
    [anon_sym_break] = ACTIONS(332),
    [sym_integer] = ACTIONS(214),
    [anon_sym_return] = ACTIONS(334),
    [anon_sym_throw] = ACTIONS(336),
    [anon_sym_while] = ACTIONS(338),
    [anon_sym_do] = ACTIONS(340),
    [anon_sym_for] = ACTIONS(342),
    [anon_sym_foreach] = ACTIONS(344),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_switch] = ACTIONS(348),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [63] = {
    [sym_text_interpolation] = STATE(63),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(494),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_array_element_initializer] = STATE(543),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(474),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_as] = ACTIONS(482),
    [anon_sym_RBRACE] = ACTIONS(474),
    [anon_sym_AMP] = ACTIONS(484),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(474),
    [anon_sym_QMARK] = ACTIONS(482),
    [anon_sym_array] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(474),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_EQ_GT] = ACTIONS(474),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(494),
    [anon_sym_STAR_STAR] = ACTIONS(474),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [anon_sym_RBRACK] = ACTIONS(474),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_from] = ACTIONS(518),
    [anon_sym_instanceof] = ACTIONS(482),
    [anon_sym_QMARK_QMARK] = ACTIONS(474),
    [aux_sym_binary_expression_token1] = ACTIONS(482),
    [aux_sym_binary_expression_token2] = ACTIONS(482),
    [aux_sym_binary_expression_token3] = ACTIONS(482),
    [anon_sym_PIPE_PIPE] = ACTIONS(474),
    [anon_sym_AMP_AMP] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(482),
    [anon_sym_CARET] = ACTIONS(474),
    [anon_sym_EQ_EQ] = ACTIONS(482),
    [anon_sym_BANG_EQ] = ACTIONS(482),
    [anon_sym_LT_GT] = ACTIONS(474),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_GT] = ACTIONS(482),
    [anon_sym_LT_EQ] = ACTIONS(482),
    [anon_sym_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_EQ_GT] = ACTIONS(474),
    [anon_sym_LT_LT] = ACTIONS(474),
    [anon_sym_GT_GT] = ACTIONS(474),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_STAR] = ACTIONS(482),
    [anon_sym_SLASH] = ACTIONS(482),
    [anon_sym_PERCENT] = ACTIONS(474),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [64] = {
    [sym_text_interpolation] = STATE(64),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(581),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_array_element_initializer] = STATE(583),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_COMMA] = ACTIONS(474),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_AMP] = ACTIONS(534),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_QMARK] = ACTIONS(482),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_EQ_GT] = ACTIONS(474),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(244),
    [anon_sym_STAR_STAR] = ACTIONS(474),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_from] = ACTIONS(536),
    [anon_sym_instanceof] = ACTIONS(482),
    [anon_sym_QMARK_QMARK] = ACTIONS(474),
    [aux_sym_binary_expression_token1] = ACTIONS(482),
    [aux_sym_binary_expression_token2] = ACTIONS(482),
    [aux_sym_binary_expression_token3] = ACTIONS(482),
    [anon_sym_PIPE_PIPE] = ACTIONS(474),
    [anon_sym_AMP_AMP] = ACTIONS(474),
    [anon_sym_PIPE] = ACTIONS(482),
    [anon_sym_CARET] = ACTIONS(474),
    [anon_sym_EQ_EQ] = ACTIONS(482),
    [anon_sym_BANG_EQ] = ACTIONS(482),
    [anon_sym_LT_GT] = ACTIONS(474),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(474),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_GT] = ACTIONS(482),
    [anon_sym_LT_EQ] = ACTIONS(482),
    [anon_sym_GT_EQ] = ACTIONS(474),
    [anon_sym_LT_EQ_GT] = ACTIONS(474),
    [anon_sym_LT_LT] = ACTIONS(474),
    [anon_sym_GT_GT] = ACTIONS(474),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_STAR] = ACTIONS(482),
    [anon_sym_SLASH] = ACTIONS(482),
    [anon_sym_PERCENT] = ACTIONS(474),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(474),
    [sym_heredoc] = ACTIONS(264),
  },
  [65] = {
    [sym_text_interpolation] = STATE(65),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym_cast_type] = STATE(1357),
    [sym__expression] = STATE(669),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [66] = {
    [sym_text_interpolation] = STATE(66),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym_cast_type] = STATE(1350),
    [sym__expression] = STATE(670),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [67] = {
    [sym_text_interpolation] = STATE(67),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym_cast_type] = STATE(1376),
    [sym__expression] = STATE(670),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [68] = {
    [sym_text_interpolation] = STATE(68),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym_cast_type] = STATE(1398),
    [sym__expression] = STATE(670),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [69] = {
    [sym_text_interpolation] = STATE(69),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym_cast_type] = STATE(1371),
    [sym__expression] = STATE(670),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [70] = {
    [sym_text_interpolation] = STATE(70),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym_cast_type] = STATE(1404),
    [sym__expression] = STATE(670),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [71] = {
    [sym_text_interpolation] = STATE(71),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym_cast_type] = STATE(1332),
    [sym__expression] = STATE(670),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [72] = {
    [sym_text_interpolation] = STATE(72),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym_cast_type] = STATE(1340),
    [sym__expression] = STATE(669),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [73] = {
    [sym_text_interpolation] = STATE(73),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym_cast_type] = STATE(1340),
    [sym__expression] = STATE(670),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(538),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_float] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_binary] = ACTIONS(540),
    [anon_sym_boolean] = ACTIONS(540),
    [anon_sym_double] = ACTIONS(540),
    [anon_sym_integer] = ACTIONS(540),
    [anon_sym_object] = ACTIONS(540),
    [anon_sym_real] = ACTIONS(540),
    [anon_sym_unset] = ACTIONS(540),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [74] = {
    [sym_text_interpolation] = STATE(74),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(494),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_array_element_initializer] = STATE(1127),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(542),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [anon_sym_RBRACK] = ACTIONS(546),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [75] = {
    [sym_text_interpolation] = STATE(75),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(494),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_array_element_initializer] = STATE(1133),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(548),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(550),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [76] = {
    [sym_text_interpolation] = STATE(76),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(494),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_array_element_initializer] = STATE(1151),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(552),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(554),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [77] = {
    [sym_text_interpolation] = STATE(77),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(494),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_array_element_initializer] = STATE(978),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(556),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [anon_sym_RBRACK] = ACTIONS(558),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [78] = {
    [sym_text_interpolation] = STATE(78),
    [sym_catch_clause] = STATE(131),
    [sym_finally_clause] = STATE(131),
    [aux_sym_try_statement_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(560),
    [sym_name] = ACTIONS(562),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(560),
    [anon_sym_static] = ACTIONS(562),
    [anon_sym_global] = ACTIONS(562),
    [anon_sym_namespace] = ACTIONS(562),
    [anon_sym_use] = ACTIONS(562),
    [anon_sym_BSLASH] = ACTIONS(560),
    [anon_sym_function] = ACTIONS(562),
    [anon_sym_const] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_RBRACE] = ACTIONS(560),
    [anon_sym_trait] = ACTIONS(562),
    [anon_sym_interface] = ACTIONS(562),
    [anon_sym_class] = ACTIONS(562),
    [anon_sym_abstract] = ACTIONS(562),
    [anon_sym_final] = ACTIONS(562),
    [anon_sym_public] = ACTIONS(562),
    [anon_sym_protected] = ACTIONS(562),
    [anon_sym_private] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_array] = ACTIONS(562),
    [anon_sym_unset] = ACTIONS(562),
    [anon_sym_echo] = ACTIONS(562),
    [anon_sym_declare] = ACTIONS(562),
    [anon_sym_enddeclare] = ACTIONS(562),
    [sym_float] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(562),
    [anon_sym_catch] = ACTIONS(564),
    [anon_sym_finally] = ACTIONS(567),
    [anon_sym_goto] = ACTIONS(562),
    [anon_sym_continue] = ACTIONS(562),
    [anon_sym_break] = ACTIONS(562),
    [sym_integer] = ACTIONS(562),
    [anon_sym_return] = ACTIONS(562),
    [anon_sym_throw] = ACTIONS(562),
    [anon_sym_while] = ACTIONS(562),
    [anon_sym_endwhile] = ACTIONS(562),
    [anon_sym_do] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(562),
    [anon_sym_endfor] = ACTIONS(562),
    [anon_sym_foreach] = ACTIONS(562),
    [anon_sym_endforeach] = ACTIONS(562),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_endif] = ACTIONS(562),
    [anon_sym_elseif] = ACTIONS(562),
    [anon_sym_else] = ACTIONS(562),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_endswitch] = ACTIONS(562),
    [anon_sym_case] = ACTIONS(562),
    [anon_sym_default] = ACTIONS(562),
    [anon_sym_AT] = ACTIONS(560),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_TILDE] = ACTIONS(560),
    [anon_sym_BANG] = ACTIONS(560),
    [anon_sym_clone] = ACTIONS(562),
    [anon_sym_print] = ACTIONS(562),
    [anon_sym_new] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(560),
    [anon_sym_DASH_DASH] = ACTIONS(560),
    [sym_shell_command_expression] = ACTIONS(560),
    [anon_sym_list] = ACTIONS(562),
    [anon_sym_self] = ACTIONS(562),
    [anon_sym_parent] = ACTIONS(562),
    [anon_sym_LBRACK] = ACTIONS(560),
    [sym_string] = ACTIONS(560),
    [sym_boolean] = ACTIONS(562),
    [sym_null] = ACTIONS(562),
    [anon_sym_DOLLAR] = ACTIONS(560),
    [anon_sym_yield] = ACTIONS(562),
    [anon_sym_include] = ACTIONS(562),
    [anon_sym_include_once] = ACTIONS(562),
    [anon_sym_require] = ACTIONS(562),
    [anon_sym_require_once] = ACTIONS(562),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(560),
  },
  [79] = {
    [sym_text_interpolation] = STATE(79),
    [sym_catch_clause] = STATE(131),
    [sym_finally_clause] = STATE(131),
    [aux_sym_try_statement_repeat1] = STATE(78),
    [ts_builtin_sym_end] = ACTIONS(570),
    [sym_name] = ACTIONS(572),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(570),
    [anon_sym_static] = ACTIONS(572),
    [anon_sym_global] = ACTIONS(572),
    [anon_sym_namespace] = ACTIONS(572),
    [anon_sym_use] = ACTIONS(572),
    [anon_sym_BSLASH] = ACTIONS(570),
    [anon_sym_function] = ACTIONS(572),
    [anon_sym_const] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(570),
    [anon_sym_RBRACE] = ACTIONS(570),
    [anon_sym_trait] = ACTIONS(572),
    [anon_sym_interface] = ACTIONS(572),
    [anon_sym_class] = ACTIONS(572),
    [anon_sym_abstract] = ACTIONS(572),
    [anon_sym_final] = ACTIONS(572),
    [anon_sym_public] = ACTIONS(572),
    [anon_sym_protected] = ACTIONS(572),
    [anon_sym_private] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_array] = ACTIONS(572),
    [anon_sym_unset] = ACTIONS(572),
    [anon_sym_echo] = ACTIONS(572),
    [anon_sym_declare] = ACTIONS(572),
    [anon_sym_enddeclare] = ACTIONS(572),
    [sym_float] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(572),
    [anon_sym_catch] = ACTIONS(574),
    [anon_sym_finally] = ACTIONS(576),
    [anon_sym_goto] = ACTIONS(572),
    [anon_sym_continue] = ACTIONS(572),
    [anon_sym_break] = ACTIONS(572),
    [sym_integer] = ACTIONS(572),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_throw] = ACTIONS(572),
    [anon_sym_while] = ACTIONS(572),
    [anon_sym_endwhile] = ACTIONS(572),
    [anon_sym_do] = ACTIONS(572),
    [anon_sym_for] = ACTIONS(572),
    [anon_sym_endfor] = ACTIONS(572),
    [anon_sym_foreach] = ACTIONS(572),
    [anon_sym_endforeach] = ACTIONS(572),
    [anon_sym_if] = ACTIONS(572),
    [anon_sym_endif] = ACTIONS(572),
    [anon_sym_elseif] = ACTIONS(572),
    [anon_sym_else] = ACTIONS(572),
    [anon_sym_switch] = ACTIONS(572),
    [anon_sym_endswitch] = ACTIONS(572),
    [anon_sym_case] = ACTIONS(572),
    [anon_sym_default] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(570),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_TILDE] = ACTIONS(570),
    [anon_sym_BANG] = ACTIONS(570),
    [anon_sym_clone] = ACTIONS(572),
    [anon_sym_print] = ACTIONS(572),
    [anon_sym_new] = ACTIONS(572),
    [anon_sym_PLUS_PLUS] = ACTIONS(570),
    [anon_sym_DASH_DASH] = ACTIONS(570),
    [sym_shell_command_expression] = ACTIONS(570),
    [anon_sym_list] = ACTIONS(572),
    [anon_sym_self] = ACTIONS(572),
    [anon_sym_parent] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(570),
    [sym_string] = ACTIONS(570),
    [sym_boolean] = ACTIONS(572),
    [sym_null] = ACTIONS(572),
    [anon_sym_DOLLAR] = ACTIONS(570),
    [anon_sym_yield] = ACTIONS(572),
    [anon_sym_include] = ACTIONS(572),
    [anon_sym_include_once] = ACTIONS(572),
    [anon_sym_require] = ACTIONS(572),
    [anon_sym_require_once] = ACTIONS(572),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(570),
  },
  [80] = {
    [sym_text_interpolation] = STATE(80),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(494),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_array_element_initializer] = STATE(1067),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(578),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [81] = {
    [sym_text_interpolation] = STATE(81),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(638),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_variadic_unpacking] = STATE(1146),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(582),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [82] = {
    [sym_text_interpolation] = STATE(82),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(675),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(371),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(371),
    [sym_scoped_property_access_expression] = STATE(371),
    [sym_list_literal] = STATE(897),
    [sym_function_call_expression] = STATE(351),
    [sym_scoped_call_expression] = STATE(351),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(351),
    [sym_subscript_expression] = STATE(351),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(351),
    [sym_variable_name] = STATE(351),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [aux_sym_list_literal_repeat1] = STATE(1104),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(584),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(586),
    [anon_sym_RPAREN] = ACTIONS(588),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [83] = {
    [sym_text_interpolation] = STATE(83),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expressions] = STATE(1345),
    [sym_sequence_expression] = STATE(1176),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(590),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [84] = {
    [sym_text_interpolation] = STATE(84),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(635),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_variadic_unpacking] = STATE(1097),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(582),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [85] = {
    [sym_text_interpolation] = STATE(85),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expressions] = STATE(1344),
    [sym_sequence_expression] = STATE(1176),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(594),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [86] = {
    [sym_text_interpolation] = STATE(86),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(494),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_array_element_initializer] = STATE(1067),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(596),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [87] = {
    [sym_text_interpolation] = STATE(87),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(494),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_array_element_initializer] = STATE(1067),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(598),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [88] = {
    [sym_text_interpolation] = STATE(88),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(494),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_array_element_initializer] = STATE(1067),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [anon_sym_RBRACK] = ACTIONS(600),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [89] = {
    [sym_text_interpolation] = STATE(89),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expressions] = STATE(1396),
    [sym_sequence_expression] = STATE(1176),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(602),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [90] = {
    [sym_text_interpolation] = STATE(90),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(494),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_array_element_initializer] = STATE(1067),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(600),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [91] = {
    [sym_text_interpolation] = STATE(91),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(494),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_array_element_initializer] = STATE(1067),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [anon_sym_RBRACK] = ACTIONS(604),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [92] = {
    [sym_text_interpolation] = STATE(92),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(494),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_array_element_initializer] = STATE(1067),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [anon_sym_RBRACK] = ACTIONS(606),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [93] = {
    [sym_text_interpolation] = STATE(93),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expressions] = STATE(1368),
    [sym_sequence_expression] = STATE(1176),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(608),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [94] = {
    [sym_text_interpolation] = STATE(94),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expressions] = STATE(1358),
    [sym_sequence_expression] = STATE(1176),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(610),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [95] = {
    [sym_text_interpolation] = STATE(95),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expressions] = STATE(1353),
    [sym_sequence_expression] = STATE(1176),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(612),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [96] = {
    [sym_text_interpolation] = STATE(96),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expressions] = STATE(1400),
    [sym_sequence_expression] = STATE(1176),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(614),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [97] = {
    [sym_text_interpolation] = STATE(97),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(634),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_variadic_unpacking] = STATE(1042),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(582),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [98] = {
    [sym_text_interpolation] = STATE(98),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expressions] = STATE(1341),
    [sym_sequence_expression] = STATE(1176),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(618),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [99] = {
    [sym_text_interpolation] = STATE(99),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(632),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_variadic_unpacking] = STATE(1005),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(582),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [100] = {
    [sym_text_interpolation] = STATE(100),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expressions] = STATE(1323),
    [sym_sequence_expression] = STATE(1176),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(622),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [101] = {
    [sym_text_interpolation] = STATE(101),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expressions] = STATE(1401),
    [sym_sequence_expression] = STATE(1176),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(624),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [102] = {
    [sym_text_interpolation] = STATE(102),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(494),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_array_element_initializer] = STATE(1067),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [anon_sym_RBRACK] = ACTIONS(596),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [103] = {
    [sym_text_interpolation] = STATE(103),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expressions] = STATE(1402),
    [sym_sequence_expression] = STATE(1176),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(626),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [104] = {
    [sym_text_interpolation] = STATE(104),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expressions] = STATE(1413),
    [sym_sequence_expression] = STATE(1176),
    [sym__expression] = STATE(641),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(628),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [105] = {
    [sym_text_interpolation] = STATE(105),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(647),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(630),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(630),
    [sym_heredoc] = ACTIONS(264),
  },
  [106] = {
    [sym_text_interpolation] = STATE(106),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym_foreach_pair] = STATE(1346),
    [sym__expression] = STATE(660),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1245),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(632),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [107] = {
    [sym_text_interpolation] = STATE(107),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(692),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(376),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(376),
    [sym_scoped_property_access_expression] = STATE(376),
    [sym_list_literal] = STATE(1140),
    [sym_function_call_expression] = STATE(364),
    [sym_scoped_call_expression] = STATE(364),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(364),
    [sym_subscript_expression] = STATE(364),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(364),
    [sym_variable_name] = STATE(364),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(634),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(586),
    [anon_sym_RPAREN] = ACTIONS(634),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [108] = {
    [sym_text_interpolation] = STATE(108),
    [sym_else_if_clause] = STATE(286),
    [sym_else_clause] = STATE(260),
    [aux_sym_if_statement_repeat1] = STATE(115),
    [ts_builtin_sym_end] = ACTIONS(636),
    [sym_name] = ACTIONS(638),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym_static] = ACTIONS(638),
    [anon_sym_global] = ACTIONS(638),
    [anon_sym_namespace] = ACTIONS(638),
    [anon_sym_use] = ACTIONS(638),
    [anon_sym_BSLASH] = ACTIONS(636),
    [anon_sym_function] = ACTIONS(638),
    [anon_sym_const] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(636),
    [anon_sym_trait] = ACTIONS(638),
    [anon_sym_interface] = ACTIONS(638),
    [anon_sym_class] = ACTIONS(638),
    [anon_sym_abstract] = ACTIONS(638),
    [anon_sym_final] = ACTIONS(638),
    [anon_sym_public] = ACTIONS(638),
    [anon_sym_protected] = ACTIONS(638),
    [anon_sym_private] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(636),
    [anon_sym_array] = ACTIONS(638),
    [anon_sym_unset] = ACTIONS(638),
    [anon_sym_echo] = ACTIONS(638),
    [anon_sym_declare] = ACTIONS(638),
    [anon_sym_enddeclare] = ACTIONS(638),
    [sym_float] = ACTIONS(638),
    [anon_sym_try] = ACTIONS(638),
    [anon_sym_goto] = ACTIONS(638),
    [anon_sym_continue] = ACTIONS(638),
    [anon_sym_break] = ACTIONS(638),
    [sym_integer] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(638),
    [anon_sym_throw] = ACTIONS(638),
    [anon_sym_while] = ACTIONS(638),
    [anon_sym_endwhile] = ACTIONS(638),
    [anon_sym_do] = ACTIONS(638),
    [anon_sym_for] = ACTIONS(638),
    [anon_sym_endfor] = ACTIONS(638),
    [anon_sym_foreach] = ACTIONS(638),
    [anon_sym_endforeach] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(638),
    [anon_sym_endif] = ACTIONS(638),
    [anon_sym_elseif] = ACTIONS(640),
    [anon_sym_else] = ACTIONS(642),
    [anon_sym_switch] = ACTIONS(638),
    [anon_sym_endswitch] = ACTIONS(638),
    [anon_sym_case] = ACTIONS(638),
    [anon_sym_default] = ACTIONS(638),
    [anon_sym_AT] = ACTIONS(636),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_TILDE] = ACTIONS(636),
    [anon_sym_BANG] = ACTIONS(636),
    [anon_sym_clone] = ACTIONS(638),
    [anon_sym_print] = ACTIONS(638),
    [anon_sym_new] = ACTIONS(638),
    [anon_sym_PLUS_PLUS] = ACTIONS(636),
    [anon_sym_DASH_DASH] = ACTIONS(636),
    [sym_shell_command_expression] = ACTIONS(636),
    [anon_sym_list] = ACTIONS(638),
    [anon_sym_self] = ACTIONS(638),
    [anon_sym_parent] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(636),
    [sym_string] = ACTIONS(636),
    [sym_boolean] = ACTIONS(638),
    [sym_null] = ACTIONS(638),
    [anon_sym_DOLLAR] = ACTIONS(636),
    [anon_sym_yield] = ACTIONS(638),
    [anon_sym_include] = ACTIONS(638),
    [anon_sym_include_once] = ACTIONS(638),
    [anon_sym_require] = ACTIONS(638),
    [anon_sym_require_once] = ACTIONS(638),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(636),
  },
  [109] = {
    [sym_text_interpolation] = STATE(109),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expressions] = STATE(1243),
    [sym_sequence_expression] = STATE(1244),
    [sym__expression] = STATE(640),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [110] = {
    [sym_text_interpolation] = STATE(110),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(652),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(644),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(644),
    [sym_heredoc] = ACTIONS(264),
  },
  [111] = {
    [sym_text_interpolation] = STATE(111),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(645),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(646),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(646),
    [sym_heredoc] = ACTIONS(264),
  },
  [112] = {
    [sym_text_interpolation] = STATE(112),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expressions] = STATE(1186),
    [sym_sequence_expression] = STATE(1244),
    [sym__expression] = STATE(640),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [113] = {
    [sym_text_interpolation] = STATE(113),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym_foreach_pair] = STATE(1399),
    [sym__expression] = STATE(656),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1165),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(648),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [114] = {
    [sym_text_interpolation] = STATE(114),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(494),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_array_element_initializer] = STATE(1067),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [115] = {
    [sym_text_interpolation] = STATE(115),
    [sym_else_if_clause] = STATE(286),
    [sym_else_clause] = STATE(292),
    [aux_sym_if_statement_repeat1] = STATE(127),
    [ts_builtin_sym_end] = ACTIONS(650),
    [sym_name] = ACTIONS(652),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_static] = ACTIONS(652),
    [anon_sym_global] = ACTIONS(652),
    [anon_sym_namespace] = ACTIONS(652),
    [anon_sym_use] = ACTIONS(652),
    [anon_sym_BSLASH] = ACTIONS(650),
    [anon_sym_function] = ACTIONS(652),
    [anon_sym_const] = ACTIONS(652),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_trait] = ACTIONS(652),
    [anon_sym_interface] = ACTIONS(652),
    [anon_sym_class] = ACTIONS(652),
    [anon_sym_abstract] = ACTIONS(652),
    [anon_sym_final] = ACTIONS(652),
    [anon_sym_public] = ACTIONS(652),
    [anon_sym_protected] = ACTIONS(652),
    [anon_sym_private] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_array] = ACTIONS(652),
    [anon_sym_unset] = ACTIONS(652),
    [anon_sym_echo] = ACTIONS(652),
    [anon_sym_declare] = ACTIONS(652),
    [anon_sym_enddeclare] = ACTIONS(652),
    [sym_float] = ACTIONS(652),
    [anon_sym_try] = ACTIONS(652),
    [anon_sym_goto] = ACTIONS(652),
    [anon_sym_continue] = ACTIONS(652),
    [anon_sym_break] = ACTIONS(652),
    [sym_integer] = ACTIONS(652),
    [anon_sym_return] = ACTIONS(652),
    [anon_sym_throw] = ACTIONS(652),
    [anon_sym_while] = ACTIONS(652),
    [anon_sym_endwhile] = ACTIONS(652),
    [anon_sym_do] = ACTIONS(652),
    [anon_sym_for] = ACTIONS(652),
    [anon_sym_endfor] = ACTIONS(652),
    [anon_sym_foreach] = ACTIONS(652),
    [anon_sym_endforeach] = ACTIONS(652),
    [anon_sym_if] = ACTIONS(652),
    [anon_sym_endif] = ACTIONS(652),
    [anon_sym_elseif] = ACTIONS(640),
    [anon_sym_else] = ACTIONS(642),
    [anon_sym_switch] = ACTIONS(652),
    [anon_sym_endswitch] = ACTIONS(652),
    [anon_sym_case] = ACTIONS(652),
    [anon_sym_default] = ACTIONS(652),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_BANG] = ACTIONS(650),
    [anon_sym_clone] = ACTIONS(652),
    [anon_sym_print] = ACTIONS(652),
    [anon_sym_new] = ACTIONS(652),
    [anon_sym_PLUS_PLUS] = ACTIONS(650),
    [anon_sym_DASH_DASH] = ACTIONS(650),
    [sym_shell_command_expression] = ACTIONS(650),
    [anon_sym_list] = ACTIONS(652),
    [anon_sym_self] = ACTIONS(652),
    [anon_sym_parent] = ACTIONS(652),
    [anon_sym_LBRACK] = ACTIONS(650),
    [sym_string] = ACTIONS(650),
    [sym_boolean] = ACTIONS(652),
    [sym_null] = ACTIONS(652),
    [anon_sym_DOLLAR] = ACTIONS(650),
    [anon_sym_yield] = ACTIONS(652),
    [anon_sym_include] = ACTIONS(652),
    [anon_sym_include_once] = ACTIONS(652),
    [anon_sym_require] = ACTIONS(652),
    [anon_sym_require_once] = ACTIONS(652),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(650),
  },
  [116] = {
    [sym_text_interpolation] = STATE(116),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(648),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(654),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(654),
    [sym_heredoc] = ACTIONS(264),
  },
  [117] = {
    [sym_text_interpolation] = STATE(117),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(658),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_variadic_unpacking] = STATE(1252),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(582),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [118] = {
    [sym_text_interpolation] = STATE(118),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(649),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(656),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(656),
    [sym_heredoc] = ACTIONS(264),
  },
  [119] = {
    [sym_text_interpolation] = STATE(119),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(650),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(658),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(658),
    [sym_heredoc] = ACTIONS(264),
  },
  [120] = {
    [sym_text_interpolation] = STATE(120),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(679),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(660),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [121] = {
    [sym_text_interpolation] = STATE(121),
    [ts_builtin_sym_end] = ACTIONS(662),
    [sym_name] = ACTIONS(664),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(662),
    [anon_sym_static] = ACTIONS(664),
    [anon_sym_global] = ACTIONS(664),
    [anon_sym_namespace] = ACTIONS(664),
    [anon_sym_use] = ACTIONS(664),
    [anon_sym_BSLASH] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(664),
    [anon_sym_const] = ACTIONS(664),
    [anon_sym_LBRACE] = ACTIONS(662),
    [anon_sym_RBRACE] = ACTIONS(662),
    [anon_sym_trait] = ACTIONS(664),
    [anon_sym_interface] = ACTIONS(664),
    [anon_sym_class] = ACTIONS(664),
    [anon_sym_abstract] = ACTIONS(664),
    [anon_sym_final] = ACTIONS(664),
    [anon_sym_public] = ACTIONS(664),
    [anon_sym_protected] = ACTIONS(664),
    [anon_sym_private] = ACTIONS(664),
    [anon_sym_LPAREN] = ACTIONS(662),
    [anon_sym_array] = ACTIONS(664),
    [anon_sym_unset] = ACTIONS(664),
    [anon_sym_echo] = ACTIONS(664),
    [anon_sym_declare] = ACTIONS(664),
    [anon_sym_enddeclare] = ACTIONS(664),
    [sym_float] = ACTIONS(664),
    [anon_sym_try] = ACTIONS(664),
    [anon_sym_catch] = ACTIONS(664),
    [anon_sym_finally] = ACTIONS(664),
    [anon_sym_goto] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(664),
    [anon_sym_break] = ACTIONS(664),
    [sym_integer] = ACTIONS(664),
    [anon_sym_return] = ACTIONS(664),
    [anon_sym_throw] = ACTIONS(664),
    [anon_sym_while] = ACTIONS(664),
    [anon_sym_endwhile] = ACTIONS(664),
    [anon_sym_do] = ACTIONS(664),
    [anon_sym_for] = ACTIONS(664),
    [anon_sym_endfor] = ACTIONS(664),
    [anon_sym_foreach] = ACTIONS(664),
    [anon_sym_endforeach] = ACTIONS(664),
    [anon_sym_if] = ACTIONS(664),
    [anon_sym_endif] = ACTIONS(664),
    [anon_sym_elseif] = ACTIONS(664),
    [anon_sym_else] = ACTIONS(664),
    [anon_sym_switch] = ACTIONS(664),
    [anon_sym_endswitch] = ACTIONS(664),
    [anon_sym_case] = ACTIONS(664),
    [anon_sym_default] = ACTIONS(664),
    [anon_sym_AT] = ACTIONS(662),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_TILDE] = ACTIONS(662),
    [anon_sym_BANG] = ACTIONS(662),
    [anon_sym_clone] = ACTIONS(664),
    [anon_sym_print] = ACTIONS(664),
    [anon_sym_new] = ACTIONS(664),
    [anon_sym_PLUS_PLUS] = ACTIONS(662),
    [anon_sym_DASH_DASH] = ACTIONS(662),
    [sym_shell_command_expression] = ACTIONS(662),
    [anon_sym_list] = ACTIONS(664),
    [anon_sym_self] = ACTIONS(664),
    [anon_sym_parent] = ACTIONS(664),
    [anon_sym_LBRACK] = ACTIONS(662),
    [sym_string] = ACTIONS(662),
    [sym_boolean] = ACTIONS(664),
    [sym_null] = ACTIONS(664),
    [anon_sym_DOLLAR] = ACTIONS(662),
    [anon_sym_yield] = ACTIONS(664),
    [anon_sym_include] = ACTIONS(664),
    [anon_sym_include_once] = ACTIONS(664),
    [anon_sym_require] = ACTIONS(664),
    [anon_sym_require_once] = ACTIONS(664),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(662),
  },
  [122] = {
    [sym_text_interpolation] = STATE(122),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym_sequence_expression] = STATE(1288),
    [sym__expression] = STATE(631),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [123] = {
    [sym_text_interpolation] = STATE(123),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(689),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [anon_sym_COLON] = ACTIONS(666),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [124] = {
    [sym_text_interpolation] = STATE(124),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(681),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [anon_sym_RBRACK] = ACTIONS(668),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [125] = {
    [sym_text_interpolation] = STATE(125),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(676),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [anon_sym_RBRACK] = ACTIONS(670),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [126] = {
    [sym_text_interpolation] = STATE(126),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(485),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(672),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [127] = {
    [sym_text_interpolation] = STATE(127),
    [sym_else_if_clause] = STATE(286),
    [aux_sym_if_statement_repeat1] = STATE(127),
    [ts_builtin_sym_end] = ACTIONS(674),
    [sym_name] = ACTIONS(676),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(674),
    [anon_sym_static] = ACTIONS(676),
    [anon_sym_global] = ACTIONS(676),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_use] = ACTIONS(676),
    [anon_sym_BSLASH] = ACTIONS(674),
    [anon_sym_function] = ACTIONS(676),
    [anon_sym_const] = ACTIONS(676),
    [anon_sym_LBRACE] = ACTIONS(674),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_trait] = ACTIONS(676),
    [anon_sym_interface] = ACTIONS(676),
    [anon_sym_class] = ACTIONS(676),
    [anon_sym_abstract] = ACTIONS(676),
    [anon_sym_final] = ACTIONS(676),
    [anon_sym_public] = ACTIONS(676),
    [anon_sym_protected] = ACTIONS(676),
    [anon_sym_private] = ACTIONS(676),
    [anon_sym_LPAREN] = ACTIONS(674),
    [anon_sym_array] = ACTIONS(676),
    [anon_sym_unset] = ACTIONS(676),
    [anon_sym_echo] = ACTIONS(676),
    [anon_sym_declare] = ACTIONS(676),
    [anon_sym_enddeclare] = ACTIONS(676),
    [sym_float] = ACTIONS(676),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_goto] = ACTIONS(676),
    [anon_sym_continue] = ACTIONS(676),
    [anon_sym_break] = ACTIONS(676),
    [sym_integer] = ACTIONS(676),
    [anon_sym_return] = ACTIONS(676),
    [anon_sym_throw] = ACTIONS(676),
    [anon_sym_while] = ACTIONS(676),
    [anon_sym_endwhile] = ACTIONS(676),
    [anon_sym_do] = ACTIONS(676),
    [anon_sym_for] = ACTIONS(676),
    [anon_sym_endfor] = ACTIONS(676),
    [anon_sym_foreach] = ACTIONS(676),
    [anon_sym_endforeach] = ACTIONS(676),
    [anon_sym_if] = ACTIONS(676),
    [anon_sym_endif] = ACTIONS(676),
    [anon_sym_elseif] = ACTIONS(678),
    [anon_sym_else] = ACTIONS(676),
    [anon_sym_switch] = ACTIONS(676),
    [anon_sym_endswitch] = ACTIONS(676),
    [anon_sym_case] = ACTIONS(676),
    [anon_sym_default] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(674),
    [anon_sym_PLUS] = ACTIONS(676),
    [anon_sym_DASH] = ACTIONS(676),
    [anon_sym_TILDE] = ACTIONS(674),
    [anon_sym_BANG] = ACTIONS(674),
    [anon_sym_clone] = ACTIONS(676),
    [anon_sym_print] = ACTIONS(676),
    [anon_sym_new] = ACTIONS(676),
    [anon_sym_PLUS_PLUS] = ACTIONS(674),
    [anon_sym_DASH_DASH] = ACTIONS(674),
    [sym_shell_command_expression] = ACTIONS(674),
    [anon_sym_list] = ACTIONS(676),
    [anon_sym_self] = ACTIONS(676),
    [anon_sym_parent] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(674),
    [sym_string] = ACTIONS(674),
    [sym_boolean] = ACTIONS(676),
    [sym_null] = ACTIONS(676),
    [anon_sym_DOLLAR] = ACTIONS(674),
    [anon_sym_yield] = ACTIONS(676),
    [anon_sym_include] = ACTIONS(676),
    [anon_sym_include_once] = ACTIONS(676),
    [anon_sym_require] = ACTIONS(676),
    [anon_sym_require_once] = ACTIONS(676),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(674),
  },
  [128] = {
    [sym_text_interpolation] = STATE(128),
    [ts_builtin_sym_end] = ACTIONS(681),
    [sym_name] = ACTIONS(683),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_static] = ACTIONS(683),
    [anon_sym_global] = ACTIONS(683),
    [anon_sym_namespace] = ACTIONS(683),
    [anon_sym_use] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(681),
    [anon_sym_function] = ACTIONS(683),
    [anon_sym_const] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(681),
    [anon_sym_RBRACE] = ACTIONS(681),
    [anon_sym_trait] = ACTIONS(683),
    [anon_sym_interface] = ACTIONS(683),
    [anon_sym_class] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(683),
    [anon_sym_final] = ACTIONS(683),
    [anon_sym_public] = ACTIONS(683),
    [anon_sym_protected] = ACTIONS(683),
    [anon_sym_private] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_array] = ACTIONS(683),
    [anon_sym_unset] = ACTIONS(683),
    [anon_sym_echo] = ACTIONS(683),
    [anon_sym_declare] = ACTIONS(683),
    [anon_sym_enddeclare] = ACTIONS(683),
    [sym_float] = ACTIONS(683),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_catch] = ACTIONS(683),
    [anon_sym_finally] = ACTIONS(683),
    [anon_sym_goto] = ACTIONS(683),
    [anon_sym_continue] = ACTIONS(683),
    [anon_sym_break] = ACTIONS(683),
    [sym_integer] = ACTIONS(683),
    [anon_sym_return] = ACTIONS(683),
    [anon_sym_throw] = ACTIONS(683),
    [anon_sym_while] = ACTIONS(683),
    [anon_sym_endwhile] = ACTIONS(683),
    [anon_sym_do] = ACTIONS(683),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_endfor] = ACTIONS(683),
    [anon_sym_foreach] = ACTIONS(683),
    [anon_sym_endforeach] = ACTIONS(683),
    [anon_sym_if] = ACTIONS(683),
    [anon_sym_endif] = ACTIONS(683),
    [anon_sym_elseif] = ACTIONS(683),
    [anon_sym_else] = ACTIONS(683),
    [anon_sym_switch] = ACTIONS(683),
    [anon_sym_endswitch] = ACTIONS(683),
    [anon_sym_case] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(681),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(681),
    [anon_sym_BANG] = ACTIONS(681),
    [anon_sym_clone] = ACTIONS(683),
    [anon_sym_print] = ACTIONS(683),
    [anon_sym_new] = ACTIONS(683),
    [anon_sym_PLUS_PLUS] = ACTIONS(681),
    [anon_sym_DASH_DASH] = ACTIONS(681),
    [sym_shell_command_expression] = ACTIONS(681),
    [anon_sym_list] = ACTIONS(683),
    [anon_sym_self] = ACTIONS(683),
    [anon_sym_parent] = ACTIONS(683),
    [anon_sym_LBRACK] = ACTIONS(681),
    [sym_string] = ACTIONS(681),
    [sym_boolean] = ACTIONS(683),
    [sym_null] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(681),
    [anon_sym_yield] = ACTIONS(683),
    [anon_sym_include] = ACTIONS(683),
    [anon_sym_include_once] = ACTIONS(683),
    [anon_sym_require] = ACTIONS(683),
    [anon_sym_require_once] = ACTIONS(683),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(681),
  },
  [129] = {
    [sym_text_interpolation] = STATE(129),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(698),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1306),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(685),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [130] = {
    [sym_text_interpolation] = STATE(130),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym_sequence_expression] = STATE(1239),
    [sym__expression] = STATE(633),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [131] = {
    [sym_text_interpolation] = STATE(131),
    [ts_builtin_sym_end] = ACTIONS(687),
    [sym_name] = ACTIONS(689),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(687),
    [anon_sym_static] = ACTIONS(689),
    [anon_sym_global] = ACTIONS(689),
    [anon_sym_namespace] = ACTIONS(689),
    [anon_sym_use] = ACTIONS(689),
    [anon_sym_BSLASH] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(689),
    [anon_sym_const] = ACTIONS(689),
    [anon_sym_LBRACE] = ACTIONS(687),
    [anon_sym_RBRACE] = ACTIONS(687),
    [anon_sym_trait] = ACTIONS(689),
    [anon_sym_interface] = ACTIONS(689),
    [anon_sym_class] = ACTIONS(689),
    [anon_sym_abstract] = ACTIONS(689),
    [anon_sym_final] = ACTIONS(689),
    [anon_sym_public] = ACTIONS(689),
    [anon_sym_protected] = ACTIONS(689),
    [anon_sym_private] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_array] = ACTIONS(689),
    [anon_sym_unset] = ACTIONS(689),
    [anon_sym_echo] = ACTIONS(689),
    [anon_sym_declare] = ACTIONS(689),
    [anon_sym_enddeclare] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_try] = ACTIONS(689),
    [anon_sym_catch] = ACTIONS(689),
    [anon_sym_finally] = ACTIONS(689),
    [anon_sym_goto] = ACTIONS(689),
    [anon_sym_continue] = ACTIONS(689),
    [anon_sym_break] = ACTIONS(689),
    [sym_integer] = ACTIONS(689),
    [anon_sym_return] = ACTIONS(689),
    [anon_sym_throw] = ACTIONS(689),
    [anon_sym_while] = ACTIONS(689),
    [anon_sym_endwhile] = ACTIONS(689),
    [anon_sym_do] = ACTIONS(689),
    [anon_sym_for] = ACTIONS(689),
    [anon_sym_endfor] = ACTIONS(689),
    [anon_sym_foreach] = ACTIONS(689),
    [anon_sym_endforeach] = ACTIONS(689),
    [anon_sym_if] = ACTIONS(689),
    [anon_sym_endif] = ACTIONS(689),
    [anon_sym_elseif] = ACTIONS(689),
    [anon_sym_else] = ACTIONS(689),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_endswitch] = ACTIONS(689),
    [anon_sym_case] = ACTIONS(689),
    [anon_sym_default] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(687),
    [anon_sym_PLUS] = ACTIONS(689),
    [anon_sym_DASH] = ACTIONS(689),
    [anon_sym_TILDE] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(687),
    [anon_sym_clone] = ACTIONS(689),
    [anon_sym_print] = ACTIONS(689),
    [anon_sym_new] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(687),
    [anon_sym_DASH_DASH] = ACTIONS(687),
    [sym_shell_command_expression] = ACTIONS(687),
    [anon_sym_list] = ACTIONS(689),
    [anon_sym_self] = ACTIONS(689),
    [anon_sym_parent] = ACTIONS(689),
    [anon_sym_LBRACK] = ACTIONS(687),
    [sym_string] = ACTIONS(687),
    [sym_boolean] = ACTIONS(689),
    [sym_null] = ACTIONS(689),
    [anon_sym_DOLLAR] = ACTIONS(687),
    [anon_sym_yield] = ACTIONS(689),
    [anon_sym_include] = ACTIONS(689),
    [anon_sym_include_once] = ACTIONS(689),
    [anon_sym_require] = ACTIONS(689),
    [anon_sym_require_once] = ACTIONS(689),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(687),
  },
  [132] = {
    [sym_text_interpolation] = STATE(132),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(685),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [anon_sym_RBRACK] = ACTIONS(691),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [133] = {
    [sym_text_interpolation] = STATE(133),
    [ts_builtin_sym_end] = ACTIONS(693),
    [sym_name] = ACTIONS(695),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_global] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_use] = ACTIONS(695),
    [anon_sym_BSLASH] = ACTIONS(693),
    [anon_sym_function] = ACTIONS(695),
    [anon_sym_const] = ACTIONS(695),
    [anon_sym_LBRACE] = ACTIONS(693),
    [anon_sym_RBRACE] = ACTIONS(693),
    [anon_sym_trait] = ACTIONS(695),
    [anon_sym_interface] = ACTIONS(695),
    [anon_sym_class] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(695),
    [anon_sym_final] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_LPAREN] = ACTIONS(693),
    [anon_sym_array] = ACTIONS(695),
    [anon_sym_unset] = ACTIONS(695),
    [anon_sym_echo] = ACTIONS(695),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_enddeclare] = ACTIONS(695),
    [sym_float] = ACTIONS(695),
    [anon_sym_try] = ACTIONS(695),
    [anon_sym_catch] = ACTIONS(695),
    [anon_sym_finally] = ACTIONS(695),
    [anon_sym_goto] = ACTIONS(695),
    [anon_sym_continue] = ACTIONS(695),
    [anon_sym_break] = ACTIONS(695),
    [sym_integer] = ACTIONS(695),
    [anon_sym_return] = ACTIONS(695),
    [anon_sym_throw] = ACTIONS(695),
    [anon_sym_while] = ACTIONS(695),
    [anon_sym_endwhile] = ACTIONS(695),
    [anon_sym_do] = ACTIONS(695),
    [anon_sym_for] = ACTIONS(695),
    [anon_sym_endfor] = ACTIONS(695),
    [anon_sym_foreach] = ACTIONS(695),
    [anon_sym_endforeach] = ACTIONS(695),
    [anon_sym_if] = ACTIONS(695),
    [anon_sym_endif] = ACTIONS(695),
    [anon_sym_elseif] = ACTIONS(695),
    [anon_sym_else] = ACTIONS(695),
    [anon_sym_switch] = ACTIONS(695),
    [anon_sym_endswitch] = ACTIONS(695),
    [anon_sym_case] = ACTIONS(695),
    [anon_sym_default] = ACTIONS(695),
    [anon_sym_AT] = ACTIONS(693),
    [anon_sym_PLUS] = ACTIONS(695),
    [anon_sym_DASH] = ACTIONS(695),
    [anon_sym_TILDE] = ACTIONS(693),
    [anon_sym_BANG] = ACTIONS(693),
    [anon_sym_clone] = ACTIONS(695),
    [anon_sym_print] = ACTIONS(695),
    [anon_sym_new] = ACTIONS(695),
    [anon_sym_PLUS_PLUS] = ACTIONS(693),
    [anon_sym_DASH_DASH] = ACTIONS(693),
    [sym_shell_command_expression] = ACTIONS(693),
    [anon_sym_list] = ACTIONS(695),
    [anon_sym_self] = ACTIONS(695),
    [anon_sym_parent] = ACTIONS(695),
    [anon_sym_LBRACK] = ACTIONS(693),
    [sym_string] = ACTIONS(693),
    [sym_boolean] = ACTIONS(695),
    [sym_null] = ACTIONS(695),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [anon_sym_yield] = ACTIONS(695),
    [anon_sym_include] = ACTIONS(695),
    [anon_sym_include_once] = ACTIONS(695),
    [anon_sym_require] = ACTIONS(695),
    [anon_sym_require_once] = ACTIONS(695),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(693),
  },
  [134] = {
    [sym_text_interpolation] = STATE(134),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(589),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_AMP] = ACTIONS(697),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [135] = {
    [sym_text_interpolation] = STATE(135),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(686),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [anon_sym_RBRACK] = ACTIONS(699),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [136] = {
    [sym_text_interpolation] = STATE(136),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(578),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_AMP] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [137] = {
    [sym_text_interpolation] = STATE(137),
    [ts_builtin_sym_end] = ACTIONS(703),
    [sym_name] = ACTIONS(705),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_static] = ACTIONS(705),
    [anon_sym_global] = ACTIONS(705),
    [anon_sym_namespace] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(705),
    [anon_sym_BSLASH] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(705),
    [anon_sym_const] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(703),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_trait] = ACTIONS(705),
    [anon_sym_interface] = ACTIONS(705),
    [anon_sym_class] = ACTIONS(705),
    [anon_sym_abstract] = ACTIONS(705),
    [anon_sym_final] = ACTIONS(705),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_array] = ACTIONS(705),
    [anon_sym_unset] = ACTIONS(705),
    [anon_sym_echo] = ACTIONS(705),
    [anon_sym_declare] = ACTIONS(705),
    [anon_sym_enddeclare] = ACTIONS(705),
    [sym_float] = ACTIONS(705),
    [anon_sym_try] = ACTIONS(705),
    [anon_sym_catch] = ACTIONS(705),
    [anon_sym_finally] = ACTIONS(705),
    [anon_sym_goto] = ACTIONS(705),
    [anon_sym_continue] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(705),
    [sym_integer] = ACTIONS(705),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_throw] = ACTIONS(705),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_endwhile] = ACTIONS(705),
    [anon_sym_do] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(705),
    [anon_sym_endfor] = ACTIONS(705),
    [anon_sym_foreach] = ACTIONS(705),
    [anon_sym_endforeach] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(705),
    [anon_sym_endif] = ACTIONS(705),
    [anon_sym_elseif] = ACTIONS(705),
    [anon_sym_else] = ACTIONS(705),
    [anon_sym_switch] = ACTIONS(705),
    [anon_sym_endswitch] = ACTIONS(705),
    [anon_sym_case] = ACTIONS(705),
    [anon_sym_default] = ACTIONS(705),
    [anon_sym_AT] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_TILDE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(703),
    [anon_sym_clone] = ACTIONS(705),
    [anon_sym_print] = ACTIONS(705),
    [anon_sym_new] = ACTIONS(705),
    [anon_sym_PLUS_PLUS] = ACTIONS(703),
    [anon_sym_DASH_DASH] = ACTIONS(703),
    [sym_shell_command_expression] = ACTIONS(703),
    [anon_sym_list] = ACTIONS(705),
    [anon_sym_self] = ACTIONS(705),
    [anon_sym_parent] = ACTIONS(705),
    [anon_sym_LBRACK] = ACTIONS(703),
    [sym_string] = ACTIONS(703),
    [sym_boolean] = ACTIONS(705),
    [sym_null] = ACTIONS(705),
    [anon_sym_DOLLAR] = ACTIONS(703),
    [anon_sym_yield] = ACTIONS(705),
    [anon_sym_include] = ACTIONS(705),
    [anon_sym_include_once] = ACTIONS(705),
    [anon_sym_require] = ACTIONS(705),
    [anon_sym_require_once] = ACTIONS(705),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(703),
  },
  [138] = {
    [sym_text_interpolation] = STATE(138),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(488),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [139] = {
    [sym_text_interpolation] = STATE(139),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(694),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [140] = {
    [sym_text_interpolation] = STATE(140),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(483),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [141] = {
    [sym_text_interpolation] = STATE(141),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(684),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [142] = {
    [sym_text_interpolation] = STATE(142),
    [ts_builtin_sym_end] = ACTIONS(709),
    [sym_name] = ACTIONS(711),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(713),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_global] = ACTIONS(711),
    [anon_sym_namespace] = ACTIONS(711),
    [anon_sym_use] = ACTIONS(711),
    [anon_sym_BSLASH] = ACTIONS(709),
    [anon_sym_function] = ACTIONS(711),
    [anon_sym_const] = ACTIONS(711),
    [anon_sym_LBRACE] = ACTIONS(709),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_trait] = ACTIONS(711),
    [anon_sym_interface] = ACTIONS(711),
    [anon_sym_class] = ACTIONS(711),
    [anon_sym_abstract] = ACTIONS(711),
    [anon_sym_final] = ACTIONS(711),
    [anon_sym_public] = ACTIONS(711),
    [anon_sym_protected] = ACTIONS(711),
    [anon_sym_private] = ACTIONS(711),
    [anon_sym_LPAREN] = ACTIONS(709),
    [anon_sym_array] = ACTIONS(711),
    [anon_sym_unset] = ACTIONS(711),
    [anon_sym_echo] = ACTIONS(711),
    [anon_sym_declare] = ACTIONS(711),
    [anon_sym_enddeclare] = ACTIONS(711),
    [sym_float] = ACTIONS(711),
    [anon_sym_try] = ACTIONS(711),
    [anon_sym_goto] = ACTIONS(711),
    [anon_sym_continue] = ACTIONS(711),
    [anon_sym_break] = ACTIONS(711),
    [sym_integer] = ACTIONS(711),
    [anon_sym_return] = ACTIONS(711),
    [anon_sym_throw] = ACTIONS(711),
    [anon_sym_while] = ACTIONS(711),
    [anon_sym_endwhile] = ACTIONS(711),
    [anon_sym_do] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(711),
    [anon_sym_endfor] = ACTIONS(711),
    [anon_sym_foreach] = ACTIONS(711),
    [anon_sym_endforeach] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(711),
    [anon_sym_endif] = ACTIONS(711),
    [anon_sym_elseif] = ACTIONS(711),
    [anon_sym_else] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(711),
    [anon_sym_endswitch] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(711),
    [anon_sym_default] = ACTIONS(711),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_PLUS] = ACTIONS(711),
    [anon_sym_DASH] = ACTIONS(711),
    [anon_sym_TILDE] = ACTIONS(709),
    [anon_sym_BANG] = ACTIONS(709),
    [anon_sym_clone] = ACTIONS(711),
    [anon_sym_print] = ACTIONS(711),
    [anon_sym_new] = ACTIONS(711),
    [anon_sym_PLUS_PLUS] = ACTIONS(709),
    [anon_sym_DASH_DASH] = ACTIONS(709),
    [sym_shell_command_expression] = ACTIONS(709),
    [anon_sym_list] = ACTIONS(711),
    [anon_sym_self] = ACTIONS(711),
    [anon_sym_parent] = ACTIONS(711),
    [anon_sym_LBRACK] = ACTIONS(709),
    [sym_string] = ACTIONS(709),
    [sym_boolean] = ACTIONS(711),
    [sym_null] = ACTIONS(711),
    [anon_sym_DOLLAR] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(711),
    [anon_sym_include] = ACTIONS(711),
    [anon_sym_include_once] = ACTIONS(711),
    [anon_sym_require] = ACTIONS(711),
    [anon_sym_require_once] = ACTIONS(711),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(713),
    [sym_heredoc] = ACTIONS(709),
  },
  [143] = {
    [sym_text_interpolation] = STATE(143),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(671),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [144] = {
    [sym_text_interpolation] = STATE(144),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(642),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [145] = {
    [sym_text_interpolation] = STATE(145),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(570),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [146] = {
    [sym_text_interpolation] = STATE(146),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(672),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [147] = {
    [sym_text_interpolation] = STATE(147),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(687),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [148] = {
    [sym_text_interpolation] = STATE(148),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(657),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [149] = {
    [sym_text_interpolation] = STATE(149),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(691),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [150] = {
    [sym_text_interpolation] = STATE(150),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(661),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [151] = {
    [sym_text_interpolation] = STATE(151),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(680),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [152] = {
    [sym_text_interpolation] = STATE(152),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(695),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [153] = {
    [sym_text_interpolation] = STATE(153),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(696),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [154] = {
    [sym_text_interpolation] = STATE(154),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(697),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [155] = {
    [sym_text_interpolation] = STATE(155),
    [ts_builtin_sym_end] = ACTIONS(715),
    [sym_name] = ACTIONS(717),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym_static] = ACTIONS(717),
    [anon_sym_global] = ACTIONS(717),
    [anon_sym_namespace] = ACTIONS(717),
    [anon_sym_use] = ACTIONS(717),
    [anon_sym_BSLASH] = ACTIONS(715),
    [anon_sym_function] = ACTIONS(717),
    [anon_sym_const] = ACTIONS(717),
    [anon_sym_LBRACE] = ACTIONS(715),
    [anon_sym_RBRACE] = ACTIONS(715),
    [anon_sym_trait] = ACTIONS(717),
    [anon_sym_interface] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(717),
    [anon_sym_final] = ACTIONS(717),
    [anon_sym_public] = ACTIONS(717),
    [anon_sym_protected] = ACTIONS(717),
    [anon_sym_private] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(715),
    [anon_sym_array] = ACTIONS(717),
    [anon_sym_unset] = ACTIONS(717),
    [anon_sym_echo] = ACTIONS(717),
    [anon_sym_declare] = ACTIONS(717),
    [anon_sym_enddeclare] = ACTIONS(717),
    [sym_float] = ACTIONS(717),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_goto] = ACTIONS(717),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_break] = ACTIONS(717),
    [sym_integer] = ACTIONS(717),
    [anon_sym_return] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(717),
    [anon_sym_endwhile] = ACTIONS(717),
    [anon_sym_do] = ACTIONS(717),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_endfor] = ACTIONS(717),
    [anon_sym_foreach] = ACTIONS(717),
    [anon_sym_endforeach] = ACTIONS(717),
    [anon_sym_if] = ACTIONS(717),
    [anon_sym_endif] = ACTIONS(717),
    [anon_sym_elseif] = ACTIONS(717),
    [anon_sym_else] = ACTIONS(717),
    [anon_sym_switch] = ACTIONS(717),
    [anon_sym_endswitch] = ACTIONS(717),
    [anon_sym_case] = ACTIONS(717),
    [anon_sym_default] = ACTIONS(717),
    [anon_sym_AT] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(715),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_clone] = ACTIONS(717),
    [anon_sym_print] = ACTIONS(717),
    [anon_sym_new] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(715),
    [anon_sym_DASH_DASH] = ACTIONS(715),
    [sym_shell_command_expression] = ACTIONS(715),
    [anon_sym_list] = ACTIONS(717),
    [anon_sym_self] = ACTIONS(717),
    [anon_sym_parent] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(715),
    [sym_string] = ACTIONS(715),
    [sym_boolean] = ACTIONS(717),
    [sym_null] = ACTIONS(717),
    [anon_sym_DOLLAR] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_include] = ACTIONS(717),
    [anon_sym_include_once] = ACTIONS(717),
    [anon_sym_require] = ACTIONS(717),
    [anon_sym_require_once] = ACTIONS(717),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(715),
    [sym_heredoc] = ACTIONS(715),
  },
  [156] = {
    [sym_text_interpolation] = STATE(156),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(699),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [157] = {
    [sym_text_interpolation] = STATE(157),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(693),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [158] = {
    [sym_text_interpolation] = STATE(158),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(678),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [159] = {
    [sym_text_interpolation] = STATE(159),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(511),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [160] = {
    [sym_text_interpolation] = STATE(160),
    [ts_builtin_sym_end] = ACTIONS(719),
    [sym_name] = ACTIONS(721),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(723),
    [anon_sym_static] = ACTIONS(721),
    [anon_sym_global] = ACTIONS(721),
    [anon_sym_namespace] = ACTIONS(721),
    [anon_sym_use] = ACTIONS(721),
    [anon_sym_BSLASH] = ACTIONS(719),
    [anon_sym_function] = ACTIONS(721),
    [anon_sym_const] = ACTIONS(721),
    [anon_sym_LBRACE] = ACTIONS(719),
    [anon_sym_RBRACE] = ACTIONS(719),
    [anon_sym_trait] = ACTIONS(721),
    [anon_sym_interface] = ACTIONS(721),
    [anon_sym_class] = ACTIONS(721),
    [anon_sym_abstract] = ACTIONS(721),
    [anon_sym_final] = ACTIONS(721),
    [anon_sym_public] = ACTIONS(721),
    [anon_sym_protected] = ACTIONS(721),
    [anon_sym_private] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(719),
    [anon_sym_array] = ACTIONS(721),
    [anon_sym_unset] = ACTIONS(721),
    [anon_sym_echo] = ACTIONS(721),
    [anon_sym_declare] = ACTIONS(721),
    [anon_sym_enddeclare] = ACTIONS(721),
    [sym_float] = ACTIONS(721),
    [anon_sym_try] = ACTIONS(721),
    [anon_sym_goto] = ACTIONS(721),
    [anon_sym_continue] = ACTIONS(721),
    [anon_sym_break] = ACTIONS(721),
    [sym_integer] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(721),
    [anon_sym_throw] = ACTIONS(721),
    [anon_sym_while] = ACTIONS(721),
    [anon_sym_endwhile] = ACTIONS(721),
    [anon_sym_do] = ACTIONS(721),
    [anon_sym_for] = ACTIONS(721),
    [anon_sym_endfor] = ACTIONS(721),
    [anon_sym_foreach] = ACTIONS(721),
    [anon_sym_endforeach] = ACTIONS(721),
    [anon_sym_if] = ACTIONS(721),
    [anon_sym_endif] = ACTIONS(721),
    [anon_sym_elseif] = ACTIONS(721),
    [anon_sym_else] = ACTIONS(721),
    [anon_sym_switch] = ACTIONS(721),
    [anon_sym_endswitch] = ACTIONS(721),
    [anon_sym_case] = ACTIONS(721),
    [anon_sym_default] = ACTIONS(721),
    [anon_sym_AT] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(721),
    [anon_sym_DASH] = ACTIONS(721),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_clone] = ACTIONS(721),
    [anon_sym_print] = ACTIONS(721),
    [anon_sym_new] = ACTIONS(721),
    [anon_sym_PLUS_PLUS] = ACTIONS(719),
    [anon_sym_DASH_DASH] = ACTIONS(719),
    [sym_shell_command_expression] = ACTIONS(719),
    [anon_sym_list] = ACTIONS(721),
    [anon_sym_self] = ACTIONS(721),
    [anon_sym_parent] = ACTIONS(721),
    [anon_sym_LBRACK] = ACTIONS(719),
    [sym_string] = ACTIONS(719),
    [sym_boolean] = ACTIONS(721),
    [sym_null] = ACTIONS(721),
    [anon_sym_DOLLAR] = ACTIONS(719),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_include] = ACTIONS(721),
    [anon_sym_include_once] = ACTIONS(721),
    [anon_sym_require] = ACTIONS(721),
    [anon_sym_require_once] = ACTIONS(721),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(723),
    [sym_heredoc] = ACTIONS(719),
  },
  [161] = {
    [sym_text_interpolation] = STATE(161),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(673),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [162] = {
    [sym_text_interpolation] = STATE(162),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(518),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [163] = {
    [sym_text_interpolation] = STATE(163),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(664),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [164] = {
    [sym_text_interpolation] = STATE(164),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(580),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [165] = {
    [sym_text_interpolation] = STATE(165),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(674),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [166] = {
    [sym_text_interpolation] = STATE(166),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(683),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [167] = {
    [sym_text_interpolation] = STATE(167),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(688),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [168] = {
    [sym_text_interpolation] = STATE(168),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(644),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [169] = {
    [sym_text_interpolation] = STATE(169),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(615),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [170] = {
    [sym_text_interpolation] = STATE(170),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(651),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [171] = {
    [sym_text_interpolation] = STATE(171),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(606),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [172] = {
    [sym_text_interpolation] = STATE(172),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(612),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [173] = {
    [sym_text_interpolation] = STATE(173),
    [ts_builtin_sym_end] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(727),
    [anon_sym_use] = ACTIONS(727),
    [anon_sym_BSLASH] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_const] = ACTIONS(727),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_trait] = ACTIONS(727),
    [anon_sym_interface] = ACTIONS(727),
    [anon_sym_class] = ACTIONS(727),
    [anon_sym_abstract] = ACTIONS(727),
    [anon_sym_final] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_array] = ACTIONS(727),
    [anon_sym_unset] = ACTIONS(727),
    [anon_sym_echo] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_enddeclare] = ACTIONS(727),
    [sym_float] = ACTIONS(727),
    [anon_sym_try] = ACTIONS(727),
    [anon_sym_goto] = ACTIONS(727),
    [anon_sym_continue] = ACTIONS(727),
    [anon_sym_break] = ACTIONS(727),
    [sym_integer] = ACTIONS(727),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_throw] = ACTIONS(727),
    [anon_sym_while] = ACTIONS(727),
    [anon_sym_endwhile] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(727),
    [anon_sym_for] = ACTIONS(727),
    [anon_sym_endfor] = ACTIONS(727),
    [anon_sym_foreach] = ACTIONS(727),
    [anon_sym_endforeach] = ACTIONS(727),
    [anon_sym_if] = ACTIONS(727),
    [anon_sym_endif] = ACTIONS(727),
    [anon_sym_elseif] = ACTIONS(727),
    [anon_sym_else] = ACTIONS(727),
    [anon_sym_switch] = ACTIONS(727),
    [anon_sym_endswitch] = ACTIONS(727),
    [anon_sym_case] = ACTIONS(727),
    [anon_sym_default] = ACTIONS(727),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(727),
    [anon_sym_DASH] = ACTIONS(727),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(725),
    [anon_sym_clone] = ACTIONS(727),
    [anon_sym_print] = ACTIONS(727),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_PLUS_PLUS] = ACTIONS(725),
    [anon_sym_DASH_DASH] = ACTIONS(725),
    [sym_shell_command_expression] = ACTIONS(725),
    [anon_sym_list] = ACTIONS(727),
    [anon_sym_self] = ACTIONS(727),
    [anon_sym_parent] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(725),
    [sym_string] = ACTIONS(725),
    [sym_boolean] = ACTIONS(727),
    [sym_null] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_include] = ACTIONS(727),
    [anon_sym_include_once] = ACTIONS(727),
    [anon_sym_require] = ACTIONS(727),
    [anon_sym_require_once] = ACTIONS(727),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(725),
    [sym_heredoc] = ACTIONS(725),
  },
  [174] = {
    [sym_text_interpolation] = STATE(174),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(600),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [175] = {
    [sym_text_interpolation] = STATE(175),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(588),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [176] = {
    [sym_text_interpolation] = STATE(176),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(591),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [177] = {
    [sym_text_interpolation] = STATE(177),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(533),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [178] = {
    [sym_text_interpolation] = STATE(178),
    [ts_builtin_sym_end] = ACTIONS(729),
    [sym_name] = ACTIONS(731),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(733),
    [anon_sym_static] = ACTIONS(731),
    [anon_sym_global] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(731),
    [anon_sym_use] = ACTIONS(731),
    [anon_sym_BSLASH] = ACTIONS(729),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_const] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(729),
    [anon_sym_RBRACE] = ACTIONS(729),
    [anon_sym_trait] = ACTIONS(731),
    [anon_sym_interface] = ACTIONS(731),
    [anon_sym_class] = ACTIONS(731),
    [anon_sym_abstract] = ACTIONS(731),
    [anon_sym_final] = ACTIONS(731),
    [anon_sym_public] = ACTIONS(731),
    [anon_sym_protected] = ACTIONS(731),
    [anon_sym_private] = ACTIONS(731),
    [anon_sym_LPAREN] = ACTIONS(729),
    [anon_sym_array] = ACTIONS(731),
    [anon_sym_unset] = ACTIONS(731),
    [anon_sym_echo] = ACTIONS(731),
    [anon_sym_declare] = ACTIONS(731),
    [anon_sym_enddeclare] = ACTIONS(731),
    [sym_float] = ACTIONS(731),
    [anon_sym_try] = ACTIONS(731),
    [anon_sym_goto] = ACTIONS(731),
    [anon_sym_continue] = ACTIONS(731),
    [anon_sym_break] = ACTIONS(731),
    [sym_integer] = ACTIONS(731),
    [anon_sym_return] = ACTIONS(731),
    [anon_sym_throw] = ACTIONS(731),
    [anon_sym_while] = ACTIONS(731),
    [anon_sym_endwhile] = ACTIONS(731),
    [anon_sym_do] = ACTIONS(731),
    [anon_sym_for] = ACTIONS(731),
    [anon_sym_endfor] = ACTIONS(731),
    [anon_sym_foreach] = ACTIONS(731),
    [anon_sym_endforeach] = ACTIONS(731),
    [anon_sym_if] = ACTIONS(731),
    [anon_sym_endif] = ACTIONS(731),
    [anon_sym_elseif] = ACTIONS(731),
    [anon_sym_else] = ACTIONS(731),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_endswitch] = ACTIONS(731),
    [anon_sym_case] = ACTIONS(731),
    [anon_sym_default] = ACTIONS(731),
    [anon_sym_AT] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(731),
    [anon_sym_TILDE] = ACTIONS(729),
    [anon_sym_BANG] = ACTIONS(729),
    [anon_sym_clone] = ACTIONS(731),
    [anon_sym_print] = ACTIONS(731),
    [anon_sym_new] = ACTIONS(731),
    [anon_sym_PLUS_PLUS] = ACTIONS(729),
    [anon_sym_DASH_DASH] = ACTIONS(729),
    [sym_shell_command_expression] = ACTIONS(729),
    [anon_sym_list] = ACTIONS(731),
    [anon_sym_self] = ACTIONS(731),
    [anon_sym_parent] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(729),
    [sym_string] = ACTIONS(729),
    [sym_boolean] = ACTIONS(731),
    [sym_null] = ACTIONS(731),
    [anon_sym_DOLLAR] = ACTIONS(729),
    [anon_sym_yield] = ACTIONS(731),
    [anon_sym_include] = ACTIONS(731),
    [anon_sym_include_once] = ACTIONS(731),
    [anon_sym_require] = ACTIONS(731),
    [anon_sym_require_once] = ACTIONS(731),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(733),
    [sym_heredoc] = ACTIONS(729),
  },
  [179] = {
    [sym_text_interpolation] = STATE(179),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(655),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [180] = {
    [sym_text_interpolation] = STATE(180),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(598),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [181] = {
    [sym_text_interpolation] = STATE(181),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(496),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [182] = {
    [sym_text_interpolation] = STATE(182),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(542),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [183] = {
    [sym_text_interpolation] = STATE(183),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(495),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [184] = {
    [sym_text_interpolation] = STATE(184),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(531),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [185] = {
    [sym_text_interpolation] = STATE(185),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(576),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [186] = {
    [sym_text_interpolation] = STATE(186),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(604),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [187] = {
    [sym_text_interpolation] = STATE(187),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(497),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [188] = {
    [sym_text_interpolation] = STATE(188),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(603),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [189] = {
    [sym_text_interpolation] = STATE(189),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(558),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [190] = {
    [sym_text_interpolation] = STATE(190),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(601),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [191] = {
    [sym_text_interpolation] = STATE(191),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(593),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [192] = {
    [sym_text_interpolation] = STATE(192),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(590),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [193] = {
    [sym_text_interpolation] = STATE(193),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(562),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [194] = {
    [sym_text_interpolation] = STATE(194),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(563),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [195] = {
    [sym_text_interpolation] = STATE(195),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(564),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [196] = {
    [sym_text_interpolation] = STATE(196),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(585),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [197] = {
    [sym_text_interpolation] = STATE(197),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(572),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [198] = {
    [sym_text_interpolation] = STATE(198),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(573),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [199] = {
    [sym_text_interpolation] = STATE(199),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(574),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [200] = {
    [sym_text_interpolation] = STATE(200),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(575),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [201] = {
    [sym_text_interpolation] = STATE(201),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(544),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [202] = {
    [sym_text_interpolation] = STATE(202),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(540),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [203] = {
    [sym_text_interpolation] = STATE(203),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(663),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [204] = {
    [sym_text_interpolation] = STATE(204),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(534),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [205] = {
    [sym_text_interpolation] = STATE(205),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(559),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [206] = {
    [sym_text_interpolation] = STATE(206),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(507),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [207] = {
    [sym_text_interpolation] = STATE(207),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(682),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [208] = {
    [sym_text_interpolation] = STATE(208),
    [ts_builtin_sym_end] = ACTIONS(735),
    [sym_name] = ACTIONS(737),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_static] = ACTIONS(737),
    [anon_sym_global] = ACTIONS(737),
    [anon_sym_namespace] = ACTIONS(737),
    [anon_sym_use] = ACTIONS(737),
    [anon_sym_BSLASH] = ACTIONS(735),
    [anon_sym_function] = ACTIONS(737),
    [anon_sym_const] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [anon_sym_trait] = ACTIONS(737),
    [anon_sym_interface] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(737),
    [anon_sym_abstract] = ACTIONS(737),
    [anon_sym_final] = ACTIONS(737),
    [anon_sym_public] = ACTIONS(737),
    [anon_sym_protected] = ACTIONS(737),
    [anon_sym_private] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_array] = ACTIONS(737),
    [anon_sym_unset] = ACTIONS(737),
    [anon_sym_echo] = ACTIONS(737),
    [anon_sym_declare] = ACTIONS(737),
    [anon_sym_enddeclare] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_goto] = ACTIONS(737),
    [anon_sym_continue] = ACTIONS(737),
    [anon_sym_break] = ACTIONS(737),
    [sym_integer] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(737),
    [anon_sym_throw] = ACTIONS(737),
    [anon_sym_while] = ACTIONS(737),
    [anon_sym_endwhile] = ACTIONS(737),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(737),
    [anon_sym_endfor] = ACTIONS(737),
    [anon_sym_foreach] = ACTIONS(737),
    [anon_sym_endforeach] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_endif] = ACTIONS(737),
    [anon_sym_elseif] = ACTIONS(737),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_switch] = ACTIONS(737),
    [anon_sym_endswitch] = ACTIONS(737),
    [anon_sym_case] = ACTIONS(737),
    [anon_sym_default] = ACTIONS(737),
    [anon_sym_AT] = ACTIONS(735),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_DASH] = ACTIONS(737),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_BANG] = ACTIONS(735),
    [anon_sym_clone] = ACTIONS(737),
    [anon_sym_print] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(737),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [sym_shell_command_expression] = ACTIONS(735),
    [anon_sym_list] = ACTIONS(737),
    [anon_sym_self] = ACTIONS(737),
    [anon_sym_parent] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(735),
    [sym_string] = ACTIONS(735),
    [sym_boolean] = ACTIONS(737),
    [sym_null] = ACTIONS(737),
    [anon_sym_DOLLAR] = ACTIONS(735),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_include] = ACTIONS(737),
    [anon_sym_include_once] = ACTIONS(737),
    [anon_sym_require] = ACTIONS(737),
    [anon_sym_require_once] = ACTIONS(737),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(739),
    [sym_heredoc] = ACTIONS(735),
  },
  [209] = {
    [sym_text_interpolation] = STATE(209),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(690),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [210] = {
    [sym_text_interpolation] = STATE(210),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(669),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [211] = {
    [sym_text_interpolation] = STATE(211),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(662),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [212] = {
    [sym_text_interpolation] = STATE(212),
    [ts_builtin_sym_end] = ACTIONS(741),
    [sym_name] = ACTIONS(743),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_static] = ACTIONS(743),
    [anon_sym_global] = ACTIONS(743),
    [anon_sym_namespace] = ACTIONS(743),
    [anon_sym_use] = ACTIONS(743),
    [anon_sym_BSLASH] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(743),
    [anon_sym_const] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(741),
    [anon_sym_trait] = ACTIONS(743),
    [anon_sym_interface] = ACTIONS(743),
    [anon_sym_class] = ACTIONS(743),
    [anon_sym_abstract] = ACTIONS(743),
    [anon_sym_final] = ACTIONS(743),
    [anon_sym_public] = ACTIONS(743),
    [anon_sym_protected] = ACTIONS(743),
    [anon_sym_private] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(741),
    [anon_sym_array] = ACTIONS(743),
    [anon_sym_unset] = ACTIONS(743),
    [anon_sym_echo] = ACTIONS(743),
    [anon_sym_declare] = ACTIONS(743),
    [anon_sym_enddeclare] = ACTIONS(743),
    [sym_float] = ACTIONS(743),
    [anon_sym_try] = ACTIONS(743),
    [anon_sym_goto] = ACTIONS(743),
    [anon_sym_continue] = ACTIONS(743),
    [anon_sym_break] = ACTIONS(743),
    [sym_integer] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(743),
    [anon_sym_throw] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [anon_sym_endwhile] = ACTIONS(743),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_for] = ACTIONS(743),
    [anon_sym_endfor] = ACTIONS(743),
    [anon_sym_foreach] = ACTIONS(743),
    [anon_sym_endforeach] = ACTIONS(743),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_endif] = ACTIONS(743),
    [anon_sym_elseif] = ACTIONS(743),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_switch] = ACTIONS(743),
    [anon_sym_endswitch] = ACTIONS(743),
    [anon_sym_case] = ACTIONS(743),
    [anon_sym_default] = ACTIONS(743),
    [anon_sym_AT] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(741),
    [anon_sym_BANG] = ACTIONS(741),
    [anon_sym_clone] = ACTIONS(743),
    [anon_sym_print] = ACTIONS(743),
    [anon_sym_new] = ACTIONS(743),
    [anon_sym_PLUS_PLUS] = ACTIONS(741),
    [anon_sym_DASH_DASH] = ACTIONS(741),
    [sym_shell_command_expression] = ACTIONS(741),
    [anon_sym_list] = ACTIONS(743),
    [anon_sym_self] = ACTIONS(743),
    [anon_sym_parent] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(741),
    [sym_string] = ACTIONS(741),
    [sym_boolean] = ACTIONS(743),
    [sym_null] = ACTIONS(743),
    [anon_sym_DOLLAR] = ACTIONS(741),
    [anon_sym_yield] = ACTIONS(743),
    [anon_sym_include] = ACTIONS(743),
    [anon_sym_include_once] = ACTIONS(743),
    [anon_sym_require] = ACTIONS(743),
    [anon_sym_require_once] = ACTIONS(743),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(745),
    [sym_heredoc] = ACTIONS(741),
  },
  [213] = {
    [sym_text_interpolation] = STATE(213),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(677),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [214] = {
    [sym_text_interpolation] = STATE(214),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(670),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [215] = {
    [sym_text_interpolation] = STATE(215),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(646),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [216] = {
    [sym_text_interpolation] = STATE(216),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(639),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [217] = {
    [sym_text_interpolation] = STATE(217),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(636),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [218] = {
    [sym_text_interpolation] = STATE(218),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(594),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [219] = {
    [sym_text_interpolation] = STATE(219),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(486),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [220] = {
    [sym_text_interpolation] = STATE(220),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(569),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [221] = {
    [sym_text_interpolation] = STATE(221),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(653),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [222] = {
    [sym_text_interpolation] = STATE(222),
    [ts_builtin_sym_end] = ACTIONS(747),
    [sym_name] = ACTIONS(749),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_namespace] = ACTIONS(749),
    [anon_sym_use] = ACTIONS(749),
    [anon_sym_BSLASH] = ACTIONS(747),
    [anon_sym_function] = ACTIONS(749),
    [anon_sym_const] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_RBRACE] = ACTIONS(747),
    [anon_sym_trait] = ACTIONS(749),
    [anon_sym_interface] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(749),
    [anon_sym_abstract] = ACTIONS(749),
    [anon_sym_final] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_array] = ACTIONS(749),
    [anon_sym_unset] = ACTIONS(749),
    [anon_sym_echo] = ACTIONS(749),
    [anon_sym_declare] = ACTIONS(749),
    [anon_sym_enddeclare] = ACTIONS(749),
    [sym_float] = ACTIONS(749),
    [anon_sym_try] = ACTIONS(749),
    [anon_sym_goto] = ACTIONS(749),
    [anon_sym_continue] = ACTIONS(749),
    [anon_sym_break] = ACTIONS(749),
    [sym_integer] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(749),
    [anon_sym_throw] = ACTIONS(749),
    [anon_sym_while] = ACTIONS(749),
    [anon_sym_endwhile] = ACTIONS(749),
    [anon_sym_do] = ACTIONS(749),
    [anon_sym_for] = ACTIONS(749),
    [anon_sym_endfor] = ACTIONS(749),
    [anon_sym_foreach] = ACTIONS(749),
    [anon_sym_endforeach] = ACTIONS(749),
    [anon_sym_if] = ACTIONS(749),
    [anon_sym_endif] = ACTIONS(749),
    [anon_sym_elseif] = ACTIONS(749),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_switch] = ACTIONS(749),
    [anon_sym_endswitch] = ACTIONS(749),
    [anon_sym_case] = ACTIONS(749),
    [anon_sym_default] = ACTIONS(749),
    [anon_sym_AT] = ACTIONS(747),
    [anon_sym_PLUS] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(749),
    [anon_sym_TILDE] = ACTIONS(747),
    [anon_sym_BANG] = ACTIONS(747),
    [anon_sym_clone] = ACTIONS(749),
    [anon_sym_print] = ACTIONS(749),
    [anon_sym_new] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(747),
    [anon_sym_DASH_DASH] = ACTIONS(747),
    [sym_shell_command_expression] = ACTIONS(747),
    [anon_sym_list] = ACTIONS(749),
    [anon_sym_self] = ACTIONS(749),
    [anon_sym_parent] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(747),
    [sym_string] = ACTIONS(747),
    [sym_boolean] = ACTIONS(749),
    [sym_null] = ACTIONS(749),
    [anon_sym_DOLLAR] = ACTIONS(747),
    [anon_sym_yield] = ACTIONS(749),
    [anon_sym_include] = ACTIONS(749),
    [anon_sym_include_once] = ACTIONS(749),
    [anon_sym_require] = ACTIONS(749),
    [anon_sym_require_once] = ACTIONS(749),
    [sym_comment] = ACTIONS(5),
    [sym__automatic_semicolon] = ACTIONS(751),
    [sym_heredoc] = ACTIONS(747),
  },
  [223] = {
    [sym_text_interpolation] = STATE(223),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(503),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [224] = {
    [sym_text_interpolation] = STATE(224),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(667),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [225] = {
    [sym_text_interpolation] = STATE(225),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(505),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [226] = {
    [sym_text_interpolation] = STATE(226),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(509),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [227] = {
    [sym_text_interpolation] = STATE(227),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(510),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [228] = {
    [sym_text_interpolation] = STATE(228),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(515),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [229] = {
    [sym_text_interpolation] = STATE(229),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(592),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [230] = {
    [sym_text_interpolation] = STATE(230),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(484),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [231] = {
    [sym_text_interpolation] = STATE(231),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(523),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [232] = {
    [sym_text_interpolation] = STATE(232),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(524),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [233] = {
    [sym_text_interpolation] = STATE(233),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(525),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [234] = {
    [sym_text_interpolation] = STATE(234),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(526),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [235] = {
    [sym_text_interpolation] = STATE(235),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(527),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [236] = {
    [sym_text_interpolation] = STATE(236),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(643),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [237] = {
    [sym_text_interpolation] = STATE(237),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(532),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [238] = {
    [sym_text_interpolation] = STATE(238),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(535),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [239] = {
    [sym_text_interpolation] = STATE(239),
    [sym_qualified_name] = STATE(551),
    [sym_namespace_name_as_prefix] = STATE(882),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(637),
    [sym__unary_expression] = STATE(611),
    [sym_unary_op_expression] = STATE(596),
    [sym_exponentiation_expression] = STATE(596),
    [sym_clone_expression] = STATE(568),
    [sym__primary_expression] = STATE(568),
    [sym_parenthesized_expression] = STATE(455),
    [sym_class_constant_access_expression] = STATE(516),
    [sym_print_intrinsic] = STATE(584),
    [sym_anonymous_function_creation_expression] = STATE(584),
    [sym_object_creation_expression] = STATE(584),
    [sym_update_expression] = STATE(584),
    [sym_cast_expression] = STATE(596),
    [sym_cast_variable] = STATE(375),
    [sym_assignment_expression] = STATE(605),
    [sym_conditional_expression] = STATE(605),
    [sym_augmented_assignment_expression] = STATE(605),
    [sym_member_access_expression] = STATE(375),
    [sym_scoped_property_access_expression] = STATE(375),
    [sym_list_literal] = STATE(1352),
    [sym_function_call_expression] = STATE(353),
    [sym_scoped_call_expression] = STATE(353),
    [sym__scope_resolution_qualifier] = STATE(1360),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(353),
    [sym__dereferencable_expression] = STATE(931),
    [sym_array_creation_expression] = STATE(437),
    [sym__string] = STATE(455),
    [sym_dynamic_variable_name] = STATE(353),
    [sym_variable_name] = STATE(353),
    [sym_yield_expression] = STATE(605),
    [sym_binary_expression] = STATE(605),
    [sym_include_expression] = STATE(605),
    [sym_include_once_expression] = STATE(605),
    [sym_require_expression] = STATE(605),
    [sym_require_once_expression] = STATE(605),
    [sym__reserved_identifier] = STATE(530),
    [sym_name] = ACTIONS(528),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(530),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(204),
    [anon_sym_array] = ACTIONS(206),
    [sym_float] = ACTIONS(214),
    [sym_integer] = ACTIONS(214),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_DASH] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_clone] = ACTIONS(248),
    [anon_sym_print] = ACTIONS(250),
    [anon_sym_new] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(254),
    [anon_sym_DASH_DASH] = ACTIONS(254),
    [sym_shell_command_expression] = ACTIONS(256),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(260),
    [anon_sym_parent] = ACTIONS(260),
    [anon_sym_LBRACK] = ACTIONS(262),
    [sym_string] = ACTIONS(264),
    [sym_boolean] = ACTIONS(214),
    [sym_null] = ACTIONS(214),
    [anon_sym_DOLLAR] = ACTIONS(266),
    [anon_sym_yield] = ACTIONS(268),
    [anon_sym_include] = ACTIONS(270),
    [anon_sym_include_once] = ACTIONS(272),
    [anon_sym_require] = ACTIONS(274),
    [anon_sym_require_once] = ACTIONS(276),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(264),
  },
  [240] = {
    [sym_text_interpolation] = STATE(240),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(665),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [241] = {
    [sym_text_interpolation] = STATE(241),
    [sym_qualified_name] = STATE(440),
    [sym_namespace_name_as_prefix] = STATE(889),
    [sym_namespace_name] = STATE(1333),
    [sym__expression] = STATE(536),
    [sym__unary_expression] = STATE(528),
    [sym_unary_op_expression] = STATE(520),
    [sym_exponentiation_expression] = STATE(520),
    [sym_clone_expression] = STATE(513),
    [sym__primary_expression] = STATE(513),
    [sym_parenthesized_expression] = STATE(405),
    [sym_class_constant_access_expression] = STATE(431),
    [sym_print_intrinsic] = STATE(545),
    [sym_anonymous_function_creation_expression] = STATE(545),
    [sym_object_creation_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_cast_expression] = STATE(520),
    [sym_cast_variable] = STATE(348),
    [sym_assignment_expression] = STATE(492),
    [sym_conditional_expression] = STATE(492),
    [sym_augmented_assignment_expression] = STATE(492),
    [sym_member_access_expression] = STATE(348),
    [sym_scoped_property_access_expression] = STATE(348),
    [sym_list_literal] = STATE(1381),
    [sym_function_call_expression] = STATE(332),
    [sym_scoped_call_expression] = STATE(332),
    [sym__scope_resolution_qualifier] = STATE(1393),
    [sym_relative_scope] = STATE(1361),
    [sym_member_call_expression] = STATE(332),
    [sym_subscript_expression] = STATE(332),
    [sym__dereferencable_expression] = STATE(902),
    [sym_array_creation_expression] = STATE(386),
    [sym__string] = STATE(405),
    [sym_dynamic_variable_name] = STATE(332),
    [sym_variable_name] = STATE(332),
    [sym_yield_expression] = STATE(492),
    [sym_binary_expression] = STATE(492),
    [sym_include_expression] = STATE(492),
    [sym_include_once_expression] = STATE(492),
    [sym_require_expression] = STATE(492),
    [sym_require_once_expression] = STATE(492),
    [sym__reserved_identifier] = STATE(418),
    [sym_name] = ACTIONS(472),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_static] = ACTIONS(476),
    [anon_sym_namespace] = ACTIONS(478),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_function] = ACTIONS(480),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_array] = ACTIONS(488),
    [sym_float] = ACTIONS(490),
    [sym_integer] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_clone] = ACTIONS(498),
    [anon_sym_print] = ACTIONS(500),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [sym_shell_command_expression] = ACTIONS(506),
    [anon_sym_list] = ACTIONS(258),
    [anon_sym_self] = ACTIONS(508),
    [anon_sym_parent] = ACTIONS(508),
    [anon_sym_LBRACK] = ACTIONS(510),
    [sym_string] = ACTIONS(512),
    [sym_boolean] = ACTIONS(490),
    [sym_null] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(514),
    [anon_sym_yield] = ACTIONS(516),
    [anon_sym_include] = ACTIONS(520),
    [anon_sym_include_once] = ACTIONS(522),
    [anon_sym_require] = ACTIONS(524),
    [anon_sym_require_once] = ACTIONS(526),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(512),
  },
  [242] = {
    [sym_text_interpolation] = STATE(242),
    [ts_builtin_sym_end] = ACTIONS(753),
    [sym_name] = ACTIONS(755),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(753),
    [anon_sym_static] = ACTIONS(755),
    [anon_sym_global] = ACTIONS(755),
    [anon_sym_namespace] = ACTIONS(755),
    [anon_sym_use] = ACTIONS(755),
    [anon_sym_BSLASH] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(755),
    [anon_sym_const] = ACTIONS(755),
    [anon_sym_LBRACE] = ACTIONS(753),
    [anon_sym_RBRACE] = ACTIONS(753),
    [anon_sym_trait] = ACTIONS(755),
    [anon_sym_interface] = ACTIONS(755),
    [anon_sym_class] = ACTIONS(755),
    [anon_sym_abstract] = ACTIONS(755),
    [anon_sym_final] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(755),
    [anon_sym_protected] = ACTIONS(755),
    [anon_sym_private] = ACTIONS(755),
    [anon_sym_LPAREN] = ACTIONS(753),
    [anon_sym_array] = ACTIONS(755),
    [anon_sym_unset] = ACTIONS(755),
    [anon_sym_echo] = ACTIONS(755),
    [anon_sym_declare] = ACTIONS(755),
    [anon_sym_enddeclare] = ACTIONS(755),
    [sym_float] = ACTIONS(755),
    [anon_sym_try] = ACTIONS(755),
    [anon_sym_goto] = ACTIONS(755),
    [anon_sym_continue] = ACTIONS(755),
    [anon_sym_break] = ACTIONS(755),
    [sym_integer] = ACTIONS(755),
    [anon_sym_return] = ACTIONS(755),
    [anon_sym_throw] = ACTIONS(755),
    [anon_sym_while] = ACTIONS(755),
    [anon_sym_endwhile] = ACTIONS(755),
    [anon_sym_do] = ACTIONS(755),
    [anon_sym_for] = ACTIONS(755),
    [anon_sym_endfor] = ACTIONS(755),
    [anon_sym_foreach] = ACTIONS(755),
    [anon_sym_endforeach] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(755),
    [anon_sym_endif] = ACTIONS(755),
    [anon_sym_elseif] = ACTIONS(755),
    [anon_sym_else] = ACTIONS(755),
    [anon_sym_switch] = ACTIONS(755),
    [anon_sym_endswitch] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(755),
    [anon_sym_default] = ACTIONS(755),
    [anon_sym_AT] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(755),
    [anon_sym_DASH] = ACTIONS(755),
    [anon_sym_TILDE] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(753),
    [anon_sym_clone] = ACTIONS(755),
    [anon_sym_print] = ACTIONS(755),
    [anon_sym_new] = ACTIONS(755),
    [anon_sym_PLUS_PLUS] = ACTIONS(753),
    [anon_sym_DASH_DASH] = ACTIONS(753),
    [sym_shell_command_expression] = ACTIONS(753),
    [anon_sym_list] = ACTIONS(755),
    [anon_sym_self] = ACTIONS(755),
    [anon_sym_parent] = ACTIONS(755),
    [anon_sym_LBRACK] = ACTIONS(753),
    [sym_string] = ACTIONS(753),
    [sym_boolean] = ACTIONS(755),
    [sym_null] = ACTIONS(755),
    [anon_sym_DOLLAR] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(755),
    [anon_sym_include] = ACTIONS(755),
    [anon_sym_include_once] = ACTIONS(755),
    [anon_sym_require] = ACTIONS(755),
    [anon_sym_require_once] = ACTIONS(755),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(753),
  },
  [243] = {
    [sym_text_interpolation] = STATE(243),
    [ts_builtin_sym_end] = ACTIONS(757),
    [sym_name] = ACTIONS(759),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(757),
    [anon_sym_static] = ACTIONS(759),
    [anon_sym_global] = ACTIONS(759),
    [anon_sym_namespace] = ACTIONS(759),
    [anon_sym_use] = ACTIONS(759),
    [anon_sym_BSLASH] = ACTIONS(757),
    [anon_sym_function] = ACTIONS(759),
    [anon_sym_const] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(757),
    [anon_sym_RBRACE] = ACTIONS(757),
    [anon_sym_trait] = ACTIONS(759),
    [anon_sym_interface] = ACTIONS(759),
    [anon_sym_class] = ACTIONS(759),
    [anon_sym_abstract] = ACTIONS(759),
    [anon_sym_final] = ACTIONS(759),
    [anon_sym_public] = ACTIONS(759),
    [anon_sym_protected] = ACTIONS(759),
    [anon_sym_private] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(757),
    [anon_sym_array] = ACTIONS(759),
    [anon_sym_unset] = ACTIONS(759),
    [anon_sym_echo] = ACTIONS(759),
    [anon_sym_declare] = ACTIONS(759),
    [anon_sym_enddeclare] = ACTIONS(759),
    [sym_float] = ACTIONS(759),
    [anon_sym_try] = ACTIONS(759),
    [anon_sym_goto] = ACTIONS(759),
    [anon_sym_continue] = ACTIONS(759),
    [anon_sym_break] = ACTIONS(759),
    [sym_integer] = ACTIONS(759),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_throw] = ACTIONS(759),
    [anon_sym_while] = ACTIONS(759),
    [anon_sym_endwhile] = ACTIONS(759),
    [anon_sym_do] = ACTIONS(759),
    [anon_sym_for] = ACTIONS(759),
    [anon_sym_endfor] = ACTIONS(759),
    [anon_sym_foreach] = ACTIONS(759),
    [anon_sym_endforeach] = ACTIONS(759),
    [anon_sym_if] = ACTIONS(759),
    [anon_sym_endif] = ACTIONS(759),
    [anon_sym_elseif] = ACTIONS(759),
    [anon_sym_else] = ACTIONS(759),
    [anon_sym_switch] = ACTIONS(759),
    [anon_sym_endswitch] = ACTIONS(759),
    [anon_sym_case] = ACTIONS(759),
    [anon_sym_default] = ACTIONS(759),
    [anon_sym_AT] = ACTIONS(757),
    [anon_sym_PLUS] = ACTIONS(759),
    [anon_sym_DASH] = ACTIONS(759),
    [anon_sym_TILDE] = ACTIONS(757),
    [anon_sym_BANG] = ACTIONS(757),
    [anon_sym_clone] = ACTIONS(759),
    [anon_sym_print] = ACTIONS(759),
    [anon_sym_new] = ACTIONS(759),
    [anon_sym_PLUS_PLUS] = ACTIONS(757),
    [anon_sym_DASH_DASH] = ACTIONS(757),
    [sym_shell_command_expression] = ACTIONS(757),
    [anon_sym_list] = ACTIONS(759),
    [anon_sym_self] = ACTIONS(759),
    [anon_sym_parent] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(757),
    [sym_string] = ACTIONS(757),
    [sym_boolean] = ACTIONS(759),
    [sym_null] = ACTIONS(759),
    [anon_sym_DOLLAR] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(759),
    [anon_sym_include] = ACTIONS(759),
    [anon_sym_include_once] = ACTIONS(759),
    [anon_sym_require] = ACTIONS(759),
    [anon_sym_require_once] = ACTIONS(759),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(757),
  },
  [244] = {
    [sym_text_interpolation] = STATE(244),
    [ts_builtin_sym_end] = ACTIONS(761),
    [sym_name] = ACTIONS(763),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(761),
    [anon_sym_static] = ACTIONS(763),
    [anon_sym_global] = ACTIONS(763),
    [anon_sym_namespace] = ACTIONS(763),
    [anon_sym_use] = ACTIONS(763),
    [anon_sym_BSLASH] = ACTIONS(761),
    [anon_sym_function] = ACTIONS(763),
    [anon_sym_const] = ACTIONS(763),
    [anon_sym_LBRACE] = ACTIONS(761),
    [anon_sym_RBRACE] = ACTIONS(761),
    [anon_sym_trait] = ACTIONS(763),
    [anon_sym_interface] = ACTIONS(763),
    [anon_sym_class] = ACTIONS(763),
    [anon_sym_abstract] = ACTIONS(763),
    [anon_sym_final] = ACTIONS(763),
    [anon_sym_public] = ACTIONS(763),
    [anon_sym_protected] = ACTIONS(763),
    [anon_sym_private] = ACTIONS(763),
    [anon_sym_LPAREN] = ACTIONS(761),
    [anon_sym_array] = ACTIONS(763),
    [anon_sym_unset] = ACTIONS(763),
    [anon_sym_echo] = ACTIONS(763),
    [anon_sym_declare] = ACTIONS(763),
    [anon_sym_enddeclare] = ACTIONS(763),
    [sym_float] = ACTIONS(763),
    [anon_sym_try] = ACTIONS(763),
    [anon_sym_goto] = ACTIONS(763),
    [anon_sym_continue] = ACTIONS(763),
    [anon_sym_break] = ACTIONS(763),
    [sym_integer] = ACTIONS(763),
    [anon_sym_return] = ACTIONS(763),
    [anon_sym_throw] = ACTIONS(763),
    [anon_sym_while] = ACTIONS(763),
    [anon_sym_endwhile] = ACTIONS(763),
    [anon_sym_do] = ACTIONS(763),
    [anon_sym_for] = ACTIONS(763),
    [anon_sym_endfor] = ACTIONS(763),
    [anon_sym_foreach] = ACTIONS(763),
    [anon_sym_endforeach] = ACTIONS(763),
    [anon_sym_if] = ACTIONS(763),
    [anon_sym_endif] = ACTIONS(763),
    [anon_sym_elseif] = ACTIONS(763),
    [anon_sym_else] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(763),
    [anon_sym_endswitch] = ACTIONS(763),
    [anon_sym_case] = ACTIONS(763),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_AT] = ACTIONS(761),
    [anon_sym_PLUS] = ACTIONS(763),
    [anon_sym_DASH] = ACTIONS(763),
    [anon_sym_TILDE] = ACTIONS(761),
    [anon_sym_BANG] = ACTIONS(761),
    [anon_sym_clone] = ACTIONS(763),
    [anon_sym_print] = ACTIONS(763),
    [anon_sym_new] = ACTIONS(763),
    [anon_sym_PLUS_PLUS] = ACTIONS(761),
    [anon_sym_DASH_DASH] = ACTIONS(761),
    [sym_shell_command_expression] = ACTIONS(761),
    [anon_sym_list] = ACTIONS(763),
    [anon_sym_self] = ACTIONS(763),
    [anon_sym_parent] = ACTIONS(763),
    [anon_sym_LBRACK] = ACTIONS(761),
    [sym_string] = ACTIONS(761),
    [sym_boolean] = ACTIONS(763),
    [sym_null] = ACTIONS(763),
    [anon_sym_DOLLAR] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(763),
    [anon_sym_include] = ACTIONS(763),
    [anon_sym_include_once] = ACTIONS(763),
    [anon_sym_require] = ACTIONS(763),
    [anon_sym_require_once] = ACTIONS(763),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(761),
  },
  [245] = {
    [sym_text_interpolation] = STATE(245),
    [ts_builtin_sym_end] = ACTIONS(765),
    [sym_name] = ACTIONS(767),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(765),
    [anon_sym_static] = ACTIONS(767),
    [anon_sym_global] = ACTIONS(767),
    [anon_sym_namespace] = ACTIONS(767),
    [anon_sym_use] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(767),
    [anon_sym_const] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_RBRACE] = ACTIONS(765),
    [anon_sym_trait] = ACTIONS(767),
    [anon_sym_interface] = ACTIONS(767),
    [anon_sym_class] = ACTIONS(767),
    [anon_sym_abstract] = ACTIONS(767),
    [anon_sym_final] = ACTIONS(767),
    [anon_sym_public] = ACTIONS(767),
    [anon_sym_protected] = ACTIONS(767),
    [anon_sym_private] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(765),
    [anon_sym_array] = ACTIONS(767),
    [anon_sym_unset] = ACTIONS(767),
    [anon_sym_echo] = ACTIONS(767),
    [anon_sym_declare] = ACTIONS(767),
    [anon_sym_enddeclare] = ACTIONS(767),
    [sym_float] = ACTIONS(767),
    [anon_sym_try] = ACTIONS(767),
    [anon_sym_goto] = ACTIONS(767),
    [anon_sym_continue] = ACTIONS(767),
    [anon_sym_break] = ACTIONS(767),
    [sym_integer] = ACTIONS(767),
    [anon_sym_return] = ACTIONS(767),
    [anon_sym_throw] = ACTIONS(767),
    [anon_sym_while] = ACTIONS(767),
    [anon_sym_endwhile] = ACTIONS(767),
    [anon_sym_do] = ACTIONS(767),
    [anon_sym_for] = ACTIONS(767),
    [anon_sym_endfor] = ACTIONS(767),
    [anon_sym_foreach] = ACTIONS(767),
    [anon_sym_endforeach] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_endif] = ACTIONS(767),
    [anon_sym_elseif] = ACTIONS(767),
    [anon_sym_else] = ACTIONS(767),
    [anon_sym_switch] = ACTIONS(767),
    [anon_sym_endswitch] = ACTIONS(767),
    [anon_sym_case] = ACTIONS(767),
    [anon_sym_default] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(765),
    [anon_sym_BANG] = ACTIONS(765),
    [anon_sym_clone] = ACTIONS(767),
    [anon_sym_print] = ACTIONS(767),
    [anon_sym_new] = ACTIONS(767),
    [anon_sym_PLUS_PLUS] = ACTIONS(765),
    [anon_sym_DASH_DASH] = ACTIONS(765),
    [sym_shell_command_expression] = ACTIONS(765),
    [anon_sym_list] = ACTIONS(767),
    [anon_sym_self] = ACTIONS(767),
    [anon_sym_parent] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(765),
    [sym_string] = ACTIONS(765),
    [sym_boolean] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(767),
    [anon_sym_include] = ACTIONS(767),
    [anon_sym_include_once] = ACTIONS(767),
    [anon_sym_require] = ACTIONS(767),
    [anon_sym_require_once] = ACTIONS(767),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(765),
  },
  [246] = {
    [sym_text_interpolation] = STATE(246),
    [ts_builtin_sym_end] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_static] = ACTIONS(771),
    [anon_sym_global] = ACTIONS(771),
    [anon_sym_namespace] = ACTIONS(771),
    [anon_sym_use] = ACTIONS(771),
    [anon_sym_BSLASH] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(771),
    [anon_sym_const] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(769),
    [anon_sym_RBRACE] = ACTIONS(769),
    [anon_sym_trait] = ACTIONS(771),
    [anon_sym_interface] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(771),
    [anon_sym_abstract] = ACTIONS(771),
    [anon_sym_final] = ACTIONS(771),
    [anon_sym_public] = ACTIONS(771),
    [anon_sym_protected] = ACTIONS(771),
    [anon_sym_private] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(769),
    [anon_sym_array] = ACTIONS(771),
    [anon_sym_unset] = ACTIONS(771),
    [anon_sym_echo] = ACTIONS(771),
    [anon_sym_declare] = ACTIONS(771),
    [anon_sym_enddeclare] = ACTIONS(771),
    [sym_float] = ACTIONS(771),
    [anon_sym_try] = ACTIONS(771),
    [anon_sym_goto] = ACTIONS(771),
    [anon_sym_continue] = ACTIONS(771),
    [anon_sym_break] = ACTIONS(771),
    [sym_integer] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(771),
    [anon_sym_throw] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_endwhile] = ACTIONS(771),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_endfor] = ACTIONS(771),
    [anon_sym_foreach] = ACTIONS(771),
    [anon_sym_endforeach] = ACTIONS(771),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_endif] = ACTIONS(771),
    [anon_sym_elseif] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_switch] = ACTIONS(771),
    [anon_sym_endswitch] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(771),
    [anon_sym_default] = ACTIONS(771),
    [anon_sym_AT] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_TILDE] = ACTIONS(769),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_clone] = ACTIONS(771),
    [anon_sym_print] = ACTIONS(771),
    [anon_sym_new] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(769),
    [anon_sym_DASH_DASH] = ACTIONS(769),
    [sym_shell_command_expression] = ACTIONS(769),
    [anon_sym_list] = ACTIONS(771),
    [anon_sym_self] = ACTIONS(771),
    [anon_sym_parent] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(769),
    [sym_string] = ACTIONS(769),
    [sym_boolean] = ACTIONS(771),
    [sym_null] = ACTIONS(771),
    [anon_sym_DOLLAR] = ACTIONS(769),
    [anon_sym_yield] = ACTIONS(771),
    [anon_sym_include] = ACTIONS(771),
    [anon_sym_include_once] = ACTIONS(771),
    [anon_sym_require] = ACTIONS(771),
    [anon_sym_require_once] = ACTIONS(771),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(769),
  },
  [247] = {
    [sym_text_interpolation] = STATE(247),
    [ts_builtin_sym_end] = ACTIONS(773),
    [sym_name] = ACTIONS(775),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(773),
    [anon_sym_static] = ACTIONS(775),
    [anon_sym_global] = ACTIONS(775),
    [anon_sym_namespace] = ACTIONS(775),
    [anon_sym_use] = ACTIONS(775),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(775),
    [anon_sym_const] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(773),
    [anon_sym_RBRACE] = ACTIONS(773),
    [anon_sym_trait] = ACTIONS(775),
    [anon_sym_interface] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(775),
    [anon_sym_abstract] = ACTIONS(775),
    [anon_sym_final] = ACTIONS(775),
    [anon_sym_public] = ACTIONS(775),
    [anon_sym_protected] = ACTIONS(775),
    [anon_sym_private] = ACTIONS(775),
    [anon_sym_LPAREN] = ACTIONS(773),
    [anon_sym_array] = ACTIONS(775),
    [anon_sym_unset] = ACTIONS(775),
    [anon_sym_echo] = ACTIONS(775),
    [anon_sym_declare] = ACTIONS(775),
    [anon_sym_enddeclare] = ACTIONS(775),
    [sym_float] = ACTIONS(775),
    [anon_sym_try] = ACTIONS(775),
    [anon_sym_goto] = ACTIONS(775),
    [anon_sym_continue] = ACTIONS(775),
    [anon_sym_break] = ACTIONS(775),
    [sym_integer] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(775),
    [anon_sym_throw] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_endwhile] = ACTIONS(775),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(775),
    [anon_sym_endfor] = ACTIONS(775),
    [anon_sym_foreach] = ACTIONS(775),
    [anon_sym_endforeach] = ACTIONS(775),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_endif] = ACTIONS(775),
    [anon_sym_elseif] = ACTIONS(775),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_switch] = ACTIONS(775),
    [anon_sym_endswitch] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(775),
    [anon_sym_default] = ACTIONS(775),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_DASH] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(773),
    [anon_sym_clone] = ACTIONS(775),
    [anon_sym_print] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(775),
    [anon_sym_PLUS_PLUS] = ACTIONS(773),
    [anon_sym_DASH_DASH] = ACTIONS(773),
    [sym_shell_command_expression] = ACTIONS(773),
    [anon_sym_list] = ACTIONS(775),
    [anon_sym_self] = ACTIONS(775),
    [anon_sym_parent] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(773),
    [sym_string] = ACTIONS(773),
    [sym_boolean] = ACTIONS(775),
    [sym_null] = ACTIONS(775),
    [anon_sym_DOLLAR] = ACTIONS(773),
    [anon_sym_yield] = ACTIONS(775),
    [anon_sym_include] = ACTIONS(775),
    [anon_sym_include_once] = ACTIONS(775),
    [anon_sym_require] = ACTIONS(775),
    [anon_sym_require_once] = ACTIONS(775),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(773),
  },
  [248] = {
    [sym_text_interpolation] = STATE(248),
    [ts_builtin_sym_end] = ACTIONS(769),
    [sym_name] = ACTIONS(771),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_static] = ACTIONS(771),
    [anon_sym_global] = ACTIONS(771),
    [anon_sym_namespace] = ACTIONS(771),
    [anon_sym_use] = ACTIONS(771),
    [anon_sym_BSLASH] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(771),
    [anon_sym_const] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(769),
    [anon_sym_RBRACE] = ACTIONS(769),
    [anon_sym_trait] = ACTIONS(771),
    [anon_sym_interface] = ACTIONS(771),
    [anon_sym_class] = ACTIONS(771),
    [anon_sym_abstract] = ACTIONS(771),
    [anon_sym_final] = ACTIONS(771),
    [anon_sym_public] = ACTIONS(771),
    [anon_sym_protected] = ACTIONS(771),
    [anon_sym_private] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(769),
    [anon_sym_array] = ACTIONS(771),
    [anon_sym_unset] = ACTIONS(771),
    [anon_sym_echo] = ACTIONS(771),
    [anon_sym_declare] = ACTIONS(771),
    [anon_sym_enddeclare] = ACTIONS(771),
    [sym_float] = ACTIONS(771),
    [anon_sym_try] = ACTIONS(771),
    [anon_sym_goto] = ACTIONS(771),
    [anon_sym_continue] = ACTIONS(771),
    [anon_sym_break] = ACTIONS(771),
    [sym_integer] = ACTIONS(771),
    [anon_sym_return] = ACTIONS(771),
    [anon_sym_throw] = ACTIONS(771),
    [anon_sym_while] = ACTIONS(771),
    [anon_sym_endwhile] = ACTIONS(771),
    [anon_sym_do] = ACTIONS(771),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_endfor] = ACTIONS(771),
    [anon_sym_foreach] = ACTIONS(771),
    [anon_sym_endforeach] = ACTIONS(771),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_endif] = ACTIONS(771),
    [anon_sym_elseif] = ACTIONS(771),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_switch] = ACTIONS(771),
    [anon_sym_endswitch] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(771),
    [anon_sym_default] = ACTIONS(771),
    [anon_sym_AT] = ACTIONS(769),
    [anon_sym_PLUS] = ACTIONS(771),
    [anon_sym_DASH] = ACTIONS(771),
    [anon_sym_TILDE] = ACTIONS(769),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_clone] = ACTIONS(771),
    [anon_sym_print] = ACTIONS(771),
    [anon_sym_new] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(769),
    [anon_sym_DASH_DASH] = ACTIONS(769),
    [sym_shell_command_expression] = ACTIONS(769),
    [anon_sym_list] = ACTIONS(771),
    [anon_sym_self] = ACTIONS(771),
    [anon_sym_parent] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(769),
    [sym_string] = ACTIONS(769),
    [sym_boolean] = ACTIONS(771),
    [sym_null] = ACTIONS(771),
    [anon_sym_DOLLAR] = ACTIONS(769),
    [anon_sym_yield] = ACTIONS(771),
    [anon_sym_include] = ACTIONS(771),
    [anon_sym_include_once] = ACTIONS(771),
    [anon_sym_require] = ACTIONS(771),
    [anon_sym_require_once] = ACTIONS(771),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(769),
  },
  [249] = {
    [sym_text_interpolation] = STATE(249),
    [ts_builtin_sym_end] = ACTIONS(777),
    [sym_name] = ACTIONS(779),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(777),
    [anon_sym_static] = ACTIONS(779),
    [anon_sym_global] = ACTIONS(779),
    [anon_sym_namespace] = ACTIONS(779),
    [anon_sym_use] = ACTIONS(779),
    [anon_sym_BSLASH] = ACTIONS(777),
    [anon_sym_function] = ACTIONS(779),
    [anon_sym_const] = ACTIONS(779),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_trait] = ACTIONS(779),
    [anon_sym_interface] = ACTIONS(779),
    [anon_sym_class] = ACTIONS(779),
    [anon_sym_abstract] = ACTIONS(779),
    [anon_sym_final] = ACTIONS(779),
    [anon_sym_public] = ACTIONS(779),
    [anon_sym_protected] = ACTIONS(779),
    [anon_sym_private] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(777),
    [anon_sym_array] = ACTIONS(779),
    [anon_sym_unset] = ACTIONS(779),
    [anon_sym_echo] = ACTIONS(779),
    [anon_sym_declare] = ACTIONS(779),
    [anon_sym_enddeclare] = ACTIONS(779),
    [sym_float] = ACTIONS(779),
    [anon_sym_try] = ACTIONS(779),
    [anon_sym_goto] = ACTIONS(779),
    [anon_sym_continue] = ACTIONS(779),
    [anon_sym_break] = ACTIONS(779),
    [sym_integer] = ACTIONS(779),
    [anon_sym_return] = ACTIONS(779),
    [anon_sym_throw] = ACTIONS(779),
    [anon_sym_while] = ACTIONS(779),
    [anon_sym_endwhile] = ACTIONS(779),
    [anon_sym_do] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(779),
    [anon_sym_endfor] = ACTIONS(779),
    [anon_sym_foreach] = ACTIONS(779),
    [anon_sym_endforeach] = ACTIONS(779),
    [anon_sym_if] = ACTIONS(779),
    [anon_sym_endif] = ACTIONS(779),
    [anon_sym_elseif] = ACTIONS(779),
    [anon_sym_else] = ACTIONS(779),
    [anon_sym_switch] = ACTIONS(779),
    [anon_sym_endswitch] = ACTIONS(779),
    [anon_sym_case] = ACTIONS(779),
    [anon_sym_default] = ACTIONS(779),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_TILDE] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(777),
    [anon_sym_clone] = ACTIONS(779),
    [anon_sym_print] = ACTIONS(779),
    [anon_sym_new] = ACTIONS(779),
    [anon_sym_PLUS_PLUS] = ACTIONS(777),
    [anon_sym_DASH_DASH] = ACTIONS(777),
    [sym_shell_command_expression] = ACTIONS(777),
    [anon_sym_list] = ACTIONS(779),
    [anon_sym_self] = ACTIONS(779),
    [anon_sym_parent] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(777),
    [sym_string] = ACTIONS(777),
    [sym_boolean] = ACTIONS(779),
    [sym_null] = ACTIONS(779),
    [anon_sym_DOLLAR] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(779),
    [anon_sym_include] = ACTIONS(779),
    [anon_sym_include_once] = ACTIONS(779),
    [anon_sym_require] = ACTIONS(779),
    [anon_sym_require_once] = ACTIONS(779),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(777),
  },
  [250] = {
    [sym_text_interpolation] = STATE(250),
    [ts_builtin_sym_end] = ACTIONS(781),
    [sym_name] = ACTIONS(783),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(781),
    [anon_sym_static] = ACTIONS(783),
    [anon_sym_global] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(783),
    [anon_sym_use] = ACTIONS(783),
    [anon_sym_BSLASH] = ACTIONS(781),
    [anon_sym_function] = ACTIONS(783),
    [anon_sym_const] = ACTIONS(783),
    [anon_sym_LBRACE] = ACTIONS(781),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_trait] = ACTIONS(783),
    [anon_sym_interface] = ACTIONS(783),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_abstract] = ACTIONS(783),
    [anon_sym_final] = ACTIONS(783),
    [anon_sym_public] = ACTIONS(783),
    [anon_sym_protected] = ACTIONS(783),
    [anon_sym_private] = ACTIONS(783),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_array] = ACTIONS(783),
    [anon_sym_unset] = ACTIONS(783),
    [anon_sym_echo] = ACTIONS(783),
    [anon_sym_declare] = ACTIONS(783),
    [anon_sym_enddeclare] = ACTIONS(783),
    [sym_float] = ACTIONS(783),
    [anon_sym_try] = ACTIONS(783),
    [anon_sym_goto] = ACTIONS(783),
    [anon_sym_continue] = ACTIONS(783),
    [anon_sym_break] = ACTIONS(783),
    [sym_integer] = ACTIONS(783),
    [anon_sym_return] = ACTIONS(783),
    [anon_sym_throw] = ACTIONS(783),
    [anon_sym_while] = ACTIONS(783),
    [anon_sym_endwhile] = ACTIONS(783),
    [anon_sym_do] = ACTIONS(783),
    [anon_sym_for] = ACTIONS(783),
    [anon_sym_endfor] = ACTIONS(783),
    [anon_sym_foreach] = ACTIONS(783),
    [anon_sym_endforeach] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(783),
    [anon_sym_endif] = ACTIONS(783),
    [anon_sym_elseif] = ACTIONS(783),
    [anon_sym_else] = ACTIONS(783),
    [anon_sym_switch] = ACTIONS(783),
    [anon_sym_endswitch] = ACTIONS(783),
    [anon_sym_case] = ACTIONS(783),
    [anon_sym_default] = ACTIONS(783),
    [anon_sym_AT] = ACTIONS(781),
    [anon_sym_PLUS] = ACTIONS(783),
    [anon_sym_DASH] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(781),
    [anon_sym_clone] = ACTIONS(783),
    [anon_sym_print] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(783),
    [anon_sym_PLUS_PLUS] = ACTIONS(781),
    [anon_sym_DASH_DASH] = ACTIONS(781),
    [sym_shell_command_expression] = ACTIONS(781),
    [anon_sym_list] = ACTIONS(783),
    [anon_sym_self] = ACTIONS(783),
    [anon_sym_parent] = ACTIONS(783),
    [anon_sym_LBRACK] = ACTIONS(781),
    [sym_string] = ACTIONS(781),
    [sym_boolean] = ACTIONS(783),
    [sym_null] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(783),
    [anon_sym_include] = ACTIONS(783),
    [anon_sym_include_once] = ACTIONS(783),
    [anon_sym_require] = ACTIONS(783),
    [anon_sym_require_once] = ACTIONS(783),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(781),
  },
  [251] = {
    [sym_text_interpolation] = STATE(251),
    [ts_builtin_sym_end] = ACTIONS(785),
    [sym_name] = ACTIONS(787),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_static] = ACTIONS(787),
    [anon_sym_global] = ACTIONS(787),
    [anon_sym_namespace] = ACTIONS(787),
    [anon_sym_use] = ACTIONS(787),
    [anon_sym_BSLASH] = ACTIONS(785),
    [anon_sym_function] = ACTIONS(787),
    [anon_sym_const] = ACTIONS(787),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_RBRACE] = ACTIONS(785),
    [anon_sym_trait] = ACTIONS(787),
    [anon_sym_interface] = ACTIONS(787),
    [anon_sym_class] = ACTIONS(787),
    [anon_sym_abstract] = ACTIONS(787),
    [anon_sym_final] = ACTIONS(787),
    [anon_sym_public] = ACTIONS(787),
    [anon_sym_protected] = ACTIONS(787),
    [anon_sym_private] = ACTIONS(787),
    [anon_sym_LPAREN] = ACTIONS(785),
    [anon_sym_array] = ACTIONS(787),
    [anon_sym_unset] = ACTIONS(787),
    [anon_sym_echo] = ACTIONS(787),
    [anon_sym_declare] = ACTIONS(787),
    [anon_sym_enddeclare] = ACTIONS(787),
    [sym_float] = ACTIONS(787),
    [anon_sym_try] = ACTIONS(787),
    [anon_sym_goto] = ACTIONS(787),
    [anon_sym_continue] = ACTIONS(787),
    [anon_sym_break] = ACTIONS(787),
    [sym_integer] = ACTIONS(787),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_throw] = ACTIONS(787),
    [anon_sym_while] = ACTIONS(787),
    [anon_sym_endwhile] = ACTIONS(787),
    [anon_sym_do] = ACTIONS(787),
    [anon_sym_for] = ACTIONS(787),
    [anon_sym_endfor] = ACTIONS(787),
    [anon_sym_foreach] = ACTIONS(787),
    [anon_sym_endforeach] = ACTIONS(787),
    [anon_sym_if] = ACTIONS(787),
    [anon_sym_endif] = ACTIONS(787),
    [anon_sym_elseif] = ACTIONS(787),
    [anon_sym_else] = ACTIONS(787),
    [anon_sym_switch] = ACTIONS(787),
    [anon_sym_endswitch] = ACTIONS(787),
    [anon_sym_case] = ACTIONS(787),
    [anon_sym_default] = ACTIONS(787),
    [anon_sym_AT] = ACTIONS(785),
    [anon_sym_PLUS] = ACTIONS(787),
    [anon_sym_DASH] = ACTIONS(787),
    [anon_sym_TILDE] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(785),
    [anon_sym_clone] = ACTIONS(787),
    [anon_sym_print] = ACTIONS(787),
    [anon_sym_new] = ACTIONS(787),
    [anon_sym_PLUS_PLUS] = ACTIONS(785),
    [anon_sym_DASH_DASH] = ACTIONS(785),
    [sym_shell_command_expression] = ACTIONS(785),
    [anon_sym_list] = ACTIONS(787),
    [anon_sym_self] = ACTIONS(787),
    [anon_sym_parent] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(785),
    [sym_string] = ACTIONS(785),
    [sym_boolean] = ACTIONS(787),
    [sym_null] = ACTIONS(787),
    [anon_sym_DOLLAR] = ACTIONS(785),
    [anon_sym_yield] = ACTIONS(787),
    [anon_sym_include] = ACTIONS(787),
    [anon_sym_include_once] = ACTIONS(787),
    [anon_sym_require] = ACTIONS(787),
    [anon_sym_require_once] = ACTIONS(787),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(785),
  },
  [252] = {
    [sym_text_interpolation] = STATE(252),
    [ts_builtin_sym_end] = ACTIONS(789),
    [sym_name] = ACTIONS(791),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(789),
    [anon_sym_static] = ACTIONS(791),
    [anon_sym_global] = ACTIONS(791),
    [anon_sym_namespace] = ACTIONS(791),
    [anon_sym_use] = ACTIONS(791),
    [anon_sym_BSLASH] = ACTIONS(789),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_const] = ACTIONS(791),
    [anon_sym_LBRACE] = ACTIONS(789),
    [anon_sym_RBRACE] = ACTIONS(789),
    [anon_sym_trait] = ACTIONS(791),
    [anon_sym_interface] = ACTIONS(791),
    [anon_sym_class] = ACTIONS(791),
    [anon_sym_abstract] = ACTIONS(791),
    [anon_sym_final] = ACTIONS(791),
    [anon_sym_public] = ACTIONS(791),
    [anon_sym_protected] = ACTIONS(791),
    [anon_sym_private] = ACTIONS(791),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_array] = ACTIONS(791),
    [anon_sym_unset] = ACTIONS(791),
    [anon_sym_echo] = ACTIONS(791),
    [anon_sym_declare] = ACTIONS(791),
    [anon_sym_enddeclare] = ACTIONS(791),
    [sym_float] = ACTIONS(791),
    [anon_sym_try] = ACTIONS(791),
    [anon_sym_goto] = ACTIONS(791),
    [anon_sym_continue] = ACTIONS(791),
    [anon_sym_break] = ACTIONS(791),
    [sym_integer] = ACTIONS(791),
    [anon_sym_return] = ACTIONS(791),
    [anon_sym_throw] = ACTIONS(791),
    [anon_sym_while] = ACTIONS(791),
    [anon_sym_endwhile] = ACTIONS(791),
    [anon_sym_do] = ACTIONS(791),
    [anon_sym_for] = ACTIONS(791),
    [anon_sym_endfor] = ACTIONS(791),
    [anon_sym_foreach] = ACTIONS(791),
    [anon_sym_endforeach] = ACTIONS(791),
    [anon_sym_if] = ACTIONS(791),
    [anon_sym_endif] = ACTIONS(791),
    [anon_sym_elseif] = ACTIONS(791),
    [anon_sym_else] = ACTIONS(791),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_endswitch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(791),
    [anon_sym_default] = ACTIONS(791),
    [anon_sym_AT] = ACTIONS(789),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(789),
    [anon_sym_BANG] = ACTIONS(789),
    [anon_sym_clone] = ACTIONS(791),
    [anon_sym_print] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(791),
    [anon_sym_PLUS_PLUS] = ACTIONS(789),
    [anon_sym_DASH_DASH] = ACTIONS(789),
    [sym_shell_command_expression] = ACTIONS(789),
    [anon_sym_list] = ACTIONS(791),
    [anon_sym_self] = ACTIONS(791),
    [anon_sym_parent] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(789),
    [sym_string] = ACTIONS(789),
    [sym_boolean] = ACTIONS(791),
    [sym_null] = ACTIONS(791),
    [anon_sym_DOLLAR] = ACTIONS(789),
    [anon_sym_yield] = ACTIONS(791),
    [anon_sym_include] = ACTIONS(791),
    [anon_sym_include_once] = ACTIONS(791),
    [anon_sym_require] = ACTIONS(791),
    [anon_sym_require_once] = ACTIONS(791),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(789),
  },
  [253] = {
    [sym_text_interpolation] = STATE(253),
    [ts_builtin_sym_end] = ACTIONS(793),
    [sym_name] = ACTIONS(795),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(793),
    [anon_sym_static] = ACTIONS(795),
    [anon_sym_global] = ACTIONS(795),
    [anon_sym_namespace] = ACTIONS(795),
    [anon_sym_use] = ACTIONS(795),
    [anon_sym_BSLASH] = ACTIONS(793),
    [anon_sym_function] = ACTIONS(795),
    [anon_sym_const] = ACTIONS(795),
    [anon_sym_LBRACE] = ACTIONS(793),
    [anon_sym_RBRACE] = ACTIONS(793),
    [anon_sym_trait] = ACTIONS(795),
    [anon_sym_interface] = ACTIONS(795),
    [anon_sym_class] = ACTIONS(795),
    [anon_sym_abstract] = ACTIONS(795),
    [anon_sym_final] = ACTIONS(795),
    [anon_sym_public] = ACTIONS(795),
    [anon_sym_protected] = ACTIONS(795),
    [anon_sym_private] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_array] = ACTIONS(795),
    [anon_sym_unset] = ACTIONS(795),
    [anon_sym_echo] = ACTIONS(795),
    [anon_sym_declare] = ACTIONS(795),
    [anon_sym_enddeclare] = ACTIONS(795),
    [sym_float] = ACTIONS(795),
    [anon_sym_try] = ACTIONS(795),
    [anon_sym_goto] = ACTIONS(795),
    [anon_sym_continue] = ACTIONS(795),
    [anon_sym_break] = ACTIONS(795),
    [sym_integer] = ACTIONS(795),
    [anon_sym_return] = ACTIONS(795),
    [anon_sym_throw] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(795),
    [anon_sym_endwhile] = ACTIONS(795),
    [anon_sym_do] = ACTIONS(795),
    [anon_sym_for] = ACTIONS(795),
    [anon_sym_endfor] = ACTIONS(795),
    [anon_sym_foreach] = ACTIONS(795),
    [anon_sym_endforeach] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(795),
    [anon_sym_endif] = ACTIONS(795),
    [anon_sym_elseif] = ACTIONS(795),
    [anon_sym_else] = ACTIONS(795),
    [anon_sym_switch] = ACTIONS(795),
    [anon_sym_endswitch] = ACTIONS(795),
    [anon_sym_case] = ACTIONS(795),
    [anon_sym_default] = ACTIONS(795),
    [anon_sym_AT] = ACTIONS(793),
    [anon_sym_PLUS] = ACTIONS(795),
    [anon_sym_DASH] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(793),
    [anon_sym_BANG] = ACTIONS(793),
    [anon_sym_clone] = ACTIONS(795),
    [anon_sym_print] = ACTIONS(795),
    [anon_sym_new] = ACTIONS(795),
    [anon_sym_PLUS_PLUS] = ACTIONS(793),
    [anon_sym_DASH_DASH] = ACTIONS(793),
    [sym_shell_command_expression] = ACTIONS(793),
    [anon_sym_list] = ACTIONS(795),
    [anon_sym_self] = ACTIONS(795),
    [anon_sym_parent] = ACTIONS(795),
    [anon_sym_LBRACK] = ACTIONS(793),
    [sym_string] = ACTIONS(793),
    [sym_boolean] = ACTIONS(795),
    [sym_null] = ACTIONS(795),
    [anon_sym_DOLLAR] = ACTIONS(793),
    [anon_sym_yield] = ACTIONS(795),
    [anon_sym_include] = ACTIONS(795),
    [anon_sym_include_once] = ACTIONS(795),
    [anon_sym_require] = ACTIONS(795),
    [anon_sym_require_once] = ACTIONS(795),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(793),
  },
  [254] = {
    [sym_text_interpolation] = STATE(254),
    [ts_builtin_sym_end] = ACTIONS(797),
    [sym_name] = ACTIONS(799),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(797),
    [anon_sym_static] = ACTIONS(799),
    [anon_sym_global] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(799),
    [anon_sym_use] = ACTIONS(799),
    [anon_sym_BSLASH] = ACTIONS(797),
    [anon_sym_function] = ACTIONS(799),
    [anon_sym_const] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(797),
    [anon_sym_RBRACE] = ACTIONS(797),
    [anon_sym_trait] = ACTIONS(799),
    [anon_sym_interface] = ACTIONS(799),
    [anon_sym_class] = ACTIONS(799),
    [anon_sym_abstract] = ACTIONS(799),
    [anon_sym_final] = ACTIONS(799),
    [anon_sym_public] = ACTIONS(799),
    [anon_sym_protected] = ACTIONS(799),
    [anon_sym_private] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_array] = ACTIONS(799),
    [anon_sym_unset] = ACTIONS(799),
    [anon_sym_echo] = ACTIONS(799),
    [anon_sym_declare] = ACTIONS(799),
    [anon_sym_enddeclare] = ACTIONS(799),
    [sym_float] = ACTIONS(799),
    [anon_sym_try] = ACTIONS(799),
    [anon_sym_goto] = ACTIONS(799),
    [anon_sym_continue] = ACTIONS(799),
    [anon_sym_break] = ACTIONS(799),
    [sym_integer] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_throw] = ACTIONS(799),
    [anon_sym_while] = ACTIONS(799),
    [anon_sym_endwhile] = ACTIONS(799),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_endfor] = ACTIONS(799),
    [anon_sym_foreach] = ACTIONS(799),
    [anon_sym_endforeach] = ACTIONS(799),
    [anon_sym_if] = ACTIONS(799),
    [anon_sym_endif] = ACTIONS(799),
    [anon_sym_elseif] = ACTIONS(799),
    [anon_sym_else] = ACTIONS(799),
    [anon_sym_switch] = ACTIONS(799),
    [anon_sym_endswitch] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(799),
    [anon_sym_default] = ACTIONS(799),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_TILDE] = ACTIONS(797),
    [anon_sym_BANG] = ACTIONS(797),
    [anon_sym_clone] = ACTIONS(799),
    [anon_sym_print] = ACTIONS(799),
    [anon_sym_new] = ACTIONS(799),
    [anon_sym_PLUS_PLUS] = ACTIONS(797),
    [anon_sym_DASH_DASH] = ACTIONS(797),
    [sym_shell_command_expression] = ACTIONS(797),
    [anon_sym_list] = ACTIONS(799),
    [anon_sym_self] = ACTIONS(799),
    [anon_sym_parent] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(797),
    [sym_string] = ACTIONS(797),
    [sym_boolean] = ACTIONS(799),
    [sym_null] = ACTIONS(799),
    [anon_sym_DOLLAR] = ACTIONS(797),
    [anon_sym_yield] = ACTIONS(799),
    [anon_sym_include] = ACTIONS(799),
    [anon_sym_include_once] = ACTIONS(799),
    [anon_sym_require] = ACTIONS(799),
    [anon_sym_require_once] = ACTIONS(799),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(797),
  },
  [255] = {
    [sym_text_interpolation] = STATE(255),
    [ts_builtin_sym_end] = ACTIONS(801),
    [sym_name] = ACTIONS(803),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(801),
    [anon_sym_static] = ACTIONS(803),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_namespace] = ACTIONS(803),
    [anon_sym_use] = ACTIONS(803),
    [anon_sym_BSLASH] = ACTIONS(801),
    [anon_sym_function] = ACTIONS(803),
    [anon_sym_const] = ACTIONS(803),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(801),
    [anon_sym_trait] = ACTIONS(803),
    [anon_sym_interface] = ACTIONS(803),
    [anon_sym_class] = ACTIONS(803),
    [anon_sym_abstract] = ACTIONS(803),
    [anon_sym_final] = ACTIONS(803),
    [anon_sym_public] = ACTIONS(803),
    [anon_sym_protected] = ACTIONS(803),
    [anon_sym_private] = ACTIONS(803),
    [anon_sym_LPAREN] = ACTIONS(801),
    [anon_sym_array] = ACTIONS(803),
    [anon_sym_unset] = ACTIONS(803),
    [anon_sym_echo] = ACTIONS(803),
    [anon_sym_declare] = ACTIONS(803),
    [anon_sym_enddeclare] = ACTIONS(803),
    [sym_float] = ACTIONS(803),
    [anon_sym_try] = ACTIONS(803),
    [anon_sym_goto] = ACTIONS(803),
    [anon_sym_continue] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(803),
    [sym_integer] = ACTIONS(803),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_throw] = ACTIONS(803),
    [anon_sym_while] = ACTIONS(803),
    [anon_sym_endwhile] = ACTIONS(803),
    [anon_sym_do] = ACTIONS(803),
    [anon_sym_for] = ACTIONS(803),
    [anon_sym_endfor] = ACTIONS(803),
    [anon_sym_foreach] = ACTIONS(803),
    [anon_sym_endforeach] = ACTIONS(803),
    [anon_sym_if] = ACTIONS(803),
    [anon_sym_endif] = ACTIONS(803),
    [anon_sym_elseif] = ACTIONS(803),
    [anon_sym_else] = ACTIONS(803),
    [anon_sym_switch] = ACTIONS(803),
    [anon_sym_endswitch] = ACTIONS(803),
    [anon_sym_case] = ACTIONS(803),
    [anon_sym_default] = ACTIONS(803),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(803),
    [anon_sym_DASH] = ACTIONS(803),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_clone] = ACTIONS(803),
    [anon_sym_print] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(803),
    [anon_sym_PLUS_PLUS] = ACTIONS(801),
    [anon_sym_DASH_DASH] = ACTIONS(801),
    [sym_shell_command_expression] = ACTIONS(801),
    [anon_sym_list] = ACTIONS(803),
    [anon_sym_self] = ACTIONS(803),
    [anon_sym_parent] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(801),
    [sym_string] = ACTIONS(801),
    [sym_boolean] = ACTIONS(803),
    [sym_null] = ACTIONS(803),
    [anon_sym_DOLLAR] = ACTIONS(801),
    [anon_sym_yield] = ACTIONS(803),
    [anon_sym_include] = ACTIONS(803),
    [anon_sym_include_once] = ACTIONS(803),
    [anon_sym_require] = ACTIONS(803),
    [anon_sym_require_once] = ACTIONS(803),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(801),
  },
  [256] = {
    [sym_text_interpolation] = STATE(256),
    [ts_builtin_sym_end] = ACTIONS(805),
    [sym_name] = ACTIONS(807),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(805),
    [anon_sym_static] = ACTIONS(807),
    [anon_sym_global] = ACTIONS(807),
    [anon_sym_namespace] = ACTIONS(807),
    [anon_sym_use] = ACTIONS(807),
    [anon_sym_BSLASH] = ACTIONS(805),
    [anon_sym_function] = ACTIONS(807),
    [anon_sym_const] = ACTIONS(807),
    [anon_sym_LBRACE] = ACTIONS(805),
    [anon_sym_RBRACE] = ACTIONS(805),
    [anon_sym_trait] = ACTIONS(807),
    [anon_sym_interface] = ACTIONS(807),
    [anon_sym_class] = ACTIONS(807),
    [anon_sym_abstract] = ACTIONS(807),
    [anon_sym_final] = ACTIONS(807),
    [anon_sym_public] = ACTIONS(807),
    [anon_sym_protected] = ACTIONS(807),
    [anon_sym_private] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(805),
    [anon_sym_array] = ACTIONS(807),
    [anon_sym_unset] = ACTIONS(807),
    [anon_sym_echo] = ACTIONS(807),
    [anon_sym_declare] = ACTIONS(807),
    [anon_sym_enddeclare] = ACTIONS(807),
    [sym_float] = ACTIONS(807),
    [anon_sym_try] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(807),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_break] = ACTIONS(807),
    [sym_integer] = ACTIONS(807),
    [anon_sym_return] = ACTIONS(807),
    [anon_sym_throw] = ACTIONS(807),
    [anon_sym_while] = ACTIONS(807),
    [anon_sym_endwhile] = ACTIONS(807),
    [anon_sym_do] = ACTIONS(807),
    [anon_sym_for] = ACTIONS(807),
    [anon_sym_endfor] = ACTIONS(807),
    [anon_sym_foreach] = ACTIONS(807),
    [anon_sym_endforeach] = ACTIONS(807),
    [anon_sym_if] = ACTIONS(807),
    [anon_sym_endif] = ACTIONS(807),
    [anon_sym_elseif] = ACTIONS(807),
    [anon_sym_else] = ACTIONS(807),
    [anon_sym_switch] = ACTIONS(807),
    [anon_sym_endswitch] = ACTIONS(807),
    [anon_sym_case] = ACTIONS(807),
    [anon_sym_default] = ACTIONS(807),
    [anon_sym_AT] = ACTIONS(805),
    [anon_sym_PLUS] = ACTIONS(807),
    [anon_sym_DASH] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(805),
    [anon_sym_BANG] = ACTIONS(805),
    [anon_sym_clone] = ACTIONS(807),
    [anon_sym_print] = ACTIONS(807),
    [anon_sym_new] = ACTIONS(807),
    [anon_sym_PLUS_PLUS] = ACTIONS(805),
    [anon_sym_DASH_DASH] = ACTIONS(805),
    [sym_shell_command_expression] = ACTIONS(805),
    [anon_sym_list] = ACTIONS(807),
    [anon_sym_self] = ACTIONS(807),
    [anon_sym_parent] = ACTIONS(807),
    [anon_sym_LBRACK] = ACTIONS(805),
    [sym_string] = ACTIONS(805),
    [sym_boolean] = ACTIONS(807),
    [sym_null] = ACTIONS(807),
    [anon_sym_DOLLAR] = ACTIONS(805),
    [anon_sym_yield] = ACTIONS(807),
    [anon_sym_include] = ACTIONS(807),
    [anon_sym_include_once] = ACTIONS(807),
    [anon_sym_require] = ACTIONS(807),
    [anon_sym_require_once] = ACTIONS(807),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(805),
  },
  [257] = {
    [sym_text_interpolation] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(809),
    [sym_name] = ACTIONS(811),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(811),
    [anon_sym_global] = ACTIONS(811),
    [anon_sym_namespace] = ACTIONS(811),
    [anon_sym_use] = ACTIONS(811),
    [anon_sym_BSLASH] = ACTIONS(809),
    [anon_sym_function] = ACTIONS(811),
    [anon_sym_const] = ACTIONS(811),
    [anon_sym_LBRACE] = ACTIONS(809),
    [anon_sym_RBRACE] = ACTIONS(809),
    [anon_sym_trait] = ACTIONS(811),
    [anon_sym_interface] = ACTIONS(811),
    [anon_sym_class] = ACTIONS(811),
    [anon_sym_abstract] = ACTIONS(811),
    [anon_sym_final] = ACTIONS(811),
    [anon_sym_public] = ACTIONS(811),
    [anon_sym_protected] = ACTIONS(811),
    [anon_sym_private] = ACTIONS(811),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_array] = ACTIONS(811),
    [anon_sym_unset] = ACTIONS(811),
    [anon_sym_echo] = ACTIONS(811),
    [anon_sym_declare] = ACTIONS(811),
    [anon_sym_enddeclare] = ACTIONS(811),
    [sym_float] = ACTIONS(811),
    [anon_sym_try] = ACTIONS(811),
    [anon_sym_goto] = ACTIONS(811),
    [anon_sym_continue] = ACTIONS(811),
    [anon_sym_break] = ACTIONS(811),
    [sym_integer] = ACTIONS(811),
    [anon_sym_return] = ACTIONS(811),
    [anon_sym_throw] = ACTIONS(811),
    [anon_sym_while] = ACTIONS(811),
    [anon_sym_endwhile] = ACTIONS(811),
    [anon_sym_do] = ACTIONS(811),
    [anon_sym_for] = ACTIONS(811),
    [anon_sym_endfor] = ACTIONS(811),
    [anon_sym_foreach] = ACTIONS(811),
    [anon_sym_endforeach] = ACTIONS(811),
    [anon_sym_if] = ACTIONS(811),
    [anon_sym_endif] = ACTIONS(811),
    [anon_sym_elseif] = ACTIONS(811),
    [anon_sym_else] = ACTIONS(811),
    [anon_sym_switch] = ACTIONS(811),
    [anon_sym_endswitch] = ACTIONS(811),
    [anon_sym_case] = ACTIONS(811),
    [anon_sym_default] = ACTIONS(811),
    [anon_sym_AT] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_clone] = ACTIONS(811),
    [anon_sym_print] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(811),
    [anon_sym_PLUS_PLUS] = ACTIONS(809),
    [anon_sym_DASH_DASH] = ACTIONS(809),
    [sym_shell_command_expression] = ACTIONS(809),
    [anon_sym_list] = ACTIONS(811),
    [anon_sym_self] = ACTIONS(811),
    [anon_sym_parent] = ACTIONS(811),
    [anon_sym_LBRACK] = ACTIONS(809),
    [sym_string] = ACTIONS(809),
    [sym_boolean] = ACTIONS(811),
    [sym_null] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(809),
    [anon_sym_yield] = ACTIONS(811),
    [anon_sym_include] = ACTIONS(811),
    [anon_sym_include_once] = ACTIONS(811),
    [anon_sym_require] = ACTIONS(811),
    [anon_sym_require_once] = ACTIONS(811),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(809),
  },
  [258] = {
    [sym_text_interpolation] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(813),
    [sym_name] = ACTIONS(815),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(815),
    [anon_sym_global] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_use] = ACTIONS(815),
    [anon_sym_BSLASH] = ACTIONS(813),
    [anon_sym_function] = ACTIONS(815),
    [anon_sym_const] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_trait] = ACTIONS(815),
    [anon_sym_interface] = ACTIONS(815),
    [anon_sym_class] = ACTIONS(815),
    [anon_sym_abstract] = ACTIONS(815),
    [anon_sym_final] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(813),
    [anon_sym_array] = ACTIONS(815),
    [anon_sym_unset] = ACTIONS(815),
    [anon_sym_echo] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_enddeclare] = ACTIONS(815),
    [sym_float] = ACTIONS(815),
    [anon_sym_try] = ACTIONS(815),
    [anon_sym_goto] = ACTIONS(815),
    [anon_sym_continue] = ACTIONS(815),
    [anon_sym_break] = ACTIONS(815),
    [sym_integer] = ACTIONS(815),
    [anon_sym_return] = ACTIONS(815),
    [anon_sym_throw] = ACTIONS(815),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_endwhile] = ACTIONS(815),
    [anon_sym_do] = ACTIONS(815),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_endfor] = ACTIONS(815),
    [anon_sym_foreach] = ACTIONS(815),
    [anon_sym_endforeach] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_endif] = ACTIONS(815),
    [anon_sym_elseif] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(815),
    [anon_sym_switch] = ACTIONS(815),
    [anon_sym_endswitch] = ACTIONS(815),
    [anon_sym_case] = ACTIONS(815),
    [anon_sym_default] = ACTIONS(815),
    [anon_sym_AT] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_TILDE] = ACTIONS(813),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_clone] = ACTIONS(815),
    [anon_sym_print] = ACTIONS(815),
    [anon_sym_new] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [sym_shell_command_expression] = ACTIONS(813),
    [anon_sym_list] = ACTIONS(815),
    [anon_sym_self] = ACTIONS(815),
    [anon_sym_parent] = ACTIONS(815),
    [anon_sym_LBRACK] = ACTIONS(813),
    [sym_string] = ACTIONS(813),
    [sym_boolean] = ACTIONS(815),
    [sym_null] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [anon_sym_yield] = ACTIONS(815),
    [anon_sym_include] = ACTIONS(815),
    [anon_sym_include_once] = ACTIONS(815),
    [anon_sym_require] = ACTIONS(815),
    [anon_sym_require_once] = ACTIONS(815),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(813),
  },
  [259] = {
    [sym_text_interpolation] = STATE(259),
    [ts_builtin_sym_end] = ACTIONS(817),
    [sym_name] = ACTIONS(819),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(817),
    [anon_sym_static] = ACTIONS(819),
    [anon_sym_global] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(819),
    [anon_sym_use] = ACTIONS(819),
    [anon_sym_BSLASH] = ACTIONS(817),
    [anon_sym_function] = ACTIONS(819),
    [anon_sym_const] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(817),
    [anon_sym_RBRACE] = ACTIONS(817),
    [anon_sym_trait] = ACTIONS(819),
    [anon_sym_interface] = ACTIONS(819),
    [anon_sym_class] = ACTIONS(819),
    [anon_sym_abstract] = ACTIONS(819),
    [anon_sym_final] = ACTIONS(819),
    [anon_sym_public] = ACTIONS(819),
    [anon_sym_protected] = ACTIONS(819),
    [anon_sym_private] = ACTIONS(819),
    [anon_sym_LPAREN] = ACTIONS(817),
    [anon_sym_array] = ACTIONS(819),
    [anon_sym_unset] = ACTIONS(819),
    [anon_sym_echo] = ACTIONS(819),
    [anon_sym_declare] = ACTIONS(819),
    [anon_sym_enddeclare] = ACTIONS(819),
    [sym_float] = ACTIONS(819),
    [anon_sym_try] = ACTIONS(819),
    [anon_sym_goto] = ACTIONS(819),
    [anon_sym_continue] = ACTIONS(819),
    [anon_sym_break] = ACTIONS(819),
    [sym_integer] = ACTIONS(819),
    [anon_sym_return] = ACTIONS(819),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_while] = ACTIONS(819),
    [anon_sym_endwhile] = ACTIONS(819),
    [anon_sym_do] = ACTIONS(819),
    [anon_sym_for] = ACTIONS(819),
    [anon_sym_endfor] = ACTIONS(819),
    [anon_sym_foreach] = ACTIONS(819),
    [anon_sym_endforeach] = ACTIONS(819),
    [anon_sym_if] = ACTIONS(819),
    [anon_sym_endif] = ACTIONS(819),
    [anon_sym_elseif] = ACTIONS(819),
    [anon_sym_else] = ACTIONS(819),
    [anon_sym_switch] = ACTIONS(819),
    [anon_sym_endswitch] = ACTIONS(819),
    [anon_sym_case] = ACTIONS(819),
    [anon_sym_default] = ACTIONS(819),
    [anon_sym_AT] = ACTIONS(817),
    [anon_sym_PLUS] = ACTIONS(819),
    [anon_sym_DASH] = ACTIONS(819),
    [anon_sym_TILDE] = ACTIONS(817),
    [anon_sym_BANG] = ACTIONS(817),
    [anon_sym_clone] = ACTIONS(819),
    [anon_sym_print] = ACTIONS(819),
    [anon_sym_new] = ACTIONS(819),
    [anon_sym_PLUS_PLUS] = ACTIONS(817),
    [anon_sym_DASH_DASH] = ACTIONS(817),
    [sym_shell_command_expression] = ACTIONS(817),
    [anon_sym_list] = ACTIONS(819),
    [anon_sym_self] = ACTIONS(819),
    [anon_sym_parent] = ACTIONS(819),
    [anon_sym_LBRACK] = ACTIONS(817),
    [sym_string] = ACTIONS(817),
    [sym_boolean] = ACTIONS(819),
    [sym_null] = ACTIONS(819),
    [anon_sym_DOLLAR] = ACTIONS(817),
    [anon_sym_yield] = ACTIONS(819),
    [anon_sym_include] = ACTIONS(819),
    [anon_sym_include_once] = ACTIONS(819),
    [anon_sym_require] = ACTIONS(819),
    [anon_sym_require_once] = ACTIONS(819),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(817),
  },
  [260] = {
    [sym_text_interpolation] = STATE(260),
    [ts_builtin_sym_end] = ACTIONS(821),
    [sym_name] = ACTIONS(823),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(821),
    [anon_sym_static] = ACTIONS(823),
    [anon_sym_global] = ACTIONS(823),
    [anon_sym_namespace] = ACTIONS(823),
    [anon_sym_use] = ACTIONS(823),
    [anon_sym_BSLASH] = ACTIONS(821),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_const] = ACTIONS(823),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_trait] = ACTIONS(823),
    [anon_sym_interface] = ACTIONS(823),
    [anon_sym_class] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_final] = ACTIONS(823),
    [anon_sym_public] = ACTIONS(823),
    [anon_sym_protected] = ACTIONS(823),
    [anon_sym_private] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(821),
    [anon_sym_array] = ACTIONS(823),
    [anon_sym_unset] = ACTIONS(823),
    [anon_sym_echo] = ACTIONS(823),
    [anon_sym_declare] = ACTIONS(823),
    [anon_sym_enddeclare] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_try] = ACTIONS(823),
    [anon_sym_goto] = ACTIONS(823),
    [anon_sym_continue] = ACTIONS(823),
    [anon_sym_break] = ACTIONS(823),
    [sym_integer] = ACTIONS(823),
    [anon_sym_return] = ACTIONS(823),
    [anon_sym_throw] = ACTIONS(823),
    [anon_sym_while] = ACTIONS(823),
    [anon_sym_endwhile] = ACTIONS(823),
    [anon_sym_do] = ACTIONS(823),
    [anon_sym_for] = ACTIONS(823),
    [anon_sym_endfor] = ACTIONS(823),
    [anon_sym_foreach] = ACTIONS(823),
    [anon_sym_endforeach] = ACTIONS(823),
    [anon_sym_if] = ACTIONS(823),
    [anon_sym_endif] = ACTIONS(823),
    [anon_sym_elseif] = ACTIONS(823),
    [anon_sym_else] = ACTIONS(823),
    [anon_sym_switch] = ACTIONS(823),
    [anon_sym_endswitch] = ACTIONS(823),
    [anon_sym_case] = ACTIONS(823),
    [anon_sym_default] = ACTIONS(823),
    [anon_sym_AT] = ACTIONS(821),
    [anon_sym_PLUS] = ACTIONS(823),
    [anon_sym_DASH] = ACTIONS(823),
    [anon_sym_TILDE] = ACTIONS(821),
    [anon_sym_BANG] = ACTIONS(821),
    [anon_sym_clone] = ACTIONS(823),
    [anon_sym_print] = ACTIONS(823),
    [anon_sym_new] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(821),
    [anon_sym_DASH_DASH] = ACTIONS(821),
    [sym_shell_command_expression] = ACTIONS(821),
    [anon_sym_list] = ACTIONS(823),
    [anon_sym_self] = ACTIONS(823),
    [anon_sym_parent] = ACTIONS(823),
    [anon_sym_LBRACK] = ACTIONS(821),
    [sym_string] = ACTIONS(821),
    [sym_boolean] = ACTIONS(823),
    [sym_null] = ACTIONS(823),
    [anon_sym_DOLLAR] = ACTIONS(821),
    [anon_sym_yield] = ACTIONS(823),
    [anon_sym_include] = ACTIONS(823),
    [anon_sym_include_once] = ACTIONS(823),
    [anon_sym_require] = ACTIONS(823),
    [anon_sym_require_once] = ACTIONS(823),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(821),
  },
  [261] = {
    [sym_text_interpolation] = STATE(261),
    [ts_builtin_sym_end] = ACTIONS(825),
    [sym_name] = ACTIONS(827),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(825),
    [anon_sym_static] = ACTIONS(827),
    [anon_sym_global] = ACTIONS(827),
    [anon_sym_namespace] = ACTIONS(827),
    [anon_sym_use] = ACTIONS(827),
    [anon_sym_BSLASH] = ACTIONS(825),
    [anon_sym_function] = ACTIONS(827),
    [anon_sym_const] = ACTIONS(827),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(825),
    [anon_sym_trait] = ACTIONS(827),
    [anon_sym_interface] = ACTIONS(827),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_abstract] = ACTIONS(827),
    [anon_sym_final] = ACTIONS(827),
    [anon_sym_public] = ACTIONS(827),
    [anon_sym_protected] = ACTIONS(827),
    [anon_sym_private] = ACTIONS(827),
    [anon_sym_LPAREN] = ACTIONS(825),
    [anon_sym_array] = ACTIONS(827),
    [anon_sym_unset] = ACTIONS(827),
    [anon_sym_echo] = ACTIONS(827),
    [anon_sym_declare] = ACTIONS(827),
    [anon_sym_enddeclare] = ACTIONS(827),
    [sym_float] = ACTIONS(827),
    [anon_sym_try] = ACTIONS(827),
    [anon_sym_goto] = ACTIONS(827),
    [anon_sym_continue] = ACTIONS(827),
    [anon_sym_break] = ACTIONS(827),
    [sym_integer] = ACTIONS(827),
    [anon_sym_return] = ACTIONS(827),
    [anon_sym_throw] = ACTIONS(827),
    [anon_sym_while] = ACTIONS(827),
    [anon_sym_endwhile] = ACTIONS(827),
    [anon_sym_do] = ACTIONS(827),
    [anon_sym_for] = ACTIONS(827),
    [anon_sym_endfor] = ACTIONS(827),
    [anon_sym_foreach] = ACTIONS(827),
    [anon_sym_endforeach] = ACTIONS(827),
    [anon_sym_if] = ACTIONS(827),
    [anon_sym_endif] = ACTIONS(827),
    [anon_sym_elseif] = ACTIONS(827),
    [anon_sym_else] = ACTIONS(827),
    [anon_sym_switch] = ACTIONS(827),
    [anon_sym_endswitch] = ACTIONS(827),
    [anon_sym_case] = ACTIONS(827),
    [anon_sym_default] = ACTIONS(827),
    [anon_sym_AT] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_BANG] = ACTIONS(825),
    [anon_sym_clone] = ACTIONS(827),
    [anon_sym_print] = ACTIONS(827),
    [anon_sym_new] = ACTIONS(827),
    [anon_sym_PLUS_PLUS] = ACTIONS(825),
    [anon_sym_DASH_DASH] = ACTIONS(825),
    [sym_shell_command_expression] = ACTIONS(825),
    [anon_sym_list] = ACTIONS(827),
    [anon_sym_self] = ACTIONS(827),
    [anon_sym_parent] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(825),
    [sym_string] = ACTIONS(825),
    [sym_boolean] = ACTIONS(827),
    [sym_null] = ACTIONS(827),
    [anon_sym_DOLLAR] = ACTIONS(825),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_include] = ACTIONS(827),
    [anon_sym_include_once] = ACTIONS(827),
    [anon_sym_require] = ACTIONS(827),
    [anon_sym_require_once] = ACTIONS(827),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(825),
  },
  [262] = {
    [sym_text_interpolation] = STATE(262),
    [ts_builtin_sym_end] = ACTIONS(829),
    [sym_name] = ACTIONS(831),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(829),
    [anon_sym_static] = ACTIONS(831),
    [anon_sym_global] = ACTIONS(831),
    [anon_sym_namespace] = ACTIONS(831),
    [anon_sym_use] = ACTIONS(831),
    [anon_sym_BSLASH] = ACTIONS(829),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_const] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(829),
    [anon_sym_RBRACE] = ACTIONS(829),
    [anon_sym_trait] = ACTIONS(831),
    [anon_sym_interface] = ACTIONS(831),
    [anon_sym_class] = ACTIONS(831),
    [anon_sym_abstract] = ACTIONS(831),
    [anon_sym_final] = ACTIONS(831),
    [anon_sym_public] = ACTIONS(831),
    [anon_sym_protected] = ACTIONS(831),
    [anon_sym_private] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(829),
    [anon_sym_array] = ACTIONS(831),
    [anon_sym_unset] = ACTIONS(831),
    [anon_sym_echo] = ACTIONS(831),
    [anon_sym_declare] = ACTIONS(831),
    [anon_sym_enddeclare] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [anon_sym_try] = ACTIONS(831),
    [anon_sym_goto] = ACTIONS(831),
    [anon_sym_continue] = ACTIONS(831),
    [anon_sym_break] = ACTIONS(831),
    [sym_integer] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_throw] = ACTIONS(831),
    [anon_sym_while] = ACTIONS(831),
    [anon_sym_endwhile] = ACTIONS(831),
    [anon_sym_do] = ACTIONS(831),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_endfor] = ACTIONS(831),
    [anon_sym_foreach] = ACTIONS(831),
    [anon_sym_endforeach] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(831),
    [anon_sym_endif] = ACTIONS(831),
    [anon_sym_elseif] = ACTIONS(831),
    [anon_sym_else] = ACTIONS(831),
    [anon_sym_switch] = ACTIONS(831),
    [anon_sym_endswitch] = ACTIONS(831),
    [anon_sym_case] = ACTIONS(831),
    [anon_sym_default] = ACTIONS(831),
    [anon_sym_AT] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_clone] = ACTIONS(831),
    [anon_sym_print] = ACTIONS(831),
    [anon_sym_new] = ACTIONS(831),
    [anon_sym_PLUS_PLUS] = ACTIONS(829),
    [anon_sym_DASH_DASH] = ACTIONS(829),
    [sym_shell_command_expression] = ACTIONS(829),
    [anon_sym_list] = ACTIONS(831),
    [anon_sym_self] = ACTIONS(831),
    [anon_sym_parent] = ACTIONS(831),
    [anon_sym_LBRACK] = ACTIONS(829),
    [sym_string] = ACTIONS(829),
    [sym_boolean] = ACTIONS(831),
    [sym_null] = ACTIONS(831),
    [anon_sym_DOLLAR] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(831),
    [anon_sym_include] = ACTIONS(831),
    [anon_sym_include_once] = ACTIONS(831),
    [anon_sym_require] = ACTIONS(831),
    [anon_sym_require_once] = ACTIONS(831),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(829),
  },
  [263] = {
    [sym_text_interpolation] = STATE(263),
    [ts_builtin_sym_end] = ACTIONS(833),
    [sym_name] = ACTIONS(835),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(833),
    [anon_sym_static] = ACTIONS(835),
    [anon_sym_global] = ACTIONS(835),
    [anon_sym_namespace] = ACTIONS(835),
    [anon_sym_use] = ACTIONS(835),
    [anon_sym_BSLASH] = ACTIONS(833),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_const] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(833),
    [anon_sym_RBRACE] = ACTIONS(833),
    [anon_sym_trait] = ACTIONS(835),
    [anon_sym_interface] = ACTIONS(835),
    [anon_sym_class] = ACTIONS(835),
    [anon_sym_abstract] = ACTIONS(835),
    [anon_sym_final] = ACTIONS(835),
    [anon_sym_public] = ACTIONS(835),
    [anon_sym_protected] = ACTIONS(835),
    [anon_sym_private] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_array] = ACTIONS(835),
    [anon_sym_unset] = ACTIONS(835),
    [anon_sym_echo] = ACTIONS(835),
    [anon_sym_declare] = ACTIONS(835),
    [anon_sym_enddeclare] = ACTIONS(835),
    [sym_float] = ACTIONS(835),
    [anon_sym_try] = ACTIONS(835),
    [anon_sym_goto] = ACTIONS(835),
    [anon_sym_continue] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(835),
    [sym_integer] = ACTIONS(835),
    [anon_sym_return] = ACTIONS(835),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_endwhile] = ACTIONS(835),
    [anon_sym_do] = ACTIONS(835),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_endfor] = ACTIONS(835),
    [anon_sym_foreach] = ACTIONS(835),
    [anon_sym_endforeach] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_endif] = ACTIONS(835),
    [anon_sym_elseif] = ACTIONS(835),
    [anon_sym_else] = ACTIONS(835),
    [anon_sym_switch] = ACTIONS(835),
    [anon_sym_endswitch] = ACTIONS(835),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_default] = ACTIONS(835),
    [anon_sym_AT] = ACTIONS(833),
    [anon_sym_PLUS] = ACTIONS(835),
    [anon_sym_DASH] = ACTIONS(835),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_clone] = ACTIONS(835),
    [anon_sym_print] = ACTIONS(835),
    [anon_sym_new] = ACTIONS(835),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [sym_shell_command_expression] = ACTIONS(833),
    [anon_sym_list] = ACTIONS(835),
    [anon_sym_self] = ACTIONS(835),
    [anon_sym_parent] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(833),
    [sym_string] = ACTIONS(833),
    [sym_boolean] = ACTIONS(835),
    [sym_null] = ACTIONS(835),
    [anon_sym_DOLLAR] = ACTIONS(833),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_include] = ACTIONS(835),
    [anon_sym_include_once] = ACTIONS(835),
    [anon_sym_require] = ACTIONS(835),
    [anon_sym_require_once] = ACTIONS(835),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(833),
  },
  [264] = {
    [sym_text_interpolation] = STATE(264),
    [ts_builtin_sym_end] = ACTIONS(837),
    [sym_name] = ACTIONS(839),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_static] = ACTIONS(839),
    [anon_sym_global] = ACTIONS(839),
    [anon_sym_namespace] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(839),
    [anon_sym_BSLASH] = ACTIONS(837),
    [anon_sym_function] = ACTIONS(839),
    [anon_sym_const] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_trait] = ACTIONS(839),
    [anon_sym_interface] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(839),
    [anon_sym_abstract] = ACTIONS(839),
    [anon_sym_final] = ACTIONS(839),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(837),
    [anon_sym_array] = ACTIONS(839),
    [anon_sym_unset] = ACTIONS(839),
    [anon_sym_echo] = ACTIONS(839),
    [anon_sym_declare] = ACTIONS(839),
    [anon_sym_enddeclare] = ACTIONS(839),
    [sym_float] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(839),
    [anon_sym_goto] = ACTIONS(839),
    [anon_sym_continue] = ACTIONS(839),
    [anon_sym_break] = ACTIONS(839),
    [sym_integer] = ACTIONS(839),
    [anon_sym_return] = ACTIONS(839),
    [anon_sym_throw] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(839),
    [anon_sym_endwhile] = ACTIONS(839),
    [anon_sym_do] = ACTIONS(839),
    [anon_sym_for] = ACTIONS(839),
    [anon_sym_endfor] = ACTIONS(839),
    [anon_sym_foreach] = ACTIONS(839),
    [anon_sym_endforeach] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_endif] = ACTIONS(839),
    [anon_sym_elseif] = ACTIONS(839),
    [anon_sym_else] = ACTIONS(839),
    [anon_sym_switch] = ACTIONS(839),
    [anon_sym_endswitch] = ACTIONS(839),
    [anon_sym_case] = ACTIONS(839),
    [anon_sym_default] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_TILDE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(837),
    [anon_sym_clone] = ACTIONS(839),
    [anon_sym_print] = ACTIONS(839),
    [anon_sym_new] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(837),
    [anon_sym_DASH_DASH] = ACTIONS(837),
    [sym_shell_command_expression] = ACTIONS(837),
    [anon_sym_list] = ACTIONS(839),
    [anon_sym_self] = ACTIONS(839),
    [anon_sym_parent] = ACTIONS(839),
    [anon_sym_LBRACK] = ACTIONS(837),
    [sym_string] = ACTIONS(837),
    [sym_boolean] = ACTIONS(839),
    [sym_null] = ACTIONS(839),
    [anon_sym_DOLLAR] = ACTIONS(837),
    [anon_sym_yield] = ACTIONS(839),
    [anon_sym_include] = ACTIONS(839),
    [anon_sym_include_once] = ACTIONS(839),
    [anon_sym_require] = ACTIONS(839),
    [anon_sym_require_once] = ACTIONS(839),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(837),
  },
  [265] = {
    [sym_text_interpolation] = STATE(265),
    [ts_builtin_sym_end] = ACTIONS(841),
    [sym_name] = ACTIONS(843),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(841),
    [anon_sym_static] = ACTIONS(843),
    [anon_sym_global] = ACTIONS(843),
    [anon_sym_namespace] = ACTIONS(843),
    [anon_sym_use] = ACTIONS(843),
    [anon_sym_BSLASH] = ACTIONS(841),
    [anon_sym_function] = ACTIONS(843),
    [anon_sym_const] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_trait] = ACTIONS(843),
    [anon_sym_interface] = ACTIONS(843),
    [anon_sym_class] = ACTIONS(843),
    [anon_sym_abstract] = ACTIONS(843),
    [anon_sym_final] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(843),
    [anon_sym_protected] = ACTIONS(843),
    [anon_sym_private] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(841),
    [anon_sym_array] = ACTIONS(843),
    [anon_sym_unset] = ACTIONS(843),
    [anon_sym_echo] = ACTIONS(843),
    [anon_sym_declare] = ACTIONS(843),
    [anon_sym_enddeclare] = ACTIONS(843),
    [sym_float] = ACTIONS(843),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_goto] = ACTIONS(843),
    [anon_sym_continue] = ACTIONS(843),
    [anon_sym_break] = ACTIONS(843),
    [sym_integer] = ACTIONS(843),
    [anon_sym_return] = ACTIONS(843),
    [anon_sym_throw] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(843),
    [anon_sym_endwhile] = ACTIONS(843),
    [anon_sym_do] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_endfor] = ACTIONS(843),
    [anon_sym_foreach] = ACTIONS(843),
    [anon_sym_endforeach] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_endif] = ACTIONS(843),
    [anon_sym_elseif] = ACTIONS(843),
    [anon_sym_else] = ACTIONS(843),
    [anon_sym_switch] = ACTIONS(843),
    [anon_sym_endswitch] = ACTIONS(843),
    [anon_sym_case] = ACTIONS(843),
    [anon_sym_default] = ACTIONS(843),
    [anon_sym_AT] = ACTIONS(841),
    [anon_sym_PLUS] = ACTIONS(843),
    [anon_sym_DASH] = ACTIONS(843),
    [anon_sym_TILDE] = ACTIONS(841),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_clone] = ACTIONS(843),
    [anon_sym_print] = ACTIONS(843),
    [anon_sym_new] = ACTIONS(843),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [sym_shell_command_expression] = ACTIONS(841),
    [anon_sym_list] = ACTIONS(843),
    [anon_sym_self] = ACTIONS(843),
    [anon_sym_parent] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(841),
    [sym_string] = ACTIONS(841),
    [sym_boolean] = ACTIONS(843),
    [sym_null] = ACTIONS(843),
    [anon_sym_DOLLAR] = ACTIONS(841),
    [anon_sym_yield] = ACTIONS(843),
    [anon_sym_include] = ACTIONS(843),
    [anon_sym_include_once] = ACTIONS(843),
    [anon_sym_require] = ACTIONS(843),
    [anon_sym_require_once] = ACTIONS(843),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(841),
  },
  [266] = {
    [sym_text_interpolation] = STATE(266),
    [ts_builtin_sym_end] = ACTIONS(845),
    [sym_name] = ACTIONS(847),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(845),
    [anon_sym_static] = ACTIONS(847),
    [anon_sym_global] = ACTIONS(847),
    [anon_sym_namespace] = ACTIONS(847),
    [anon_sym_use] = ACTIONS(847),
    [anon_sym_BSLASH] = ACTIONS(845),
    [anon_sym_function] = ACTIONS(847),
    [anon_sym_const] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(845),
    [anon_sym_trait] = ACTIONS(847),
    [anon_sym_interface] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(847),
    [anon_sym_abstract] = ACTIONS(847),
    [anon_sym_final] = ACTIONS(847),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_array] = ACTIONS(847),
    [anon_sym_unset] = ACTIONS(847),
    [anon_sym_echo] = ACTIONS(847),
    [anon_sym_declare] = ACTIONS(847),
    [anon_sym_enddeclare] = ACTIONS(847),
    [sym_float] = ACTIONS(847),
    [anon_sym_try] = ACTIONS(847),
    [anon_sym_goto] = ACTIONS(847),
    [anon_sym_continue] = ACTIONS(847),
    [anon_sym_break] = ACTIONS(847),
    [sym_integer] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(847),
    [anon_sym_throw] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_endwhile] = ACTIONS(847),
    [anon_sym_do] = ACTIONS(847),
    [anon_sym_for] = ACTIONS(847),
    [anon_sym_endfor] = ACTIONS(847),
    [anon_sym_foreach] = ACTIONS(847),
    [anon_sym_endforeach] = ACTIONS(847),
    [anon_sym_if] = ACTIONS(847),
    [anon_sym_endif] = ACTIONS(847),
    [anon_sym_elseif] = ACTIONS(847),
    [anon_sym_else] = ACTIONS(847),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_endswitch] = ACTIONS(847),
    [anon_sym_case] = ACTIONS(847),
    [anon_sym_default] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(845),
    [anon_sym_PLUS] = ACTIONS(847),
    [anon_sym_DASH] = ACTIONS(847),
    [anon_sym_TILDE] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(845),
    [anon_sym_clone] = ACTIONS(847),
    [anon_sym_print] = ACTIONS(847),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_PLUS_PLUS] = ACTIONS(845),
    [anon_sym_DASH_DASH] = ACTIONS(845),
    [sym_shell_command_expression] = ACTIONS(845),
    [anon_sym_list] = ACTIONS(847),
    [anon_sym_self] = ACTIONS(847),
    [anon_sym_parent] = ACTIONS(847),
    [anon_sym_LBRACK] = ACTIONS(845),
    [sym_string] = ACTIONS(845),
    [sym_boolean] = ACTIONS(847),
    [sym_null] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(845),
    [anon_sym_yield] = ACTIONS(847),
    [anon_sym_include] = ACTIONS(847),
    [anon_sym_include_once] = ACTIONS(847),
    [anon_sym_require] = ACTIONS(847),
    [anon_sym_require_once] = ACTIONS(847),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(845),
  },
  [267] = {
    [sym_text_interpolation] = STATE(267),
    [ts_builtin_sym_end] = ACTIONS(849),
    [sym_name] = ACTIONS(851),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(849),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_global] = ACTIONS(851),
    [anon_sym_namespace] = ACTIONS(851),
    [anon_sym_use] = ACTIONS(851),
    [anon_sym_BSLASH] = ACTIONS(849),
    [anon_sym_function] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_RBRACE] = ACTIONS(849),
    [anon_sym_trait] = ACTIONS(851),
    [anon_sym_interface] = ACTIONS(851),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_abstract] = ACTIONS(851),
    [anon_sym_final] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_LPAREN] = ACTIONS(849),
    [anon_sym_array] = ACTIONS(851),
    [anon_sym_unset] = ACTIONS(851),
    [anon_sym_echo] = ACTIONS(851),
    [anon_sym_declare] = ACTIONS(851),
    [anon_sym_enddeclare] = ACTIONS(851),
    [sym_float] = ACTIONS(851),
    [anon_sym_try] = ACTIONS(851),
    [anon_sym_goto] = ACTIONS(851),
    [anon_sym_continue] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(851),
    [sym_integer] = ACTIONS(851),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_throw] = ACTIONS(851),
    [anon_sym_while] = ACTIONS(851),
    [anon_sym_endwhile] = ACTIONS(851),
    [anon_sym_do] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_endfor] = ACTIONS(851),
    [anon_sym_foreach] = ACTIONS(851),
    [anon_sym_endforeach] = ACTIONS(851),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_endif] = ACTIONS(851),
    [anon_sym_elseif] = ACTIONS(851),
    [anon_sym_else] = ACTIONS(851),
    [anon_sym_switch] = ACTIONS(851),
    [anon_sym_endswitch] = ACTIONS(851),
    [anon_sym_case] = ACTIONS(851),
    [anon_sym_default] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_TILDE] = ACTIONS(849),
    [anon_sym_BANG] = ACTIONS(849),
    [anon_sym_clone] = ACTIONS(851),
    [anon_sym_print] = ACTIONS(851),
    [anon_sym_new] = ACTIONS(851),
    [anon_sym_PLUS_PLUS] = ACTIONS(849),
    [anon_sym_DASH_DASH] = ACTIONS(849),
    [sym_shell_command_expression] = ACTIONS(849),
    [anon_sym_list] = ACTIONS(851),
    [anon_sym_self] = ACTIONS(851),
    [anon_sym_parent] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(849),
    [sym_string] = ACTIONS(849),
    [sym_boolean] = ACTIONS(851),
    [sym_null] = ACTIONS(851),
    [anon_sym_DOLLAR] = ACTIONS(849),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_include] = ACTIONS(851),
    [anon_sym_include_once] = ACTIONS(851),
    [anon_sym_require] = ACTIONS(851),
    [anon_sym_require_once] = ACTIONS(851),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(849),
  },
  [268] = {
    [sym_text_interpolation] = STATE(268),
    [ts_builtin_sym_end] = ACTIONS(853),
    [sym_name] = ACTIONS(855),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(853),
    [anon_sym_static] = ACTIONS(855),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_namespace] = ACTIONS(855),
    [anon_sym_use] = ACTIONS(855),
    [anon_sym_BSLASH] = ACTIONS(853),
    [anon_sym_function] = ACTIONS(855),
    [anon_sym_const] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(853),
    [anon_sym_trait] = ACTIONS(855),
    [anon_sym_interface] = ACTIONS(855),
    [anon_sym_class] = ACTIONS(855),
    [anon_sym_abstract] = ACTIONS(855),
    [anon_sym_final] = ACTIONS(855),
    [anon_sym_public] = ACTIONS(855),
    [anon_sym_protected] = ACTIONS(855),
    [anon_sym_private] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_array] = ACTIONS(855),
    [anon_sym_unset] = ACTIONS(855),
    [anon_sym_echo] = ACTIONS(855),
    [anon_sym_declare] = ACTIONS(855),
    [anon_sym_enddeclare] = ACTIONS(855),
    [sym_float] = ACTIONS(855),
    [anon_sym_try] = ACTIONS(855),
    [anon_sym_goto] = ACTIONS(855),
    [anon_sym_continue] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(855),
    [sym_integer] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(855),
    [anon_sym_throw] = ACTIONS(855),
    [anon_sym_while] = ACTIONS(855),
    [anon_sym_endwhile] = ACTIONS(855),
    [anon_sym_do] = ACTIONS(855),
    [anon_sym_for] = ACTIONS(855),
    [anon_sym_endfor] = ACTIONS(855),
    [anon_sym_foreach] = ACTIONS(855),
    [anon_sym_endforeach] = ACTIONS(855),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_endif] = ACTIONS(855),
    [anon_sym_elseif] = ACTIONS(855),
    [anon_sym_else] = ACTIONS(855),
    [anon_sym_switch] = ACTIONS(855),
    [anon_sym_endswitch] = ACTIONS(855),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_default] = ACTIONS(855),
    [anon_sym_AT] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_TILDE] = ACTIONS(853),
    [anon_sym_BANG] = ACTIONS(853),
    [anon_sym_clone] = ACTIONS(855),
    [anon_sym_print] = ACTIONS(855),
    [anon_sym_new] = ACTIONS(855),
    [anon_sym_PLUS_PLUS] = ACTIONS(853),
    [anon_sym_DASH_DASH] = ACTIONS(853),
    [sym_shell_command_expression] = ACTIONS(853),
    [anon_sym_list] = ACTIONS(855),
    [anon_sym_self] = ACTIONS(855),
    [anon_sym_parent] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(853),
    [sym_string] = ACTIONS(853),
    [sym_boolean] = ACTIONS(855),
    [sym_null] = ACTIONS(855),
    [anon_sym_DOLLAR] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_include] = ACTIONS(855),
    [anon_sym_include_once] = ACTIONS(855),
    [anon_sym_require] = ACTIONS(855),
    [anon_sym_require_once] = ACTIONS(855),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(853),
  },
  [269] = {
    [sym_text_interpolation] = STATE(269),
    [ts_builtin_sym_end] = ACTIONS(857),
    [sym_name] = ACTIONS(859),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_static] = ACTIONS(859),
    [anon_sym_global] = ACTIONS(859),
    [anon_sym_namespace] = ACTIONS(859),
    [anon_sym_use] = ACTIONS(859),
    [anon_sym_BSLASH] = ACTIONS(857),
    [anon_sym_function] = ACTIONS(859),
    [anon_sym_const] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(857),
    [anon_sym_trait] = ACTIONS(859),
    [anon_sym_interface] = ACTIONS(859),
    [anon_sym_class] = ACTIONS(859),
    [anon_sym_abstract] = ACTIONS(859),
    [anon_sym_final] = ACTIONS(859),
    [anon_sym_public] = ACTIONS(859),
    [anon_sym_protected] = ACTIONS(859),
    [anon_sym_private] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_array] = ACTIONS(859),
    [anon_sym_unset] = ACTIONS(859),
    [anon_sym_echo] = ACTIONS(859),
    [anon_sym_declare] = ACTIONS(859),
    [anon_sym_enddeclare] = ACTIONS(859),
    [sym_float] = ACTIONS(859),
    [anon_sym_try] = ACTIONS(859),
    [anon_sym_goto] = ACTIONS(859),
    [anon_sym_continue] = ACTIONS(859),
    [anon_sym_break] = ACTIONS(859),
    [sym_integer] = ACTIONS(859),
    [anon_sym_return] = ACTIONS(859),
    [anon_sym_throw] = ACTIONS(859),
    [anon_sym_while] = ACTIONS(859),
    [anon_sym_endwhile] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(859),
    [anon_sym_endfor] = ACTIONS(859),
    [anon_sym_foreach] = ACTIONS(859),
    [anon_sym_endforeach] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_endif] = ACTIONS(859),
    [anon_sym_elseif] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(859),
    [anon_sym_switch] = ACTIONS(859),
    [anon_sym_endswitch] = ACTIONS(859),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_default] = ACTIONS(859),
    [anon_sym_AT] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_clone] = ACTIONS(859),
    [anon_sym_print] = ACTIONS(859),
    [anon_sym_new] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [sym_shell_command_expression] = ACTIONS(857),
    [anon_sym_list] = ACTIONS(859),
    [anon_sym_self] = ACTIONS(859),
    [anon_sym_parent] = ACTIONS(859),
    [anon_sym_LBRACK] = ACTIONS(857),
    [sym_string] = ACTIONS(857),
    [sym_boolean] = ACTIONS(859),
    [sym_null] = ACTIONS(859),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_yield] = ACTIONS(859),
    [anon_sym_include] = ACTIONS(859),
    [anon_sym_include_once] = ACTIONS(859),
    [anon_sym_require] = ACTIONS(859),
    [anon_sym_require_once] = ACTIONS(859),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(857),
  },
  [270] = {
    [sym_text_interpolation] = STATE(270),
    [ts_builtin_sym_end] = ACTIONS(861),
    [sym_name] = ACTIONS(863),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_static] = ACTIONS(863),
    [anon_sym_global] = ACTIONS(863),
    [anon_sym_namespace] = ACTIONS(863),
    [anon_sym_use] = ACTIONS(863),
    [anon_sym_BSLASH] = ACTIONS(861),
    [anon_sym_function] = ACTIONS(863),
    [anon_sym_const] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(861),
    [anon_sym_RBRACE] = ACTIONS(861),
    [anon_sym_trait] = ACTIONS(863),
    [anon_sym_interface] = ACTIONS(863),
    [anon_sym_class] = ACTIONS(863),
    [anon_sym_abstract] = ACTIONS(863),
    [anon_sym_final] = ACTIONS(863),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_protected] = ACTIONS(863),
    [anon_sym_private] = ACTIONS(863),
    [anon_sym_LPAREN] = ACTIONS(861),
    [anon_sym_array] = ACTIONS(863),
    [anon_sym_unset] = ACTIONS(863),
    [anon_sym_echo] = ACTIONS(863),
    [anon_sym_declare] = ACTIONS(863),
    [anon_sym_enddeclare] = ACTIONS(863),
    [sym_float] = ACTIONS(863),
    [anon_sym_try] = ACTIONS(863),
    [anon_sym_goto] = ACTIONS(863),
    [anon_sym_continue] = ACTIONS(863),
    [anon_sym_break] = ACTIONS(863),
    [sym_integer] = ACTIONS(863),
    [anon_sym_return] = ACTIONS(863),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_while] = ACTIONS(863),
    [anon_sym_endwhile] = ACTIONS(863),
    [anon_sym_do] = ACTIONS(863),
    [anon_sym_for] = ACTIONS(863),
    [anon_sym_endfor] = ACTIONS(863),
    [anon_sym_foreach] = ACTIONS(863),
    [anon_sym_endforeach] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_endif] = ACTIONS(863),
    [anon_sym_elseif] = ACTIONS(863),
    [anon_sym_else] = ACTIONS(863),
    [anon_sym_switch] = ACTIONS(863),
    [anon_sym_endswitch] = ACTIONS(863),
    [anon_sym_case] = ACTIONS(863),
    [anon_sym_default] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(861),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(861),
    [anon_sym_clone] = ACTIONS(863),
    [anon_sym_print] = ACTIONS(863),
    [anon_sym_new] = ACTIONS(863),
    [anon_sym_PLUS_PLUS] = ACTIONS(861),
    [anon_sym_DASH_DASH] = ACTIONS(861),
    [sym_shell_command_expression] = ACTIONS(861),
    [anon_sym_list] = ACTIONS(863),
    [anon_sym_self] = ACTIONS(863),
    [anon_sym_parent] = ACTIONS(863),
    [anon_sym_LBRACK] = ACTIONS(861),
    [sym_string] = ACTIONS(861),
    [sym_boolean] = ACTIONS(863),
    [sym_null] = ACTIONS(863),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_yield] = ACTIONS(863),
    [anon_sym_include] = ACTIONS(863),
    [anon_sym_include_once] = ACTIONS(863),
    [anon_sym_require] = ACTIONS(863),
    [anon_sym_require_once] = ACTIONS(863),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(861),
  },
  [271] = {
    [sym_text_interpolation] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(865),
    [sym_name] = ACTIONS(867),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(865),
    [anon_sym_static] = ACTIONS(867),
    [anon_sym_global] = ACTIONS(867),
    [anon_sym_namespace] = ACTIONS(867),
    [anon_sym_use] = ACTIONS(867),
    [anon_sym_BSLASH] = ACTIONS(865),
    [anon_sym_function] = ACTIONS(867),
    [anon_sym_const] = ACTIONS(867),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(865),
    [anon_sym_trait] = ACTIONS(867),
    [anon_sym_interface] = ACTIONS(867),
    [anon_sym_class] = ACTIONS(867),
    [anon_sym_abstract] = ACTIONS(867),
    [anon_sym_final] = ACTIONS(867),
    [anon_sym_public] = ACTIONS(867),
    [anon_sym_protected] = ACTIONS(867),
    [anon_sym_private] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(865),
    [anon_sym_array] = ACTIONS(867),
    [anon_sym_unset] = ACTIONS(867),
    [anon_sym_echo] = ACTIONS(867),
    [anon_sym_declare] = ACTIONS(867),
    [anon_sym_enddeclare] = ACTIONS(867),
    [sym_float] = ACTIONS(867),
    [anon_sym_try] = ACTIONS(867),
    [anon_sym_goto] = ACTIONS(867),
    [anon_sym_continue] = ACTIONS(867),
    [anon_sym_break] = ACTIONS(867),
    [sym_integer] = ACTIONS(867),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_throw] = ACTIONS(867),
    [anon_sym_while] = ACTIONS(867),
    [anon_sym_endwhile] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(867),
    [anon_sym_for] = ACTIONS(867),
    [anon_sym_endfor] = ACTIONS(867),
    [anon_sym_foreach] = ACTIONS(867),
    [anon_sym_endforeach] = ACTIONS(867),
    [anon_sym_if] = ACTIONS(867),
    [anon_sym_endif] = ACTIONS(867),
    [anon_sym_elseif] = ACTIONS(867),
    [anon_sym_else] = ACTIONS(867),
    [anon_sym_switch] = ACTIONS(867),
    [anon_sym_endswitch] = ACTIONS(867),
    [anon_sym_case] = ACTIONS(867),
    [anon_sym_default] = ACTIONS(867),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(867),
    [anon_sym_TILDE] = ACTIONS(865),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_clone] = ACTIONS(867),
    [anon_sym_print] = ACTIONS(867),
    [anon_sym_new] = ACTIONS(867),
    [anon_sym_PLUS_PLUS] = ACTIONS(865),
    [anon_sym_DASH_DASH] = ACTIONS(865),
    [sym_shell_command_expression] = ACTIONS(865),
    [anon_sym_list] = ACTIONS(867),
    [anon_sym_self] = ACTIONS(867),
    [anon_sym_parent] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(865),
    [sym_string] = ACTIONS(865),
    [sym_boolean] = ACTIONS(867),
    [sym_null] = ACTIONS(867),
    [anon_sym_DOLLAR] = ACTIONS(865),
    [anon_sym_yield] = ACTIONS(867),
    [anon_sym_include] = ACTIONS(867),
    [anon_sym_include_once] = ACTIONS(867),
    [anon_sym_require] = ACTIONS(867),
    [anon_sym_require_once] = ACTIONS(867),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(865),
  },
  [272] = {
    [sym_text_interpolation] = STATE(272),
    [ts_builtin_sym_end] = ACTIONS(869),
    [sym_name] = ACTIONS(871),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(869),
    [anon_sym_static] = ACTIONS(871),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_namespace] = ACTIONS(871),
    [anon_sym_use] = ACTIONS(871),
    [anon_sym_BSLASH] = ACTIONS(869),
    [anon_sym_function] = ACTIONS(871),
    [anon_sym_const] = ACTIONS(871),
    [anon_sym_LBRACE] = ACTIONS(869),
    [anon_sym_RBRACE] = ACTIONS(869),
    [anon_sym_trait] = ACTIONS(871),
    [anon_sym_interface] = ACTIONS(871),
    [anon_sym_class] = ACTIONS(871),
    [anon_sym_abstract] = ACTIONS(871),
    [anon_sym_final] = ACTIONS(871),
    [anon_sym_public] = ACTIONS(871),
    [anon_sym_protected] = ACTIONS(871),
    [anon_sym_private] = ACTIONS(871),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_array] = ACTIONS(871),
    [anon_sym_unset] = ACTIONS(871),
    [anon_sym_echo] = ACTIONS(871),
    [anon_sym_declare] = ACTIONS(871),
    [anon_sym_enddeclare] = ACTIONS(871),
    [sym_float] = ACTIONS(871),
    [anon_sym_try] = ACTIONS(871),
    [anon_sym_goto] = ACTIONS(871),
    [anon_sym_continue] = ACTIONS(871),
    [anon_sym_break] = ACTIONS(871),
    [sym_integer] = ACTIONS(871),
    [anon_sym_return] = ACTIONS(871),
    [anon_sym_throw] = ACTIONS(871),
    [anon_sym_while] = ACTIONS(871),
    [anon_sym_endwhile] = ACTIONS(871),
    [anon_sym_do] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(871),
    [anon_sym_endfor] = ACTIONS(871),
    [anon_sym_foreach] = ACTIONS(871),
    [anon_sym_endforeach] = ACTIONS(871),
    [anon_sym_if] = ACTIONS(871),
    [anon_sym_endif] = ACTIONS(871),
    [anon_sym_elseif] = ACTIONS(871),
    [anon_sym_else] = ACTIONS(871),
    [anon_sym_switch] = ACTIONS(871),
    [anon_sym_endswitch] = ACTIONS(871),
    [anon_sym_case] = ACTIONS(871),
    [anon_sym_default] = ACTIONS(871),
    [anon_sym_AT] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_TILDE] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_clone] = ACTIONS(871),
    [anon_sym_print] = ACTIONS(871),
    [anon_sym_new] = ACTIONS(871),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [sym_shell_command_expression] = ACTIONS(869),
    [anon_sym_list] = ACTIONS(871),
    [anon_sym_self] = ACTIONS(871),
    [anon_sym_parent] = ACTIONS(871),
    [anon_sym_LBRACK] = ACTIONS(869),
    [sym_string] = ACTIONS(869),
    [sym_boolean] = ACTIONS(871),
    [sym_null] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(871),
    [anon_sym_include] = ACTIONS(871),
    [anon_sym_include_once] = ACTIONS(871),
    [anon_sym_require] = ACTIONS(871),
    [anon_sym_require_once] = ACTIONS(871),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(869),
  },
  [273] = {
    [sym_text_interpolation] = STATE(273),
    [ts_builtin_sym_end] = ACTIONS(873),
    [sym_name] = ACTIONS(875),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_static] = ACTIONS(875),
    [anon_sym_global] = ACTIONS(875),
    [anon_sym_namespace] = ACTIONS(875),
    [anon_sym_use] = ACTIONS(875),
    [anon_sym_BSLASH] = ACTIONS(873),
    [anon_sym_function] = ACTIONS(875),
    [anon_sym_const] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(873),
    [anon_sym_RBRACE] = ACTIONS(873),
    [anon_sym_trait] = ACTIONS(875),
    [anon_sym_interface] = ACTIONS(875),
    [anon_sym_class] = ACTIONS(875),
    [anon_sym_abstract] = ACTIONS(875),
    [anon_sym_final] = ACTIONS(875),
    [anon_sym_public] = ACTIONS(875),
    [anon_sym_protected] = ACTIONS(875),
    [anon_sym_private] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_array] = ACTIONS(875),
    [anon_sym_unset] = ACTIONS(875),
    [anon_sym_echo] = ACTIONS(875),
    [anon_sym_declare] = ACTIONS(875),
    [anon_sym_enddeclare] = ACTIONS(875),
    [sym_float] = ACTIONS(875),
    [anon_sym_try] = ACTIONS(875),
    [anon_sym_goto] = ACTIONS(875),
    [anon_sym_continue] = ACTIONS(875),
    [anon_sym_break] = ACTIONS(875),
    [sym_integer] = ACTIONS(875),
    [anon_sym_return] = ACTIONS(875),
    [anon_sym_throw] = ACTIONS(875),
    [anon_sym_while] = ACTIONS(875),
    [anon_sym_endwhile] = ACTIONS(875),
    [anon_sym_do] = ACTIONS(875),
    [anon_sym_for] = ACTIONS(875),
    [anon_sym_endfor] = ACTIONS(875),
    [anon_sym_foreach] = ACTIONS(875),
    [anon_sym_endforeach] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(875),
    [anon_sym_endif] = ACTIONS(875),
    [anon_sym_elseif] = ACTIONS(875),
    [anon_sym_else] = ACTIONS(875),
    [anon_sym_switch] = ACTIONS(875),
    [anon_sym_endswitch] = ACTIONS(875),
    [anon_sym_case] = ACTIONS(875),
    [anon_sym_default] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_DASH] = ACTIONS(875),
    [anon_sym_TILDE] = ACTIONS(873),
    [anon_sym_BANG] = ACTIONS(873),
    [anon_sym_clone] = ACTIONS(875),
    [anon_sym_print] = ACTIONS(875),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(873),
    [anon_sym_DASH_DASH] = ACTIONS(873),
    [sym_shell_command_expression] = ACTIONS(873),
    [anon_sym_list] = ACTIONS(875),
    [anon_sym_self] = ACTIONS(875),
    [anon_sym_parent] = ACTIONS(875),
    [anon_sym_LBRACK] = ACTIONS(873),
    [sym_string] = ACTIONS(873),
    [sym_boolean] = ACTIONS(875),
    [sym_null] = ACTIONS(875),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_yield] = ACTIONS(875),
    [anon_sym_include] = ACTIONS(875),
    [anon_sym_include_once] = ACTIONS(875),
    [anon_sym_require] = ACTIONS(875),
    [anon_sym_require_once] = ACTIONS(875),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(873),
  },
  [274] = {
    [sym_text_interpolation] = STATE(274),
    [ts_builtin_sym_end] = ACTIONS(877),
    [sym_name] = ACTIONS(879),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(877),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_global] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(879),
    [anon_sym_use] = ACTIONS(879),
    [anon_sym_BSLASH] = ACTIONS(877),
    [anon_sym_function] = ACTIONS(879),
    [anon_sym_const] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(877),
    [anon_sym_RBRACE] = ACTIONS(877),
    [anon_sym_trait] = ACTIONS(879),
    [anon_sym_interface] = ACTIONS(879),
    [anon_sym_class] = ACTIONS(879),
    [anon_sym_abstract] = ACTIONS(879),
    [anon_sym_final] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_array] = ACTIONS(879),
    [anon_sym_unset] = ACTIONS(879),
    [anon_sym_echo] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_enddeclare] = ACTIONS(879),
    [sym_float] = ACTIONS(879),
    [anon_sym_try] = ACTIONS(879),
    [anon_sym_goto] = ACTIONS(879),
    [anon_sym_continue] = ACTIONS(879),
    [anon_sym_break] = ACTIONS(879),
    [sym_integer] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(879),
    [anon_sym_throw] = ACTIONS(879),
    [anon_sym_while] = ACTIONS(879),
    [anon_sym_endwhile] = ACTIONS(879),
    [anon_sym_do] = ACTIONS(879),
    [anon_sym_for] = ACTIONS(879),
    [anon_sym_endfor] = ACTIONS(879),
    [anon_sym_foreach] = ACTIONS(879),
    [anon_sym_endforeach] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(879),
    [anon_sym_endif] = ACTIONS(879),
    [anon_sym_elseif] = ACTIONS(879),
    [anon_sym_else] = ACTIONS(879),
    [anon_sym_switch] = ACTIONS(879),
    [anon_sym_endswitch] = ACTIONS(879),
    [anon_sym_case] = ACTIONS(879),
    [anon_sym_default] = ACTIONS(879),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(879),
    [anon_sym_DASH] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_clone] = ACTIONS(879),
    [anon_sym_print] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(879),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [sym_shell_command_expression] = ACTIONS(877),
    [anon_sym_list] = ACTIONS(879),
    [anon_sym_self] = ACTIONS(879),
    [anon_sym_parent] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(877),
    [sym_string] = ACTIONS(877),
    [sym_boolean] = ACTIONS(879),
    [sym_null] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(877),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_include] = ACTIONS(879),
    [anon_sym_include_once] = ACTIONS(879),
    [anon_sym_require] = ACTIONS(879),
    [anon_sym_require_once] = ACTIONS(879),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(877),
  },
  [275] = {
    [sym_text_interpolation] = STATE(275),
    [ts_builtin_sym_end] = ACTIONS(881),
    [sym_name] = ACTIONS(883),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_static] = ACTIONS(883),
    [anon_sym_global] = ACTIONS(883),
    [anon_sym_namespace] = ACTIONS(883),
    [anon_sym_use] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(881),
    [anon_sym_function] = ACTIONS(883),
    [anon_sym_const] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(881),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_trait] = ACTIONS(883),
    [anon_sym_interface] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(883),
    [anon_sym_abstract] = ACTIONS(883),
    [anon_sym_final] = ACTIONS(883),
    [anon_sym_public] = ACTIONS(883),
    [anon_sym_protected] = ACTIONS(883),
    [anon_sym_private] = ACTIONS(883),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_array] = ACTIONS(883),
    [anon_sym_unset] = ACTIONS(883),
    [anon_sym_echo] = ACTIONS(883),
    [anon_sym_declare] = ACTIONS(883),
    [anon_sym_enddeclare] = ACTIONS(883),
    [sym_float] = ACTIONS(883),
    [anon_sym_try] = ACTIONS(883),
    [anon_sym_goto] = ACTIONS(883),
    [anon_sym_continue] = ACTIONS(883),
    [anon_sym_break] = ACTIONS(883),
    [sym_integer] = ACTIONS(883),
    [anon_sym_return] = ACTIONS(883),
    [anon_sym_throw] = ACTIONS(883),
    [anon_sym_while] = ACTIONS(883),
    [anon_sym_endwhile] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_for] = ACTIONS(883),
    [anon_sym_endfor] = ACTIONS(883),
    [anon_sym_foreach] = ACTIONS(883),
    [anon_sym_endforeach] = ACTIONS(883),
    [anon_sym_if] = ACTIONS(883),
    [anon_sym_endif] = ACTIONS(883),
    [anon_sym_elseif] = ACTIONS(883),
    [anon_sym_else] = ACTIONS(883),
    [anon_sym_switch] = ACTIONS(883),
    [anon_sym_endswitch] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(883),
    [anon_sym_default] = ACTIONS(883),
    [anon_sym_AT] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_DASH] = ACTIONS(883),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_BANG] = ACTIONS(881),
    [anon_sym_clone] = ACTIONS(883),
    [anon_sym_print] = ACTIONS(883),
    [anon_sym_new] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(881),
    [anon_sym_DASH_DASH] = ACTIONS(881),
    [sym_shell_command_expression] = ACTIONS(881),
    [anon_sym_list] = ACTIONS(883),
    [anon_sym_self] = ACTIONS(883),
    [anon_sym_parent] = ACTIONS(883),
    [anon_sym_LBRACK] = ACTIONS(881),
    [sym_string] = ACTIONS(881),
    [sym_boolean] = ACTIONS(883),
    [sym_null] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(881),
    [anon_sym_yield] = ACTIONS(883),
    [anon_sym_include] = ACTIONS(883),
    [anon_sym_include_once] = ACTIONS(883),
    [anon_sym_require] = ACTIONS(883),
    [anon_sym_require_once] = ACTIONS(883),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(881),
  },
  [276] = {
    [sym_text_interpolation] = STATE(276),
    [ts_builtin_sym_end] = ACTIONS(885),
    [sym_name] = ACTIONS(887),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(885),
    [anon_sym_static] = ACTIONS(887),
    [anon_sym_global] = ACTIONS(887),
    [anon_sym_namespace] = ACTIONS(887),
    [anon_sym_use] = ACTIONS(887),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_function] = ACTIONS(887),
    [anon_sym_const] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(885),
    [anon_sym_RBRACE] = ACTIONS(885),
    [anon_sym_trait] = ACTIONS(887),
    [anon_sym_interface] = ACTIONS(887),
    [anon_sym_class] = ACTIONS(887),
    [anon_sym_abstract] = ACTIONS(887),
    [anon_sym_final] = ACTIONS(887),
    [anon_sym_public] = ACTIONS(887),
    [anon_sym_protected] = ACTIONS(887),
    [anon_sym_private] = ACTIONS(887),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_array] = ACTIONS(887),
    [anon_sym_unset] = ACTIONS(887),
    [anon_sym_echo] = ACTIONS(887),
    [anon_sym_declare] = ACTIONS(887),
    [anon_sym_enddeclare] = ACTIONS(887),
    [sym_float] = ACTIONS(887),
    [anon_sym_try] = ACTIONS(887),
    [anon_sym_goto] = ACTIONS(887),
    [anon_sym_continue] = ACTIONS(887),
    [anon_sym_break] = ACTIONS(887),
    [sym_integer] = ACTIONS(887),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_throw] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_endwhile] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_for] = ACTIONS(887),
    [anon_sym_endfor] = ACTIONS(887),
    [anon_sym_foreach] = ACTIONS(887),
    [anon_sym_endforeach] = ACTIONS(887),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_endif] = ACTIONS(887),
    [anon_sym_elseif] = ACTIONS(887),
    [anon_sym_else] = ACTIONS(887),
    [anon_sym_switch] = ACTIONS(887),
    [anon_sym_endswitch] = ACTIONS(887),
    [anon_sym_case] = ACTIONS(887),
    [anon_sym_default] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(885),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_clone] = ACTIONS(887),
    [anon_sym_print] = ACTIONS(887),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [sym_shell_command_expression] = ACTIONS(885),
    [anon_sym_list] = ACTIONS(887),
    [anon_sym_self] = ACTIONS(887),
    [anon_sym_parent] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(885),
    [sym_string] = ACTIONS(885),
    [sym_boolean] = ACTIONS(887),
    [sym_null] = ACTIONS(887),
    [anon_sym_DOLLAR] = ACTIONS(885),
    [anon_sym_yield] = ACTIONS(887),
    [anon_sym_include] = ACTIONS(887),
    [anon_sym_include_once] = ACTIONS(887),
    [anon_sym_require] = ACTIONS(887),
    [anon_sym_require_once] = ACTIONS(887),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(885),
  },
  [277] = {
    [sym_text_interpolation] = STATE(277),
    [ts_builtin_sym_end] = ACTIONS(889),
    [sym_name] = ACTIONS(891),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_global] = ACTIONS(891),
    [anon_sym_namespace] = ACTIONS(891),
    [anon_sym_use] = ACTIONS(891),
    [anon_sym_BSLASH] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(891),
    [anon_sym_const] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(889),
    [anon_sym_trait] = ACTIONS(891),
    [anon_sym_interface] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(891),
    [anon_sym_abstract] = ACTIONS(891),
    [anon_sym_final] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(889),
    [anon_sym_array] = ACTIONS(891),
    [anon_sym_unset] = ACTIONS(891),
    [anon_sym_echo] = ACTIONS(891),
    [anon_sym_declare] = ACTIONS(891),
    [anon_sym_enddeclare] = ACTIONS(891),
    [sym_float] = ACTIONS(891),
    [anon_sym_try] = ACTIONS(891),
    [anon_sym_goto] = ACTIONS(891),
    [anon_sym_continue] = ACTIONS(891),
    [anon_sym_break] = ACTIONS(891),
    [sym_integer] = ACTIONS(891),
    [anon_sym_return] = ACTIONS(891),
    [anon_sym_throw] = ACTIONS(891),
    [anon_sym_while] = ACTIONS(891),
    [anon_sym_endwhile] = ACTIONS(891),
    [anon_sym_do] = ACTIONS(891),
    [anon_sym_for] = ACTIONS(891),
    [anon_sym_endfor] = ACTIONS(891),
    [anon_sym_foreach] = ACTIONS(891),
    [anon_sym_endforeach] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_endif] = ACTIONS(891),
    [anon_sym_elseif] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(891),
    [anon_sym_switch] = ACTIONS(891),
    [anon_sym_endswitch] = ACTIONS(891),
    [anon_sym_case] = ACTIONS(891),
    [anon_sym_default] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_clone] = ACTIONS(891),
    [anon_sym_print] = ACTIONS(891),
    [anon_sym_new] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(889),
    [anon_sym_DASH_DASH] = ACTIONS(889),
    [sym_shell_command_expression] = ACTIONS(889),
    [anon_sym_list] = ACTIONS(891),
    [anon_sym_self] = ACTIONS(891),
    [anon_sym_parent] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(889),
    [sym_string] = ACTIONS(889),
    [sym_boolean] = ACTIONS(891),
    [sym_null] = ACTIONS(891),
    [anon_sym_DOLLAR] = ACTIONS(889),
    [anon_sym_yield] = ACTIONS(891),
    [anon_sym_include] = ACTIONS(891),
    [anon_sym_include_once] = ACTIONS(891),
    [anon_sym_require] = ACTIONS(891),
    [anon_sym_require_once] = ACTIONS(891),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(889),
  },
  [278] = {
    [sym_text_interpolation] = STATE(278),
    [ts_builtin_sym_end] = ACTIONS(893),
    [sym_name] = ACTIONS(895),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_static] = ACTIONS(895),
    [anon_sym_global] = ACTIONS(895),
    [anon_sym_namespace] = ACTIONS(895),
    [anon_sym_use] = ACTIONS(895),
    [anon_sym_BSLASH] = ACTIONS(893),
    [anon_sym_function] = ACTIONS(895),
    [anon_sym_const] = ACTIONS(895),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_trait] = ACTIONS(895),
    [anon_sym_interface] = ACTIONS(895),
    [anon_sym_class] = ACTIONS(895),
    [anon_sym_abstract] = ACTIONS(895),
    [anon_sym_final] = ACTIONS(895),
    [anon_sym_public] = ACTIONS(895),
    [anon_sym_protected] = ACTIONS(895),
    [anon_sym_private] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(893),
    [anon_sym_array] = ACTIONS(895),
    [anon_sym_unset] = ACTIONS(895),
    [anon_sym_echo] = ACTIONS(895),
    [anon_sym_declare] = ACTIONS(895),
    [anon_sym_enddeclare] = ACTIONS(895),
    [sym_float] = ACTIONS(895),
    [anon_sym_try] = ACTIONS(895),
    [anon_sym_goto] = ACTIONS(895),
    [anon_sym_continue] = ACTIONS(895),
    [anon_sym_break] = ACTIONS(895),
    [sym_integer] = ACTIONS(895),
    [anon_sym_return] = ACTIONS(895),
    [anon_sym_throw] = ACTIONS(895),
    [anon_sym_while] = ACTIONS(895),
    [anon_sym_endwhile] = ACTIONS(895),
    [anon_sym_do] = ACTIONS(895),
    [anon_sym_for] = ACTIONS(895),
    [anon_sym_endfor] = ACTIONS(895),
    [anon_sym_foreach] = ACTIONS(895),
    [anon_sym_endforeach] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(895),
    [anon_sym_endif] = ACTIONS(895),
    [anon_sym_elseif] = ACTIONS(895),
    [anon_sym_else] = ACTIONS(895),
    [anon_sym_switch] = ACTIONS(895),
    [anon_sym_endswitch] = ACTIONS(895),
    [anon_sym_case] = ACTIONS(895),
    [anon_sym_default] = ACTIONS(895),
    [anon_sym_AT] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(893),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_clone] = ACTIONS(895),
    [anon_sym_print] = ACTIONS(895),
    [anon_sym_new] = ACTIONS(895),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [sym_shell_command_expression] = ACTIONS(893),
    [anon_sym_list] = ACTIONS(895),
    [anon_sym_self] = ACTIONS(895),
    [anon_sym_parent] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(893),
    [sym_string] = ACTIONS(893),
    [sym_boolean] = ACTIONS(895),
    [sym_null] = ACTIONS(895),
    [anon_sym_DOLLAR] = ACTIONS(893),
    [anon_sym_yield] = ACTIONS(895),
    [anon_sym_include] = ACTIONS(895),
    [anon_sym_include_once] = ACTIONS(895),
    [anon_sym_require] = ACTIONS(895),
    [anon_sym_require_once] = ACTIONS(895),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(893),
  },
  [279] = {
    [sym_text_interpolation] = STATE(279),
    [ts_builtin_sym_end] = ACTIONS(897),
    [sym_name] = ACTIONS(899),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_static] = ACTIONS(899),
    [anon_sym_global] = ACTIONS(899),
    [anon_sym_namespace] = ACTIONS(899),
    [anon_sym_use] = ACTIONS(899),
    [anon_sym_BSLASH] = ACTIONS(897),
    [anon_sym_function] = ACTIONS(899),
    [anon_sym_const] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_trait] = ACTIONS(899),
    [anon_sym_interface] = ACTIONS(899),
    [anon_sym_class] = ACTIONS(899),
    [anon_sym_abstract] = ACTIONS(899),
    [anon_sym_final] = ACTIONS(899),
    [anon_sym_public] = ACTIONS(899),
    [anon_sym_protected] = ACTIONS(899),
    [anon_sym_private] = ACTIONS(899),
    [anon_sym_LPAREN] = ACTIONS(897),
    [anon_sym_array] = ACTIONS(899),
    [anon_sym_unset] = ACTIONS(899),
    [anon_sym_echo] = ACTIONS(899),
    [anon_sym_declare] = ACTIONS(899),
    [anon_sym_enddeclare] = ACTIONS(899),
    [sym_float] = ACTIONS(899),
    [anon_sym_try] = ACTIONS(899),
    [anon_sym_goto] = ACTIONS(899),
    [anon_sym_continue] = ACTIONS(899),
    [anon_sym_break] = ACTIONS(899),
    [sym_integer] = ACTIONS(899),
    [anon_sym_return] = ACTIONS(899),
    [anon_sym_throw] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_endwhile] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_endfor] = ACTIONS(899),
    [anon_sym_foreach] = ACTIONS(899),
    [anon_sym_endforeach] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_endif] = ACTIONS(899),
    [anon_sym_elseif] = ACTIONS(899),
    [anon_sym_else] = ACTIONS(899),
    [anon_sym_switch] = ACTIONS(899),
    [anon_sym_endswitch] = ACTIONS(899),
    [anon_sym_case] = ACTIONS(899),
    [anon_sym_default] = ACTIONS(899),
    [anon_sym_AT] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_clone] = ACTIONS(899),
    [anon_sym_print] = ACTIONS(899),
    [anon_sym_new] = ACTIONS(899),
    [anon_sym_PLUS_PLUS] = ACTIONS(897),
    [anon_sym_DASH_DASH] = ACTIONS(897),
    [sym_shell_command_expression] = ACTIONS(897),
    [anon_sym_list] = ACTIONS(899),
    [anon_sym_self] = ACTIONS(899),
    [anon_sym_parent] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(897),
    [sym_string] = ACTIONS(897),
    [sym_boolean] = ACTIONS(899),
    [sym_null] = ACTIONS(899),
    [anon_sym_DOLLAR] = ACTIONS(897),
    [anon_sym_yield] = ACTIONS(899),
    [anon_sym_include] = ACTIONS(899),
    [anon_sym_include_once] = ACTIONS(899),
    [anon_sym_require] = ACTIONS(899),
    [anon_sym_require_once] = ACTIONS(899),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(897),
  },
  [280] = {
    [sym_text_interpolation] = STATE(280),
    [ts_builtin_sym_end] = ACTIONS(901),
    [sym_name] = ACTIONS(903),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(901),
    [anon_sym_static] = ACTIONS(903),
    [anon_sym_global] = ACTIONS(903),
    [anon_sym_namespace] = ACTIONS(903),
    [anon_sym_use] = ACTIONS(903),
    [anon_sym_BSLASH] = ACTIONS(901),
    [anon_sym_function] = ACTIONS(903),
    [anon_sym_const] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(901),
    [anon_sym_RBRACE] = ACTIONS(901),
    [anon_sym_trait] = ACTIONS(903),
    [anon_sym_interface] = ACTIONS(903),
    [anon_sym_class] = ACTIONS(903),
    [anon_sym_abstract] = ACTIONS(903),
    [anon_sym_final] = ACTIONS(903),
    [anon_sym_public] = ACTIONS(903),
    [anon_sym_protected] = ACTIONS(903),
    [anon_sym_private] = ACTIONS(903),
    [anon_sym_LPAREN] = ACTIONS(901),
    [anon_sym_array] = ACTIONS(903),
    [anon_sym_unset] = ACTIONS(903),
    [anon_sym_echo] = ACTIONS(903),
    [anon_sym_declare] = ACTIONS(903),
    [anon_sym_enddeclare] = ACTIONS(903),
    [sym_float] = ACTIONS(903),
    [anon_sym_try] = ACTIONS(903),
    [anon_sym_goto] = ACTIONS(903),
    [anon_sym_continue] = ACTIONS(903),
    [anon_sym_break] = ACTIONS(903),
    [sym_integer] = ACTIONS(903),
    [anon_sym_return] = ACTIONS(903),
    [anon_sym_throw] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(903),
    [anon_sym_endwhile] = ACTIONS(903),
    [anon_sym_do] = ACTIONS(903),
    [anon_sym_for] = ACTIONS(903),
    [anon_sym_endfor] = ACTIONS(903),
    [anon_sym_foreach] = ACTIONS(903),
    [anon_sym_endforeach] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(903),
    [anon_sym_endif] = ACTIONS(903),
    [anon_sym_elseif] = ACTIONS(903),
    [anon_sym_else] = ACTIONS(903),
    [anon_sym_switch] = ACTIONS(903),
    [anon_sym_endswitch] = ACTIONS(903),
    [anon_sym_case] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(903),
    [anon_sym_AT] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_DASH] = ACTIONS(903),
    [anon_sym_TILDE] = ACTIONS(901),
    [anon_sym_BANG] = ACTIONS(901),
    [anon_sym_clone] = ACTIONS(903),
    [anon_sym_print] = ACTIONS(903),
    [anon_sym_new] = ACTIONS(903),
    [anon_sym_PLUS_PLUS] = ACTIONS(901),
    [anon_sym_DASH_DASH] = ACTIONS(901),
    [sym_shell_command_expression] = ACTIONS(901),
    [anon_sym_list] = ACTIONS(903),
    [anon_sym_self] = ACTIONS(903),
    [anon_sym_parent] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(901),
    [sym_string] = ACTIONS(901),
    [sym_boolean] = ACTIONS(903),
    [sym_null] = ACTIONS(903),
    [anon_sym_DOLLAR] = ACTIONS(901),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_include] = ACTIONS(903),
    [anon_sym_include_once] = ACTIONS(903),
    [anon_sym_require] = ACTIONS(903),
    [anon_sym_require_once] = ACTIONS(903),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(901),
  },
  [281] = {
    [sym_text_interpolation] = STATE(281),
    [ts_builtin_sym_end] = ACTIONS(905),
    [sym_name] = ACTIONS(907),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(905),
    [anon_sym_static] = ACTIONS(907),
    [anon_sym_global] = ACTIONS(907),
    [anon_sym_namespace] = ACTIONS(907),
    [anon_sym_use] = ACTIONS(907),
    [anon_sym_BSLASH] = ACTIONS(905),
    [anon_sym_function] = ACTIONS(907),
    [anon_sym_const] = ACTIONS(907),
    [anon_sym_LBRACE] = ACTIONS(905),
    [anon_sym_RBRACE] = ACTIONS(905),
    [anon_sym_trait] = ACTIONS(907),
    [anon_sym_interface] = ACTIONS(907),
    [anon_sym_class] = ACTIONS(907),
    [anon_sym_abstract] = ACTIONS(907),
    [anon_sym_final] = ACTIONS(907),
    [anon_sym_public] = ACTIONS(907),
    [anon_sym_protected] = ACTIONS(907),
    [anon_sym_private] = ACTIONS(907),
    [anon_sym_LPAREN] = ACTIONS(905),
    [anon_sym_array] = ACTIONS(907),
    [anon_sym_unset] = ACTIONS(907),
    [anon_sym_echo] = ACTIONS(907),
    [anon_sym_declare] = ACTIONS(907),
    [anon_sym_enddeclare] = ACTIONS(907),
    [sym_float] = ACTIONS(907),
    [anon_sym_try] = ACTIONS(907),
    [anon_sym_goto] = ACTIONS(907),
    [anon_sym_continue] = ACTIONS(907),
    [anon_sym_break] = ACTIONS(907),
    [sym_integer] = ACTIONS(907),
    [anon_sym_return] = ACTIONS(907),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_while] = ACTIONS(907),
    [anon_sym_endwhile] = ACTIONS(907),
    [anon_sym_do] = ACTIONS(907),
    [anon_sym_for] = ACTIONS(907),
    [anon_sym_endfor] = ACTIONS(907),
    [anon_sym_foreach] = ACTIONS(907),
    [anon_sym_endforeach] = ACTIONS(907),
    [anon_sym_if] = ACTIONS(907),
    [anon_sym_endif] = ACTIONS(907),
    [anon_sym_elseif] = ACTIONS(907),
    [anon_sym_else] = ACTIONS(907),
    [anon_sym_switch] = ACTIONS(907),
    [anon_sym_endswitch] = ACTIONS(907),
    [anon_sym_case] = ACTIONS(907),
    [anon_sym_default] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(907),
    [anon_sym_DASH] = ACTIONS(907),
    [anon_sym_TILDE] = ACTIONS(905),
    [anon_sym_BANG] = ACTIONS(905),
    [anon_sym_clone] = ACTIONS(907),
    [anon_sym_print] = ACTIONS(907),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS_PLUS] = ACTIONS(905),
    [anon_sym_DASH_DASH] = ACTIONS(905),
    [sym_shell_command_expression] = ACTIONS(905),
    [anon_sym_list] = ACTIONS(907),
    [anon_sym_self] = ACTIONS(907),
    [anon_sym_parent] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(905),
    [sym_string] = ACTIONS(905),
    [sym_boolean] = ACTIONS(907),
    [sym_null] = ACTIONS(907),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [anon_sym_yield] = ACTIONS(907),
    [anon_sym_include] = ACTIONS(907),
    [anon_sym_include_once] = ACTIONS(907),
    [anon_sym_require] = ACTIONS(907),
    [anon_sym_require_once] = ACTIONS(907),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(905),
  },
  [282] = {
    [sym_text_interpolation] = STATE(282),
    [ts_builtin_sym_end] = ACTIONS(909),
    [sym_name] = ACTIONS(911),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_static] = ACTIONS(911),
    [anon_sym_global] = ACTIONS(911),
    [anon_sym_namespace] = ACTIONS(911),
    [anon_sym_use] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(909),
    [anon_sym_function] = ACTIONS(911),
    [anon_sym_const] = ACTIONS(911),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_trait] = ACTIONS(911),
    [anon_sym_interface] = ACTIONS(911),
    [anon_sym_class] = ACTIONS(911),
    [anon_sym_abstract] = ACTIONS(911),
    [anon_sym_final] = ACTIONS(911),
    [anon_sym_public] = ACTIONS(911),
    [anon_sym_protected] = ACTIONS(911),
    [anon_sym_private] = ACTIONS(911),
    [anon_sym_LPAREN] = ACTIONS(909),
    [anon_sym_array] = ACTIONS(911),
    [anon_sym_unset] = ACTIONS(911),
    [anon_sym_echo] = ACTIONS(911),
    [anon_sym_declare] = ACTIONS(911),
    [anon_sym_enddeclare] = ACTIONS(911),
    [sym_float] = ACTIONS(911),
    [anon_sym_try] = ACTIONS(911),
    [anon_sym_goto] = ACTIONS(911),
    [anon_sym_continue] = ACTIONS(911),
    [anon_sym_break] = ACTIONS(911),
    [sym_integer] = ACTIONS(911),
    [anon_sym_return] = ACTIONS(911),
    [anon_sym_throw] = ACTIONS(911),
    [anon_sym_while] = ACTIONS(911),
    [anon_sym_endwhile] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(911),
    [anon_sym_for] = ACTIONS(911),
    [anon_sym_endfor] = ACTIONS(911),
    [anon_sym_foreach] = ACTIONS(911),
    [anon_sym_endforeach] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(911),
    [anon_sym_endif] = ACTIONS(911),
    [anon_sym_elseif] = ACTIONS(911),
    [anon_sym_else] = ACTIONS(911),
    [anon_sym_switch] = ACTIONS(911),
    [anon_sym_endswitch] = ACTIONS(911),
    [anon_sym_case] = ACTIONS(911),
    [anon_sym_default] = ACTIONS(911),
    [anon_sym_AT] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_DASH] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(909),
    [anon_sym_BANG] = ACTIONS(909),
    [anon_sym_clone] = ACTIONS(911),
    [anon_sym_print] = ACTIONS(911),
    [anon_sym_new] = ACTIONS(911),
    [anon_sym_PLUS_PLUS] = ACTIONS(909),
    [anon_sym_DASH_DASH] = ACTIONS(909),
    [sym_shell_command_expression] = ACTIONS(909),
    [anon_sym_list] = ACTIONS(911),
    [anon_sym_self] = ACTIONS(911),
    [anon_sym_parent] = ACTIONS(911),
    [anon_sym_LBRACK] = ACTIONS(909),
    [sym_string] = ACTIONS(909),
    [sym_boolean] = ACTIONS(911),
    [sym_null] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(909),
    [anon_sym_yield] = ACTIONS(911),
    [anon_sym_include] = ACTIONS(911),
    [anon_sym_include_once] = ACTIONS(911),
    [anon_sym_require] = ACTIONS(911),
    [anon_sym_require_once] = ACTIONS(911),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(909),
  },
  [283] = {
    [sym_text_interpolation] = STATE(283),
    [ts_builtin_sym_end] = ACTIONS(913),
    [sym_name] = ACTIONS(915),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_static] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(915),
    [anon_sym_namespace] = ACTIONS(915),
    [anon_sym_use] = ACTIONS(915),
    [anon_sym_BSLASH] = ACTIONS(913),
    [anon_sym_function] = ACTIONS(915),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_trait] = ACTIONS(915),
    [anon_sym_interface] = ACTIONS(915),
    [anon_sym_class] = ACTIONS(915),
    [anon_sym_abstract] = ACTIONS(915),
    [anon_sym_final] = ACTIONS(915),
    [anon_sym_public] = ACTIONS(915),
    [anon_sym_protected] = ACTIONS(915),
    [anon_sym_private] = ACTIONS(915),
    [anon_sym_LPAREN] = ACTIONS(913),
    [anon_sym_array] = ACTIONS(915),
    [anon_sym_unset] = ACTIONS(915),
    [anon_sym_echo] = ACTIONS(915),
    [anon_sym_declare] = ACTIONS(915),
    [anon_sym_enddeclare] = ACTIONS(915),
    [sym_float] = ACTIONS(915),
    [anon_sym_try] = ACTIONS(915),
    [anon_sym_goto] = ACTIONS(915),
    [anon_sym_continue] = ACTIONS(915),
    [anon_sym_break] = ACTIONS(915),
    [sym_integer] = ACTIONS(915),
    [anon_sym_return] = ACTIONS(915),
    [anon_sym_throw] = ACTIONS(915),
    [anon_sym_while] = ACTIONS(915),
    [anon_sym_endwhile] = ACTIONS(915),
    [anon_sym_do] = ACTIONS(915),
    [anon_sym_for] = ACTIONS(915),
    [anon_sym_endfor] = ACTIONS(915),
    [anon_sym_foreach] = ACTIONS(915),
    [anon_sym_endforeach] = ACTIONS(915),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_endif] = ACTIONS(915),
    [anon_sym_elseif] = ACTIONS(915),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_switch] = ACTIONS(915),
    [anon_sym_endswitch] = ACTIONS(915),
    [anon_sym_case] = ACTIONS(915),
    [anon_sym_default] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_BANG] = ACTIONS(913),
    [anon_sym_clone] = ACTIONS(915),
    [anon_sym_print] = ACTIONS(915),
    [anon_sym_new] = ACTIONS(915),
    [anon_sym_PLUS_PLUS] = ACTIONS(913),
    [anon_sym_DASH_DASH] = ACTIONS(913),
    [sym_shell_command_expression] = ACTIONS(913),
    [anon_sym_list] = ACTIONS(915),
    [anon_sym_self] = ACTIONS(915),
    [anon_sym_parent] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(913),
    [sym_string] = ACTIONS(913),
    [sym_boolean] = ACTIONS(915),
    [sym_null] = ACTIONS(915),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_yield] = ACTIONS(915),
    [anon_sym_include] = ACTIONS(915),
    [anon_sym_include_once] = ACTIONS(915),
    [anon_sym_require] = ACTIONS(915),
    [anon_sym_require_once] = ACTIONS(915),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(913),
  },
  [284] = {
    [sym_text_interpolation] = STATE(284),
    [ts_builtin_sym_end] = ACTIONS(917),
    [sym_name] = ACTIONS(919),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(917),
    [anon_sym_static] = ACTIONS(919),
    [anon_sym_global] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_use] = ACTIONS(919),
    [anon_sym_BSLASH] = ACTIONS(917),
    [anon_sym_function] = ACTIONS(919),
    [anon_sym_const] = ACTIONS(919),
    [anon_sym_LBRACE] = ACTIONS(917),
    [anon_sym_RBRACE] = ACTIONS(917),
    [anon_sym_trait] = ACTIONS(919),
    [anon_sym_interface] = ACTIONS(919),
    [anon_sym_class] = ACTIONS(919),
    [anon_sym_abstract] = ACTIONS(919),
    [anon_sym_final] = ACTIONS(919),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_array] = ACTIONS(919),
    [anon_sym_unset] = ACTIONS(919),
    [anon_sym_echo] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_enddeclare] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [anon_sym_try] = ACTIONS(919),
    [anon_sym_goto] = ACTIONS(919),
    [anon_sym_continue] = ACTIONS(919),
    [anon_sym_break] = ACTIONS(919),
    [sym_integer] = ACTIONS(919),
    [anon_sym_return] = ACTIONS(919),
    [anon_sym_throw] = ACTIONS(919),
    [anon_sym_while] = ACTIONS(919),
    [anon_sym_endwhile] = ACTIONS(919),
    [anon_sym_do] = ACTIONS(919),
    [anon_sym_for] = ACTIONS(919),
    [anon_sym_endfor] = ACTIONS(919),
    [anon_sym_foreach] = ACTIONS(919),
    [anon_sym_endforeach] = ACTIONS(919),
    [anon_sym_if] = ACTIONS(919),
    [anon_sym_endif] = ACTIONS(919),
    [anon_sym_elseif] = ACTIONS(919),
    [anon_sym_else] = ACTIONS(919),
    [anon_sym_switch] = ACTIONS(919),
    [anon_sym_endswitch] = ACTIONS(919),
    [anon_sym_case] = ACTIONS(919),
    [anon_sym_default] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(917),
    [anon_sym_PLUS] = ACTIONS(919),
    [anon_sym_DASH] = ACTIONS(919),
    [anon_sym_TILDE] = ACTIONS(917),
    [anon_sym_BANG] = ACTIONS(917),
    [anon_sym_clone] = ACTIONS(919),
    [anon_sym_print] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(919),
    [anon_sym_PLUS_PLUS] = ACTIONS(917),
    [anon_sym_DASH_DASH] = ACTIONS(917),
    [sym_shell_command_expression] = ACTIONS(917),
    [anon_sym_list] = ACTIONS(919),
    [anon_sym_self] = ACTIONS(919),
    [anon_sym_parent] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(917),
    [sym_string] = ACTIONS(917),
    [sym_boolean] = ACTIONS(919),
    [sym_null] = ACTIONS(919),
    [anon_sym_DOLLAR] = ACTIONS(917),
    [anon_sym_yield] = ACTIONS(919),
    [anon_sym_include] = ACTIONS(919),
    [anon_sym_include_once] = ACTIONS(919),
    [anon_sym_require] = ACTIONS(919),
    [anon_sym_require_once] = ACTIONS(919),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(917),
  },
  [285] = {
    [sym_text_interpolation] = STATE(285),
    [ts_builtin_sym_end] = ACTIONS(921),
    [sym_name] = ACTIONS(923),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(921),
    [anon_sym_static] = ACTIONS(923),
    [anon_sym_global] = ACTIONS(923),
    [anon_sym_namespace] = ACTIONS(923),
    [anon_sym_use] = ACTIONS(923),
    [anon_sym_BSLASH] = ACTIONS(921),
    [anon_sym_function] = ACTIONS(923),
    [anon_sym_const] = ACTIONS(923),
    [anon_sym_LBRACE] = ACTIONS(921),
    [anon_sym_RBRACE] = ACTIONS(921),
    [anon_sym_trait] = ACTIONS(923),
    [anon_sym_interface] = ACTIONS(923),
    [anon_sym_class] = ACTIONS(923),
    [anon_sym_abstract] = ACTIONS(923),
    [anon_sym_final] = ACTIONS(923),
    [anon_sym_public] = ACTIONS(923),
    [anon_sym_protected] = ACTIONS(923),
    [anon_sym_private] = ACTIONS(923),
    [anon_sym_LPAREN] = ACTIONS(921),
    [anon_sym_array] = ACTIONS(923),
    [anon_sym_unset] = ACTIONS(923),
    [anon_sym_echo] = ACTIONS(923),
    [anon_sym_declare] = ACTIONS(923),
    [anon_sym_enddeclare] = ACTIONS(923),
    [sym_float] = ACTIONS(923),
    [anon_sym_try] = ACTIONS(923),
    [anon_sym_goto] = ACTIONS(923),
    [anon_sym_continue] = ACTIONS(923),
    [anon_sym_break] = ACTIONS(923),
    [sym_integer] = ACTIONS(923),
    [anon_sym_return] = ACTIONS(923),
    [anon_sym_throw] = ACTIONS(923),
    [anon_sym_while] = ACTIONS(923),
    [anon_sym_endwhile] = ACTIONS(923),
    [anon_sym_do] = ACTIONS(923),
    [anon_sym_for] = ACTIONS(923),
    [anon_sym_endfor] = ACTIONS(923),
    [anon_sym_foreach] = ACTIONS(923),
    [anon_sym_endforeach] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(923),
    [anon_sym_endif] = ACTIONS(923),
    [anon_sym_elseif] = ACTIONS(923),
    [anon_sym_else] = ACTIONS(923),
    [anon_sym_switch] = ACTIONS(923),
    [anon_sym_endswitch] = ACTIONS(923),
    [anon_sym_case] = ACTIONS(923),
    [anon_sym_default] = ACTIONS(923),
    [anon_sym_AT] = ACTIONS(921),
    [anon_sym_PLUS] = ACTIONS(923),
    [anon_sym_DASH] = ACTIONS(923),
    [anon_sym_TILDE] = ACTIONS(921),
    [anon_sym_BANG] = ACTIONS(921),
    [anon_sym_clone] = ACTIONS(923),
    [anon_sym_print] = ACTIONS(923),
    [anon_sym_new] = ACTIONS(923),
    [anon_sym_PLUS_PLUS] = ACTIONS(921),
    [anon_sym_DASH_DASH] = ACTIONS(921),
    [sym_shell_command_expression] = ACTIONS(921),
    [anon_sym_list] = ACTIONS(923),
    [anon_sym_self] = ACTIONS(923),
    [anon_sym_parent] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(921),
    [sym_string] = ACTIONS(921),
    [sym_boolean] = ACTIONS(923),
    [sym_null] = ACTIONS(923),
    [anon_sym_DOLLAR] = ACTIONS(921),
    [anon_sym_yield] = ACTIONS(923),
    [anon_sym_include] = ACTIONS(923),
    [anon_sym_include_once] = ACTIONS(923),
    [anon_sym_require] = ACTIONS(923),
    [anon_sym_require_once] = ACTIONS(923),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(921),
  },
  [286] = {
    [sym_text_interpolation] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(925),
    [sym_name] = ACTIONS(927),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(925),
    [anon_sym_static] = ACTIONS(927),
    [anon_sym_global] = ACTIONS(927),
    [anon_sym_namespace] = ACTIONS(927),
    [anon_sym_use] = ACTIONS(927),
    [anon_sym_BSLASH] = ACTIONS(925),
    [anon_sym_function] = ACTIONS(927),
    [anon_sym_const] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_RBRACE] = ACTIONS(925),
    [anon_sym_trait] = ACTIONS(927),
    [anon_sym_interface] = ACTIONS(927),
    [anon_sym_class] = ACTIONS(927),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_final] = ACTIONS(927),
    [anon_sym_public] = ACTIONS(927),
    [anon_sym_protected] = ACTIONS(927),
    [anon_sym_private] = ACTIONS(927),
    [anon_sym_LPAREN] = ACTIONS(925),
    [anon_sym_array] = ACTIONS(927),
    [anon_sym_unset] = ACTIONS(927),
    [anon_sym_echo] = ACTIONS(927),
    [anon_sym_declare] = ACTIONS(927),
    [anon_sym_enddeclare] = ACTIONS(927),
    [sym_float] = ACTIONS(927),
    [anon_sym_try] = ACTIONS(927),
    [anon_sym_goto] = ACTIONS(927),
    [anon_sym_continue] = ACTIONS(927),
    [anon_sym_break] = ACTIONS(927),
    [sym_integer] = ACTIONS(927),
    [anon_sym_return] = ACTIONS(927),
    [anon_sym_throw] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(927),
    [anon_sym_endwhile] = ACTIONS(927),
    [anon_sym_do] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(927),
    [anon_sym_endfor] = ACTIONS(927),
    [anon_sym_foreach] = ACTIONS(927),
    [anon_sym_endforeach] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(927),
    [anon_sym_endif] = ACTIONS(927),
    [anon_sym_elseif] = ACTIONS(927),
    [anon_sym_else] = ACTIONS(927),
    [anon_sym_switch] = ACTIONS(927),
    [anon_sym_endswitch] = ACTIONS(927),
    [anon_sym_case] = ACTIONS(927),
    [anon_sym_default] = ACTIONS(927),
    [anon_sym_AT] = ACTIONS(925),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_TILDE] = ACTIONS(925),
    [anon_sym_BANG] = ACTIONS(925),
    [anon_sym_clone] = ACTIONS(927),
    [anon_sym_print] = ACTIONS(927),
    [anon_sym_new] = ACTIONS(927),
    [anon_sym_PLUS_PLUS] = ACTIONS(925),
    [anon_sym_DASH_DASH] = ACTIONS(925),
    [sym_shell_command_expression] = ACTIONS(925),
    [anon_sym_list] = ACTIONS(927),
    [anon_sym_self] = ACTIONS(927),
    [anon_sym_parent] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(925),
    [sym_string] = ACTIONS(925),
    [sym_boolean] = ACTIONS(927),
    [sym_null] = ACTIONS(927),
    [anon_sym_DOLLAR] = ACTIONS(925),
    [anon_sym_yield] = ACTIONS(927),
    [anon_sym_include] = ACTIONS(927),
    [anon_sym_include_once] = ACTIONS(927),
    [anon_sym_require] = ACTIONS(927),
    [anon_sym_require_once] = ACTIONS(927),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(925),
  },
  [287] = {
    [sym_text_interpolation] = STATE(287),
    [ts_builtin_sym_end] = ACTIONS(929),
    [sym_name] = ACTIONS(931),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(929),
    [anon_sym_static] = ACTIONS(931),
    [anon_sym_global] = ACTIONS(931),
    [anon_sym_namespace] = ACTIONS(931),
    [anon_sym_use] = ACTIONS(931),
    [anon_sym_BSLASH] = ACTIONS(929),
    [anon_sym_function] = ACTIONS(931),
    [anon_sym_const] = ACTIONS(931),
    [anon_sym_LBRACE] = ACTIONS(929),
    [anon_sym_RBRACE] = ACTIONS(929),
    [anon_sym_trait] = ACTIONS(931),
    [anon_sym_interface] = ACTIONS(931),
    [anon_sym_class] = ACTIONS(931),
    [anon_sym_abstract] = ACTIONS(931),
    [anon_sym_final] = ACTIONS(931),
    [anon_sym_public] = ACTIONS(931),
    [anon_sym_protected] = ACTIONS(931),
    [anon_sym_private] = ACTIONS(931),
    [anon_sym_LPAREN] = ACTIONS(929),
    [anon_sym_array] = ACTIONS(931),
    [anon_sym_unset] = ACTIONS(931),
    [anon_sym_echo] = ACTIONS(931),
    [anon_sym_declare] = ACTIONS(931),
    [anon_sym_enddeclare] = ACTIONS(931),
    [sym_float] = ACTIONS(931),
    [anon_sym_try] = ACTIONS(931),
    [anon_sym_goto] = ACTIONS(931),
    [anon_sym_continue] = ACTIONS(931),
    [anon_sym_break] = ACTIONS(931),
    [sym_integer] = ACTIONS(931),
    [anon_sym_return] = ACTIONS(931),
    [anon_sym_throw] = ACTIONS(931),
    [anon_sym_while] = ACTIONS(931),
    [anon_sym_endwhile] = ACTIONS(931),
    [anon_sym_do] = ACTIONS(931),
    [anon_sym_for] = ACTIONS(931),
    [anon_sym_endfor] = ACTIONS(931),
    [anon_sym_foreach] = ACTIONS(931),
    [anon_sym_endforeach] = ACTIONS(931),
    [anon_sym_if] = ACTIONS(931),
    [anon_sym_endif] = ACTIONS(931),
    [anon_sym_elseif] = ACTIONS(931),
    [anon_sym_else] = ACTIONS(931),
    [anon_sym_switch] = ACTIONS(931),
    [anon_sym_endswitch] = ACTIONS(931),
    [anon_sym_case] = ACTIONS(931),
    [anon_sym_default] = ACTIONS(931),
    [anon_sym_AT] = ACTIONS(929),
    [anon_sym_PLUS] = ACTIONS(931),
    [anon_sym_DASH] = ACTIONS(931),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_clone] = ACTIONS(931),
    [anon_sym_print] = ACTIONS(931),
    [anon_sym_new] = ACTIONS(931),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [sym_shell_command_expression] = ACTIONS(929),
    [anon_sym_list] = ACTIONS(931),
    [anon_sym_self] = ACTIONS(931),
    [anon_sym_parent] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(929),
    [sym_string] = ACTIONS(929),
    [sym_boolean] = ACTIONS(931),
    [sym_null] = ACTIONS(931),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_yield] = ACTIONS(931),
    [anon_sym_include] = ACTIONS(931),
    [anon_sym_include_once] = ACTIONS(931),
    [anon_sym_require] = ACTIONS(931),
    [anon_sym_require_once] = ACTIONS(931),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(929),
  },
  [288] = {
    [sym_text_interpolation] = STATE(288),
    [ts_builtin_sym_end] = ACTIONS(933),
    [sym_name] = ACTIONS(935),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(933),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_global] = ACTIONS(935),
    [anon_sym_namespace] = ACTIONS(935),
    [anon_sym_use] = ACTIONS(935),
    [anon_sym_BSLASH] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_const] = ACTIONS(935),
    [anon_sym_LBRACE] = ACTIONS(933),
    [anon_sym_RBRACE] = ACTIONS(933),
    [anon_sym_trait] = ACTIONS(935),
    [anon_sym_interface] = ACTIONS(935),
    [anon_sym_class] = ACTIONS(935),
    [anon_sym_abstract] = ACTIONS(935),
    [anon_sym_final] = ACTIONS(935),
    [anon_sym_public] = ACTIONS(935),
    [anon_sym_protected] = ACTIONS(935),
    [anon_sym_private] = ACTIONS(935),
    [anon_sym_LPAREN] = ACTIONS(933),
    [anon_sym_array] = ACTIONS(935),
    [anon_sym_unset] = ACTIONS(935),
    [anon_sym_echo] = ACTIONS(935),
    [anon_sym_declare] = ACTIONS(935),
    [anon_sym_enddeclare] = ACTIONS(935),
    [sym_float] = ACTIONS(935),
    [anon_sym_try] = ACTIONS(935),
    [anon_sym_goto] = ACTIONS(935),
    [anon_sym_continue] = ACTIONS(935),
    [anon_sym_break] = ACTIONS(935),
    [sym_integer] = ACTIONS(935),
    [anon_sym_return] = ACTIONS(935),
    [anon_sym_throw] = ACTIONS(935),
    [anon_sym_while] = ACTIONS(935),
    [anon_sym_endwhile] = ACTIONS(935),
    [anon_sym_do] = ACTIONS(935),
    [anon_sym_for] = ACTIONS(935),
    [anon_sym_endfor] = ACTIONS(935),
    [anon_sym_foreach] = ACTIONS(935),
    [anon_sym_endforeach] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(935),
    [anon_sym_endif] = ACTIONS(935),
    [anon_sym_elseif] = ACTIONS(935),
    [anon_sym_else] = ACTIONS(935),
    [anon_sym_switch] = ACTIONS(935),
    [anon_sym_endswitch] = ACTIONS(935),
    [anon_sym_case] = ACTIONS(935),
    [anon_sym_default] = ACTIONS(935),
    [anon_sym_AT] = ACTIONS(933),
    [anon_sym_PLUS] = ACTIONS(935),
    [anon_sym_DASH] = ACTIONS(935),
    [anon_sym_TILDE] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(933),
    [anon_sym_clone] = ACTIONS(935),
    [anon_sym_print] = ACTIONS(935),
    [anon_sym_new] = ACTIONS(935),
    [anon_sym_PLUS_PLUS] = ACTIONS(933),
    [anon_sym_DASH_DASH] = ACTIONS(933),
    [sym_shell_command_expression] = ACTIONS(933),
    [anon_sym_list] = ACTIONS(935),
    [anon_sym_self] = ACTIONS(935),
    [anon_sym_parent] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(933),
    [sym_string] = ACTIONS(933),
    [sym_boolean] = ACTIONS(935),
    [sym_null] = ACTIONS(935),
    [anon_sym_DOLLAR] = ACTIONS(933),
    [anon_sym_yield] = ACTIONS(935),
    [anon_sym_include] = ACTIONS(935),
    [anon_sym_include_once] = ACTIONS(935),
    [anon_sym_require] = ACTIONS(935),
    [anon_sym_require_once] = ACTIONS(935),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(933),
  },
  [289] = {
    [sym_text_interpolation] = STATE(289),
    [ts_builtin_sym_end] = ACTIONS(937),
    [sym_name] = ACTIONS(939),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(937),
    [anon_sym_static] = ACTIONS(939),
    [anon_sym_global] = ACTIONS(939),
    [anon_sym_namespace] = ACTIONS(939),
    [anon_sym_use] = ACTIONS(939),
    [anon_sym_BSLASH] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(939),
    [anon_sym_const] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(937),
    [anon_sym_RBRACE] = ACTIONS(937),
    [anon_sym_trait] = ACTIONS(939),
    [anon_sym_interface] = ACTIONS(939),
    [anon_sym_class] = ACTIONS(939),
    [anon_sym_abstract] = ACTIONS(939),
    [anon_sym_final] = ACTIONS(939),
    [anon_sym_public] = ACTIONS(939),
    [anon_sym_protected] = ACTIONS(939),
    [anon_sym_private] = ACTIONS(939),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_array] = ACTIONS(939),
    [anon_sym_unset] = ACTIONS(939),
    [anon_sym_echo] = ACTIONS(939),
    [anon_sym_declare] = ACTIONS(939),
    [anon_sym_enddeclare] = ACTIONS(939),
    [sym_float] = ACTIONS(939),
    [anon_sym_try] = ACTIONS(939),
    [anon_sym_goto] = ACTIONS(939),
    [anon_sym_continue] = ACTIONS(939),
    [anon_sym_break] = ACTIONS(939),
    [sym_integer] = ACTIONS(939),
    [anon_sym_return] = ACTIONS(939),
    [anon_sym_throw] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_endwhile] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_for] = ACTIONS(939),
    [anon_sym_endfor] = ACTIONS(939),
    [anon_sym_foreach] = ACTIONS(939),
    [anon_sym_endforeach] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_endif] = ACTIONS(939),
    [anon_sym_elseif] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_switch] = ACTIONS(939),
    [anon_sym_endswitch] = ACTIONS(939),
    [anon_sym_case] = ACTIONS(939),
    [anon_sym_default] = ACTIONS(939),
    [anon_sym_AT] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_TILDE] = ACTIONS(937),
    [anon_sym_BANG] = ACTIONS(937),
    [anon_sym_clone] = ACTIONS(939),
    [anon_sym_print] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(937),
    [anon_sym_DASH_DASH] = ACTIONS(937),
    [sym_shell_command_expression] = ACTIONS(937),
    [anon_sym_list] = ACTIONS(939),
    [anon_sym_self] = ACTIONS(939),
    [anon_sym_parent] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(937),
    [sym_string] = ACTIONS(937),
    [sym_boolean] = ACTIONS(939),
    [sym_null] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(937),
    [anon_sym_yield] = ACTIONS(939),
    [anon_sym_include] = ACTIONS(939),
    [anon_sym_include_once] = ACTIONS(939),
    [anon_sym_require] = ACTIONS(939),
    [anon_sym_require_once] = ACTIONS(939),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(937),
  },
  [290] = {
    [sym_text_interpolation] = STATE(290),
    [ts_builtin_sym_end] = ACTIONS(941),
    [sym_name] = ACTIONS(943),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym_static] = ACTIONS(943),
    [anon_sym_global] = ACTIONS(943),
    [anon_sym_namespace] = ACTIONS(943),
    [anon_sym_use] = ACTIONS(943),
    [anon_sym_BSLASH] = ACTIONS(941),
    [anon_sym_function] = ACTIONS(943),
    [anon_sym_const] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_trait] = ACTIONS(943),
    [anon_sym_interface] = ACTIONS(943),
    [anon_sym_class] = ACTIONS(943),
    [anon_sym_abstract] = ACTIONS(943),
    [anon_sym_final] = ACTIONS(943),
    [anon_sym_public] = ACTIONS(943),
    [anon_sym_protected] = ACTIONS(943),
    [anon_sym_private] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_array] = ACTIONS(943),
    [anon_sym_unset] = ACTIONS(943),
    [anon_sym_echo] = ACTIONS(943),
    [anon_sym_declare] = ACTIONS(943),
    [anon_sym_enddeclare] = ACTIONS(943),
    [sym_float] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_goto] = ACTIONS(943),
    [anon_sym_continue] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(943),
    [sym_integer] = ACTIONS(943),
    [anon_sym_return] = ACTIONS(943),
    [anon_sym_throw] = ACTIONS(943),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_endwhile] = ACTIONS(943),
    [anon_sym_do] = ACTIONS(943),
    [anon_sym_for] = ACTIONS(943),
    [anon_sym_endfor] = ACTIONS(943),
    [anon_sym_foreach] = ACTIONS(943),
    [anon_sym_endforeach] = ACTIONS(943),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_endif] = ACTIONS(943),
    [anon_sym_elseif] = ACTIONS(943),
    [anon_sym_else] = ACTIONS(943),
    [anon_sym_switch] = ACTIONS(943),
    [anon_sym_endswitch] = ACTIONS(943),
    [anon_sym_case] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(943),
    [anon_sym_TILDE] = ACTIONS(941),
    [anon_sym_BANG] = ACTIONS(941),
    [anon_sym_clone] = ACTIONS(943),
    [anon_sym_print] = ACTIONS(943),
    [anon_sym_new] = ACTIONS(943),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [sym_shell_command_expression] = ACTIONS(941),
    [anon_sym_list] = ACTIONS(943),
    [anon_sym_self] = ACTIONS(943),
    [anon_sym_parent] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(941),
    [sym_string] = ACTIONS(941),
    [sym_boolean] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [anon_sym_DOLLAR] = ACTIONS(941),
    [anon_sym_yield] = ACTIONS(943),
    [anon_sym_include] = ACTIONS(943),
    [anon_sym_include_once] = ACTIONS(943),
    [anon_sym_require] = ACTIONS(943),
    [anon_sym_require_once] = ACTIONS(943),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(941),
  },
  [291] = {
    [sym_text_interpolation] = STATE(291),
    [ts_builtin_sym_end] = ACTIONS(945),
    [sym_name] = ACTIONS(947),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(945),
    [anon_sym_static] = ACTIONS(947),
    [anon_sym_global] = ACTIONS(947),
    [anon_sym_namespace] = ACTIONS(947),
    [anon_sym_use] = ACTIONS(947),
    [anon_sym_BSLASH] = ACTIONS(945),
    [anon_sym_function] = ACTIONS(947),
    [anon_sym_const] = ACTIONS(947),
    [anon_sym_LBRACE] = ACTIONS(945),
    [anon_sym_RBRACE] = ACTIONS(945),
    [anon_sym_trait] = ACTIONS(947),
    [anon_sym_interface] = ACTIONS(947),
    [anon_sym_class] = ACTIONS(947),
    [anon_sym_abstract] = ACTIONS(947),
    [anon_sym_final] = ACTIONS(947),
    [anon_sym_public] = ACTIONS(947),
    [anon_sym_protected] = ACTIONS(947),
    [anon_sym_private] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(945),
    [anon_sym_array] = ACTIONS(947),
    [anon_sym_unset] = ACTIONS(947),
    [anon_sym_echo] = ACTIONS(947),
    [anon_sym_declare] = ACTIONS(947),
    [anon_sym_enddeclare] = ACTIONS(947),
    [sym_float] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(947),
    [anon_sym_goto] = ACTIONS(947),
    [anon_sym_continue] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(947),
    [sym_integer] = ACTIONS(947),
    [anon_sym_return] = ACTIONS(947),
    [anon_sym_throw] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(947),
    [anon_sym_endwhile] = ACTIONS(947),
    [anon_sym_do] = ACTIONS(947),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_endfor] = ACTIONS(947),
    [anon_sym_foreach] = ACTIONS(947),
    [anon_sym_endforeach] = ACTIONS(947),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_endif] = ACTIONS(947),
    [anon_sym_elseif] = ACTIONS(947),
    [anon_sym_else] = ACTIONS(947),
    [anon_sym_switch] = ACTIONS(947),
    [anon_sym_endswitch] = ACTIONS(947),
    [anon_sym_case] = ACTIONS(947),
    [anon_sym_default] = ACTIONS(947),
    [anon_sym_AT] = ACTIONS(945),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(945),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_clone] = ACTIONS(947),
    [anon_sym_print] = ACTIONS(947),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(945),
    [anon_sym_DASH_DASH] = ACTIONS(945),
    [sym_shell_command_expression] = ACTIONS(945),
    [anon_sym_list] = ACTIONS(947),
    [anon_sym_self] = ACTIONS(947),
    [anon_sym_parent] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(945),
    [sym_string] = ACTIONS(945),
    [sym_boolean] = ACTIONS(947),
    [sym_null] = ACTIONS(947),
    [anon_sym_DOLLAR] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_include] = ACTIONS(947),
    [anon_sym_include_once] = ACTIONS(947),
    [anon_sym_require] = ACTIONS(947),
    [anon_sym_require_once] = ACTIONS(947),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(945),
  },
  [292] = {
    [sym_text_interpolation] = STATE(292),
    [ts_builtin_sym_end] = ACTIONS(949),
    [sym_name] = ACTIONS(951),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(949),
    [anon_sym_static] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(951),
    [anon_sym_namespace] = ACTIONS(951),
    [anon_sym_use] = ACTIONS(951),
    [anon_sym_BSLASH] = ACTIONS(949),
    [anon_sym_function] = ACTIONS(951),
    [anon_sym_const] = ACTIONS(951),
    [anon_sym_LBRACE] = ACTIONS(949),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_trait] = ACTIONS(951),
    [anon_sym_interface] = ACTIONS(951),
    [anon_sym_class] = ACTIONS(951),
    [anon_sym_abstract] = ACTIONS(951),
    [anon_sym_final] = ACTIONS(951),
    [anon_sym_public] = ACTIONS(951),
    [anon_sym_protected] = ACTIONS(951),
    [anon_sym_private] = ACTIONS(951),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_array] = ACTIONS(951),
    [anon_sym_unset] = ACTIONS(951),
    [anon_sym_echo] = ACTIONS(951),
    [anon_sym_declare] = ACTIONS(951),
    [anon_sym_enddeclare] = ACTIONS(951),
    [sym_float] = ACTIONS(951),
    [anon_sym_try] = ACTIONS(951),
    [anon_sym_goto] = ACTIONS(951),
    [anon_sym_continue] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(951),
    [sym_integer] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(951),
    [anon_sym_endwhile] = ACTIONS(951),
    [anon_sym_do] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_endfor] = ACTIONS(951),
    [anon_sym_foreach] = ACTIONS(951),
    [anon_sym_endforeach] = ACTIONS(951),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_endif] = ACTIONS(951),
    [anon_sym_elseif] = ACTIONS(951),
    [anon_sym_else] = ACTIONS(951),
    [anon_sym_switch] = ACTIONS(951),
    [anon_sym_endswitch] = ACTIONS(951),
    [anon_sym_case] = ACTIONS(951),
    [anon_sym_default] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(949),
    [anon_sym_PLUS] = ACTIONS(951),
    [anon_sym_DASH] = ACTIONS(951),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_clone] = ACTIONS(951),
    [anon_sym_print] = ACTIONS(951),
    [anon_sym_new] = ACTIONS(951),
    [anon_sym_PLUS_PLUS] = ACTIONS(949),
    [anon_sym_DASH_DASH] = ACTIONS(949),
    [sym_shell_command_expression] = ACTIONS(949),
    [anon_sym_list] = ACTIONS(951),
    [anon_sym_self] = ACTIONS(951),
    [anon_sym_parent] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(949),
    [sym_string] = ACTIONS(949),
    [sym_boolean] = ACTIONS(951),
    [sym_null] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_include] = ACTIONS(951),
    [anon_sym_include_once] = ACTIONS(951),
    [anon_sym_require] = ACTIONS(951),
    [anon_sym_require_once] = ACTIONS(951),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(949),
  },
  [293] = {
    [sym_text_interpolation] = STATE(293),
    [ts_builtin_sym_end] = ACTIONS(953),
    [sym_name] = ACTIONS(955),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(953),
    [anon_sym_static] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(955),
    [anon_sym_namespace] = ACTIONS(955),
    [anon_sym_use] = ACTIONS(955),
    [anon_sym_BSLASH] = ACTIONS(953),
    [anon_sym_function] = ACTIONS(955),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(953),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_trait] = ACTIONS(955),
    [anon_sym_interface] = ACTIONS(955),
    [anon_sym_class] = ACTIONS(955),
    [anon_sym_abstract] = ACTIONS(955),
    [anon_sym_final] = ACTIONS(955),
    [anon_sym_public] = ACTIONS(955),
    [anon_sym_protected] = ACTIONS(955),
    [anon_sym_private] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(953),
    [anon_sym_array] = ACTIONS(955),
    [anon_sym_unset] = ACTIONS(955),
    [anon_sym_echo] = ACTIONS(955),
    [anon_sym_declare] = ACTIONS(955),
    [anon_sym_enddeclare] = ACTIONS(955),
    [sym_float] = ACTIONS(955),
    [anon_sym_try] = ACTIONS(955),
    [anon_sym_goto] = ACTIONS(955),
    [anon_sym_continue] = ACTIONS(955),
    [anon_sym_break] = ACTIONS(955),
    [sym_integer] = ACTIONS(955),
    [anon_sym_return] = ACTIONS(955),
    [anon_sym_throw] = ACTIONS(955),
    [anon_sym_while] = ACTIONS(955),
    [anon_sym_endwhile] = ACTIONS(955),
    [anon_sym_do] = ACTIONS(955),
    [anon_sym_for] = ACTIONS(955),
    [anon_sym_endfor] = ACTIONS(955),
    [anon_sym_foreach] = ACTIONS(955),
    [anon_sym_endforeach] = ACTIONS(955),
    [anon_sym_if] = ACTIONS(955),
    [anon_sym_endif] = ACTIONS(955),
    [anon_sym_elseif] = ACTIONS(955),
    [anon_sym_else] = ACTIONS(955),
    [anon_sym_switch] = ACTIONS(955),
    [anon_sym_endswitch] = ACTIONS(955),
    [anon_sym_case] = ACTIONS(955),
    [anon_sym_default] = ACTIONS(955),
    [anon_sym_AT] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(955),
    [anon_sym_TILDE] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_clone] = ACTIONS(955),
    [anon_sym_print] = ACTIONS(955),
    [anon_sym_new] = ACTIONS(955),
    [anon_sym_PLUS_PLUS] = ACTIONS(953),
    [anon_sym_DASH_DASH] = ACTIONS(953),
    [sym_shell_command_expression] = ACTIONS(953),
    [anon_sym_list] = ACTIONS(955),
    [anon_sym_self] = ACTIONS(955),
    [anon_sym_parent] = ACTIONS(955),
    [anon_sym_LBRACK] = ACTIONS(953),
    [sym_string] = ACTIONS(953),
    [sym_boolean] = ACTIONS(955),
    [sym_null] = ACTIONS(955),
    [anon_sym_DOLLAR] = ACTIONS(953),
    [anon_sym_yield] = ACTIONS(955),
    [anon_sym_include] = ACTIONS(955),
    [anon_sym_include_once] = ACTIONS(955),
    [anon_sym_require] = ACTIONS(955),
    [anon_sym_require_once] = ACTIONS(955),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(953),
  },
  [294] = {
    [sym_text_interpolation] = STATE(294),
    [ts_builtin_sym_end] = ACTIONS(957),
    [sym_name] = ACTIONS(959),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(957),
    [anon_sym_static] = ACTIONS(959),
    [anon_sym_global] = ACTIONS(959),
    [anon_sym_namespace] = ACTIONS(959),
    [anon_sym_use] = ACTIONS(959),
    [anon_sym_BSLASH] = ACTIONS(957),
    [anon_sym_function] = ACTIONS(959),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_trait] = ACTIONS(959),
    [anon_sym_interface] = ACTIONS(959),
    [anon_sym_class] = ACTIONS(959),
    [anon_sym_abstract] = ACTIONS(959),
    [anon_sym_final] = ACTIONS(959),
    [anon_sym_public] = ACTIONS(959),
    [anon_sym_protected] = ACTIONS(959),
    [anon_sym_private] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_array] = ACTIONS(959),
    [anon_sym_unset] = ACTIONS(959),
    [anon_sym_echo] = ACTIONS(959),
    [anon_sym_declare] = ACTIONS(959),
    [anon_sym_enddeclare] = ACTIONS(959),
    [sym_float] = ACTIONS(959),
    [anon_sym_try] = ACTIONS(959),
    [anon_sym_goto] = ACTIONS(959),
    [anon_sym_continue] = ACTIONS(959),
    [anon_sym_break] = ACTIONS(959),
    [sym_integer] = ACTIONS(959),
    [anon_sym_return] = ACTIONS(959),
    [anon_sym_throw] = ACTIONS(959),
    [anon_sym_while] = ACTIONS(959),
    [anon_sym_endwhile] = ACTIONS(959),
    [anon_sym_do] = ACTIONS(959),
    [anon_sym_for] = ACTIONS(959),
    [anon_sym_endfor] = ACTIONS(959),
    [anon_sym_foreach] = ACTIONS(959),
    [anon_sym_endforeach] = ACTIONS(959),
    [anon_sym_if] = ACTIONS(959),
    [anon_sym_endif] = ACTIONS(959),
    [anon_sym_elseif] = ACTIONS(959),
    [anon_sym_else] = ACTIONS(959),
    [anon_sym_switch] = ACTIONS(959),
    [anon_sym_endswitch] = ACTIONS(959),
    [anon_sym_case] = ACTIONS(959),
    [anon_sym_default] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(959),
    [anon_sym_DASH] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_clone] = ACTIONS(959),
    [anon_sym_print] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(957),
    [anon_sym_DASH_DASH] = ACTIONS(957),
    [sym_shell_command_expression] = ACTIONS(957),
    [anon_sym_list] = ACTIONS(959),
    [anon_sym_self] = ACTIONS(959),
    [anon_sym_parent] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(957),
    [sym_string] = ACTIONS(957),
    [sym_boolean] = ACTIONS(959),
    [sym_null] = ACTIONS(959),
    [anon_sym_DOLLAR] = ACTIONS(957),
    [anon_sym_yield] = ACTIONS(959),
    [anon_sym_include] = ACTIONS(959),
    [anon_sym_include_once] = ACTIONS(959),
    [anon_sym_require] = ACTIONS(959),
    [anon_sym_require_once] = ACTIONS(959),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(957),
  },
  [295] = {
    [sym_text_interpolation] = STATE(295),
    [ts_builtin_sym_end] = ACTIONS(961),
    [sym_name] = ACTIONS(963),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(961),
    [anon_sym_static] = ACTIONS(963),
    [anon_sym_global] = ACTIONS(963),
    [anon_sym_namespace] = ACTIONS(963),
    [anon_sym_use] = ACTIONS(963),
    [anon_sym_BSLASH] = ACTIONS(961),
    [anon_sym_function] = ACTIONS(963),
    [anon_sym_const] = ACTIONS(963),
    [anon_sym_LBRACE] = ACTIONS(961),
    [anon_sym_RBRACE] = ACTIONS(961),
    [anon_sym_trait] = ACTIONS(963),
    [anon_sym_interface] = ACTIONS(963),
    [anon_sym_class] = ACTIONS(963),
    [anon_sym_abstract] = ACTIONS(963),
    [anon_sym_final] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(963),
    [anon_sym_protected] = ACTIONS(963),
    [anon_sym_private] = ACTIONS(963),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_array] = ACTIONS(963),
    [anon_sym_unset] = ACTIONS(963),
    [anon_sym_echo] = ACTIONS(963),
    [anon_sym_declare] = ACTIONS(963),
    [anon_sym_enddeclare] = ACTIONS(963),
    [sym_float] = ACTIONS(963),
    [anon_sym_try] = ACTIONS(963),
    [anon_sym_goto] = ACTIONS(963),
    [anon_sym_continue] = ACTIONS(963),
    [anon_sym_break] = ACTIONS(963),
    [sym_integer] = ACTIONS(963),
    [anon_sym_return] = ACTIONS(963),
    [anon_sym_throw] = ACTIONS(963),
    [anon_sym_while] = ACTIONS(963),
    [anon_sym_endwhile] = ACTIONS(963),
    [anon_sym_do] = ACTIONS(963),
    [anon_sym_for] = ACTIONS(963),
    [anon_sym_endfor] = ACTIONS(963),
    [anon_sym_foreach] = ACTIONS(963),
    [anon_sym_endforeach] = ACTIONS(963),
    [anon_sym_if] = ACTIONS(963),
    [anon_sym_endif] = ACTIONS(963),
    [anon_sym_elseif] = ACTIONS(963),
    [anon_sym_else] = ACTIONS(963),
    [anon_sym_switch] = ACTIONS(963),
    [anon_sym_endswitch] = ACTIONS(963),
    [anon_sym_case] = ACTIONS(963),
    [anon_sym_default] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(961),
    [anon_sym_PLUS] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(961),
    [anon_sym_clone] = ACTIONS(963),
    [anon_sym_print] = ACTIONS(963),
    [anon_sym_new] = ACTIONS(963),
    [anon_sym_PLUS_PLUS] = ACTIONS(961),
    [anon_sym_DASH_DASH] = ACTIONS(961),
    [sym_shell_command_expression] = ACTIONS(961),
    [anon_sym_list] = ACTIONS(963),
    [anon_sym_self] = ACTIONS(963),
    [anon_sym_parent] = ACTIONS(963),
    [anon_sym_LBRACK] = ACTIONS(961),
    [sym_string] = ACTIONS(961),
    [sym_boolean] = ACTIONS(963),
    [sym_null] = ACTIONS(963),
    [anon_sym_DOLLAR] = ACTIONS(961),
    [anon_sym_yield] = ACTIONS(963),
    [anon_sym_include] = ACTIONS(963),
    [anon_sym_include_once] = ACTIONS(963),
    [anon_sym_require] = ACTIONS(963),
    [anon_sym_require_once] = ACTIONS(963),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(961),
  },
  [296] = {
    [sym_text_interpolation] = STATE(296),
    [ts_builtin_sym_end] = ACTIONS(965),
    [sym_name] = ACTIONS(967),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(965),
    [anon_sym_static] = ACTIONS(967),
    [anon_sym_global] = ACTIONS(967),
    [anon_sym_namespace] = ACTIONS(967),
    [anon_sym_use] = ACTIONS(967),
    [anon_sym_BSLASH] = ACTIONS(965),
    [anon_sym_function] = ACTIONS(967),
    [anon_sym_const] = ACTIONS(967),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(965),
    [anon_sym_trait] = ACTIONS(967),
    [anon_sym_interface] = ACTIONS(967),
    [anon_sym_class] = ACTIONS(967),
    [anon_sym_abstract] = ACTIONS(967),
    [anon_sym_final] = ACTIONS(967),
    [anon_sym_public] = ACTIONS(967),
    [anon_sym_protected] = ACTIONS(967),
    [anon_sym_private] = ACTIONS(967),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_array] = ACTIONS(967),
    [anon_sym_unset] = ACTIONS(967),
    [anon_sym_echo] = ACTIONS(967),
    [anon_sym_declare] = ACTIONS(967),
    [anon_sym_enddeclare] = ACTIONS(967),
    [sym_float] = ACTIONS(967),
    [anon_sym_try] = ACTIONS(967),
    [anon_sym_goto] = ACTIONS(967),
    [anon_sym_continue] = ACTIONS(967),
    [anon_sym_break] = ACTIONS(967),
    [sym_integer] = ACTIONS(967),
    [anon_sym_return] = ACTIONS(967),
    [anon_sym_throw] = ACTIONS(967),
    [anon_sym_while] = ACTIONS(967),
    [anon_sym_endwhile] = ACTIONS(967),
    [anon_sym_do] = ACTIONS(967),
    [anon_sym_for] = ACTIONS(967),
    [anon_sym_endfor] = ACTIONS(967),
    [anon_sym_foreach] = ACTIONS(967),
    [anon_sym_endforeach] = ACTIONS(967),
    [anon_sym_if] = ACTIONS(967),
    [anon_sym_endif] = ACTIONS(967),
    [anon_sym_elseif] = ACTIONS(967),
    [anon_sym_else] = ACTIONS(967),
    [anon_sym_switch] = ACTIONS(967),
    [anon_sym_endswitch] = ACTIONS(967),
    [anon_sym_case] = ACTIONS(967),
    [anon_sym_default] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(965),
    [anon_sym_PLUS] = ACTIONS(967),
    [anon_sym_DASH] = ACTIONS(967),
    [anon_sym_TILDE] = ACTIONS(965),
    [anon_sym_BANG] = ACTIONS(965),
    [anon_sym_clone] = ACTIONS(967),
    [anon_sym_print] = ACTIONS(967),
    [anon_sym_new] = ACTIONS(967),
    [anon_sym_PLUS_PLUS] = ACTIONS(965),
    [anon_sym_DASH_DASH] = ACTIONS(965),
    [sym_shell_command_expression] = ACTIONS(965),
    [anon_sym_list] = ACTIONS(967),
    [anon_sym_self] = ACTIONS(967),
    [anon_sym_parent] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(965),
    [sym_string] = ACTIONS(965),
    [sym_boolean] = ACTIONS(967),
    [sym_null] = ACTIONS(967),
    [anon_sym_DOLLAR] = ACTIONS(965),
    [anon_sym_yield] = ACTIONS(967),
    [anon_sym_include] = ACTIONS(967),
    [anon_sym_include_once] = ACTIONS(967),
    [anon_sym_require] = ACTIONS(967),
    [anon_sym_require_once] = ACTIONS(967),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(965),
  },
  [297] = {
    [sym_text_interpolation] = STATE(297),
    [ts_builtin_sym_end] = ACTIONS(969),
    [sym_name] = ACTIONS(971),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(969),
    [anon_sym_static] = ACTIONS(971),
    [anon_sym_global] = ACTIONS(971),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_use] = ACTIONS(971),
    [anon_sym_BSLASH] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(971),
    [anon_sym_const] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(969),
    [anon_sym_RBRACE] = ACTIONS(969),
    [anon_sym_trait] = ACTIONS(971),
    [anon_sym_interface] = ACTIONS(971),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_abstract] = ACTIONS(971),
    [anon_sym_final] = ACTIONS(971),
    [anon_sym_public] = ACTIONS(971),
    [anon_sym_protected] = ACTIONS(971),
    [anon_sym_private] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_array] = ACTIONS(971),
    [anon_sym_unset] = ACTIONS(971),
    [anon_sym_echo] = ACTIONS(971),
    [anon_sym_declare] = ACTIONS(971),
    [anon_sym_enddeclare] = ACTIONS(971),
    [sym_float] = ACTIONS(971),
    [anon_sym_try] = ACTIONS(971),
    [anon_sym_goto] = ACTIONS(971),
    [anon_sym_continue] = ACTIONS(971),
    [anon_sym_break] = ACTIONS(971),
    [sym_integer] = ACTIONS(971),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_throw] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(971),
    [anon_sym_endwhile] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_endfor] = ACTIONS(971),
    [anon_sym_foreach] = ACTIONS(971),
    [anon_sym_endforeach] = ACTIONS(971),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_endif] = ACTIONS(971),
    [anon_sym_elseif] = ACTIONS(971),
    [anon_sym_else] = ACTIONS(971),
    [anon_sym_switch] = ACTIONS(971),
    [anon_sym_endswitch] = ACTIONS(971),
    [anon_sym_case] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_TILDE] = ACTIONS(969),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_clone] = ACTIONS(971),
    [anon_sym_print] = ACTIONS(971),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_PLUS_PLUS] = ACTIONS(969),
    [anon_sym_DASH_DASH] = ACTIONS(969),
    [sym_shell_command_expression] = ACTIONS(969),
    [anon_sym_list] = ACTIONS(971),
    [anon_sym_self] = ACTIONS(971),
    [anon_sym_parent] = ACTIONS(971),
    [anon_sym_LBRACK] = ACTIONS(969),
    [sym_string] = ACTIONS(969),
    [sym_boolean] = ACTIONS(971),
    [sym_null] = ACTIONS(971),
    [anon_sym_DOLLAR] = ACTIONS(969),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_include] = ACTIONS(971),
    [anon_sym_include_once] = ACTIONS(971),
    [anon_sym_require] = ACTIONS(971),
    [anon_sym_require_once] = ACTIONS(971),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(969),
  },
  [298] = {
    [sym_text_interpolation] = STATE(298),
    [ts_builtin_sym_end] = ACTIONS(973),
    [sym_name] = ACTIONS(975),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_static] = ACTIONS(975),
    [anon_sym_global] = ACTIONS(975),
    [anon_sym_namespace] = ACTIONS(975),
    [anon_sym_use] = ACTIONS(975),
    [anon_sym_BSLASH] = ACTIONS(973),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_const] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_trait] = ACTIONS(975),
    [anon_sym_interface] = ACTIONS(975),
    [anon_sym_class] = ACTIONS(975),
    [anon_sym_abstract] = ACTIONS(975),
    [anon_sym_final] = ACTIONS(975),
    [anon_sym_public] = ACTIONS(975),
    [anon_sym_protected] = ACTIONS(975),
    [anon_sym_private] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(973),
    [anon_sym_array] = ACTIONS(975),
    [anon_sym_unset] = ACTIONS(975),
    [anon_sym_echo] = ACTIONS(975),
    [anon_sym_declare] = ACTIONS(975),
    [anon_sym_enddeclare] = ACTIONS(975),
    [sym_float] = ACTIONS(975),
    [anon_sym_try] = ACTIONS(975),
    [anon_sym_goto] = ACTIONS(975),
    [anon_sym_continue] = ACTIONS(975),
    [anon_sym_break] = ACTIONS(975),
    [sym_integer] = ACTIONS(975),
    [anon_sym_return] = ACTIONS(975),
    [anon_sym_throw] = ACTIONS(975),
    [anon_sym_while] = ACTIONS(975),
    [anon_sym_endwhile] = ACTIONS(975),
    [anon_sym_do] = ACTIONS(975),
    [anon_sym_for] = ACTIONS(975),
    [anon_sym_endfor] = ACTIONS(975),
    [anon_sym_foreach] = ACTIONS(975),
    [anon_sym_endforeach] = ACTIONS(975),
    [anon_sym_if] = ACTIONS(975),
    [anon_sym_endif] = ACTIONS(975),
    [anon_sym_elseif] = ACTIONS(975),
    [anon_sym_else] = ACTIONS(975),
    [anon_sym_switch] = ACTIONS(975),
    [anon_sym_endswitch] = ACTIONS(975),
    [anon_sym_case] = ACTIONS(975),
    [anon_sym_default] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_TILDE] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_clone] = ACTIONS(975),
    [anon_sym_print] = ACTIONS(975),
    [anon_sym_new] = ACTIONS(975),
    [anon_sym_PLUS_PLUS] = ACTIONS(973),
    [anon_sym_DASH_DASH] = ACTIONS(973),
    [sym_shell_command_expression] = ACTIONS(973),
    [anon_sym_list] = ACTIONS(975),
    [anon_sym_self] = ACTIONS(975),
    [anon_sym_parent] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(973),
    [sym_string] = ACTIONS(973),
    [sym_boolean] = ACTIONS(975),
    [sym_null] = ACTIONS(975),
    [anon_sym_DOLLAR] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(975),
    [anon_sym_include] = ACTIONS(975),
    [anon_sym_include_once] = ACTIONS(975),
    [anon_sym_require] = ACTIONS(975),
    [anon_sym_require_once] = ACTIONS(975),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(973),
  },
  [299] = {
    [sym_text_interpolation] = STATE(299),
    [ts_builtin_sym_end] = ACTIONS(977),
    [sym_name] = ACTIONS(979),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(977),
    [anon_sym_static] = ACTIONS(979),
    [anon_sym_global] = ACTIONS(979),
    [anon_sym_namespace] = ACTIONS(979),
    [anon_sym_use] = ACTIONS(979),
    [anon_sym_BSLASH] = ACTIONS(977),
    [anon_sym_function] = ACTIONS(979),
    [anon_sym_const] = ACTIONS(979),
    [anon_sym_LBRACE] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_trait] = ACTIONS(979),
    [anon_sym_interface] = ACTIONS(979),
    [anon_sym_class] = ACTIONS(979),
    [anon_sym_abstract] = ACTIONS(979),
    [anon_sym_final] = ACTIONS(979),
    [anon_sym_public] = ACTIONS(979),
    [anon_sym_protected] = ACTIONS(979),
    [anon_sym_private] = ACTIONS(979),
    [anon_sym_LPAREN] = ACTIONS(977),
    [anon_sym_array] = ACTIONS(979),
    [anon_sym_unset] = ACTIONS(979),
    [anon_sym_echo] = ACTIONS(979),
    [anon_sym_declare] = ACTIONS(979),
    [anon_sym_enddeclare] = ACTIONS(979),
    [sym_float] = ACTIONS(979),
    [anon_sym_try] = ACTIONS(979),
    [anon_sym_goto] = ACTIONS(979),
    [anon_sym_continue] = ACTIONS(979),
    [anon_sym_break] = ACTIONS(979),
    [sym_integer] = ACTIONS(979),
    [anon_sym_return] = ACTIONS(979),
    [anon_sym_throw] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(979),
    [anon_sym_endwhile] = ACTIONS(979),
    [anon_sym_do] = ACTIONS(979),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_endfor] = ACTIONS(979),
    [anon_sym_foreach] = ACTIONS(979),
    [anon_sym_endforeach] = ACTIONS(979),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_endif] = ACTIONS(979),
    [anon_sym_elseif] = ACTIONS(979),
    [anon_sym_else] = ACTIONS(979),
    [anon_sym_switch] = ACTIONS(979),
    [anon_sym_endswitch] = ACTIONS(979),
    [anon_sym_case] = ACTIONS(979),
    [anon_sym_default] = ACTIONS(979),
    [anon_sym_AT] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_clone] = ACTIONS(979),
    [anon_sym_print] = ACTIONS(979),
    [anon_sym_new] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(977),
    [anon_sym_DASH_DASH] = ACTIONS(977),
    [sym_shell_command_expression] = ACTIONS(977),
    [anon_sym_list] = ACTIONS(979),
    [anon_sym_self] = ACTIONS(979),
    [anon_sym_parent] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(977),
    [sym_string] = ACTIONS(977),
    [sym_boolean] = ACTIONS(979),
    [sym_null] = ACTIONS(979),
    [anon_sym_DOLLAR] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(979),
    [anon_sym_include] = ACTIONS(979),
    [anon_sym_include_once] = ACTIONS(979),
    [anon_sym_require] = ACTIONS(979),
    [anon_sym_require_once] = ACTIONS(979),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(977),
  },
  [300] = {
    [sym_text_interpolation] = STATE(300),
    [ts_builtin_sym_end] = ACTIONS(969),
    [sym_name] = ACTIONS(971),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(969),
    [anon_sym_static] = ACTIONS(971),
    [anon_sym_global] = ACTIONS(971),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_use] = ACTIONS(971),
    [anon_sym_BSLASH] = ACTIONS(969),
    [anon_sym_function] = ACTIONS(971),
    [anon_sym_const] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(969),
    [anon_sym_RBRACE] = ACTIONS(969),
    [anon_sym_trait] = ACTIONS(971),
    [anon_sym_interface] = ACTIONS(971),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_abstract] = ACTIONS(971),
    [anon_sym_final] = ACTIONS(971),
    [anon_sym_public] = ACTIONS(971),
    [anon_sym_protected] = ACTIONS(971),
    [anon_sym_private] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_array] = ACTIONS(971),
    [anon_sym_unset] = ACTIONS(971),
    [anon_sym_echo] = ACTIONS(971),
    [anon_sym_declare] = ACTIONS(971),
    [anon_sym_enddeclare] = ACTIONS(971),
    [sym_float] = ACTIONS(971),
    [anon_sym_try] = ACTIONS(971),
    [anon_sym_goto] = ACTIONS(971),
    [anon_sym_continue] = ACTIONS(971),
    [anon_sym_break] = ACTIONS(971),
    [sym_integer] = ACTIONS(971),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_throw] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(971),
    [anon_sym_endwhile] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(971),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_endfor] = ACTIONS(971),
    [anon_sym_foreach] = ACTIONS(971),
    [anon_sym_endforeach] = ACTIONS(971),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_endif] = ACTIONS(971),
    [anon_sym_elseif] = ACTIONS(971),
    [anon_sym_else] = ACTIONS(971),
    [anon_sym_switch] = ACTIONS(971),
    [anon_sym_endswitch] = ACTIONS(971),
    [anon_sym_case] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(969),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_TILDE] = ACTIONS(969),
    [anon_sym_BANG] = ACTIONS(969),
    [anon_sym_clone] = ACTIONS(971),
    [anon_sym_print] = ACTIONS(971),
    [anon_sym_new] = ACTIONS(971),
    [anon_sym_PLUS_PLUS] = ACTIONS(969),
    [anon_sym_DASH_DASH] = ACTIONS(969),
    [sym_shell_command_expression] = ACTIONS(969),
    [anon_sym_list] = ACTIONS(971),
    [anon_sym_self] = ACTIONS(971),
    [anon_sym_parent] = ACTIONS(971),
    [anon_sym_LBRACK] = ACTIONS(969),
    [sym_string] = ACTIONS(969),
    [sym_boolean] = ACTIONS(971),
    [sym_null] = ACTIONS(971),
    [anon_sym_DOLLAR] = ACTIONS(969),
    [anon_sym_yield] = ACTIONS(971),
    [anon_sym_include] = ACTIONS(971),
    [anon_sym_include_once] = ACTIONS(971),
    [anon_sym_require] = ACTIONS(971),
    [anon_sym_require_once] = ACTIONS(971),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(969),
  },
  [301] = {
    [sym_text_interpolation] = STATE(301),
    [ts_builtin_sym_end] = ACTIONS(981),
    [sym_name] = ACTIONS(983),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_static] = ACTIONS(983),
    [anon_sym_global] = ACTIONS(983),
    [anon_sym_namespace] = ACTIONS(983),
    [anon_sym_use] = ACTIONS(983),
    [anon_sym_BSLASH] = ACTIONS(981),
    [anon_sym_function] = ACTIONS(983),
    [anon_sym_const] = ACTIONS(983),
    [anon_sym_LBRACE] = ACTIONS(981),
    [anon_sym_RBRACE] = ACTIONS(981),
    [anon_sym_trait] = ACTIONS(983),
    [anon_sym_interface] = ACTIONS(983),
    [anon_sym_class] = ACTIONS(983),
    [anon_sym_abstract] = ACTIONS(983),
    [anon_sym_final] = ACTIONS(983),
    [anon_sym_public] = ACTIONS(983),
    [anon_sym_protected] = ACTIONS(983),
    [anon_sym_private] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_array] = ACTIONS(983),
    [anon_sym_unset] = ACTIONS(983),
    [anon_sym_echo] = ACTIONS(983),
    [anon_sym_declare] = ACTIONS(983),
    [anon_sym_enddeclare] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [anon_sym_try] = ACTIONS(983),
    [anon_sym_goto] = ACTIONS(983),
    [anon_sym_continue] = ACTIONS(983),
    [anon_sym_break] = ACTIONS(983),
    [sym_integer] = ACTIONS(983),
    [anon_sym_return] = ACTIONS(983),
    [anon_sym_throw] = ACTIONS(983),
    [anon_sym_while] = ACTIONS(983),
    [anon_sym_endwhile] = ACTIONS(983),
    [anon_sym_do] = ACTIONS(983),
    [anon_sym_for] = ACTIONS(983),
    [anon_sym_endfor] = ACTIONS(983),
    [anon_sym_foreach] = ACTIONS(983),
    [anon_sym_endforeach] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(983),
    [anon_sym_endif] = ACTIONS(983),
    [anon_sym_elseif] = ACTIONS(983),
    [anon_sym_else] = ACTIONS(983),
    [anon_sym_switch] = ACTIONS(983),
    [anon_sym_endswitch] = ACTIONS(983),
    [anon_sym_case] = ACTIONS(983),
    [anon_sym_default] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(981),
    [anon_sym_PLUS] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(983),
    [anon_sym_TILDE] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(981),
    [anon_sym_clone] = ACTIONS(983),
    [anon_sym_print] = ACTIONS(983),
    [anon_sym_new] = ACTIONS(983),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_DASH_DASH] = ACTIONS(981),
    [sym_shell_command_expression] = ACTIONS(981),
    [anon_sym_list] = ACTIONS(983),
    [anon_sym_self] = ACTIONS(983),
    [anon_sym_parent] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(981),
    [sym_string] = ACTIONS(981),
    [sym_boolean] = ACTIONS(983),
    [sym_null] = ACTIONS(983),
    [anon_sym_DOLLAR] = ACTIONS(981),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_include] = ACTIONS(983),
    [anon_sym_include_once] = ACTIONS(983),
    [anon_sym_require] = ACTIONS(983),
    [anon_sym_require_once] = ACTIONS(983),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(981),
  },
  [302] = {
    [sym_text_interpolation] = STATE(302),
    [ts_builtin_sym_end] = ACTIONS(985),
    [sym_name] = ACTIONS(987),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(987),
    [anon_sym_namespace] = ACTIONS(987),
    [anon_sym_use] = ACTIONS(987),
    [anon_sym_BSLASH] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_const] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(985),
    [anon_sym_RBRACE] = ACTIONS(985),
    [anon_sym_trait] = ACTIONS(987),
    [anon_sym_interface] = ACTIONS(987),
    [anon_sym_class] = ACTIONS(987),
    [anon_sym_abstract] = ACTIONS(987),
    [anon_sym_final] = ACTIONS(987),
    [anon_sym_public] = ACTIONS(987),
    [anon_sym_protected] = ACTIONS(987),
    [anon_sym_private] = ACTIONS(987),
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_array] = ACTIONS(987),
    [anon_sym_unset] = ACTIONS(987),
    [anon_sym_echo] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(987),
    [anon_sym_enddeclare] = ACTIONS(987),
    [sym_float] = ACTIONS(987),
    [anon_sym_try] = ACTIONS(987),
    [anon_sym_goto] = ACTIONS(987),
    [anon_sym_continue] = ACTIONS(987),
    [anon_sym_break] = ACTIONS(987),
    [sym_integer] = ACTIONS(987),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_throw] = ACTIONS(987),
    [anon_sym_while] = ACTIONS(987),
    [anon_sym_endwhile] = ACTIONS(987),
    [anon_sym_do] = ACTIONS(987),
    [anon_sym_for] = ACTIONS(987),
    [anon_sym_endfor] = ACTIONS(987),
    [anon_sym_foreach] = ACTIONS(987),
    [anon_sym_endforeach] = ACTIONS(987),
    [anon_sym_if] = ACTIONS(987),
    [anon_sym_endif] = ACTIONS(987),
    [anon_sym_elseif] = ACTIONS(987),
    [anon_sym_else] = ACTIONS(987),
    [anon_sym_switch] = ACTIONS(987),
    [anon_sym_endswitch] = ACTIONS(987),
    [anon_sym_case] = ACTIONS(987),
    [anon_sym_default] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(987),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_clone] = ACTIONS(987),
    [anon_sym_print] = ACTIONS(987),
    [anon_sym_new] = ACTIONS(987),
    [anon_sym_PLUS_PLUS] = ACTIONS(985),
    [anon_sym_DASH_DASH] = ACTIONS(985),
    [sym_shell_command_expression] = ACTIONS(985),
    [anon_sym_list] = ACTIONS(987),
    [anon_sym_self] = ACTIONS(987),
    [anon_sym_parent] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(985),
    [sym_string] = ACTIONS(985),
    [sym_boolean] = ACTIONS(987),
    [sym_null] = ACTIONS(987),
    [anon_sym_DOLLAR] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(987),
    [anon_sym_include] = ACTIONS(987),
    [anon_sym_include_once] = ACTIONS(987),
    [anon_sym_require] = ACTIONS(987),
    [anon_sym_require_once] = ACTIONS(987),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(985),
  },
  [303] = {
    [sym_text_interpolation] = STATE(303),
    [ts_builtin_sym_end] = ACTIONS(985),
    [sym_name] = ACTIONS(987),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(985),
    [anon_sym_static] = ACTIONS(987),
    [anon_sym_global] = ACTIONS(987),
    [anon_sym_namespace] = ACTIONS(987),
    [anon_sym_use] = ACTIONS(987),
    [anon_sym_BSLASH] = ACTIONS(985),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_const] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(985),
    [anon_sym_RBRACE] = ACTIONS(985),
    [anon_sym_trait] = ACTIONS(987),
    [anon_sym_interface] = ACTIONS(987),
    [anon_sym_class] = ACTIONS(987),
    [anon_sym_abstract] = ACTIONS(987),
    [anon_sym_final] = ACTIONS(987),
    [anon_sym_public] = ACTIONS(987),
    [anon_sym_protected] = ACTIONS(987),
    [anon_sym_private] = ACTIONS(987),
    [anon_sym_LPAREN] = ACTIONS(985),
    [anon_sym_array] = ACTIONS(987),
    [anon_sym_unset] = ACTIONS(987),
    [anon_sym_echo] = ACTIONS(987),
    [anon_sym_declare] = ACTIONS(987),
    [anon_sym_enddeclare] = ACTIONS(987),
    [sym_float] = ACTIONS(987),
    [anon_sym_try] = ACTIONS(987),
    [anon_sym_goto] = ACTIONS(987),
    [anon_sym_continue] = ACTIONS(987),
    [anon_sym_break] = ACTIONS(987),
    [sym_integer] = ACTIONS(987),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_throw] = ACTIONS(987),
    [anon_sym_while] = ACTIONS(987),
    [anon_sym_endwhile] = ACTIONS(987),
    [anon_sym_do] = ACTIONS(987),
    [anon_sym_for] = ACTIONS(987),
    [anon_sym_endfor] = ACTIONS(987),
    [anon_sym_foreach] = ACTIONS(987),
    [anon_sym_endforeach] = ACTIONS(987),
    [anon_sym_if] = ACTIONS(987),
    [anon_sym_endif] = ACTIONS(987),
    [anon_sym_elseif] = ACTIONS(987),
    [anon_sym_else] = ACTIONS(987),
    [anon_sym_switch] = ACTIONS(987),
    [anon_sym_endswitch] = ACTIONS(987),
    [anon_sym_case] = ACTIONS(987),
    [anon_sym_default] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(987),
    [anon_sym_TILDE] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_clone] = ACTIONS(987),
    [anon_sym_print] = ACTIONS(987),
    [anon_sym_new] = ACTIONS(987),
    [anon_sym_PLUS_PLUS] = ACTIONS(985),
    [anon_sym_DASH_DASH] = ACTIONS(985),
    [sym_shell_command_expression] = ACTIONS(985),
    [anon_sym_list] = ACTIONS(987),
    [anon_sym_self] = ACTIONS(987),
    [anon_sym_parent] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(985),
    [sym_string] = ACTIONS(985),
    [sym_boolean] = ACTIONS(987),
    [sym_null] = ACTIONS(987),
    [anon_sym_DOLLAR] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(987),
    [anon_sym_include] = ACTIONS(987),
    [anon_sym_include_once] = ACTIONS(987),
    [anon_sym_require] = ACTIONS(987),
    [anon_sym_require_once] = ACTIONS(987),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(985),
  },
  [304] = {
    [sym_text_interpolation] = STATE(304),
    [ts_builtin_sym_end] = ACTIONS(725),
    [sym_name] = ACTIONS(727),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_static] = ACTIONS(727),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_namespace] = ACTIONS(727),
    [anon_sym_use] = ACTIONS(727),
    [anon_sym_BSLASH] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_const] = ACTIONS(727),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_trait] = ACTIONS(727),
    [anon_sym_interface] = ACTIONS(727),
    [anon_sym_class] = ACTIONS(727),
    [anon_sym_abstract] = ACTIONS(727),
    [anon_sym_final] = ACTIONS(727),
    [anon_sym_public] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(727),
    [anon_sym_private] = ACTIONS(727),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_array] = ACTIONS(727),
    [anon_sym_unset] = ACTIONS(727),
    [anon_sym_echo] = ACTIONS(727),
    [anon_sym_declare] = ACTIONS(727),
    [anon_sym_enddeclare] = ACTIONS(727),
    [sym_float] = ACTIONS(727),
    [anon_sym_try] = ACTIONS(727),
    [anon_sym_goto] = ACTIONS(727),
    [anon_sym_continue] = ACTIONS(727),
    [anon_sym_break] = ACTIONS(727),
    [sym_integer] = ACTIONS(727),
    [anon_sym_return] = ACTIONS(727),
    [anon_sym_throw] = ACTIONS(727),
    [anon_sym_while] = ACTIONS(727),
    [anon_sym_endwhile] = ACTIONS(727),
    [anon_sym_do] = ACTIONS(727),
    [anon_sym_for] = ACTIONS(727),
    [anon_sym_endfor] = ACTIONS(727),
    [anon_sym_foreach] = ACTIONS(727),
    [anon_sym_endforeach] = ACTIONS(727),
    [anon_sym_if] = ACTIONS(727),
    [anon_sym_endif] = ACTIONS(727),
    [anon_sym_elseif] = ACTIONS(727),
    [anon_sym_else] = ACTIONS(727),
    [anon_sym_switch] = ACTIONS(727),
    [anon_sym_endswitch] = ACTIONS(727),
    [anon_sym_case] = ACTIONS(727),
    [anon_sym_default] = ACTIONS(727),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(727),
    [anon_sym_DASH] = ACTIONS(727),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(725),
    [anon_sym_clone] = ACTIONS(727),
    [anon_sym_print] = ACTIONS(727),
    [anon_sym_new] = ACTIONS(727),
    [anon_sym_PLUS_PLUS] = ACTIONS(725),
    [anon_sym_DASH_DASH] = ACTIONS(725),
    [sym_shell_command_expression] = ACTIONS(725),
    [anon_sym_list] = ACTIONS(727),
    [anon_sym_self] = ACTIONS(727),
    [anon_sym_parent] = ACTIONS(727),
    [anon_sym_LBRACK] = ACTIONS(725),
    [sym_string] = ACTIONS(725),
    [sym_boolean] = ACTIONS(727),
    [sym_null] = ACTIONS(727),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_yield] = ACTIONS(727),
    [anon_sym_include] = ACTIONS(727),
    [anon_sym_include_once] = ACTIONS(727),
    [anon_sym_require] = ACTIONS(727),
    [anon_sym_require_once] = ACTIONS(727),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(725),
  },
  [305] = {
    [sym_text_interpolation] = STATE(305),
    [ts_builtin_sym_end] = ACTIONS(945),
    [sym_name] = ACTIONS(947),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(945),
    [anon_sym_static] = ACTIONS(947),
    [anon_sym_global] = ACTIONS(947),
    [anon_sym_namespace] = ACTIONS(947),
    [anon_sym_use] = ACTIONS(947),
    [anon_sym_BSLASH] = ACTIONS(945),
    [anon_sym_function] = ACTIONS(947),
    [anon_sym_const] = ACTIONS(947),
    [anon_sym_LBRACE] = ACTIONS(945),
    [anon_sym_RBRACE] = ACTIONS(945),
    [anon_sym_trait] = ACTIONS(947),
    [anon_sym_interface] = ACTIONS(947),
    [anon_sym_class] = ACTIONS(947),
    [anon_sym_abstract] = ACTIONS(947),
    [anon_sym_final] = ACTIONS(947),
    [anon_sym_public] = ACTIONS(947),
    [anon_sym_protected] = ACTIONS(947),
    [anon_sym_private] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(945),
    [anon_sym_array] = ACTIONS(947),
    [anon_sym_unset] = ACTIONS(947),
    [anon_sym_echo] = ACTIONS(947),
    [anon_sym_declare] = ACTIONS(947),
    [anon_sym_enddeclare] = ACTIONS(947),
    [sym_float] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(947),
    [anon_sym_goto] = ACTIONS(947),
    [anon_sym_continue] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(947),
    [sym_integer] = ACTIONS(947),
    [anon_sym_return] = ACTIONS(947),
    [anon_sym_throw] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(947),
    [anon_sym_endwhile] = ACTIONS(947),
    [anon_sym_do] = ACTIONS(947),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_endfor] = ACTIONS(947),
    [anon_sym_foreach] = ACTIONS(947),
    [anon_sym_endforeach] = ACTIONS(947),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_endif] = ACTIONS(947),
    [anon_sym_elseif] = ACTIONS(947),
    [anon_sym_else] = ACTIONS(947),
    [anon_sym_switch] = ACTIONS(947),
    [anon_sym_endswitch] = ACTIONS(947),
    [anon_sym_case] = ACTIONS(947),
    [anon_sym_default] = ACTIONS(947),
    [anon_sym_AT] = ACTIONS(945),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_TILDE] = ACTIONS(945),
    [anon_sym_BANG] = ACTIONS(945),
    [anon_sym_clone] = ACTIONS(947),
    [anon_sym_print] = ACTIONS(947),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(945),
    [anon_sym_DASH_DASH] = ACTIONS(945),
    [sym_shell_command_expression] = ACTIONS(945),
    [anon_sym_list] = ACTIONS(947),
    [anon_sym_self] = ACTIONS(947),
    [anon_sym_parent] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(945),
    [sym_string] = ACTIONS(945),
    [sym_boolean] = ACTIONS(947),
    [sym_null] = ACTIONS(947),
    [anon_sym_DOLLAR] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_include] = ACTIONS(947),
    [anon_sym_include_once] = ACTIONS(947),
    [anon_sym_require] = ACTIONS(947),
    [anon_sym_require_once] = ACTIONS(947),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(945),
  },
  [306] = {
    [sym_text_interpolation] = STATE(306),
    [ts_builtin_sym_end] = ACTIONS(989),
    [sym_name] = ACTIONS(991),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(989),
    [anon_sym_static] = ACTIONS(991),
    [anon_sym_global] = ACTIONS(991),
    [anon_sym_namespace] = ACTIONS(991),
    [anon_sym_use] = ACTIONS(991),
    [anon_sym_BSLASH] = ACTIONS(989),
    [anon_sym_function] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_RBRACE] = ACTIONS(989),
    [anon_sym_trait] = ACTIONS(991),
    [anon_sym_interface] = ACTIONS(991),
    [anon_sym_class] = ACTIONS(991),
    [anon_sym_abstract] = ACTIONS(991),
    [anon_sym_final] = ACTIONS(991),
    [anon_sym_public] = ACTIONS(991),
    [anon_sym_protected] = ACTIONS(991),
    [anon_sym_private] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(989),
    [anon_sym_array] = ACTIONS(991),
    [anon_sym_unset] = ACTIONS(991),
    [anon_sym_echo] = ACTIONS(991),
    [anon_sym_declare] = ACTIONS(991),
    [anon_sym_enddeclare] = ACTIONS(991),
    [sym_float] = ACTIONS(991),
    [anon_sym_try] = ACTIONS(991),
    [anon_sym_goto] = ACTIONS(991),
    [anon_sym_continue] = ACTIONS(991),
    [anon_sym_break] = ACTIONS(991),
    [sym_integer] = ACTIONS(991),
    [anon_sym_return] = ACTIONS(991),
    [anon_sym_throw] = ACTIONS(991),
    [anon_sym_while] = ACTIONS(991),
    [anon_sym_endwhile] = ACTIONS(991),
    [anon_sym_do] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_endfor] = ACTIONS(991),
    [anon_sym_foreach] = ACTIONS(991),
    [anon_sym_endforeach] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_endif] = ACTIONS(991),
    [anon_sym_elseif] = ACTIONS(991),
    [anon_sym_else] = ACTIONS(991),
    [anon_sym_switch] = ACTIONS(991),
    [anon_sym_endswitch] = ACTIONS(991),
    [anon_sym_case] = ACTIONS(991),
    [anon_sym_default] = ACTIONS(991),
    [anon_sym_AT] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(989),
    [anon_sym_clone] = ACTIONS(991),
    [anon_sym_print] = ACTIONS(991),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(989),
    [anon_sym_DASH_DASH] = ACTIONS(989),
    [sym_shell_command_expression] = ACTIONS(989),
    [anon_sym_list] = ACTIONS(991),
    [anon_sym_self] = ACTIONS(991),
    [anon_sym_parent] = ACTIONS(991),
    [anon_sym_LBRACK] = ACTIONS(989),
    [sym_string] = ACTIONS(989),
    [sym_boolean] = ACTIONS(991),
    [sym_null] = ACTIONS(991),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [anon_sym_yield] = ACTIONS(991),
    [anon_sym_include] = ACTIONS(991),
    [anon_sym_include_once] = ACTIONS(991),
    [anon_sym_require] = ACTIONS(991),
    [anon_sym_require_once] = ACTIONS(991),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(989),
  },
  [307] = {
    [sym_text_interpolation] = STATE(307),
    [ts_builtin_sym_end] = ACTIONS(993),
    [sym_name] = ACTIONS(995),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_static] = ACTIONS(995),
    [anon_sym_global] = ACTIONS(995),
    [anon_sym_namespace] = ACTIONS(995),
    [anon_sym_use] = ACTIONS(995),
    [anon_sym_BSLASH] = ACTIONS(993),
    [anon_sym_function] = ACTIONS(995),
    [anon_sym_const] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_trait] = ACTIONS(995),
    [anon_sym_interface] = ACTIONS(995),
    [anon_sym_class] = ACTIONS(995),
    [anon_sym_abstract] = ACTIONS(995),
    [anon_sym_final] = ACTIONS(995),
    [anon_sym_public] = ACTIONS(995),
    [anon_sym_protected] = ACTIONS(995),
    [anon_sym_private] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(993),
    [anon_sym_array] = ACTIONS(995),
    [anon_sym_unset] = ACTIONS(995),
    [anon_sym_echo] = ACTIONS(995),
    [anon_sym_declare] = ACTIONS(995),
    [anon_sym_enddeclare] = ACTIONS(995),
    [sym_float] = ACTIONS(995),
    [anon_sym_try] = ACTIONS(995),
    [anon_sym_goto] = ACTIONS(995),
    [anon_sym_continue] = ACTIONS(995),
    [anon_sym_break] = ACTIONS(995),
    [sym_integer] = ACTIONS(995),
    [anon_sym_return] = ACTIONS(995),
    [anon_sym_throw] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(995),
    [anon_sym_endwhile] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_endfor] = ACTIONS(995),
    [anon_sym_foreach] = ACTIONS(995),
    [anon_sym_endforeach] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_endif] = ACTIONS(995),
    [anon_sym_elseif] = ACTIONS(995),
    [anon_sym_else] = ACTIONS(995),
    [anon_sym_switch] = ACTIONS(995),
    [anon_sym_endswitch] = ACTIONS(995),
    [anon_sym_case] = ACTIONS(995),
    [anon_sym_default] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_clone] = ACTIONS(995),
    [anon_sym_print] = ACTIONS(995),
    [anon_sym_new] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [sym_shell_command_expression] = ACTIONS(993),
    [anon_sym_list] = ACTIONS(995),
    [anon_sym_self] = ACTIONS(995),
    [anon_sym_parent] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(993),
    [sym_string] = ACTIONS(993),
    [sym_boolean] = ACTIONS(995),
    [sym_null] = ACTIONS(995),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [anon_sym_yield] = ACTIONS(995),
    [anon_sym_include] = ACTIONS(995),
    [anon_sym_include_once] = ACTIONS(995),
    [anon_sym_require] = ACTIONS(995),
    [anon_sym_require_once] = ACTIONS(995),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(993),
  },
  [308] = {
    [sym_text_interpolation] = STATE(308),
    [ts_builtin_sym_end] = ACTIONS(997),
    [sym_name] = ACTIONS(999),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_static] = ACTIONS(999),
    [anon_sym_global] = ACTIONS(999),
    [anon_sym_namespace] = ACTIONS(999),
    [anon_sym_use] = ACTIONS(999),
    [anon_sym_BSLASH] = ACTIONS(997),
    [anon_sym_function] = ACTIONS(999),
    [anon_sym_const] = ACTIONS(999),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_trait] = ACTIONS(999),
    [anon_sym_interface] = ACTIONS(999),
    [anon_sym_class] = ACTIONS(999),
    [anon_sym_abstract] = ACTIONS(999),
    [anon_sym_final] = ACTIONS(999),
    [anon_sym_public] = ACTIONS(999),
    [anon_sym_protected] = ACTIONS(999),
    [anon_sym_private] = ACTIONS(999),
    [anon_sym_LPAREN] = ACTIONS(997),
    [anon_sym_array] = ACTIONS(999),
    [anon_sym_unset] = ACTIONS(999),
    [anon_sym_echo] = ACTIONS(999),
    [anon_sym_declare] = ACTIONS(999),
    [anon_sym_enddeclare] = ACTIONS(999),
    [sym_float] = ACTIONS(999),
    [anon_sym_try] = ACTIONS(999),
    [anon_sym_goto] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(999),
    [anon_sym_break] = ACTIONS(999),
    [sym_integer] = ACTIONS(999),
    [anon_sym_return] = ACTIONS(999),
    [anon_sym_throw] = ACTIONS(999),
    [anon_sym_while] = ACTIONS(999),
    [anon_sym_endwhile] = ACTIONS(999),
    [anon_sym_do] = ACTIONS(999),
    [anon_sym_for] = ACTIONS(999),
    [anon_sym_endfor] = ACTIONS(999),
    [anon_sym_foreach] = ACTIONS(999),
    [anon_sym_endforeach] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_endif] = ACTIONS(999),
    [anon_sym_elseif] = ACTIONS(999),
    [anon_sym_else] = ACTIONS(999),
    [anon_sym_switch] = ACTIONS(999),
    [anon_sym_endswitch] = ACTIONS(999),
    [anon_sym_case] = ACTIONS(999),
    [anon_sym_default] = ACTIONS(999),
    [anon_sym_AT] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(997),
    [anon_sym_BANG] = ACTIONS(997),
    [anon_sym_clone] = ACTIONS(999),
    [anon_sym_print] = ACTIONS(999),
    [anon_sym_new] = ACTIONS(999),
    [anon_sym_PLUS_PLUS] = ACTIONS(997),
    [anon_sym_DASH_DASH] = ACTIONS(997),
    [sym_shell_command_expression] = ACTIONS(997),
    [anon_sym_list] = ACTIONS(999),
    [anon_sym_self] = ACTIONS(999),
    [anon_sym_parent] = ACTIONS(999),
    [anon_sym_LBRACK] = ACTIONS(997),
    [sym_string] = ACTIONS(997),
    [sym_boolean] = ACTIONS(999),
    [sym_null] = ACTIONS(999),
    [anon_sym_DOLLAR] = ACTIONS(997),
    [anon_sym_yield] = ACTIONS(999),
    [anon_sym_include] = ACTIONS(999),
    [anon_sym_include_once] = ACTIONS(999),
    [anon_sym_require] = ACTIONS(999),
    [anon_sym_require_once] = ACTIONS(999),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(997),
  },
  [309] = {
    [sym_text_interpolation] = STATE(309),
    [ts_builtin_sym_end] = ACTIONS(993),
    [sym_name] = ACTIONS(995),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(993),
    [anon_sym_static] = ACTIONS(995),
    [anon_sym_global] = ACTIONS(995),
    [anon_sym_namespace] = ACTIONS(995),
    [anon_sym_use] = ACTIONS(995),
    [anon_sym_BSLASH] = ACTIONS(993),
    [anon_sym_function] = ACTIONS(995),
    [anon_sym_const] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_trait] = ACTIONS(995),
    [anon_sym_interface] = ACTIONS(995),
    [anon_sym_class] = ACTIONS(995),
    [anon_sym_abstract] = ACTIONS(995),
    [anon_sym_final] = ACTIONS(995),
    [anon_sym_public] = ACTIONS(995),
    [anon_sym_protected] = ACTIONS(995),
    [anon_sym_private] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(993),
    [anon_sym_array] = ACTIONS(995),
    [anon_sym_unset] = ACTIONS(995),
    [anon_sym_echo] = ACTIONS(995),
    [anon_sym_declare] = ACTIONS(995),
    [anon_sym_enddeclare] = ACTIONS(995),
    [sym_float] = ACTIONS(995),
    [anon_sym_try] = ACTIONS(995),
    [anon_sym_goto] = ACTIONS(995),
    [anon_sym_continue] = ACTIONS(995),
    [anon_sym_break] = ACTIONS(995),
    [sym_integer] = ACTIONS(995),
    [anon_sym_return] = ACTIONS(995),
    [anon_sym_throw] = ACTIONS(995),
    [anon_sym_while] = ACTIONS(995),
    [anon_sym_endwhile] = ACTIONS(995),
    [anon_sym_do] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_endfor] = ACTIONS(995),
    [anon_sym_foreach] = ACTIONS(995),
    [anon_sym_endforeach] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_endif] = ACTIONS(995),
    [anon_sym_elseif] = ACTIONS(995),
    [anon_sym_else] = ACTIONS(995),
    [anon_sym_switch] = ACTIONS(995),
    [anon_sym_endswitch] = ACTIONS(995),
    [anon_sym_case] = ACTIONS(995),
    [anon_sym_default] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(993),
    [anon_sym_BANG] = ACTIONS(993),
    [anon_sym_clone] = ACTIONS(995),
    [anon_sym_print] = ACTIONS(995),
    [anon_sym_new] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(993),
    [anon_sym_DASH_DASH] = ACTIONS(993),
    [sym_shell_command_expression] = ACTIONS(993),
    [anon_sym_list] = ACTIONS(995),
    [anon_sym_self] = ACTIONS(995),
    [anon_sym_parent] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(993),
    [sym_string] = ACTIONS(993),
    [sym_boolean] = ACTIONS(995),
    [sym_null] = ACTIONS(995),
    [anon_sym_DOLLAR] = ACTIONS(993),
    [anon_sym_yield] = ACTIONS(995),
    [anon_sym_include] = ACTIONS(995),
    [anon_sym_include_once] = ACTIONS(995),
    [anon_sym_require] = ACTIONS(995),
    [anon_sym_require_once] = ACTIONS(995),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(993),
  },
  [310] = {
    [sym_text_interpolation] = STATE(310),
    [ts_builtin_sym_end] = ACTIONS(1001),
    [sym_name] = ACTIONS(1003),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1001),
    [anon_sym_static] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1003),
    [anon_sym_namespace] = ACTIONS(1003),
    [anon_sym_use] = ACTIONS(1003),
    [anon_sym_BSLASH] = ACTIONS(1001),
    [anon_sym_function] = ACTIONS(1003),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1001),
    [anon_sym_RBRACE] = ACTIONS(1001),
    [anon_sym_trait] = ACTIONS(1003),
    [anon_sym_interface] = ACTIONS(1003),
    [anon_sym_class] = ACTIONS(1003),
    [anon_sym_abstract] = ACTIONS(1003),
    [anon_sym_final] = ACTIONS(1003),
    [anon_sym_public] = ACTIONS(1003),
    [anon_sym_protected] = ACTIONS(1003),
    [anon_sym_private] = ACTIONS(1003),
    [anon_sym_LPAREN] = ACTIONS(1001),
    [anon_sym_array] = ACTIONS(1003),
    [anon_sym_unset] = ACTIONS(1003),
    [anon_sym_echo] = ACTIONS(1003),
    [anon_sym_declare] = ACTIONS(1003),
    [anon_sym_enddeclare] = ACTIONS(1003),
    [sym_float] = ACTIONS(1003),
    [anon_sym_try] = ACTIONS(1003),
    [anon_sym_goto] = ACTIONS(1003),
    [anon_sym_continue] = ACTIONS(1003),
    [anon_sym_break] = ACTIONS(1003),
    [sym_integer] = ACTIONS(1003),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_while] = ACTIONS(1003),
    [anon_sym_endwhile] = ACTIONS(1003),
    [anon_sym_do] = ACTIONS(1003),
    [anon_sym_for] = ACTIONS(1003),
    [anon_sym_endfor] = ACTIONS(1003),
    [anon_sym_foreach] = ACTIONS(1003),
    [anon_sym_endforeach] = ACTIONS(1003),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_endif] = ACTIONS(1003),
    [anon_sym_elseif] = ACTIONS(1003),
    [anon_sym_else] = ACTIONS(1003),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_endswitch] = ACTIONS(1003),
    [anon_sym_case] = ACTIONS(1003),
    [anon_sym_default] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_TILDE] = ACTIONS(1001),
    [anon_sym_BANG] = ACTIONS(1001),
    [anon_sym_clone] = ACTIONS(1003),
    [anon_sym_print] = ACTIONS(1003),
    [anon_sym_new] = ACTIONS(1003),
    [anon_sym_PLUS_PLUS] = ACTIONS(1001),
    [anon_sym_DASH_DASH] = ACTIONS(1001),
    [sym_shell_command_expression] = ACTIONS(1001),
    [anon_sym_list] = ACTIONS(1003),
    [anon_sym_self] = ACTIONS(1003),
    [anon_sym_parent] = ACTIONS(1003),
    [anon_sym_LBRACK] = ACTIONS(1001),
    [sym_string] = ACTIONS(1001),
    [sym_boolean] = ACTIONS(1003),
    [sym_null] = ACTIONS(1003),
    [anon_sym_DOLLAR] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1003),
    [anon_sym_include] = ACTIONS(1003),
    [anon_sym_include_once] = ACTIONS(1003),
    [anon_sym_require] = ACTIONS(1003),
    [anon_sym_require_once] = ACTIONS(1003),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1001),
  },
  [311] = {
    [sym_text_interpolation] = STATE(311),
    [ts_builtin_sym_end] = ACTIONS(1005),
    [sym_name] = ACTIONS(1007),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1005),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_global] = ACTIONS(1007),
    [anon_sym_namespace] = ACTIONS(1007),
    [anon_sym_use] = ACTIONS(1007),
    [anon_sym_BSLASH] = ACTIONS(1005),
    [anon_sym_function] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_trait] = ACTIONS(1007),
    [anon_sym_interface] = ACTIONS(1007),
    [anon_sym_class] = ACTIONS(1007),
    [anon_sym_abstract] = ACTIONS(1007),
    [anon_sym_final] = ACTIONS(1007),
    [anon_sym_public] = ACTIONS(1007),
    [anon_sym_protected] = ACTIONS(1007),
    [anon_sym_private] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_array] = ACTIONS(1007),
    [anon_sym_unset] = ACTIONS(1007),
    [anon_sym_echo] = ACTIONS(1007),
    [anon_sym_declare] = ACTIONS(1007),
    [anon_sym_enddeclare] = ACTIONS(1007),
    [sym_float] = ACTIONS(1007),
    [anon_sym_try] = ACTIONS(1007),
    [anon_sym_goto] = ACTIONS(1007),
    [anon_sym_continue] = ACTIONS(1007),
    [anon_sym_break] = ACTIONS(1007),
    [sym_integer] = ACTIONS(1007),
    [anon_sym_return] = ACTIONS(1007),
    [anon_sym_throw] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_endwhile] = ACTIONS(1007),
    [anon_sym_do] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_endfor] = ACTIONS(1007),
    [anon_sym_foreach] = ACTIONS(1007),
    [anon_sym_endforeach] = ACTIONS(1007),
    [anon_sym_if] = ACTIONS(1007),
    [anon_sym_endif] = ACTIONS(1007),
    [anon_sym_elseif] = ACTIONS(1007),
    [anon_sym_else] = ACTIONS(1007),
    [anon_sym_switch] = ACTIONS(1007),
    [anon_sym_endswitch] = ACTIONS(1007),
    [anon_sym_case] = ACTIONS(1007),
    [anon_sym_default] = ACTIONS(1007),
    [anon_sym_AT] = ACTIONS(1005),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_DASH] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1005),
    [anon_sym_BANG] = ACTIONS(1005),
    [anon_sym_clone] = ACTIONS(1007),
    [anon_sym_print] = ACTIONS(1007),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS_PLUS] = ACTIONS(1005),
    [anon_sym_DASH_DASH] = ACTIONS(1005),
    [sym_shell_command_expression] = ACTIONS(1005),
    [anon_sym_list] = ACTIONS(1007),
    [anon_sym_self] = ACTIONS(1007),
    [anon_sym_parent] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [sym_string] = ACTIONS(1005),
    [sym_boolean] = ACTIONS(1007),
    [sym_null] = ACTIONS(1007),
    [anon_sym_DOLLAR] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1007),
    [anon_sym_include] = ACTIONS(1007),
    [anon_sym_include_once] = ACTIONS(1007),
    [anon_sym_require] = ACTIONS(1007),
    [anon_sym_require_once] = ACTIONS(1007),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1005),
  },
  [312] = {
    [sym_text_interpolation] = STATE(312),
    [ts_builtin_sym_end] = ACTIONS(1009),
    [sym_name] = ACTIONS(1011),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1009),
    [anon_sym_static] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1011),
    [anon_sym_namespace] = ACTIONS(1011),
    [anon_sym_use] = ACTIONS(1011),
    [anon_sym_BSLASH] = ACTIONS(1009),
    [anon_sym_function] = ACTIONS(1011),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1009),
    [anon_sym_RBRACE] = ACTIONS(1009),
    [anon_sym_trait] = ACTIONS(1011),
    [anon_sym_interface] = ACTIONS(1011),
    [anon_sym_class] = ACTIONS(1011),
    [anon_sym_abstract] = ACTIONS(1011),
    [anon_sym_final] = ACTIONS(1011),
    [anon_sym_public] = ACTIONS(1011),
    [anon_sym_protected] = ACTIONS(1011),
    [anon_sym_private] = ACTIONS(1011),
    [anon_sym_LPAREN] = ACTIONS(1009),
    [anon_sym_array] = ACTIONS(1011),
    [anon_sym_unset] = ACTIONS(1011),
    [anon_sym_echo] = ACTIONS(1011),
    [anon_sym_declare] = ACTIONS(1011),
    [anon_sym_enddeclare] = ACTIONS(1011),
    [sym_float] = ACTIONS(1011),
    [anon_sym_try] = ACTIONS(1011),
    [anon_sym_goto] = ACTIONS(1011),
    [anon_sym_continue] = ACTIONS(1011),
    [anon_sym_break] = ACTIONS(1011),
    [sym_integer] = ACTIONS(1011),
    [anon_sym_return] = ACTIONS(1011),
    [anon_sym_throw] = ACTIONS(1011),
    [anon_sym_while] = ACTIONS(1011),
    [anon_sym_endwhile] = ACTIONS(1011),
    [anon_sym_do] = ACTIONS(1011),
    [anon_sym_for] = ACTIONS(1011),
    [anon_sym_endfor] = ACTIONS(1011),
    [anon_sym_foreach] = ACTIONS(1011),
    [anon_sym_endforeach] = ACTIONS(1011),
    [anon_sym_if] = ACTIONS(1011),
    [anon_sym_endif] = ACTIONS(1011),
    [anon_sym_elseif] = ACTIONS(1011),
    [anon_sym_else] = ACTIONS(1011),
    [anon_sym_switch] = ACTIONS(1011),
    [anon_sym_endswitch] = ACTIONS(1011),
    [anon_sym_case] = ACTIONS(1011),
    [anon_sym_default] = ACTIONS(1011),
    [anon_sym_AT] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_clone] = ACTIONS(1011),
    [anon_sym_print] = ACTIONS(1011),
    [anon_sym_new] = ACTIONS(1011),
    [anon_sym_PLUS_PLUS] = ACTIONS(1009),
    [anon_sym_DASH_DASH] = ACTIONS(1009),
    [sym_shell_command_expression] = ACTIONS(1009),
    [anon_sym_list] = ACTIONS(1011),
    [anon_sym_self] = ACTIONS(1011),
    [anon_sym_parent] = ACTIONS(1011),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [sym_string] = ACTIONS(1009),
    [sym_boolean] = ACTIONS(1011),
    [sym_null] = ACTIONS(1011),
    [anon_sym_DOLLAR] = ACTIONS(1009),
    [anon_sym_yield] = ACTIONS(1011),
    [anon_sym_include] = ACTIONS(1011),
    [anon_sym_include_once] = ACTIONS(1011),
    [anon_sym_require] = ACTIONS(1011),
    [anon_sym_require_once] = ACTIONS(1011),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1009),
  },
  [313] = {
    [sym_text_interpolation] = STATE(313),
    [ts_builtin_sym_end] = ACTIONS(715),
    [sym_name] = ACTIONS(717),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym_static] = ACTIONS(717),
    [anon_sym_global] = ACTIONS(717),
    [anon_sym_namespace] = ACTIONS(717),
    [anon_sym_use] = ACTIONS(717),
    [anon_sym_BSLASH] = ACTIONS(715),
    [anon_sym_function] = ACTIONS(717),
    [anon_sym_const] = ACTIONS(717),
    [anon_sym_LBRACE] = ACTIONS(715),
    [anon_sym_RBRACE] = ACTIONS(715),
    [anon_sym_trait] = ACTIONS(717),
    [anon_sym_interface] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(717),
    [anon_sym_final] = ACTIONS(717),
    [anon_sym_public] = ACTIONS(717),
    [anon_sym_protected] = ACTIONS(717),
    [anon_sym_private] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(715),
    [anon_sym_array] = ACTIONS(717),
    [anon_sym_unset] = ACTIONS(717),
    [anon_sym_echo] = ACTIONS(717),
    [anon_sym_declare] = ACTIONS(717),
    [anon_sym_enddeclare] = ACTIONS(717),
    [sym_float] = ACTIONS(717),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_goto] = ACTIONS(717),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_break] = ACTIONS(717),
    [sym_integer] = ACTIONS(717),
    [anon_sym_return] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(717),
    [anon_sym_endwhile] = ACTIONS(717),
    [anon_sym_do] = ACTIONS(717),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_endfor] = ACTIONS(717),
    [anon_sym_foreach] = ACTIONS(717),
    [anon_sym_endforeach] = ACTIONS(717),
    [anon_sym_if] = ACTIONS(717),
    [anon_sym_endif] = ACTIONS(717),
    [anon_sym_elseif] = ACTIONS(717),
    [anon_sym_else] = ACTIONS(717),
    [anon_sym_switch] = ACTIONS(717),
    [anon_sym_endswitch] = ACTIONS(717),
    [anon_sym_case] = ACTIONS(717),
    [anon_sym_default] = ACTIONS(717),
    [anon_sym_AT] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_TILDE] = ACTIONS(715),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_clone] = ACTIONS(717),
    [anon_sym_print] = ACTIONS(717),
    [anon_sym_new] = ACTIONS(717),
    [anon_sym_PLUS_PLUS] = ACTIONS(715),
    [anon_sym_DASH_DASH] = ACTIONS(715),
    [sym_shell_command_expression] = ACTIONS(715),
    [anon_sym_list] = ACTIONS(717),
    [anon_sym_self] = ACTIONS(717),
    [anon_sym_parent] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(715),
    [sym_string] = ACTIONS(715),
    [sym_boolean] = ACTIONS(717),
    [sym_null] = ACTIONS(717),
    [anon_sym_DOLLAR] = ACTIONS(715),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_include] = ACTIONS(717),
    [anon_sym_include_once] = ACTIONS(717),
    [anon_sym_require] = ACTIONS(717),
    [anon_sym_require_once] = ACTIONS(717),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(715),
  },
  [314] = {
    [sym_text_interpolation] = STATE(314),
    [ts_builtin_sym_end] = ACTIONS(1013),
    [sym_name] = ACTIONS(1015),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_static] = ACTIONS(1015),
    [anon_sym_global] = ACTIONS(1015),
    [anon_sym_namespace] = ACTIONS(1015),
    [anon_sym_use] = ACTIONS(1015),
    [anon_sym_BSLASH] = ACTIONS(1013),
    [anon_sym_function] = ACTIONS(1015),
    [anon_sym_const] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1013),
    [anon_sym_trait] = ACTIONS(1015),
    [anon_sym_interface] = ACTIONS(1015),
    [anon_sym_class] = ACTIONS(1015),
    [anon_sym_abstract] = ACTIONS(1015),
    [anon_sym_final] = ACTIONS(1015),
    [anon_sym_public] = ACTIONS(1015),
    [anon_sym_protected] = ACTIONS(1015),
    [anon_sym_private] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(1013),
    [anon_sym_array] = ACTIONS(1015),
    [anon_sym_unset] = ACTIONS(1015),
    [anon_sym_echo] = ACTIONS(1015),
    [anon_sym_declare] = ACTIONS(1015),
    [anon_sym_enddeclare] = ACTIONS(1015),
    [sym_float] = ACTIONS(1015),
    [anon_sym_try] = ACTIONS(1015),
    [anon_sym_goto] = ACTIONS(1015),
    [anon_sym_continue] = ACTIONS(1015),
    [anon_sym_break] = ACTIONS(1015),
    [sym_integer] = ACTIONS(1015),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_throw] = ACTIONS(1015),
    [anon_sym_while] = ACTIONS(1015),
    [anon_sym_endwhile] = ACTIONS(1015),
    [anon_sym_do] = ACTIONS(1015),
    [anon_sym_for] = ACTIONS(1015),
    [anon_sym_endfor] = ACTIONS(1015),
    [anon_sym_foreach] = ACTIONS(1015),
    [anon_sym_endforeach] = ACTIONS(1015),
    [anon_sym_if] = ACTIONS(1015),
    [anon_sym_endif] = ACTIONS(1015),
    [anon_sym_elseif] = ACTIONS(1015),
    [anon_sym_else] = ACTIONS(1015),
    [anon_sym_switch] = ACTIONS(1015),
    [anon_sym_endswitch] = ACTIONS(1015),
    [anon_sym_case] = ACTIONS(1015),
    [anon_sym_default] = ACTIONS(1015),
    [anon_sym_AT] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_DASH] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1013),
    [anon_sym_BANG] = ACTIONS(1013),
    [anon_sym_clone] = ACTIONS(1015),
    [anon_sym_print] = ACTIONS(1015),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [sym_shell_command_expression] = ACTIONS(1013),
    [anon_sym_list] = ACTIONS(1015),
    [anon_sym_self] = ACTIONS(1015),
    [anon_sym_parent] = ACTIONS(1015),
    [anon_sym_LBRACK] = ACTIONS(1013),
    [sym_string] = ACTIONS(1013),
    [sym_boolean] = ACTIONS(1015),
    [sym_null] = ACTIONS(1015),
    [anon_sym_DOLLAR] = ACTIONS(1013),
    [anon_sym_yield] = ACTIONS(1015),
    [anon_sym_include] = ACTIONS(1015),
    [anon_sym_include_once] = ACTIONS(1015),
    [anon_sym_require] = ACTIONS(1015),
    [anon_sym_require_once] = ACTIONS(1015),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1013),
  },
  [315] = {
    [sym_text_interpolation] = STATE(315),
    [ts_builtin_sym_end] = ACTIONS(1017),
    [sym_name] = ACTIONS(1019),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1017),
    [anon_sym_static] = ACTIONS(1019),
    [anon_sym_global] = ACTIONS(1019),
    [anon_sym_namespace] = ACTIONS(1019),
    [anon_sym_use] = ACTIONS(1019),
    [anon_sym_BSLASH] = ACTIONS(1017),
    [anon_sym_function] = ACTIONS(1019),
    [anon_sym_const] = ACTIONS(1019),
    [anon_sym_LBRACE] = ACTIONS(1017),
    [anon_sym_RBRACE] = ACTIONS(1017),
    [anon_sym_trait] = ACTIONS(1019),
    [anon_sym_interface] = ACTIONS(1019),
    [anon_sym_class] = ACTIONS(1019),
    [anon_sym_abstract] = ACTIONS(1019),
    [anon_sym_final] = ACTIONS(1019),
    [anon_sym_public] = ACTIONS(1019),
    [anon_sym_protected] = ACTIONS(1019),
    [anon_sym_private] = ACTIONS(1019),
    [anon_sym_LPAREN] = ACTIONS(1017),
    [anon_sym_array] = ACTIONS(1019),
    [anon_sym_unset] = ACTIONS(1019),
    [anon_sym_echo] = ACTIONS(1019),
    [anon_sym_declare] = ACTIONS(1019),
    [anon_sym_enddeclare] = ACTIONS(1019),
    [sym_float] = ACTIONS(1019),
    [anon_sym_try] = ACTIONS(1019),
    [anon_sym_goto] = ACTIONS(1019),
    [anon_sym_continue] = ACTIONS(1019),
    [anon_sym_break] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1019),
    [anon_sym_return] = ACTIONS(1019),
    [anon_sym_throw] = ACTIONS(1019),
    [anon_sym_while] = ACTIONS(1019),
    [anon_sym_endwhile] = ACTIONS(1019),
    [anon_sym_do] = ACTIONS(1019),
    [anon_sym_for] = ACTIONS(1019),
    [anon_sym_endfor] = ACTIONS(1019),
    [anon_sym_foreach] = ACTIONS(1019),
    [anon_sym_endforeach] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(1019),
    [anon_sym_endif] = ACTIONS(1019),
    [anon_sym_elseif] = ACTIONS(1019),
    [anon_sym_else] = ACTIONS(1019),
    [anon_sym_switch] = ACTIONS(1019),
    [anon_sym_endswitch] = ACTIONS(1019),
    [anon_sym_case] = ACTIONS(1019),
    [anon_sym_default] = ACTIONS(1019),
    [anon_sym_AT] = ACTIONS(1017),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1017),
    [anon_sym_BANG] = ACTIONS(1017),
    [anon_sym_clone] = ACTIONS(1019),
    [anon_sym_print] = ACTIONS(1019),
    [anon_sym_new] = ACTIONS(1019),
    [anon_sym_PLUS_PLUS] = ACTIONS(1017),
    [anon_sym_DASH_DASH] = ACTIONS(1017),
    [sym_shell_command_expression] = ACTIONS(1017),
    [anon_sym_list] = ACTIONS(1019),
    [anon_sym_self] = ACTIONS(1019),
    [anon_sym_parent] = ACTIONS(1019),
    [anon_sym_LBRACK] = ACTIONS(1017),
    [sym_string] = ACTIONS(1017),
    [sym_boolean] = ACTIONS(1019),
    [sym_null] = ACTIONS(1019),
    [anon_sym_DOLLAR] = ACTIONS(1017),
    [anon_sym_yield] = ACTIONS(1019),
    [anon_sym_include] = ACTIONS(1019),
    [anon_sym_include_once] = ACTIONS(1019),
    [anon_sym_require] = ACTIONS(1019),
    [anon_sym_require_once] = ACTIONS(1019),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1017),
  },
  [316] = {
    [sym_text_interpolation] = STATE(316),
    [ts_builtin_sym_end] = ACTIONS(1021),
    [sym_name] = ACTIONS(1023),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1021),
    [anon_sym_static] = ACTIONS(1023),
    [anon_sym_global] = ACTIONS(1023),
    [anon_sym_namespace] = ACTIONS(1023),
    [anon_sym_use] = ACTIONS(1023),
    [anon_sym_BSLASH] = ACTIONS(1021),
    [anon_sym_function] = ACTIONS(1023),
    [anon_sym_const] = ACTIONS(1023),
    [anon_sym_LBRACE] = ACTIONS(1021),
    [anon_sym_RBRACE] = ACTIONS(1021),
    [anon_sym_trait] = ACTIONS(1023),
    [anon_sym_interface] = ACTIONS(1023),
    [anon_sym_class] = ACTIONS(1023),
    [anon_sym_abstract] = ACTIONS(1023),
    [anon_sym_final] = ACTIONS(1023),
    [anon_sym_public] = ACTIONS(1023),
    [anon_sym_protected] = ACTIONS(1023),
    [anon_sym_private] = ACTIONS(1023),
    [anon_sym_LPAREN] = ACTIONS(1021),
    [anon_sym_array] = ACTIONS(1023),
    [anon_sym_unset] = ACTIONS(1023),
    [anon_sym_echo] = ACTIONS(1023),
    [anon_sym_declare] = ACTIONS(1023),
    [anon_sym_enddeclare] = ACTIONS(1023),
    [sym_float] = ACTIONS(1023),
    [anon_sym_try] = ACTIONS(1023),
    [anon_sym_goto] = ACTIONS(1023),
    [anon_sym_continue] = ACTIONS(1023),
    [anon_sym_break] = ACTIONS(1023),
    [sym_integer] = ACTIONS(1023),
    [anon_sym_return] = ACTIONS(1023),
    [anon_sym_throw] = ACTIONS(1023),
    [anon_sym_while] = ACTIONS(1023),
    [anon_sym_endwhile] = ACTIONS(1023),
    [anon_sym_do] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1023),
    [anon_sym_endfor] = ACTIONS(1023),
    [anon_sym_foreach] = ACTIONS(1023),
    [anon_sym_endforeach] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1023),
    [anon_sym_endif] = ACTIONS(1023),
    [anon_sym_elseif] = ACTIONS(1023),
    [anon_sym_else] = ACTIONS(1023),
    [anon_sym_switch] = ACTIONS(1023),
    [anon_sym_endswitch] = ACTIONS(1023),
    [anon_sym_case] = ACTIONS(1023),
    [anon_sym_default] = ACTIONS(1023),
    [anon_sym_AT] = ACTIONS(1021),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_DASH] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1021),
    [anon_sym_BANG] = ACTIONS(1021),
    [anon_sym_clone] = ACTIONS(1023),
    [anon_sym_print] = ACTIONS(1023),
    [anon_sym_new] = ACTIONS(1023),
    [anon_sym_PLUS_PLUS] = ACTIONS(1021),
    [anon_sym_DASH_DASH] = ACTIONS(1021),
    [sym_shell_command_expression] = ACTIONS(1021),
    [anon_sym_list] = ACTIONS(1023),
    [anon_sym_self] = ACTIONS(1023),
    [anon_sym_parent] = ACTIONS(1023),
    [anon_sym_LBRACK] = ACTIONS(1021),
    [sym_string] = ACTIONS(1021),
    [sym_boolean] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [anon_sym_DOLLAR] = ACTIONS(1021),
    [anon_sym_yield] = ACTIONS(1023),
    [anon_sym_include] = ACTIONS(1023),
    [anon_sym_include_once] = ACTIONS(1023),
    [anon_sym_require] = ACTIONS(1023),
    [anon_sym_require_once] = ACTIONS(1023),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1021),
  },
  [317] = {
    [sym_text_interpolation] = STATE(317),
    [ts_builtin_sym_end] = ACTIONS(1025),
    [sym_name] = ACTIONS(1027),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_static] = ACTIONS(1027),
    [anon_sym_global] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1027),
    [anon_sym_use] = ACTIONS(1027),
    [anon_sym_BSLASH] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1027),
    [anon_sym_const] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_trait] = ACTIONS(1027),
    [anon_sym_interface] = ACTIONS(1027),
    [anon_sym_class] = ACTIONS(1027),
    [anon_sym_abstract] = ACTIONS(1027),
    [anon_sym_final] = ACTIONS(1027),
    [anon_sym_public] = ACTIONS(1027),
    [anon_sym_protected] = ACTIONS(1027),
    [anon_sym_private] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1025),
    [anon_sym_array] = ACTIONS(1027),
    [anon_sym_unset] = ACTIONS(1027),
    [anon_sym_echo] = ACTIONS(1027),
    [anon_sym_declare] = ACTIONS(1027),
    [anon_sym_enddeclare] = ACTIONS(1027),
    [sym_float] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1027),
    [anon_sym_goto] = ACTIONS(1027),
    [anon_sym_continue] = ACTIONS(1027),
    [anon_sym_break] = ACTIONS(1027),
    [sym_integer] = ACTIONS(1027),
    [anon_sym_return] = ACTIONS(1027),
    [anon_sym_throw] = ACTIONS(1027),
    [anon_sym_while] = ACTIONS(1027),
    [anon_sym_endwhile] = ACTIONS(1027),
    [anon_sym_do] = ACTIONS(1027),
    [anon_sym_for] = ACTIONS(1027),
    [anon_sym_endfor] = ACTIONS(1027),
    [anon_sym_foreach] = ACTIONS(1027),
    [anon_sym_endforeach] = ACTIONS(1027),
    [anon_sym_if] = ACTIONS(1027),
    [anon_sym_endif] = ACTIONS(1027),
    [anon_sym_elseif] = ACTIONS(1027),
    [anon_sym_else] = ACTIONS(1027),
    [anon_sym_switch] = ACTIONS(1027),
    [anon_sym_endswitch] = ACTIONS(1027),
    [anon_sym_case] = ACTIONS(1027),
    [anon_sym_default] = ACTIONS(1027),
    [anon_sym_AT] = ACTIONS(1025),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_clone] = ACTIONS(1027),
    [anon_sym_print] = ACTIONS(1027),
    [anon_sym_new] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [sym_shell_command_expression] = ACTIONS(1025),
    [anon_sym_list] = ACTIONS(1027),
    [anon_sym_self] = ACTIONS(1027),
    [anon_sym_parent] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [sym_string] = ACTIONS(1025),
    [sym_boolean] = ACTIONS(1027),
    [sym_null] = ACTIONS(1027),
    [anon_sym_DOLLAR] = ACTIONS(1025),
    [anon_sym_yield] = ACTIONS(1027),
    [anon_sym_include] = ACTIONS(1027),
    [anon_sym_include_once] = ACTIONS(1027),
    [anon_sym_require] = ACTIONS(1027),
    [anon_sym_require_once] = ACTIONS(1027),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1025),
  },
  [318] = {
    [sym_text_interpolation] = STATE(318),
    [ts_builtin_sym_end] = ACTIONS(1029),
    [sym_name] = ACTIONS(1031),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1029),
    [anon_sym_static] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1031),
    [anon_sym_namespace] = ACTIONS(1031),
    [anon_sym_use] = ACTIONS(1031),
    [anon_sym_BSLASH] = ACTIONS(1029),
    [anon_sym_function] = ACTIONS(1031),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_trait] = ACTIONS(1031),
    [anon_sym_interface] = ACTIONS(1031),
    [anon_sym_class] = ACTIONS(1031),
    [anon_sym_abstract] = ACTIONS(1031),
    [anon_sym_final] = ACTIONS(1031),
    [anon_sym_public] = ACTIONS(1031),
    [anon_sym_protected] = ACTIONS(1031),
    [anon_sym_private] = ACTIONS(1031),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_array] = ACTIONS(1031),
    [anon_sym_unset] = ACTIONS(1031),
    [anon_sym_echo] = ACTIONS(1031),
    [anon_sym_declare] = ACTIONS(1031),
    [anon_sym_enddeclare] = ACTIONS(1031),
    [sym_float] = ACTIONS(1031),
    [anon_sym_try] = ACTIONS(1031),
    [anon_sym_goto] = ACTIONS(1031),
    [anon_sym_continue] = ACTIONS(1031),
    [anon_sym_break] = ACTIONS(1031),
    [sym_integer] = ACTIONS(1031),
    [anon_sym_return] = ACTIONS(1031),
    [anon_sym_throw] = ACTIONS(1031),
    [anon_sym_while] = ACTIONS(1031),
    [anon_sym_endwhile] = ACTIONS(1031),
    [anon_sym_do] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1031),
    [anon_sym_endfor] = ACTIONS(1031),
    [anon_sym_foreach] = ACTIONS(1031),
    [anon_sym_endforeach] = ACTIONS(1031),
    [anon_sym_if] = ACTIONS(1031),
    [anon_sym_endif] = ACTIONS(1031),
    [anon_sym_elseif] = ACTIONS(1031),
    [anon_sym_else] = ACTIONS(1031),
    [anon_sym_switch] = ACTIONS(1031),
    [anon_sym_endswitch] = ACTIONS(1031),
    [anon_sym_case] = ACTIONS(1031),
    [anon_sym_default] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1029),
    [anon_sym_clone] = ACTIONS(1031),
    [anon_sym_print] = ACTIONS(1031),
    [anon_sym_new] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1029),
    [sym_shell_command_expression] = ACTIONS(1029),
    [anon_sym_list] = ACTIONS(1031),
    [anon_sym_self] = ACTIONS(1031),
    [anon_sym_parent] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [sym_string] = ACTIONS(1029),
    [sym_boolean] = ACTIONS(1031),
    [sym_null] = ACTIONS(1031),
    [anon_sym_DOLLAR] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1031),
    [anon_sym_include] = ACTIONS(1031),
    [anon_sym_include_once] = ACTIONS(1031),
    [anon_sym_require] = ACTIONS(1031),
    [anon_sym_require_once] = ACTIONS(1031),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1029),
  },
  [319] = {
    [sym_text_interpolation] = STATE(319),
    [ts_builtin_sym_end] = ACTIONS(1033),
    [sym_name] = ACTIONS(1035),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(1035),
    [anon_sym_global] = ACTIONS(1035),
    [anon_sym_namespace] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1035),
    [anon_sym_BSLASH] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_const] = ACTIONS(1035),
    [anon_sym_LBRACE] = ACTIONS(1033),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_trait] = ACTIONS(1035),
    [anon_sym_interface] = ACTIONS(1035),
    [anon_sym_class] = ACTIONS(1035),
    [anon_sym_abstract] = ACTIONS(1035),
    [anon_sym_final] = ACTIONS(1035),
    [anon_sym_public] = ACTIONS(1035),
    [anon_sym_protected] = ACTIONS(1035),
    [anon_sym_private] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(1033),
    [anon_sym_array] = ACTIONS(1035),
    [anon_sym_unset] = ACTIONS(1035),
    [anon_sym_echo] = ACTIONS(1035),
    [anon_sym_declare] = ACTIONS(1035),
    [anon_sym_enddeclare] = ACTIONS(1035),
    [sym_float] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_goto] = ACTIONS(1035),
    [anon_sym_continue] = ACTIONS(1035),
    [anon_sym_break] = ACTIONS(1035),
    [sym_integer] = ACTIONS(1035),
    [anon_sym_return] = ACTIONS(1035),
    [anon_sym_throw] = ACTIONS(1035),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_endwhile] = ACTIONS(1035),
    [anon_sym_do] = ACTIONS(1035),
    [anon_sym_for] = ACTIONS(1035),
    [anon_sym_endfor] = ACTIONS(1035),
    [anon_sym_foreach] = ACTIONS(1035),
    [anon_sym_endforeach] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_endif] = ACTIONS(1035),
    [anon_sym_elseif] = ACTIONS(1035),
    [anon_sym_else] = ACTIONS(1035),
    [anon_sym_switch] = ACTIONS(1035),
    [anon_sym_endswitch] = ACTIONS(1035),
    [anon_sym_case] = ACTIONS(1035),
    [anon_sym_default] = ACTIONS(1035),
    [anon_sym_AT] = ACTIONS(1033),
    [anon_sym_PLUS] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1035),
    [anon_sym_TILDE] = ACTIONS(1033),
    [anon_sym_BANG] = ACTIONS(1033),
    [anon_sym_clone] = ACTIONS(1035),
    [anon_sym_print] = ACTIONS(1035),
    [anon_sym_new] = ACTIONS(1035),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_DASH_DASH] = ACTIONS(1033),
    [sym_shell_command_expression] = ACTIONS(1033),
    [anon_sym_list] = ACTIONS(1035),
    [anon_sym_self] = ACTIONS(1035),
    [anon_sym_parent] = ACTIONS(1035),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [sym_string] = ACTIONS(1033),
    [sym_boolean] = ACTIONS(1035),
    [sym_null] = ACTIONS(1035),
    [anon_sym_DOLLAR] = ACTIONS(1033),
    [anon_sym_yield] = ACTIONS(1035),
    [anon_sym_include] = ACTIONS(1035),
    [anon_sym_include_once] = ACTIONS(1035),
    [anon_sym_require] = ACTIONS(1035),
    [anon_sym_require_once] = ACTIONS(1035),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1033),
  },
  [320] = {
    [sym_text_interpolation] = STATE(320),
    [ts_builtin_sym_end] = ACTIONS(1037),
    [sym_name] = ACTIONS(1039),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1039),
    [anon_sym_global] = ACTIONS(1039),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_use] = ACTIONS(1039),
    [anon_sym_BSLASH] = ACTIONS(1037),
    [anon_sym_function] = ACTIONS(1039),
    [anon_sym_const] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1037),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym_trait] = ACTIONS(1039),
    [anon_sym_interface] = ACTIONS(1039),
    [anon_sym_class] = ACTIONS(1039),
    [anon_sym_abstract] = ACTIONS(1039),
    [anon_sym_final] = ACTIONS(1039),
    [anon_sym_public] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_array] = ACTIONS(1039),
    [anon_sym_unset] = ACTIONS(1039),
    [anon_sym_echo] = ACTIONS(1039),
    [anon_sym_declare] = ACTIONS(1039),
    [anon_sym_enddeclare] = ACTIONS(1039),
    [sym_float] = ACTIONS(1039),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1039),
    [anon_sym_continue] = ACTIONS(1039),
    [anon_sym_break] = ACTIONS(1039),
    [sym_integer] = ACTIONS(1039),
    [anon_sym_return] = ACTIONS(1039),
    [anon_sym_throw] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1039),
    [anon_sym_endwhile] = ACTIONS(1039),
    [anon_sym_do] = ACTIONS(1039),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_endfor] = ACTIONS(1039),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_endforeach] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1039),
    [anon_sym_endif] = ACTIONS(1039),
    [anon_sym_elseif] = ACTIONS(1039),
    [anon_sym_else] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(1039),
    [anon_sym_endswitch] = ACTIONS(1039),
    [anon_sym_case] = ACTIONS(1039),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_AT] = ACTIONS(1037),
    [anon_sym_PLUS] = ACTIONS(1039),
    [anon_sym_DASH] = ACTIONS(1039),
    [anon_sym_TILDE] = ACTIONS(1037),
    [anon_sym_BANG] = ACTIONS(1037),
    [anon_sym_clone] = ACTIONS(1039),
    [anon_sym_print] = ACTIONS(1039),
    [anon_sym_new] = ACTIONS(1039),
    [anon_sym_PLUS_PLUS] = ACTIONS(1037),
    [anon_sym_DASH_DASH] = ACTIONS(1037),
    [sym_shell_command_expression] = ACTIONS(1037),
    [anon_sym_list] = ACTIONS(1039),
    [anon_sym_self] = ACTIONS(1039),
    [anon_sym_parent] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1037),
    [sym_string] = ACTIONS(1037),
    [sym_boolean] = ACTIONS(1039),
    [sym_null] = ACTIONS(1039),
    [anon_sym_DOLLAR] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_include] = ACTIONS(1039),
    [anon_sym_include_once] = ACTIONS(1039),
    [anon_sym_require] = ACTIONS(1039),
    [anon_sym_require_once] = ACTIONS(1039),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1037),
  },
  [321] = {
    [sym_text_interpolation] = STATE(321),
    [ts_builtin_sym_end] = ACTIONS(1037),
    [sym_name] = ACTIONS(1039),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(1039),
    [anon_sym_global] = ACTIONS(1039),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_use] = ACTIONS(1039),
    [anon_sym_BSLASH] = ACTIONS(1037),
    [anon_sym_function] = ACTIONS(1039),
    [anon_sym_const] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1037),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym_trait] = ACTIONS(1039),
    [anon_sym_interface] = ACTIONS(1039),
    [anon_sym_class] = ACTIONS(1039),
    [anon_sym_abstract] = ACTIONS(1039),
    [anon_sym_final] = ACTIONS(1039),
    [anon_sym_public] = ACTIONS(1039),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_array] = ACTIONS(1039),
    [anon_sym_unset] = ACTIONS(1039),
    [anon_sym_echo] = ACTIONS(1039),
    [anon_sym_declare] = ACTIONS(1039),
    [anon_sym_enddeclare] = ACTIONS(1039),
    [sym_float] = ACTIONS(1039),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_goto] = ACTIONS(1039),
    [anon_sym_continue] = ACTIONS(1039),
    [anon_sym_break] = ACTIONS(1039),
    [sym_integer] = ACTIONS(1039),
    [anon_sym_return] = ACTIONS(1039),
    [anon_sym_throw] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1039),
    [anon_sym_endwhile] = ACTIONS(1039),
    [anon_sym_do] = ACTIONS(1039),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_endfor] = ACTIONS(1039),
    [anon_sym_foreach] = ACTIONS(1039),
    [anon_sym_endforeach] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1039),
    [anon_sym_endif] = ACTIONS(1039),
    [anon_sym_elseif] = ACTIONS(1039),
    [anon_sym_else] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(1039),
    [anon_sym_endswitch] = ACTIONS(1039),
    [anon_sym_case] = ACTIONS(1039),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_AT] = ACTIONS(1037),
    [anon_sym_PLUS] = ACTIONS(1039),
    [anon_sym_DASH] = ACTIONS(1039),
    [anon_sym_TILDE] = ACTIONS(1037),
    [anon_sym_BANG] = ACTIONS(1037),
    [anon_sym_clone] = ACTIONS(1039),
    [anon_sym_print] = ACTIONS(1039),
    [anon_sym_new] = ACTIONS(1039),
    [anon_sym_PLUS_PLUS] = ACTIONS(1037),
    [anon_sym_DASH_DASH] = ACTIONS(1037),
    [sym_shell_command_expression] = ACTIONS(1037),
    [anon_sym_list] = ACTIONS(1039),
    [anon_sym_self] = ACTIONS(1039),
    [anon_sym_parent] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1037),
    [sym_string] = ACTIONS(1037),
    [sym_boolean] = ACTIONS(1039),
    [sym_null] = ACTIONS(1039),
    [anon_sym_DOLLAR] = ACTIONS(1037),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_include] = ACTIONS(1039),
    [anon_sym_include_once] = ACTIONS(1039),
    [anon_sym_require] = ACTIONS(1039),
    [anon_sym_require_once] = ACTIONS(1039),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1037),
  },
  [322] = {
    [sym_text_interpolation] = STATE(322),
    [ts_builtin_sym_end] = ACTIONS(1033),
    [sym_name] = ACTIONS(1035),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(1035),
    [anon_sym_global] = ACTIONS(1035),
    [anon_sym_namespace] = ACTIONS(1035),
    [anon_sym_use] = ACTIONS(1035),
    [anon_sym_BSLASH] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1035),
    [anon_sym_const] = ACTIONS(1035),
    [anon_sym_LBRACE] = ACTIONS(1033),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_trait] = ACTIONS(1035),
    [anon_sym_interface] = ACTIONS(1035),
    [anon_sym_class] = ACTIONS(1035),
    [anon_sym_abstract] = ACTIONS(1035),
    [anon_sym_final] = ACTIONS(1035),
    [anon_sym_public] = ACTIONS(1035),
    [anon_sym_protected] = ACTIONS(1035),
    [anon_sym_private] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(1033),
    [anon_sym_array] = ACTIONS(1035),
    [anon_sym_unset] = ACTIONS(1035),
    [anon_sym_echo] = ACTIONS(1035),
    [anon_sym_declare] = ACTIONS(1035),
    [anon_sym_enddeclare] = ACTIONS(1035),
    [sym_float] = ACTIONS(1035),
    [anon_sym_try] = ACTIONS(1035),
    [anon_sym_goto] = ACTIONS(1035),
    [anon_sym_continue] = ACTIONS(1035),
    [anon_sym_break] = ACTIONS(1035),
    [sym_integer] = ACTIONS(1035),
    [anon_sym_return] = ACTIONS(1035),
    [anon_sym_throw] = ACTIONS(1035),
    [anon_sym_while] = ACTIONS(1035),
    [anon_sym_endwhile] = ACTIONS(1035),
    [anon_sym_do] = ACTIONS(1035),
    [anon_sym_for] = ACTIONS(1035),
    [anon_sym_endfor] = ACTIONS(1035),
    [anon_sym_foreach] = ACTIONS(1035),
    [anon_sym_endforeach] = ACTIONS(1035),
    [anon_sym_if] = ACTIONS(1035),
    [anon_sym_endif] = ACTIONS(1035),
    [anon_sym_elseif] = ACTIONS(1035),
    [anon_sym_else] = ACTIONS(1035),
    [anon_sym_switch] = ACTIONS(1035),
    [anon_sym_endswitch] = ACTIONS(1035),
    [anon_sym_case] = ACTIONS(1035),
    [anon_sym_default] = ACTIONS(1035),
    [anon_sym_AT] = ACTIONS(1033),
    [anon_sym_PLUS] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1035),
    [anon_sym_TILDE] = ACTIONS(1033),
    [anon_sym_BANG] = ACTIONS(1033),
    [anon_sym_clone] = ACTIONS(1035),
    [anon_sym_print] = ACTIONS(1035),
    [anon_sym_new] = ACTIONS(1035),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_DASH_DASH] = ACTIONS(1033),
    [sym_shell_command_expression] = ACTIONS(1033),
    [anon_sym_list] = ACTIONS(1035),
    [anon_sym_self] = ACTIONS(1035),
    [anon_sym_parent] = ACTIONS(1035),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [sym_string] = ACTIONS(1033),
    [sym_boolean] = ACTIONS(1035),
    [sym_null] = ACTIONS(1035),
    [anon_sym_DOLLAR] = ACTIONS(1033),
    [anon_sym_yield] = ACTIONS(1035),
    [anon_sym_include] = ACTIONS(1035),
    [anon_sym_include_once] = ACTIONS(1035),
    [anon_sym_require] = ACTIONS(1035),
    [anon_sym_require_once] = ACTIONS(1035),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1033),
  },
  [323] = {
    [sym_text_interpolation] = STATE(323),
    [ts_builtin_sym_end] = ACTIONS(1041),
    [sym_name] = ACTIONS(1043),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1041),
    [anon_sym_static] = ACTIONS(1043),
    [anon_sym_global] = ACTIONS(1043),
    [anon_sym_namespace] = ACTIONS(1043),
    [anon_sym_use] = ACTIONS(1043),
    [anon_sym_BSLASH] = ACTIONS(1041),
    [anon_sym_function] = ACTIONS(1043),
    [anon_sym_const] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(1041),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_trait] = ACTIONS(1043),
    [anon_sym_interface] = ACTIONS(1043),
    [anon_sym_class] = ACTIONS(1043),
    [anon_sym_abstract] = ACTIONS(1043),
    [anon_sym_final] = ACTIONS(1043),
    [anon_sym_public] = ACTIONS(1043),
    [anon_sym_protected] = ACTIONS(1043),
    [anon_sym_private] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1041),
    [anon_sym_array] = ACTIONS(1043),
    [anon_sym_unset] = ACTIONS(1043),
    [anon_sym_echo] = ACTIONS(1043),
    [anon_sym_declare] = ACTIONS(1043),
    [anon_sym_enddeclare] = ACTIONS(1043),
    [sym_float] = ACTIONS(1043),
    [anon_sym_try] = ACTIONS(1043),
    [anon_sym_goto] = ACTIONS(1043),
    [anon_sym_continue] = ACTIONS(1043),
    [anon_sym_break] = ACTIONS(1043),
    [sym_integer] = ACTIONS(1043),
    [anon_sym_return] = ACTIONS(1043),
    [anon_sym_throw] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(1043),
    [anon_sym_endwhile] = ACTIONS(1043),
    [anon_sym_do] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(1043),
    [anon_sym_endfor] = ACTIONS(1043),
    [anon_sym_foreach] = ACTIONS(1043),
    [anon_sym_endforeach] = ACTIONS(1043),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_endif] = ACTIONS(1043),
    [anon_sym_elseif] = ACTIONS(1043),
    [anon_sym_else] = ACTIONS(1043),
    [anon_sym_switch] = ACTIONS(1043),
    [anon_sym_endswitch] = ACTIONS(1043),
    [anon_sym_case] = ACTIONS(1043),
    [anon_sym_default] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(1041),
    [anon_sym_PLUS] = ACTIONS(1043),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_TILDE] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1041),
    [anon_sym_clone] = ACTIONS(1043),
    [anon_sym_print] = ACTIONS(1043),
    [anon_sym_new] = ACTIONS(1043),
    [anon_sym_PLUS_PLUS] = ACTIONS(1041),
    [anon_sym_DASH_DASH] = ACTIONS(1041),
    [sym_shell_command_expression] = ACTIONS(1041),
    [anon_sym_list] = ACTIONS(1043),
    [anon_sym_self] = ACTIONS(1043),
    [anon_sym_parent] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(1041),
    [sym_string] = ACTIONS(1041),
    [sym_boolean] = ACTIONS(1043),
    [sym_null] = ACTIONS(1043),
    [anon_sym_DOLLAR] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(1043),
    [anon_sym_include] = ACTIONS(1043),
    [anon_sym_include_once] = ACTIONS(1043),
    [anon_sym_require] = ACTIONS(1043),
    [anon_sym_require_once] = ACTIONS(1043),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1041),
  },
  [324] = {
    [sym_text_interpolation] = STATE(324),
    [sym_name] = ACTIONS(1045),
    [anon_sym_QMARK_GT] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1045),
    [anon_sym_global] = ACTIONS(1045),
    [anon_sym_namespace] = ACTIONS(1045),
    [anon_sym_use] = ACTIONS(1045),
    [anon_sym_BSLASH] = ACTIONS(1047),
    [anon_sym_function] = ACTIONS(1045),
    [anon_sym_const] = ACTIONS(1045),
    [anon_sym_LBRACE] = ACTIONS(1047),
    [anon_sym_trait] = ACTIONS(1045),
    [anon_sym_interface] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1045),
    [anon_sym_abstract] = ACTIONS(1045),
    [anon_sym_final] = ACTIONS(1045),
    [anon_sym_public] = ACTIONS(1045),
    [anon_sym_protected] = ACTIONS(1045),
    [anon_sym_private] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1047),
    [anon_sym_array] = ACTIONS(1045),
    [anon_sym_unset] = ACTIONS(1045),
    [anon_sym_COLON] = ACTIONS(1047),
    [anon_sym_echo] = ACTIONS(1045),
    [anon_sym_declare] = ACTIONS(1045),
    [sym_float] = ACTIONS(1045),
    [anon_sym_try] = ACTIONS(1045),
    [anon_sym_goto] = ACTIONS(1045),
    [anon_sym_continue] = ACTIONS(1045),
    [anon_sym_break] = ACTIONS(1045),
    [sym_integer] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_throw] = ACTIONS(1045),
    [anon_sym_while] = ACTIONS(1045),
    [anon_sym_do] = ACTIONS(1045),
    [anon_sym_for] = ACTIONS(1045),
    [anon_sym_foreach] = ACTIONS(1045),
    [anon_sym_if] = ACTIONS(1045),
    [anon_sym_switch] = ACTIONS(1045),
    [anon_sym_AT] = ACTIONS(1047),
    [anon_sym_PLUS] = ACTIONS(1045),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_TILDE] = ACTIONS(1047),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_clone] = ACTIONS(1045),
    [anon_sym_print] = ACTIONS(1045),
    [anon_sym_new] = ACTIONS(1045),
    [anon_sym_PLUS_PLUS] = ACTIONS(1047),
    [anon_sym_DASH_DASH] = ACTIONS(1047),
    [sym_shell_command_expression] = ACTIONS(1047),
    [anon_sym_list] = ACTIONS(1045),
    [anon_sym_self] = ACTIONS(1045),
    [anon_sym_parent] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [sym_string] = ACTIONS(1047),
    [sym_boolean] = ACTIONS(1045),
    [sym_null] = ACTIONS(1045),
    [anon_sym_DOLLAR] = ACTIONS(1047),
    [anon_sym_yield] = ACTIONS(1045),
    [anon_sym_include] = ACTIONS(1045),
    [anon_sym_include_once] = ACTIONS(1045),
    [anon_sym_require] = ACTIONS(1045),
    [anon_sym_require_once] = ACTIONS(1045),
    [sym_comment] = ACTIONS(5),
    [sym_heredoc] = ACTIONS(1047),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(325), 1,
      sym_text_interpolation,
    ACTIONS(1051), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [74] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(326), 1,
      sym_text_interpolation,
    ACTIONS(1055), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1053), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [148] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(327), 1,
      sym_text_interpolation,
    ACTIONS(1059), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1057), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [222] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(328), 1,
      sym_text_interpolation,
    STATE(336), 1,
      sym_arguments,
    ACTIONS(1063), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1061), 37,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [299] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_EQ,
    STATE(329), 1,
      sym_text_interpolation,
    STATE(346), 1,
      sym_arguments,
    ACTIONS(1075), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1077), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1067), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1073), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [384] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(330), 1,
      sym_text_interpolation,
    STATE(339), 1,
      sym_arguments,
    ACTIONS(1081), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1079), 37,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [461] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(331), 1,
      sym_text_interpolation,
    STATE(342), 1,
      sym_arguments,
    ACTIONS(1085), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1083), 37,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [538] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1087), 1,
      anon_sym_EQ,
    STATE(332), 1,
      sym_text_interpolation,
    STATE(346), 1,
      sym_arguments,
    ACTIONS(1075), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1089), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1067), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1073), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [623] = 38,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(476), 1,
      anon_sym_static,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(480), 1,
      anon_sym_function,
    ACTIONS(486), 1,
      anon_sym_LPAREN,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(492), 1,
      anon_sym_AT,
    ACTIONS(498), 1,
      anon_sym_clone,
    ACTIONS(500), 1,
      anon_sym_print,
    ACTIONS(502), 1,
      anon_sym_new,
    ACTIONS(506), 1,
      sym_shell_command_expression,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    STATE(333), 1,
      sym_text_interpolation,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(431), 1,
      sym_class_constant_access_expression,
    STATE(440), 1,
      sym_qualified_name,
    STATE(491), 1,
      sym__unary_expression,
    STATE(889), 1,
      sym_namespace_name_as_prefix,
    STATE(902), 1,
      sym__dereferencable_expression,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    STATE(1393), 1,
      sym__scope_resolution_qualifier,
    ACTIONS(494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(496), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(508), 2,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(513), 2,
      sym_clone_expression,
      sym__primary_expression,
    STATE(347), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(405), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(520), 3,
      sym_unary_op_expression,
      sym_exponentiation_expression,
      sym_cast_expression,
    ACTIONS(490), 4,
      sym_float,
      sym_integer,
      sym_boolean,
      sym_null,
    STATE(545), 4,
      sym_print_intrinsic,
      sym_anonymous_function_creation_expression,
      sym_object_creation_expression,
      sym_update_expression,
    STATE(329), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [761] = 38,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(476), 1,
      anon_sym_static,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(480), 1,
      anon_sym_function,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(492), 1,
      anon_sym_AT,
    ACTIONS(498), 1,
      anon_sym_clone,
    ACTIONS(500), 1,
      anon_sym_print,
    ACTIONS(502), 1,
      anon_sym_new,
    ACTIONS(506), 1,
      sym_shell_command_expression,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(586), 1,
      anon_sym_LPAREN,
    STATE(334), 1,
      sym_text_interpolation,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(431), 1,
      sym_class_constant_access_expression,
    STATE(440), 1,
      sym_qualified_name,
    STATE(491), 1,
      sym__unary_expression,
    STATE(889), 1,
      sym_namespace_name_as_prefix,
    STATE(902), 1,
      sym__dereferencable_expression,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    STATE(1393), 1,
      sym__scope_resolution_qualifier,
    ACTIONS(494), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(496), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(508), 2,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(513), 2,
      sym_clone_expression,
      sym__primary_expression,
    STATE(377), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(405), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(520), 3,
      sym_unary_op_expression,
      sym_exponentiation_expression,
      sym_cast_expression,
    ACTIONS(490), 4,
      sym_float,
      sym_integer,
      sym_boolean,
      sym_null,
    STATE(545), 4,
      sym_print_intrinsic,
      sym_anonymous_function_creation_expression,
      sym_object_creation_expression,
      sym_update_expression,
    STATE(358), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [899] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(335), 1,
      sym_text_interpolation,
    ACTIONS(1093), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1091), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [971] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(336), 1,
      sym_text_interpolation,
    ACTIONS(1097), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1095), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1043] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(337), 1,
      sym_text_interpolation,
    ACTIONS(1101), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1099), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1115] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(338), 1,
      sym_text_interpolation,
    ACTIONS(1105), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1103), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1187] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(339), 1,
      sym_text_interpolation,
    ACTIONS(1109), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1107), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1259] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(340), 1,
      sym_text_interpolation,
    ACTIONS(1113), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1111), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1331] = 38,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(204), 1,
      anon_sym_LPAREN,
    ACTIONS(206), 1,
      anon_sym_array,
    ACTIONS(242), 1,
      anon_sym_AT,
    ACTIONS(248), 1,
      anon_sym_clone,
    ACTIONS(250), 1,
      anon_sym_print,
    ACTIONS(252), 1,
      anon_sym_new,
    ACTIONS(256), 1,
      sym_shell_command_expression,
    ACTIONS(262), 1,
      anon_sym_LBRACK,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(530), 1,
      anon_sym_static,
    ACTIONS(532), 1,
      anon_sym_function,
    STATE(341), 1,
      sym_text_interpolation,
    STATE(516), 1,
      sym_class_constant_access_expression,
    STATE(530), 1,
      sym__reserved_identifier,
    STATE(551), 1,
      sym_qualified_name,
    STATE(582), 1,
      sym__unary_expression,
    STATE(882), 1,
      sym_namespace_name_as_prefix,
    STATE(931), 1,
      sym__dereferencable_expression,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1360), 1,
      sym__scope_resolution_qualifier,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(244), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(246), 2,
      anon_sym_TILDE,
      anon_sym_BANG,
    ACTIONS(254), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(260), 2,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(264), 2,
      sym_heredoc,
      sym_string,
    STATE(568), 2,
      sym_clone_expression,
      sym__primary_expression,
    STATE(374), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(455), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(596), 3,
      sym_unary_op_expression,
      sym_exponentiation_expression,
      sym_cast_expression,
    ACTIONS(214), 4,
      sym_float,
      sym_integer,
      sym_boolean,
      sym_null,
    STATE(584), 4,
      sym_print_intrinsic,
      sym_anonymous_function_creation_expression,
      sym_object_creation_expression,
      sym_update_expression,
    STATE(350), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [1469] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(342), 1,
      sym_text_interpolation,
    ACTIONS(1117), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1115), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1541] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(343), 1,
      sym_text_interpolation,
    ACTIONS(1121), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1119), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1613] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(344), 1,
      sym_text_interpolation,
    ACTIONS(1125), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1123), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1685] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(345), 1,
      sym_text_interpolation,
    ACTIONS(1129), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1127), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1757] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(346), 1,
      sym_text_interpolation,
    ACTIONS(1133), 20,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1131), 38,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [1829] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_EQ,
    STATE(347), 1,
      sym_text_interpolation,
    ACTIONS(1075), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1077), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1067), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1073), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1908] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_EQ,
    STATE(348), 1,
      sym_text_interpolation,
    ACTIONS(1075), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1089), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1067), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1073), 19,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [1987] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_LPAREN,
    STATE(349), 1,
      sym_text_interpolation,
    STATE(359), 1,
      sym_arguments,
    ACTIONS(1081), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1079), 34,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2060] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_EQ,
    ACTIONS(1135), 1,
      anon_sym_LPAREN,
    STATE(350), 1,
      sym_text_interpolation,
    STATE(368), 1,
      sym_arguments,
    ACTIONS(1137), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1077), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1067), 16,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1073), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2141] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_COMMA,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1087), 1,
      anon_sym_EQ,
    ACTIONS(1139), 1,
      anon_sym_RPAREN,
    STATE(346), 1,
      sym_arguments,
    STATE(351), 1,
      sym_text_interpolation,
    STATE(1075), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(1075), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1089), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1067), 13,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1073), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2228] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_LPAREN,
    STATE(352), 1,
      sym_text_interpolation,
    STATE(360), 1,
      sym_arguments,
    ACTIONS(1063), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1061), 34,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2301] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_EQ,
    STATE(353), 1,
      sym_text_interpolation,
    STATE(368), 1,
      sym_arguments,
    ACTIONS(1137), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1143), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1067), 16,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1073), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2382] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_LPAREN,
    STATE(354), 1,
      sym_text_interpolation,
    STATE(365), 1,
      sym_arguments,
    ACTIONS(1085), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1083), 34,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2455] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(355), 1,
      sym_text_interpolation,
    ACTIONS(1129), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1127), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2523] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(356), 1,
      sym_text_interpolation,
    ACTIONS(1093), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1091), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2591] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(357), 1,
      sym_text_interpolation,
    ACTIONS(1059), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1057), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2659] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_EQ,
    STATE(346), 1,
      sym_arguments,
    STATE(358), 1,
      sym_text_interpolation,
    ACTIONS(1075), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1067), 13,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1077), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1073), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [2739] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(359), 1,
      sym_text_interpolation,
    ACTIONS(1109), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1107), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2807] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(360), 1,
      sym_text_interpolation,
    ACTIONS(1097), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1095), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2875] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(361), 1,
      sym_text_interpolation,
    ACTIONS(1105), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1103), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [2943] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(362), 1,
      sym_text_interpolation,
    ACTIONS(1101), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1099), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3011] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(363), 1,
      sym_text_interpolation,
    ACTIONS(1125), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1123), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3079] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1087), 1,
      anon_sym_EQ,
    STATE(346), 1,
      sym_arguments,
    STATE(364), 1,
      sym_text_interpolation,
    ACTIONS(1075), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1145), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1089), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1067), 13,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1073), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3161] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(365), 1,
      sym_text_interpolation,
    ACTIONS(1117), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1115), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3229] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(366), 1,
      sym_text_interpolation,
    ACTIONS(1055), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1053), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3297] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(367), 1,
      sym_text_interpolation,
    ACTIONS(1121), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1119), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3365] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(368), 1,
      sym_text_interpolation,
    ACTIONS(1133), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1131), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3433] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(369), 1,
      sym_text_interpolation,
    ACTIONS(1113), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1111), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3501] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(370), 1,
      sym_text_interpolation,
    ACTIONS(1051), 19,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1049), 35,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_COLON_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [3569] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_COMMA,
    ACTIONS(1087), 1,
      anon_sym_EQ,
    ACTIONS(1139), 1,
      anon_sym_RPAREN,
    STATE(371), 1,
      sym_text_interpolation,
    STATE(1075), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(1075), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1089), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1067), 13,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1073), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3650] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(372), 1,
      sym_text_interpolation,
    ACTIONS(695), 12,
      anon_sym_final,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(693), 41,
      anon_sym_SEMI,
      anon_sym_static,
      anon_sym_COMMA,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_abstract,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_while,
      anon_sym_EQ_GT,
      anon_sym_elseif,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [3717] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(373), 1,
      sym_text_interpolation,
    ACTIONS(683), 12,
      anon_sym_final,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(681), 41,
      anon_sym_SEMI,
      anon_sym_static,
      anon_sym_COMMA,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_abstract,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_while,
      anon_sym_EQ_GT,
      anon_sym_elseif,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [3784] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_EQ,
    STATE(374), 1,
      sym_text_interpolation,
    ACTIONS(1137), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1077), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1067), 16,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1073), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3859] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1141), 1,
      anon_sym_EQ,
    STATE(375), 1,
      sym_text_interpolation,
    ACTIONS(1137), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1143), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1067), 16,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1073), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [3934] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_EQ,
    STATE(376), 1,
      sym_text_interpolation,
    ACTIONS(1075), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1145), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1089), 12,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1067), 13,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1073), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4010] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_EQ,
    STATE(377), 1,
      sym_text_interpolation,
    ACTIONS(1075), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1067), 13,
      anon_sym_EQ_GT,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1077), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_STAR_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DOT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1073), 18,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
  [4084] = 34,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(206), 1,
      anon_sym_array,
    ACTIONS(248), 1,
      anon_sym_clone,
    ACTIONS(250), 1,
      anon_sym_print,
    ACTIONS(252), 1,
      anon_sym_new,
    ACTIONS(256), 1,
      sym_shell_command_expression,
    ACTIONS(262), 1,
      anon_sym_LBRACK,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(530), 1,
      anon_sym_static,
    ACTIONS(532), 1,
      anon_sym_function,
    ACTIONS(1147), 1,
      anon_sym_LPAREN,
    STATE(378), 1,
      sym_text_interpolation,
    STATE(516), 1,
      sym_class_constant_access_expression,
    STATE(530), 1,
      sym__reserved_identifier,
    STATE(551), 1,
      sym_qualified_name,
    STATE(586), 1,
      sym_exponentiation_expression,
    STATE(882), 1,
      sym_namespace_name_as_prefix,
    STATE(931), 1,
      sym__dereferencable_expression,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1360), 1,
      sym__scope_resolution_qualifier,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(254), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(260), 2,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(264), 2,
      sym_heredoc,
      sym_string,
    STATE(587), 2,
      sym_clone_expression,
      sym__primary_expression,
    STATE(455), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(464), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    ACTIONS(214), 4,
      sym_float,
      sym_integer,
      sym_boolean,
      sym_null,
    STATE(584), 4,
      sym_print_intrinsic,
      sym_anonymous_function_creation_expression,
      sym_object_creation_expression,
      sym_update_expression,
    STATE(430), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [4206] = 34,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(476), 1,
      anon_sym_static,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(480), 1,
      anon_sym_function,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(498), 1,
      anon_sym_clone,
    ACTIONS(500), 1,
      anon_sym_print,
    ACTIONS(502), 1,
      anon_sym_new,
    ACTIONS(506), 1,
      sym_shell_command_expression,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1149), 1,
      anon_sym_LPAREN,
    STATE(379), 1,
      sym_text_interpolation,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(431), 1,
      sym_class_constant_access_expression,
    STATE(440), 1,
      sym_qualified_name,
    STATE(502), 1,
      sym_exponentiation_expression,
    STATE(889), 1,
      sym_namespace_name_as_prefix,
    STATE(902), 1,
      sym__dereferencable_expression,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    STATE(1393), 1,
      sym__scope_resolution_qualifier,
    ACTIONS(504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(508), 2,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(521), 2,
      sym_clone_expression,
      sym__primary_expression,
    STATE(390), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(405), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    ACTIONS(490), 4,
      sym_float,
      sym_integer,
      sym_boolean,
      sym_null,
    STATE(545), 4,
      sym_print_intrinsic,
      sym_anonymous_function_creation_expression,
      sym_object_creation_expression,
      sym_update_expression,
    STATE(383), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [4328] = 32,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(206), 1,
      anon_sym_array,
    ACTIONS(250), 1,
      anon_sym_print,
    ACTIONS(252), 1,
      anon_sym_new,
    ACTIONS(256), 1,
      sym_shell_command_expression,
    ACTIONS(262), 1,
      anon_sym_LBRACK,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(530), 1,
      anon_sym_static,
    ACTIONS(532), 1,
      anon_sym_function,
    ACTIONS(1147), 1,
      anon_sym_LPAREN,
    STATE(380), 1,
      sym_text_interpolation,
    STATE(516), 1,
      sym_class_constant_access_expression,
    STATE(530), 1,
      sym__reserved_identifier,
    STATE(551), 1,
      sym_qualified_name,
    STATE(609), 1,
      sym__primary_expression,
    STATE(882), 1,
      sym_namespace_name_as_prefix,
    STATE(931), 1,
      sym__dereferencable_expression,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1360), 1,
      sym__scope_resolution_qualifier,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(254), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(260), 2,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(264), 2,
      sym_heredoc,
      sym_string,
    STATE(455), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(464), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    ACTIONS(214), 4,
      sym_float,
      sym_integer,
      sym_boolean,
      sym_null,
    STATE(584), 4,
      sym_print_intrinsic,
      sym_anonymous_function_creation_expression,
      sym_object_creation_expression,
      sym_update_expression,
    STATE(430), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [4443] = 32,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(476), 1,
      anon_sym_static,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(480), 1,
      anon_sym_function,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(500), 1,
      anon_sym_print,
    ACTIONS(502), 1,
      anon_sym_new,
    ACTIONS(506), 1,
      sym_shell_command_expression,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1149), 1,
      anon_sym_LPAREN,
    STATE(381), 1,
      sym_text_interpolation,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(431), 1,
      sym_class_constant_access_expression,
    STATE(440), 1,
      sym_qualified_name,
    STATE(529), 1,
      sym__primary_expression,
    STATE(889), 1,
      sym_namespace_name_as_prefix,
    STATE(902), 1,
      sym__dereferencable_expression,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    STATE(1393), 1,
      sym__scope_resolution_qualifier,
    ACTIONS(504), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(508), 2,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(390), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(405), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    ACTIONS(490), 4,
      sym_float,
      sym_integer,
      sym_boolean,
      sym_null,
    STATE(545), 4,
      sym_print_intrinsic,
      sym_anonymous_function_creation_expression,
      sym_object_creation_expression,
      sym_update_expression,
    STATE(383), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [4558] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(346), 1,
      sym_arguments,
    STATE(382), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1069), 13,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1077), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [4624] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(346), 1,
      sym_arguments,
    STATE(383), 1,
      sym_text_interpolation,
    ACTIONS(1075), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1073), 13,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1067), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [4692] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(342), 1,
      sym_arguments,
    STATE(384), 1,
      sym_text_interpolation,
    ACTIONS(1153), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1151), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_insteadof,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [4755] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1157), 1,
      anon_sym_BSLASH,
    STATE(385), 1,
      sym_text_interpolation,
    STATE(1308), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1160), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1155), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_implements,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [4818] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1087), 1,
      anon_sym_EQ,
    STATE(346), 1,
      sym_arguments,
    STATE(386), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1073), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1067), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [4885] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(387), 1,
      sym_text_interpolation,
    ACTIONS(1164), 13,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1162), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [4943] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(342), 1,
      sym_arguments,
    STATE(388), 1,
      sym_text_interpolation,
    ACTIONS(1085), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1083), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5005] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_LPAREN,
    STATE(389), 1,
      sym_text_interpolation,
    STATE(537), 1,
      sym_arguments,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1168), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1166), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5069] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(390), 1,
      sym_text_interpolation,
    ACTIONS(1075), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1073), 13,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1067), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5131] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(391), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1069), 13,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1077), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5191] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_LPAREN,
    STATE(392), 1,
      sym_text_interpolation,
    STATE(417), 1,
      sym_arguments,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1168), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1166), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5255] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_LPAREN,
    STATE(393), 1,
      sym_text_interpolation,
    STATE(424), 1,
      sym_arguments,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1174), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1172), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5319] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(394), 1,
      sym_text_interpolation,
    ACTIONS(1178), 13,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1176), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5377] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(336), 1,
      sym_arguments,
    STATE(395), 1,
      sym_text_interpolation,
    ACTIONS(1063), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1061), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5439] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(396), 1,
      sym_text_interpolation,
    ACTIONS(1182), 13,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1180), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5497] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(339), 1,
      sym_arguments,
    STATE(397), 1,
      sym_text_interpolation,
    ACTIONS(1081), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1079), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5559] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(346), 1,
      sym_arguments,
    STATE(398), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1186), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1184), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5623] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_LPAREN,
    STATE(399), 1,
      sym_text_interpolation,
    STATE(410), 1,
      sym_arguments,
    ACTIONS(1063), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1061), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5685] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_LPAREN,
    STATE(400), 1,
      sym_text_interpolation,
    STATE(413), 1,
      sym_arguments,
    ACTIONS(1081), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1079), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5747] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_LPAREN,
    STATE(401), 1,
      sym_text_interpolation,
    STATE(415), 1,
      sym_arguments,
    ACTIONS(1085), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1083), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5809] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(336), 1,
      sym_arguments,
    STATE(402), 1,
      sym_text_interpolation,
    ACTIONS(1063), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1061), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5869] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(339), 1,
      sym_arguments,
    STATE(403), 1,
      sym_text_interpolation,
    ACTIONS(1081), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1079), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5929] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_LPAREN,
    STATE(404), 1,
      sym_text_interpolation,
    STATE(424), 1,
      sym_arguments,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1069), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1077), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [5993] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(346), 1,
      sym_arguments,
    STATE(405), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1073), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1067), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6057] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(342), 1,
      sym_arguments,
    STATE(406), 1,
      sym_text_interpolation,
    ACTIONS(1085), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1083), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6117] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(407), 1,
      sym_text_interpolation,
    ACTIONS(1190), 13,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1188), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6175] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(408), 1,
      sym_text_interpolation,
    ACTIONS(1194), 13,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1192), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6233] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(409), 1,
      sym_text_interpolation,
    ACTIONS(1101), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1099), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6290] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(410), 1,
      sym_text_interpolation,
    ACTIONS(1097), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1095), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6347] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(411), 1,
      sym_text_interpolation,
    ACTIONS(1198), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1196), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6404] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(412), 1,
      sym_text_interpolation,
    ACTIONS(1051), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1049), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6461] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(413), 1,
      sym_text_interpolation,
    ACTIONS(1109), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1107), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6518] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(414), 1,
      sym_text_interpolation,
    ACTIONS(1113), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1111), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6575] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(415), 1,
      sym_text_interpolation,
    ACTIONS(1117), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1115), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6632] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(416), 1,
      sym_text_interpolation,
    ACTIONS(1055), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1053), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6689] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(417), 1,
      sym_text_interpolation,
    ACTIONS(1131), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1202), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1200), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6748] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(418), 1,
      sym_text_interpolation,
    ACTIONS(1160), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1155), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_implements,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6805] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(419), 1,
      sym_text_interpolation,
    ACTIONS(1121), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1119), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6862] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(420), 1,
      sym_text_interpolation,
    ACTIONS(1105), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1103), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6919] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(421), 1,
      sym_text_interpolation,
    ACTIONS(1059), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1057), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [6976] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(422), 1,
      sym_text_interpolation,
    ACTIONS(1045), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1047), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7033] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(423), 1,
      sym_text_interpolation,
    ACTIONS(1206), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1204), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_implements,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK,
      anon_sym_DOLLAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7090] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(424), 1,
      sym_text_interpolation,
    ACTIONS(1133), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1131), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7147] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(425), 1,
      sym_text_interpolation,
    ACTIONS(1129), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1127), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7204] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(426), 1,
      sym_text_interpolation,
    ACTIONS(1125), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1123), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7261] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(427), 1,
      sym_text_interpolation,
    ACTIONS(1093), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1091), 31,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7318] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(428), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1069), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1077), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7376] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(429), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1174), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1172), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7434] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_LPAREN,
    STATE(368), 1,
      sym_arguments,
    STATE(430), 1,
      sym_text_interpolation,
    ACTIONS(1137), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1073), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1067), 22,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7498] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(431), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1073), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1067), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7556] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_LPAREN,
    STATE(368), 1,
      sym_arguments,
    STATE(432), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1069), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1077), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7618] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(433), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1186), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1184), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7676] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    STATE(346), 1,
      sym_arguments,
    STATE(434), 1,
      sym_text_interpolation,
    ACTIONS(1186), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1184), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7737] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    STATE(417), 1,
      sym_arguments,
    STATE(435), 1,
      sym_text_interpolation,
    ACTIONS(1168), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1166), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7798] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1210), 1,
      anon_sym_function,
    ACTIONS(1212), 1,
      anon_sym_COLON_COLON,
    STATE(436), 1,
      sym_text_interpolation,
    ACTIONS(1093), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1091), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7857] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_EQ,
    STATE(368), 1,
      sym_arguments,
    STATE(437), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1073), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1067), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7920] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(438), 1,
      sym_text_interpolation,
    ACTIONS(717), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(715), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_while,
      anon_sym_EQ_GT,
      anon_sym_elseif,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [7975] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(439), 1,
      sym_text_interpolation,
    ACTIONS(727), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(725), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_while,
      anon_sym_EQ_GT,
      anon_sym_elseif,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8030] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    STATE(346), 1,
      sym_arguments,
    STATE(440), 1,
      sym_text_interpolation,
    ACTIONS(1073), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1067), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8091] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1214), 1,
      anon_sym_LPAREN,
    STATE(441), 1,
      sym_text_interpolation,
    STATE(475), 1,
      sym_arguments,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1168), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1166), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8151] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(442), 1,
      sym_text_interpolation,
    ACTIONS(1178), 12,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1176), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8205] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1214), 1,
      anon_sym_LPAREN,
    STATE(443), 1,
      sym_text_interpolation,
    STATE(477), 1,
      sym_arguments,
    ACTIONS(1085), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1083), 27,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8263] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(444), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1069), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1077), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8319] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1157), 1,
      anon_sym_BSLASH,
    STATE(445), 1,
      sym_text_interpolation,
    STATE(1308), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1160), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1155), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8377] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(446), 1,
      sym_text_interpolation,
    ACTIONS(1164), 12,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1162), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8431] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_LPAREN,
    STATE(365), 1,
      sym_arguments,
    STATE(447), 1,
      sym_text_interpolation,
    ACTIONS(1153), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1151), 27,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8489] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1212), 1,
      anon_sym_COLON_COLON,
    STATE(448), 1,
      sym_text_interpolation,
    ACTIONS(1093), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1091), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8545] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(336), 1,
      sym_arguments,
    STATE(449), 1,
      sym_text_interpolation,
    ACTIONS(1063), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1061), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8601] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(450), 1,
      sym_text_interpolation,
    ACTIONS(1093), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1091), 29,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8655] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1214), 1,
      anon_sym_LPAREN,
    STATE(451), 1,
      sym_text_interpolation,
    STATE(595), 1,
      sym_arguments,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1168), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1166), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8715] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1214), 1,
      anon_sym_LPAREN,
    STATE(452), 1,
      sym_text_interpolation,
    STATE(474), 1,
      sym_arguments,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1069), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1077), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8775] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(453), 1,
      sym_text_interpolation,
    ACTIONS(1190), 12,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1188), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8829] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1214), 1,
      anon_sym_LPAREN,
    STATE(454), 1,
      sym_text_interpolation,
    STATE(467), 1,
      sym_arguments,
    ACTIONS(1081), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1079), 27,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8887] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_LPAREN,
    STATE(368), 1,
      sym_arguments,
    STATE(455), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1073), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1067), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [8947] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(456), 1,
      sym_text_interpolation,
    ACTIONS(1182), 12,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1180), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9001] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(346), 1,
      sym_arguments,
    STATE(457), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1186), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1184), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9061] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(339), 1,
      sym_arguments,
    STATE(458), 1,
      sym_text_interpolation,
    ACTIONS(1081), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1079), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9117] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(342), 1,
      sym_arguments,
    STATE(459), 1,
      sym_text_interpolation,
    ACTIONS(1085), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1083), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9173] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(342), 1,
      sym_arguments,
    STATE(460), 1,
      sym_text_interpolation,
    ACTIONS(1085), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1083), 27,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9231] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(339), 1,
      sym_arguments,
    STATE(461), 1,
      sym_text_interpolation,
    ACTIONS(1081), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1079), 27,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9289] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(336), 1,
      sym_arguments,
    STATE(462), 1,
      sym_text_interpolation,
    ACTIONS(1063), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1061), 27,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9347] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1214), 1,
      anon_sym_LPAREN,
    STATE(463), 1,
      sym_text_interpolation,
    STATE(474), 1,
      sym_arguments,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1174), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1172), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9407] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(464), 1,
      sym_text_interpolation,
    ACTIONS(1137), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1073), 12,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1067), 22,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9465] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1214), 1,
      anon_sym_LPAREN,
    STATE(465), 1,
      sym_text_interpolation,
    STATE(481), 1,
      sym_arguments,
    ACTIONS(1063), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1061), 27,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9523] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(466), 1,
      sym_text_interpolation,
    ACTIONS(1194), 12,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1192), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9577] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(467), 1,
      sym_text_interpolation,
    ACTIONS(1109), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1107), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9630] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(468), 1,
      sym_text_interpolation,
    ACTIONS(1129), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1127), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9683] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(469), 1,
      sym_text_interpolation,
    ACTIONS(1121), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1119), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9736] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(470), 1,
      sym_text_interpolation,
    ACTIONS(1105), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1103), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9789] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(471), 1,
      sym_text_interpolation,
    ACTIONS(1125), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1123), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9842] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(472), 1,
      sym_text_interpolation,
    ACTIONS(1059), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1057), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9895] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(473), 1,
      sym_text_interpolation,
    ACTIONS(1055), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1053), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [9948] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(474), 1,
      sym_text_interpolation,
    ACTIONS(1133), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1131), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10001] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(475), 1,
      sym_text_interpolation,
    ACTIONS(1131), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1202), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1200), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10056] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(476), 1,
      sym_text_interpolation,
    ACTIONS(1198), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1196), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10109] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(477), 1,
      sym_text_interpolation,
    ACTIONS(1117), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1115), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10162] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(478), 1,
      sym_text_interpolation,
    ACTIONS(1113), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1111), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10215] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(479), 1,
      sym_text_interpolation,
    ACTIONS(1051), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1049), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10268] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(480), 1,
      sym_text_interpolation,
    ACTIONS(1101), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1099), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10321] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(481), 1,
      sym_text_interpolation,
    ACTIONS(1097), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1095), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10374] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(482), 1,
      sym_text_interpolation,
    ACTIONS(1045), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1047), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10427] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1220), 1,
      anon_sym_QMARK,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    STATE(483), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1216), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [10507] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    STATE(484), 1,
      sym_text_interpolation,
    ACTIONS(1186), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [10579] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    STATE(485), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1248), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [10659] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    STATE(486), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1252), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [10739] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(487), 1,
      sym_text_interpolation,
    ACTIONS(1206), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1204), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10791] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(488), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1254), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [10877] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(489), 1,
      sym_text_interpolation,
    ACTIONS(1264), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1262), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10929] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(490), 1,
      sym_text_interpolation,
    ACTIONS(1268), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1266), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [10981] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(491), 1,
      sym_text_interpolation,
    ACTIONS(1272), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1270), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11033] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(492), 1,
      sym_text_interpolation,
    ACTIONS(1276), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1274), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11085] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(493), 1,
      sym_text_interpolation,
    ACTIONS(1280), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1278), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11137] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1284), 1,
      anon_sym_EQ_GT,
    STATE(494), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1282), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [11225] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1288), 1,
      anon_sym_QMARK,
    STATE(495), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1286), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [11305] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    STATE(496), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1290), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [11385] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(497), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1292), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [11471] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(498), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1174), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1172), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11525] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(499), 1,
      sym_text_interpolation,
    ACTIONS(1296), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1294), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11577] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(500), 1,
      sym_text_interpolation,
    ACTIONS(1300), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1298), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11629] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(501), 1,
      sym_text_interpolation,
    ACTIONS(1304), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1302), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11681] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(502), 1,
      sym_text_interpolation,
    ACTIONS(1308), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1306), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11733] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(503), 1,
      sym_text_interpolation,
    ACTIONS(1186), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1184), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11785] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1212), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1310), 1,
      anon_sym_function,
    ACTIONS(1312), 1,
      anon_sym_DOLLAR,
    STATE(504), 1,
      sym_text_interpolation,
    STATE(892), 1,
      sym_variable_name,
    STATE(915), 1,
      sym_static_variable_declaration,
    ACTIONS(1093), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1091), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11847] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    STATE(505), 1,
      sym_text_interpolation,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1186), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1184), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [11905] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(506), 1,
      sym_text_interpolation,
    ACTIONS(1316), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1314), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [11957] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(507), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1318), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [12043] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(508), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1186), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1184), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12097] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    STATE(509), 1,
      sym_text_interpolation,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1186), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1184), 22,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [12157] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    STATE(510), 1,
      sym_text_interpolation,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1186), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1184), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [12221] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1322), 1,
      anon_sym_QMARK,
    STATE(511), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1320), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [12301] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(512), 1,
      sym_text_interpolation,
    ACTIONS(1326), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1324), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12353] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1332), 1,
      anon_sym_STAR_STAR,
    STATE(513), 1,
      sym_text_interpolation,
    ACTIONS(1330), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1328), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12407] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(514), 1,
      sym_text_interpolation,
    ACTIONS(1336), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1334), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12459] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    STATE(515), 1,
      sym_text_interpolation,
    ACTIONS(1186), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [12529] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(516), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1073), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1067), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12583] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(517), 1,
      sym_text_interpolation,
    ACTIONS(1340), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1338), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12635] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(518), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1342), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [12721] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(519), 1,
      sym_text_interpolation,
    ACTIONS(1346), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1344), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12773] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(520), 1,
      sym_text_interpolation,
    ACTIONS(1330), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1328), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12825] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1332), 1,
      anon_sym_STAR_STAR,
    STATE(521), 1,
      sym_text_interpolation,
    ACTIONS(1308), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1306), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12879] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1212), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1310), 1,
      anon_sym_function,
    ACTIONS(1312), 1,
      anon_sym_DOLLAR,
    STATE(522), 1,
      sym_text_interpolation,
    STATE(892), 1,
      sym_variable_name,
    STATE(903), 1,
      sym_static_variable_declaration,
    ACTIONS(1093), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1091), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [12941] = 16,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1186), 1,
      anon_sym_QMARK,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    STATE(523), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [13015] = 17,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1186), 1,
      anon_sym_QMARK,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    STATE(524), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
  [13091] = 20,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    STATE(525), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [13173] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(526), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token2,
  [13257] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    STATE(527), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [13337] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1348), 1,
      anon_sym_instanceof,
    STATE(528), 1,
      sym_text_interpolation,
    ACTIONS(1276), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1274), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13391] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(529), 1,
      sym_text_interpolation,
    ACTIONS(1352), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1350), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13443] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(530), 1,
      sym_text_interpolation,
    ACTIONS(1160), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1155), 28,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13495] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(531), 1,
      sym_text_interpolation,
    ACTIONS(1356), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1354), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13547] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    STATE(532), 1,
      sym_text_interpolation,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1186), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1184), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [13603] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(533), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1354), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [13689] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(534), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1358), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [13775] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    STATE(535), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1186), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [13843] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(536), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1360), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [13929] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(537), 1,
      sym_text_interpolation,
    ACTIONS(1202), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1200), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [13981] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(538), 1,
      sym_text_interpolation,
    ACTIONS(1364), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1362), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14033] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(539), 1,
      sym_text_interpolation,
    ACTIONS(1174), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1172), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14085] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(540), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1366), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [14171] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(541), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
    ACTIONS(1069), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1077), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14225] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(542), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1368), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [14311] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(543), 1,
      sym_text_interpolation,
    ACTIONS(1372), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1370), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14363] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1246), 1,
      anon_sym_PERCENT,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(544), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1244), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1374), 10,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
  [14449] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(545), 1,
      sym_text_interpolation,
    ACTIONS(1073), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1067), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14501] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1212), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1310), 1,
      anon_sym_function,
    STATE(546), 1,
      sym_text_interpolation,
    ACTIONS(1093), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1091), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14556] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(547), 1,
      sym_text_interpolation,
    ACTIONS(717), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(715), 26,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_while,
      anon_sym_EQ_GT,
      anon_sym_elseif,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14607] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(548), 1,
      sym_text_interpolation,
    ACTIONS(727), 11,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(725), 26,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_while,
      anon_sym_EQ_GT,
      anon_sym_elseif,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14658] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1157), 1,
      anon_sym_BSLASH,
    ACTIONS(1376), 1,
      anon_sym_COLON,
    STATE(549), 1,
      sym_text_interpolation,
    STATE(1308), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1160), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1155), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14715] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1157), 1,
      anon_sym_BSLASH,
    ACTIONS(1378), 1,
      anon_sym_COLON,
    STATE(550), 1,
      sym_text_interpolation,
    STATE(1308), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1160), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1155), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_COLON_COLON,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14772] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    STATE(368), 1,
      sym_arguments,
    STATE(551), 1,
      sym_text_interpolation,
    ACTIONS(1073), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1067), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14829] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    STATE(346), 1,
      sym_arguments,
    STATE(552), 1,
      sym_text_interpolation,
    ACTIONS(1186), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1184), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14886] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1214), 1,
      anon_sym_LPAREN,
    STATE(475), 1,
      sym_arguments,
    STATE(553), 1,
      sym_text_interpolation,
    ACTIONS(1168), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1166), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14943] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1212), 1,
      anon_sym_COLON_COLON,
    STATE(554), 1,
      sym_text_interpolation,
    ACTIONS(1093), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1091), 25,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [14995] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1380), 1,
      sym_name,
    ACTIONS(1382), 1,
      anon_sym_RBRACE,
    ACTIONS(1384), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(555), 1,
      sym_text_interpolation,
    STATE(557), 1,
      aux_sym_use_list_repeat1,
    STATE(819), 1,
      sym_class_constant_access_expression,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(974), 1,
      sym__dereferencable_expression,
    STATE(1055), 1,
      sym_qualified_name,
    STATE(1331), 1,
      sym__scope_resolution_qualifier,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(1286), 2,
      sym_use_instead_of_clause,
      sym_use_as_clause,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(959), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(812), 9,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_array_creation_expression,
      sym__string,
      sym_dynamic_variable_name,
      sym_variable_name,
  [15085] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1386), 1,
      sym_name,
    ACTIONS(1392), 1,
      anon_sym_namespace,
    ACTIONS(1395), 1,
      anon_sym_BSLASH,
    ACTIONS(1398), 1,
      anon_sym_RBRACE,
    ACTIONS(1400), 1,
      anon_sym_LPAREN,
    ACTIONS(1403), 1,
      anon_sym_array,
    ACTIONS(1406), 1,
      anon_sym_LBRACK,
    ACTIONS(1412), 1,
      anon_sym_DOLLAR,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(819), 1,
      sym_class_constant_access_expression,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(974), 1,
      sym__dereferencable_expression,
    STATE(1055), 1,
      sym_qualified_name,
    STATE(1331), 1,
      sym__scope_resolution_qualifier,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(1409), 2,
      sym_heredoc,
      sym_string,
    STATE(556), 2,
      sym_text_interpolation,
      aux_sym_use_list_repeat1,
    STATE(1286), 2,
      sym_use_instead_of_clause,
      sym_use_as_clause,
    ACTIONS(1389), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(959), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(812), 9,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_array_creation_expression,
      sym__string,
      sym_dynamic_variable_name,
      sym_variable_name,
  [15173] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1380), 1,
      sym_name,
    ACTIONS(1384), 1,
      anon_sym_LPAREN,
    ACTIONS(1415), 1,
      anon_sym_RBRACE,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(556), 1,
      aux_sym_use_list_repeat1,
    STATE(557), 1,
      sym_text_interpolation,
    STATE(819), 1,
      sym_class_constant_access_expression,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(974), 1,
      sym__dereferencable_expression,
    STATE(1055), 1,
      sym_qualified_name,
    STATE(1331), 1,
      sym__scope_resolution_qualifier,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(1286), 2,
      sym_use_instead_of_clause,
      sym_use_as_clause,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(959), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(812), 9,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_array_creation_expression,
      sym__string,
      sym_dynamic_variable_name,
      sym_variable_name,
  [15263] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1220), 1,
      anon_sym_QMARK,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    STATE(558), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1216), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [15339] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    STATE(559), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1252), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [15415] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(560), 1,
      sym_text_interpolation,
    ACTIONS(1268), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1266), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15463] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(561), 1,
      sym_text_interpolation,
    ACTIONS(1346), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1344), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15511] = 17,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1186), 1,
      anon_sym_QMARK,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    STATE(562), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 11,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
  [15583] = 16,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1186), 1,
      anon_sym_QMARK,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    STATE(563), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 12,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [15653] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    STATE(564), 1,
      sym_text_interpolation,
    ACTIONS(1186), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 12,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [15721] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(565), 1,
      sym_text_interpolation,
    ACTIONS(1296), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1294), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15769] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(566), 1,
      sym_text_interpolation,
    ACTIONS(1364), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1362), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15817] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(567), 1,
      sym_text_interpolation,
    ACTIONS(1300), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1298), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15865] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    STATE(568), 1,
      sym_text_interpolation,
    ACTIONS(1330), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1328), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [15915] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    STATE(569), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1290), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [15991] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1288), 1,
      anon_sym_QMARK,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    STATE(570), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1286), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [16067] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(571), 1,
      sym_text_interpolation,
    ACTIONS(1340), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1338), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16115] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    STATE(572), 1,
      sym_text_interpolation,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1186), 5,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1184), 17,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [16175] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    STATE(573), 1,
      sym_text_interpolation,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1186), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1184), 18,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
  [16231] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    STATE(574), 1,
      sym_text_interpolation,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1186), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1184), 20,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [16285] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(575), 1,
      sym_text_interpolation,
    ACTIONS(1186), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1184), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16333] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(576), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1318), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [16415] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(577), 1,
      sym_text_interpolation,
    ACTIONS(1316), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1314), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16463] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(578), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1254), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [16545] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(258), 1,
      anon_sym_list,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1384), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(579), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(959), 1,
      sym_class_constant_access_expression,
    STATE(974), 1,
      sym__dereferencable_expression,
    STATE(1055), 1,
      sym_qualified_name,
    STATE(1276), 1,
      sym_list_literal,
    STATE(1331), 1,
      sym__scope_resolution_qualifier,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(811), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(812), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(777), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [16633] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(580), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1368), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [16715] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1455), 1,
      anon_sym_EQ_GT,
    STATE(581), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1282), 5,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [16799] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(582), 1,
      sym_text_interpolation,
    ACTIONS(1272), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1270), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16847] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(583), 1,
      sym_text_interpolation,
    ACTIONS(1372), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1370), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16895] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(584), 1,
      sym_text_interpolation,
    ACTIONS(1073), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1067), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [16943] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    STATE(585), 1,
      sym_text_interpolation,
    ACTIONS(1186), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 13,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [17009] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(586), 1,
      sym_text_interpolation,
    ACTIONS(1308), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1306), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17057] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    STATE(587), 1,
      sym_text_interpolation,
    ACTIONS(1308), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1306), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17107] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(588), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1374), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [17189] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    STATE(589), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1248), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [17265] = 20,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    STATE(590), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 8,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [17343] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(591), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1366), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [17425] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(592), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1342), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [17507] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(593), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 7,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token2,
  [17587] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1322), 1,
      anon_sym_QMARK,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    STATE(594), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1320), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [17663] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(595), 1,
      sym_text_interpolation,
    ACTIONS(1202), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1200), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17711] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(596), 1,
      sym_text_interpolation,
    ACTIONS(1330), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1328), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17759] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(597), 1,
      sym_text_interpolation,
    ACTIONS(1326), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1324), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17807] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(598), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1358), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [17889] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(599), 1,
      sym_text_interpolation,
    ACTIONS(1336), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1334), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [17937] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(600), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1292), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [18019] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    STATE(601), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 9,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
  [18095] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(602), 1,
      sym_text_interpolation,
    ACTIONS(1174), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1172), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18143] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    STATE(603), 1,
      sym_text_interpolation,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1186), 8,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1184), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
  [18195] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    STATE(604), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1186), 3,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1184), 13,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [18259] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(605), 1,
      sym_text_interpolation,
    ACTIONS(1276), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1274), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18307] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(606), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1354), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [18389] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(607), 1,
      sym_text_interpolation,
    ACTIONS(1264), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1262), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18437] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(608), 1,
      sym_text_interpolation,
    ACTIONS(683), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(681), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18485] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(609), 1,
      sym_text_interpolation,
    ACTIONS(1352), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1350), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18533] = 25,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(258), 1,
      anon_sym_list,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1384), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(610), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(959), 1,
      sym_class_constant_access_expression,
    STATE(974), 1,
      sym__dereferencable_expression,
    STATE(1050), 1,
      sym_list_literal,
    STATE(1055), 1,
      sym_qualified_name,
    STATE(1331), 1,
      sym__scope_resolution_qualifier,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(787), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(812), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(753), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [18621] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_instanceof,
    STATE(611), 1,
      sym_text_interpolation,
    ACTIONS(1276), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1274), 23,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18671] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(612), 1,
      sym_text_interpolation,
    ACTIONS(1356), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1354), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18719] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(613), 1,
      sym_text_interpolation,
    ACTIONS(1280), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1278), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18767] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(614), 1,
      sym_text_interpolation,
    ACTIONS(695), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(693), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18815] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1443), 1,
      anon_sym_PERCENT,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(615), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1441), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
    ACTIONS(1360), 6,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
  [18897] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(616), 1,
      sym_text_interpolation,
    ACTIONS(1304), 10,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1302), 24,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR_STAR,
      anon_sym_instanceof,
      anon_sym_QMARK_QMARK,
      aux_sym_binary_expression_token1,
      aux_sym_binary_expression_token2,
      aux_sym_binary_expression_token3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
      anon_sym_PERCENT,
  [18945] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(1384), 1,
      anon_sym_LPAREN,
    ACTIONS(1459), 1,
      anon_sym_class,
    ACTIONS(1461), 1,
      anon_sym_DOLLAR,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(435), 1,
      sym_qualified_name,
    STATE(617), 1,
      sym_text_interpolation,
    STATE(889), 1,
      sym_namespace_name_as_prefix,
    STATE(963), 1,
      sym__dereferencable_expression,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1337), 1,
      sym__scope_resolution_qualifier,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(389), 2,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(959), 2,
      sym_class_constant_access_expression,
      sym_cast_variable,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(392), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(812), 6,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_array_creation_expression,
      sym__string,
  [19030] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(1384), 1,
      anon_sym_LPAREN,
    ACTIONS(1463), 1,
      anon_sym_class,
    ACTIONS(1465), 1,
      anon_sym_DOLLAR,
    STATE(530), 1,
      sym__reserved_identifier,
    STATE(553), 1,
      sym_qualified_name,
    STATE(618), 1,
      sym_text_interpolation,
    STATE(882), 1,
      sym_namespace_name_as_prefix,
    STATE(906), 1,
      sym__dereferencable_expression,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1356), 1,
      sym__scope_resolution_qualifier,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(451), 2,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(959), 2,
      sym_class_constant_access_expression,
      sym_cast_variable,
    ACTIONS(260), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(441), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(812), 6,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_array_creation_expression,
      sym__string,
  [19115] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1384), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(619), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(959), 1,
      sym_class_constant_access_expression,
    STATE(974), 1,
      sym__dereferencable_expression,
    STATE(1055), 1,
      sym_qualified_name,
    STATE(1331), 1,
      sym__scope_resolution_qualifier,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(391), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(812), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(382), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [19197] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(1461), 1,
      anon_sym_DOLLAR,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(620), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(959), 1,
      sym_class_constant_access_expression,
    STATE(969), 1,
      sym__dereferencable_expression,
    STATE(1125), 1,
      sym_qualified_name,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1335), 1,
      sym__scope_resolution_qualifier,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(429), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(802), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(393), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [19279] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1149), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(621), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(902), 1,
      sym__dereferencable_expression,
    STATE(959), 1,
      sym_class_constant_access_expression,
    STATE(1055), 1,
      sym_qualified_name,
    STATE(1331), 1,
      sym__scope_resolution_qualifier,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(391), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(812), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(382), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [19361] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(1461), 1,
      anon_sym_DOLLAR,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(622), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(959), 1,
      sym_class_constant_access_expression,
    STATE(969), 1,
      sym__dereferencable_expression,
    STATE(1125), 1,
      sym_qualified_name,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1335), 1,
      sym__scope_resolution_qualifier,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(428), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(802), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(404), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [19443] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1384), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(623), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(959), 1,
      sym_class_constant_access_expression,
    STATE(974), 1,
      sym__dereferencable_expression,
    STATE(1055), 1,
      sym_qualified_name,
    STATE(1331), 1,
      sym__scope_resolution_qualifier,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(783), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(812), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(750), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [19525] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1384), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(624), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(959), 1,
      sym_class_constant_access_expression,
    STATE(974), 1,
      sym__dereferencable_expression,
    STATE(1055), 1,
      sym_qualified_name,
    STATE(1331), 1,
      sym__scope_resolution_qualifier,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(784), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(812), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(754), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [19607] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(1465), 1,
      anon_sym_DOLLAR,
    ACTIONS(1469), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(625), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(939), 1,
      sym__dereferencable_expression,
    STATE(959), 1,
      sym_class_constant_access_expression,
    STATE(1060), 1,
      sym_qualified_name,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1343), 1,
      sym__scope_resolution_qualifier,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(541), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(815), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(452), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [19689] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(1471), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(626), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(931), 1,
      sym__dereferencable_expression,
    STATE(959), 1,
      sym_class_constant_access_expression,
    STATE(981), 1,
      sym_qualified_name,
    STATE(1324), 1,
      sym__scope_resolution_qualifier,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(444), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(808), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(432), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [19771] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1384), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(627), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(959), 1,
      sym_class_constant_access_expression,
    STATE(974), 1,
      sym__dereferencable_expression,
    STATE(1055), 1,
      sym_qualified_name,
    STATE(1331), 1,
      sym__scope_resolution_qualifier,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(790), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(812), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(778), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [19853] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(1384), 1,
      anon_sym_LPAREN,
    ACTIONS(1465), 1,
      anon_sym_DOLLAR,
    STATE(530), 1,
      sym__reserved_identifier,
    STATE(552), 1,
      sym_qualified_name,
    STATE(628), 1,
      sym_text_interpolation,
    STATE(882), 1,
      sym_namespace_name_as_prefix,
    STATE(972), 1,
      sym__dereferencable_expression,
    STATE(1330), 1,
      sym__scope_resolution_qualifier,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(508), 2,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(959), 2,
      sym_class_constant_access_expression,
      sym_cast_variable,
    ACTIONS(260), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(457), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(812), 6,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_array_creation_expression,
      sym__string,
  [19935] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(1384), 1,
      anon_sym_LPAREN,
    ACTIONS(1461), 1,
      anon_sym_DOLLAR,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(434), 1,
      sym_qualified_name,
    STATE(629), 1,
      sym_text_interpolation,
    STATE(889), 1,
      sym_namespace_name_as_prefix,
    STATE(976), 1,
      sym__dereferencable_expression,
    STATE(1326), 1,
      sym__scope_resolution_qualifier,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    STATE(433), 2,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(959), 2,
      sym_class_constant_access_expression,
      sym_cast_variable,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(398), 3,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
    STATE(812), 6,
      sym_parenthesized_expression,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_array_creation_expression,
      sym__string,
  [20017] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(488), 1,
      anon_sym_array,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(1465), 1,
      anon_sym_DOLLAR,
    ACTIONS(1469), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(630), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(939), 1,
      sym__dereferencable_expression,
    STATE(959), 1,
      sym_class_constant_access_expression,
    STATE(1060), 1,
      sym_qualified_name,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1343), 1,
      sym__scope_resolution_qualifier,
    STATE(1361), 1,
      sym_relative_scope,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(508), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(498), 3,
      sym_cast_variable,
      sym_member_access_expression,
      sym_scoped_property_access_expression,
    STATE(815), 3,
      sym_parenthesized_expression,
      sym_array_creation_expression,
      sym__string,
    STATE(463), 6,
      sym_function_call_expression,
      sym_scoped_call_expression,
      sym_member_call_expression,
      sym_subscript_expression,
      sym_dynamic_variable_name,
      sym_variable_name,
  [20099] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1475), 1,
      anon_sym_COMMA,
    STATE(631), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1473), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20180] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1477), 1,
      anon_sym_COMMA,
    ACTIONS(1479), 1,
      anon_sym_RPAREN,
    STATE(632), 1,
      sym_text_interpolation,
    STATE(1062), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20263] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1441), 1,
      anon_sym_SLASH,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1481), 1,
      anon_sym_COMMA,
    STATE(633), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1443), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1473), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20344] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1477), 1,
      anon_sym_COMMA,
    ACTIONS(1483), 1,
      anon_sym_RPAREN,
    STATE(634), 1,
      sym_text_interpolation,
    STATE(1037), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20427] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1477), 1,
      anon_sym_COMMA,
    ACTIONS(1485), 1,
      anon_sym_RPAREN,
    STATE(635), 1,
      sym_text_interpolation,
    STATE(1059), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20510] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1441), 1,
      anon_sym_SLASH,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(636), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1443), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1487), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20589] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1441), 1,
      anon_sym_SLASH,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(637), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1443), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1489), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20668] = 24,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1477), 1,
      anon_sym_COMMA,
    ACTIONS(1491), 1,
      anon_sym_RPAREN,
    STATE(638), 1,
      sym_text_interpolation,
    STATE(1102), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20751] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1441), 1,
      anon_sym_SLASH,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(639), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1443), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1493), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20830] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1441), 1,
      anon_sym_SLASH,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1481), 1,
      anon_sym_COMMA,
    STATE(640), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1443), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1495), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20911] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1475), 1,
      anon_sym_COMMA,
    STATE(641), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1495), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [20992] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(642), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1497), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21070] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(643), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1499), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21148] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1441), 1,
      anon_sym_SLASH,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(644), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1443), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1501), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21226] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1441), 1,
      anon_sym_SLASH,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(645), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1443), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1503), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21304] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1441), 1,
      anon_sym_SLASH,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(646), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1443), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1505), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21382] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1441), 1,
      anon_sym_SLASH,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(647), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1443), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1507), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21460] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1441), 1,
      anon_sym_SLASH,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(648), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1443), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1509), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21538] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1441), 1,
      anon_sym_SLASH,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(649), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1443), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1511), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21616] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1441), 1,
      anon_sym_SLASH,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(650), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1443), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1513), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21694] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(651), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1515), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21772] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1441), 1,
      anon_sym_SLASH,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(652), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1443), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1517), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21850] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(653), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1519), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [21928] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1441), 1,
      anon_sym_SLASH,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(654), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1443), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1521), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22006] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(655), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1523), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22084] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1525), 1,
      anon_sym_RPAREN,
    ACTIONS(1527), 1,
      anon_sym_EQ_GT,
    STATE(656), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22164] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(657), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1529), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22242] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    STATE(658), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1531), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22320] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1417), 1,
      anon_sym_AMP,
    ACTIONS(1421), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1423), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1425), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1427), 1,
      anon_sym_PIPE,
    ACTIONS(1429), 1,
      anon_sym_CARET,
    ACTIONS(1437), 1,
      anon_sym_GT_EQ,
    ACTIONS(1441), 1,
      anon_sym_SLASH,
    ACTIONS(1445), 1,
      anon_sym_QMARK,
    ACTIONS(1449), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1451), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1453), 1,
      aux_sym_binary_expression_token3,
    STATE(659), 1,
      sym_text_interpolation,
    ACTIONS(1431), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1439), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1443), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1533), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1419), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1435), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1433), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22398] = 23,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1527), 1,
      anon_sym_EQ_GT,
    ACTIONS(1535), 1,
      anon_sym_RPAREN,
    STATE(660), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22478] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1537), 1,
      anon_sym_RBRACE,
    STATE(661), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22555] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1539), 1,
      anon_sym_RBRACE,
    STATE(662), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22632] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1541), 1,
      anon_sym_as,
    STATE(663), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22709] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1543), 1,
      anon_sym_RBRACE,
    STATE(664), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22786] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1545), 1,
      anon_sym_RBRACE,
    STATE(665), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [22863] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(1547), 1,
      sym_name,
    ACTIONS(1551), 1,
      anon_sym_AMP,
    ACTIONS(1553), 1,
      anon_sym_RPAREN,
    ACTIONS(1555), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1557), 1,
      anon_sym_QMARK,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    STATE(666), 1,
      sym_text_interpolation,
    STATE(854), 1,
      sym_namespace_name_as_prefix,
    STATE(955), 1,
      sym__type,
    STATE(975), 1,
      sym_qualified_name,
    STATE(1018), 1,
      sym__reserved_identifier,
    STATE(1051), 1,
      sym_variable_name,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(949), 2,
      sym_optional_type,
      sym_primitive_type,
    STATE(1141), 2,
      sym_simple_parameter,
      sym_variadic_parameter,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1559), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [22938] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1563), 1,
      anon_sym_RBRACE,
    STATE(667), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23015] = 21,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(1547), 1,
      sym_name,
    ACTIONS(1551), 1,
      anon_sym_AMP,
    ACTIONS(1555), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1557), 1,
      anon_sym_QMARK,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    ACTIONS(1565), 1,
      anon_sym_RPAREN,
    STATE(668), 1,
      sym_text_interpolation,
    STATE(854), 1,
      sym_namespace_name_as_prefix,
    STATE(955), 1,
      sym__type,
    STATE(975), 1,
      sym_qualified_name,
    STATE(1018), 1,
      sym__reserved_identifier,
    STATE(1051), 1,
      sym_variable_name,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(949), 2,
      sym_optional_type,
      sym_primitive_type,
    STATE(1087), 2,
      sym_simple_parameter,
      sym_variadic_parameter,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1559), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [23090] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1567), 1,
      anon_sym_RPAREN,
    STATE(669), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23167] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1569), 1,
      anon_sym_RPAREN,
    STATE(670), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23244] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1571), 1,
      anon_sym_RBRACE,
    STATE(671), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23321] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1573), 1,
      anon_sym_RBRACE,
    STATE(672), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23398] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1575), 1,
      anon_sym_RBRACE,
    STATE(673), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23475] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1577), 1,
      anon_sym_RBRACE,
    STATE(674), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23552] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1579), 1,
      anon_sym_EQ_GT,
    STATE(675), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23629] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1575), 1,
      anon_sym_RBRACK,
    STATE(676), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23706] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1581), 1,
      anon_sym_RBRACE,
    STATE(677), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23783] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1583), 1,
      anon_sym_RPAREN,
    STATE(678), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23860] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1585), 1,
      anon_sym_COLON,
    STATE(679), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [23937] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1587), 1,
      anon_sym_RBRACE,
    STATE(680), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24014] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1589), 1,
      anon_sym_RBRACK,
    STATE(681), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24091] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1591), 1,
      anon_sym_RBRACE,
    STATE(682), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24168] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1589), 1,
      anon_sym_RBRACE,
    STATE(683), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24245] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1593), 1,
      anon_sym_as,
    STATE(684), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24322] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1539), 1,
      anon_sym_RBRACK,
    STATE(685), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24399] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1591), 1,
      anon_sym_RBRACK,
    STATE(686), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24476] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1595), 1,
      anon_sym_RPAREN,
    STATE(687), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24553] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1597), 1,
      anon_sym_RBRACE,
    STATE(688), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24630] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1599), 1,
      anon_sym_COLON,
    STATE(689), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24707] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1601), 1,
      anon_sym_RBRACE,
    STATE(690), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24784] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1603), 1,
      anon_sym_RPAREN,
    STATE(691), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24861] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1605), 1,
      anon_sym_EQ_GT,
    STATE(692), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [24938] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1607), 1,
      anon_sym_RBRACE,
    STATE(693), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [25015] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1609), 1,
      anon_sym_RBRACE,
    STATE(694), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [25092] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1611), 1,
      anon_sym_RBRACE,
    STATE(695), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [25169] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1613), 1,
      anon_sym_RBRACE,
    STATE(696), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [25246] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1615), 1,
      anon_sym_RBRACE,
    STATE(697), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [25323] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1617), 1,
      anon_sym_RPAREN,
    STATE(698), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [25400] = 22,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1218), 1,
      anon_sym_AMP,
    ACTIONS(1224), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1226), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1228), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1230), 1,
      anon_sym_PIPE,
    ACTIONS(1232), 1,
      anon_sym_CARET,
    ACTIONS(1240), 1,
      anon_sym_GT_EQ,
    ACTIONS(1244), 1,
      anon_sym_SLASH,
    ACTIONS(1250), 1,
      anon_sym_QMARK,
    ACTIONS(1256), 1,
      aux_sym_binary_expression_token1,
    ACTIONS(1258), 1,
      aux_sym_binary_expression_token2,
    ACTIONS(1260), 1,
      aux_sym_binary_expression_token3,
    ACTIONS(1619), 1,
      anon_sym_RPAREN,
    STATE(699), 1,
      sym_text_interpolation,
    ACTIONS(1234), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1242), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1246), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1222), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_DOT,
    ACTIONS(1238), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_EQ,
    ACTIONS(1236), 4,
      anon_sym_LT_GT,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_LT_EQ_GT,
  [25477] = 20,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(1547), 1,
      sym_name,
    ACTIONS(1551), 1,
      anon_sym_AMP,
    ACTIONS(1555), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1557), 1,
      anon_sym_QMARK,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    STATE(700), 1,
      sym_text_interpolation,
    STATE(854), 1,
      sym_namespace_name_as_prefix,
    STATE(955), 1,
      sym__type,
    STATE(975), 1,
      sym_qualified_name,
    STATE(1018), 1,
      sym__reserved_identifier,
    STATE(1051), 1,
      sym_variable_name,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(949), 2,
      sym_optional_type,
      sym_primitive_type,
    STATE(1255), 2,
      sym_simple_parameter,
      sym_variadic_parameter,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1559), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [25549] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1621), 1,
      anon_sym_static,
    ACTIONS(1623), 1,
      anon_sym_use,
    ACTIONS(1625), 1,
      anon_sym_function,
    ACTIONS(1627), 1,
      anon_sym_const,
    ACTIONS(1629), 1,
      anon_sym_RBRACE,
    ACTIONS(1633), 1,
      sym_var_modifier,
    STATE(701), 1,
      sym_text_interpolation,
    STATE(708), 1,
      aux_sym_declaration_list_repeat1,
    STATE(715), 1,
      aux_sym_property_declaration_repeat1,
    STATE(726), 1,
      sym__member_declaration,
    STATE(741), 1,
      sym_visibility_modifier,
    STATE(758), 1,
      sym__modifier,
    STATE(940), 1,
      sym__function_definition_header,
    ACTIONS(1631), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(761), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1635), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(727), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [25614] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1621), 1,
      anon_sym_static,
    ACTIONS(1623), 1,
      anon_sym_use,
    ACTIONS(1625), 1,
      anon_sym_function,
    ACTIONS(1627), 1,
      anon_sym_const,
    ACTIONS(1633), 1,
      sym_var_modifier,
    ACTIONS(1637), 1,
      anon_sym_RBRACE,
    STATE(702), 1,
      sym_text_interpolation,
    STATE(707), 1,
      aux_sym_declaration_list_repeat1,
    STATE(715), 1,
      aux_sym_property_declaration_repeat1,
    STATE(726), 1,
      sym__member_declaration,
    STATE(741), 1,
      sym_visibility_modifier,
    STATE(758), 1,
      sym__modifier,
    STATE(940), 1,
      sym__function_definition_header,
    ACTIONS(1631), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(761), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1635), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(727), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [25679] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1621), 1,
      anon_sym_static,
    ACTIONS(1623), 1,
      anon_sym_use,
    ACTIONS(1625), 1,
      anon_sym_function,
    ACTIONS(1627), 1,
      anon_sym_const,
    ACTIONS(1633), 1,
      sym_var_modifier,
    ACTIONS(1639), 1,
      anon_sym_RBRACE,
    STATE(703), 1,
      sym_text_interpolation,
    STATE(704), 1,
      aux_sym_declaration_list_repeat1,
    STATE(715), 1,
      aux_sym_property_declaration_repeat1,
    STATE(726), 1,
      sym__member_declaration,
    STATE(741), 1,
      sym_visibility_modifier,
    STATE(758), 1,
      sym__modifier,
    STATE(940), 1,
      sym__function_definition_header,
    ACTIONS(1631), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(761), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1635), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(727), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [25744] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1621), 1,
      anon_sym_static,
    ACTIONS(1623), 1,
      anon_sym_use,
    ACTIONS(1625), 1,
      anon_sym_function,
    ACTIONS(1627), 1,
      anon_sym_const,
    ACTIONS(1633), 1,
      sym_var_modifier,
    ACTIONS(1641), 1,
      anon_sym_RBRACE,
    STATE(704), 1,
      sym_text_interpolation,
    STATE(706), 1,
      aux_sym_declaration_list_repeat1,
    STATE(715), 1,
      aux_sym_property_declaration_repeat1,
    STATE(726), 1,
      sym__member_declaration,
    STATE(741), 1,
      sym_visibility_modifier,
    STATE(758), 1,
      sym__modifier,
    STATE(940), 1,
      sym__function_definition_header,
    ACTIONS(1631), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(761), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1635), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(727), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [25809] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1621), 1,
      anon_sym_static,
    ACTIONS(1623), 1,
      anon_sym_use,
    ACTIONS(1625), 1,
      anon_sym_function,
    ACTIONS(1627), 1,
      anon_sym_const,
    ACTIONS(1633), 1,
      sym_var_modifier,
    ACTIONS(1643), 1,
      anon_sym_RBRACE,
    STATE(705), 1,
      sym_text_interpolation,
    STATE(709), 1,
      aux_sym_declaration_list_repeat1,
    STATE(715), 1,
      aux_sym_property_declaration_repeat1,
    STATE(726), 1,
      sym__member_declaration,
    STATE(741), 1,
      sym_visibility_modifier,
    STATE(758), 1,
      sym__modifier,
    STATE(940), 1,
      sym__function_definition_header,
    ACTIONS(1631), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(761), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1635), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(727), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [25874] = 18,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_static,
    ACTIONS(1648), 1,
      anon_sym_use,
    ACTIONS(1651), 1,
      anon_sym_function,
    ACTIONS(1654), 1,
      anon_sym_const,
    ACTIONS(1657), 1,
      anon_sym_RBRACE,
    ACTIONS(1662), 1,
      sym_var_modifier,
    STATE(715), 1,
      aux_sym_property_declaration_repeat1,
    STATE(726), 1,
      sym__member_declaration,
    STATE(741), 1,
      sym_visibility_modifier,
    STATE(758), 1,
      sym__modifier,
    STATE(940), 1,
      sym__function_definition_header,
    ACTIONS(1659), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(706), 2,
      sym_text_interpolation,
      aux_sym_declaration_list_repeat1,
    STATE(761), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1665), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(727), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [25937] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1621), 1,
      anon_sym_static,
    ACTIONS(1623), 1,
      anon_sym_use,
    ACTIONS(1625), 1,
      anon_sym_function,
    ACTIONS(1627), 1,
      anon_sym_const,
    ACTIONS(1633), 1,
      sym_var_modifier,
    ACTIONS(1668), 1,
      anon_sym_RBRACE,
    STATE(706), 1,
      aux_sym_declaration_list_repeat1,
    STATE(707), 1,
      sym_text_interpolation,
    STATE(715), 1,
      aux_sym_property_declaration_repeat1,
    STATE(726), 1,
      sym__member_declaration,
    STATE(741), 1,
      sym_visibility_modifier,
    STATE(758), 1,
      sym__modifier,
    STATE(940), 1,
      sym__function_definition_header,
    ACTIONS(1631), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(761), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1635), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(727), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [26002] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1621), 1,
      anon_sym_static,
    ACTIONS(1623), 1,
      anon_sym_use,
    ACTIONS(1625), 1,
      anon_sym_function,
    ACTIONS(1627), 1,
      anon_sym_const,
    ACTIONS(1633), 1,
      sym_var_modifier,
    ACTIONS(1670), 1,
      anon_sym_RBRACE,
    STATE(706), 1,
      aux_sym_declaration_list_repeat1,
    STATE(708), 1,
      sym_text_interpolation,
    STATE(715), 1,
      aux_sym_property_declaration_repeat1,
    STATE(726), 1,
      sym__member_declaration,
    STATE(741), 1,
      sym_visibility_modifier,
    STATE(758), 1,
      sym__modifier,
    STATE(940), 1,
      sym__function_definition_header,
    ACTIONS(1631), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(761), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1635), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(727), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [26067] = 19,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1621), 1,
      anon_sym_static,
    ACTIONS(1623), 1,
      anon_sym_use,
    ACTIONS(1625), 1,
      anon_sym_function,
    ACTIONS(1627), 1,
      anon_sym_const,
    ACTIONS(1633), 1,
      sym_var_modifier,
    ACTIONS(1672), 1,
      anon_sym_RBRACE,
    STATE(706), 1,
      aux_sym_declaration_list_repeat1,
    STATE(709), 1,
      sym_text_interpolation,
    STATE(715), 1,
      aux_sym_property_declaration_repeat1,
    STATE(726), 1,
      sym__member_declaration,
    STATE(741), 1,
      sym_visibility_modifier,
    STATE(758), 1,
      sym__modifier,
    STATE(940), 1,
      sym__function_definition_header,
    ACTIONS(1631), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(761), 2,
      sym_class_modifier,
      sym_static_modifier,
    ACTIONS(1635), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(727), 4,
      sym_const_declaration,
      sym_property_declaration,
      sym_method_declaration,
      sym_use_declaration,
  [26132] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(1676), 1,
      anon_sym_QMARK,
    STATE(530), 1,
      sym__reserved_identifier,
    STATE(710), 1,
      sym_text_interpolation,
    STATE(882), 1,
      sym_namespace_name_as_prefix,
    STATE(1088), 1,
      sym__type,
    STATE(1136), 1,
      sym_qualified_name,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1135), 2,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1674), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1678), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [26188] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(1680), 1,
      anon_sym_QMARK,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(711), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(975), 1,
      sym_qualified_name,
    STATE(1333), 1,
      sym_namespace_name,
    STATE(1415), 1,
      sym__type,
    STATE(949), 2,
      sym_optional_type,
      sym_primitive_type,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1559), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [26244] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    STATE(530), 1,
      sym__reserved_identifier,
    STATE(712), 1,
      sym_text_interpolation,
    STATE(882), 1,
      sym_namespace_name_as_prefix,
    STATE(1090), 1,
      sym_primitive_type,
    STATE(1091), 1,
      sym_qualified_name,
    STATE(1333), 1,
      sym_namespace_name,
    ACTIONS(1674), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1678), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [26293] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(713), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(929), 1,
      sym_primitive_type,
    STATE(970), 1,
      sym_qualified_name,
    STATE(1333), 1,
      sym_namespace_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1559), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [26342] = 13,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(1547), 1,
      sym_name,
    STATE(714), 1,
      sym_text_interpolation,
    STATE(854), 1,
      sym_namespace_name_as_prefix,
    STATE(929), 1,
      sym_primitive_type,
    STATE(970), 1,
      sym_qualified_name,
    STATE(1018), 1,
      sym__reserved_identifier,
    STATE(1333), 1,
      sym_namespace_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    ACTIONS(1559), 8,
      anon_sym_array,
      anon_sym_callable,
      anon_sym_iterable,
      anon_sym_bool,
      anon_sym_float,
      anon_sym_int,
      anon_sym_string,
      anon_sym_void,
  [26391] = 15,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1312), 1,
      anon_sym_DOLLAR,
    ACTIONS(1621), 1,
      anon_sym_static,
    ACTIONS(1625), 1,
      anon_sym_function,
    ACTIONS(1633), 1,
      sym_var_modifier,
    STATE(715), 1,
      sym_text_interpolation,
    STATE(721), 1,
      aux_sym_property_declaration_repeat1,
    STATE(758), 1,
      sym__modifier,
    STATE(873), 1,
      sym_variable_name,
    STATE(927), 1,
      sym__function_definition_header,
    STATE(928), 1,
      sym_property_element,
    ACTIONS(1631), 2,
      anon_sym_abstract,
      anon_sym_final,
    ACTIONS(1635), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(761), 3,
      sym_class_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
  [26442] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(871), 1,
      anon_sym_else,
    STATE(716), 1,
      sym_text_interpolation,
    ACTIONS(869), 13,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_while,
      anon_sym_elseif,
  [26470] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(1682), 1,
      anon_sym_BSLASH,
    STATE(530), 1,
      sym__reserved_identifier,
    STATE(717), 1,
      sym_text_interpolation,
    STATE(732), 1,
      sym_namespace_function_or_const,
    STATE(882), 1,
      sym_namespace_name_as_prefix,
    STATE(886), 1,
      sym_qualified_name,
    STATE(899), 1,
      sym_namespace_use_clause,
    STATE(1387), 1,
      sym_namespace_name,
    ACTIONS(1684), 2,
      anon_sym_function,
      anon_sym_const,
    ACTIONS(1674), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26516] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(795), 1,
      anon_sym_else,
    STATE(718), 1,
      sym_text_interpolation,
    ACTIONS(793), 13,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_while,
      anon_sym_elseif,
  [26544] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(719), 1,
      sym_text_interpolation,
    ACTIONS(1091), 14,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_implements,
      anon_sym_insteadof,
      anon_sym_AMP,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_DOLLAR,
  [26570] = 14,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(1686), 1,
      anon_sym_BSLASH,
    STATE(530), 1,
      sym__reserved_identifier,
    STATE(720), 1,
      sym_text_interpolation,
    STATE(729), 1,
      sym_namespace_function_or_const,
    STATE(882), 1,
      sym_namespace_name_as_prefix,
    STATE(886), 1,
      sym_qualified_name,
    STATE(917), 1,
      sym_namespace_use_clause,
    STATE(1378), 1,
      sym_namespace_name,
    ACTIONS(1684), 2,
      anon_sym_function,
      anon_sym_const,
    ACTIONS(1674), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26616] = 10,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1688), 1,
      anon_sym_static,
    ACTIONS(1696), 1,
      sym_var_modifier,
    STATE(758), 1,
      sym__modifier,
    ACTIONS(1691), 2,
      anon_sym_function,
      anon_sym_DOLLAR,
    ACTIONS(1693), 2,
      anon_sym_abstract,
      anon_sym_final,
    STATE(721), 2,
      sym_text_interpolation,
      aux_sym_property_declaration_repeat1,
    ACTIONS(1699), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
    STATE(761), 3,
      sym_class_modifier,
      sym_static_modifier,
      sym_visibility_modifier,
  [26654] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(811), 1,
      anon_sym_else,
    STATE(722), 1,
      sym_text_interpolation,
    ACTIONS(809), 13,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_while,
      anon_sym_elseif,
  [26682] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(723), 1,
      sym_text_interpolation,
    ACTIONS(1702), 6,
      anon_sym_static,
      anon_sym_namespace,
      anon_sym_array,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
    ACTIONS(1398), 7,
      sym_heredoc,
      anon_sym_BSLASH,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      sym_string,
      anon_sym_DOLLAR,
  [26709] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(724), 1,
      sym_text_interpolation,
    ACTIONS(1704), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26732] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(725), 1,
      sym_text_interpolation,
    ACTIONS(1706), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26755] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(726), 1,
      sym_text_interpolation,
    ACTIONS(1708), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26778] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(727), 1,
      sym_text_interpolation,
    ACTIONS(1710), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26801] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(728), 1,
      sym_text_interpolation,
    ACTIONS(1712), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26824] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(1714), 1,
      anon_sym_BSLASH,
    STATE(530), 1,
      sym__reserved_identifier,
    STATE(729), 1,
      sym_text_interpolation,
    STATE(882), 1,
      sym_namespace_name_as_prefix,
    STATE(886), 1,
      sym_qualified_name,
    STATE(966), 1,
      sym_namespace_use_clause,
    STATE(1388), 1,
      sym_namespace_name,
    ACTIONS(1674), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26863] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(730), 1,
      sym_text_interpolation,
    ACTIONS(1716), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26886] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    STATE(530), 1,
      sym__reserved_identifier,
    STATE(731), 1,
      sym_text_interpolation,
    STATE(882), 1,
      sym_namespace_name_as_prefix,
    STATE(886), 1,
      sym_qualified_name,
    STATE(1086), 1,
      sym_namespace_use_clause,
    STATE(1333), 1,
      sym_namespace_name,
    ACTIONS(1674), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26925] = 12,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    ACTIONS(1718), 1,
      anon_sym_BSLASH,
    STATE(530), 1,
      sym__reserved_identifier,
    STATE(732), 1,
      sym_text_interpolation,
    STATE(882), 1,
      sym_namespace_name_as_prefix,
    STATE(886), 1,
      sym_qualified_name,
    STATE(943), 1,
      sym_namespace_use_clause,
    STATE(1392), 1,
      sym_namespace_name,
    ACTIONS(1674), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [26964] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(733), 1,
      sym_text_interpolation,
    ACTIONS(1720), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [26987] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(734), 1,
      sym_text_interpolation,
    ACTIONS(1722), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [27010] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(735), 1,
      sym_text_interpolation,
    ACTIONS(1724), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [27033] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(736), 1,
      sym_text_interpolation,
    ACTIONS(1726), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [27056] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(737), 1,
      sym_text_interpolation,
    ACTIONS(1728), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [27079] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(738), 1,
      sym_text_interpolation,
    ACTIONS(1730), 11,
      anon_sym_static,
      anon_sym_use,
      anon_sym_function,
      anon_sym_const,
      anon_sym_RBRACE,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [27102] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(739), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(1024), 1,
      sym_qualified_name,
    STATE(1333), 1,
      sym_namespace_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27138] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(740), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(1266), 1,
      sym_qualified_name,
    STATE(1333), 1,
      sym_namespace_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27174] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1734), 1,
      anon_sym_const,
    STATE(741), 1,
      sym_text_interpolation,
    ACTIONS(1732), 9,
      anon_sym_static,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_DOLLAR,
  [27198] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    STATE(530), 1,
      sym__reserved_identifier,
    STATE(742), 1,
      sym_text_interpolation,
    STATE(882), 1,
      sym_namespace_name_as_prefix,
    STATE(913), 1,
      sym_qualified_name,
    STATE(1333), 1,
      sym_namespace_name,
    ACTIONS(1674), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27234] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(743), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(1163), 1,
      sym_qualified_name,
    STATE(1333), 1,
      sym_namespace_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27270] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(744), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(1069), 1,
      sym_qualified_name,
    STATE(1333), 1,
      sym_namespace_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27306] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(478), 1,
      anon_sym_namespace,
    ACTIONS(528), 1,
      sym_name,
    STATE(530), 1,
      sym__reserved_identifier,
    STATE(745), 1,
      sym_text_interpolation,
    STATE(801), 1,
      sym_qualified_name,
    STATE(882), 1,
      sym_namespace_name_as_prefix,
    STATE(1333), 1,
      sym_namespace_name,
    ACTIONS(1674), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27342] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(746), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(1179), 1,
      sym_qualified_name,
    STATE(1333), 1,
      sym_namespace_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27378] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(747), 1,
      sym_text_interpolation,
    ACTIONS(1736), 10,
      anon_sym_static,
      anon_sym_function,
      anon_sym_const,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_DOLLAR,
  [27400] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(748), 1,
      sym_text_interpolation,
    ACTIONS(1738), 10,
      anon_sym_static,
      anon_sym_function,
      anon_sym_class,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_DOLLAR,
  [27422] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(186), 1,
      anon_sym_BSLASH,
    ACTIONS(472), 1,
      sym_name,
    ACTIONS(478), 1,
      anon_sym_namespace,
    STATE(418), 1,
      sym__reserved_identifier,
    STATE(749), 1,
      sym_text_interpolation,
    STATE(868), 1,
      sym_namespace_name_as_prefix,
    STATE(1211), 1,
      sym_qualified_name,
    STATE(1333), 1,
      sym_namespace_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27458] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1740), 1,
      anon_sym_COMMA,
    ACTIONS(1742), 1,
      anon_sym_RPAREN,
    STATE(346), 1,
      sym_arguments,
    STATE(750), 1,
      sym_text_interpolation,
    STATE(1107), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [27489] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1744), 1,
      sym_name,
    ACTIONS(1748), 1,
      anon_sym_LBRACE,
    STATE(751), 1,
      sym_text_interpolation,
    ACTIONS(1746), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(330), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [27518] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1750), 1,
      sym_name,
    ACTIONS(1754), 1,
      anon_sym_LBRACE,
    STATE(384), 1,
      sym__reserved_identifier,
    STATE(752), 1,
      sym_text_interpolation,
    STATE(331), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1752), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27549] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_COMMA,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1756), 1,
      anon_sym_RPAREN,
    STATE(346), 1,
      sym_arguments,
    STATE(753), 1,
      sym_text_interpolation,
    STATE(1053), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [27580] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1740), 1,
      anon_sym_COMMA,
    ACTIONS(1758), 1,
      anon_sym_RPAREN,
    STATE(346), 1,
      sym_arguments,
    STATE(754), 1,
      sym_text_interpolation,
    STATE(1138), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [27611] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_DOLLAR,
    ACTIONS(1760), 1,
      sym_name,
    ACTIONS(1762), 1,
      anon_sym_LBRACE,
    STATE(755), 1,
      sym_text_interpolation,
    STATE(805), 1,
      sym__reserved_identifier,
    STATE(401), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27642] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1465), 1,
      anon_sym_DOLLAR,
    ACTIONS(1764), 1,
      sym_name,
    ACTIONS(1766), 1,
      anon_sym_LBRACE,
    STATE(756), 1,
      sym_text_interpolation,
    ACTIONS(1674), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(458), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [27671] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(1768), 1,
      sym_name,
    ACTIONS(1772), 1,
      anon_sym_LBRACE,
    STATE(757), 1,
      sym_text_interpolation,
    ACTIONS(1770), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(349), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [27700] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(758), 1,
      sym_text_interpolation,
    ACTIONS(1774), 9,
      anon_sym_static,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_DOLLAR,
  [27721] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(1776), 1,
      sym_name,
    ACTIONS(1778), 1,
      anon_sym_LBRACE,
    STATE(447), 1,
      sym__reserved_identifier,
    STATE(759), 1,
      sym_text_interpolation,
    STATE(354), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1674), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27752] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_DOLLAR,
    ACTIONS(1780), 1,
      sym_name,
    ACTIONS(1782), 1,
      anon_sym_LBRACE,
    STATE(760), 1,
      sym_text_interpolation,
    ACTIONS(1752), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(403), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [27781] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(761), 1,
      sym_text_interpolation,
    ACTIONS(1732), 9,
      anon_sym_static,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_DOLLAR,
  [27802] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1465), 1,
      anon_sym_DOLLAR,
    ACTIONS(1784), 1,
      sym_name,
    ACTIONS(1786), 1,
      anon_sym_LBRACE,
    STATE(762), 1,
      sym_text_interpolation,
    ACTIONS(1674), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(454), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [27831] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1465), 1,
      anon_sym_DOLLAR,
    ACTIONS(1788), 1,
      sym_name,
    ACTIONS(1790), 1,
      anon_sym_LBRACE,
    STATE(763), 1,
      sym_text_interpolation,
    STATE(798), 1,
      sym__reserved_identifier,
    STATE(443), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27862] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(764), 1,
      sym_text_interpolation,
    ACTIONS(1792), 9,
      anon_sym_static,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_final,
      sym_var_modifier,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_DOLLAR,
  [27883] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1465), 1,
      anon_sym_DOLLAR,
    ACTIONS(1794), 1,
      sym_name,
    ACTIONS(1796), 1,
      anon_sym_LBRACE,
    STATE(765), 1,
      sym_text_interpolation,
    ACTIONS(1674), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(461), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [27912] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1465), 1,
      anon_sym_DOLLAR,
    ACTIONS(1750), 1,
      sym_name,
    ACTIONS(1754), 1,
      anon_sym_LBRACE,
    STATE(384), 1,
      sym__reserved_identifier,
    STATE(766), 1,
      sym_text_interpolation,
    STATE(459), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27943] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(1778), 1,
      anon_sym_LBRACE,
    ACTIONS(1798), 1,
      sym_name,
    STATE(767), 1,
      sym_text_interpolation,
    STATE(789), 1,
      sym__reserved_identifier,
    STATE(354), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [27974] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_DOLLAR,
    ACTIONS(1750), 1,
      sym_name,
    ACTIONS(1754), 1,
      anon_sym_LBRACE,
    STATE(384), 1,
      sym__reserved_identifier,
    STATE(768), 1,
      sym_text_interpolation,
    STATE(388), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [28005] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_DOLLAR,
    ACTIONS(1750), 1,
      sym_name,
    ACTIONS(1754), 1,
      anon_sym_LBRACE,
    STATE(384), 1,
      sym__reserved_identifier,
    STATE(769), 1,
      sym_text_interpolation,
    STATE(406), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [28036] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_DOLLAR,
    ACTIONS(1800), 1,
      sym_name,
    ACTIONS(1802), 1,
      anon_sym_LBRACE,
    STATE(770), 1,
      sym_text_interpolation,
    ACTIONS(1752), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(400), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [28065] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1465), 1,
      anon_sym_DOLLAR,
    ACTIONS(1750), 1,
      sym_name,
    ACTIONS(1754), 1,
      anon_sym_LBRACE,
    STATE(384), 1,
      sym__reserved_identifier,
    STATE(771), 1,
      sym_text_interpolation,
    STATE(460), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [28096] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_DOLLAR,
    ACTIONS(1804), 1,
      sym_name,
    ACTIONS(1806), 1,
      anon_sym_LBRACE,
    STATE(772), 1,
      sym_text_interpolation,
    ACTIONS(1752), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(397), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [28125] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1750), 1,
      sym_name,
    ACTIONS(1754), 1,
      anon_sym_LBRACE,
    STATE(384), 1,
      sym__reserved_identifier,
    STATE(773), 1,
      sym_text_interpolation,
    STATE(331), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [28156] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(1744), 1,
      sym_name,
    ACTIONS(1748), 1,
      anon_sym_LBRACE,
    STATE(774), 1,
      sym_text_interpolation,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
    STATE(330), 3,
      sym_dynamic_variable_name,
      sym_variable_name,
      sym__reserved_identifier,
  [28185] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(562), 1,
      anon_sym_else,
    ACTIONS(1808), 1,
      anon_sym_catch,
    ACTIONS(1811), 1,
      anon_sym_finally,
    ACTIONS(560), 2,
      anon_sym_while,
      anon_sym_elseif,
    STATE(775), 2,
      sym_text_interpolation,
      aux_sym_try_statement_repeat1,
    STATE(874), 2,
      sym_catch_clause,
      sym_finally_clause,
  [28213] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(572), 1,
      anon_sym_else,
    ACTIONS(1814), 1,
      anon_sym_catch,
    ACTIONS(1816), 1,
      anon_sym_finally,
    STATE(775), 1,
      aux_sym_try_statement_repeat1,
    STATE(776), 1,
      sym_text_interpolation,
    ACTIONS(570), 2,
      anon_sym_while,
      anon_sym_elseif,
    STATE(874), 2,
      sym_catch_clause,
      sym_finally_clause,
  [28243] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(346), 1,
      sym_arguments,
    STATE(777), 1,
      sym_text_interpolation,
    ACTIONS(1818), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [28269] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(346), 1,
      sym_arguments,
    STATE(778), 1,
      sym_text_interpolation,
    ACTIONS(1820), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [28295] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1822), 1,
      sym_name,
    ACTIONS(1824), 1,
      anon_sym_AMP,
    ACTIONS(1826), 1,
      anon_sym_LPAREN,
    STATE(779), 1,
      sym_text_interpolation,
    STATE(797), 1,
      sym_formal_parameters,
    STATE(1228), 1,
      sym__reserved_identifier,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [28325] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1828), 1,
      anon_sym_LBRACE,
    ACTIONS(1830), 1,
      anon_sym_extends,
    ACTIONS(1832), 1,
      anon_sym_implements,
    STATE(595), 1,
      sym_declaration_list,
    STATE(780), 1,
      sym_text_interpolation,
    STATE(841), 1,
      sym_arguments,
    STATE(895), 1,
      sym_class_base_clause,
    STATE(1293), 1,
      sym_class_interface_clause,
  [28359] = 11,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1830), 1,
      anon_sym_extends,
    ACTIONS(1832), 1,
      anon_sym_implements,
    ACTIONS(1834), 1,
      anon_sym_LBRACE,
    STATE(537), 1,
      sym_declaration_list,
    STATE(781), 1,
      sym_text_interpolation,
    STATE(835), 1,
      sym_arguments,
    STATE(945), 1,
      sym_class_base_clause,
    STATE(1159), 1,
      sym_class_interface_clause,
  [28393] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_LPAREN,
    ACTIONS(1836), 1,
      sym_name,
    STATE(782), 1,
      sym_text_interpolation,
    STATE(831), 1,
      sym_formal_parameters,
    STATE(1196), 1,
      sym__reserved_identifier,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [28420] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1740), 1,
      anon_sym_COMMA,
    ACTIONS(1742), 1,
      anon_sym_RPAREN,
    STATE(783), 1,
      sym_text_interpolation,
    STATE(1107), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [28445] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1740), 1,
      anon_sym_COMMA,
    ACTIONS(1758), 1,
      anon_sym_RPAREN,
    STATE(784), 1,
      sym_text_interpolation,
    STATE(1138), 1,
      aux_sym_unset_statement_repeat1,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [28470] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1840), 1,
      sym_integer,
    STATE(785), 1,
      sym_text_interpolation,
    STATE(1411), 1,
      sym__string,
    ACTIONS(512), 2,
      sym_heredoc,
      sym_string,
    ACTIONS(1838), 3,
      sym_float,
      sym_boolean,
      sym_null,
  [28495] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1844), 1,
      anon_sym_case,
    ACTIONS(1847), 1,
      anon_sym_default,
    ACTIONS(1842), 2,
      anon_sym_RBRACE,
      anon_sym_endswitch,
    STATE(786), 2,
      sym_text_interpolation,
      aux_sym_switch_block_repeat1,
    STATE(912), 2,
      sym_case_statement,
      sym_default_statement,
  [28520] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_COMMA,
    ACTIONS(1756), 1,
      anon_sym_RPAREN,
    STATE(787), 1,
      sym_text_interpolation,
    STATE(1053), 1,
      aux_sym_list_literal_repeat1,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [28545] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    STATE(788), 1,
      sym_text_interpolation,
    STATE(1260), 1,
      sym_namespace_use_group,
    ACTIONS(1850), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [28567] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_LPAREN,
    STATE(365), 1,
      sym_arguments,
    STATE(789), 1,
      sym_text_interpolation,
    ACTIONS(1151), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [28589] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(790), 1,
      sym_text_interpolation,
    ACTIONS(1820), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [28609] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_RBRACE,
    ACTIONS(1856), 1,
      anon_sym_case,
    ACTIONS(1858), 1,
      anon_sym_default,
    STATE(786), 1,
      aux_sym_switch_block_repeat1,
    STATE(791), 1,
      sym_text_interpolation,
    STATE(912), 2,
      sym_case_statement,
      sym_default_statement,
  [28635] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1860), 1,
      sym_name,
    ACTIONS(1862), 1,
      anon_sym_AMP,
    STATE(792), 1,
      sym_text_interpolation,
    STATE(1191), 1,
      sym__reserved_identifier,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [28659] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LBRACE,
    ACTIONS(1830), 1,
      anon_sym_extends,
    ACTIONS(1832), 1,
      anon_sym_implements,
    STATE(793), 1,
      sym_text_interpolation,
    STATE(870), 1,
      sym_declaration_list,
    STATE(964), 1,
      sym_class_base_clause,
    STATE(1290), 1,
      sym_class_interface_clause,
  [28687] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    ACTIONS(1864), 1,
      anon_sym_use,
    ACTIONS(1866), 1,
      anon_sym_COLON,
    STATE(538), 1,
      sym_compound_statement,
    STATE(794), 1,
      sym_text_interpolation,
    STATE(961), 1,
      sym_anonymous_function_use_clause,
    STATE(1164), 1,
      sym__return_type,
  [28715] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1868), 1,
      sym_name,
    STATE(795), 1,
      sym_text_interpolation,
    STATE(957), 1,
      sym_namespace_name,
    STATE(1034), 1,
      sym_namespace_use_group_clause,
    STATE(1269), 1,
      sym_namespace_function_or_const,
    ACTIONS(1684), 2,
      anon_sym_function,
      anon_sym_const,
  [28741] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    STATE(796), 1,
      sym_text_interpolation,
    STATE(1271), 1,
      sym_namespace_use_group,
    ACTIONS(1870), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [28763] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1864), 1,
      anon_sym_use,
    ACTIONS(1866), 1,
      anon_sym_COLON,
    ACTIONS(1872), 1,
      anon_sym_LBRACE,
    STATE(566), 1,
      sym_compound_statement,
    STATE(797), 1,
      sym_text_interpolation,
    STATE(925), 1,
      sym_anonymous_function_use_clause,
    STATE(1189), 1,
      sym__return_type,
  [28791] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1214), 1,
      anon_sym_LPAREN,
    STATE(477), 1,
      sym_arguments,
    STATE(798), 1,
      sym_text_interpolation,
    ACTIONS(1151), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [28813] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_extends,
    ACTIONS(1832), 1,
      anon_sym_implements,
    ACTIONS(1874), 1,
      anon_sym_LBRACE,
    STATE(208), 1,
      sym_declaration_list,
    STATE(799), 1,
      sym_text_interpolation,
    STATE(922), 1,
      sym_class_base_clause,
    STATE(1169), 1,
      sym_class_interface_clause,
  [28841] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1876), 1,
      sym_name,
    STATE(800), 1,
      sym_text_interpolation,
    STATE(1128), 1,
      sym_const_element,
    STATE(1369), 1,
      sym__reserved_identifier,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [28865] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1880), 1,
      anon_sym_COMMA,
    ACTIONS(1882), 1,
      anon_sym_LBRACE,
    STATE(736), 1,
      sym_use_list,
    STATE(801), 1,
      sym_text_interpolation,
    STATE(806), 1,
      aux_sym_interface_base_clause_repeat1,
    ACTIONS(1878), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [28891] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_LPAREN,
    STATE(424), 1,
      sym_arguments,
    STATE(802), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [28913] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    STATE(803), 1,
      sym_text_interpolation,
    STATE(1271), 1,
      sym_namespace_use_group,
    ACTIONS(1850), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [28935] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1868), 1,
      sym_name,
    STATE(804), 1,
      sym_text_interpolation,
    STATE(957), 1,
      sym_namespace_name,
    STATE(1269), 1,
      sym_namespace_function_or_const,
    STATE(1279), 1,
      sym_namespace_use_group_clause,
    ACTIONS(1684), 2,
      anon_sym_function,
      anon_sym_const,
  [28961] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_LPAREN,
    STATE(415), 1,
      sym_arguments,
    STATE(805), 1,
      sym_text_interpolation,
    ACTIONS(1151), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [28983] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1880), 1,
      anon_sym_COMMA,
    ACTIONS(1882), 1,
      anon_sym_LBRACE,
    STATE(728), 1,
      sym_use_list,
    STATE(806), 1,
      sym_text_interpolation,
    STATE(851), 1,
      aux_sym_interface_base_clause_repeat1,
    ACTIONS(1884), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [29009] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1864), 1,
      anon_sym_use,
    ACTIONS(1866), 1,
      anon_sym_COLON,
    ACTIONS(1872), 1,
      anon_sym_LBRACE,
    STATE(565), 1,
      sym_compound_statement,
    STATE(807), 1,
      sym_text_interpolation,
    STATE(968), 1,
      sym_anonymous_function_use_clause,
    STATE(1274), 1,
      sym__return_type,
  [29037] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_LPAREN,
    STATE(368), 1,
      sym_arguments,
    STATE(808), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [29059] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_case,
    ACTIONS(1858), 1,
      anon_sym_default,
    ACTIONS(1886), 1,
      anon_sym_RBRACE,
    STATE(791), 1,
      aux_sym_switch_block_repeat1,
    STATE(809), 1,
      sym_text_interpolation,
    STATE(912), 2,
      sym_case_statement,
      sym_default_statement,
  [29085] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    ACTIONS(1864), 1,
      anon_sym_use,
    ACTIONS(1866), 1,
      anon_sym_COLON,
    STATE(499), 1,
      sym_compound_statement,
    STATE(810), 1,
      sym_text_interpolation,
    STATE(908), 1,
      sym_anonymous_function_use_clause,
    STATE(1195), 1,
      sym__return_type,
  [29113] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(811), 1,
      sym_text_interpolation,
    ACTIONS(1818), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [29133] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(346), 1,
      sym_arguments,
    STATE(812), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [29155] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1890), 1,
      anon_sym_BSLASH,
    STATE(813), 1,
      sym_text_interpolation,
    ACTIONS(1888), 5,
      anon_sym_static,
      anon_sym_namespace,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [29175] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    ACTIONS(1864), 1,
      anon_sym_use,
    ACTIONS(1866), 1,
      anon_sym_COLON,
    STATE(489), 1,
      sym_compound_statement,
    STATE(814), 1,
      sym_text_interpolation,
    STATE(933), 1,
      sym_anonymous_function_use_clause,
    STATE(1168), 1,
      sym__return_type,
  [29203] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1214), 1,
      anon_sym_LPAREN,
    STATE(474), 1,
      sym_arguments,
    STATE(815), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [29225] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1157), 1,
      anon_sym_BSLASH,
    ACTIONS(1892), 1,
      anon_sym_as,
    ACTIONS(1894), 1,
      anon_sym_insteadof,
    STATE(816), 1,
      sym_text_interpolation,
    STATE(1308), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1155), 2,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
  [29251] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    STATE(817), 1,
      sym_text_interpolation,
    STATE(1177), 1,
      sym_namespace_use_group,
    ACTIONS(1870), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [29273] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(650), 1,
      anon_sym_while,
    ACTIONS(1896), 1,
      anon_sym_elseif,
    ACTIONS(1898), 1,
      anon_sym_else,
    STATE(818), 1,
      sym_text_interpolation,
    STATE(858), 1,
      aux_sym_if_statement_repeat1,
    STATE(1025), 1,
      sym_else_clause,
    STATE(1072), 1,
      sym_else_if_clause,
  [29301] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1892), 1,
      anon_sym_as,
    ACTIONS(1894), 1,
      anon_sym_insteadof,
    STATE(819), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [29323] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_case,
    ACTIONS(1858), 1,
      anon_sym_default,
    ACTIONS(1900), 1,
      anon_sym_endswitch,
    STATE(786), 1,
      aux_sym_switch_block_repeat1,
    STATE(820), 1,
      sym_text_interpolation,
    STATE(912), 2,
      sym_case_statement,
      sym_default_statement,
  [29349] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_case,
    ACTIONS(1858), 1,
      anon_sym_default,
    ACTIONS(1902), 1,
      anon_sym_RBRACE,
    STATE(786), 1,
      aux_sym_switch_block_repeat1,
    STATE(821), 1,
      sym_text_interpolation,
    STATE(912), 2,
      sym_case_statement,
      sym_default_statement,
  [29375] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1876), 1,
      sym_name,
    STATE(822), 1,
      sym_text_interpolation,
    STATE(920), 1,
      sym_const_element,
    STATE(1369), 1,
      sym__reserved_identifier,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [29399] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_case,
    ACTIONS(1858), 1,
      anon_sym_default,
    ACTIONS(1904), 1,
      anon_sym_endswitch,
    STATE(786), 1,
      aux_sym_switch_block_repeat1,
    STATE(823), 1,
      sym_text_interpolation,
    STATE(912), 2,
      sym_case_statement,
      sym_default_statement,
  [29425] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1906), 1,
      anon_sym_endif,
    ACTIONS(1908), 1,
      anon_sym_elseif,
    ACTIONS(1910), 1,
      anon_sym_else,
    STATE(824), 1,
      sym_text_interpolation,
    STATE(830), 1,
      aux_sym_if_statement_repeat2,
    STATE(1098), 1,
      sym_else_if_clause_2,
    STATE(1310), 1,
      sym_else_clause_2,
  [29453] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_case,
    ACTIONS(1858), 1,
      anon_sym_default,
    ACTIONS(1912), 1,
      anon_sym_RBRACE,
    STATE(821), 1,
      aux_sym_switch_block_repeat1,
    STATE(825), 1,
      sym_text_interpolation,
    STATE(912), 2,
      sym_case_statement,
      sym_default_statement,
  [29479] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_case,
    ACTIONS(1858), 1,
      anon_sym_default,
    ACTIONS(1914), 1,
      anon_sym_endswitch,
    STATE(820), 1,
      aux_sym_switch_block_repeat1,
    STATE(826), 1,
      sym_text_interpolation,
    STATE(912), 2,
      sym_case_statement,
      sym_default_statement,
  [29505] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_elseif,
    ACTIONS(1910), 1,
      anon_sym_else,
    ACTIONS(1916), 1,
      anon_sym_endif,
    STATE(827), 1,
      sym_text_interpolation,
    STATE(867), 1,
      aux_sym_if_statement_repeat2,
    STATE(1098), 1,
      sym_else_if_clause_2,
    STATE(1349), 1,
      sym_else_clause_2,
  [29533] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1876), 1,
      sym_name,
    STATE(828), 1,
      sym_text_interpolation,
    STATE(896), 1,
      sym_const_element,
    STATE(1369), 1,
      sym__reserved_identifier,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [29557] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LBRACE,
    ACTIONS(1830), 1,
      anon_sym_extends,
    ACTIONS(1832), 1,
      anon_sym_implements,
    STATE(829), 1,
      sym_text_interpolation,
    STATE(864), 1,
      sym_declaration_list,
    STATE(905), 1,
      sym_class_base_clause,
    STATE(1192), 1,
      sym_class_interface_clause,
  [29585] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_elseif,
    ACTIONS(1910), 1,
      anon_sym_else,
    ACTIONS(1918), 1,
      anon_sym_endif,
    STATE(830), 1,
      sym_text_interpolation,
    STATE(867), 1,
      aux_sym_if_statement_repeat2,
    STATE(1098), 1,
      sym_else_if_clause_2,
    STATE(1355), 1,
      sym_else_clause_2,
  [29613] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1864), 1,
      anon_sym_use,
    ACTIONS(1866), 1,
      anon_sym_COLON,
    ACTIONS(1872), 1,
      anon_sym_LBRACE,
    STATE(607), 1,
      sym_compound_statement,
    STATE(831), 1,
      sym_text_interpolation,
    STATE(958), 1,
      sym_anonymous_function_use_clause,
    STATE(1267), 1,
      sym__return_type,
  [29641] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1876), 1,
      sym_name,
    STATE(832), 1,
      sym_text_interpolation,
    STATE(914), 1,
      sym_const_element,
    STATE(1369), 1,
      sym__reserved_identifier,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [29665] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    STATE(833), 1,
      sym_text_interpolation,
    STATE(1209), 1,
      sym_namespace_use_group,
    ACTIONS(1850), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [29687] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    STATE(834), 1,
      sym_text_interpolation,
    STATE(1171), 1,
      sym_namespace_use_group,
    ACTIONS(1870), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [29709] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_extends,
    ACTIONS(1832), 1,
      anon_sym_implements,
    ACTIONS(1834), 1,
      anon_sym_LBRACE,
    STATE(493), 1,
      sym_declaration_list,
    STATE(835), 1,
      sym_text_interpolation,
    STATE(916), 1,
      sym_class_base_clause,
    STATE(1187), 1,
      sym_class_interface_clause,
  [29737] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    STATE(836), 1,
      sym_text_interpolation,
    STATE(1198), 1,
      sym_namespace_use_group,
    ACTIONS(1870), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [29759] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_LBRACE,
    STATE(837), 1,
      sym_text_interpolation,
    STATE(1198), 1,
      sym_namespace_use_group,
    ACTIONS(1850), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [29781] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_case,
    ACTIONS(1858), 1,
      anon_sym_default,
    ACTIONS(1920), 1,
      anon_sym_endswitch,
    STATE(823), 1,
      aux_sym_switch_block_repeat1,
    STATE(838), 1,
      sym_text_interpolation,
    STATE(912), 2,
      sym_case_statement,
      sym_default_statement,
  [29807] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_extends,
    ACTIONS(1832), 1,
      anon_sym_implements,
    ACTIONS(1874), 1,
      anon_sym_LBRACE,
    STATE(178), 1,
      sym_declaration_list,
    STATE(839), 1,
      sym_text_interpolation,
    STATE(944), 1,
      sym_class_base_clause,
    STATE(1277), 1,
      sym_class_interface_clause,
  [29835] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1908), 1,
      anon_sym_elseif,
    ACTIONS(1910), 1,
      anon_sym_else,
    ACTIONS(1922), 1,
      anon_sym_endif,
    STATE(827), 1,
      aux_sym_if_statement_repeat2,
    STATE(840), 1,
      sym_text_interpolation,
    STATE(1098), 1,
      sym_else_if_clause_2,
    STATE(1338), 1,
      sym_else_clause_2,
  [29863] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LBRACE,
    ACTIONS(1830), 1,
      anon_sym_extends,
    ACTIONS(1832), 1,
      anon_sym_implements,
    STATE(613), 1,
      sym_declaration_list,
    STATE(841), 1,
      sym_text_interpolation,
    STATE(918), 1,
      sym_class_base_clause,
    STATE(1292), 1,
      sym_class_interface_clause,
  [29891] = 9,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(636), 1,
      anon_sym_while,
    ACTIONS(1896), 1,
      anon_sym_elseif,
    ACTIONS(1898), 1,
      anon_sym_else,
    STATE(818), 1,
      aux_sym_if_statement_repeat1,
    STATE(842), 1,
      sym_text_interpolation,
    STATE(1071), 1,
      sym_else_clause,
    STATE(1072), 1,
      sym_else_if_clause,
  [29919] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1876), 1,
      sym_name,
    STATE(843), 1,
      sym_text_interpolation,
    STATE(960), 1,
      sym_const_element,
    STATE(1369), 1,
      sym__reserved_identifier,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [29943] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1924), 1,
      anon_sym_catch,
    ACTIONS(1926), 1,
      anon_sym_finally,
    STATE(79), 1,
      aux_sym_try_statement_repeat1,
    STATE(844), 1,
      sym_text_interpolation,
    STATE(131), 2,
      sym_catch_clause,
      sym_finally_clause,
  [29966] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1928), 1,
      sym_name,
    STATE(845), 1,
      sym_text_interpolation,
    STATE(1106), 1,
      sym_visibility_modifier,
    ACTIONS(1930), 3,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
  [29987] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1932), 1,
      sym_name,
    STATE(846), 1,
      sym_text_interpolation,
    STATE(1395), 1,
      sym_namespace_name,
    ACTIONS(1935), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [30008] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1932), 1,
      sym_name,
    STATE(847), 1,
      sym_text_interpolation,
    STATE(1391), 1,
      sym_namespace_name,
    ACTIONS(1935), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [30029] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1939), 1,
      anon_sym_COLON,
    STATE(848), 1,
      sym_text_interpolation,
    STATE(1089), 1,
      sym__return_type,
    ACTIONS(1937), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [30050] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    ACTIONS(1941), 1,
      sym_name,
    ACTIONS(1943), 1,
      anon_sym_LBRACE,
    STATE(849), 1,
      sym_text_interpolation,
    STATE(355), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [30073] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1947), 1,
      anon_sym_BSLASH,
    STATE(850), 1,
      sym_text_interpolation,
    STATE(884), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1945), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [30094] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1952), 1,
      anon_sym_COMMA,
    STATE(851), 2,
      sym_text_interpolation,
      aux_sym_interface_base_clause_repeat1,
    ACTIONS(1950), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [30113] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(743), 1,
      anon_sym_else,
    STATE(852), 1,
      sym_text_interpolation,
    ACTIONS(741), 2,
      anon_sym_while,
      anon_sym_elseif,
    ACTIONS(1955), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30134] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(711), 1,
      anon_sym_else,
    STATE(853), 1,
      sym_text_interpolation,
    ACTIONS(709), 2,
      anon_sym_while,
      anon_sym_elseif,
    ACTIONS(1957), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30155] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1959), 1,
      sym_name,
    STATE(854), 1,
      sym_text_interpolation,
    STATE(1027), 1,
      sym__reserved_identifier,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [30176] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(705), 1,
      anon_sym_else,
    STATE(855), 1,
      sym_text_interpolation,
    ACTIONS(703), 4,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_while,
      anon_sym_elseif,
  [30195] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_BSLASH,
    STATE(856), 1,
      sym_text_interpolation,
    STATE(860), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1961), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [30216] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1157), 1,
      anon_sym_BSLASH,
    STATE(857), 1,
      sym_text_interpolation,
    STATE(1308), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1155), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [30237] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(674), 1,
      anon_sym_while,
    ACTIONS(676), 1,
      anon_sym_else,
    ACTIONS(1965), 1,
      anon_sym_elseif,
    STATE(1072), 1,
      sym_else_if_clause,
    STATE(858), 2,
      sym_text_interpolation,
      aux_sym_if_statement_repeat1,
  [30260] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1461), 1,
      anon_sym_DOLLAR,
    ACTIONS(1968), 1,
      sym_name,
    ACTIONS(1970), 1,
      anon_sym_LBRACE,
    STATE(859), 1,
      sym_text_interpolation,
    STATE(425), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [30283] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_BSLASH,
    STATE(860), 1,
      sym_text_interpolation,
    STATE(890), 1,
      aux_sym_namespace_name_repeat1,
    ACTIONS(1945), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [30304] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(721), 1,
      anon_sym_else,
    STATE(861), 1,
      sym_text_interpolation,
    ACTIONS(719), 2,
      anon_sym_while,
      anon_sym_elseif,
    ACTIONS(1972), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30325] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_LBRACE,
    ACTIONS(1976), 1,
      anon_sym_BSLASH,
    STATE(247), 1,
      sym_compound_statement,
    STATE(862), 1,
      sym_text_interpolation,
    ACTIONS(1974), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30348] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1932), 1,
      sym_name,
    STATE(863), 1,
      sym_text_interpolation,
    STATE(1373), 1,
      sym_namespace_name,
    ACTIONS(1935), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [30369] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(731), 1,
      anon_sym_else,
    STATE(864), 1,
      sym_text_interpolation,
    ACTIONS(729), 2,
      anon_sym_while,
      anon_sym_elseif,
    ACTIONS(1978), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30390] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1932), 1,
      sym_name,
    STATE(865), 1,
      sym_text_interpolation,
    STATE(1384), 1,
      sym_namespace_name,
    ACTIONS(1935), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [30411] = 7,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(15), 1,
      sym_comment,
    ACTIONS(1980), 1,
      ts_builtin_sym_end,
    ACTIONS(1982), 1,
      sym_php_tag,
    STATE(866), 1,
      sym_text_interpolation,
    STATE(879), 1,
      aux_sym_text_repeat1,
    ACTIONS(13), 2,
      aux_sym_text_token1,
      aux_sym_text_token2,
  [30434] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1984), 1,
      anon_sym_endif,
    ACTIONS(1986), 1,
      anon_sym_elseif,
    ACTIONS(1989), 1,
      anon_sym_else,
    STATE(1098), 1,
      sym_else_if_clause_2,
    STATE(867), 2,
      sym_text_interpolation,
      aux_sym_if_statement_repeat2,
  [30457] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1991), 1,
      sym_name,
    STATE(423), 1,
      sym__reserved_identifier,
    STATE(868), 1,
      sym_text_interpolation,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [30478] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1465), 1,
      anon_sym_DOLLAR,
    ACTIONS(1993), 1,
      sym_name,
    ACTIONS(1995), 1,
      anon_sym_LBRACE,
    STATE(869), 1,
      sym_text_interpolation,
    STATE(468), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [30501] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(737), 1,
      anon_sym_else,
    STATE(870), 1,
      sym_text_interpolation,
    ACTIONS(735), 2,
      anon_sym_while,
      anon_sym_elseif,
    ACTIONS(1997), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30522] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1999), 1,
      sym_name,
    STATE(871), 1,
      sym_text_interpolation,
    STATE(1166), 1,
      sym__reserved_identifier,
    ACTIONS(1549), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [30543] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(664), 1,
      anon_sym_else,
    STATE(872), 1,
      sym_text_interpolation,
    ACTIONS(662), 4,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_while,
      anon_sym_elseif,
  [30562] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_EQ,
    STATE(873), 1,
      sym_text_interpolation,
    STATE(993), 1,
      sym_property_initializer,
    ACTIONS(2001), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [30583] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(689), 1,
      anon_sym_else,
    STATE(874), 1,
      sym_text_interpolation,
    ACTIONS(687), 4,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_while,
      anon_sym_elseif,
  [30602] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    ACTIONS(2005), 1,
      sym_name,
    ACTIONS(2007), 1,
      anon_sym_BSLASH,
    STATE(875), 1,
      sym_text_interpolation,
    STATE(881), 1,
      sym_namespace_name,
    STATE(1103), 1,
      sym_compound_statement,
  [30627] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2009), 1,
      anon_sym_BSLASH,
    STATE(850), 1,
      aux_sym_namespace_name_repeat1,
    STATE(876), 1,
      sym_text_interpolation,
    ACTIONS(1961), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [30648] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1814), 1,
      anon_sym_catch,
    ACTIONS(1816), 1,
      anon_sym_finally,
    STATE(776), 1,
      aux_sym_try_statement_repeat1,
    STATE(877), 1,
      sym_text_interpolation,
    STATE(874), 2,
      sym_catch_clause,
      sym_finally_clause,
  [30671] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(749), 1,
      anon_sym_else,
    STATE(878), 1,
      sym_text_interpolation,
    ACTIONS(747), 2,
      anon_sym_while,
      anon_sym_elseif,
    ACTIONS(2012), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30692] = 6,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(15), 1,
      sym_comment,
    ACTIONS(2014), 1,
      ts_builtin_sym_end,
    ACTIONS(2016), 1,
      sym_php_tag,
    ACTIONS(2018), 2,
      aux_sym_text_token1,
      aux_sym_text_token2,
    STATE(879), 2,
      sym_text_interpolation,
      aux_sym_text_repeat1,
  [30713] = 8,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_LBRACE,
    ACTIONS(2005), 1,
      sym_name,
    ACTIONS(2007), 1,
      anon_sym_BSLASH,
    STATE(259), 1,
      sym_compound_statement,
    STATE(862), 1,
      sym_namespace_name,
    STATE(880), 1,
      sym_text_interpolation,
  [30738] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    ACTIONS(1976), 1,
      anon_sym_BSLASH,
    STATE(881), 1,
      sym_text_interpolation,
    STATE(1143), 1,
      sym_compound_statement,
    ACTIONS(2021), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30761] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2023), 1,
      sym_name,
    STATE(487), 1,
      sym__reserved_identifier,
    STATE(882), 1,
      sym_text_interpolation,
    ACTIONS(1674), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [30782] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(514), 1,
      anon_sym_DOLLAR,
    ACTIONS(2025), 1,
      sym_name,
    ACTIONS(2027), 1,
      anon_sym_LBRACE,
    STATE(883), 1,
      sym_text_interpolation,
    STATE(345), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [30805] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_BSLASH,
    STATE(884), 2,
      sym_text_interpolation,
      aux_sym_namespace_name_repeat1,
    ACTIONS(2029), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [30824] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_name,
    STATE(885), 1,
      sym_text_interpolation,
    STATE(1379), 1,
      sym_namespace_name,
    ACTIONS(1870), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [30845] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2039), 1,
      anon_sym_as,
    STATE(886), 1,
      sym_text_interpolation,
    STATE(1065), 1,
      sym_namespace_aliasing_clause,
    ACTIONS(2037), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [30866] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1932), 1,
      sym_name,
    STATE(887), 1,
      sym_text_interpolation,
    STATE(1348), 1,
      sym_namespace_name,
    ACTIONS(1935), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [30887] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1939), 1,
      anon_sym_COLON,
    STATE(888), 1,
      sym_text_interpolation,
    STATE(1057), 1,
      sym__return_type,
    ACTIONS(2041), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [30908] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1991), 1,
      sym_name,
    STATE(423), 1,
      sym__reserved_identifier,
    STATE(889), 1,
      sym_text_interpolation,
    ACTIONS(1752), 3,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
  [30929] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2043), 1,
      anon_sym_BSLASH,
    STATE(890), 2,
      sym_text_interpolation,
      aux_sym_namespace_name_repeat1,
    ACTIONS(2029), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [30948] = 7,
    ACTIONS(15), 1,
      sym_comment,
    ACTIONS(2046), 1,
      sym_php_tag,
    ACTIONS(2050), 1,
      sym__eof,
    STATE(891), 1,
      sym_text_interpolation,
    STATE(937), 1,
      aux_sym_text_repeat1,
    STATE(1406), 1,
      sym_text,
    ACTIONS(2048), 2,
      aux_sym_text_token1,
      aux_sym_text_token2,
  [30971] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2054), 1,
      anon_sym_EQ,
    STATE(892), 1,
      sym_text_interpolation,
    ACTIONS(2052), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [30989] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(893), 1,
      sym_text_interpolation,
    STATE(1327), 1,
      sym_declare_directive,
    ACTIONS(2056), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [31007] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(894), 1,
      sym_text_interpolation,
    ACTIONS(2029), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_BSLASH,
      anon_sym_LBRACE,
  [31023] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LBRACE,
    ACTIONS(1832), 1,
      anon_sym_implements,
    STATE(613), 1,
      sym_declaration_list,
    STATE(895), 1,
      sym_text_interpolation,
    STATE(1292), 1,
      sym_class_interface_clause,
  [31045] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2060), 1,
      anon_sym_COMMA,
    STATE(896), 1,
      sym_text_interpolation,
    STATE(962), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(2058), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31065] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_COMMA,
    ACTIONS(1139), 1,
      anon_sym_RPAREN,
    ACTIONS(2062), 1,
      anon_sym_EQ,
    STATE(897), 1,
      sym_text_interpolation,
    STATE(1075), 1,
      aux_sym_list_literal_repeat1,
  [31087] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2060), 1,
      anon_sym_COMMA,
    STATE(898), 1,
      sym_text_interpolation,
    STATE(930), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(2064), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31107] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2068), 1,
      anon_sym_COMMA,
    STATE(899), 1,
      sym_text_interpolation,
    STATE(946), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(2066), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31127] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2072), 1,
      anon_sym_COMMA,
    STATE(900), 1,
      sym_text_interpolation,
    STATE(936), 1,
      aux_sym_global_declaration_repeat1,
    ACTIONS(2070), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31147] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(901), 1,
      sym_text_interpolation,
    ACTIONS(2029), 4,
      anon_sym_COMMA,
      anon_sym_BSLASH,
      anon_sym_as,
      anon_sym_RBRACE,
  [31163] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      anon_sym_DASH_GT,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    STATE(902), 1,
      sym_text_interpolation,
  [31185] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_COMMA,
    STATE(903), 1,
      sym_text_interpolation,
    STATE(934), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(2080), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31205] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(904), 1,
      sym_text_interpolation,
    ACTIONS(1870), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [31221] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LBRACE,
    ACTIONS(1832), 1,
      anon_sym_implements,
    STATE(852), 1,
      sym_declaration_list,
    STATE(905), 1,
      sym_text_interpolation,
    STATE(1206), 1,
      sym_class_interface_clause,
  [31243] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2084), 1,
      anon_sym_LBRACE,
    ACTIONS(2086), 1,
      anon_sym_DASH_GT,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    STATE(906), 1,
      sym_text_interpolation,
  [31265] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2060), 1,
      anon_sym_COMMA,
    STATE(907), 1,
      sym_text_interpolation,
    STATE(930), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(2090), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31285] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    ACTIONS(1866), 1,
      anon_sym_COLON,
    STATE(512), 1,
      sym_compound_statement,
    STATE(908), 1,
      sym_text_interpolation,
    STATE(1208), 1,
      sym__return_type,
  [31307] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2072), 1,
      anon_sym_COMMA,
    STATE(909), 1,
      sym_text_interpolation,
    STATE(965), 1,
      aux_sym_global_declaration_repeat1,
    ACTIONS(2092), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31327] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_COMMA,
    ACTIONS(2094), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(910), 2,
      sym_text_interpolation,
      aux_sym_namespace_use_declaration_repeat1,
  [31345] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(911), 1,
      sym_text_interpolation,
    ACTIONS(2099), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [31361] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(912), 1,
      sym_text_interpolation,
    ACTIONS(2101), 4,
      anon_sym_RBRACE,
      anon_sym_endswitch,
      anon_sym_case,
      anon_sym_default,
  [31377] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(913), 1,
      sym_text_interpolation,
    ACTIONS(1950), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [31393] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2060), 1,
      anon_sym_COMMA,
    STATE(914), 1,
      sym_text_interpolation,
    STATE(948), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(2064), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31413] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_COMMA,
    STATE(915), 1,
      sym_text_interpolation,
    STATE(932), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(2103), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31433] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1832), 1,
      anon_sym_implements,
    ACTIONS(1834), 1,
      anon_sym_LBRACE,
    STATE(506), 1,
      sym_declaration_list,
    STATE(916), 1,
      sym_text_interpolation,
    STATE(1205), 1,
      sym_class_interface_clause,
  [31455] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2068), 1,
      anon_sym_COMMA,
    STATE(917), 1,
      sym_text_interpolation,
    STATE(926), 1,
      aux_sym_namespace_use_declaration_repeat1,
    ACTIONS(2105), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31475] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LBRACE,
    ACTIONS(1832), 1,
      anon_sym_implements,
    STATE(577), 1,
      sym_declaration_list,
    STATE(918), 1,
      sym_text_interpolation,
    STATE(1250), 1,
      sym_class_interface_clause,
  [31497] = 5,
    ACTIONS(15), 1,
      sym_comment,
    ACTIONS(2014), 1,
      sym__eof,
    ACTIONS(2016), 1,
      sym_php_tag,
    ACTIONS(2107), 2,
      aux_sym_text_token1,
      aux_sym_text_token2,
    STATE(919), 2,
      sym_text_interpolation,
      aux_sym_text_repeat1,
  [31515] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2060), 1,
      anon_sym_COMMA,
    STATE(898), 1,
      aux_sym_const_declaration_repeat1,
    STATE(920), 1,
      sym_text_interpolation,
    ACTIONS(2110), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31535] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2114), 1,
      anon_sym_COMMA,
    ACTIONS(2112), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(921), 2,
      sym_text_interpolation,
      aux_sym_property_declaration_repeat2,
  [31553] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1832), 1,
      anon_sym_implements,
    ACTIONS(1874), 1,
      anon_sym_LBRACE,
    STATE(222), 1,
      sym_declaration_list,
    STATE(922), 1,
      sym_text_interpolation,
    STATE(1218), 1,
      sym_class_interface_clause,
  [31575] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_LBRACE,
    ACTIONS(2119), 1,
      anon_sym_extends,
    STATE(261), 1,
      sym_declaration_list,
    STATE(923), 1,
      sym_text_interpolation,
    STATE(1170), 1,
      sym_interface_base_clause,
  [31597] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2068), 1,
      anon_sym_COMMA,
    STATE(910), 1,
      aux_sym_namespace_use_declaration_repeat1,
    STATE(924), 1,
      sym_text_interpolation,
    ACTIONS(2121), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31617] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_COLON,
    ACTIONS(1872), 1,
      anon_sym_LBRACE,
    STATE(560), 1,
      sym_compound_statement,
    STATE(925), 1,
      sym_text_interpolation,
    STATE(1157), 1,
      sym__return_type,
  [31639] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2068), 1,
      anon_sym_COMMA,
    STATE(910), 1,
      aux_sym_namespace_use_declaration_repeat1,
    STATE(926), 1,
      sym_text_interpolation,
    ACTIONS(2123), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31659] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    STATE(724), 1,
      sym_compound_statement,
    STATE(927), 1,
      sym_text_interpolation,
    ACTIONS(2125), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31679] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2129), 1,
      anon_sym_COMMA,
    STATE(928), 1,
      sym_text_interpolation,
    STATE(967), 1,
      aux_sym_property_declaration_repeat2,
    ACTIONS(2127), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31699] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(929), 1,
      sym_text_interpolation,
    ACTIONS(2131), 4,
      anon_sym_LBRACE,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [31715] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_COMMA,
    ACTIONS(2133), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(930), 2,
      sym_text_interpolation,
      aux_sym_const_declaration_repeat1,
  [31733] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2138), 1,
      anon_sym_LBRACE,
    ACTIONS(2140), 1,
      anon_sym_DASH_GT,
    ACTIONS(2142), 1,
      anon_sym_LBRACK,
    STATE(931), 1,
      sym_text_interpolation,
  [31755] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_COMMA,
    STATE(932), 1,
      sym_text_interpolation,
    STATE(953), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(2144), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31775] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    ACTIONS(1866), 1,
      anon_sym_COLON,
    STATE(500), 1,
      sym_compound_statement,
    STATE(933), 1,
      sym_text_interpolation,
    STATE(1197), 1,
      sym__return_type,
  [31797] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_COMMA,
    STATE(934), 1,
      sym_text_interpolation,
    STATE(953), 1,
      aux_sym_function_static_declaration_repeat1,
    ACTIONS(2146), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31817] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1834), 1,
      anon_sym_LBRACE,
    ACTIONS(2119), 1,
      anon_sym_extends,
    STATE(935), 1,
      sym_text_interpolation,
    STATE(1129), 1,
      sym_declaration_list,
    STATE(1162), 1,
      sym_interface_base_clause,
  [31839] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2072), 1,
      anon_sym_COMMA,
    STATE(936), 1,
      sym_text_interpolation,
    STATE(951), 1,
      aux_sym_global_declaration_repeat1,
    ACTIONS(2148), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31859] = 6,
    ACTIONS(15), 1,
      sym_comment,
    ACTIONS(1980), 1,
      sym__eof,
    ACTIONS(1982), 1,
      sym_php_tag,
    STATE(919), 1,
      aux_sym_text_repeat1,
    STATE(937), 1,
      sym_text_interpolation,
    ACTIONS(2150), 2,
      aux_sym_text_token1,
      aux_sym_text_token2,
  [31879] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_COMMA,
    ACTIONS(2155), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(938), 2,
      sym_text_interpolation,
      aux_sym_array_creation_expression_repeat1,
  [31897] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2084), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2157), 1,
      anon_sym_DASH_GT,
    STATE(939), 1,
      sym_text_interpolation,
  [31919] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    STATE(733), 1,
      sym_compound_statement,
    STATE(940), 1,
      sym_text_interpolation,
    ACTIONS(2159), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31939] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2068), 1,
      anon_sym_COMMA,
    STATE(910), 1,
      aux_sym_namespace_use_declaration_repeat1,
    STATE(941), 1,
      sym_text_interpolation,
    ACTIONS(2161), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31959] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(942), 1,
      sym_text_interpolation,
    STATE(1418), 1,
      sym_declare_directive,
    ACTIONS(2056), 3,
      anon_sym_ticks,
      anon_sym_encoding,
      anon_sym_strict_types,
  [31977] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2068), 1,
      anon_sym_COMMA,
    STATE(924), 1,
      aux_sym_namespace_use_declaration_repeat1,
    STATE(943), 1,
      sym_text_interpolation,
    ACTIONS(2163), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31997] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1832), 1,
      anon_sym_implements,
    ACTIONS(1874), 1,
      anon_sym_LBRACE,
    STATE(212), 1,
      sym_declaration_list,
    STATE(944), 1,
      sym_text_interpolation,
    STATE(1253), 1,
      sym_class_interface_clause,
  [32019] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1832), 1,
      anon_sym_implements,
    ACTIONS(1834), 1,
      anon_sym_LBRACE,
    STATE(493), 1,
      sym_declaration_list,
    STATE(945), 1,
      sym_text_interpolation,
    STATE(1187), 1,
      sym_class_interface_clause,
  [32041] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2068), 1,
      anon_sym_COMMA,
    STATE(910), 1,
      aux_sym_namespace_use_declaration_repeat1,
    STATE(946), 1,
      sym_text_interpolation,
    ACTIONS(2163), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32061] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(947), 1,
      sym_text_interpolation,
    ACTIONS(2165), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [32077] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2060), 1,
      anon_sym_COMMA,
    STATE(930), 1,
      aux_sym_const_declaration_repeat1,
    STATE(948), 1,
      sym_text_interpolation,
    ACTIONS(2167), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32097] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(949), 1,
      sym_text_interpolation,
    ACTIONS(2169), 4,
      anon_sym_LBRACE,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [32113] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(950), 1,
      sym_text_interpolation,
    ACTIONS(2171), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [32129] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2175), 1,
      anon_sym_COMMA,
    ACTIONS(2173), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(951), 2,
      sym_text_interpolation,
      aux_sym_global_declaration_repeat1,
  [32147] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(952), 1,
      sym_text_interpolation,
    ACTIONS(2178), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [32163] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2182), 1,
      anon_sym_COMMA,
    ACTIONS(2180), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(953), 2,
      sym_text_interpolation,
      aux_sym_function_static_declaration_repeat1,
  [32181] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2187), 1,
      anon_sym_as,
    STATE(954), 1,
      sym_text_interpolation,
    STATE(1278), 1,
      sym_namespace_aliasing_clause,
    ACTIONS(2185), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [32201] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    ACTIONS(2189), 1,
      anon_sym_AMP,
    ACTIONS(2191), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(955), 1,
      sym_text_interpolation,
    STATE(1052), 1,
      sym_variable_name,
  [32223] = 5,
    ACTIONS(11), 1,
      anon_sym_QMARK_GT,
    ACTIONS(15), 1,
      sym_comment,
    ACTIONS(2193), 1,
      ts_builtin_sym_end,
    STATE(956), 1,
      sym_text_interpolation,
    ACTIONS(2195), 3,
      sym_php_tag,
      aux_sym_text_token1,
      aux_sym_text_token2,
  [32241] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2187), 1,
      anon_sym_as,
    STATE(957), 1,
      sym_text_interpolation,
    STATE(1298), 1,
      sym_namespace_aliasing_clause,
    ACTIONS(2197), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [32261] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_COLON,
    ACTIONS(1872), 1,
      anon_sym_LBRACE,
    STATE(567), 1,
      sym_compound_statement,
    STATE(958), 1,
      sym_text_interpolation,
    STATE(1272), 1,
      sym__return_type,
  [32283] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(959), 1,
      sym_text_interpolation,
    ACTIONS(1071), 4,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
  [32299] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2060), 1,
      anon_sym_COMMA,
    STATE(907), 1,
      aux_sym_const_declaration_repeat1,
    STATE(960), 1,
      sym_text_interpolation,
    ACTIONS(2199), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32319] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    ACTIONS(1866), 1,
      anon_sym_COLON,
    STATE(490), 1,
      sym_compound_statement,
    STATE(961), 1,
      sym_text_interpolation,
    STATE(1173), 1,
      sym__return_type,
  [32341] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2060), 1,
      anon_sym_COMMA,
    STATE(930), 1,
      aux_sym_const_declaration_repeat1,
    STATE(962), 1,
      sym_text_interpolation,
    ACTIONS(2199), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32361] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2201), 1,
      anon_sym_LBRACE,
    ACTIONS(2203), 1,
      anon_sym_DASH_GT,
    ACTIONS(2205), 1,
      anon_sym_LBRACK,
    STATE(963), 1,
      sym_text_interpolation,
  [32383] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LBRACE,
    ACTIONS(1832), 1,
      anon_sym_implements,
    STATE(878), 1,
      sym_declaration_list,
    STATE(964), 1,
      sym_text_interpolation,
    STATE(1175), 1,
      sym_class_interface_clause,
  [32405] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2072), 1,
      anon_sym_COMMA,
    STATE(951), 1,
      aux_sym_global_declaration_repeat1,
    STATE(965), 1,
      sym_text_interpolation,
    ACTIONS(2207), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32425] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2068), 1,
      anon_sym_COMMA,
    STATE(941), 1,
      aux_sym_namespace_use_declaration_repeat1,
    STATE(966), 1,
      sym_text_interpolation,
    ACTIONS(2123), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32445] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2129), 1,
      anon_sym_COMMA,
    STATE(921), 1,
      aux_sym_property_declaration_repeat2,
    STATE(967), 1,
      sym_text_interpolation,
    ACTIONS(2209), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32465] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_COLON,
    ACTIONS(1872), 1,
      anon_sym_LBRACE,
    STATE(597), 1,
      sym_compound_statement,
    STATE(968), 1,
      sym_text_interpolation,
    STATE(1257), 1,
      sym__return_type,
  [32487] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2201), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      anon_sym_LBRACK,
    ACTIONS(2211), 1,
      anon_sym_DASH_GT,
    STATE(969), 1,
      sym_text_interpolation,
  [32509] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(970), 1,
      sym_text_interpolation,
    ACTIONS(2213), 4,
      anon_sym_LBRACE,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [32525] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(971), 1,
      sym_text_interpolation,
    ACTIONS(1850), 4,
      anon_sym_static,
      anon_sym_self,
      anon_sym_parent,
      sym_name,
  [32541] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2084), 1,
      anon_sym_LBRACE,
    ACTIONS(2088), 1,
      anon_sym_LBRACK,
    ACTIONS(2215), 1,
      anon_sym_DASH_GT,
    STATE(972), 1,
      sym_text_interpolation,
  [32563] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(973), 1,
      sym_text_interpolation,
    ACTIONS(2217), 4,
      anon_sym_LBRACE,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [32579] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2074), 1,
      anon_sym_LBRACE,
    ACTIONS(2078), 1,
      anon_sym_LBRACK,
    ACTIONS(2219), 1,
      anon_sym_DASH_GT,
    STATE(974), 1,
      sym_text_interpolation,
  [32601] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(975), 1,
      sym_text_interpolation,
    ACTIONS(2221), 4,
      anon_sym_LBRACE,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [32617] = 7,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2201), 1,
      anon_sym_LBRACE,
    ACTIONS(2205), 1,
      anon_sym_LBRACK,
    ACTIONS(2223), 1,
      anon_sym_DASH_GT,
    STATE(976), 1,
      sym_text_interpolation,
  [32639] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1039), 1,
      anon_sym_else,
    STATE(977), 1,
      sym_text_interpolation,
    ACTIONS(1037), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32656] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(550), 1,
      anon_sym_RBRACK,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    STATE(978), 1,
      sym_text_interpolation,
    STATE(1101), 1,
      aux_sym_array_creation_expression_repeat1,
  [32675] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(791), 1,
      anon_sym_else,
    STATE(979), 1,
      sym_text_interpolation,
    ACTIONS(789), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32692] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(931), 1,
      anon_sym_else,
    STATE(980), 1,
      sym_text_interpolation,
    ACTIONS(929), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32709] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    STATE(368), 1,
      sym_arguments,
    STATE(981), 1,
      sym_text_interpolation,
  [32728] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(759), 1,
      anon_sym_else,
    STATE(982), 1,
      sym_text_interpolation,
    ACTIONS(757), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32745] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(771), 1,
      anon_sym_else,
    STATE(983), 1,
      sym_text_interpolation,
    ACTIONS(769), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32762] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(771), 1,
      anon_sym_else,
    STATE(984), 1,
      sym_text_interpolation,
    ACTIONS(769), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32779] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(835), 1,
      anon_sym_else,
    STATE(985), 1,
      sym_text_interpolation,
    ACTIONS(833), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32796] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(843), 1,
      anon_sym_else,
    STATE(986), 1,
      sym_text_interpolation,
    ACTIONS(841), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32813] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(855), 1,
      anon_sym_else,
    STATE(987), 1,
      sym_text_interpolation,
    ACTIONS(853), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32830] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(967), 1,
      anon_sym_else,
    STATE(988), 1,
      sym_text_interpolation,
    ACTIONS(965), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32847] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_LBRACE,
    ACTIONS(2227), 1,
      anon_sym_COMMA,
    STATE(989), 2,
      sym_text_interpolation,
      aux_sym_interface_base_clause_repeat1,
  [32864] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(831), 1,
      anon_sym_else,
    STATE(990), 1,
      sym_text_interpolation,
    ACTIONS(829), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32881] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_else,
    STATE(991), 1,
      sym_text_interpolation,
    ACTIONS(2230), 2,
      anon_sym_endif,
      anon_sym_elseif,
  [32898] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(847), 1,
      anon_sym_else,
    STATE(992), 1,
      sym_text_interpolation,
    ACTIONS(845), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32915] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(993), 1,
      sym_text_interpolation,
    ACTIONS(2234), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [32930] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(879), 1,
      anon_sym_else,
    STATE(994), 1,
      sym_text_interpolation,
    ACTIONS(877), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32947] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(891), 1,
      anon_sym_else,
    STATE(995), 1,
      sym_text_interpolation,
    ACTIONS(889), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32964] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(907), 1,
      anon_sym_else,
    STATE(996), 1,
      sym_text_interpolation,
    ACTIONS(905), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32981] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(947), 1,
      anon_sym_else,
    STATE(997), 1,
      sym_text_interpolation,
    ACTIONS(945), 2,
      anon_sym_while,
      anon_sym_elseif,
  [32998] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(947), 1,
      anon_sym_else,
    STATE(998), 1,
      sym_text_interpolation,
    ACTIONS(945), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33015] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(875), 1,
      anon_sym_else,
    STATE(999), 1,
      sym_text_interpolation,
    ACTIONS(873), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33032] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1039), 1,
      anon_sym_else,
    STATE(1000), 1,
      sym_text_interpolation,
    ACTIONS(1037), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33049] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1031), 1,
      anon_sym_else,
    STATE(1001), 1,
      sym_text_interpolation,
    ACTIONS(1029), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33066] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1023), 1,
      anon_sym_else,
    STATE(1002), 1,
      sym_text_interpolation,
    ACTIONS(1021), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33083] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1015), 1,
      anon_sym_else,
    STATE(1003), 1,
      sym_text_interpolation,
    ACTIONS(1013), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33100] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1007), 1,
      anon_sym_else,
    STATE(1004), 1,
      sym_text_interpolation,
    ACTIONS(1005), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33117] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_COMMA,
    ACTIONS(1479), 1,
      anon_sym_RPAREN,
    STATE(1005), 1,
      sym_text_interpolation,
    STATE(1062), 1,
      aux_sym_arguments_repeat1,
  [33136] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_else,
    STATE(1006), 1,
      sym_text_interpolation,
    ACTIONS(993), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33153] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_else,
    STATE(1007), 1,
      sym_text_interpolation,
    ACTIONS(993), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33170] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(987), 1,
      anon_sym_else,
    STATE(1008), 1,
      sym_text_interpolation,
    ACTIONS(985), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33187] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(987), 1,
      anon_sym_else,
    STATE(1009), 1,
      sym_text_interpolation,
    ACTIONS(985), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33204] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(983), 1,
      anon_sym_else,
    STATE(1010), 1,
      sym_text_interpolation,
    ACTIONS(981), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33221] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(971), 1,
      anon_sym_else,
    STATE(1011), 1,
      sym_text_interpolation,
    ACTIONS(969), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33238] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(971), 1,
      anon_sym_else,
    STATE(1012), 1,
      sym_text_interpolation,
    ACTIONS(969), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33255] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(959), 1,
      anon_sym_else,
    STATE(1013), 1,
      sym_text_interpolation,
    ACTIONS(957), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33272] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(955), 1,
      anon_sym_else,
    STATE(1014), 1,
      sym_text_interpolation,
    ACTIONS(953), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33289] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(943), 1,
      anon_sym_else,
    STATE(1015), 1,
      sym_text_interpolation,
    ACTIONS(941), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33306] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(903), 1,
      anon_sym_else,
    STATE(1016), 1,
      sym_text_interpolation,
    ACTIONS(901), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33323] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_else,
    STATE(1017), 1,
      sym_text_interpolation,
    ACTIONS(897), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33340] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1018), 1,
      sym_text_interpolation,
    ACTIONS(1155), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [33355] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1019), 1,
      sym_text_interpolation,
    ACTIONS(2178), 3,
      anon_sym_use,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [33370] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1312), 1,
      anon_sym_DOLLAR,
    STATE(873), 1,
      sym_variable_name,
    STATE(1020), 1,
      sym_text_interpolation,
    STATE(1074), 1,
      sym_property_element,
  [33389] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(887), 1,
      anon_sym_else,
    STATE(1021), 1,
      sym_text_interpolation,
    ACTIONS(885), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33406] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(895), 1,
      anon_sym_else,
    STATE(1022), 1,
      sym_text_interpolation,
    ACTIONS(893), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33423] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_COMMA,
    ACTIONS(2238), 1,
      anon_sym_RPAREN,
    STATE(1023), 1,
      sym_text_interpolation,
    STATE(1064), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
  [33442] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2240), 1,
      anon_sym_COMMA,
    ACTIONS(2242), 1,
      anon_sym_LBRACE,
    STATE(1024), 1,
      sym_text_interpolation,
    STATE(1080), 1,
      aux_sym_interface_base_clause_repeat1,
  [33461] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(951), 1,
      anon_sym_else,
    STATE(1025), 1,
      sym_text_interpolation,
    ACTIONS(949), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33478] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    ACTIONS(2244), 1,
      anon_sym_AMP,
    STATE(1026), 1,
      sym_text_interpolation,
    STATE(1284), 1,
      sym_variable_name,
  [33497] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1027), 1,
      sym_text_interpolation,
    ACTIONS(1204), 3,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOLLAR,
  [33512] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_COMMA,
    ACTIONS(2238), 1,
      anon_sym_RPAREN,
    STATE(1028), 1,
      sym_text_interpolation,
    STATE(1063), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
  [33531] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(963), 1,
      anon_sym_else,
    STATE(1029), 1,
      sym_text_interpolation,
    ACTIONS(961), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33548] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(999), 1,
      anon_sym_else,
    STATE(1030), 1,
      sym_text_interpolation,
    ACTIONS(997), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33565] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2246), 1,
      anon_sym_COMMA,
    ACTIONS(2248), 1,
      anon_sym_RBRACE,
    STATE(1031), 1,
      sym_text_interpolation,
    STATE(1061), 1,
      aux_sym_namespace_use_group_repeat1,
  [33584] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1011), 1,
      anon_sym_else,
    STATE(1032), 1,
      sym_text_interpolation,
    ACTIONS(1009), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33601] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1035), 1,
      anon_sym_else,
    STATE(1033), 1,
      sym_text_interpolation,
    ACTIONS(1033), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33618] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2246), 1,
      anon_sym_COMMA,
    ACTIONS(2250), 1,
      anon_sym_RBRACE,
    STATE(1031), 1,
      aux_sym_namespace_use_group_repeat1,
    STATE(1034), 1,
      sym_text_interpolation,
  [33637] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1035), 1,
      anon_sym_else,
    STATE(1035), 1,
      sym_text_interpolation,
    ACTIONS(1033), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33654] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2252), 1,
      anon_sym_LBRACE,
    ACTIONS(2254), 1,
      anon_sym_COLON,
    STATE(299), 1,
      sym_switch_block,
    STATE(1036), 1,
      sym_text_interpolation,
  [33673] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_COMMA,
    ACTIONS(2256), 1,
      anon_sym_RPAREN,
    STATE(1037), 1,
      sym_text_interpolation,
    STATE(1045), 1,
      aux_sym_arguments_repeat1,
  [33692] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1038), 1,
      sym_text_interpolation,
    ACTIONS(2180), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [33707] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1039), 1,
      sym_text_interpolation,
    ACTIONS(2165), 3,
      anon_sym_use,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [33722] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1019), 1,
      anon_sym_else,
    STATE(1040), 1,
      sym_text_interpolation,
    ACTIONS(1017), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33739] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2258), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_RPAREN,
    STATE(1041), 2,
      sym_text_interpolation,
      aux_sym_formal_parameters_repeat1,
  [33756] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_COMMA,
    ACTIONS(1483), 1,
      anon_sym_RPAREN,
    STATE(1037), 1,
      aux_sym_arguments_repeat1,
    STATE(1042), 1,
      sym_text_interpolation,
  [33775] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1043), 1,
      sym_text_interpolation,
    ACTIONS(2173), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [33790] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    ACTIONS(2263), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1044), 1,
      sym_text_interpolation,
    STATE(1131), 1,
      sym_variable_name,
  [33809] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1531), 1,
      anon_sym_RPAREN,
    ACTIONS(2265), 1,
      anon_sym_COMMA,
    STATE(1045), 2,
      sym_text_interpolation,
      aux_sym_arguments_repeat1,
  [33826] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_else,
    STATE(1046), 1,
      sym_text_interpolation,
    ACTIONS(1001), 2,
      anon_sym_while,
      anon_sym_elseif,
  [33843] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2270), 1,
      anon_sym_EQ,
    STATE(1047), 1,
      sym_text_interpolation,
    ACTIONS(2268), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [33860] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1048), 1,
      sym_text_interpolation,
    ACTIONS(2272), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [33875] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1049), 1,
      sym_text_interpolation,
    ACTIONS(2274), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [33890] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_COMMA,
    ACTIONS(1756), 1,
      anon_sym_RPAREN,
    STATE(1050), 1,
      sym_text_interpolation,
    STATE(1053), 1,
      aux_sym_list_literal_repeat1,
  [33909] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2278), 1,
      anon_sym_EQ,
    STATE(1051), 1,
      sym_text_interpolation,
    ACTIONS(2276), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [33926] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2282), 1,
      anon_sym_EQ,
    STATE(1052), 1,
      sym_text_interpolation,
    ACTIONS(2280), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [33943] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_COMMA,
    ACTIONS(2284), 1,
      anon_sym_RPAREN,
    STATE(1053), 1,
      sym_text_interpolation,
    STATE(1073), 1,
      aux_sym_list_literal_repeat1,
  [33962] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_COMMA,
    ACTIONS(2286), 1,
      anon_sym_RPAREN,
    STATE(1023), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
    STATE(1054), 1,
      sym_text_interpolation,
  [33981] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    STATE(346), 1,
      sym_arguments,
    STATE(1055), 1,
      sym_text_interpolation,
  [34000] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_COLON,
    ACTIONS(1937), 1,
      anon_sym_LBRACE,
    STATE(1056), 1,
      sym_text_interpolation,
    STATE(1336), 1,
      sym__return_type,
  [34019] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1057), 1,
      sym_text_interpolation,
    ACTIONS(2288), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [34034] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(851), 1,
      anon_sym_else,
    STATE(1058), 1,
      sym_text_interpolation,
    ACTIONS(849), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34051] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_COMMA,
    ACTIONS(2290), 1,
      anon_sym_RPAREN,
    STATE(1045), 1,
      aux_sym_arguments_repeat1,
    STATE(1059), 1,
      sym_text_interpolation,
  [34070] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1214), 1,
      anon_sym_LPAREN,
    STATE(474), 1,
      sym_arguments,
    STATE(1060), 1,
      sym_text_interpolation,
  [34089] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2292), 1,
      anon_sym_COMMA,
    ACTIONS(2295), 1,
      anon_sym_RBRACE,
    STATE(1061), 2,
      sym_text_interpolation,
      aux_sym_namespace_use_group_repeat1,
  [34106] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_COMMA,
    ACTIONS(2297), 1,
      anon_sym_RPAREN,
    STATE(1045), 1,
      aux_sym_arguments_repeat1,
    STATE(1062), 1,
      sym_text_interpolation,
  [34125] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_COMMA,
    ACTIONS(2299), 1,
      anon_sym_RPAREN,
    STATE(1063), 1,
      sym_text_interpolation,
    STATE(1064), 1,
      aux_sym_anonymous_function_use_clause_repeat1,
  [34144] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_COMMA,
    ACTIONS(2304), 1,
      anon_sym_RPAREN,
    STATE(1064), 2,
      sym_text_interpolation,
      aux_sym_anonymous_function_use_clause_repeat1,
  [34161] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1065), 1,
      sym_text_interpolation,
    ACTIONS(2306), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [34176] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(839), 1,
      anon_sym_else,
    STATE(1066), 1,
      sym_text_interpolation,
    ACTIONS(837), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34193] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1067), 1,
      sym_text_interpolation,
    ACTIONS(2155), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [34208] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(975), 1,
      anon_sym_else,
    STATE(1068), 1,
      sym_text_interpolation,
    ACTIONS(973), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34225] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2240), 1,
      anon_sym_COMMA,
    ACTIONS(2308), 1,
      anon_sym_LBRACE,
    STATE(1069), 1,
      sym_text_interpolation,
    STATE(1079), 1,
      aux_sym_interface_base_clause_repeat1,
  [34244] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_LPAREN,
    ACTIONS(2310), 1,
      anon_sym_AMP,
    STATE(794), 1,
      sym_formal_parameters,
    STATE(1070), 1,
      sym_text_interpolation,
  [34263] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(823), 1,
      anon_sym_else,
    STATE(1071), 1,
      sym_text_interpolation,
    ACTIONS(821), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34280] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(927), 1,
      anon_sym_else,
    STATE(1072), 1,
      sym_text_interpolation,
    ACTIONS(925), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34297] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_RPAREN,
    ACTIONS(2312), 1,
      anon_sym_COMMA,
    STATE(1073), 2,
      sym_text_interpolation,
      aux_sym_list_literal_repeat1,
  [34314] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1074), 1,
      sym_text_interpolation,
    ACTIONS(2112), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [34329] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_COMMA,
    ACTIONS(2315), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_list_literal_repeat1,
    STATE(1075), 1,
      sym_text_interpolation,
  [34348] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1027), 1,
      anon_sym_else,
    STATE(1076), 1,
      sym_text_interpolation,
    ACTIONS(1025), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34365] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(863), 1,
      anon_sym_else,
    STATE(1077), 1,
      sym_text_interpolation,
    ACTIONS(861), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34382] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1078), 1,
      sym_text_interpolation,
    ACTIONS(2317), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [34397] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2240), 1,
      anon_sym_COMMA,
    ACTIONS(2319), 1,
      anon_sym_LBRACE,
    STATE(989), 1,
      aux_sym_interface_base_clause_repeat1,
    STATE(1079), 1,
      sym_text_interpolation,
  [34416] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2240), 1,
      anon_sym_COMMA,
    ACTIONS(2321), 1,
      anon_sym_LBRACE,
    STATE(989), 1,
      aux_sym_interface_base_clause_repeat1,
    STATE(1080), 1,
      sym_text_interpolation,
  [34435] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(991), 1,
      anon_sym_else,
    STATE(1081), 1,
      sym_text_interpolation,
    ACTIONS(989), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34452] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    ACTIONS(2323), 1,
      anon_sym_AMP,
    STATE(1054), 1,
      sym_variable_name,
    STATE(1082), 1,
      sym_text_interpolation,
  [34471] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_LPAREN,
    ACTIONS(2325), 1,
      anon_sym_AMP,
    STATE(831), 1,
      sym_formal_parameters,
    STATE(1083), 1,
      sym_text_interpolation,
  [34490] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(763), 1,
      anon_sym_else,
    STATE(1084), 1,
      sym_text_interpolation,
    ACTIONS(761), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34507] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(783), 1,
      anon_sym_else,
    STATE(1085), 1,
      sym_text_interpolation,
    ACTIONS(781), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34524] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1086), 1,
      sym_text_interpolation,
    ACTIONS(2094), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [34539] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2327), 1,
      anon_sym_COMMA,
    ACTIONS(2329), 1,
      anon_sym_RPAREN,
    STATE(1087), 1,
      sym_text_interpolation,
    STATE(1117), 1,
      aux_sym_formal_parameters_repeat1,
  [34558] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1088), 1,
      sym_text_interpolation,
    ACTIONS(2331), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [34573] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1089), 1,
      sym_text_interpolation,
    ACTIONS(2333), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [34588] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1090), 1,
      sym_text_interpolation,
    ACTIONS(2131), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [34603] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1091), 1,
      sym_text_interpolation,
    ACTIONS(2213), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [34618] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1092), 1,
      sym_text_interpolation,
    ACTIONS(2335), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [34633] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    STATE(1093), 1,
      sym_text_interpolation,
    STATE(900), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [34650] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(911), 1,
      anon_sym_else,
    STATE(1094), 1,
      sym_text_interpolation,
    ACTIONS(909), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34667] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(859), 1,
      anon_sym_else,
    STATE(1095), 1,
      sym_text_interpolation,
    ACTIONS(857), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34684] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(803), 1,
      anon_sym_else,
    STATE(1096), 1,
      sym_text_interpolation,
    ACTIONS(801), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34701] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_COMMA,
    ACTIONS(1485), 1,
      anon_sym_RPAREN,
    STATE(1059), 1,
      aux_sym_arguments_repeat1,
    STATE(1097), 1,
      sym_text_interpolation,
  [34720] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_else,
    STATE(1098), 1,
      sym_text_interpolation,
    ACTIONS(2337), 2,
      anon_sym_endif,
      anon_sym_elseif,
  [34737] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1099), 1,
      sym_text_interpolation,
    ACTIONS(2341), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [34752] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_LPAREN,
    ACTIONS(2343), 1,
      anon_sym_AMP,
    STATE(814), 1,
      sym_formal_parameters,
    STATE(1100), 1,
      sym_text_interpolation,
  [34771] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(606), 1,
      anon_sym_RBRACK,
    ACTIONS(2345), 1,
      anon_sym_COMMA,
    STATE(938), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(1101), 1,
      sym_text_interpolation,
  [34790] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_COMMA,
    ACTIONS(2347), 1,
      anon_sym_RPAREN,
    STATE(1045), 1,
      aux_sym_arguments_repeat1,
    STATE(1102), 1,
      sym_text_interpolation,
  [34809] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(819), 1,
      anon_sym_else,
    STATE(1103), 1,
      sym_text_interpolation,
    ACTIONS(817), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34826] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_COMMA,
    ACTIONS(1139), 1,
      anon_sym_RPAREN,
    STATE(1073), 1,
      aux_sym_list_literal_repeat1,
    STATE(1104), 1,
      sym_text_interpolation,
  [34845] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1105), 1,
      sym_text_interpolation,
    ACTIONS(2349), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [34860] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2351), 1,
      sym_name,
    STATE(1106), 1,
      sym_text_interpolation,
    ACTIONS(2353), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [34877] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1740), 1,
      anon_sym_COMMA,
    ACTIONS(2355), 1,
      anon_sym_RPAREN,
    STATE(1107), 1,
      sym_text_interpolation,
    STATE(1148), 1,
      aux_sym_unset_statement_repeat1,
  [34896] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    STATE(1108), 1,
      sym_text_interpolation,
    STATE(909), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [34913] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_LPAREN,
    ACTIONS(2357), 1,
      anon_sym_AMP,
    STATE(797), 1,
      sym_formal_parameters,
    STATE(1109), 1,
      sym_text_interpolation,
  [34932] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(979), 1,
      anon_sym_else,
    STATE(1110), 1,
      sym_text_interpolation,
    ACTIONS(977), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34949] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    ACTIONS(2359), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1047), 1,
      sym_variable_name,
    STATE(1111), 1,
      sym_text_interpolation,
  [34968] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(939), 1,
      anon_sym_else,
    STATE(1112), 1,
      sym_text_interpolation,
    ACTIONS(937), 2,
      anon_sym_while,
      anon_sym_elseif,
  [34985] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(935), 1,
      anon_sym_else,
    STATE(1113), 1,
      sym_text_interpolation,
    ACTIONS(933), 2,
      anon_sym_while,
      anon_sym_elseif,
  [35002] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(755), 1,
      anon_sym_else,
    STATE(1114), 1,
      sym_text_interpolation,
    ACTIONS(753), 2,
      anon_sym_while,
      anon_sym_elseif,
  [35019] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(923), 1,
      anon_sym_else,
    STATE(1115), 1,
      sym_text_interpolation,
    ACTIONS(921), 2,
      anon_sym_while,
      anon_sym_elseif,
  [35036] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(600), 1,
      anon_sym_RPAREN,
    ACTIONS(2361), 1,
      anon_sym_COMMA,
    STATE(938), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(1116), 1,
      sym_text_interpolation,
  [35055] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2327), 1,
      anon_sym_COMMA,
    ACTIONS(2363), 1,
      anon_sym_RPAREN,
    STATE(1041), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(1117), 1,
      sym_text_interpolation,
  [35074] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(919), 1,
      anon_sym_else,
    STATE(1118), 1,
      sym_text_interpolation,
    ACTIONS(917), 2,
      anon_sym_while,
      anon_sym_elseif,
  [35091] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1866), 1,
      anon_sym_COLON,
    ACTIONS(2041), 1,
      anon_sym_LBRACE,
    STATE(1119), 1,
      sym_text_interpolation,
    STATE(1347), 1,
      sym__return_type,
  [35110] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2327), 1,
      anon_sym_COMMA,
    ACTIONS(2365), 1,
      anon_sym_RPAREN,
    STATE(1041), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(1120), 1,
      sym_text_interpolation,
  [35129] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2367), 1,
      anon_sym_LBRACE,
    ACTIONS(2369), 1,
      anon_sym_COLON,
    STATE(1110), 1,
      sym_switch_block,
    STATE(1121), 1,
      sym_text_interpolation,
  [35148] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(915), 1,
      anon_sym_else,
    STATE(1122), 1,
      sym_text_interpolation,
    ACTIONS(913), 2,
      anon_sym_while,
      anon_sym_elseif,
  [35165] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(883), 1,
      anon_sym_else,
    STATE(1123), 1,
      sym_text_interpolation,
    ACTIONS(881), 2,
      anon_sym_while,
      anon_sym_elseif,
  [35182] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(799), 1,
      anon_sym_else,
    STATE(1124), 1,
      sym_text_interpolation,
    ACTIONS(797), 2,
      anon_sym_while,
      anon_sym_elseif,
  [35199] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_LPAREN,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    STATE(424), 1,
      sym_arguments,
    STATE(1125), 1,
      sym_text_interpolation,
  [35218] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1312), 1,
      anon_sym_DOLLAR,
    STATE(892), 1,
      sym_variable_name,
    STATE(1038), 1,
      sym_static_variable_declaration,
    STATE(1126), 1,
      sym_text_interpolation,
  [35237] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(554), 1,
      anon_sym_RBRACK,
    ACTIONS(2371), 1,
      anon_sym_COMMA,
    STATE(1127), 1,
      sym_text_interpolation,
    STATE(1152), 1,
      aux_sym_array_creation_expression_repeat1,
  [35256] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1128), 1,
      sym_text_interpolation,
    ACTIONS(2133), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [35271] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(827), 1,
      anon_sym_else,
    STATE(1129), 1,
      sym_text_interpolation,
    ACTIONS(825), 2,
      anon_sym_while,
      anon_sym_elseif,
  [35288] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(815), 1,
      anon_sym_else,
    STATE(1130), 1,
      sym_text_interpolation,
    ACTIONS(813), 2,
      anon_sym_while,
      anon_sym_elseif,
  [35305] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2375), 1,
      anon_sym_EQ,
    STATE(1131), 1,
      sym_text_interpolation,
    ACTIONS(2373), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [35322] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2007), 1,
      anon_sym_BSLASH,
    ACTIONS(2377), 1,
      sym_name,
    STATE(1132), 1,
      sym_text_interpolation,
    STATE(1373), 1,
      sym_namespace_name,
  [35341] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(606), 1,
      anon_sym_RPAREN,
    ACTIONS(2379), 1,
      anon_sym_COMMA,
    STATE(1133), 1,
      sym_text_interpolation,
    STATE(1150), 1,
      aux_sym_array_creation_expression_repeat1,
  [35360] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(266), 1,
      anon_sym_DOLLAR,
    STATE(1134), 1,
      sym_text_interpolation,
    STATE(1043), 2,
      sym_dynamic_variable_name,
      sym_variable_name,
  [35377] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1135), 1,
      sym_text_interpolation,
    ACTIONS(2169), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [35392] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1136), 1,
      sym_text_interpolation,
    ACTIONS(2221), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [35407] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1137), 1,
      sym_text_interpolation,
    ACTIONS(2217), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [35422] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1740), 1,
      anon_sym_COMMA,
    ACTIONS(2381), 1,
      anon_sym_RPAREN,
    STATE(1138), 1,
      sym_text_interpolation,
    STATE(1148), 1,
      aux_sym_unset_statement_repeat1,
  [35441] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1139), 1,
      sym_text_interpolation,
    ACTIONS(2099), 3,
      anon_sym_use,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [35456] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2062), 1,
      anon_sym_EQ,
    STATE(1140), 1,
      sym_text_interpolation,
    ACTIONS(1145), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [35473] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2327), 1,
      anon_sym_COMMA,
    ACTIONS(2383), 1,
      anon_sym_RPAREN,
    STATE(1120), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(1141), 1,
      sym_text_interpolation,
  [35492] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(767), 1,
      anon_sym_else,
    STATE(1142), 1,
      sym_text_interpolation,
    ACTIONS(765), 2,
      anon_sym_while,
      anon_sym_elseif,
  [35509] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(775), 1,
      anon_sym_else,
    STATE(1143), 1,
      sym_text_interpolation,
    ACTIONS(773), 2,
      anon_sym_while,
      anon_sym_elseif,
  [35526] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(779), 1,
      anon_sym_else,
    STATE(1144), 1,
      sym_text_interpolation,
    ACTIONS(777), 2,
      anon_sym_while,
      anon_sym_elseif,
  [35543] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(787), 1,
      anon_sym_else,
    STATE(1145), 1,
      sym_text_interpolation,
    ACTIONS(785), 2,
      anon_sym_while,
      anon_sym_elseif,
  [35560] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_COMMA,
    ACTIONS(1491), 1,
      anon_sym_RPAREN,
    STATE(1102), 1,
      aux_sym_arguments_repeat1,
    STATE(1146), 1,
      sym_text_interpolation,
  [35579] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(807), 1,
      anon_sym_else,
    STATE(1147), 1,
      sym_text_interpolation,
    ACTIONS(805), 2,
      anon_sym_while,
      anon_sym_elseif,
  [35596] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1820), 1,
      anon_sym_RPAREN,
    ACTIONS(2385), 1,
      anon_sym_COMMA,
    STATE(1148), 2,
      sym_text_interpolation,
      aux_sym_unset_statement_repeat1,
  [35613] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1149), 1,
      sym_text_interpolation,
    ACTIONS(1736), 3,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      sym_name,
  [35628] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(596), 1,
      anon_sym_RPAREN,
    ACTIONS(2388), 1,
      anon_sym_COMMA,
    STATE(938), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(1150), 1,
      sym_text_interpolation,
  [35647] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(604), 1,
      anon_sym_RPAREN,
    ACTIONS(2390), 1,
      anon_sym_COMMA,
    STATE(1116), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(1151), 1,
      sym_text_interpolation,
  [35666] = 6,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(604), 1,
      anon_sym_RBRACK,
    ACTIONS(2392), 1,
      anon_sym_COMMA,
    STATE(938), 1,
      aux_sym_array_creation_expression_repeat1,
    STATE(1152), 1,
      sym_text_interpolation,
  [35685] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1043), 1,
      anon_sym_else,
    STATE(1153), 1,
      sym_text_interpolation,
    ACTIONS(1041), 2,
      anon_sym_while,
      anon_sym_elseif,
  [35702] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    STATE(1154), 1,
      sym_text_interpolation,
    STATE(1300), 1,
      sym_variable_name,
  [35718] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1155), 1,
      sym_text_interpolation,
    ACTIONS(2394), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35732] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_LPAREN,
    STATE(831), 1,
      sym_formal_parameters,
    STATE(1156), 1,
      sym_text_interpolation,
  [35748] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1872), 1,
      anon_sym_LBRACE,
    STATE(616), 1,
      sym_compound_statement,
    STATE(1157), 1,
      sym_text_interpolation,
  [35764] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    STATE(872), 1,
      sym_compound_statement,
    STATE(1158), 1,
      sym_text_interpolation,
  [35780] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1834), 1,
      anon_sym_LBRACE,
    STATE(493), 1,
      sym_declaration_list,
    STATE(1159), 1,
      sym_text_interpolation,
  [35796] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(466), 1,
      ts_builtin_sym_end,
    ACTIONS(2396), 1,
      sym_php_tag,
    STATE(1160), 1,
      sym_text_interpolation,
  [35812] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1161), 1,
      sym_text_interpolation,
    ACTIONS(2398), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [35826] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1834), 1,
      anon_sym_LBRACE,
    STATE(1085), 1,
      sym_declaration_list,
    STATE(1162), 1,
      sym_text_interpolation,
  [35842] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    STATE(1163), 1,
      sym_text_interpolation,
    STATE(1342), 1,
      sym_variable_name,
  [35858] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    STATE(490), 1,
      sym_compound_statement,
    STATE(1164), 1,
      sym_text_interpolation,
  [35874] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1525), 1,
      anon_sym_RPAREN,
    ACTIONS(2062), 1,
      anon_sym_EQ,
    STATE(1165), 1,
      sym_text_interpolation,
  [35890] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2400), 1,
      anon_sym_LPAREN,
    STATE(888), 1,
      sym_formal_parameters,
    STATE(1166), 1,
      sym_text_interpolation,
  [35906] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_LPAREN,
    STATE(814), 1,
      sym_formal_parameters,
    STATE(1167), 1,
      sym_text_interpolation,
  [35922] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    STATE(500), 1,
      sym_compound_statement,
    STATE(1168), 1,
      sym_text_interpolation,
  [35938] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1874), 1,
      anon_sym_LBRACE,
    STATE(222), 1,
      sym_declaration_list,
    STATE(1169), 1,
      sym_text_interpolation,
  [35954] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_LBRACE,
    STATE(250), 1,
      sym_declaration_list,
    STATE(1170), 1,
      sym_text_interpolation,
  [35970] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1171), 1,
      sym_text_interpolation,
    ACTIONS(2121), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [35984] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    STATE(1172), 1,
      sym_text_interpolation,
    STATE(1256), 1,
      sym_variable_name,
  [36000] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    STATE(501), 1,
      sym_compound_statement,
    STATE(1173), 1,
      sym_text_interpolation,
  [36016] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1157), 1,
      anon_sym_BSLASH,
    STATE(1174), 1,
      sym_text_interpolation,
    STATE(1308), 1,
      aux_sym_namespace_name_repeat1,
  [36032] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LBRACE,
    STATE(861), 1,
      sym_declaration_list,
    STATE(1175), 1,
      sym_text_interpolation,
  [36048] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1176), 1,
      sym_text_interpolation,
    ACTIONS(1495), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [36062] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1177), 1,
      sym_text_interpolation,
    ACTIONS(2161), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36076] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1178), 1,
      sym_text_interpolation,
    ACTIONS(2402), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36090] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    STATE(1179), 1,
      sym_text_interpolation,
    STATE(1351), 1,
      sym_variable_name,
  [36106] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1180), 1,
      sym_text_interpolation,
    ACTIONS(2404), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36120] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1181), 1,
      sym_text_interpolation,
    ACTIONS(2406), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36134] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(62), 1,
      sym_parenthesized_expression,
    STATE(1182), 1,
      sym_text_interpolation,
  [36150] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1183), 1,
      sym_text_interpolation,
    ACTIONS(2410), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36164] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1184), 1,
      sym_text_interpolation,
    ACTIONS(2412), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36178] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1185), 1,
      sym_text_interpolation,
    ACTIONS(1854), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36192] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1186), 1,
      sym_text_interpolation,
    ACTIONS(2414), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36206] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1834), 1,
      anon_sym_LBRACE,
    STATE(506), 1,
      sym_declaration_list,
    STATE(1187), 1,
      sym_text_interpolation,
  [36222] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1188), 1,
      sym_text_interpolation,
    ACTIONS(2416), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36236] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1872), 1,
      anon_sym_LBRACE,
    STATE(560), 1,
      sym_compound_statement,
    STATE(1189), 1,
      sym_text_interpolation,
  [36252] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1834), 1,
      anon_sym_LBRACE,
    STATE(1130), 1,
      sym_declaration_list,
    STATE(1190), 1,
      sym_text_interpolation,
  [36268] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2400), 1,
      anon_sym_LPAREN,
    STATE(848), 1,
      sym_formal_parameters,
    STATE(1191), 1,
      sym_text_interpolation,
  [36284] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LBRACE,
    STATE(852), 1,
      sym_declaration_list,
    STATE(1192), 1,
      sym_text_interpolation,
  [36300] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    STATE(1161), 1,
      sym_variable_name,
    STATE(1193), 1,
      sym_text_interpolation,
  [36316] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    STATE(1194), 1,
      sym_text_interpolation,
    STATE(1249), 1,
      sym_variable_name,
  [36332] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    STATE(512), 1,
      sym_compound_statement,
    STATE(1195), 1,
      sym_text_interpolation,
  [36348] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_LPAREN,
    STATE(1119), 1,
      sym_formal_parameters,
    STATE(1196), 1,
      sym_text_interpolation,
  [36364] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    STATE(514), 1,
      sym_compound_statement,
    STATE(1197), 1,
      sym_text_interpolation,
  [36380] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1198), 1,
      sym_text_interpolation,
    ACTIONS(2418), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36394] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_LBRACE,
    STATE(121), 1,
      sym_compound_statement,
    STATE(1199), 1,
      sym_text_interpolation,
  [36410] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1200), 1,
      sym_text_interpolation,
    ACTIONS(2420), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36424] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    STATE(994), 1,
      sym_compound_statement,
    STATE(1201), 1,
      sym_text_interpolation,
  [36440] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1202), 1,
      sym_text_interpolation,
    ACTIONS(2422), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36454] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1203), 1,
      sym_text_interpolation,
    ACTIONS(2424), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36468] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1204), 1,
      sym_text_interpolation,
    ACTIONS(2426), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36482] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1834), 1,
      anon_sym_LBRACE,
    STATE(517), 1,
      sym_declaration_list,
    STATE(1205), 1,
      sym_text_interpolation,
  [36498] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LBRACE,
    STATE(853), 1,
      sym_declaration_list,
    STATE(1206), 1,
      sym_text_interpolation,
  [36514] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(337), 1,
      sym_arguments,
    STATE(1207), 1,
      sym_text_interpolation,
  [36530] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    STATE(519), 1,
      sym_compound_statement,
    STATE(1208), 1,
      sym_text_interpolation,
  [36546] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1209), 1,
      sym_text_interpolation,
    ACTIONS(2428), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36560] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1210), 1,
      sym_text_interpolation,
    ACTIONS(2430), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36574] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1211), 1,
      sym_text_interpolation,
    ACTIONS(2432), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [36588] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1212), 1,
      sym_text_interpolation,
    ACTIONS(2434), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36602] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1213), 1,
      sym_text_interpolation,
    ACTIONS(2436), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36616] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1214), 1,
      sym_text_interpolation,
    ACTIONS(2438), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36630] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    STATE(855), 1,
      sym_compound_statement,
    STATE(1215), 1,
      sym_text_interpolation,
  [36646] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1216), 1,
      sym_text_interpolation,
    ACTIONS(420), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36660] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(38), 1,
      sym_parenthesized_expression,
    STATE(1217), 1,
      sym_text_interpolation,
  [36676] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1874), 1,
      anon_sym_LBRACE,
    STATE(160), 1,
      sym_declaration_list,
    STATE(1218), 1,
      sym_text_interpolation,
  [36692] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1219), 1,
      sym_text_interpolation,
    ACTIONS(430), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36706] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym_parenthesized_expression,
    STATE(1220), 1,
      sym_text_interpolation,
  [36722] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1221), 1,
      sym_text_interpolation,
    ACTIONS(2440), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36736] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1222), 1,
      sym_text_interpolation,
    ACTIONS(2442), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36750] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1223), 1,
      sym_text_interpolation,
    ACTIONS(2444), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36764] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1224), 1,
      sym_text_interpolation,
    ACTIONS(2446), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36778] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1225), 1,
      sym_text_interpolation,
    ACTIONS(2448), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36792] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    STATE(1226), 1,
      sym_text_interpolation,
    STATE(1258), 1,
      sym_parenthesized_expression,
  [36808] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(320), 1,
      anon_sym_COLON,
    STATE(991), 1,
      sym_colon_block,
    STATE(1227), 1,
      sym_text_interpolation,
  [36824] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_LPAREN,
    STATE(1056), 1,
      sym_formal_parameters,
    STATE(1228), 1,
      sym_text_interpolation,
  [36840] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1229), 1,
      sym_text_interpolation,
    ACTIONS(2452), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36854] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_LBRACE,
    STATE(258), 1,
      sym_declaration_list,
    STATE(1230), 1,
      sym_text_interpolation,
  [36870] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    STATE(844), 1,
      sym_compound_statement,
    STATE(1231), 1,
      sym_text_interpolation,
  [36886] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2454), 1,
      anon_sym_LPAREN,
    ACTIONS(2456), 1,
      anon_sym_RPAREN,
    STATE(1232), 1,
      sym_text_interpolation,
  [36902] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1233), 1,
      sym_text_interpolation,
    ACTIONS(2458), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36916] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(46), 1,
      sym_parenthesized_expression,
    STATE(1234), 1,
      sym_text_interpolation,
  [36932] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym_parenthesized_expression,
    STATE(1235), 1,
      sym_text_interpolation,
  [36948] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2460), 1,
      anon_sym_LPAREN,
    STATE(1036), 1,
      sym_parenthesized_expression,
    STATE(1236), 1,
      sym_text_interpolation,
  [36964] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1237), 1,
      sym_text_interpolation,
    ACTIONS(2462), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36978] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1238), 1,
      sym_text_interpolation,
    ACTIONS(2464), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [36992] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1239), 1,
      sym_text_interpolation,
    ACTIONS(1473), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37006] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1240), 1,
      sym_text_interpolation,
    ACTIONS(2466), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37020] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1241), 1,
      sym_text_interpolation,
    ACTIONS(2468), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37034] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_LPAREN,
    STATE(807), 1,
      sym_formal_parameters,
    STATE(1242), 1,
      sym_text_interpolation,
  [37050] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1243), 1,
      sym_text_interpolation,
    ACTIONS(2470), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37064] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1244), 1,
      sym_text_interpolation,
    ACTIONS(1495), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37078] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1535), 1,
      anon_sym_RPAREN,
    ACTIONS(2062), 1,
      anon_sym_EQ,
    STATE(1245), 1,
      sym_text_interpolation,
  [37094] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1246), 1,
      sym_text_interpolation,
    ACTIONS(2472), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37108] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    STATE(1028), 1,
      sym_variable_name,
    STATE(1247), 1,
      sym_text_interpolation,
  [37124] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1248), 1,
      sym_text_interpolation,
    ACTIONS(2474), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37138] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1249), 1,
      sym_text_interpolation,
    ACTIONS(2476), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [37152] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LBRACE,
    STATE(571), 1,
      sym_declaration_list,
    STATE(1250), 1,
      sym_text_interpolation,
  [37168] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_DOLLAR,
    STATE(1251), 1,
      sym_text_interpolation,
    STATE(1263), 1,
      sym_variable_name,
  [37184] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1252), 1,
      sym_text_interpolation,
    ACTIONS(1531), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [37198] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1874), 1,
      anon_sym_LBRACE,
    STATE(142), 1,
      sym_declaration_list,
    STATE(1253), 1,
      sym_text_interpolation,
  [37214] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_LPAREN,
    STATE(362), 1,
      sym_arguments,
    STATE(1254), 1,
      sym_text_interpolation,
  [37230] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1255), 1,
      sym_text_interpolation,
    ACTIONS(2261), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [37244] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1256), 1,
      sym_text_interpolation,
    ACTIONS(2478), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [37258] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1872), 1,
      anon_sym_LBRACE,
    STATE(561), 1,
      sym_compound_statement,
    STATE(1257), 1,
      sym_text_interpolation,
  [37274] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1258), 1,
      sym_text_interpolation,
    ACTIONS(2480), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37288] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1214), 1,
      anon_sym_LPAREN,
    STATE(480), 1,
      sym_arguments,
    STATE(1259), 1,
      sym_text_interpolation,
  [37304] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1260), 1,
      sym_text_interpolation,
    ACTIONS(2482), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37318] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1261), 1,
      sym_text_interpolation,
    ACTIONS(442), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37332] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1262), 1,
      sym_text_interpolation,
    ACTIONS(2484), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37346] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1263), 1,
      sym_text_interpolation,
    ACTIONS(2486), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [37360] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1264), 1,
      sym_text_interpolation,
    ACTIONS(2488), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [37374] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_LPAREN,
    STATE(57), 1,
      sym_parenthesized_expression,
    STATE(1265), 1,
      sym_text_interpolation,
  [37390] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1266), 1,
      sym_text_interpolation,
    ACTIONS(1950), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [37404] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1872), 1,
      anon_sym_LBRACE,
    STATE(567), 1,
      sym_compound_statement,
    STATE(1267), 1,
      sym_text_interpolation,
  [37420] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1268), 1,
      sym_text_interpolation,
    ACTIONS(2490), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37434] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2492), 1,
      sym_name,
    STATE(954), 1,
      sym_namespace_name,
    STATE(1269), 1,
      sym_text_interpolation,
  [37450] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1270), 1,
      sym_text_interpolation,
    ACTIONS(2494), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37464] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1271), 1,
      sym_text_interpolation,
    ACTIONS(2496), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37478] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1872), 1,
      anon_sym_LBRACE,
    STATE(599), 1,
      sym_compound_statement,
    STATE(1272), 1,
      sym_text_interpolation,
  [37494] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1273), 1,
      sym_text_interpolation,
    ACTIONS(2498), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37508] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1872), 1,
      anon_sym_LBRACE,
    STATE(597), 1,
      sym_compound_statement,
    STATE(1274), 1,
      sym_text_interpolation,
  [37524] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1275), 1,
      sym_text_interpolation,
    ACTIONS(2500), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37538] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1276), 1,
      sym_text_interpolation,
    ACTIONS(1818), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [37552] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1874), 1,
      anon_sym_LBRACE,
    STATE(212), 1,
      sym_declaration_list,
    STATE(1277), 1,
      sym_text_interpolation,
  [37568] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1278), 1,
      sym_text_interpolation,
    ACTIONS(2502), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [37582] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1279), 1,
      sym_text_interpolation,
    ACTIONS(2295), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [37596] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1280), 1,
      sym_text_interpolation,
    ACTIONS(2504), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37610] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1281), 1,
      sym_text_interpolation,
    ACTIONS(2506), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [37624] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1170), 1,
      anon_sym_LPAREN,
    STATE(409), 1,
      sym_arguments,
    STATE(1282), 1,
      sym_text_interpolation,
  [37640] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1283), 1,
      sym_text_interpolation,
    ACTIONS(2508), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37654] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1284), 1,
      sym_text_interpolation,
    ACTIONS(2304), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [37668] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1285), 1,
      sym_text_interpolation,
    ACTIONS(2510), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37682] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1286), 1,
      sym_text_interpolation,
    ACTIONS(2512), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37696] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1287), 1,
      sym_text_interpolation,
    ACTIONS(2353), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37710] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1288), 1,
      sym_text_interpolation,
    ACTIONS(1473), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [37724] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1289), 1,
      sym_text_interpolation,
    ACTIONS(2514), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37738] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LBRACE,
    STATE(878), 1,
      sym_declaration_list,
    STATE(1290), 1,
      sym_text_interpolation,
  [37754] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_LBRACE,
    STATE(137), 1,
      sym_compound_statement,
    STATE(1291), 1,
      sym_text_interpolation,
  [37770] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LBRACE,
    STATE(577), 1,
      sym_declaration_list,
    STATE(1292), 1,
      sym_text_interpolation,
  [37786] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LBRACE,
    STATE(613), 1,
      sym_declaration_list,
    STATE(1293), 1,
      sym_text_interpolation,
  [37802] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1294), 1,
      sym_text_interpolation,
    ACTIONS(2335), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [37816] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1295), 1,
      sym_text_interpolation,
    ACTIONS(1902), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37830] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1296), 1,
      sym_text_interpolation,
    ACTIONS(406), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [37844] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    STATE(1181), 1,
      sym_parenthesized_expression,
    STATE(1297), 1,
      sym_text_interpolation,
  [37860] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1298), 1,
      sym_text_interpolation,
    ACTIONS(2185), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [37874] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2460), 1,
      anon_sym_LPAREN,
    STATE(1227), 1,
      sym_parenthesized_expression,
    STATE(1299), 1,
      sym_text_interpolation,
  [37890] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1300), 1,
      sym_text_interpolation,
    ACTIONS(2516), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [37904] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1301), 1,
      sym_text_interpolation,
    ACTIONS(2518), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
  [37918] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_LPAREN,
    STATE(810), 1,
      sym_formal_parameters,
    STATE(1302), 1,
      sym_text_interpolation,
  [37934] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1303), 1,
      sym_text_interpolation,
    ACTIONS(2520), 2,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [37948] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(192), 1,
      anon_sym_LBRACE,
    STATE(274), 1,
      sym_compound_statement,
    STATE(1304), 1,
      sym_text_interpolation,
  [37964] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(320), 1,
      anon_sym_COLON,
    STATE(1305), 1,
      sym_text_interpolation,
    STATE(1367), 1,
      sym_colon_block,
  [37980] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1617), 1,
      anon_sym_RPAREN,
    ACTIONS(2062), 1,
      anon_sym_EQ,
    STATE(1306), 1,
      sym_text_interpolation,
  [37996] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2460), 1,
      anon_sym_LPAREN,
    STATE(1121), 1,
      sym_parenthesized_expression,
    STATE(1307), 1,
      sym_text_interpolation,
  [38012] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2522), 1,
      anon_sym_BSLASH,
    STATE(890), 1,
      aux_sym_namespace_name_repeat1,
    STATE(1308), 1,
      sym_text_interpolation,
  [38028] = 5,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(310), 1,
      anon_sym_LBRACE,
    STATE(877), 1,
      sym_compound_statement,
    STATE(1309), 1,
      sym_text_interpolation,
  [38044] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2525), 1,
      anon_sym_endif,
    STATE(1310), 1,
      sym_text_interpolation,
  [38057] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2454), 1,
      anon_sym_LPAREN,
    STATE(1311), 1,
      sym_text_interpolation,
  [38070] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2527), 1,
      sym_name,
    STATE(1312), 1,
      sym_text_interpolation,
  [38083] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2529), 1,
      anon_sym_endforeach,
    STATE(1313), 1,
      sym_text_interpolation,
  [38096] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2531), 1,
      sym_name,
    STATE(1314), 1,
      sym_text_interpolation,
  [38109] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2533), 1,
      sym_name,
    STATE(1315), 1,
      sym_text_interpolation,
  [38122] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2535), 1,
      sym_name,
    STATE(1316), 1,
      sym_text_interpolation,
  [38135] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2537), 1,
      sym_name,
    STATE(1317), 1,
      sym_text_interpolation,
  [38148] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2539), 1,
      sym_name,
    STATE(1318), 1,
      sym_text_interpolation,
  [38161] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2541), 1,
      anon_sym_const,
    STATE(1319), 1,
      sym_text_interpolation,
  [38174] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2543), 1,
      sym_name,
    STATE(1320), 1,
      sym_text_interpolation,
  [38187] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_LPAREN,
    STATE(1321), 1,
      sym_text_interpolation,
  [38200] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2547), 1,
      anon_sym_class,
    STATE(1322), 1,
      sym_text_interpolation,
  [38213] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2549), 1,
      anon_sym_RPAREN,
    STATE(1323), 1,
      sym_text_interpolation,
  [38226] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2551), 1,
      anon_sym_COLON_COLON,
    STATE(1324), 1,
      sym_text_interpolation,
  [38239] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2553), 1,
      sym_name,
    STATE(1325), 1,
      sym_text_interpolation,
  [38252] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2555), 1,
      anon_sym_COLON_COLON,
    STATE(1326), 1,
      sym_text_interpolation,
  [38265] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2557), 1,
      anon_sym_RPAREN,
    STATE(1327), 1,
      sym_text_interpolation,
  [38278] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2559), 1,
      anon_sym_endwhile,
    STATE(1328), 1,
      sym_text_interpolation,
  [38291] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2561), 1,
      anon_sym_while,
    STATE(1329), 1,
      sym_text_interpolation,
  [38304] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2563), 1,
      anon_sym_COLON_COLON,
    STATE(1330), 1,
      sym_text_interpolation,
  [38317] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2565), 1,
      anon_sym_COLON_COLON,
    STATE(1331), 1,
      sym_text_interpolation,
  [38330] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2567), 1,
      anon_sym_RPAREN,
    STATE(1332), 1,
      sym_text_interpolation,
  [38343] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2569), 1,
      anon_sym_BSLASH,
    STATE(1333), 1,
      sym_text_interpolation,
  [38356] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2571), 1,
      anon_sym_endforeach,
    STATE(1334), 1,
      sym_text_interpolation,
  [38369] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_COLON_COLON,
    STATE(1335), 1,
      sym_text_interpolation,
  [38382] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2333), 1,
      anon_sym_LBRACE,
    STATE(1336), 1,
      sym_text_interpolation,
  [38395] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2575), 1,
      anon_sym_COLON_COLON,
    STATE(1337), 1,
      sym_text_interpolation,
  [38408] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_endif,
    STATE(1338), 1,
      sym_text_interpolation,
  [38421] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(550), 1,
      anon_sym_RBRACK,
    STATE(1339), 1,
      sym_text_interpolation,
  [38434] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2579), 1,
      anon_sym_RPAREN,
    STATE(1340), 1,
      sym_text_interpolation,
  [38447] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(622), 1,
      anon_sym_RPAREN,
    STATE(1341), 1,
      sym_text_interpolation,
  [38460] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2581), 1,
      anon_sym_RPAREN,
    STATE(1342), 1,
      sym_text_interpolation,
  [38473] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2583), 1,
      anon_sym_COLON_COLON,
    STATE(1343), 1,
      sym_text_interpolation,
  [38486] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(612), 1,
      anon_sym_RPAREN,
    STATE(1344), 1,
      sym_text_interpolation,
  [38499] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(624), 1,
      anon_sym_SEMI,
    STATE(1345), 1,
      sym_text_interpolation,
  [38512] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1535), 1,
      anon_sym_RPAREN,
    STATE(1346), 1,
      sym_text_interpolation,
  [38525] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2288), 1,
      anon_sym_LBRACE,
    STATE(1347), 1,
      sym_text_interpolation,
  [38538] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_BSLASH,
    STATE(1348), 1,
      sym_text_interpolation,
  [38551] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2587), 1,
      anon_sym_endif,
    STATE(1349), 1,
      sym_text_interpolation,
  [38564] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2589), 1,
      anon_sym_RPAREN,
    STATE(1350), 1,
      sym_text_interpolation,
  [38577] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2591), 1,
      anon_sym_RPAREN,
    STATE(1351), 1,
      sym_text_interpolation,
  [38590] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2593), 1,
      anon_sym_EQ,
    STATE(1352), 1,
      sym_text_interpolation,
  [38603] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(610), 1,
      anon_sym_RPAREN,
    STATE(1353), 1,
      sym_text_interpolation,
  [38616] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2595), 1,
      anon_sym_LPAREN,
    STATE(1354), 1,
      sym_text_interpolation,
  [38629] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2597), 1,
      anon_sym_endif,
    STATE(1355), 1,
      sym_text_interpolation,
  [38642] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2599), 1,
      anon_sym_COLON_COLON,
    STATE(1356), 1,
      sym_text_interpolation,
  [38655] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2601), 1,
      anon_sym_RPAREN,
    STATE(1357), 1,
      sym_text_interpolation,
  [38668] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2603), 1,
      anon_sym_RPAREN,
    STATE(1358), 1,
      sym_text_interpolation,
  [38681] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_endforeach,
    STATE(1359), 1,
      sym_text_interpolation,
  [38694] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_COLON_COLON,
    STATE(1360), 1,
      sym_text_interpolation,
  [38707] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1208), 1,
      anon_sym_COLON_COLON,
    STATE(1361), 1,
      sym_text_interpolation,
  [38720] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_endforeach,
    STATE(1362), 1,
      sym_text_interpolation,
  [38733] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2611), 1,
      anon_sym_LPAREN,
    STATE(1363), 1,
      sym_text_interpolation,
  [38746] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2613), 1,
      anon_sym_LPAREN,
    STATE(1364), 1,
      sym_text_interpolation,
  [38759] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2456), 1,
      anon_sym_RPAREN,
    STATE(1365), 1,
      sym_text_interpolation,
  [38772] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2615), 1,
      sym_name,
    STATE(1366), 1,
      sym_text_interpolation,
  [38785] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2617), 1,
      anon_sym_endif,
    STATE(1367), 1,
      sym_text_interpolation,
  [38798] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2619), 1,
      anon_sym_SEMI,
    STATE(1368), 1,
      sym_text_interpolation,
  [38811] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2621), 1,
      anon_sym_EQ,
    STATE(1369), 1,
      sym_text_interpolation,
  [38824] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2623), 1,
      anon_sym_LPAREN,
    STATE(1370), 1,
      sym_text_interpolation,
  [38837] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2625), 1,
      anon_sym_RPAREN,
    STATE(1371), 1,
      sym_text_interpolation,
  [38850] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2627), 1,
      anon_sym_LPAREN,
    STATE(1372), 1,
      sym_text_interpolation,
  [38863] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1976), 1,
      anon_sym_BSLASH,
    STATE(1373), 1,
      sym_text_interpolation,
  [38876] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2629), 1,
      anon_sym_endwhile,
    STATE(1374), 1,
      sym_text_interpolation,
  [38889] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_LPAREN,
    STATE(1375), 1,
      sym_text_interpolation,
  [38902] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_RPAREN,
    STATE(1376), 1,
      sym_text_interpolation,
  [38915] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1941), 1,
      sym_name,
    STATE(1377), 1,
      sym_text_interpolation,
  [38928] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_BSLASH,
    STATE(1378), 1,
      sym_text_interpolation,
  [38941] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2637), 1,
      anon_sym_BSLASH,
    STATE(1379), 1,
      sym_text_interpolation,
  [38954] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2639), 1,
      sym_name,
    STATE(1380), 1,
      sym_text_interpolation,
  [38967] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2062), 1,
      anon_sym_EQ,
    STATE(1381), 1,
      sym_text_interpolation,
  [38980] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2641), 1,
      sym_name,
    STATE(1382), 1,
      sym_text_interpolation,
  [38993] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2643), 1,
      sym_name,
    STATE(1383), 1,
      sym_text_interpolation,
  [39006] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2645), 1,
      anon_sym_BSLASH,
    STATE(1384), 1,
      sym_text_interpolation,
  [39019] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2647), 1,
      anon_sym_class,
    STATE(1385), 1,
      sym_text_interpolation,
  [39032] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1734), 1,
      anon_sym_const,
    STATE(1386), 1,
      sym_text_interpolation,
  [39045] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2649), 1,
      anon_sym_BSLASH,
    STATE(1387), 1,
      sym_text_interpolation,
  [39058] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2651), 1,
      anon_sym_BSLASH,
    STATE(1388), 1,
      sym_text_interpolation,
  [39071] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2653), 1,
      sym_name,
    STATE(1389), 1,
      sym_text_interpolation,
  [39084] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2655), 1,
      anon_sym_while,
    STATE(1390), 1,
      sym_text_interpolation,
  [39097] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2657), 1,
      anon_sym_BSLASH,
    STATE(1391), 1,
      sym_text_interpolation,
  [39110] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2659), 1,
      anon_sym_BSLASH,
    STATE(1392), 1,
      sym_text_interpolation,
  [39123] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_COLON_COLON,
    STATE(1393), 1,
      sym_text_interpolation,
  [39136] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2025), 1,
      sym_name,
    STATE(1394), 1,
      sym_text_interpolation,
  [39149] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2663), 1,
      anon_sym_BSLASH,
    STATE(1395), 1,
      sym_text_interpolation,
  [39162] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(614), 1,
      anon_sym_SEMI,
    STATE(1396), 1,
      sym_text_interpolation,
  [39175] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2665), 1,
      anon_sym_LPAREN,
    STATE(1397), 1,
      sym_text_interpolation,
  [39188] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_RPAREN,
    STATE(1398), 1,
      sym_text_interpolation,
  [39201] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1525), 1,
      anon_sym_RPAREN,
    STATE(1399), 1,
      sym_text_interpolation,
  [39214] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2669), 1,
      anon_sym_SEMI,
    STATE(1400), 1,
      sym_text_interpolation,
  [39227] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2671), 1,
      anon_sym_SEMI,
    STATE(1401), 1,
      sym_text_interpolation,
  [39240] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(618), 1,
      anon_sym_RPAREN,
    STATE(1402), 1,
      sym_text_interpolation,
  [39253] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(554), 1,
      anon_sym_RBRACK,
    STATE(1403), 1,
      sym_text_interpolation,
  [39266] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2673), 1,
      anon_sym_RPAREN,
    STATE(1404), 1,
      sym_text_interpolation,
  [39279] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2675), 1,
      sym_name,
    STATE(1405), 1,
      sym_text_interpolation,
  [39292] = 3,
    ACTIONS(5), 1,
      sym_comment,
    STATE(1406), 1,
      sym_text_interpolation,
    ACTIONS(2677), 2,
      sym__eof,
      sym_php_tag,
  [39303] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2679), 1,
      anon_sym_LPAREN,
    STATE(1407), 1,
      sym_text_interpolation,
  [39316] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2681), 1,
      anon_sym_LPAREN,
    STATE(1408), 1,
      sym_text_interpolation,
  [39329] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2683), 1,
      sym_name,
    STATE(1409), 1,
      sym_text_interpolation,
  [39342] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(606), 1,
      anon_sym_RPAREN,
    STATE(1410), 1,
      sym_text_interpolation,
  [39355] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2685), 1,
      anon_sym_RPAREN,
    STATE(1411), 1,
      sym_text_interpolation,
  [39368] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2687), 1,
      anon_sym_EQ,
    STATE(1412), 1,
      sym_text_interpolation,
  [39381] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_SEMI,
    STATE(1413), 1,
      sym_text_interpolation,
  [39394] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(604), 1,
      anon_sym_RPAREN,
    STATE(1414), 1,
      sym_text_interpolation,
  [39407] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_LBRACE,
    STATE(1415), 1,
      sym_text_interpolation,
  [39420] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2691), 1,
      ts_builtin_sym_end,
    STATE(1416), 1,
      sym_text_interpolation,
  [39433] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_LPAREN,
    STATE(1417), 1,
      sym_text_interpolation,
  [39446] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2695), 1,
      anon_sym_RPAREN,
    STATE(1418), 1,
      sym_text_interpolation,
  [39459] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2697), 1,
      anon_sym_LPAREN,
    STATE(1419), 1,
      sym_text_interpolation,
  [39472] = 4,
    ACTIONS(3), 1,
      anon_sym_QMARK_GT,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(2699), 1,
      anon_sym_LPAREN,
    STATE(1420), 1,
      sym_text_interpolation,
  [39485] = 1,
    ACTIONS(2701), 1,
      ts_builtin_sym_end,
  [39489] = 1,
    ACTIONS(2703), 1,
      ts_builtin_sym_end,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(325)] = 0,
  [SMALL_STATE(326)] = 74,
  [SMALL_STATE(327)] = 148,
  [SMALL_STATE(328)] = 222,
  [SMALL_STATE(329)] = 299,
  [SMALL_STATE(330)] = 384,
  [SMALL_STATE(331)] = 461,
  [SMALL_STATE(332)] = 538,
  [SMALL_STATE(333)] = 623,
  [SMALL_STATE(334)] = 761,
  [SMALL_STATE(335)] = 899,
  [SMALL_STATE(336)] = 971,
  [SMALL_STATE(337)] = 1043,
  [SMALL_STATE(338)] = 1115,
  [SMALL_STATE(339)] = 1187,
  [SMALL_STATE(340)] = 1259,
  [SMALL_STATE(341)] = 1331,
  [SMALL_STATE(342)] = 1469,
  [SMALL_STATE(343)] = 1541,
  [SMALL_STATE(344)] = 1613,
  [SMALL_STATE(345)] = 1685,
  [SMALL_STATE(346)] = 1757,
  [SMALL_STATE(347)] = 1829,
  [SMALL_STATE(348)] = 1908,
  [SMALL_STATE(349)] = 1987,
  [SMALL_STATE(350)] = 2060,
  [SMALL_STATE(351)] = 2141,
  [SMALL_STATE(352)] = 2228,
  [SMALL_STATE(353)] = 2301,
  [SMALL_STATE(354)] = 2382,
  [SMALL_STATE(355)] = 2455,
  [SMALL_STATE(356)] = 2523,
  [SMALL_STATE(357)] = 2591,
  [SMALL_STATE(358)] = 2659,
  [SMALL_STATE(359)] = 2739,
  [SMALL_STATE(360)] = 2807,
  [SMALL_STATE(361)] = 2875,
  [SMALL_STATE(362)] = 2943,
  [SMALL_STATE(363)] = 3011,
  [SMALL_STATE(364)] = 3079,
  [SMALL_STATE(365)] = 3161,
  [SMALL_STATE(366)] = 3229,
  [SMALL_STATE(367)] = 3297,
  [SMALL_STATE(368)] = 3365,
  [SMALL_STATE(369)] = 3433,
  [SMALL_STATE(370)] = 3501,
  [SMALL_STATE(371)] = 3569,
  [SMALL_STATE(372)] = 3650,
  [SMALL_STATE(373)] = 3717,
  [SMALL_STATE(374)] = 3784,
  [SMALL_STATE(375)] = 3859,
  [SMALL_STATE(376)] = 3934,
  [SMALL_STATE(377)] = 4010,
  [SMALL_STATE(378)] = 4084,
  [SMALL_STATE(379)] = 4206,
  [SMALL_STATE(380)] = 4328,
  [SMALL_STATE(381)] = 4443,
  [SMALL_STATE(382)] = 4558,
  [SMALL_STATE(383)] = 4624,
  [SMALL_STATE(384)] = 4692,
  [SMALL_STATE(385)] = 4755,
  [SMALL_STATE(386)] = 4818,
  [SMALL_STATE(387)] = 4885,
  [SMALL_STATE(388)] = 4943,
  [SMALL_STATE(389)] = 5005,
  [SMALL_STATE(390)] = 5069,
  [SMALL_STATE(391)] = 5131,
  [SMALL_STATE(392)] = 5191,
  [SMALL_STATE(393)] = 5255,
  [SMALL_STATE(394)] = 5319,
  [SMALL_STATE(395)] = 5377,
  [SMALL_STATE(396)] = 5439,
  [SMALL_STATE(397)] = 5497,
  [SMALL_STATE(398)] = 5559,
  [SMALL_STATE(399)] = 5623,
  [SMALL_STATE(400)] = 5685,
  [SMALL_STATE(401)] = 5747,
  [SMALL_STATE(402)] = 5809,
  [SMALL_STATE(403)] = 5869,
  [SMALL_STATE(404)] = 5929,
  [SMALL_STATE(405)] = 5993,
  [SMALL_STATE(406)] = 6057,
  [SMALL_STATE(407)] = 6117,
  [SMALL_STATE(408)] = 6175,
  [SMALL_STATE(409)] = 6233,
  [SMALL_STATE(410)] = 6290,
  [SMALL_STATE(411)] = 6347,
  [SMALL_STATE(412)] = 6404,
  [SMALL_STATE(413)] = 6461,
  [SMALL_STATE(414)] = 6518,
  [SMALL_STATE(415)] = 6575,
  [SMALL_STATE(416)] = 6632,
  [SMALL_STATE(417)] = 6689,
  [SMALL_STATE(418)] = 6748,
  [SMALL_STATE(419)] = 6805,
  [SMALL_STATE(420)] = 6862,
  [SMALL_STATE(421)] = 6919,
  [SMALL_STATE(422)] = 6976,
  [SMALL_STATE(423)] = 7033,
  [SMALL_STATE(424)] = 7090,
  [SMALL_STATE(425)] = 7147,
  [SMALL_STATE(426)] = 7204,
  [SMALL_STATE(427)] = 7261,
  [SMALL_STATE(428)] = 7318,
  [SMALL_STATE(429)] = 7376,
  [SMALL_STATE(430)] = 7434,
  [SMALL_STATE(431)] = 7498,
  [SMALL_STATE(432)] = 7556,
  [SMALL_STATE(433)] = 7618,
  [SMALL_STATE(434)] = 7676,
  [SMALL_STATE(435)] = 7737,
  [SMALL_STATE(436)] = 7798,
  [SMALL_STATE(437)] = 7857,
  [SMALL_STATE(438)] = 7920,
  [SMALL_STATE(439)] = 7975,
  [SMALL_STATE(440)] = 8030,
  [SMALL_STATE(441)] = 8091,
  [SMALL_STATE(442)] = 8151,
  [SMALL_STATE(443)] = 8205,
  [SMALL_STATE(444)] = 8263,
  [SMALL_STATE(445)] = 8319,
  [SMALL_STATE(446)] = 8377,
  [SMALL_STATE(447)] = 8431,
  [SMALL_STATE(448)] = 8489,
  [SMALL_STATE(449)] = 8545,
  [SMALL_STATE(450)] = 8601,
  [SMALL_STATE(451)] = 8655,
  [SMALL_STATE(452)] = 8715,
  [SMALL_STATE(453)] = 8775,
  [SMALL_STATE(454)] = 8829,
  [SMALL_STATE(455)] = 8887,
  [SMALL_STATE(456)] = 8947,
  [SMALL_STATE(457)] = 9001,
  [SMALL_STATE(458)] = 9061,
  [SMALL_STATE(459)] = 9117,
  [SMALL_STATE(460)] = 9173,
  [SMALL_STATE(461)] = 9231,
  [SMALL_STATE(462)] = 9289,
  [SMALL_STATE(463)] = 9347,
  [SMALL_STATE(464)] = 9407,
  [SMALL_STATE(465)] = 9465,
  [SMALL_STATE(466)] = 9523,
  [SMALL_STATE(467)] = 9577,
  [SMALL_STATE(468)] = 9630,
  [SMALL_STATE(469)] = 9683,
  [SMALL_STATE(470)] = 9736,
  [SMALL_STATE(471)] = 9789,
  [SMALL_STATE(472)] = 9842,
  [SMALL_STATE(473)] = 9895,
  [SMALL_STATE(474)] = 9948,
  [SMALL_STATE(475)] = 10001,
  [SMALL_STATE(476)] = 10056,
  [SMALL_STATE(477)] = 10109,
  [SMALL_STATE(478)] = 10162,
  [SMALL_STATE(479)] = 10215,
  [SMALL_STATE(480)] = 10268,
  [SMALL_STATE(481)] = 10321,
  [SMALL_STATE(482)] = 10374,
  [SMALL_STATE(483)] = 10427,
  [SMALL_STATE(484)] = 10507,
  [SMALL_STATE(485)] = 10579,
  [SMALL_STATE(486)] = 10659,
  [SMALL_STATE(487)] = 10739,
  [SMALL_STATE(488)] = 10791,
  [SMALL_STATE(489)] = 10877,
  [SMALL_STATE(490)] = 10929,
  [SMALL_STATE(491)] = 10981,
  [SMALL_STATE(492)] = 11033,
  [SMALL_STATE(493)] = 11085,
  [SMALL_STATE(494)] = 11137,
  [SMALL_STATE(495)] = 11225,
  [SMALL_STATE(496)] = 11305,
  [SMALL_STATE(497)] = 11385,
  [SMALL_STATE(498)] = 11471,
  [SMALL_STATE(499)] = 11525,
  [SMALL_STATE(500)] = 11577,
  [SMALL_STATE(501)] = 11629,
  [SMALL_STATE(502)] = 11681,
  [SMALL_STATE(503)] = 11733,
  [SMALL_STATE(504)] = 11785,
  [SMALL_STATE(505)] = 11847,
  [SMALL_STATE(506)] = 11905,
  [SMALL_STATE(507)] = 11957,
  [SMALL_STATE(508)] = 12043,
  [SMALL_STATE(509)] = 12097,
  [SMALL_STATE(510)] = 12157,
  [SMALL_STATE(511)] = 12221,
  [SMALL_STATE(512)] = 12301,
  [SMALL_STATE(513)] = 12353,
  [SMALL_STATE(514)] = 12407,
  [SMALL_STATE(515)] = 12459,
  [SMALL_STATE(516)] = 12529,
  [SMALL_STATE(517)] = 12583,
  [SMALL_STATE(518)] = 12635,
  [SMALL_STATE(519)] = 12721,
  [SMALL_STATE(520)] = 12773,
  [SMALL_STATE(521)] = 12825,
  [SMALL_STATE(522)] = 12879,
  [SMALL_STATE(523)] = 12941,
  [SMALL_STATE(524)] = 13015,
  [SMALL_STATE(525)] = 13091,
  [SMALL_STATE(526)] = 13173,
  [SMALL_STATE(527)] = 13257,
  [SMALL_STATE(528)] = 13337,
  [SMALL_STATE(529)] = 13391,
  [SMALL_STATE(530)] = 13443,
  [SMALL_STATE(531)] = 13495,
  [SMALL_STATE(532)] = 13547,
  [SMALL_STATE(533)] = 13603,
  [SMALL_STATE(534)] = 13689,
  [SMALL_STATE(535)] = 13775,
  [SMALL_STATE(536)] = 13843,
  [SMALL_STATE(537)] = 13929,
  [SMALL_STATE(538)] = 13981,
  [SMALL_STATE(539)] = 14033,
  [SMALL_STATE(540)] = 14085,
  [SMALL_STATE(541)] = 14171,
  [SMALL_STATE(542)] = 14225,
  [SMALL_STATE(543)] = 14311,
  [SMALL_STATE(544)] = 14363,
  [SMALL_STATE(545)] = 14449,
  [SMALL_STATE(546)] = 14501,
  [SMALL_STATE(547)] = 14556,
  [SMALL_STATE(548)] = 14607,
  [SMALL_STATE(549)] = 14658,
  [SMALL_STATE(550)] = 14715,
  [SMALL_STATE(551)] = 14772,
  [SMALL_STATE(552)] = 14829,
  [SMALL_STATE(553)] = 14886,
  [SMALL_STATE(554)] = 14943,
  [SMALL_STATE(555)] = 14995,
  [SMALL_STATE(556)] = 15085,
  [SMALL_STATE(557)] = 15173,
  [SMALL_STATE(558)] = 15263,
  [SMALL_STATE(559)] = 15339,
  [SMALL_STATE(560)] = 15415,
  [SMALL_STATE(561)] = 15463,
  [SMALL_STATE(562)] = 15511,
  [SMALL_STATE(563)] = 15583,
  [SMALL_STATE(564)] = 15653,
  [SMALL_STATE(565)] = 15721,
  [SMALL_STATE(566)] = 15769,
  [SMALL_STATE(567)] = 15817,
  [SMALL_STATE(568)] = 15865,
  [SMALL_STATE(569)] = 15915,
  [SMALL_STATE(570)] = 15991,
  [SMALL_STATE(571)] = 16067,
  [SMALL_STATE(572)] = 16115,
  [SMALL_STATE(573)] = 16175,
  [SMALL_STATE(574)] = 16231,
  [SMALL_STATE(575)] = 16285,
  [SMALL_STATE(576)] = 16333,
  [SMALL_STATE(577)] = 16415,
  [SMALL_STATE(578)] = 16463,
  [SMALL_STATE(579)] = 16545,
  [SMALL_STATE(580)] = 16633,
  [SMALL_STATE(581)] = 16715,
  [SMALL_STATE(582)] = 16799,
  [SMALL_STATE(583)] = 16847,
  [SMALL_STATE(584)] = 16895,
  [SMALL_STATE(585)] = 16943,
  [SMALL_STATE(586)] = 17009,
  [SMALL_STATE(587)] = 17057,
  [SMALL_STATE(588)] = 17107,
  [SMALL_STATE(589)] = 17189,
  [SMALL_STATE(590)] = 17265,
  [SMALL_STATE(591)] = 17343,
  [SMALL_STATE(592)] = 17425,
  [SMALL_STATE(593)] = 17507,
  [SMALL_STATE(594)] = 17587,
  [SMALL_STATE(595)] = 17663,
  [SMALL_STATE(596)] = 17711,
  [SMALL_STATE(597)] = 17759,
  [SMALL_STATE(598)] = 17807,
  [SMALL_STATE(599)] = 17889,
  [SMALL_STATE(600)] = 17937,
  [SMALL_STATE(601)] = 18019,
  [SMALL_STATE(602)] = 18095,
  [SMALL_STATE(603)] = 18143,
  [SMALL_STATE(604)] = 18195,
  [SMALL_STATE(605)] = 18259,
  [SMALL_STATE(606)] = 18307,
  [SMALL_STATE(607)] = 18389,
  [SMALL_STATE(608)] = 18437,
  [SMALL_STATE(609)] = 18485,
  [SMALL_STATE(610)] = 18533,
  [SMALL_STATE(611)] = 18621,
  [SMALL_STATE(612)] = 18671,
  [SMALL_STATE(613)] = 18719,
  [SMALL_STATE(614)] = 18767,
  [SMALL_STATE(615)] = 18815,
  [SMALL_STATE(616)] = 18897,
  [SMALL_STATE(617)] = 18945,
  [SMALL_STATE(618)] = 19030,
  [SMALL_STATE(619)] = 19115,
  [SMALL_STATE(620)] = 19197,
  [SMALL_STATE(621)] = 19279,
  [SMALL_STATE(622)] = 19361,
  [SMALL_STATE(623)] = 19443,
  [SMALL_STATE(624)] = 19525,
  [SMALL_STATE(625)] = 19607,
  [SMALL_STATE(626)] = 19689,
  [SMALL_STATE(627)] = 19771,
  [SMALL_STATE(628)] = 19853,
  [SMALL_STATE(629)] = 19935,
  [SMALL_STATE(630)] = 20017,
  [SMALL_STATE(631)] = 20099,
  [SMALL_STATE(632)] = 20180,
  [SMALL_STATE(633)] = 20263,
  [SMALL_STATE(634)] = 20344,
  [SMALL_STATE(635)] = 20427,
  [SMALL_STATE(636)] = 20510,
  [SMALL_STATE(637)] = 20589,
  [SMALL_STATE(638)] = 20668,
  [SMALL_STATE(639)] = 20751,
  [SMALL_STATE(640)] = 20830,
  [SMALL_STATE(641)] = 20911,
  [SMALL_STATE(642)] = 20992,
  [SMALL_STATE(643)] = 21070,
  [SMALL_STATE(644)] = 21148,
  [SMALL_STATE(645)] = 21226,
  [SMALL_STATE(646)] = 21304,
  [SMALL_STATE(647)] = 21382,
  [SMALL_STATE(648)] = 21460,
  [SMALL_STATE(649)] = 21538,
  [SMALL_STATE(650)] = 21616,
  [SMALL_STATE(651)] = 21694,
  [SMALL_STATE(652)] = 21772,
  [SMALL_STATE(653)] = 21850,
  [SMALL_STATE(654)] = 21928,
  [SMALL_STATE(655)] = 22006,
  [SMALL_STATE(656)] = 22084,
  [SMALL_STATE(657)] = 22164,
  [SMALL_STATE(658)] = 22242,
  [SMALL_STATE(659)] = 22320,
  [SMALL_STATE(660)] = 22398,
  [SMALL_STATE(661)] = 22478,
  [SMALL_STATE(662)] = 22555,
  [SMALL_STATE(663)] = 22632,
  [SMALL_STATE(664)] = 22709,
  [SMALL_STATE(665)] = 22786,
  [SMALL_STATE(666)] = 22863,
  [SMALL_STATE(667)] = 22938,
  [SMALL_STATE(668)] = 23015,
  [SMALL_STATE(669)] = 23090,
  [SMALL_STATE(670)] = 23167,
  [SMALL_STATE(671)] = 23244,
  [SMALL_STATE(672)] = 23321,
  [SMALL_STATE(673)] = 23398,
  [SMALL_STATE(674)] = 23475,
  [SMALL_STATE(675)] = 23552,
  [SMALL_STATE(676)] = 23629,
  [SMALL_STATE(677)] = 23706,
  [SMALL_STATE(678)] = 23783,
  [SMALL_STATE(679)] = 23860,
  [SMALL_STATE(680)] = 23937,
  [SMALL_STATE(681)] = 24014,
  [SMALL_STATE(682)] = 24091,
  [SMALL_STATE(683)] = 24168,
  [SMALL_STATE(684)] = 24245,
  [SMALL_STATE(685)] = 24322,
  [SMALL_STATE(686)] = 24399,
  [SMALL_STATE(687)] = 24476,
  [SMALL_STATE(688)] = 24553,
  [SMALL_STATE(689)] = 24630,
  [SMALL_STATE(690)] = 24707,
  [SMALL_STATE(691)] = 24784,
  [SMALL_STATE(692)] = 24861,
  [SMALL_STATE(693)] = 24938,
  [SMALL_STATE(694)] = 25015,
  [SMALL_STATE(695)] = 25092,
  [SMALL_STATE(696)] = 25169,
  [SMALL_STATE(697)] = 25246,
  [SMALL_STATE(698)] = 25323,
  [SMALL_STATE(699)] = 25400,
  [SMALL_STATE(700)] = 25477,
  [SMALL_STATE(701)] = 25549,
  [SMALL_STATE(702)] = 25614,
  [SMALL_STATE(703)] = 25679,
  [SMALL_STATE(704)] = 25744,
  [SMALL_STATE(705)] = 25809,
  [SMALL_STATE(706)] = 25874,
  [SMALL_STATE(707)] = 25937,
  [SMALL_STATE(708)] = 26002,
  [SMALL_STATE(709)] = 26067,
  [SMALL_STATE(710)] = 26132,
  [SMALL_STATE(711)] = 26188,
  [SMALL_STATE(712)] = 26244,
  [SMALL_STATE(713)] = 26293,
  [SMALL_STATE(714)] = 26342,
  [SMALL_STATE(715)] = 26391,
  [SMALL_STATE(716)] = 26442,
  [SMALL_STATE(717)] = 26470,
  [SMALL_STATE(718)] = 26516,
  [SMALL_STATE(719)] = 26544,
  [SMALL_STATE(720)] = 26570,
  [SMALL_STATE(721)] = 26616,
  [SMALL_STATE(722)] = 26654,
  [SMALL_STATE(723)] = 26682,
  [SMALL_STATE(724)] = 26709,
  [SMALL_STATE(725)] = 26732,
  [SMALL_STATE(726)] = 26755,
  [SMALL_STATE(727)] = 26778,
  [SMALL_STATE(728)] = 26801,
  [SMALL_STATE(729)] = 26824,
  [SMALL_STATE(730)] = 26863,
  [SMALL_STATE(731)] = 26886,
  [SMALL_STATE(732)] = 26925,
  [SMALL_STATE(733)] = 26964,
  [SMALL_STATE(734)] = 26987,
  [SMALL_STATE(735)] = 27010,
  [SMALL_STATE(736)] = 27033,
  [SMALL_STATE(737)] = 27056,
  [SMALL_STATE(738)] = 27079,
  [SMALL_STATE(739)] = 27102,
  [SMALL_STATE(740)] = 27138,
  [SMALL_STATE(741)] = 27174,
  [SMALL_STATE(742)] = 27198,
  [SMALL_STATE(743)] = 27234,
  [SMALL_STATE(744)] = 27270,
  [SMALL_STATE(745)] = 27306,
  [SMALL_STATE(746)] = 27342,
  [SMALL_STATE(747)] = 27378,
  [SMALL_STATE(748)] = 27400,
  [SMALL_STATE(749)] = 27422,
  [SMALL_STATE(750)] = 27458,
  [SMALL_STATE(751)] = 27489,
  [SMALL_STATE(752)] = 27518,
  [SMALL_STATE(753)] = 27549,
  [SMALL_STATE(754)] = 27580,
  [SMALL_STATE(755)] = 27611,
  [SMALL_STATE(756)] = 27642,
  [SMALL_STATE(757)] = 27671,
  [SMALL_STATE(758)] = 27700,
  [SMALL_STATE(759)] = 27721,
  [SMALL_STATE(760)] = 27752,
  [SMALL_STATE(761)] = 27781,
  [SMALL_STATE(762)] = 27802,
  [SMALL_STATE(763)] = 27831,
  [SMALL_STATE(764)] = 27862,
  [SMALL_STATE(765)] = 27883,
  [SMALL_STATE(766)] = 27912,
  [SMALL_STATE(767)] = 27943,
  [SMALL_STATE(768)] = 27974,
  [SMALL_STATE(769)] = 28005,
  [SMALL_STATE(770)] = 28036,
  [SMALL_STATE(771)] = 28065,
  [SMALL_STATE(772)] = 28096,
  [SMALL_STATE(773)] = 28125,
  [SMALL_STATE(774)] = 28156,
  [SMALL_STATE(775)] = 28185,
  [SMALL_STATE(776)] = 28213,
  [SMALL_STATE(777)] = 28243,
  [SMALL_STATE(778)] = 28269,
  [SMALL_STATE(779)] = 28295,
  [SMALL_STATE(780)] = 28325,
  [SMALL_STATE(781)] = 28359,
  [SMALL_STATE(782)] = 28393,
  [SMALL_STATE(783)] = 28420,
  [SMALL_STATE(784)] = 28445,
  [SMALL_STATE(785)] = 28470,
  [SMALL_STATE(786)] = 28495,
  [SMALL_STATE(787)] = 28520,
  [SMALL_STATE(788)] = 28545,
  [SMALL_STATE(789)] = 28567,
  [SMALL_STATE(790)] = 28589,
  [SMALL_STATE(791)] = 28609,
  [SMALL_STATE(792)] = 28635,
  [SMALL_STATE(793)] = 28659,
  [SMALL_STATE(794)] = 28687,
  [SMALL_STATE(795)] = 28715,
  [SMALL_STATE(796)] = 28741,
  [SMALL_STATE(797)] = 28763,
  [SMALL_STATE(798)] = 28791,
  [SMALL_STATE(799)] = 28813,
  [SMALL_STATE(800)] = 28841,
  [SMALL_STATE(801)] = 28865,
  [SMALL_STATE(802)] = 28891,
  [SMALL_STATE(803)] = 28913,
  [SMALL_STATE(804)] = 28935,
  [SMALL_STATE(805)] = 28961,
  [SMALL_STATE(806)] = 28983,
  [SMALL_STATE(807)] = 29009,
  [SMALL_STATE(808)] = 29037,
  [SMALL_STATE(809)] = 29059,
  [SMALL_STATE(810)] = 29085,
  [SMALL_STATE(811)] = 29113,
  [SMALL_STATE(812)] = 29133,
  [SMALL_STATE(813)] = 29155,
  [SMALL_STATE(814)] = 29175,
  [SMALL_STATE(815)] = 29203,
  [SMALL_STATE(816)] = 29225,
  [SMALL_STATE(817)] = 29251,
  [SMALL_STATE(818)] = 29273,
  [SMALL_STATE(819)] = 29301,
  [SMALL_STATE(820)] = 29323,
  [SMALL_STATE(821)] = 29349,
  [SMALL_STATE(822)] = 29375,
  [SMALL_STATE(823)] = 29399,
  [SMALL_STATE(824)] = 29425,
  [SMALL_STATE(825)] = 29453,
  [SMALL_STATE(826)] = 29479,
  [SMALL_STATE(827)] = 29505,
  [SMALL_STATE(828)] = 29533,
  [SMALL_STATE(829)] = 29557,
  [SMALL_STATE(830)] = 29585,
  [SMALL_STATE(831)] = 29613,
  [SMALL_STATE(832)] = 29641,
  [SMALL_STATE(833)] = 29665,
  [SMALL_STATE(834)] = 29687,
  [SMALL_STATE(835)] = 29709,
  [SMALL_STATE(836)] = 29737,
  [SMALL_STATE(837)] = 29759,
  [SMALL_STATE(838)] = 29781,
  [SMALL_STATE(839)] = 29807,
  [SMALL_STATE(840)] = 29835,
  [SMALL_STATE(841)] = 29863,
  [SMALL_STATE(842)] = 29891,
  [SMALL_STATE(843)] = 29919,
  [SMALL_STATE(844)] = 29943,
  [SMALL_STATE(845)] = 29966,
  [SMALL_STATE(846)] = 29987,
  [SMALL_STATE(847)] = 30008,
  [SMALL_STATE(848)] = 30029,
  [SMALL_STATE(849)] = 30050,
  [SMALL_STATE(850)] = 30073,
  [SMALL_STATE(851)] = 30094,
  [SMALL_STATE(852)] = 30113,
  [SMALL_STATE(853)] = 30134,
  [SMALL_STATE(854)] = 30155,
  [SMALL_STATE(855)] = 30176,
  [SMALL_STATE(856)] = 30195,
  [SMALL_STATE(857)] = 30216,
  [SMALL_STATE(858)] = 30237,
  [SMALL_STATE(859)] = 30260,
  [SMALL_STATE(860)] = 30283,
  [SMALL_STATE(861)] = 30304,
  [SMALL_STATE(862)] = 30325,
  [SMALL_STATE(863)] = 30348,
  [SMALL_STATE(864)] = 30369,
  [SMALL_STATE(865)] = 30390,
  [SMALL_STATE(866)] = 30411,
  [SMALL_STATE(867)] = 30434,
  [SMALL_STATE(868)] = 30457,
  [SMALL_STATE(869)] = 30478,
  [SMALL_STATE(870)] = 30501,
  [SMALL_STATE(871)] = 30522,
  [SMALL_STATE(872)] = 30543,
  [SMALL_STATE(873)] = 30562,
  [SMALL_STATE(874)] = 30583,
  [SMALL_STATE(875)] = 30602,
  [SMALL_STATE(876)] = 30627,
  [SMALL_STATE(877)] = 30648,
  [SMALL_STATE(878)] = 30671,
  [SMALL_STATE(879)] = 30692,
  [SMALL_STATE(880)] = 30713,
  [SMALL_STATE(881)] = 30738,
  [SMALL_STATE(882)] = 30761,
  [SMALL_STATE(883)] = 30782,
  [SMALL_STATE(884)] = 30805,
  [SMALL_STATE(885)] = 30824,
  [SMALL_STATE(886)] = 30845,
  [SMALL_STATE(887)] = 30866,
  [SMALL_STATE(888)] = 30887,
  [SMALL_STATE(889)] = 30908,
  [SMALL_STATE(890)] = 30929,
  [SMALL_STATE(891)] = 30948,
  [SMALL_STATE(892)] = 30971,
  [SMALL_STATE(893)] = 30989,
  [SMALL_STATE(894)] = 31007,
  [SMALL_STATE(895)] = 31023,
  [SMALL_STATE(896)] = 31045,
  [SMALL_STATE(897)] = 31065,
  [SMALL_STATE(898)] = 31087,
  [SMALL_STATE(899)] = 31107,
  [SMALL_STATE(900)] = 31127,
  [SMALL_STATE(901)] = 31147,
  [SMALL_STATE(902)] = 31163,
  [SMALL_STATE(903)] = 31185,
  [SMALL_STATE(904)] = 31205,
  [SMALL_STATE(905)] = 31221,
  [SMALL_STATE(906)] = 31243,
  [SMALL_STATE(907)] = 31265,
  [SMALL_STATE(908)] = 31285,
  [SMALL_STATE(909)] = 31307,
  [SMALL_STATE(910)] = 31327,
  [SMALL_STATE(911)] = 31345,
  [SMALL_STATE(912)] = 31361,
  [SMALL_STATE(913)] = 31377,
  [SMALL_STATE(914)] = 31393,
  [SMALL_STATE(915)] = 31413,
  [SMALL_STATE(916)] = 31433,
  [SMALL_STATE(917)] = 31455,
  [SMALL_STATE(918)] = 31475,
  [SMALL_STATE(919)] = 31497,
  [SMALL_STATE(920)] = 31515,
  [SMALL_STATE(921)] = 31535,
  [SMALL_STATE(922)] = 31553,
  [SMALL_STATE(923)] = 31575,
  [SMALL_STATE(924)] = 31597,
  [SMALL_STATE(925)] = 31617,
  [SMALL_STATE(926)] = 31639,
  [SMALL_STATE(927)] = 31659,
  [SMALL_STATE(928)] = 31679,
  [SMALL_STATE(929)] = 31699,
  [SMALL_STATE(930)] = 31715,
  [SMALL_STATE(931)] = 31733,
  [SMALL_STATE(932)] = 31755,
  [SMALL_STATE(933)] = 31775,
  [SMALL_STATE(934)] = 31797,
  [SMALL_STATE(935)] = 31817,
  [SMALL_STATE(936)] = 31839,
  [SMALL_STATE(937)] = 31859,
  [SMALL_STATE(938)] = 31879,
  [SMALL_STATE(939)] = 31897,
  [SMALL_STATE(940)] = 31919,
  [SMALL_STATE(941)] = 31939,
  [SMALL_STATE(942)] = 31959,
  [SMALL_STATE(943)] = 31977,
  [SMALL_STATE(944)] = 31997,
  [SMALL_STATE(945)] = 32019,
  [SMALL_STATE(946)] = 32041,
  [SMALL_STATE(947)] = 32061,
  [SMALL_STATE(948)] = 32077,
  [SMALL_STATE(949)] = 32097,
  [SMALL_STATE(950)] = 32113,
  [SMALL_STATE(951)] = 32129,
  [SMALL_STATE(952)] = 32147,
  [SMALL_STATE(953)] = 32163,
  [SMALL_STATE(954)] = 32181,
  [SMALL_STATE(955)] = 32201,
  [SMALL_STATE(956)] = 32223,
  [SMALL_STATE(957)] = 32241,
  [SMALL_STATE(958)] = 32261,
  [SMALL_STATE(959)] = 32283,
  [SMALL_STATE(960)] = 32299,
  [SMALL_STATE(961)] = 32319,
  [SMALL_STATE(962)] = 32341,
  [SMALL_STATE(963)] = 32361,
  [SMALL_STATE(964)] = 32383,
  [SMALL_STATE(965)] = 32405,
  [SMALL_STATE(966)] = 32425,
  [SMALL_STATE(967)] = 32445,
  [SMALL_STATE(968)] = 32465,
  [SMALL_STATE(969)] = 32487,
  [SMALL_STATE(970)] = 32509,
  [SMALL_STATE(971)] = 32525,
  [SMALL_STATE(972)] = 32541,
  [SMALL_STATE(973)] = 32563,
  [SMALL_STATE(974)] = 32579,
  [SMALL_STATE(975)] = 32601,
  [SMALL_STATE(976)] = 32617,
  [SMALL_STATE(977)] = 32639,
  [SMALL_STATE(978)] = 32656,
  [SMALL_STATE(979)] = 32675,
  [SMALL_STATE(980)] = 32692,
  [SMALL_STATE(981)] = 32709,
  [SMALL_STATE(982)] = 32728,
  [SMALL_STATE(983)] = 32745,
  [SMALL_STATE(984)] = 32762,
  [SMALL_STATE(985)] = 32779,
  [SMALL_STATE(986)] = 32796,
  [SMALL_STATE(987)] = 32813,
  [SMALL_STATE(988)] = 32830,
  [SMALL_STATE(989)] = 32847,
  [SMALL_STATE(990)] = 32864,
  [SMALL_STATE(991)] = 32881,
  [SMALL_STATE(992)] = 32898,
  [SMALL_STATE(993)] = 32915,
  [SMALL_STATE(994)] = 32930,
  [SMALL_STATE(995)] = 32947,
  [SMALL_STATE(996)] = 32964,
  [SMALL_STATE(997)] = 32981,
  [SMALL_STATE(998)] = 32998,
  [SMALL_STATE(999)] = 33015,
  [SMALL_STATE(1000)] = 33032,
  [SMALL_STATE(1001)] = 33049,
  [SMALL_STATE(1002)] = 33066,
  [SMALL_STATE(1003)] = 33083,
  [SMALL_STATE(1004)] = 33100,
  [SMALL_STATE(1005)] = 33117,
  [SMALL_STATE(1006)] = 33136,
  [SMALL_STATE(1007)] = 33153,
  [SMALL_STATE(1008)] = 33170,
  [SMALL_STATE(1009)] = 33187,
  [SMALL_STATE(1010)] = 33204,
  [SMALL_STATE(1011)] = 33221,
  [SMALL_STATE(1012)] = 33238,
  [SMALL_STATE(1013)] = 33255,
  [SMALL_STATE(1014)] = 33272,
  [SMALL_STATE(1015)] = 33289,
  [SMALL_STATE(1016)] = 33306,
  [SMALL_STATE(1017)] = 33323,
  [SMALL_STATE(1018)] = 33340,
  [SMALL_STATE(1019)] = 33355,
  [SMALL_STATE(1020)] = 33370,
  [SMALL_STATE(1021)] = 33389,
  [SMALL_STATE(1022)] = 33406,
  [SMALL_STATE(1023)] = 33423,
  [SMALL_STATE(1024)] = 33442,
  [SMALL_STATE(1025)] = 33461,
  [SMALL_STATE(1026)] = 33478,
  [SMALL_STATE(1027)] = 33497,
  [SMALL_STATE(1028)] = 33512,
  [SMALL_STATE(1029)] = 33531,
  [SMALL_STATE(1030)] = 33548,
  [SMALL_STATE(1031)] = 33565,
  [SMALL_STATE(1032)] = 33584,
  [SMALL_STATE(1033)] = 33601,
  [SMALL_STATE(1034)] = 33618,
  [SMALL_STATE(1035)] = 33637,
  [SMALL_STATE(1036)] = 33654,
  [SMALL_STATE(1037)] = 33673,
  [SMALL_STATE(1038)] = 33692,
  [SMALL_STATE(1039)] = 33707,
  [SMALL_STATE(1040)] = 33722,
  [SMALL_STATE(1041)] = 33739,
  [SMALL_STATE(1042)] = 33756,
  [SMALL_STATE(1043)] = 33775,
  [SMALL_STATE(1044)] = 33790,
  [SMALL_STATE(1045)] = 33809,
  [SMALL_STATE(1046)] = 33826,
  [SMALL_STATE(1047)] = 33843,
  [SMALL_STATE(1048)] = 33860,
  [SMALL_STATE(1049)] = 33875,
  [SMALL_STATE(1050)] = 33890,
  [SMALL_STATE(1051)] = 33909,
  [SMALL_STATE(1052)] = 33926,
  [SMALL_STATE(1053)] = 33943,
  [SMALL_STATE(1054)] = 33962,
  [SMALL_STATE(1055)] = 33981,
  [SMALL_STATE(1056)] = 34000,
  [SMALL_STATE(1057)] = 34019,
  [SMALL_STATE(1058)] = 34034,
  [SMALL_STATE(1059)] = 34051,
  [SMALL_STATE(1060)] = 34070,
  [SMALL_STATE(1061)] = 34089,
  [SMALL_STATE(1062)] = 34106,
  [SMALL_STATE(1063)] = 34125,
  [SMALL_STATE(1064)] = 34144,
  [SMALL_STATE(1065)] = 34161,
  [SMALL_STATE(1066)] = 34176,
  [SMALL_STATE(1067)] = 34193,
  [SMALL_STATE(1068)] = 34208,
  [SMALL_STATE(1069)] = 34225,
  [SMALL_STATE(1070)] = 34244,
  [SMALL_STATE(1071)] = 34263,
  [SMALL_STATE(1072)] = 34280,
  [SMALL_STATE(1073)] = 34297,
  [SMALL_STATE(1074)] = 34314,
  [SMALL_STATE(1075)] = 34329,
  [SMALL_STATE(1076)] = 34348,
  [SMALL_STATE(1077)] = 34365,
  [SMALL_STATE(1078)] = 34382,
  [SMALL_STATE(1079)] = 34397,
  [SMALL_STATE(1080)] = 34416,
  [SMALL_STATE(1081)] = 34435,
  [SMALL_STATE(1082)] = 34452,
  [SMALL_STATE(1083)] = 34471,
  [SMALL_STATE(1084)] = 34490,
  [SMALL_STATE(1085)] = 34507,
  [SMALL_STATE(1086)] = 34524,
  [SMALL_STATE(1087)] = 34539,
  [SMALL_STATE(1088)] = 34558,
  [SMALL_STATE(1089)] = 34573,
  [SMALL_STATE(1090)] = 34588,
  [SMALL_STATE(1091)] = 34603,
  [SMALL_STATE(1092)] = 34618,
  [SMALL_STATE(1093)] = 34633,
  [SMALL_STATE(1094)] = 34650,
  [SMALL_STATE(1095)] = 34667,
  [SMALL_STATE(1096)] = 34684,
  [SMALL_STATE(1097)] = 34701,
  [SMALL_STATE(1098)] = 34720,
  [SMALL_STATE(1099)] = 34737,
  [SMALL_STATE(1100)] = 34752,
  [SMALL_STATE(1101)] = 34771,
  [SMALL_STATE(1102)] = 34790,
  [SMALL_STATE(1103)] = 34809,
  [SMALL_STATE(1104)] = 34826,
  [SMALL_STATE(1105)] = 34845,
  [SMALL_STATE(1106)] = 34860,
  [SMALL_STATE(1107)] = 34877,
  [SMALL_STATE(1108)] = 34896,
  [SMALL_STATE(1109)] = 34913,
  [SMALL_STATE(1110)] = 34932,
  [SMALL_STATE(1111)] = 34949,
  [SMALL_STATE(1112)] = 34968,
  [SMALL_STATE(1113)] = 34985,
  [SMALL_STATE(1114)] = 35002,
  [SMALL_STATE(1115)] = 35019,
  [SMALL_STATE(1116)] = 35036,
  [SMALL_STATE(1117)] = 35055,
  [SMALL_STATE(1118)] = 35074,
  [SMALL_STATE(1119)] = 35091,
  [SMALL_STATE(1120)] = 35110,
  [SMALL_STATE(1121)] = 35129,
  [SMALL_STATE(1122)] = 35148,
  [SMALL_STATE(1123)] = 35165,
  [SMALL_STATE(1124)] = 35182,
  [SMALL_STATE(1125)] = 35199,
  [SMALL_STATE(1126)] = 35218,
  [SMALL_STATE(1127)] = 35237,
  [SMALL_STATE(1128)] = 35256,
  [SMALL_STATE(1129)] = 35271,
  [SMALL_STATE(1130)] = 35288,
  [SMALL_STATE(1131)] = 35305,
  [SMALL_STATE(1132)] = 35322,
  [SMALL_STATE(1133)] = 35341,
  [SMALL_STATE(1134)] = 35360,
  [SMALL_STATE(1135)] = 35377,
  [SMALL_STATE(1136)] = 35392,
  [SMALL_STATE(1137)] = 35407,
  [SMALL_STATE(1138)] = 35422,
  [SMALL_STATE(1139)] = 35441,
  [SMALL_STATE(1140)] = 35456,
  [SMALL_STATE(1141)] = 35473,
  [SMALL_STATE(1142)] = 35492,
  [SMALL_STATE(1143)] = 35509,
  [SMALL_STATE(1144)] = 35526,
  [SMALL_STATE(1145)] = 35543,
  [SMALL_STATE(1146)] = 35560,
  [SMALL_STATE(1147)] = 35579,
  [SMALL_STATE(1148)] = 35596,
  [SMALL_STATE(1149)] = 35613,
  [SMALL_STATE(1150)] = 35628,
  [SMALL_STATE(1151)] = 35647,
  [SMALL_STATE(1152)] = 35666,
  [SMALL_STATE(1153)] = 35685,
  [SMALL_STATE(1154)] = 35702,
  [SMALL_STATE(1155)] = 35718,
  [SMALL_STATE(1156)] = 35732,
  [SMALL_STATE(1157)] = 35748,
  [SMALL_STATE(1158)] = 35764,
  [SMALL_STATE(1159)] = 35780,
  [SMALL_STATE(1160)] = 35796,
  [SMALL_STATE(1161)] = 35812,
  [SMALL_STATE(1162)] = 35826,
  [SMALL_STATE(1163)] = 35842,
  [SMALL_STATE(1164)] = 35858,
  [SMALL_STATE(1165)] = 35874,
  [SMALL_STATE(1166)] = 35890,
  [SMALL_STATE(1167)] = 35906,
  [SMALL_STATE(1168)] = 35922,
  [SMALL_STATE(1169)] = 35938,
  [SMALL_STATE(1170)] = 35954,
  [SMALL_STATE(1171)] = 35970,
  [SMALL_STATE(1172)] = 35984,
  [SMALL_STATE(1173)] = 36000,
  [SMALL_STATE(1174)] = 36016,
  [SMALL_STATE(1175)] = 36032,
  [SMALL_STATE(1176)] = 36048,
  [SMALL_STATE(1177)] = 36062,
  [SMALL_STATE(1178)] = 36076,
  [SMALL_STATE(1179)] = 36090,
  [SMALL_STATE(1180)] = 36106,
  [SMALL_STATE(1181)] = 36120,
  [SMALL_STATE(1182)] = 36134,
  [SMALL_STATE(1183)] = 36150,
  [SMALL_STATE(1184)] = 36164,
  [SMALL_STATE(1185)] = 36178,
  [SMALL_STATE(1186)] = 36192,
  [SMALL_STATE(1187)] = 36206,
  [SMALL_STATE(1188)] = 36222,
  [SMALL_STATE(1189)] = 36236,
  [SMALL_STATE(1190)] = 36252,
  [SMALL_STATE(1191)] = 36268,
  [SMALL_STATE(1192)] = 36284,
  [SMALL_STATE(1193)] = 36300,
  [SMALL_STATE(1194)] = 36316,
  [SMALL_STATE(1195)] = 36332,
  [SMALL_STATE(1196)] = 36348,
  [SMALL_STATE(1197)] = 36364,
  [SMALL_STATE(1198)] = 36380,
  [SMALL_STATE(1199)] = 36394,
  [SMALL_STATE(1200)] = 36410,
  [SMALL_STATE(1201)] = 36424,
  [SMALL_STATE(1202)] = 36440,
  [SMALL_STATE(1203)] = 36454,
  [SMALL_STATE(1204)] = 36468,
  [SMALL_STATE(1205)] = 36482,
  [SMALL_STATE(1206)] = 36498,
  [SMALL_STATE(1207)] = 36514,
  [SMALL_STATE(1208)] = 36530,
  [SMALL_STATE(1209)] = 36546,
  [SMALL_STATE(1210)] = 36560,
  [SMALL_STATE(1211)] = 36574,
  [SMALL_STATE(1212)] = 36588,
  [SMALL_STATE(1213)] = 36602,
  [SMALL_STATE(1214)] = 36616,
  [SMALL_STATE(1215)] = 36630,
  [SMALL_STATE(1216)] = 36646,
  [SMALL_STATE(1217)] = 36660,
  [SMALL_STATE(1218)] = 36676,
  [SMALL_STATE(1219)] = 36692,
  [SMALL_STATE(1220)] = 36706,
  [SMALL_STATE(1221)] = 36722,
  [SMALL_STATE(1222)] = 36736,
  [SMALL_STATE(1223)] = 36750,
  [SMALL_STATE(1224)] = 36764,
  [SMALL_STATE(1225)] = 36778,
  [SMALL_STATE(1226)] = 36792,
  [SMALL_STATE(1227)] = 36808,
  [SMALL_STATE(1228)] = 36824,
  [SMALL_STATE(1229)] = 36840,
  [SMALL_STATE(1230)] = 36854,
  [SMALL_STATE(1231)] = 36870,
  [SMALL_STATE(1232)] = 36886,
  [SMALL_STATE(1233)] = 36902,
  [SMALL_STATE(1234)] = 36916,
  [SMALL_STATE(1235)] = 36932,
  [SMALL_STATE(1236)] = 36948,
  [SMALL_STATE(1237)] = 36964,
  [SMALL_STATE(1238)] = 36978,
  [SMALL_STATE(1239)] = 36992,
  [SMALL_STATE(1240)] = 37006,
  [SMALL_STATE(1241)] = 37020,
  [SMALL_STATE(1242)] = 37034,
  [SMALL_STATE(1243)] = 37050,
  [SMALL_STATE(1244)] = 37064,
  [SMALL_STATE(1245)] = 37078,
  [SMALL_STATE(1246)] = 37094,
  [SMALL_STATE(1247)] = 37108,
  [SMALL_STATE(1248)] = 37124,
  [SMALL_STATE(1249)] = 37138,
  [SMALL_STATE(1250)] = 37152,
  [SMALL_STATE(1251)] = 37168,
  [SMALL_STATE(1252)] = 37184,
  [SMALL_STATE(1253)] = 37198,
  [SMALL_STATE(1254)] = 37214,
  [SMALL_STATE(1255)] = 37230,
  [SMALL_STATE(1256)] = 37244,
  [SMALL_STATE(1257)] = 37258,
  [SMALL_STATE(1258)] = 37274,
  [SMALL_STATE(1259)] = 37288,
  [SMALL_STATE(1260)] = 37304,
  [SMALL_STATE(1261)] = 37318,
  [SMALL_STATE(1262)] = 37332,
  [SMALL_STATE(1263)] = 37346,
  [SMALL_STATE(1264)] = 37360,
  [SMALL_STATE(1265)] = 37374,
  [SMALL_STATE(1266)] = 37390,
  [SMALL_STATE(1267)] = 37404,
  [SMALL_STATE(1268)] = 37420,
  [SMALL_STATE(1269)] = 37434,
  [SMALL_STATE(1270)] = 37450,
  [SMALL_STATE(1271)] = 37464,
  [SMALL_STATE(1272)] = 37478,
  [SMALL_STATE(1273)] = 37494,
  [SMALL_STATE(1274)] = 37508,
  [SMALL_STATE(1275)] = 37524,
  [SMALL_STATE(1276)] = 37538,
  [SMALL_STATE(1277)] = 37552,
  [SMALL_STATE(1278)] = 37568,
  [SMALL_STATE(1279)] = 37582,
  [SMALL_STATE(1280)] = 37596,
  [SMALL_STATE(1281)] = 37610,
  [SMALL_STATE(1282)] = 37624,
  [SMALL_STATE(1283)] = 37640,
  [SMALL_STATE(1284)] = 37654,
  [SMALL_STATE(1285)] = 37668,
  [SMALL_STATE(1286)] = 37682,
  [SMALL_STATE(1287)] = 37696,
  [SMALL_STATE(1288)] = 37710,
  [SMALL_STATE(1289)] = 37724,
  [SMALL_STATE(1290)] = 37738,
  [SMALL_STATE(1291)] = 37754,
  [SMALL_STATE(1292)] = 37770,
  [SMALL_STATE(1293)] = 37786,
  [SMALL_STATE(1294)] = 37802,
  [SMALL_STATE(1295)] = 37816,
  [SMALL_STATE(1296)] = 37830,
  [SMALL_STATE(1297)] = 37844,
  [SMALL_STATE(1298)] = 37860,
  [SMALL_STATE(1299)] = 37874,
  [SMALL_STATE(1300)] = 37890,
  [SMALL_STATE(1301)] = 37904,
  [SMALL_STATE(1302)] = 37918,
  [SMALL_STATE(1303)] = 37934,
  [SMALL_STATE(1304)] = 37948,
  [SMALL_STATE(1305)] = 37964,
  [SMALL_STATE(1306)] = 37980,
  [SMALL_STATE(1307)] = 37996,
  [SMALL_STATE(1308)] = 38012,
  [SMALL_STATE(1309)] = 38028,
  [SMALL_STATE(1310)] = 38044,
  [SMALL_STATE(1311)] = 38057,
  [SMALL_STATE(1312)] = 38070,
  [SMALL_STATE(1313)] = 38083,
  [SMALL_STATE(1314)] = 38096,
  [SMALL_STATE(1315)] = 38109,
  [SMALL_STATE(1316)] = 38122,
  [SMALL_STATE(1317)] = 38135,
  [SMALL_STATE(1318)] = 38148,
  [SMALL_STATE(1319)] = 38161,
  [SMALL_STATE(1320)] = 38174,
  [SMALL_STATE(1321)] = 38187,
  [SMALL_STATE(1322)] = 38200,
  [SMALL_STATE(1323)] = 38213,
  [SMALL_STATE(1324)] = 38226,
  [SMALL_STATE(1325)] = 38239,
  [SMALL_STATE(1326)] = 38252,
  [SMALL_STATE(1327)] = 38265,
  [SMALL_STATE(1328)] = 38278,
  [SMALL_STATE(1329)] = 38291,
  [SMALL_STATE(1330)] = 38304,
  [SMALL_STATE(1331)] = 38317,
  [SMALL_STATE(1332)] = 38330,
  [SMALL_STATE(1333)] = 38343,
  [SMALL_STATE(1334)] = 38356,
  [SMALL_STATE(1335)] = 38369,
  [SMALL_STATE(1336)] = 38382,
  [SMALL_STATE(1337)] = 38395,
  [SMALL_STATE(1338)] = 38408,
  [SMALL_STATE(1339)] = 38421,
  [SMALL_STATE(1340)] = 38434,
  [SMALL_STATE(1341)] = 38447,
  [SMALL_STATE(1342)] = 38460,
  [SMALL_STATE(1343)] = 38473,
  [SMALL_STATE(1344)] = 38486,
  [SMALL_STATE(1345)] = 38499,
  [SMALL_STATE(1346)] = 38512,
  [SMALL_STATE(1347)] = 38525,
  [SMALL_STATE(1348)] = 38538,
  [SMALL_STATE(1349)] = 38551,
  [SMALL_STATE(1350)] = 38564,
  [SMALL_STATE(1351)] = 38577,
  [SMALL_STATE(1352)] = 38590,
  [SMALL_STATE(1353)] = 38603,
  [SMALL_STATE(1354)] = 38616,
  [SMALL_STATE(1355)] = 38629,
  [SMALL_STATE(1356)] = 38642,
  [SMALL_STATE(1357)] = 38655,
  [SMALL_STATE(1358)] = 38668,
  [SMALL_STATE(1359)] = 38681,
  [SMALL_STATE(1360)] = 38694,
  [SMALL_STATE(1361)] = 38707,
  [SMALL_STATE(1362)] = 38720,
  [SMALL_STATE(1363)] = 38733,
  [SMALL_STATE(1364)] = 38746,
  [SMALL_STATE(1365)] = 38759,
  [SMALL_STATE(1366)] = 38772,
  [SMALL_STATE(1367)] = 38785,
  [SMALL_STATE(1368)] = 38798,
  [SMALL_STATE(1369)] = 38811,
  [SMALL_STATE(1370)] = 38824,
  [SMALL_STATE(1371)] = 38837,
  [SMALL_STATE(1372)] = 38850,
  [SMALL_STATE(1373)] = 38863,
  [SMALL_STATE(1374)] = 38876,
  [SMALL_STATE(1375)] = 38889,
  [SMALL_STATE(1376)] = 38902,
  [SMALL_STATE(1377)] = 38915,
  [SMALL_STATE(1378)] = 38928,
  [SMALL_STATE(1379)] = 38941,
  [SMALL_STATE(1380)] = 38954,
  [SMALL_STATE(1381)] = 38967,
  [SMALL_STATE(1382)] = 38980,
  [SMALL_STATE(1383)] = 38993,
  [SMALL_STATE(1384)] = 39006,
  [SMALL_STATE(1385)] = 39019,
  [SMALL_STATE(1386)] = 39032,
  [SMALL_STATE(1387)] = 39045,
  [SMALL_STATE(1388)] = 39058,
  [SMALL_STATE(1389)] = 39071,
  [SMALL_STATE(1390)] = 39084,
  [SMALL_STATE(1391)] = 39097,
  [SMALL_STATE(1392)] = 39110,
  [SMALL_STATE(1393)] = 39123,
  [SMALL_STATE(1394)] = 39136,
  [SMALL_STATE(1395)] = 39149,
  [SMALL_STATE(1396)] = 39162,
  [SMALL_STATE(1397)] = 39175,
  [SMALL_STATE(1398)] = 39188,
  [SMALL_STATE(1399)] = 39201,
  [SMALL_STATE(1400)] = 39214,
  [SMALL_STATE(1401)] = 39227,
  [SMALL_STATE(1402)] = 39240,
  [SMALL_STATE(1403)] = 39253,
  [SMALL_STATE(1404)] = 39266,
  [SMALL_STATE(1405)] = 39279,
  [SMALL_STATE(1406)] = 39292,
  [SMALL_STATE(1407)] = 39303,
  [SMALL_STATE(1408)] = 39316,
  [SMALL_STATE(1409)] = 39329,
  [SMALL_STATE(1410)] = 39342,
  [SMALL_STATE(1411)] = 39355,
  [SMALL_STATE(1412)] = 39368,
  [SMALL_STATE(1413)] = 39381,
  [SMALL_STATE(1414)] = 39394,
  [SMALL_STATE(1415)] = 39407,
  [SMALL_STATE(1416)] = 39420,
  [SMALL_STATE(1417)] = 39433,
  [SMALL_STATE(1418)] = 39446,
  [SMALL_STATE(1419)] = 39459,
  [SMALL_STATE(1420)] = 39472,
  [SMALL_STATE(1421)] = 39485,
  [SMALL_STATE(1422)] = 39489,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [17] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [19] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(550),
  [22] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(323),
  [25] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(504),
  [28] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1108),
  [31] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(880),
  [34] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(720),
  [37] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(863),
  [40] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(779),
  [43] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(822),
  [46] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(21),
  [49] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1383),
  [52] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1382),
  [55] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1380),
  [58] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(748),
  [61] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(747),
  [64] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(65),
  [67] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1375),
  [70] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1372),
  [73] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(109),
  [76] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1370),
  [79] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [81] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(584),
  [84] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1231),
  [87] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1366),
  [90] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(110),
  [93] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(105),
  [96] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(111),
  [99] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(168),
  [102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1234),
  [105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(61),
  [108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1364),
  [111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1363),
  [114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1235),
  [117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1236),
  [120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(171),
  [123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(172),
  [126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(172),
  [129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(380),
  [132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(174),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(618),
  [138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(630),
  [141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(584),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1354),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(554),
  [150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(77),
  [153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(476),
  [156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(849),
  [159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(64),
  [162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(175),
  [165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(176),
  [168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(180),
  [171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(185),
  [174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1380),
  [200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_colon_block, 2),
  [232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_colon_block, 1),
  [280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, .production_id = 55),
  [282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, .production_id = 55),
  [284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_statement, 3),
  [286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_statement, 3),
  [288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_statement, 2),
  [290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_statement, 2),
  [292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, .production_id = 55),
  [294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, .production_id = 55),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 3),
  [434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1321),
  [567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1199),
  [570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 2),
  [572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 2),
  [574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_literal_repeat1, 1),
  [636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 10),
  [638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 10),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 27),
  [652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 27),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 2),
  [664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 2),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 44),
  [676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 44),
  [678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 44), SHIFT_REPEAT(1265),
  [681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3),
  [683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 1),
  [689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 1),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2),
  [695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, .production_id = 62),
  [705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, .production_id = 62),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 56),
  [711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 56),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3),
  [717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3),
  [719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 41),
  [721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 41),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2),
  [727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2),
  [729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 28),
  [731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 28),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 6),
  [737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 6),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 45),
  [743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 45),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 23),
  [749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 23),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unset_statement, 6),
  [759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unset_statement, 6),
  [761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 6),
  [763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 6),
  [765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 3),
  [767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 3),
  [769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6),
  [773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, .production_id = 6),
  [775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, .production_id = 6),
  [777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, .production_id = 5),
  [779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, .production_id = 5),
  [781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 23),
  [783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 23),
  [785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_declaration, 3),
  [787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_declaration, 3),
  [789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 6),
  [791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 6),
  [793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 3),
  [795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 3),
  [797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__jump_statement, 1),
  [799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__jump_statement, 1),
  [801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_static_declaration, 4),
  [803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_static_declaration, 4),
  [805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_static_declaration, 3),
  [807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_static_declaration, 3),
  [809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 5),
  [811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 5),
  [813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_declaration, 3, .production_id = 6),
  [815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_declaration, 3, .production_id = 6),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 2, .production_id = 2),
  [819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 2, .production_id = 2),
  [821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 26),
  [823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 26),
  [825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 6),
  [827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 6),
  [829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 45),
  [831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 45),
  [833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_clause, 3, .production_id = 10),
  [835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_clause, 3, .production_id = 10),
  [837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 10),
  [839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 10),
  [841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 26),
  [843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 26),
  [845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 28),
  [847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 28),
  [849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 5),
  [851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 5),
  [853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 27),
  [855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 27),
  [857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_declaration, 4),
  [859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_declaration, 4),
  [861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 1),
  [867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 1),
  [869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 4),
  [871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 4),
  [873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 2, .production_id = 4),
  [879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 2, .production_id = 4),
  [881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_echo_statement, 3),
  [883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_echo_statement, 3),
  [885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 3),
  [887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 3),
  [889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 7),
  [891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 7),
  [893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_label_statement, 2),
  [895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_label_statement, 2),
  [897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 12),
  [899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 12),
  [901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 11),
  [903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 11),
  [905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_statement, 7),
  [907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare_statement, 7),
  [909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_declaration, 4),
  [911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_use_declaration, 4),
  [913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3),
  [915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3),
  [917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3),
  [919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3),
  [921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3),
  [923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3),
  [925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 25),
  [927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 25),
  [929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 41),
  [931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 41),
  [933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 10),
  [939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 10),
  [941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 10, .production_id = 63),
  [943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 10, .production_id = 63),
  [945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7),
  [947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7),
  [949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 43),
  [951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 43),
  [953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10),
  [955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10),
  [957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 9, .production_id = 61),
  [959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 9, .production_id = 61),
  [961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, .production_id = 2),
  [963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, .production_id = 2),
  [965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 4),
  [967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 4),
  [969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9),
  [971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9),
  [973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 2),
  [975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 2),
  [977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 10),
  [979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 10),
  [981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 8, .production_id = 63),
  [983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 8, .production_id = 63),
  [985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 8),
  [987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 8),
  [989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8),
  [995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8),
  [997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 42),
  [999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 42),
  [1001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 23),
  [1003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 23),
  [1005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_statement, 8),
  [1007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare_statement, 8),
  [1009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 10),
  [1011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 10),
  [1013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 56),
  [1015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 56),
  [1017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unset_statement, 5),
  [1019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unset_statement, 5),
  [1021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 43),
  [1023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 43),
  [1025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [1027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [1029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 7, .production_id = 61),
  [1031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 7, .production_id = 61),
  [1033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_statement, 5),
  [1035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declare_statement, 5),
  [1037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 7),
  [1039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 7),
  [1041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [1043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [1045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [1047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [1049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [1051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [1053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [1055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [1057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [1059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [1061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_access_expression, 5, .production_id = 47),
  [1063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_access_expression, 5, .production_id = 47),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expression, 1),
  [1069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_variable, 4, .production_id = 24),
  [1071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dereferencable_expression, 1),
  [1073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expression, 1),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [1077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_variable, 4, .production_id = 24),
  [1079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_access_expression, 3, .production_id = 14),
  [1081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_access_expression, 3, .production_id = 14),
  [1083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_property_access_expression, 3, .production_id = 13),
  [1085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_property_access_expression, 3, .production_id = 13),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [1091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__reserved_identifier, 1),
  [1093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__reserved_identifier, 1),
  [1095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_call_expression, 6, .production_id = 58),
  [1097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_call_expression, 6, .production_id = 58),
  [1099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_call_expression, 6, .production_id = 57),
  [1101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_call_expression, 6, .production_id = 57),
  [1103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 3),
  [1105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 3),
  [1107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_call_expression, 4, .production_id = 32),
  [1109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_call_expression, 4, .production_id = 32),
  [1111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4),
  [1113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4),
  [1115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_call_expression, 4, .production_id = 31),
  [1117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_call_expression, 4, .production_id = 31),
  [1119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_variable_name, 4),
  [1121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_variable_name, 4),
  [1123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_name, 2),
  [1125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_name, 2),
  [1127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_variable_name, 2),
  [1129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_variable_name, 2),
  [1131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call_expression, 2, .production_id = 3),
  [1133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call_expression, 2, .production_id = 3),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_literal_repeat1, 2),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_constant_access_expression, 3),
  [1153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_constant_access_expression, 3),
  [1155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_name, 1),
  [1157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 1), SHIFT(1318),
  [1160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_name, 1),
  [1162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3),
  [1164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 2),
  [1168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 2),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2),
  [1174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2),
  [1176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 2),
  [1178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 2),
  [1180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 5),
  [1182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 5),
  [1184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 11),
  [1186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 11),
  [1188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4),
  [1190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4),
  [1192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 6),
  [1194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 6),
  [1196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 1),
  [1198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 1),
  [1200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3),
  [1202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3),
  [1204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_name, 2),
  [1206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_name, 2),
  [1208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution_qualifier, 1),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [1212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relative_scope, 1),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3),
  [1218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [1220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 12),
  [1250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [1252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 11),
  [1254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_element_initializer, 3),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 15),
  [1264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 15),
  [1266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 22),
  [1268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 4, .production_id = 22),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, .production_id = 24),
  [1272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, .production_id = 24),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [1276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 4),
  [1280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 4),
  [1282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_element_initializer, 1),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, .production_id = 29),
  [1288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, .production_id = 29),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 4, .production_id = 30),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_intrinsic, 2),
  [1294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 33),
  [1296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 33),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 34),
  [1300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 34),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 39),
  [1304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 5, .production_id = 39),
  [1306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exponentiation_expression, 3),
  [1308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exponentiation_expression, 3),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 5),
  [1316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 5),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_require_once_expression, 2),
  [1320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, .production_id = 46),
  [1322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, .production_id = 46),
  [1324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 48),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 48),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_expression, 1),
  [1330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unary_expression, 1),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [1334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 49),
  [1336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 6, .production_id = 49),
  [1338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 6),
  [1340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 6),
  [1342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_element_initializer, 2),
  [1344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 59),
  [1346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 7, .production_id = 59),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_clone_expression, 2),
  [1352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_clone_expression, 2),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_op_expression, 2),
  [1356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_op_expression, 2),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_require_expression, 2),
  [1360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_creation_expression, 3, .production_id = 9),
  [1364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_function_creation_expression, 3, .production_id = 9),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_once_expression, 2),
  [1368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_element_initializer, 4),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [1372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 2),
  [1374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include_expression, 2),
  [1376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [1378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [1380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(816),
  [1389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(448),
  [1392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1132),
  [1395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(863),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2),
  [1400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(71),
  [1403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1311),
  [1406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(74),
  [1409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(411),
  [1412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(883),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [1431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [1463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_variable_declaration, 3, .production_id = 16),
  [1489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_initializer, 2),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [1493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_element, 3),
  [1495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expressions, 1),
  [1497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 4, .production_id = 52),
  [1499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 3, .production_id = 38),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 5, .production_id = 60),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [1523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 4, .production_id = 50),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_unpacking, 2),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_pair, 4),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [1609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_pair, 3),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(764),
  [1648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(745),
  [1651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(792),
  [1654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(828),
  [1657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2),
  [1659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(748),
  [1662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(761),
  [1665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(747),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [1670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [1674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [1676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [1680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [1686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [1688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(764),
  [1691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2),
  [1693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(748),
  [1696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(761),
  [1699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 2), SHIFT_REPEAT(747),
  [1702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_use_list_repeat1, 2),
  [1704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 54),
  [1706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4),
  [1708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 1),
  [1710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__member_declaration, 1),
  [1712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 4),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [1716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 2),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [1720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 4),
  [1722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 3),
  [1724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 40),
  [1726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 3),
  [1728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 3),
  [1730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 53),
  [1732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__modifier, 1),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [1736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 1),
  [1738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_modifier, 1),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat1, 1),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [1778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_modifier, 1),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1419),
  [1811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1158),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [1818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_literal_repeat1, 4),
  [1820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unset_statement_repeat1, 2),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [1836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [1840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [1842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2),
  [1844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(170),
  [1847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1301),
  [1850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_name_as_prefix, 3),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [1860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [1862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [1864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [1868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [1870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_name_as_prefix, 2),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [1874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [1876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [1878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [1888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_function_or_const, 1),
  [1890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_function_or_const, 1),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [1896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [1898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [1900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [1902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [1910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [1916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [1924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [1928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [1930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [1932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_namespace_name_as_prefix, 1), SHIFT(1174),
  [1935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_name_as_prefix, 1),
  [1937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 3, .production_id = 8),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name, 2),
  [1947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 2), SHIFT(1405),
  [1950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_base_clause_repeat1, 2),
  [1952] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_base_clause_repeat1, 2), SHIFT_REPEAT(742),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [1961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_name, 1),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [1965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 44), SHIFT_REPEAT(1182),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [1980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_text, 1),
  [1982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_text, 1),
  [1984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat2, 2, .production_id = 44),
  [1986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat2, 2, .production_id = 44), SHIFT_REPEAT(1299),
  [1989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat2, 2, .production_id = 44),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [1999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [2001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_element, 1),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [2009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 1), SHIFT(1405),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [2014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2),
  [2016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2),
  [2018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2), SHIFT_REPEAT(956),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [2023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_namespace_name_repeat1, 2),
  [2031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_name_repeat1, 2), SHIFT_REPEAT(1405),
  [2034] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_namespace_name_as_prefix, 2), SHIFT(1174),
  [2037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_clause, 1),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [2041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 4, .production_id = 17),
  [2043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_name_repeat1, 2), SHIFT_REPEAT(1318),
  [2046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [2048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [2052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_variable_declaration, 1, .production_id = 1),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [2080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [2084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_namespace_use_declaration_repeat1, 2),
  [2096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_use_declaration_repeat1, 2), SHIFT_REPEAT(731),
  [2099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [2101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 1),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [2107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2), SHIFT_REPEAT(919),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [2112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat2, 2),
  [2114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_property_declaration_repeat2, 2), SHIFT_REPEAT(1020),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [2131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2),
  [2133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2),
  [2135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2), SHIFT_REPEAT(800),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [2150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [2152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(114),
  [2155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [2165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [2167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [2171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_name_as_prefix, 4),
  [2173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_declaration_repeat1, 2),
  [2175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_declaration_repeat1, 2), SHIFT_REPEAT(1134),
  [2178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [2180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_static_declaration_repeat1, 2),
  [2182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_static_declaration_repeat1, 2), SHIFT_REPEAT(1126),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group_clause, 2),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [2193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 1),
  [2195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 1),
  [2197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group_clause, 1),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [2213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2, .production_id = 18),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [2217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 1),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, .production_id = 7),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_base_clause_repeat1, 2), SHIFT_REPEAT(740),
  [2230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_clause_2, 3, .production_id = 10),
  [2232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if_clause_2, 3, .production_id = 10),
  [2234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_element, 2),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [2242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_interface_clause, 2),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [2258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(700),
  [2261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [2265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(117),
  [2268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 3, .production_id = 37),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 6),
  [2274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 5),
  [2276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 1, .production_id = 1),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [2280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 2, .production_id = 19),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [2288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 5, .production_id = 35),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [2292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_namespace_use_group_repeat1, 2), SHIFT_REPEAT(804),
  [2295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_namespace_use_group_repeat1, 2),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [2301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_anonymous_function_use_clause_repeat1, 2), SHIFT_REPEAT(1026),
  [2304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_anonymous_function_use_clause_repeat1, 2),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_clause, 2),
  [2308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_base_clause, 2),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [2312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_literal_repeat1, 2), SHIFT_REPEAT(107),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [2317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 4),
  [2319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_base_clause, 3),
  [2321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_interface_clause, 3),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [2331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__return_type, 2, .production_id = 21),
  [2333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_definition_header, 4, .production_id = 20),
  [2335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_aliasing_clause, 2),
  [2337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat2, 1, .production_id = 25),
  [2339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat2, 1, .production_id = 25),
  [2341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 7),
  [2343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [2349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_literal, 3),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [2353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 3),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [2357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [2373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_parameter, 2, .production_id = 5),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [2381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [2385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unset_statement_repeat1, 2), SHIFT_REPEAT(627),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 2, .production_id = 5),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [2432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_base_clause, 2),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [2456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_type, 1),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [2466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 4),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 3, .production_id = 37),
  [2478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 3, .production_id = 36),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group, 3),
  [2486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 4, .production_id = 51),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_use_clause, 4),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [2502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group_clause, 3),
  [2504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_use_group, 4),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_use_clause, 5),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [2510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_instead_of_clause, 3),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [2516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_anonymous_function_use_clause_repeat1, 3),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [2520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_function_use_clause, 6),
  [2522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_namespace_name, 2), SHIFT(1318),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [2531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [2535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [2539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [2553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [2617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause_2, 2, .production_id = 2),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [2685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declare_directive, 3),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [2691] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [2701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_text_interpolation, 3),
  [2703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_text_interpolation, 2),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_php_external_scanner_create(void);
void tree_sitter_php_external_scanner_destroy(void *);
bool tree_sitter_php_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_php_external_scanner_serialize(void *, char *);
void tree_sitter_php_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_php(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .public_symbol_map = ts_symbol_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_name,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_php_external_scanner_create,
      tree_sitter_php_external_scanner_destroy,
      tree_sitter_php_external_scanner_scan,
      tree_sitter_php_external_scanner_serialize,
      tree_sitter_php_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
